/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/base/common/path","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/network","vs/base/common/errors","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/types","vs/platform/log/common/log","vs/base/common/async","vs/base/common/strings","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/arrays","vs/base/node/pfs","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/uuid","vs/base/common/process","os","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","vs/platform/product/common/productService","fs","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/map","vs/platform/telemetry/common/telemetry","vs/base/common/extpath","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/errorMessage","vs/base/common/codicons","child_process","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/server/node/serverEnvironmentService","vs/base/common/stream","vs/base/common/performance","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/iterator","vs/base/common/marshalling","vs/editor/common/core/range","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/base/common/semver/semver","vs/workbench/api/node/uriTransformer","vs/base/parts/ipc/node/ipc.net","vs/base/common/json","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/credentials/common/credentials","vs/platform/download/common/download","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","crypto","url","vs/platform/shell/node/shellEnv","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/processes","vs/base/common/normalization","vs/base/common/console","vs/base/common/glob","vs/base/common/htmlContent","vs/base/common/labels","path","vs/base/node/id","net","vs/base/node/powershell","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/position","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/common/environmentService","vs/platform/contextkey/common/contextkey","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/localizations/node/localizations","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/server/node/extensionHostStatusService","vs/server/node/remoteLanguagePacks","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTypes","vs/workbench/common/editor","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/remote/common/remoteAgentService","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/amd","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/marked/marked","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/hash","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/severity","vs/base/node/decoder","vs/base/node/languagePacks","vs/base/node/macAddress","util","vs/base/node/extpath","vs/base/node/ports","vs/base/parts/storage/common/storage","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteAgentEnvironmentImpl","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionPoints","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/editor/common/editor","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/credentials/common/credentialsMainService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/markers/common/markers","vs/platform/credentials/node/credentialsMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/server/node/webClientServer","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/testing/common/testCollection","vs/workbench/contrib/testing/common/testId","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostTypeConverters","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionPoints","vs/server/node/remoteAgentEnvironmentImpl","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/services/extensions/common/remoteConsoleUtil","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","string_decoder","minimist","assert","graceful-fs","yauzl","yazl","http","vs/server/node/server.main"],we=function(ee){for(var e=[],k=0,n=ee.length;k<n;k++)e[k]=ve[ee[k]];return e};define(ve[117],we([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class k{static get(){const w=new Map,C=new Map,T=new Map,D=new Map;function v(S,u){S.has(u.detail)||S.set(u.detail,-u.timestamp)}function P(S,u){let b=S.get(u.detail);!b||b>=0||S.set(u.detail,b+u.timestamp)}const A=ee.getStats().slice(0).sort((S,u)=>S.timestamp-u.timestamp);for(const S of A)switch(S.type){case 10:v(w,S);break;case 11:case 12:P(w,S);break;case 21:v(C,S);break;case 22:P(C,S);break;case 33:v(T,S);break;case 34:P(T,S);break;case 31:v(D,S);break;case 32:P(D,S);break}let R=0;T.forEach(S=>R+=S);function E(S){let u=[];return S.forEach((b,f)=>u.push([f,b])),u}return{amdLoad:E(w),amdInvoke:E(C),nodeRequire:E(T),nodeEval:E(D),nodeRequireTotal:R}}static toMarkdownTable(w,C){let T="",D=[];return w.forEach((v,P)=>{D[P]=v.length}),C.forEach(v=>{v.forEach((P,A)=>{typeof P=="undefined"&&(P=v[A]="-");const R=P.toString().length;D[A]=Math.max(R,D[A])})}),w.forEach((v,P)=>{T+=`| ${v+" ".repeat(D[P]-v.toString().length)} `}),T+=`|
`,w.forEach((v,P)=>{T+=`| ${"-".repeat(D[P])} `}),T+=`|
`,C.forEach(v=>{v.forEach((P,A)=>{typeof P!="undefined"&&(T+=`| ${P+" ".repeat(D[A]-P.toString().length)} `)}),T+=`|
`}),T}}e.LoaderStats=k}),define(ve[118],we([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function k(n,w){if(!n)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=k}),define(ve[37],we([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function k(T){return T?T.replace(/\$\((.*?)\)/g,(D,v)=>` ${v} `).trim():""}e.getCodiconAriaLabel=k;class n{constructor(D,v,P){this.id=D,this.definition=v,this.description=P,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.layoutActivitybarLeft=new n("layout-activitybar-left",{fontCharacter:"\\ebec"}),n.layoutActivitybarRight=new n("layout-activitybar-right",{fontCharacter:"\\ebed"}),n.layoutPanelLeft=new n("layout-panel-left",{fontCharacter:"\\ebee"}),n.layoutPanelCenter=new n("layout-panel-center",{fontCharacter:"\\ebef"}),n.layoutPanelJustify=new n("layout-panel-justify",{fontCharacter:"\\ebf0"}),n.layoutPanelRight=new n("layout-panel-right",{fontCharacter:"\\ebf1"}),n.layoutPanel=new n("layout-panel",{fontCharacter:"\\ebf2"}),n.layoutSidebarLeft=new n("layout-sidebar-left",{fontCharacter:"\\ebf3"}),n.layoutSidebarRight=new n("layout-sidebar-right",{fontCharacter:"\\ebf4"}),n.layoutStatusbar=new n("layout-statusbar",{fontCharacter:"\\ebf5"}),n.layoutMenubar=new n("layout-menubar",{fontCharacter:"\\ebf6"}),n.layoutCentered=new n("layout-centered",{fontCharacter:"\\ebf7"}),n.target=new n("target",{fontCharacter:"\\ebf8"}),n.indent=new n("indent",{fontCharacter:"\\ebf9"}),n.recordSmall=new n("record-small",{fontCharacter:"\\ebfa"}),n.errorSmall=new n("error-small",{fontCharacter:"\\ebfb"}),n.arrowCircleDown=new n("arrow-circle-down",{fontCharacter:"\\ebfc"}),n.arrowCircleLeft=new n("arrow-circle-left",{fontCharacter:"\\ebfd"}),n.arrowCircleRight=new n("arrow-circle-right",{fontCharacter:"\\ebfe"}),n.arrowCircleUp=new n("arrow-circle-up",{fontCharacter:"\\ebff"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function w(T,D){const v=["codicon","codicon-"+T];return D&&v.push("codicon-modifier-"+D),v}e.getClassNamesArray=w;var C;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function v(R){if(R instanceof n)return["codicon","codicon-"+R.id];const E=D.exec(R.id);if(!E)return v(n.error);let[,S,u]=E;const b=["codicon","codicon-"+S];return u&&b.push("codicon-modifier-"+u.substr(1)),b}T.asClassNameArray=v;function P(R){return v(R).join(" ")}T.asClassName=P;function A(R){return"."+v(R).join(".")}T.asCSSSelector=A})(C=e.CSSIcon||(e.CSSIcon={}))}),define(ve[72],we([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function k(T){return(D,v,P)=>{let A=null,R=null;if(typeof P.value=="function"?(A="value",R=P.value):typeof P.get=="function"&&(A="get",R=P.get),!R)throw new Error("not supported");P[A]=T(R,v)}}e.createDecorator=k;function n(T,D,v){let P=null,A=null;if(typeof v.value=="function"?(P="value",A=v.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(P="get",A=v.get),!A)throw new Error("not supported");const R=`$memoize$${D}`;v[P]=function(...E){return this.hasOwnProperty(R)||Object.defineProperty(this,R,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,E)}),this[R]}}e.memoize=n;function w(T,D,v){return k((P,A)=>{const R=`$debounce$${A}`,E=`$debounce$result$${A}`;return function(...S){this[E]||(this[E]=v?v():void 0),clearTimeout(this[R]),D&&(this[E]=D(this[E],...S),S=[this[E]]),this[R]=setTimeout(()=>{P.apply(this,S),this[E]=v?v():void 0},T)}})}e.debounce=w;function C(T,D,v){return k((P,A)=>{const R=`$throttle$timer$${A}`,E=`$throttle$result$${A}`,S=`$throttle$lastRun$${A}`,u=`$throttle$pending$${A}`;return function(...b){if(this[E]||(this[E]=v?v():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),D&&(this[E]=D(this[E],...b)),this[u])return;const f=this[S]+T;f<=Date.now()?(this[S]=Date.now(),P.apply(this,[this[E]]),this[E]=v?v():void 0):(this[u]=!0,this[R]=setTimeout(()=>{this[u]=!1,this[S]=Date.now(),P.apply(this,[this[E]]),this[E]=v?v():void 0},f-Date.now()))}})}e.throttle=C}),define(ve[9],we([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class k{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(c){setTimeout(()=>{throw c.stack?new Error(c.message+`

`+c.stack):c},0)}}addListener(c){return this.listeners.push(c),()=>{this._removeListener(c)}}emit(c){this.listeners.forEach(o=>{o(c)})}_removeListener(c){this.listeners.splice(this.listeners.indexOf(c),1)}setUnexpectedErrorHandler(c){this.unexpectedErrorHandler=c}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(c){this.unexpectedErrorHandler(c),this.emit(c)}onUnexpectedExternalError(c){this.unexpectedErrorHandler(c)}}e.ErrorHandler=k,e.errorHandler=new k;function n(y){e.errorHandler.setUnexpectedErrorHandler(y)}e.setUnexpectedErrorHandler=n;function w(y){v(y)||e.errorHandler.onUnexpectedError(y)}e.onUnexpectedError=w;function C(y){v(y)||e.errorHandler.onUnexpectedExternalError(y)}e.onUnexpectedExternalError=C;function T(y){if(y instanceof Error){let{name:c,message:o}=y;const l=y.stacktrace||y.stack;return{$isError:!0,name:c,message:o,stack:l}}return y}e.transformErrorForSerialization=T;const D="Canceled";function v(y){return y instanceof P?!0:y instanceof Error&&y.name===D&&y.message===D}e.isCancellationError=v;class P extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=P;function A(){const y=new Error(D);return y.name=y.message,y}e.canceled=A;function R(y){return y?new Error(`Illegal argument: ${y}`):new Error("Illegal argument")}e.illegalArgument=R;function E(y){return y?new Error(`Illegal state: ${y}`):new Error("Illegal state")}e.illegalState=E;function S(y){return y?new Error(`readonly property '${y} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=S;function u(y){const c=new Error(`${y} has been disposed`);return c.name="DISPOSED",c}e.disposed=u;function b(y){return y?y.message?y.message:y.stack?y.stack.split(`
`)[0]:String(y):"Error"}e.getErrorMessage=b;class f extends Error{constructor(c){super("NotImplemented");c&&(this.message=c)}}e.NotImplementedError=f;class d extends Error{constructor(c){super("NotSupported");c&&(this.message=c)}}e.NotSupportedError=d;class p extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=p;class m extends Error{constructor(){super(...arguments);this.logTelemetry=!1}static fromError(c){if(c&&c instanceof Error){const o=new m;return o.name=c.name,o.message=c.message,o.stack=c.stack,o}return new m(c)}}e.ErrorNoTelemetry=m}),define(ve[18],we([0,1,9]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(O,V=0){return O[O.length-(1+V)]}e.tail=n;function w(O){if(O.length===0)throw new Error("Invalid tail call");return[O.slice(0,O.length-1),O[O.length-1]]}e.tail2=w;function C(O,V,J=(le,ge)=>le===ge){if(O===V)return!0;if(!O||!V||O.length!==V.length)return!1;for(let le=0,ge=O.length;le<ge;le++)if(!J(O[le],V[le]))return!1;return!0}e.equals=C;function T(O,V,J){let le=0,ge=O.length-1;for(;le<=ge;){const ue=(le+ge)/2|0,oe=J(O[ue],V);if(oe<0)le=ue+1;else if(oe>0)ge=ue-1;else return ue}return-(le+1)}e.binarySearch=T;function D(O,V){let J=0,le=O.length;if(le===0)return 0;for(;J<le;){const ge=Math.floor((J+le)/2);V(O[ge])?le=ge:J=ge+1}return J}e.findFirstInSorted=D;function v(O,V,J){if(O=O|0,O>=V.length)throw new TypeError("invalid index");let le=V[Math.floor(V.length*Math.random())],ge=[],ue=[],oe=[];for(let pe of V){const X=J(pe,le);X<0?ge.push(pe):X>0?ue.push(pe):oe.push(pe)}return O<ge.length?v(O,ge,J):O<ge.length+oe.length?oe[0]:v(O-(ge.length+oe.length),ue,J)}e.quickSelect=v;function P(O,V){const J=[];let le;for(const ge of O.slice(0).sort(V))!le||V(le[0],ge)!==0?(le=[ge],J.push(le)):le.push(ge);return J}e.groupBy=P;function A(O,V,J){const le=[];function ge(pe,X,B){if(X===0&&B.length===0)return;const x=le[le.length-1];x&&x.start+x.deleteCount===pe?(x.deleteCount+=X,x.toInsert.push(...B)):le.push({start:pe,deleteCount:X,toInsert:B})}let ue=0,oe=0;for(;;){if(ue===O.length){ge(ue,0,V.slice(oe));break}if(oe===V.length){ge(ue,O.length-ue,[]);break}const pe=O[ue],X=V[oe],B=J(pe,X);B===0?(ue+=1,oe+=1):B<0?(ge(ue,1,[]),ue+=1):B>0&&(ge(ue,0,[X]),oe+=1)}return le}e.sortedDiff=A;function R(O,V,J){const le=A(O,V,J),ge=[],ue=[];for(const oe of le)ge.push(...O.slice(oe.start,oe.start+oe.deleteCount)),ue.push(...oe.toInsert);return{removed:ge,added:ue}}e.delta=R;function E(O,V,J){if(J===0)return[];const le=O.slice(0,J).sort(V);return u(O,V,le,J,O.length),le}e.top=E;function S(O,V,J,le,ge){return J===0?Promise.resolve([]):new Promise((ue,oe)=>{(async()=>{const pe=O.length,X=O.slice(0,J).sort(V);for(let B=J,x=Math.min(J+le,pe);B<pe;B=x,x=Math.min(x+le,pe)){if(B>J&&await new Promise(Y=>setTimeout(Y)),ge&&ge.isCancellationRequested)throw(0,k.canceled)();u(O,V,X,B,x)}return X})().then(ue,oe)})}e.topAsync=S;function u(O,V,J,le,ge){for(const ue=J.length;le<ge;le++){const oe=O[le];if(V(oe,J[ue-1])<0){J.pop();const pe=D(J,X=>V(oe,X)<0);J.splice(pe,0,oe)}}}function b(O){return O.filter(V=>!!V)}e.coalesce=b;function f(O){let V=0;for(let J=0;J<O.length;J++)O[J]&&(O[V]=O[J],V+=1);O.length=V}e.coalesceInPlace=f;function d(O,V,J){O.splice(J,0,O.splice(V,1)[0])}e.move=d;function p(O){return!Array.isArray(O)||O.length===0}e.isFalsyOrEmpty=p;function m(O){return Array.isArray(O)&&O.length>0}e.isNonEmptyArray=m;function y(O,V=J=>J){const J=new Set;return O.filter(le=>{const ge=V(le);return J.has(ge)?!1:(J.add(ge),!0)})}e.distinct=y;function c(O){const V=new Set;return J=>{const le=O(J);return V.has(le)?!1:(V.add(le),!0)}}e.uniqueFilter=c;function o(O,V){const J=l(O,V);if(J!==-1)return O[J]}e.findLast=o;function l(O,V){for(let J=O.length-1;J>=0;J--){const le=O[J];if(V(le))return J}return-1}e.lastIndex=l;function i(O,V){return O.length>0?O[0]:V}e.firstOrDefault=i;function t(O,V){return O.length>0?O[O.length-1]:V}e.lastOrDefault=t;function r(O,V,J=(le,ge)=>le===ge){let le=0;for(let ge=0,ue=Math.min(O.length,V.length);ge<ue&&J(O[ge],V[ge]);ge++)le++;return le}e.commonPrefixLength=r;function s(O){return[].concat(...O)}e.flatten=s;function a(O,V){let J=typeof V=="number"?O:0;typeof V=="number"?J=O:(J=0,V=O);const le=[];if(J<=V)for(let ge=J;ge<V;ge++)le.push(ge);else for(let ge=J;ge>V;ge--)le.push(ge);return le}e.range=a;function h(O,V,J){return O.reduce((le,ge)=>(le[V(ge)]=J?J(ge):ge,le),Object.create(null))}e.index=h;function g(O,V){return O.push(V),()=>_(O,V)}e.insert=g;function _(O,V){const J=O.indexOf(V);if(J>-1)return O.splice(J,1),V}e.remove=_;function F(O,V,J){const le=O.slice(0,V),ge=O.slice(V);return le.concat(J,ge)}e.arrayInsert=F;function $(O,V){let J;if(typeof V=="number"){let le=V;J=()=>{const ge=Math.sin(le++)*179426549;return ge-Math.floor(ge)}}else J=Math.random;for(let le=O.length-1;le>0;le-=1){const ge=Math.floor(J()*(le+1)),ue=O[le];O[le]=O[ge],O[ge]=ue}}e.shuffle=$;function K(O,V){const J=O.indexOf(V);J>-1&&(O.splice(J,1),O.unshift(V))}e.pushToStart=K;function I(O,V){const J=O.indexOf(V);J>-1&&(O.splice(J,1),O.push(V))}e.pushToEnd=I;function W(O,V){for(const J of V)O.push(J)}e.pushMany=W;function M(O,V){return Array.isArray(O)?O.map(V):V(O)}e.mapArrayOrNot=M;function q(O){return Array.isArray(O)?O:[O]}e.asArray=q;function Z(O){return O[Math.floor(Math.random()*O.length)]}e.getRandomElement=Z;function H(O,V){for(const J of O){const le=V(J);if(le!==void 0)return le}}e.mapFind=H;function U(O,V,J){const le=Q(O,V),ge=O.length,ue=J.length;O.length=ge+ue;for(let oe=ge-1;oe>=le;oe--)O[oe+ue]=O[oe];for(let oe=0;oe<ue;oe++)O[oe+le]=J[oe]}e.insertInto=U;function z(O,V,J,le){const ge=Q(O,V),ue=O.splice(ge,J);return U(O,ge,le),ue}e.splice=z;function Q(O,V){return V<0?Math.max(V+O.length,0):Math.min(V,O.length)}function ie(O,V){return(J,le)=>V(O(J),O(le))}e.compareBy=ie;const re=(O,V)=>O-V;e.numberComparator=re;function ce(O,V){if(O.length===0)return;let J=O[0];for(let le=1;le<O.length;le++){const ge=O[le];V(ge,J)>0&&(J=ge)}return J}e.findMaxBy=ce;function de(O,V){if(O.length===0)return;let J=O[0];for(let le=1;le<O.length;le++){const ge=O[le];V(ge,J)>=0&&(J=ge)}return J}e.findLastMaxBy=de;function he(O,V){return ce(O,(J,le)=>-V(J,le))}e.findMinBy=he;class j{constructor(V){this.items=V,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(V){let J=this.firstIdx;for(;J<this.items.length&&V(this.items[J]);)J++;const le=J===this.firstIdx?null:this.items.slice(this.firstIdx,J);return this.firstIdx=J,le}takeFromEndWhile(V){let J=this.lastIdx;for(;J>=0&&V(this.items[J]);)J--;const le=J===this.lastIdx?null:this.items.slice(J+1,this.lastIdx+1);return this.lastIdx=J,le}peek(){return this.items[this.firstIdx]}dequeue(){const V=this.items[this.firstIdx];return this.firstIdx++,V}takeCount(V){const J=this.items.slice(this.firstIdx,this.firstIdx+V);return this.firstIdx+=V,J}}e.ArrayQueue=j}),define(ve[73],we([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function k(n){const w=this;let C=!1,T;return function(){return C||(C=!0,T=n.apply(w,arguments)),T}}e.once=k}),define(ve[49],we([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(n){function w(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}n.is=w;const C=Object.freeze([]);function T(){return C}n.empty=T;function*D(c){yield c}n.single=D;function v(c){return c||C}n.from=v;function P(c){return!c||c[Symbol.iterator]().next().done===!0}n.isEmpty=P;function A(c){return c[Symbol.iterator]().next().value}n.first=A;function R(c,o){for(const l of c)if(o(l))return!0;return!1}n.some=R;function E(c,o){for(const l of c)if(o(l))return l}n.find=E;function*S(c,o){for(const l of c)o(l)&&(yield l)}n.filter=S;function*u(c,o){let l=0;for(const i of c)yield o(i,l++)}n.map=u;function*b(...c){for(const o of c)for(const l of o)yield l}n.concat=b;function*f(c){for(const o of c)for(const l of o)yield l}n.concatNested=f;function d(c,o,l){let i=l;for(const t of c)i=o(i,t);return i}n.reduce=d;function*p(c,o,l=c.length){for(o<0&&(o+=c.length),l<0?l+=c.length:l>c.length&&(l=c.length);o<l;o++)yield c[o]}n.slice=p;function m(c,o=Number.POSITIVE_INFINITY){const l=[];if(o===0)return[l,c];const i=c[Symbol.iterator]();for(let t=0;t<o;t++){const r=i.next();if(r.done)return[l,n.empty()];l.push(r.value)}return[l,{[Symbol.iterator](){return i}}]}n.consume=m;function y(c,o,l=(i,t)=>i===t){const i=c[Symbol.iterator](),t=o[Symbol.iterator]();for(;;){const r=i.next(),s=t.next();if(r.done!==s.done)return!1;if(r.done)return!0;if(!l(r.value,s.value))return!1}}n.equals=y})(k=e.Iterable||(e.Iterable={}))}),define(ve[59],we([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(k=e.ScanError||(e.ScanError={}));var n;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var w;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(w=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(o){o.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function T(o,l=!1){let i=0,t=o.length,r="",s=0,a=16,h=0;function g(M){let q=0,Z=0;for(;q<M;){const H=o.charCodeAt(i);if(H>=48&&H<=57)Z=Z*16+H-48;else if(H>=65&&H<=70)Z=Z*16+H-65+10;else if(H>=97&&H<=102)Z=Z*16+H-97+10;else break;i++,q++}return q<M&&(Z=-1),Z}function _(M){i=M,r="",s=0,a=16,h=0}function F(){const M=i;if(o.charCodeAt(i)===48)i++;else for(i++;i<o.length&&P(o.charCodeAt(i));)i++;if(i<o.length&&o.charCodeAt(i)===46)if(i++,i<o.length&&P(o.charCodeAt(i)))for(i++;i<o.length&&P(o.charCodeAt(i));)i++;else return h=3,o.substring(M,i);let q=i;if(i<o.length&&(o.charCodeAt(i)===69||o.charCodeAt(i)===101))if(i++,(i<o.length&&o.charCodeAt(i)===43||o.charCodeAt(i)===45)&&i++,i<o.length&&P(o.charCodeAt(i))){for(i++;i<o.length&&P(o.charCodeAt(i));)i++;q=i}else h=3;return o.substring(M,q)}function $(){let M="",q=i;for(;;){if(i>=t){M+=o.substring(q,i),h=2;break}const Z=o.charCodeAt(i);if(Z===34){M+=o.substring(q,i),i++;break}if(Z===92){if(M+=o.substring(q,i),i++,i>=t){h=2;break}switch(o.charCodeAt(i++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const U=g(4);U>=0?M+=String.fromCharCode(U):h=4;break}default:h=5}q=i;continue}if(Z>=0&&Z<=31)if(v(Z)){M+=o.substring(q,i),h=2;break}else h=6;i++}return M}function K(){if(r="",h=0,s=i,i>=t)return s=t,a=17;let M=o.charCodeAt(i);if(D(M)){do i++,r+=String.fromCharCode(M),M=o.charCodeAt(i);while(D(M));return a=15}if(v(M))return i++,r+=String.fromCharCode(M),M===13&&o.charCodeAt(i)===10&&(i++,r+=`
`),a=14;switch(M){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,r=$(),a=10;case 47:{const q=i-1;if(o.charCodeAt(i+1)===47){for(i+=2;i<t&&!v(o.charCodeAt(i));)i++;return r=o.substring(q,i),a=12}if(o.charCodeAt(i+1)===42){i+=2;const Z=t-1;let H=!1;for(;i<Z;){if(o.charCodeAt(i)===42&&o.charCodeAt(i+1)===47){i+=2,H=!0;break}i++}return H||(i++,h=1),r=o.substring(q,i),a=13}return r+=String.fromCharCode(M),i++,a=16}case 45:if(r+=String.fromCharCode(M),i++,i===t||!P(o.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=F(),a=11;default:for(;i<t&&I(M);)i++,M=o.charCodeAt(i);if(s!==i){switch(r=o.substring(s,i),r){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return r+=String.fromCharCode(M),i++,a=16}}function I(M){if(D(M)||v(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let M;do M=K();while(M>=12&&M<=15);return M}return{setPosition:_,getPosition:()=>i,scan:l?W:K,getToken:()=>a,getTokenValue:()=>r,getTokenOffset:()=>s,getTokenLength:()=>i-s,getTokenError:()=>h}}e.createScanner=T;function D(o){return o===32||o===9||o===11||o===12||o===160||o===5760||o>=8192&&o<=8203||o===8239||o===8287||o===12288||o===65279}function v(o){return o===10||o===13||o===8232||o===8233}function P(o){return o>=48&&o<=57}var A;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(A||(A={}));function R(o,l){const i=[],t=new Object;let r;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function h(g,_,F,$){s.value=g,s.offset=_,s.length=F,s.type=$,s.colonOffset=void 0,r=s}try{m(o,{onObjectBegin:(g,_)=>{if(l<=g)throw t;r=void 0,a=l>g,i.push("")},onObjectProperty:(g,_,F)=>{if(l<_||(h(g,_,F,"property"),i[i.length-1]=g,l<=_+F))throw t},onObjectEnd:(g,_)=>{if(l<=g)throw t;r=void 0,i.pop()},onArrayBegin:(g,_)=>{if(l<=g)throw t;r=void 0,i.push(0)},onArrayEnd:(g,_)=>{if(l<=g)throw t;r=void 0,i.pop()},onLiteralValue:(g,_,F)=>{if(l<_||(h(g,_,F,c(g)),l<=_+F))throw t},onSeparator:(g,_,F)=>{if(l<=_)throw t;if(g===":"&&r&&r.type==="property")r.colonOffset=_,a=!1,r=void 0;else if(g===","){const $=i[i.length-1];typeof $=="number"?i[i.length-1]=$+1:(a=!0,i[i.length-1]=""),r=void 0}}})}catch(g){if(g!==t)throw g}return{path:i,previousNode:r,isAtPropertyKey:a,matches:g=>{let _=0;for(let F=0;_<g.length&&F<i.length;F++)if(g[_]===i[F]||g[_]==="*")_++;else if(g[_]!=="**")return!1;return _===g.length}}}e.getLocation=R;function E(o,l=[],i=C.DEFAULT){let t=null,r=[];const s=[];function a(g){Array.isArray(r)?r.push(g):t!==null&&(r[t]=g)}return m(o,{onObjectBegin:()=>{const g={};a(g),s.push(r),r=g,t=null},onObjectProperty:g=>{t=g},onObjectEnd:()=>{r=s.pop()},onArrayBegin:()=>{const g=[];a(g),s.push(r),r=g,t=null},onArrayEnd:()=>{r=s.pop()},onLiteralValue:a,onError:(g,_,F)=>{l.push({error:g,offset:_,length:F})}},i),r[0]}e.parse=E;function S(o,l=[],i=C.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(g){t.type==="property"&&(t.length=g-t.offset,t=t.parent)}function s(g){return t.children.push(g),g}m(o,{onObjectBegin:g=>{t=s({type:"object",offset:g,length:-1,parent:t,children:[]})},onObjectProperty:(g,_,F)=>{t=s({type:"property",offset:_,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:g,offset:_,length:F,parent:t})},onObjectEnd:(g,_)=>{t.length=g+_-t.offset,t=t.parent,r(g+_)},onArrayBegin:(g,_)=>{t=s({type:"array",offset:g,length:-1,parent:t,children:[]})},onArrayEnd:(g,_)=>{t.length=g+_-t.offset,t=t.parent,r(g+_)},onLiteralValue:(g,_,F)=>{s({type:c(g),offset:_,length:F,parent:t,value:g}),r(_+F)},onSeparator:(g,_,F)=>{t.type==="property"&&(g===":"?t.colonOffset=_:g===","&&r(_))},onError:(g,_,F)=>{l.push({error:g,offset:_,length:F})}},i);const h=t.children[0];return h&&delete h.parent,h}e.parseTree=S;function u(o,l){if(!o)return;let i=o;for(let t of l)if(typeof t=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const s of i.children)if(Array.isArray(s.children)&&s.children[0].value===t){i=s.children[1],r=!0;break}if(!r)return}else{const r=t;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}e.findNodeAtLocation=u;function b(o){if(!o.parent||!o.parent.children)return[];const l=b(o.parent);if(o.parent.type==="property"){const i=o.parent.children[0].value;l.push(i)}else if(o.parent.type==="array"){const i=o.parent.children.indexOf(o);i!==-1&&l.push(i)}return l}e.getNodePath=b;function f(o){switch(o.type){case"array":return o.children.map(f);case"object":{const l=Object.create(null);for(let i of o.children){const t=i.children[1];t&&(l[i.children[0].value]=f(t))}return l}case"null":case"string":case"number":case"boolean":return o.value;default:return}}e.getNodeValue=f;function d(o,l,i=!1){return l>=o.offset&&l<o.offset+o.length||i&&l===o.offset+o.length}e.contains=d;function p(o,l,i=!1){if(d(o,l,i)){const t=o.children;if(Array.isArray(t))for(let r=0;r<t.length&&t[r].offset<=l;r++){const s=p(t[r],l,i);if(s)return s}return o}}e.findNodeAtOffset=p;function m(o,l,i=C.DEFAULT){const t=T(o,!1);function r(de){return de?()=>de(t.getTokenOffset(),t.getTokenLength()):()=>!0}function s(de){return de?he=>de(he,t.getTokenOffset(),t.getTokenLength()):()=>!0}const a=r(l.onObjectBegin),h=s(l.onObjectProperty),g=r(l.onObjectEnd),_=r(l.onArrayBegin),F=r(l.onArrayEnd),$=s(l.onLiteralValue),K=s(l.onSeparator),I=r(l.onComment),W=s(l.onError),M=i&&i.disallowComments,q=i&&i.allowTrailingComma;function Z(){for(;;){const de=t.scan();switch(t.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:M||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(de){case 12:case 13:M?H(10):I();break;case 16:H(1);break;case 15:case 14:break;default:return de}}}function H(de,he=[],j=[]){if(W(de),he.length+j.length>0){let O=t.getToken();for(;O!==17;){if(he.indexOf(O)!==-1){Z();break}else if(j.indexOf(O)!==-1)break;O=Z()}}}function U(de){const he=t.getTokenValue();return de?$(he):h(he),Z(),!0}function z(){switch(t.getToken()){case 11:{let de=0;try{de=JSON.parse(t.getTokenValue()),typeof de!="number"&&(H(2),de=0)}catch{H(2)}$(de);break}case 7:$(null);break;case 8:$(!0);break;case 9:$(!1);break;default:return!1}return Z(),!0}function Q(){return t.getToken()!==10?(H(3,[],[2,5]),!1):(U(!1),t.getToken()===6?(K(":"),Z(),ce()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function ie(){a(),Z();let de=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(de||H(4,[],[]),K(","),Z(),t.getToken()===2&&q)break}else de&&H(6,[],[]);Q()||H(4,[],[2,5]),de=!0}return g(),t.getToken()!==2?H(7,[2],[]):Z(),!0}function re(){_(),Z();let de=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(de||H(4,[],[]),K(","),Z(),t.getToken()===4&&q)break}else de&&H(6,[],[]);ce()||H(4,[],[4,5]),de=!0}return F(),t.getToken()!==4?H(8,[4],[]):Z(),!0}function ce(){switch(t.getToken()){case 3:return re();case 1:return ie();case 10:return U(!0);default:return z()}}return Z(),t.getToken()===17?i.allowEmptyContent?!0:(H(4,[],[]),!1):ce()?(t.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=m;function y(o,l){let i=T(o),t=[],r,s=0,a;do switch(a=i.getPosition(),r=i.scan(),r){case 12:case 13:case 17:s!==a&&t.push(o.substring(s,a)),l!==void 0&&t.push(i.getTokenValue().replace(/[^\r\n]/g,l)),s=i.getPosition();break}while(r!==17);return t.join("")}e.stripComments=y;function c(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(ve[119],we([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class k{constructor(w){this.executor=w,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(w){this._error=w}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(w){return new k(()=>w(this.getValue()))}}e.Lazy=k}),define(ve[2],we([0,1,73,49]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const w=!1;let C=null;function T(r){C=r}if(e.setDisposableTracker=T,w){const r="__is_disposable_tracked__";T(new class{trackDisposable(s){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[r]||console.log(a)},3e3)}setParent(s,a){if(s&&s!==p.None)try{s[r]=!0}catch{}}markAsDisposed(s){if(s&&s!==p.None)try{s[r]=!0}catch{}}markAsSingleton(s){}})}function D(r){return C?.trackDisposable(r),r}function v(r){C?.markAsDisposed(r)}function P(r,s){C?.setParent(r,s)}function A(r,s){if(!!C)for(const a of r)C.setParent(a,s)}function R(r){return C?.markAsSingleton(r),r}e.markAsSingleton=R;class E extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=E;function S(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=S;function u(r){if(n.Iterable.is(r)){let s=[];for(const a of r)if(a)try{a.dispose()}catch(h){s.push(h)}if(s.length===1)throw s[0];if(s.length>1)throw new E(s);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=u;function b(...r){const s=f(()=>u(r));return A(r,s),s}e.combinedDisposable=b;function f(r){const s=D({dispose:(0,k.once)(()=>{v(s),r()})});return s}e.toDisposable=f;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1,D(this)}dispose(){this._isDisposed||(v(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{u(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return P(s,this),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class p{constructor(){this._store=new d,D(this),P(this._store,this)}dispose(){v(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=p,p.None=Object.freeze({dispose(){}});class m{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&P(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,v(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&P(s,null),s}}e.MutableDisposable=m;class y{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=y;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,D(this)}set(s){let a=s;return this.unset=()=>a=void 0,this.isset=()=>a!==void 0,this.dispose=()=>{a&&(a(),a=void 0,v(this))},this}}e.SafeDisposable=c;class o{constructor(){this.references=new Map}acquire(s,...a){let h=this.references.get(s);h||(h={counter:0,object:this.createReferencedObject(s,...a)},this.references.set(s,h));const{object:g}=h,_=(0,k.once)(()=>{--h.counter==0&&(this.destroyReferencedObject(s,h.object),this.references.delete(s))});return h.counter++,{object:g,dispose:_}}}e.ReferenceCollection=o;class l{constructor(s){this.referenceCollection=s}async acquire(s,...a){const h=this.referenceCollection.acquire(s,...a);try{return{object:await h.object,dispose:()=>h.dispose()}}catch(g){throw h.dispose(),g}}}e.AsyncReferenceCollection=l;class i{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=i;function t(r){const s=new d;try{r(s)}finally{s.dispose()}}e.disposeOnReturn=t}),define(ve[120],we([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class k{constructor(C){this.element=C,this.next=k.Undefined,this.prev=k.Undefined}}k.Undefined=new k(void 0);class n{constructor(){this._first=k.Undefined,this._last=k.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===k.Undefined}clear(){let C=this._first;for(;C!==k.Undefined;){const T=C.next;C.prev=k.Undefined,C.next=k.Undefined,C=T}this._first=k.Undefined,this._last=k.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,T){const D=new k(C);if(this._first===k.Undefined)this._first=D,this._last=D;else if(T){const P=this._last;this._last=D,D.prev=P,P.next=D}else{const P=this._first;this._first=D,D.next=P,P.prev=D}this._size+=1;let v=!1;return()=>{v||(v=!0,this._remove(D))}}shift(){if(this._first!==k.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==k.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==k.Undefined&&C.next!==k.Undefined){const T=C.prev;T.next=C.next,C.next.prev=T}else C.prev===k.Undefined&&C.next===k.Undefined?(this._first=k.Undefined,this._last=k.Undefined):C.next===k.Undefined?(this._last=this._last.prev,this._last.next=k.Undefined):C.prev===k.Undefined&&(this._first=this._first.next,this._first.prev=k.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==k.Undefined;)yield C.element,C=C.next}}e.LinkedList=n}),function(ee,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(ve[121],we([1]),e):(ee=typeof globalThis!="undefined"?globalThis:ee||self,e(ee.marked={}))}(this,function(ee){"use strict";function e(ue,oe){for(var pe=0;pe<oe.length;pe++){var X=oe[pe];X.enumerable=X.enumerable||!1,X.configurable=!0,"value"in X&&(X.writable=!0),Object.defineProperty(ue,X.key,X)}}function k(ue,oe,pe){return oe&&e(ue.prototype,oe),pe&&e(ue,pe),Object.defineProperty(ue,"prototype",{writable:!1}),ue}function n(ue,oe){if(!!ue){if(typeof ue=="string")return w(ue,oe);var pe=Object.prototype.toString.call(ue).slice(8,-1);if(pe==="Object"&&ue.constructor&&(pe=ue.constructor.name),pe==="Map"||pe==="Set")return Array.from(ue);if(pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(pe))return w(ue,oe)}}function w(ue,oe){(oe==null||oe>ue.length)&&(oe=ue.length);for(var pe=0,X=new Array(oe);pe<oe;pe++)X[pe]=ue[pe];return X}function C(ue,oe){var pe=typeof Symbol!="undefined"&&ue[Symbol.iterator]||ue["@@iterator"];if(pe)return(pe=pe.call(ue)).next.bind(pe);if(Array.isArray(ue)||(pe=n(ue))||oe&&ue&&typeof ue.length=="number"){pe&&(ue=pe);var X=0;return function(){return X>=ue.length?{done:!0}:{done:!1,value:ue[X++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function T(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ee.defaults=T();function D(ue){ee.defaults=ue}var v=/[&<>"']/,P=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,R=/[<>"']|&(?!#?\w+;)/g,E={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(oe){return E[oe]};function u(ue,oe){if(oe){if(v.test(ue))return ue.replace(P,S)}else if(A.test(ue))return ue.replace(R,S);return ue}var b=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(ue){return ue.replace(b,function(oe,pe){return pe=pe.toLowerCase(),pe==="colon"?":":pe.charAt(0)==="#"?pe.charAt(1)==="x"?String.fromCharCode(parseInt(pe.substring(2),16)):String.fromCharCode(+pe.substring(1)):""})}var d=/(^|[^\[])\^/g;function p(ue,oe){ue=ue.source||ue,oe=oe||"";var pe={replace:function(B,x){return x=x.source||x,x=x.replace(d,"$1"),ue=ue.replace(B,x),pe},getRegex:function(){return new RegExp(ue,oe)}};return pe}var m=/[^\w:]/g,y=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(ue,oe,pe){if(ue){var X;try{X=decodeURIComponent(f(pe)).replace(m,"").toLowerCase()}catch{return null}if(X.indexOf("javascript:")===0||X.indexOf("vbscript:")===0||X.indexOf("data:")===0)return null}oe&&!y.test(pe)&&(pe=r(oe,pe));try{pe=encodeURI(pe).replace(/%25/g,"%")}catch{return null}return pe}var o={},l=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,t=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(ue,oe){o[" "+ue]||(l.test(ue)?o[" "+ue]=ue+"/":o[" "+ue]=g(ue,"/",!0)),ue=o[" "+ue];var pe=ue.indexOf(":")===-1;return oe.substring(0,2)==="//"?pe?oe:ue.replace(i,"$1")+oe:oe.charAt(0)==="/"?pe?oe:ue.replace(t,"$1")+oe:ue+oe}var s={exec:function(){}};function a(ue){for(var oe=1,pe,X;oe<arguments.length;oe++){pe=arguments[oe];for(X in pe)Object.prototype.hasOwnProperty.call(pe,X)&&(ue[X]=pe[X])}return ue}function h(ue,oe){var pe=ue.replace(/\|/g,function(x,Y,fe){for(var ye=!1,ke=Y;--ke>=0&&fe[ke]==="\\";)ye=!ye;return ye?"|":" |"}),X=pe.split(/ \|/),B=0;if(X[0].trim()||X.shift(),X[X.length-1].trim()||X.pop(),X.length>oe)X.splice(oe);else for(;X.length<oe;)X.push("");for(;B<X.length;B++)X[B]=X[B].trim().replace(/\\\|/g,"|");return X}function g(ue,oe,pe){var X=ue.length;if(X===0)return"";for(var B=0;B<X;){var x=ue.charAt(X-B-1);if(x===oe&&!pe)B++;else if(x!==oe&&pe)B++;else break}return ue.substr(0,X-B)}function _(ue,oe){if(ue.indexOf(oe[1])===-1)return-1;for(var pe=ue.length,X=0,B=0;B<pe;B++)if(ue[B]==="\\")B++;else if(ue[B]===oe[0])X++;else if(ue[B]===oe[1]&&(X--,X<0))return B;return-1}function F(ue){ue&&ue.sanitize&&!ue.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function $(ue,oe){if(oe<1)return"";for(var pe="";oe>1;)oe&1&&(pe+=ue),oe>>=1,ue+=ue;return pe+ue}function K(ue,oe,pe,X){var B=oe.href,x=oe.title?u(oe.title):null,Y=ue[1].replace(/\\([\[\]])/g,"$1");if(ue[0].charAt(0)!=="!"){X.state.inLink=!0;var fe={type:"link",raw:pe,href:B,title:x,text:Y,tokens:X.inlineTokens(Y,[])};return X.state.inLink=!1,fe}else return{type:"image",raw:pe,href:B,title:x,text:u(Y)}}function I(ue,oe){var pe=ue.match(/^(\s+)(?:```)/);if(pe===null)return oe;var X=pe[1];return oe.split(`
`).map(function(B){var x=B.match(/^\s+/);if(x===null)return B;var Y=x[0];return Y.length>=X.length?B.slice(X.length):B}).join(`
`)}var W=function(){function ue(pe){this.options=pe||ee.defaults}var oe=ue.prototype;return oe.space=function(X){var B=this.rules.block.newline.exec(X);if(B&&B[0].length>0)return{type:"space",raw:B[0]}},oe.code=function(X){var B=this.rules.block.code.exec(X);if(B){var x=B[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:B[0],codeBlockStyle:"indented",text:this.options.pedantic?x:g(x,`
`)}}},oe.fences=function(X){var B=this.rules.block.fences.exec(X);if(B){var x=B[0],Y=I(x,B[3]||"");return{type:"code",raw:x,lang:B[2]?B[2].trim():B[2],text:Y}}},oe.heading=function(X){var B=this.rules.block.heading.exec(X);if(B){var x=B[2].trim();if(/#$/.test(x)){var Y=g(x,"#");(this.options.pedantic||!Y||/ $/.test(Y))&&(x=Y.trim())}var fe={type:"heading",raw:B[0],depth:B[1].length,text:x,tokens:[]};return this.lexer.inline(fe.text,fe.tokens),fe}},oe.hr=function(X){var B=this.rules.block.hr.exec(X);if(B)return{type:"hr",raw:B[0]}},oe.blockquote=function(X){var B=this.rules.block.blockquote.exec(X);if(B){var x=B[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:B[0],tokens:this.lexer.blockTokens(x,[]),text:x}}},oe.list=function(X){var B=this.rules.block.list.exec(X);if(B){var x,Y,fe,ye,ke,Re,Ue,Ne,se,Ee,me,Te,Fe=B[1].trim(),Ye=Fe.length>1,Be={type:"list",raw:"",ordered:Ye,start:Ye?+Fe.slice(0,-1):"",loose:!1,items:[]};Fe=Ye?"\\d{1,9}\\"+Fe.slice(-1):"\\"+Fe,this.options.pedantic&&(Fe=Ye?Fe:"[*+-]");for(var je=new RegExp("^( {0,3}"+Fe+")((?: [^\\n]*)?(?:\\n|$))");X&&(Te=!1,!(!(B=je.exec(X))||this.rules.block.hr.test(X)));){if(x=B[0],X=X.substring(x.length),Ne=B[2].split(`
`,1)[0],se=X.split(`
`,1)[0],this.options.pedantic?(ye=2,me=Ne.trimLeft()):(ye=B[2].search(/[^ ]/),ye=ye>4?1:ye,me=Ne.slice(ye),ye+=B[1].length),Re=!1,!Ne&&/^ *$/.test(se)&&(x+=se+`
`,X=X.substring(se.length+1),Te=!0),!Te)for(var Ge=new RegExp("^ {0,"+Math.min(3,ye-1)+"}(?:[*+-]|\\d{1,9}[.)])");X&&(Ee=X.split(`
`,1)[0],Ne=Ee,this.options.pedantic&&(Ne=Ne.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!Ge.test(Ne));){if(Ne.search(/[^ ]/)>=ye||!Ne.trim())me+=`
`+Ne.slice(ye);else if(!Re)me+=`
`+Ne;else break;!Re&&!Ne.trim()&&(Re=!0),x+=Ee+`
`,X=X.substring(Ee.length+1)}Be.loose||(Ue?Be.loose=!0:/\n *\n *$/.test(x)&&(Ue=!0)),this.options.gfm&&(Y=/^\[[ xX]\] /.exec(me),Y&&(fe=Y[0]!=="[ ] ",me=me.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:x,task:!!Y,checked:fe,loose:!1,text:me}),Be.raw+=x}Be.items[Be.items.length-1].raw=x.trimRight(),Be.items[Be.items.length-1].text=me.trimRight(),Be.raw=Be.raw.trimRight();var ne=Be.items.length;for(ke=0;ke<ne;ke++){this.lexer.state.top=!1,Be.items[ke].tokens=this.lexer.blockTokens(Be.items[ke].text,[]);var Ce=Be.items[ke].tokens.filter(function(Le){return Le.type==="space"}),Pe=Ce.every(function(Le){for(var Me=Le.raw.split(""),Ke=0,$e=C(Me),He;!(He=$e()).done;){var Qe=He.value;if(Qe===`
`&&(Ke+=1),Ke>1)return!0}return!1});!Be.loose&&Ce.length&&Pe&&(Be.loose=!0,Be.items[ke].loose=!0)}return Be}},oe.html=function(X){var B=this.rules.block.html.exec(X);if(B){var x={type:"html",raw:B[0],pre:!this.options.sanitizer&&(B[1]==="pre"||B[1]==="script"||B[1]==="style"),text:B[0]};return this.options.sanitize&&(x.type="paragraph",x.text=this.options.sanitizer?this.options.sanitizer(B[0]):u(B[0]),x.tokens=[],this.lexer.inline(x.text,x.tokens)),x}},oe.def=function(X){var B=this.rules.block.def.exec(X);if(B){B[3]&&(B[3]=B[3].substring(1,B[3].length-1));var x=B[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:x,raw:B[0],href:B[2],title:B[3]}}},oe.table=function(X){var B=this.rules.block.table.exec(X);if(B){var x={type:"table",header:h(B[1]).map(function(Ue){return{text:Ue}}),align:B[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:B[3]?B[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(x.header.length===x.align.length){x.raw=B[0];var Y=x.align.length,fe,ye,ke,Re;for(fe=0;fe<Y;fe++)/^ *-+: *$/.test(x.align[fe])?x.align[fe]="right":/^ *:-+: *$/.test(x.align[fe])?x.align[fe]="center":/^ *:-+ *$/.test(x.align[fe])?x.align[fe]="left":x.align[fe]=null;for(Y=x.rows.length,fe=0;fe<Y;fe++)x.rows[fe]=h(x.rows[fe],x.header.length).map(function(Ue){return{text:Ue}});for(Y=x.header.length,ye=0;ye<Y;ye++)x.header[ye].tokens=[],this.lexer.inlineTokens(x.header[ye].text,x.header[ye].tokens);for(Y=x.rows.length,ye=0;ye<Y;ye++)for(Re=x.rows[ye],ke=0;ke<Re.length;ke++)Re[ke].tokens=[],this.lexer.inlineTokens(Re[ke].text,Re[ke].tokens);return x}}},oe.lheading=function(X){var B=this.rules.block.lheading.exec(X);if(B){var x={type:"heading",raw:B[0],depth:B[2].charAt(0)==="="?1:2,text:B[1],tokens:[]};return this.lexer.inline(x.text,x.tokens),x}},oe.paragraph=function(X){var B=this.rules.block.paragraph.exec(X);if(B){var x={type:"paragraph",raw:B[0],text:B[1].charAt(B[1].length-1)===`
`?B[1].slice(0,-1):B[1],tokens:[]};return this.lexer.inline(x.text,x.tokens),x}},oe.text=function(X){var B=this.rules.block.text.exec(X);if(B){var x={type:"text",raw:B[0],text:B[0],tokens:[]};return this.lexer.inline(x.text,x.tokens),x}},oe.escape=function(X){var B=this.rules.inline.escape.exec(X);if(B)return{type:"escape",raw:B[0],text:u(B[1])}},oe.tag=function(X){var B=this.rules.inline.tag.exec(X);if(B)return!this.lexer.state.inLink&&/^<a /i.test(B[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(B[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(B[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(B[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:B[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(B[0]):u(B[0]):B[0]}},oe.link=function(X){var B=this.rules.inline.link.exec(X);if(B){var x=B[2].trim();if(!this.options.pedantic&&/^</.test(x)){if(!/>$/.test(x))return;var Y=g(x.slice(0,-1),"\\");if((x.length-Y.length)%2==0)return}else{var fe=_(B[2],"()");if(fe>-1){var ye=B[0].indexOf("!")===0?5:4,ke=ye+B[1].length+fe;B[2]=B[2].substring(0,fe),B[0]=B[0].substring(0,ke).trim(),B[3]=""}}var Re=B[2],Ue="";if(this.options.pedantic){var Ne=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Re);Ne&&(Re=Ne[1],Ue=Ne[3])}else Ue=B[3]?B[3].slice(1,-1):"";return Re=Re.trim(),/^</.test(Re)&&(this.options.pedantic&&!/>$/.test(x)?Re=Re.slice(1):Re=Re.slice(1,-1)),K(B,{href:Re&&Re.replace(this.rules.inline._escapes,"$1"),title:Ue&&Ue.replace(this.rules.inline._escapes,"$1")},B[0],this.lexer)}},oe.reflink=function(X,B){var x;if((x=this.rules.inline.reflink.exec(X))||(x=this.rules.inline.nolink.exec(X))){var Y=(x[2]||x[1]).replace(/\s+/g," ");if(Y=B[Y.toLowerCase()],!Y||!Y.href){var fe=x[0].charAt(0);return{type:"text",raw:fe,text:fe}}return K(x,Y,x[0],this.lexer)}},oe.emStrong=function(X,B,x){x===void 0&&(x="");var Y=this.rules.inline.emStrong.lDelim.exec(X);if(!!Y&&!(Y[3]&&x.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var fe=Y[1]||Y[2]||"";if(!fe||fe&&(x===""||this.rules.inline.punctuation.exec(x))){var ye=Y[0].length-1,ke,Re,Ue=ye,Ne=0,se=Y[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(se.lastIndex=0,B=B.slice(-1*X.length+ye);(Y=se.exec(B))!=null;)if(ke=Y[1]||Y[2]||Y[3]||Y[4]||Y[5]||Y[6],!!ke){if(Re=ke.length,Y[3]||Y[4]){Ue+=Re;continue}else if((Y[5]||Y[6])&&ye%3&&!((ye+Re)%3)){Ne+=Re;continue}if(Ue-=Re,!(Ue>0)){if(Re=Math.min(Re,Re+Ue+Ne),Math.min(ye,Re)%2){var Ee=X.slice(1,ye+Y.index+Re);return{type:"em",raw:X.slice(0,ye+Y.index+Re+1),text:Ee,tokens:this.lexer.inlineTokens(Ee,[])}}var me=X.slice(2,ye+Y.index+Re-1);return{type:"strong",raw:X.slice(0,ye+Y.index+Re+1),text:me,tokens:this.lexer.inlineTokens(me,[])}}}}}},oe.codespan=function(X){var B=this.rules.inline.code.exec(X);if(B){var x=B[2].replace(/\n/g," "),Y=/[^ ]/.test(x),fe=/^ /.test(x)&&/ $/.test(x);return Y&&fe&&(x=x.substring(1,x.length-1)),x=u(x,!0),{type:"codespan",raw:B[0],text:x}}},oe.br=function(X){var B=this.rules.inline.br.exec(X);if(B)return{type:"br",raw:B[0]}},oe.del=function(X){var B=this.rules.inline.del.exec(X);if(B)return{type:"del",raw:B[0],text:B[2],tokens:this.lexer.inlineTokens(B[2],[])}},oe.autolink=function(X,B){var x=this.rules.inline.autolink.exec(X);if(x){var Y,fe;return x[2]==="@"?(Y=u(this.options.mangle?B(x[1]):x[1]),fe="mailto:"+Y):(Y=u(x[1]),fe=Y),{type:"link",raw:x[0],text:Y,href:fe,tokens:[{type:"text",raw:Y,text:Y}]}}},oe.url=function(X,B){var x;if(x=this.rules.inline.url.exec(X)){var Y,fe;if(x[2]==="@")Y=u(this.options.mangle?B(x[0]):x[0]),fe="mailto:"+Y;else{var ye;do ye=x[0],x[0]=this.rules.inline._backpedal.exec(x[0])[0];while(ye!==x[0]);Y=u(x[0]),x[1]==="www."?fe="http://"+Y:fe=Y}return{type:"link",raw:x[0],text:Y,href:fe,tokens:[{type:"text",raw:Y,text:Y}]}}},oe.inlineText=function(X,B){var x=this.rules.inline.text.exec(X);if(x){var Y;return this.lexer.state.inRawBlock?Y=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):u(x[0]):x[0]:Y=u(this.options.smartypants?B(x[0]):x[0]),{type:"text",raw:x[0],text:Y}}},ue}(),M={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:s,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};M._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,M._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,M.def=p(M.def).replace("label",M._label).replace("title",M._title).getRegex(),M.bullet=/(?:[*+-]|\d{1,9}[.)])/,M.listItemStart=p(/^( *)(bull) */).replace("bull",M.bullet).getRegex(),M.list=p(M.list).replace(/bull/g,M.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+M.def.source+")").getRegex(),M._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",M._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,M.html=p(M.html,"i").replace("comment",M._comment).replace("tag",M._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),M.paragraph=p(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.blockquote=p(M.blockquote).replace("paragraph",M.paragraph).getRegex(),M.normal=a({},M),M.gfm=a({},M.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),M.gfm.table=p(M.gfm.table).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.gfm.paragraph=p(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",M.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.pedantic=a({},M.normal,{html:p(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",M._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:s,paragraph:p(M.normal._paragraph).replace("hr",M.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",M.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:s,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:s,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",q.punctuation=p(q.punctuation).replace(/punctuation/g,q._punctuation).getRegex(),q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,q.escapedEmSt=/\\\*|\\_/g,q._comment=p(M._comment).replace("(?:-->|$)","-->").getRegex(),q.emStrong.lDelim=p(q.emStrong.lDelim).replace(/punct/g,q._punctuation).getRegex(),q.emStrong.rDelimAst=p(q.emStrong.rDelimAst,"g").replace(/punct/g,q._punctuation).getRegex(),q.emStrong.rDelimUnd=p(q.emStrong.rDelimUnd,"g").replace(/punct/g,q._punctuation).getRegex(),q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,q.autolink=p(q.autolink).replace("scheme",q._scheme).replace("email",q._email).getRegex(),q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,q.tag=p(q.tag).replace("comment",q._comment).replace("attribute",q._attribute).getRegex(),q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,q.link=p(q.link).replace("label",q._label).replace("href",q._href).replace("title",q._title).getRegex(),q.reflink=p(q.reflink).replace("label",q._label).replace("ref",M._label).getRegex(),q.nolink=p(q.nolink).replace("ref",M._label).getRegex(),q.reflinkSearch=p(q.reflinkSearch,"g").replace("reflink",q.reflink).replace("nolink",q.nolink).getRegex(),q.normal=a({},q),q.pedantic=a({},q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:p(/^!?\[(label)\]\((.*?)\)/).replace("label",q._label).getRegex(),reflink:p(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",q._label).getRegex()}),q.gfm=a({},q.normal,{escape:p(q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),q.gfm.url=p(q.gfm.url,"i").replace("email",q.gfm._extended_email).getRegex(),q.breaks=a({},q.gfm,{br:p(q.br).replace("{2,}","*").getRegex(),text:p(q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function Z(ue){return ue.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function H(ue){var oe="",pe,X,B=ue.length;for(pe=0;pe<B;pe++)X=ue.charCodeAt(pe),Math.random()>.5&&(X="x"+X.toString(16)),oe+="&#"+X+";";return oe}var U=function(){function ue(pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=pe||ee.defaults,this.options.tokenizer=this.options.tokenizer||new W,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var X={block:M.normal,inline:q.normal};this.options.pedantic?(X.block=M.pedantic,X.inline=q.pedantic):this.options.gfm&&(X.block=M.gfm,this.options.breaks?X.inline=q.breaks:X.inline=q.gfm),this.tokenizer.rules=X}ue.lex=function(X,B){var x=new ue(B);return x.lex(X)},ue.lexInline=function(X,B){var x=new ue(B);return x.inlineTokens(X)};var oe=ue.prototype;return oe.lex=function(X){X=X.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(X,this.tokens);for(var B;B=this.inlineQueue.shift();)this.inlineTokens(B.src,B.tokens);return this.tokens},oe.blockTokens=function(X,B){var x=this;B===void 0&&(B=[]),this.options.pedantic&&(X=X.replace(/^ +$/gm,""));for(var Y,fe,ye,ke;X;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ue){return(Y=Ue.call({lexer:x},X,B))?(X=X.substring(Y.raw.length),B.push(Y),!0):!1}))){if(Y=this.tokenizer.space(X)){X=X.substring(Y.raw.length),Y.raw.length===1&&B.length>0?B[B.length-1].raw+=`
`:B.push(Y);continue}if(Y=this.tokenizer.code(X)){X=X.substring(Y.raw.length),fe=B[B.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+Y.raw,fe.text+=`
`+Y.text,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):B.push(Y);continue}if(Y=this.tokenizer.fences(X)){X=X.substring(Y.raw.length),B.push(Y);continue}if(Y=this.tokenizer.heading(X)){X=X.substring(Y.raw.length),B.push(Y);continue}if(Y=this.tokenizer.hr(X)){X=X.substring(Y.raw.length),B.push(Y);continue}if(Y=this.tokenizer.blockquote(X)){X=X.substring(Y.raw.length),B.push(Y);continue}if(Y=this.tokenizer.list(X)){X=X.substring(Y.raw.length),B.push(Y);continue}if(Y=this.tokenizer.html(X)){X=X.substring(Y.raw.length),B.push(Y);continue}if(Y=this.tokenizer.def(X)){X=X.substring(Y.raw.length),fe=B[B.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+Y.raw,fe.text+=`
`+Y.raw,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):this.tokens.links[Y.tag]||(this.tokens.links[Y.tag]={href:Y.href,title:Y.title});continue}if(Y=this.tokenizer.table(X)){X=X.substring(Y.raw.length),B.push(Y);continue}if(Y=this.tokenizer.lheading(X)){X=X.substring(Y.raw.length),B.push(Y);continue}if(ye=X,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ue=1/0,Ne=X.slice(1),se=void 0;x.options.extensions.startBlock.forEach(function(Ee){se=Ee.call({lexer:this},Ne),typeof se=="number"&&se>=0&&(Ue=Math.min(Ue,se))}),Ue<1/0&&Ue>=0&&(ye=X.substring(0,Ue+1))}(),this.state.top&&(Y=this.tokenizer.paragraph(ye))){fe=B[B.length-1],ke&&fe.type==="paragraph"?(fe.raw+=`
`+Y.raw,fe.text+=`
`+Y.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):B.push(Y),ke=ye.length!==X.length,X=X.substring(Y.raw.length);continue}if(Y=this.tokenizer.text(X)){X=X.substring(Y.raw.length),fe=B[B.length-1],fe&&fe.type==="text"?(fe.raw+=`
`+Y.raw,fe.text+=`
`+Y.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):B.push(Y);continue}if(X){var Re="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(Re);break}else throw new Error(Re)}}return this.state.top=!0,B},oe.inline=function(X,B){this.inlineQueue.push({src:X,tokens:B})},oe.inlineTokens=function(X,B){var x=this;B===void 0&&(B=[]);var Y,fe,ye,ke=X,Re,Ue,Ne;if(this.tokens.links){var se=Object.keys(this.tokens.links);if(se.length>0)for(;(Re=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)se.includes(Re[0].slice(Re[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Re.index)+"["+$("a",Re[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Re=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Re.index)+"["+$("a",Re[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Re=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Re.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;X;)if(Ue||(Ne=""),Ue=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(me){return(Y=me.call({lexer:x},X,B))?(X=X.substring(Y.raw.length),B.push(Y),!0):!1}))){if(Y=this.tokenizer.escape(X)){X=X.substring(Y.raw.length),B.push(Y);continue}if(Y=this.tokenizer.tag(X)){X=X.substring(Y.raw.length),fe=B[B.length-1],fe&&Y.type==="text"&&fe.type==="text"?(fe.raw+=Y.raw,fe.text+=Y.text):B.push(Y);continue}if(Y=this.tokenizer.link(X)){X=X.substring(Y.raw.length),B.push(Y);continue}if(Y=this.tokenizer.reflink(X,this.tokens.links)){X=X.substring(Y.raw.length),fe=B[B.length-1],fe&&Y.type==="text"&&fe.type==="text"?(fe.raw+=Y.raw,fe.text+=Y.text):B.push(Y);continue}if(Y=this.tokenizer.emStrong(X,ke,Ne)){X=X.substring(Y.raw.length),B.push(Y);continue}if(Y=this.tokenizer.codespan(X)){X=X.substring(Y.raw.length),B.push(Y);continue}if(Y=this.tokenizer.br(X)){X=X.substring(Y.raw.length),B.push(Y);continue}if(Y=this.tokenizer.del(X)){X=X.substring(Y.raw.length),B.push(Y);continue}if(Y=this.tokenizer.autolink(X,H)){X=X.substring(Y.raw.length),B.push(Y);continue}if(!this.state.inLink&&(Y=this.tokenizer.url(X,H))){X=X.substring(Y.raw.length),B.push(Y);continue}if(ye=X,this.options.extensions&&this.options.extensions.startInline&&function(){var me=1/0,Te=X.slice(1),Fe=void 0;x.options.extensions.startInline.forEach(function(Ye){Fe=Ye.call({lexer:this},Te),typeof Fe=="number"&&Fe>=0&&(me=Math.min(me,Fe))}),me<1/0&&me>=0&&(ye=X.substring(0,me+1))}(),Y=this.tokenizer.inlineText(ye,Z)){X=X.substring(Y.raw.length),Y.raw.slice(-1)!=="_"&&(Ne=Y.raw.slice(-1)),Ue=!0,fe=B[B.length-1],fe&&fe.type==="text"?(fe.raw+=Y.raw,fe.text+=Y.text):B.push(Y);continue}if(X){var Ee="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(Ee);break}else throw new Error(Ee)}}return B},k(ue,null,[{key:"rules",get:function(){return{block:M,inline:q}}}]),ue}(),z=function(){function ue(pe){this.options=pe||ee.defaults}var oe=ue.prototype;return oe.code=function(X,B,x){var Y=(B||"").match(/\S*/)[0];if(this.options.highlight){var fe=this.options.highlight(X,Y);fe!=null&&fe!==X&&(x=!0,X=fe)}return X=X.replace(/\n$/,"")+`
`,Y?'<pre><code class="'+this.options.langPrefix+u(Y,!0)+'">'+(x?X:u(X,!0))+`</code></pre>
`:"<pre><code>"+(x?X:u(X,!0))+`</code></pre>
`},oe.blockquote=function(X){return`<blockquote>
`+X+`</blockquote>
`},oe.html=function(X){return X},oe.heading=function(X,B,x,Y){return this.options.headerIds?"<h"+B+' id="'+this.options.headerPrefix+Y.slug(x)+'">'+X+"</h"+B+`>
`:"<h"+B+">"+X+"</h"+B+`>
`},oe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},oe.list=function(X,B,x){var Y=B?"ol":"ul",fe=B&&x!==1?' start="'+x+'"':"";return"<"+Y+fe+`>
`+X+"</"+Y+`>
`},oe.listitem=function(X){return"<li>"+X+`</li>
`},oe.checkbox=function(X){return"<input "+(X?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},oe.paragraph=function(X){return"<p>"+X+`</p>
`},oe.table=function(X,B){return B&&(B="<tbody>"+B+"</tbody>"),`<table>
<thead>
`+X+`</thead>
`+B+`</table>
`},oe.tablerow=function(X){return`<tr>
`+X+`</tr>
`},oe.tablecell=function(X,B){var x=B.header?"th":"td",Y=B.align?"<"+x+' align="'+B.align+'">':"<"+x+">";return Y+X+"</"+x+`>
`},oe.strong=function(X){return"<strong>"+X+"</strong>"},oe.em=function(X){return"<em>"+X+"</em>"},oe.codespan=function(X){return"<code>"+X+"</code>"},oe.br=function(){return this.options.xhtml?"<br/>":"<br>"},oe.del=function(X){return"<del>"+X+"</del>"},oe.link=function(X,B,x){if(X=c(this.options.sanitize,this.options.baseUrl,X),X===null)return x;var Y='<a href="'+u(X)+'"';return B&&(Y+=' title="'+B+'"'),Y+=">"+x+"</a>",Y},oe.image=function(X,B,x){if(X=c(this.options.sanitize,this.options.baseUrl,X),X===null)return x;var Y='<img src="'+X+'" alt="'+x+'"';return B&&(Y+=' title="'+B+'"'),Y+=this.options.xhtml?"/>":">",Y},oe.text=function(X){return X},ue}(),Q=function(){function ue(){}var oe=ue.prototype;return oe.strong=function(X){return X},oe.em=function(X){return X},oe.codespan=function(X){return X},oe.del=function(X){return X},oe.html=function(X){return X},oe.text=function(X){return X},oe.link=function(X,B,x){return""+x},oe.image=function(X,B,x){return""+x},oe.br=function(){return""},ue}(),ie=function(){function ue(){this.seen={}}var oe=ue.prototype;return oe.serialize=function(X){return X.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},oe.getNextSafeSlug=function(X,B){var x=X,Y=0;if(this.seen.hasOwnProperty(x)){Y=this.seen[X];do Y++,x=X+"-"+Y;while(this.seen.hasOwnProperty(x))}return B||(this.seen[X]=Y,this.seen[x]=0),x},oe.slug=function(X,B){B===void 0&&(B={});var x=this.serialize(X);return this.getNextSafeSlug(x,B.dryrun)},ue}(),re=function(){function ue(pe){this.options=pe||ee.defaults,this.options.renderer=this.options.renderer||new z,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Q,this.slugger=new ie}ue.parse=function(X,B){var x=new ue(B);return x.parse(X)},ue.parseInline=function(X,B){var x=new ue(B);return x.parseInline(X)};var oe=ue.prototype;return oe.parse=function(X,B){B===void 0&&(B=!0);var x="",Y,fe,ye,ke,Re,Ue,Ne,se,Ee,me,Te,Fe,Ye,Be,je,Ge,ne,Ce,Pe,Le=X.length;for(Y=0;Y<Le;Y++){if(me=X[Y],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[me.type]&&(Pe=this.options.extensions.renderers[me.type].call({parser:this},me),Pe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(me.type))){x+=Pe||"";continue}switch(me.type){case"space":continue;case"hr":{x+=this.renderer.hr();continue}case"heading":{x+=this.renderer.heading(this.parseInline(me.tokens),me.depth,f(this.parseInline(me.tokens,this.textRenderer)),this.slugger);continue}case"code":{x+=this.renderer.code(me.text,me.lang,me.escaped);continue}case"table":{for(se="",Ne="",ke=me.header.length,fe=0;fe<ke;fe++)Ne+=this.renderer.tablecell(this.parseInline(me.header[fe].tokens),{header:!0,align:me.align[fe]});for(se+=this.renderer.tablerow(Ne),Ee="",ke=me.rows.length,fe=0;fe<ke;fe++){for(Ue=me.rows[fe],Ne="",Re=Ue.length,ye=0;ye<Re;ye++)Ne+=this.renderer.tablecell(this.parseInline(Ue[ye].tokens),{header:!1,align:me.align[ye]});Ee+=this.renderer.tablerow(Ne)}x+=this.renderer.table(se,Ee);continue}case"blockquote":{Ee=this.parse(me.tokens),x+=this.renderer.blockquote(Ee);continue}case"list":{for(Te=me.ordered,Fe=me.start,Ye=me.loose,ke=me.items.length,Ee="",fe=0;fe<ke;fe++)je=me.items[fe],Ge=je.checked,ne=je.task,Be="",je.task&&(Ce=this.renderer.checkbox(Ge),Ye?je.tokens.length>0&&je.tokens[0].type==="paragraph"?(je.tokens[0].text=Ce+" "+je.tokens[0].text,je.tokens[0].tokens&&je.tokens[0].tokens.length>0&&je.tokens[0].tokens[0].type==="text"&&(je.tokens[0].tokens[0].text=Ce+" "+je.tokens[0].tokens[0].text)):je.tokens.unshift({type:"text",text:Ce}):Be+=Ce),Be+=this.parse(je.tokens,Ye),Ee+=this.renderer.listitem(Be,ne,Ge);x+=this.renderer.list(Ee,Te,Fe);continue}case"html":{x+=this.renderer.html(me.text);continue}case"paragraph":{x+=this.renderer.paragraph(this.parseInline(me.tokens));continue}case"text":{for(Ee=me.tokens?this.parseInline(me.tokens):me.text;Y+1<Le&&X[Y+1].type==="text";)me=X[++Y],Ee+=`
`+(me.tokens?this.parseInline(me.tokens):me.text);x+=B?this.renderer.paragraph(Ee):Ee;continue}default:{var Me='Token with "'+me.type+'" type was not found.';if(this.options.silent){console.error(Me);return}else throw new Error(Me)}}}return x},oe.parseInline=function(X,B){B=B||this.renderer;var x="",Y,fe,ye,ke=X.length;for(Y=0;Y<ke;Y++){if(fe=X[Y],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]&&(ye=this.options.extensions.renderers[fe.type].call({parser:this},fe),ye!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(fe.type))){x+=ye||"";continue}switch(fe.type){case"escape":{x+=B.text(fe.text);break}case"html":{x+=B.html(fe.text);break}case"link":{x+=B.link(fe.href,fe.title,this.parseInline(fe.tokens,B));break}case"image":{x+=B.image(fe.href,fe.title,fe.text);break}case"strong":{x+=B.strong(this.parseInline(fe.tokens,B));break}case"em":{x+=B.em(this.parseInline(fe.tokens,B));break}case"codespan":{x+=B.codespan(fe.text);break}case"br":{x+=B.br();break}case"del":{x+=B.del(this.parseInline(fe.tokens,B));break}case"text":{x+=B.text(fe.text);break}default:{var Re='Token with "'+fe.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}}return x},ue}();function ce(ue,oe,pe){if(typeof ue=="undefined"||ue===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ue!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ue)+", string expected");if(typeof oe=="function"&&(pe=oe,oe=null),oe=a({},ce.defaults,oe||{}),F(oe),pe){var X=oe.highlight,B;try{B=U.lex(ue,oe)}catch(ye){return pe(ye)}var x=function(ke){var Re;if(!ke)try{oe.walkTokens&&ce.walkTokens(B,oe.walkTokens),Re=re.parse(B,oe)}catch(Ue){ke=Ue}return oe.highlight=X,ke?pe(ke):pe(null,Re)};if(!X||X.length<3||(delete oe.highlight,!B.length))return x();var Y=0;ce.walkTokens(B,function(ye){ye.type==="code"&&(Y++,setTimeout(function(){X(ye.text,ye.lang,function(ke,Re){if(ke)return x(ke);Re!=null&&Re!==ye.text&&(ye.text=Re,ye.escaped=!0),Y--,Y===0&&x()})},0))}),Y===0&&x();return}try{var fe=U.lex(ue,oe);return oe.walkTokens&&ce.walkTokens(fe,oe.walkTokens),re.parse(fe,oe)}catch(ye){if(ye.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+u(ye.message+"",!0)+"</pre>";throw ye}}ce.options=ce.setOptions=function(ue){return a(ce.defaults,ue),D(ce.defaults),ce},ce.getDefaults=T,ce.defaults=ee.defaults,ce.use=function(){for(var ue=arguments.length,oe=new Array(ue),pe=0;pe<ue;pe++)oe[pe]=arguments[pe];var X=a.apply(void 0,[{}].concat(oe)),B=ce.defaults.extensions||{renderers:{},childTokens:{}},x;oe.forEach(function(Y){if(Y.extensions&&(x=!0,Y.extensions.forEach(function(ye){if(!ye.name)throw new Error("extension name required");if(ye.renderer){var ke=B.renderers?B.renderers[ye.name]:null;ke?B.renderers[ye.name]=function(){for(var Re=arguments.length,Ue=new Array(Re),Ne=0;Ne<Re;Ne++)Ue[Ne]=arguments[Ne];var se=ye.renderer.apply(this,Ue);return se===!1&&(se=ke.apply(this,Ue)),se}:B.renderers[ye.name]=ye.renderer}if(ye.tokenizer){if(!ye.level||ye.level!=="block"&&ye.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");B[ye.level]?B[ye.level].unshift(ye.tokenizer):B[ye.level]=[ye.tokenizer],ye.start&&(ye.level==="block"?B.startBlock?B.startBlock.push(ye.start):B.startBlock=[ye.start]:ye.level==="inline"&&(B.startInline?B.startInline.push(ye.start):B.startInline=[ye.start]))}ye.childTokens&&(B.childTokens[ye.name]=ye.childTokens)})),Y.renderer&&function(){var ye=ce.defaults.renderer||new z,ke=function(Ne){var se=ye[Ne];ye[Ne]=function(){for(var Ee=arguments.length,me=new Array(Ee),Te=0;Te<Ee;Te++)me[Te]=arguments[Te];var Fe=Y.renderer[Ne].apply(ye,me);return Fe===!1&&(Fe=se.apply(ye,me)),Fe}};for(var Re in Y.renderer)ke(Re);X.renderer=ye}(),Y.tokenizer&&function(){var ye=ce.defaults.tokenizer||new W,ke=function(Ne){var se=ye[Ne];ye[Ne]=function(){for(var Ee=arguments.length,me=new Array(Ee),Te=0;Te<Ee;Te++)me[Te]=arguments[Te];var Fe=Y.tokenizer[Ne].apply(ye,me);return Fe===!1&&(Fe=se.apply(ye,me)),Fe}};for(var Re in Y.tokenizer)ke(Re);X.tokenizer=ye}(),Y.walkTokens){var fe=ce.defaults.walkTokens;X.walkTokens=function(ye){Y.walkTokens.call(this,ye),fe&&fe.call(this,ye)}}x&&(X.extensions=B),ce.setOptions(X)})},ce.walkTokens=function(ue,oe){for(var pe=function(){var Y=B.value;switch(oe.call(ce,Y),Y.type){case"table":{for(var fe=C(Y.header),ye;!(ye=fe()).done;){var ke=ye.value;ce.walkTokens(ke.tokens,oe)}for(var Re=C(Y.rows),Ue;!(Ue=Re()).done;)for(var Ne=Ue.value,se=C(Ne),Ee;!(Ee=se()).done;){var me=Ee.value;ce.walkTokens(me.tokens,oe)}break}case"list":{ce.walkTokens(Y.items,oe);break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[Y.type]?ce.defaults.extensions.childTokens[Y.type].forEach(function(Te){ce.walkTokens(Y[Te],oe)}):Y.tokens&&ce.walkTokens(Y.tokens,oe)}},X=C(ue),B;!(B=X()).done;)pe()},ce.parseInline=function(ue,oe){if(typeof ue=="undefined"||ue===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ue!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ue)+", string expected");oe=a({},ce.defaults,oe||{}),F(oe);try{var pe=U.lexInline(ue,oe);return oe.walkTokens&&ce.walkTokens(pe,oe.walkTokens),re.parseInline(pe,oe)}catch(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+u(X.message+"",!0)+"</pre>";throw X}},ce.Parser=re,ce.parser=re.parse,ce.Renderer=z,ce.TextRenderer=Q,ce.Lexer=U,ce.lexer=U.lex,ce.Tokenizer=W,ce.Slugger=ie,ce.parse=ce;var de=ce.options,he=ce.setOptions,j=ce.use,O=ce.walkTokens,V=ce.parseInline,J=ce,le=re.parse,ge=U.lex;ee.Lexer=U,ee.Parser=re,ee.Renderer=z,ee.Slugger=ie,ee.TextRenderer=Q,ee.Tokenizer=W,ee.getDefaults=T,ee.lexer=ge,ee.marked=ce,ee.options=de,ee.parse=J,ee.parseInline=V,ee.parser=le,ee.setOptions=he,ee.use=j,ee.walkTokens=O,Object.defineProperty(ee,"__esModule",{value:!0})}),function(){function ee(w){const C=[];typeof w=="number"&&C.push("code/timeOrigin",w);function T(v){C.push(v,Date.now())}function D(){const v=[];for(let P=0;P<C.length;P+=2)v.push({name:C[P],startTime:C[P+1]});return v}return{mark:T,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const T of performance.getEntriesByType("mark"))C.push({name:T.name,startTime:Math.round(w+T.startTime)});return C}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function k(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=e()),w.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=k(n))}(),define(ve[3],we([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const k="en";let n=!1,w=!1,C=!1,T=!1,D=!1,v=!1,P=!1,A=!1,R=!1,E,S=k,u,b;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?f=e.globals.vscode.process:typeof process!="undefined"&&(f=process);const d=typeof f?.versions?.electron=="string",p=d&&f?.type==="renderer";if(e.isElectronSandboxed=p&&f?.sandboxed,typeof navigator=="object"&&!p)b=navigator.userAgent,n=b.indexOf("Windows")>=0,w=b.indexOf("Macintosh")>=0,A=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=b.indexOf("Linux")>=0,v=!0,E=navigator.language,S=E;else if(typeof f=="object"){n=f.platform==="win32",w=f.platform==="darwin",C=f.platform==="linux",T=C&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,P=d,R=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,E=k,S=k;const s=f.env.VSCODE_NLS_CONFIG;if(s)try{const a=JSON.parse(s),h=a.availableLanguages["*"];E=a.locale,S=h||k,u=a._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var m;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(m=e.Platform||(e.Platform={}));function y(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=y;let c=0;w?c=1:n?c=3:C&&(c=2),e.isWindows=n,e.isMacintosh=w,e.isLinux=C,e.isLinuxSnap=T,e.isNative=D,e.isElectron=P,e.isWeb=v,e.isWebWorker=v&&typeof e.globals.importScripts=="function",e.isIOS=A,e.isCI=R,e.platform=c,e.userAgent=b,e.language=S;var o;(function(s){function a(){return e.language}s.value=a;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=h;function g(){return e.language==="en"}s.isDefault=g})(o=e.Language||(e.Language={})),e.locale=E,e.translationsConfigFile=u,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let s=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeScheduleAsyncWork)for(let g=0,_=s.length;g<_;g++){const F=s[g];if(F.id===h.data.vscodeScheduleAsyncWork){s.splice(g,1),F.callback();return}}});let a=0;return h=>{const g=++a;s.push({id:g,callback:h}),e.globals.postMessage({vscodeScheduleAsyncWork:g},"*")}}return s=>setTimeout(s)})();var l;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=w||A?2:n?1:3;let i=!0,t=!1;function r(){if(!t){t=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,i=new Uint16Array(s.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=r,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ve[24],we([0,1,3]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof k.globals.vscode!="undefined"&&typeof k.globals.vscode.process!="undefined"){const w=k.globals.vscode.process;n={get platform(){return w.platform},get arch(){return w.arch},get env(){return w.env},cwd(){return w.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return k.isWindows?"win32":k.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(ve[5],we([0,1,24]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,w=97,C=90,T=122,D=46,v=47,P=92,A=58,R=63;class E extends Error{constructor(y,c,o){let l;typeof c=="string"&&c.indexOf("not ")===0?(l="must not be",c=c.replace(/^not /,"")):l="must be";const i=y.indexOf(".")!==-1?"property":"argument";let t=`The "${y}" ${i} ${l} of type ${c}`;t+=`. Received type ${typeof o}`;super(t);this.code="ERR_INVALID_ARG_TYPE"}}function S(m,y){if(typeof m!="string")throw new E(y,"string",m)}function u(m){return m===v||m===P}function b(m){return m===v}function f(m){return m>=n&&m<=C||m>=w&&m<=T}function d(m,y,c,o){let l="",i=0,t=-1,r=0,s=0;for(let a=0;a<=m.length;++a){if(a<m.length)s=m.charCodeAt(a);else{if(o(s))break;s=v}if(o(s)){if(!(t===a-1||r===1))if(r===2){if(l.length<2||i!==2||l.charCodeAt(l.length-1)!==D||l.charCodeAt(l.length-2)!==D){if(l.length>2){const h=l.lastIndexOf(c);h===-1?(l="",i=0):(l=l.slice(0,h),i=l.length-1-l.lastIndexOf(c)),t=a,r=0;continue}else if(l.length!==0){l="",i=0,t=a,r=0;continue}}y&&(l+=l.length>0?`${c}..`:"..",i=2)}else l.length>0?l+=`${c}${m.slice(t+1,a)}`:l=m.slice(t+1,a),i=a-t-1;t=a,r=0}else s===D&&r!==-1?++r:r=-1}return l}function p(m,y){if(y===null||typeof y!="object")throw new E("pathObject","Object",y);const c=y.dir||y.root,o=y.base||`${y.name||""}${y.ext||""}`;return c?c===y.root?`${c}${o}`:`${c}${m}${o}`:o}e.win32={resolve(...m){let y="",c="",o=!1;for(let l=m.length-1;l>=-1;l--){let i;if(l>=0){if(i=m[l],S(i,"path"),i.length===0)continue}else y.length===0?i=k.cwd():(i=k.env[`=${y}`]||k.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==y.toLowerCase()&&i.charCodeAt(2)===P)&&(i=`${y}\\`));const t=i.length;let r=0,s="",a=!1;const h=i.charCodeAt(0);if(t===1)u(h)&&(r=1,a=!0);else if(u(h))if(a=!0,u(i.charCodeAt(1))){let g=2,_=g;for(;g<t&&!u(i.charCodeAt(g));)g++;if(g<t&&g!==_){const F=i.slice(_,g);for(_=g;g<t&&u(i.charCodeAt(g));)g++;if(g<t&&g!==_){for(_=g;g<t&&!u(i.charCodeAt(g));)g++;(g===t||g!==_)&&(s=`\\\\${F}\\${i.slice(_,g)}`,r=g)}}}else r=1;else f(h)&&i.charCodeAt(1)===A&&(s=i.slice(0,2),r=2,t>2&&u(i.charCodeAt(2))&&(a=!0,r=3));if(s.length>0)if(y.length>0){if(s.toLowerCase()!==y.toLowerCase())continue}else y=s;if(o){if(y.length>0)break}else if(c=`${i.slice(r)}\\${c}`,o=a,a&&y.length>0)break}return c=d(c,!o,"\\",u),o?`${y}\\${c}`:`${y}${c}`||"."},normalize(m){S(m,"path");const y=m.length;if(y===0)return".";let c=0,o,l=!1;const i=m.charCodeAt(0);if(y===1)return b(i)?"\\":m;if(u(i))if(l=!0,u(m.charCodeAt(1))){let r=2,s=r;for(;r<y&&!u(m.charCodeAt(r));)r++;if(r<y&&r!==s){const a=m.slice(s,r);for(s=r;r<y&&u(m.charCodeAt(r));)r++;if(r<y&&r!==s){for(s=r;r<y&&!u(m.charCodeAt(r));)r++;if(r===y)return`\\\\${a}\\${m.slice(s)}\\`;r!==s&&(o=`\\\\${a}\\${m.slice(s,r)}`,c=r)}}}else c=1;else f(i)&&m.charCodeAt(1)===A&&(o=m.slice(0,2),c=2,y>2&&u(m.charCodeAt(2))&&(l=!0,c=3));let t=c<y?d(m.slice(c),!l,"\\",u):"";return t.length===0&&!l&&(t="."),t.length>0&&u(m.charCodeAt(y-1))&&(t+="\\"),o===void 0?l?`\\${t}`:t:l?`${o}\\${t}`:`${o}${t}`},isAbsolute(m){S(m,"path");const y=m.length;if(y===0)return!1;const c=m.charCodeAt(0);return u(c)||y>2&&f(c)&&m.charCodeAt(1)===A&&u(m.charCodeAt(2))},join(...m){if(m.length===0)return".";let y,c;for(let i=0;i<m.length;++i){const t=m[i];S(t,"path"),t.length>0&&(y===void 0?y=c=t:y+=`\\${t}`)}if(y===void 0)return".";let o=!0,l=0;if(typeof c=="string"&&u(c.charCodeAt(0))){++l;const i=c.length;i>1&&u(c.charCodeAt(1))&&(++l,i>2&&(u(c.charCodeAt(2))?++l:o=!1))}if(o){for(;l<y.length&&u(y.charCodeAt(l));)l++;l>=2&&(y=`\\${y.slice(l)}`)}return e.win32.normalize(y)},relative(m,y){if(S(m,"from"),S(y,"to"),m===y)return"";const c=e.win32.resolve(m),o=e.win32.resolve(y);if(c===o||(m=c.toLowerCase(),y=o.toLowerCase(),m===y))return"";let l=0;for(;l<m.length&&m.charCodeAt(l)===P;)l++;let i=m.length;for(;i-1>l&&m.charCodeAt(i-1)===P;)i--;const t=i-l;let r=0;for(;r<y.length&&y.charCodeAt(r)===P;)r++;let s=y.length;for(;s-1>r&&y.charCodeAt(s-1)===P;)s--;const a=s-r,h=t<a?t:a;let g=-1,_=0;for(;_<h;_++){const $=m.charCodeAt(l+_);if($!==y.charCodeAt(r+_))break;$===P&&(g=_)}if(_!==h){if(g===-1)return o}else{if(a>h){if(y.charCodeAt(r+_)===P)return o.slice(r+_+1);if(_===2)return o.slice(r+_)}t>h&&(m.charCodeAt(l+_)===P?g=_:_===2&&(g=3)),g===-1&&(g=0)}let F="";for(_=l+g+1;_<=i;++_)(_===i||m.charCodeAt(_)===P)&&(F+=F.length===0?"..":"\\..");return r+=g,F.length>0?`${F}${o.slice(r,s)}`:(o.charCodeAt(r)===P&&++r,o.slice(r,s))},toNamespacedPath(m){if(typeof m!="string")return m;if(m.length===0)return"";const y=e.win32.resolve(m);if(y.length<=2)return m;if(y.charCodeAt(0)===P){if(y.charCodeAt(1)===P){const c=y.charCodeAt(2);if(c!==R&&c!==D)return`\\\\?\\UNC\\${y.slice(2)}`}}else if(f(y.charCodeAt(0))&&y.charCodeAt(1)===A&&y.charCodeAt(2)===P)return`\\\\?\\${y}`;return m},dirname(m){S(m,"path");const y=m.length;if(y===0)return".";let c=-1,o=0;const l=m.charCodeAt(0);if(y===1)return u(l)?m:".";if(u(l)){if(c=o=1,u(m.charCodeAt(1))){let r=2,s=r;for(;r<y&&!u(m.charCodeAt(r));)r++;if(r<y&&r!==s){for(s=r;r<y&&u(m.charCodeAt(r));)r++;if(r<y&&r!==s){for(s=r;r<y&&!u(m.charCodeAt(r));)r++;if(r===y)return m;r!==s&&(c=o=r+1)}}}}else f(l)&&m.charCodeAt(1)===A&&(c=y>2&&u(m.charCodeAt(2))?3:2,o=c);let i=-1,t=!0;for(let r=y-1;r>=o;--r)if(u(m.charCodeAt(r))){if(!t){i=r;break}}else t=!1;if(i===-1){if(c===-1)return".";i=c}return m.slice(0,i)},basename(m,y){y!==void 0&&S(y,"ext"),S(m,"path");let c=0,o=-1,l=!0,i;if(m.length>=2&&f(m.charCodeAt(0))&&m.charCodeAt(1)===A&&(c=2),y!==void 0&&y.length>0&&y.length<=m.length){if(y===m)return"";let t=y.length-1,r=-1;for(i=m.length-1;i>=c;--i){const s=m.charCodeAt(i);if(u(s)){if(!l){c=i+1;break}}else r===-1&&(l=!1,r=i+1),t>=0&&(s===y.charCodeAt(t)?--t==-1&&(o=i):(t=-1,o=r))}return c===o?o=r:o===-1&&(o=m.length),m.slice(c,o)}for(i=m.length-1;i>=c;--i)if(u(m.charCodeAt(i))){if(!l){c=i+1;break}}else o===-1&&(l=!1,o=i+1);return o===-1?"":m.slice(c,o)},extname(m){S(m,"path");let y=0,c=-1,o=0,l=-1,i=!0,t=0;m.length>=2&&m.charCodeAt(1)===A&&f(m.charCodeAt(0))&&(y=o=2);for(let r=m.length-1;r>=y;--r){const s=m.charCodeAt(r);if(u(s)){if(!i){o=r+1;break}continue}l===-1&&(i=!1,l=r+1),s===D?c===-1?c=r:t!==1&&(t=1):c!==-1&&(t=-1)}return c===-1||l===-1||t===0||t===1&&c===l-1&&c===o+1?"":m.slice(c,l)},format:p.bind(null,"\\"),parse(m){S(m,"path");const y={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return y;const c=m.length;let o=0,l=m.charCodeAt(0);if(c===1)return u(l)?(y.root=y.dir=m,y):(y.base=y.name=m,y);if(u(l)){if(o=1,u(m.charCodeAt(1))){let g=2,_=g;for(;g<c&&!u(m.charCodeAt(g));)g++;if(g<c&&g!==_){for(_=g;g<c&&u(m.charCodeAt(g));)g++;if(g<c&&g!==_){for(_=g;g<c&&!u(m.charCodeAt(g));)g++;g===c?o=g:g!==_&&(o=g+1)}}}}else if(f(l)&&m.charCodeAt(1)===A){if(c<=2)return y.root=y.dir=m,y;if(o=2,u(m.charCodeAt(2))){if(c===3)return y.root=y.dir=m,y;o=3}}o>0&&(y.root=m.slice(0,o));let i=-1,t=o,r=-1,s=!0,a=m.length-1,h=0;for(;a>=o;--a){if(l=m.charCodeAt(a),u(l)){if(!s){t=a+1;break}continue}r===-1&&(s=!1,r=a+1),l===D?i===-1?i=a:h!==1&&(h=1):i!==-1&&(h=-1)}return r!==-1&&(i===-1||h===0||h===1&&i===r-1&&i===t+1?y.base=y.name=m.slice(t,r):(y.name=m.slice(t,i),y.base=m.slice(t,r),y.ext=m.slice(i,r))),t>0&&t!==o?y.dir=m.slice(0,t-1):y.dir=y.root,y},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...m){let y="",c=!1;for(let o=m.length-1;o>=-1&&!c;o--){const l=o>=0?m[o]:k.cwd();S(l,"path"),l.length!==0&&(y=`${l}/${y}`,c=l.charCodeAt(0)===v)}return y=d(y,!c,"/",b),c?`/${y}`:y.length>0?y:"."},normalize(m){if(S(m,"path"),m.length===0)return".";const y=m.charCodeAt(0)===v,c=m.charCodeAt(m.length-1)===v;return m=d(m,!y,"/",b),m.length===0?y?"/":c?"./":".":(c&&(m+="/"),y?`/${m}`:m)},isAbsolute(m){return S(m,"path"),m.length>0&&m.charCodeAt(0)===v},join(...m){if(m.length===0)return".";let y;for(let c=0;c<m.length;++c){const o=m[c];S(o,"path"),o.length>0&&(y===void 0?y=o:y+=`/${o}`)}return y===void 0?".":e.posix.normalize(y)},relative(m,y){if(S(m,"from"),S(y,"to"),m===y||(m=e.posix.resolve(m),y=e.posix.resolve(y),m===y))return"";const c=1,o=m.length,l=o-c,i=1,t=y.length-i,r=l<t?l:t;let s=-1,a=0;for(;a<r;a++){const g=m.charCodeAt(c+a);if(g!==y.charCodeAt(i+a))break;g===v&&(s=a)}if(a===r)if(t>r){if(y.charCodeAt(i+a)===v)return y.slice(i+a+1);if(a===0)return y.slice(i+a)}else l>r&&(m.charCodeAt(c+a)===v?s=a:a===0&&(s=0));let h="";for(a=c+s+1;a<=o;++a)(a===o||m.charCodeAt(a)===v)&&(h+=h.length===0?"..":"/..");return`${h}${y.slice(i+s)}`},toNamespacedPath(m){return m},dirname(m){if(S(m,"path"),m.length===0)return".";const y=m.charCodeAt(0)===v;let c=-1,o=!0;for(let l=m.length-1;l>=1;--l)if(m.charCodeAt(l)===v){if(!o){c=l;break}}else o=!1;return c===-1?y?"/":".":y&&c===1?"//":m.slice(0,c)},basename(m,y){y!==void 0&&S(y,"ext"),S(m,"path");let c=0,o=-1,l=!0,i;if(y!==void 0&&y.length>0&&y.length<=m.length){if(y===m)return"";let t=y.length-1,r=-1;for(i=m.length-1;i>=0;--i){const s=m.charCodeAt(i);if(s===v){if(!l){c=i+1;break}}else r===-1&&(l=!1,r=i+1),t>=0&&(s===y.charCodeAt(t)?--t==-1&&(o=i):(t=-1,o=r))}return c===o?o=r:o===-1&&(o=m.length),m.slice(c,o)}for(i=m.length-1;i>=0;--i)if(m.charCodeAt(i)===v){if(!l){c=i+1;break}}else o===-1&&(l=!1,o=i+1);return o===-1?"":m.slice(c,o)},extname(m){S(m,"path");let y=-1,c=0,o=-1,l=!0,i=0;for(let t=m.length-1;t>=0;--t){const r=m.charCodeAt(t);if(r===v){if(!l){c=t+1;break}continue}o===-1&&(l=!1,o=t+1),r===D?y===-1?y=t:i!==1&&(i=1):y!==-1&&(i=-1)}return y===-1||o===-1||i===0||i===1&&y===o-1&&y===c+1?"":m.slice(y,o)},format:p.bind(null,"/"),parse(m){S(m,"path");const y={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return y;const c=m.charCodeAt(0)===v;let o;c?(y.root="/",o=1):o=0;let l=-1,i=0,t=-1,r=!0,s=m.length-1,a=0;for(;s>=o;--s){const h=m.charCodeAt(s);if(h===v){if(!r){i=s+1;break}continue}t===-1&&(r=!1,t=s+1),h===D?l===-1?l=s:a!==1&&(a=1):l!==-1&&(a=-1)}if(t!==-1){const h=i===0&&c?1:i;l===-1||a===0||a===1&&l===t-1&&l===i+1?y.base=y.name=m.slice(h,t):(y.name=m.slice(h,l),y.base=m.slice(h,t),y.ext=m.slice(l,t))}return i>0?y.dir=m.slice(0,i-1):c&&(y.dir="/"),y},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=k.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=k.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=k.platform==="win32"?e.win32.join:e.posix.join,e.resolve=k.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=k.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=k.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=k.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=k.platform==="win32"?e.win32.extname:e.posix.extname,e.format=k.platform==="win32"?e.win32.format:e.posix.format,e.parse=k.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=k.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=k.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=k.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ve[60],we([0,1,5]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var n;(function(R){R.text="text/plain",R.binary="application/octet-stream",R.unknown="application/unknown",R.markdown="text/markdown",R.latex="text/latex",R.uriList="text/uri-list"})(n=e.Mimes||(e.Mimes={}));const w={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(R){const E=(0,k.extname)(R),S=w[E.toLowerCase()];return S!==void 0?S:D(R)}e.getMediaOrTextMime=T;function D(R){const E=(0,k.extname)(R);return C[E.toLowerCase()]}e.getMediaMime=D;function v(R){for(const E in C)if(C[E]===R)return E}e.getExtensionForMimeType=v;const P=/^(.+)\/(.+?)(;.+)?$/;function A(R,E){const S=P.exec(R);return S?`${S[1].toLowerCase()}/${S[2].toLowerCase()}${S[3]??""}`:E?void 0:R}e.normalizeMimeType=A}),define(ve[74],we([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var k;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(k=e.Source||(e.Source={}));var n;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function w(C,...T){const D=T.reduce((A,R)=>(A[R]=!0,A),{}),v=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(A=>!D[A]).forEach(A=>{for(let R=0;R<v.length;R++)if(A.search(v[R])!==-1){delete C[A];break}})}e.sanitizeProcessEnvironment=w}),function(ee,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var n in k)(typeof exports=="object"?exports:ee)[n]=k[n]}}(typeof self!="undefined"?self:this,function(){return function(ee){var e={};function k(n){if(e[n])return e[n].exports;var w=e[n]={i:n,l:!1,exports:{}};return ee[n].call(w.exports,w,w.exports,k),w.l=!0,w.exports}return k.m=ee,k.c=e,k.d=function(n,w,C){k.o(n,w)||Object.defineProperty(n,w,{enumerable:!0,get:C})},k.r=function(n){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(n,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(n,"__esModule",{value:!0})},k.t=function(n,w){if(1&w&&(n=k(n)),8&w||4&w&&typeof n=="object"&&n&&n.__esModule)return n;var C=Object.create(null);if(k.r(C),Object.defineProperty(C,"default",{enumerable:!0,value:n}),2&w&&typeof n!="string")for(var T in n)k.d(C,T,function(D){return n[D]}.bind(null,T));return C},k.n=function(n){var w=n&&n.__esModule?function(){return n.default}:function(){return n};return k.d(w,"a",w),w},k.o=function(n,w){return Object.prototype.hasOwnProperty.call(n,w)},k.p="",k(k.s=0)}([function(ee,e,k){(function(n){var w;e=ee.exports=j,w=typeof n=="object"&&n.env&&n.env.NODE_DEBUG&&/\bsemver\b/i.test(n.env.NODE_DEBUG)?function(){var se=Array.prototype.slice.call(arguments,0);se.unshift("SEMVER"),console.log.apply(console,se)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var C=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,D=e.re=[],v=e.src=[],P=0,A=P++;v[A]="0|[1-9]\\d*";var R=P++;v[R]="[0-9]+";var E=P++;v[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=P++;v[S]="("+v[A]+")\\.("+v[A]+")\\.("+v[A]+")";var u=P++;v[u]="("+v[R]+")\\.("+v[R]+")\\.("+v[R]+")";var b=P++;v[b]="(?:"+v[A]+"|"+v[E]+")";var f=P++;v[f]="(?:"+v[R]+"|"+v[E]+")";var d=P++;v[d]="(?:-("+v[b]+"(?:\\."+v[b]+")*))";var p=P++;v[p]="(?:-?("+v[f]+"(?:\\."+v[f]+")*))";var m=P++;v[m]="[0-9A-Za-z-]+";var y=P++;v[y]="(?:\\+("+v[m]+"(?:\\."+v[m]+")*))";var c=P++,o="v?"+v[S]+v[d]+"?"+v[y]+"?";v[c]="^"+o+"$";var l="[v=\\s]*"+v[u]+v[p]+"?"+v[y]+"?",i=P++;v[i]="^"+l+"$";var t=P++;v[t]="((?:<|>)?=?)";var r=P++;v[r]=v[R]+"|x|X|\\*";var s=P++;v[s]=v[A]+"|x|X|\\*";var a=P++;v[a]="[v=\\s]*("+v[s]+")(?:\\.("+v[s]+")(?:\\.("+v[s]+")(?:"+v[d]+")?"+v[y]+"?)?)?";var h=P++;v[h]="[v=\\s]*("+v[r]+")(?:\\.("+v[r]+")(?:\\.("+v[r]+")(?:"+v[p]+")?"+v[y]+"?)?)?";var g=P++;v[g]="^"+v[t]+"\\s*"+v[a]+"$";var _=P++;v[_]="^"+v[t]+"\\s*"+v[h]+"$";var F=P++;v[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var $=P++;v[$]="(?:~>?)";var K=P++;v[K]="(\\s*)"+v[$]+"\\s+",D[K]=new RegExp(v[K],"g");var I=P++;v[I]="^"+v[$]+v[a]+"$";var W=P++;v[W]="^"+v[$]+v[h]+"$";var M=P++;v[M]="(?:\\^)";var q=P++;v[q]="(\\s*)"+v[M]+"\\s+",D[q]=new RegExp(v[q],"g");var Z=P++;v[Z]="^"+v[M]+v[a]+"$";var H=P++;v[H]="^"+v[M]+v[h]+"$";var U=P++;v[U]="^"+v[t]+"\\s*("+l+")$|^$";var z=P++;v[z]="^"+v[t]+"\\s*("+o+")$|^$";var Q=P++;v[Q]="(\\s*)"+v[t]+"\\s*("+l+"|"+v[a]+")",D[Q]=new RegExp(v[Q],"g");var ie=P++;v[ie]="^\\s*("+v[a]+")\\s+-\\s+("+v[a]+")\\s*$";var re=P++;v[re]="^\\s*("+v[h]+")\\s+-\\s+("+v[h]+")\\s*$";var ce=P++;v[ce]="(<|>)?=?\\s*\\*";for(var de=0;de<35;de++)w(de,v[de]),D[de]||(D[de]=new RegExp(v[de]));function he(se,Ee){if(se instanceof j)return se;if(typeof se!="string"||se.length>C||!(Ee?D[i]:D[c]).test(se))return null;try{return new j(se,Ee)}catch{return null}}function j(se,Ee){if(se instanceof j){if(se.loose===Ee)return se;se=se.version}else if(typeof se!="string")throw new TypeError("Invalid Version: "+se);if(se.length>C)throw new TypeError("version is longer than "+C+" characters");if(!(this instanceof j))return new j(se,Ee);w("SemVer",se,Ee),this.loose=Ee;var me=se.trim().match(Ee?D[i]:D[c]);if(!me)throw new TypeError("Invalid Version: "+se);if(this.raw=se,this.major=+me[1],this.minor=+me[2],this.patch=+me[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");me[4]?this.prerelease=me[4].split(".").map(function(Te){if(/^[0-9]+$/.test(Te)){var Fe=+Te;if(Fe>=0&&Fe<T)return Fe}return Te}):this.prerelease=[],this.build=me[5]?me[5].split("."):[],this.format()}e.parse=he,e.valid=function(se,Ee){var me=he(se,Ee);return me?me.version:null},e.clean=function(se,Ee){var me=he(se.trim().replace(/^[=v]+/,""),Ee);return me?me.version:null},e.SemVer=j,j.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},j.prototype.toString=function(){return this.version},j.prototype.compare=function(se){return w("SemVer.compare",this.version,this.loose,se),se instanceof j||(se=new j(se,this.loose)),this.compareMain(se)||this.comparePre(se)},j.prototype.compareMain=function(se){return se instanceof j||(se=new j(se,this.loose)),V(this.major,se.major)||V(this.minor,se.minor)||V(this.patch,se.patch)},j.prototype.comparePre=function(se){if(se instanceof j||(se=new j(se,this.loose)),this.prerelease.length&&!se.prerelease.length)return-1;if(!this.prerelease.length&&se.prerelease.length)return 1;if(!this.prerelease.length&&!se.prerelease.length)return 0;var Ee=0;do{var me=this.prerelease[Ee],Te=se.prerelease[Ee];if(w("prerelease compare",Ee,me,Te),me===void 0&&Te===void 0)return 0;if(Te===void 0)return 1;if(me===void 0)return-1;if(me!==Te)return V(me,Te)}while(++Ee)},j.prototype.inc=function(se,Ee){switch(se){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ee);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ee);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ee),this.inc("pre",Ee);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ee),this.inc("pre",Ee);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var me=this.prerelease.length;--me>=0;)typeof this.prerelease[me]=="number"&&(this.prerelease[me]++,me=-2);me===-1&&this.prerelease.push(0)}Ee&&(this.prerelease[0]===Ee?isNaN(this.prerelease[1])&&(this.prerelease=[Ee,0]):this.prerelease=[Ee,0]);break;default:throw new Error("invalid increment argument: "+se)}return this.format(),this.raw=this.version,this},e.inc=function(se,Ee,me,Te){typeof me=="string"&&(Te=me,me=void 0);try{return new j(se,me).inc(Ee,Te).version}catch{return null}},e.diff=function(se,Ee){if(ue(se,Ee))return null;var me=he(se),Te=he(Ee);if(me.prerelease.length||Te.prerelease.length){for(var Fe in me)if((Fe==="major"||Fe==="minor"||Fe==="patch")&&me[Fe]!==Te[Fe])return"pre"+Fe;return"prerelease"}for(var Fe in me)if((Fe==="major"||Fe==="minor"||Fe==="patch")&&me[Fe]!==Te[Fe])return Fe},e.compareIdentifiers=V;var O=/^[0-9]+$/;function V(se,Ee){var me=O.test(se),Te=O.test(Ee);return me&&Te&&(se=+se,Ee=+Ee),me&&!Te?-1:Te&&!me?1:se<Ee?-1:se>Ee?1:0}function J(se,Ee,me){return new j(se,me).compare(new j(Ee,me))}function le(se,Ee,me){return J(se,Ee,me)>0}function ge(se,Ee,me){return J(se,Ee,me)<0}function ue(se,Ee,me){return J(se,Ee,me)===0}function oe(se,Ee,me){return J(se,Ee,me)!==0}function pe(se,Ee,me){return J(se,Ee,me)>=0}function X(se,Ee,me){return J(se,Ee,me)<=0}function B(se,Ee,me,Te){var Fe;switch(Ee){case"===":typeof se=="object"&&(se=se.version),typeof me=="object"&&(me=me.version),Fe=se===me;break;case"!==":typeof se=="object"&&(se=se.version),typeof me=="object"&&(me=me.version),Fe=se!==me;break;case"":case"=":case"==":Fe=ue(se,me,Te);break;case"!=":Fe=oe(se,me,Te);break;case">":Fe=le(se,me,Te);break;case">=":Fe=pe(se,me,Te);break;case"<":Fe=ge(se,me,Te);break;case"<=":Fe=X(se,me,Te);break;default:throw new TypeError("Invalid operator: "+Ee)}return Fe}function x(se,Ee){if(se instanceof x){if(se.loose===Ee)return se;se=se.value}if(!(this instanceof x))return new x(se,Ee);w("comparator",se,Ee),this.loose=Ee,this.parse(se),this.semver===Y?this.value="":this.value=this.operator+this.semver.version,w("comp",this)}e.rcompareIdentifiers=function(se,Ee){return V(Ee,se)},e.major=function(se,Ee){return new j(se,Ee).major},e.minor=function(se,Ee){return new j(se,Ee).minor},e.patch=function(se,Ee){return new j(se,Ee).patch},e.compare=J,e.compareLoose=function(se,Ee){return J(se,Ee,!0)},e.rcompare=function(se,Ee,me){return J(Ee,se,me)},e.sort=function(se,Ee){return se.sort(function(me,Te){return e.compare(me,Te,Ee)})},e.rsort=function(se,Ee){return se.sort(function(me,Te){return e.rcompare(me,Te,Ee)})},e.gt=le,e.lt=ge,e.eq=ue,e.neq=oe,e.gte=pe,e.lte=X,e.cmp=B,e.Comparator=x;var Y={};function fe(se,Ee){if(se instanceof fe)return se.loose===Ee?se:new fe(se.raw,Ee);if(se instanceof x)return new fe(se.value,Ee);if(!(this instanceof fe))return new fe(se,Ee);if(this.loose=Ee,this.raw=se,this.set=se.split(/\s*\|\|\s*/).map(function(me){return this.parseRange(me.trim())},this).filter(function(me){return me.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+se);this.format()}function ye(se){return!se||se.toLowerCase()==="x"||se==="*"}function ke(se,Ee,me,Te,Fe,Ye,Be,je,Ge,ne,Ce,Pe,Le){return((Ee=ye(me)?"":ye(Te)?">="+me+".0.0":ye(Fe)?">="+me+"."+Te+".0":">="+Ee)+" "+(je=ye(Ge)?"":ye(ne)?"<"+(+Ge+1)+".0.0":ye(Ce)?"<"+Ge+"."+(+ne+1)+".0":Pe?"<="+Ge+"."+ne+"."+Ce+"-"+Pe:"<="+je)).trim()}function Re(se,Ee){for(var me=0;me<se.length;me++)if(!se[me].test(Ee))return!1;if(Ee.prerelease.length){for(me=0;me<se.length;me++)if(w(se[me].semver),se[me].semver!==Y&&se[me].semver.prerelease.length>0){var Te=se[me].semver;if(Te.major===Ee.major&&Te.minor===Ee.minor&&Te.patch===Ee.patch)return!0}return!1}return!0}function Ue(se,Ee,me){try{Ee=new fe(Ee,me)}catch{return!1}return Ee.test(se)}function Ne(se,Ee,me,Te){var Fe,Ye,Be,je,Ge;switch(se=new j(se,Te),Ee=new fe(Ee,Te),me){case">":Fe=le,Ye=X,Be=ge,je=">",Ge=">=";break;case"<":Fe=ge,Ye=pe,Be=le,je="<",Ge="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(se,Ee,Te))return!1;for(var ne=0;ne<Ee.set.length;++ne){var Ce=Ee.set[ne],Pe=null,Le=null;if(Ce.forEach(function(Me){Me.semver===Y&&(Me=new x(">=0.0.0")),Pe=Pe||Me,Le=Le||Me,Fe(Me.semver,Pe.semver,Te)?Pe=Me:Be(Me.semver,Le.semver,Te)&&(Le=Me)}),Pe.operator===je||Pe.operator===Ge||(!Le.operator||Le.operator===je)&&Ye(se,Le.semver)||Le.operator===Ge&&Be(se,Le.semver))return!1}return!0}x.prototype.parse=function(se){var Ee=this.loose?D[U]:D[z],me=se.match(Ee);if(!me)throw new TypeError("Invalid comparator: "+se);this.operator=me[1],this.operator==="="&&(this.operator=""),me[2]?this.semver=new j(me[2],this.loose):this.semver=Y},x.prototype.toString=function(){return this.value},x.prototype.test=function(se){return w("Comparator.test",se,this.loose),this.semver===Y||(typeof se=="string"&&(se=new j(se,this.loose)),B(se,this.operator,this.semver,this.loose))},x.prototype.intersects=function(se,Ee){if(!(se instanceof x))throw new TypeError("a Comparator is required");var me;if(this.operator==="")return me=new fe(se.value,Ee),Ue(this.value,me,Ee);if(se.operator==="")return me=new fe(this.value,Ee),Ue(se.semver,me,Ee);var Te=!(this.operator!==">="&&this.operator!==">"||se.operator!==">="&&se.operator!==">"),Fe=!(this.operator!=="<="&&this.operator!=="<"||se.operator!=="<="&&se.operator!=="<"),Ye=this.semver.version===se.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||se.operator!==">="&&se.operator!=="<="),je=B(this.semver,"<",se.semver,Ee)&&(this.operator===">="||this.operator===">")&&(se.operator==="<="||se.operator==="<"),Ge=B(this.semver,">",se.semver,Ee)&&(this.operator==="<="||this.operator==="<")&&(se.operator===">="||se.operator===">");return Te||Fe||Ye&&Be||je||Ge},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(se){return se.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(se){var Ee=this.loose;se=se.trim(),w("range",se,Ee);var me=Ee?D[re]:D[ie];se=se.replace(me,ke),w("hyphen replace",se),se=se.replace(D[Q],"$1$2$3"),w("comparator trim",se,D[Q]),se=(se=(se=se.replace(D[K],"$1~")).replace(D[q],"$1^")).split(/\s+/).join(" ");var Te=Ee?D[U]:D[z],Fe=se.split(" ").map(function(Ye){return function(Be,je){return w("comp",Be),Be=function(Ge,ne){return Ge.trim().split(/\s+/).map(function(Ce){return function(Pe,Le){w("caret",Pe,Le);var Me=Le?D[H]:D[Z];return Pe.replace(Me,function(Ke,$e,He,Qe,Ve){var Ze;return w("caret",Pe,Ke,$e,He,Qe,Ve),ye($e)?Ze="":ye(He)?Ze=">="+$e+".0.0 <"+(+$e+1)+".0.0":ye(Qe)?Ze=$e==="0"?">="+$e+"."+He+".0 <"+$e+"."+(+He+1)+".0":">="+$e+"."+He+".0 <"+(+$e+1)+".0.0":Ve?(w("replaceCaret pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Ze=$e==="0"?He==="0"?">="+$e+"."+He+"."+Qe+Ve+" <"+$e+"."+He+"."+(+Qe+1):">="+$e+"."+He+"."+Qe+Ve+" <"+$e+"."+(+He+1)+".0":">="+$e+"."+He+"."+Qe+Ve+" <"+(+$e+1)+".0.0"):(w("no pr"),Ze=$e==="0"?He==="0"?">="+$e+"."+He+"."+Qe+" <"+$e+"."+He+"."+(+Qe+1):">="+$e+"."+He+"."+Qe+" <"+$e+"."+(+He+1)+".0":">="+$e+"."+He+"."+Qe+" <"+(+$e+1)+".0.0"),w("caret return",Ze),Ze})}(Ce,ne)}).join(" ")}(Be,je),w("caret",Be),Be=function(Ge,ne){return Ge.trim().split(/\s+/).map(function(Ce){return function(Pe,Le){var Me=Le?D[W]:D[I];return Pe.replace(Me,function(Ke,$e,He,Qe,Ve){var Ze;return w("tilde",Pe,Ke,$e,He,Qe,Ve),ye($e)?Ze="":ye(He)?Ze=">="+$e+".0.0 <"+(+$e+1)+".0.0":ye(Qe)?Ze=">="+$e+"."+He+".0 <"+$e+"."+(+He+1)+".0":Ve?(w("replaceTilde pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Ze=">="+$e+"."+He+"."+Qe+Ve+" <"+$e+"."+(+He+1)+".0"):Ze=">="+$e+"."+He+"."+Qe+" <"+$e+"."+(+He+1)+".0",w("tilde return",Ze),Ze})}(Ce,ne)}).join(" ")}(Be,je),w("tildes",Be),Be=function(Ge,ne){return w("replaceXRanges",Ge,ne),Ge.split(/\s+/).map(function(Ce){return function(Pe,Le){Pe=Pe.trim();var Me=Le?D[_]:D[g];return Pe.replace(Me,function(Ke,$e,He,Qe,Ve,Ze){w("xRange",Pe,Ke,$e,He,Qe,Ve,Ze);var it=ye(He),st=it||ye(Qe),tt=st||ye(Ve);return $e==="="&&tt&&($e=""),it?Ke=$e===">"||$e==="<"?"<0.0.0":"*":$e&&tt?(st&&(Qe=0),tt&&(Ve=0),$e===">"?($e=">=",st?(He=+He+1,Qe=0,Ve=0):tt&&(Qe=+Qe+1,Ve=0)):$e==="<="&&($e="<",st?He=+He+1:Qe=+Qe+1),Ke=$e+He+"."+Qe+"."+Ve):st?Ke=">="+He+".0.0 <"+(+He+1)+".0.0":tt&&(Ke=">="+He+"."+Qe+".0 <"+He+"."+(+Qe+1)+".0"),w("xRange return",Ke),Ke})}(Ce,ne)}).join(" ")}(Be,je),w("xrange",Be),Be=function(Ge,ne){return w("replaceStars",Ge,ne),Ge.trim().replace(D[ce],"")}(Be,je),w("stars",Be),Be}(Ye,Ee)}).join(" ").split(/\s+/);return this.loose&&(Fe=Fe.filter(function(Ye){return!!Ye.match(Te)})),Fe=Fe.map(function(Ye){return new x(Ye,Ee)})},fe.prototype.intersects=function(se,Ee){if(!(se instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(me){return me.every(function(Te){return se.set.some(function(Fe){return Fe.every(function(Ye){return Te.intersects(Ye,Ee)})})})})},e.toComparators=function(se,Ee){return new fe(se,Ee).set.map(function(me){return me.map(function(Te){return Te.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(se){if(!se)return!1;typeof se=="string"&&(se=new j(se,this.loose));for(var Ee=0;Ee<this.set.length;Ee++)if(Re(this.set[Ee],se))return!0;return!1},e.satisfies=Ue,e.maxSatisfying=function(se,Ee,me){var Te=null,Fe=null;try{var Ye=new fe(Ee,me)}catch{return null}return se.forEach(function(Be){Ye.test(Be)&&(Te&&Fe.compare(Be)!==-1||(Fe=new j(Te=Be,me)))}),Te},e.minSatisfying=function(se,Ee,me){var Te=null,Fe=null;try{var Ye=new fe(Ee,me)}catch{return null}return se.forEach(function(Be){Ye.test(Be)&&(Te&&Fe.compare(Be)!==1||(Fe=new j(Te=Be,me)))}),Te},e.validRange=function(se,Ee){try{return new fe(se,Ee).range||"*"}catch{return null}},e.ltr=function(se,Ee,me){return Ne(se,Ee,"<",me)},e.gtr=function(se,Ee,me){return Ne(se,Ee,">",me)},e.outside=Ne,e.prerelease=function(se,Ee){var me=he(se,Ee);return me&&me.prerelease.length?me.prerelease:null},e.intersects=function(se,Ee,me){return se=new fe(se,me),Ee=new fe(Ee,me),se.intersects(Ee)},e.coerce=function(se){if(se instanceof j)return se;if(typeof se!="string")return null;var Ee=se.match(D[F]);return Ee==null?null:he((Ee[1]||"0")+"."+(Ee[2]||"0")+"."+(Ee[3]||"0"))}}).call(this,k(1))},function(ee,e){var k,n,w=ee.exports={};function C(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function D(f){if(k===setTimeout)return setTimeout(f,0);if((k===C||!k)&&setTimeout)return k=setTimeout,setTimeout(f,0);try{return k(f,0)}catch{try{return k.call(null,f,0)}catch{return k.call(this,f,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:C}catch{k=C}try{n=typeof clearTimeout=="function"?clearTimeout:T}catch{n=T}})();var v,P=[],A=!1,R=-1;function E(){A&&v&&(A=!1,v.length?P=v.concat(P):R=-1,P.length&&S())}function S(){if(!A){var f=D(E);A=!0;for(var d=P.length;d;){for(v=P,P=[];++R<d;)v&&v[R].run();R=-1,d=P.length}v=null,A=!1,function(p){if(n===clearTimeout)return clearTimeout(p);if((n===T||!n)&&clearTimeout)return n=clearTimeout,clearTimeout(p);try{n(p)}catch{try{return n.call(null,p)}catch{return n.call(this,p)}}}(f)}}function u(f,d){this.fun=f,this.array=d}function b(){}w.nextTick=function(f){var d=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)d[p-1]=arguments[p];P.push(new u(f,d)),P.length!==1||A||D(S)},u.prototype.run=function(){this.fun.apply(null,this.array)},w.title="browser",w.browser=!0,w.env={},w.argv=[],w.version="",w.versions={},w.on=b,w.addListener=b,w.once=b,w.off=b,w.removeListener=b,w.removeAllListeners=b,w.emit=b,w.prependListener=b,w.prependOnceListener=b,w.listeners=function(f){return[]},w.binding=function(f){throw new Error("process.binding is not supported")},w.cwd=function(){return"/"},w.chdir=function(f){throw new Error("process.chdir is not supported")},w.umask=function(){return 0}}])}),define(ve[122],we([0,1]),function(ee,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class n{constructor(D,v,P){this.level=D,this.key=v,this.value=P,this.forward=[]}}const w=void 0;class C{constructor(D,v=2**16){this.comparator=D,this[k]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(v)|0),this._header=new n(this._maxLevel,w,w)}get size(){return this._size}clear(){this._header=new n(this._maxLevel,w,w)}has(D){return Boolean(C._search(this,D,this.comparator))}get(D){return C._search(this,D,this.comparator)?.value}set(D,v){return C._insert(this,D,v,this.comparator)&&(this._size+=1),this}delete(D){const v=C._delete(this,D,this.comparator);return v&&(this._size-=1),v}forEach(D,v){let P=this._header.forward[0];for(;P;)D.call(v,P.value,P.key,this),P=P.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let D=this._header.forward[0];for(;D;)yield[D.key,D.value],D=D.forward[0]}*keys(){let D=this._header.forward[0];for(;D;)yield D.key,D=D.forward[0]}*values(){let D=this._header.forward[0];for(;D;)yield D.value,D=D.forward[0]}toString(){let D="[SkipList]:",v=this._header.forward[0];for(;v;)D+=`node(${v.key}, ${v.value}, lvl:${v.level})`,v=v.forward[0];return D}static _search(D,v,P){let A=D._header;for(let R=D._level-1;R>=0;R--)for(;A.forward[R]&&P(A.forward[R].key,v)<0;)A=A.forward[R];if(A=A.forward[0],A&&P(A.key,v)===0)return A}static _insert(D,v,P,A){let R=[],E=D._header;for(let S=D._level-1;S>=0;S--){for(;E.forward[S]&&A(E.forward[S].key,v)<0;)E=E.forward[S];R[S]=E}if(E=E.forward[0],E&&A(E.key,v)===0)return E.value=P,!1;{let S=C._randomLevel(D);if(S>D._level){for(let u=D._level;u<S;u++)R[u]=D._header;D._level=S}E=new n(S,v,P);for(let u=0;u<S;u++)E.forward[u]=R[u].forward[u],R[u].forward[u]=E;return!0}}static _randomLevel(D,v=.5){let P=1;for(;Math.random()<v&&P<D._maxLevel;)P+=1;return P}static _delete(D,v,P){let A=[],R=D._header;for(let E=D._level-1;E>=0;E--){for(;R.forward[E]&&P(R.forward[E].key,v)<0;)R=R.forward[E];A[E]=R}if(R=R.forward[0],!R||P(R.key,v)!==0)return!1;for(let E=0;E<D._level&&A[E].forward[E]===R;E++)A[E].forward[E]=R.forward[E];for(;D._level>0&&D._header.forward[D._level-1]===w;)D._level-=1;return!0}}e.SkipList=C}),define(ve[123],we([0,1,3]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=k.globals.performance&&typeof k.globals.performance.now=="function";class w{constructor(T){this._highResolution=n&&T,this._startTime=this._now(),this._stopTime=-1}static create(T=!0){return new w(T)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?k.globals.performance.now():Date.now()}}e.StopWatch=w}),define(ve[7],we([0,1,9,73,2,120,123]),function(ee,e,k,n,w,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let D=!1,v=!1;var P;(function(i){i.None=()=>w.Disposable.None;function t(re){if(v){const{onListenerDidAdd:ce}=re,de=u.create();let he=0;re.onListenerDidAdd=()=>{++he==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),de.print()),ce?.()}}}function r(re){return(ce,de=null,he)=>{let j=!1,O;return O=re(V=>{if(!j)return O?O.dispose():j=!0,ce.call(de,V)},null,he),j&&O.dispose(),O}}i.once=r;function s(re,ce,de){return $((he,j=null,O)=>re(V=>he.call(j,ce(V)),null,O),de)}i.map=s;function a(re,ce,de){return $((he,j=null,O)=>re(V=>{ce(V),he.call(j,V)},null,O),de)}i.forEach=a;function h(re,ce,de){return $((he,j=null,O)=>re(V=>ce(V)&&he.call(j,V),null,O),de)}i.filter=h;function g(re){return re}i.signal=g;function _(...re){return(ce,de=null,he)=>(0,w.combinedDisposable)(...re.map(j=>j(O=>ce.call(de,O),null,he)))}i.any=_;function F(re,ce,de,he){let j=de;return s(re,O=>(j=ce(j,O),j),he)}i.reduce=F;function $(re,ce){let de;const he={onFirstListenerAdd(){de=re(j.fire,j)},onLastListenerRemove(){de.dispose()}};ce||t(he);const j=new f(he);return ce&&ce.add(j),j.event}function K(re,ce,de=100,he=!1,j,O){let V,J,le,ge=0;const ue={leakWarningThreshold:j,onFirstListenerAdd(){V=re(pe=>{ge++,J=ce(J,pe),he&&!le&&(oe.fire(J),J=void 0),clearTimeout(le),le=setTimeout(()=>{const X=J;J=void 0,le=void 0,(!he||ge>1)&&oe.fire(X),ge=0},de)})},onLastListenerRemove(){V.dispose()}};O||t(ue);const oe=new f(ue);return O&&O.add(oe),oe.event}i.debounce=K;function I(re,ce=(he,j)=>he===j,de){let he=!0,j;return h(re,O=>{const V=he||!ce(O,j);return he=!1,j=O,V},de)}i.latch=I;function W(re,ce,de){return[i.filter(re,ce,de),i.filter(re,he=>!ce(he),de)]}i.split=W;function M(re,ce=!1,de=[]){let he=de.slice(),j=re(J=>{he?he.push(J):V.fire(J)});const O=()=>{he&&he.forEach(J=>V.fire(J)),he=null},V=new f({onFirstListenerAdd(){j||(j=re(J=>V.fire(J)))},onFirstListenerDidAdd(){he&&(ce?setTimeout(O):O())},onLastListenerRemove(){j&&j.dispose(),j=null}});return V.event}i.buffer=M;class q{constructor(ce){this.event=ce}map(ce){return new q(s(this.event,ce))}forEach(ce){return new q(a(this.event,ce))}filter(ce){return new q(h(this.event,ce))}reduce(ce,de){return new q(F(this.event,ce,de))}latch(){return new q(I(this.event))}debounce(ce,de=100,he=!1,j){return new q(K(this.event,ce,de,he,j))}on(ce,de,he){return this.event(ce,de,he)}once(ce,de,he){return r(this.event)(ce,de,he)}}function Z(re){return new q(re)}i.chain=Z;function H(re,ce,de=he=>he){const he=(...J)=>V.fire(de(...J)),j=()=>re.on(ce,he),O=()=>re.removeListener(ce,he),V=new f({onFirstListenerAdd:j,onLastListenerRemove:O});return V.event}i.fromNodeEventEmitter=H;function U(re,ce,de=he=>he){const he=(...J)=>V.fire(de(...J)),j=()=>re.addEventListener(ce,he),O=()=>re.removeEventListener(ce,he),V=new f({onFirstListenerAdd:j,onLastListenerRemove:O});return V.event}i.fromDOMEventEmitter=U;function z(re){return new Promise(ce=>r(re)(ce))}i.toPromise=z;function Q(re,ce){return ce(void 0),re(de=>ce(de))}i.runAndSubscribe=Q;function ie(re,ce){let de=null;function he(O){de?.dispose(),de=new w.DisposableStore,ce(O,de)}he(void 0);const j=re(O=>he(O));return(0,w.toDisposable)(()=>{j.dispose(),de?.dispose()})}i.runAndSubscribeWithStore=ie})(P=e.Event||(e.Event={}));class A{constructor(t){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${t}_${A._idPool++}`}start(t){this._stopWatch=new T.StopWatch(!0),this._listenerCount=t}stop(){if(this._stopWatch){const t=this._stopWatch.elapsed();this._elapsedOverall+=t,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${t.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}A._idPool=0;let R=-1;function E(i){const t=R;return R=i,{dispose(){R=t}}}e.setGlobalLeakWarningThreshold=E;class S{constructor(t,r=Math.random().toString(18).slice(2,5)){this.customThreshold=t,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(t,r){let s=R;if(typeof this.customThreshold=="number"&&(s=this.customThreshold),s<=0||r<s)return;this._stacks||(this._stacks=new Map);const a=this._stacks.get(t.value)||0;if(this._stacks.set(t.value,a+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=s*.5;let h,g=0;for(const[_,F]of this._stacks)(!h||g<F)&&(h=_,g=F);console.warn(`[${this.name}] potential listener LEAK detected, having ${r} listeners already. MOST frequent listener (${g}):`),console.warn(h)}return()=>{const h=this._stacks.get(t.value)||0;this._stacks.set(t.value,h-1)}}}class u{constructor(t){this.value=t}static create(){return new u(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class b{constructor(t,r,s){this.callback=t,this.callbackThis=r,this.stack=s,this.subscription=new w.SafeDisposable}invoke(t){this.callback.call(this.callbackThis,t)}}class f{constructor(t){this._disposed=!1,this._options=t,this._leakageMon=R>0?new S(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new A(this._options._profName):void 0}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(D){const t=Array.from(this._listeners);queueMicrotask(()=>{for(const r of t)r.subscription.isset()&&(r.subscription.unset(),r.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(t,r,s)=>{this._listeners||(this._listeners=new C.LinkedList);const a=this._listeners.isEmpty();a&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let h,g;this._leakageMon&&this._listeners.size>=30&&(g=u.create(),h=this._leakageMon.check(g,this._listeners.size+1)),D&&(g=g??u.create());const _=new b(t,r,g),F=this._listeners.push(_);a&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,t,r);const $=_.subscription.set(()=>{h&&h(),this._disposed||(F(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return s instanceof w.DisposableStore?s.add($):Array.isArray(s)&&s.push($),$}),this._event}fire(t){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,t]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,s]=this._deliveryQueue.shift();try{r.invoke(s)}catch(a){(0,k.onUnexpectedError)(a)}}this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=f;class d extends f{async fireAsync(t,r,s){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const a of this._listeners)this._asyncDeliveryQueue.push([a,t]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[a,h]=this._asyncDeliveryQueue.shift(),g=[],_={...h,token:r,waitUntil:F=>{if(Object.isFrozen(g))throw new Error("waitUntil can NOT be called asynchronous");s&&(F=s(F,a.callback)),g.push(F)}};try{a.invoke(_)}catch(F){(0,k.onUnexpectedError)(F);continue}Object.freeze(g),await Promise.allSettled(g).then(F=>{for(const $ of F)$.status==="rejected"&&(0,k.onUnexpectedError)($.reason)})}}}}e.AsyncEmitter=d;class p extends f{constructor(t){super(t);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=t?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const t=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(t))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(t){this._listeners&&(this._isPaused!==0?this._eventQueue.push(t):super.fire(t))}}e.PauseableEmitter=p;class m extends p{constructor(t){super(t);this._delay=t.delay??100}fire(t){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(t)}}e.DebounceEmitter=m;class y extends f{constructor(t){super(t);this._queuedEvents=[],this._mergeFn=t?.merge}fire(t){this._queuedEvents.push(t),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=y;class c{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(t){const r={event:t,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const s=()=>{this.hasListeners&&this.unhook(r);const a=this.events.indexOf(r);this.events.splice(a,1)};return(0,w.toDisposable)((0,n.once)(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(t=>this.hook(t))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(t=>this.unhook(t))}hook(t){t.listener=t.event(r=>this.emitter.fire(r))}unhook(t){t.listener&&t.listener.dispose(),t.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=c;class o{constructor(){this.buffers=[]}wrapEvent(t){return(r,s,a)=>t(h=>{const g=this.buffers[this.buffers.length-1];g?g.push(()=>r.call(s,h)):r.call(s,h)},void 0,a)}bufferEvents(t){const r=[];this.buffers.push(r);const s=t();return this.buffers.pop(),r.forEach(a=>a()),s}}e.EventBufferer=o;class l{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=w.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(t){this.inputEvent=t,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=t(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=l}),define(ve[21],we([0,1,7]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(D,v){const P=setTimeout(D.bind(v),0);return{dispose(){clearTimeout(P)}}});var w;(function(D){function v(P){return P===D.None||P===D.Cancelled||P instanceof C?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}D.isCancellationToken=v,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(w=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new k.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(v){this._token=void 0,this._parentListener=void 0,this._parentListener=v&&v.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=w.Cancelled}dispose(v=!1){v&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=w.None}}e.CancellationTokenSource=T}),define(ve[124],we([0,1,21]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class n{constructor(T){this.task=T,this.result=null}get(){if(this.result)return this.result;const T=new k.CancellationTokenSource,D=this.task(T.token);return this.result={promise:D,dispose:()=>{this.result=null,T.cancel(),T.dispose()}},this.result}}e.Cache=n;class w{constructor(T){this.computeFn=T,this.lastCache=void 0,this.lastArgKey=void 0}get(T){const D=JSON.stringify(T);return this.lastArgKey!==D&&(this.lastArgKey=D,this.lastCache=this.computeFn(T)),this.lastCache}}e.LRUCachedComputed=w}),define(ve[43],we([0,1,9,2]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function w(y){const c=y;return c?typeof c.read=="function":!1}e.isReadable=w;function C(y){const c=y;return c?[c.on,c.pause,c.resume,c.destroy].every(o=>typeof o=="function"):!1}e.isReadableStream=C;function T(y){const c=y;return c?C(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=T;function D(y,c){return new v(y,c)}e.newWriteableStream=D;class v{constructor(c,o){this.reducer=c,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(o=>o(c))}emitError(c){this.listeners.error.length===0?(0,k.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(o=>o(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,o){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(c,o){if(this.state.destroyed)return;let l;switch(c){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const i=l.indexOf(o);i>=0&&l.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function P(y,c){const o=[];let l;for(;(l=y.read())!==null;)o.push(l);return c(o)}e.consumeReadable=P;function A(y,c,o){const l=[];let i;for(;(i=y.read())!==null&&l.length<o;)l.push(i);return i===null&&l.length>0?c(l):{read:()=>{if(l.length>0)return l.shift();if(typeof i!="undefined"){const t=i;return i=void 0,t}return y.read()}}}e.peekReadable=A;function R(y,c){return new Promise((o,l)=>{const i=[];E(y,{onData:t=>{c&&i.push(t)},onError:t=>{c?l(t):o(void 0)},onEnd:()=>{o(c?c(i):void 0)}})})}e.consumeStream=R;function E(y,c){let o=!1;return y.on("error",l=>{o||c.onError(l)}),y.on("end",()=>{o||c.onEnd()}),y.on("data",l=>{o||c.onData(l)}),(0,n.toDisposable)(()=>o=!0)}e.listenStream=E;function S(y,c){return new Promise((o,l)=>{const i=new n.DisposableStore,t=[],r=h=>{if(t.push(h),t.length>c)return i.dispose(),y.pause(),o({stream:y,buffer:t,ended:!1})},s=h=>l(h),a=()=>o({stream:y,buffer:t,ended:!0});i.add((0,n.toDisposable)(()=>y.removeListener("error",s))),y.on("error",s),i.add((0,n.toDisposable)(()=>y.removeListener("end",a))),y.on("end",a),i.add((0,n.toDisposable)(()=>y.removeListener("data",r))),y.on("data",r)})}e.peekStream=S;function u(y,c){const o=D(c);return o.end(y),o}e.toStream=u;function b(){const y=D(()=>{throw new Error("not supported")});return y.end(),y}e.emptyStream=b;function f(y){let c=!1;return{read:()=>c?null:(c=!0,y)}}e.toReadable=f;function d(y,c,o){const l=D(o);return E(y,{onData:i=>l.write(c.data(i)),onError:i=>l.error(c.error?c.error(i):i),onEnd:()=>l.end()}),l}e.transform=d;function p(y,c,o){let l=!1;return{read:()=>{const i=c.read();return l?i:(l=!0,i!==null?o([y,i]):y)}}}e.prefixedReadable=p;function m(y,c,o){let l=!1;const i=D(o);return E(c,{onData:t=>l?i.write(t):(l=!0,i.write(o([y,t]))),onError:t=>i.error(t),onEnd:()=>{l||(l=!0,i.write(y)),i.end()}}),i}e.prefixedStream=m}),define(ve[16],we([0,1,43]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let w,C;class T{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return n?new T(Buffer.allocUnsafe(h)):new T(new Uint8Array(h))}static wrap(h){return n&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new T(h)}static fromString(h,g){return!(g?.dontUseNodeBuffer||!1)&&n?new T(Buffer.from(h)):(w||(w=new TextEncoder),new T(w.encode(h)))}static fromByteArray(h){const g=T.alloc(h.length);for(let _=0,F=h.length;_<F;_++)g.buffer[_]=h[_];return g}static concat(h,g){if(typeof g=="undefined"){g=0;for(let $=0,K=h.length;$<K;$++)g+=h[$].byteLength}const _=T.alloc(g);let F=0;for(let $=0,K=h.length;$<K;$++){const I=h[$];_.set(I,F),F+=I.byteLength}return _}clone(){const h=T.alloc(this.byteLength);return h.set(this),h}toString(){return n?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(h,g){return new T(this.buffer.subarray(h,g))}set(h,g){if(h instanceof T)this.buffer.set(h.buffer,g);else if(h instanceof Uint8Array)this.buffer.set(h,g);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),g);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),g);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return P(this.buffer,h)}writeUInt32BE(h,g){A(this.buffer,h,g)}readUInt32LE(h){return R(this.buffer,h)}writeUInt32LE(h,g){E(this.buffer,h,g)}readUInt8(h){return S(this.buffer,h)}writeUInt8(h,g){u(this.buffer,h,g)}}e.VSBuffer=T;function D(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0}e.readUInt16LE=D;function v(a,h,g){a[g+0]=h&255,h=h>>>8,a[g+1]=h&255}e.writeUInt16LE=v;function P(a,h){return a[h]*2**24+a[h+1]*2**16+a[h+2]*2**8+a[h+3]}e.readUInt32BE=P;function A(a,h,g){a[g+3]=h,h=h>>>8,a[g+2]=h,h=h>>>8,a[g+1]=h,h=h>>>8,a[g]=h}e.writeUInt32BE=A;function R(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0|a[h+2]<<16>>>0|a[h+3]<<24>>>0}e.readUInt32LE=R;function E(a,h,g){a[g+0]=h&255,h=h>>>8,a[g+1]=h&255,h=h>>>8,a[g+2]=h&255,h=h>>>8,a[g+3]=h&255}e.writeUInt32LE=E;function S(a,h){return a[h]}e.readUInt8=S;function u(a,h,g){a[g]=h}e.writeUInt8=u;function b(a){return k.consumeReadable(a,h=>T.concat(h))}e.readableToBuffer=b;function f(a){return k.toReadable(a)}e.bufferToReadable=f;function d(a){return k.consumeStream(a,h=>T.concat(h))}e.streamToBuffer=d;async function p(a){return a.ended?T.concat(a.buffer):T.concat([...a.buffer,await d(a.stream)])}e.bufferedStreamToBuffer=p;function m(a){return k.toStream(a,h=>T.concat(h))}e.bufferToStream=m;function y(a){return k.transform(a,{data:h=>typeof h=="string"?T.fromString(h):T.wrap(h)},h=>T.concat(h))}e.streamToBufferReadableStream=y;function c(a){return k.newWriteableStream(h=>T.concat(h),a)}e.newWriteableBufferStream=c;function o(a,h){return k.prefixedReadable(a,h,g=>T.concat(g))}e.prefixedBufferReadable=o;function l(a,h){return k.prefixedStream(a,h,g=>T.concat(g))}e.prefixedBufferStream=l;function i(a){let h=0,g=0,_=0;const F=new Uint8Array(Math.floor(a.length/4*3)),$=I=>{switch(g){case 3:F[_++]=h|I,g=0;break;case 2:F[_++]=h|I>>>2,h=I<<6,g=3;break;case 1:F[_++]=h|I>>>4,h=I<<4,g=2;break;default:h=I<<2,g=1}};for(let I=0;I<a.length;I++){const W=a.charCodeAt(I);if(W>=65&&W<=90)$(W-65);else if(W>=97&&W<=122)$(W-97+26);else if(W>=48&&W<=57)$(W-48+52);else if(W===43||W===45)$(62);else if(W===47||W===95)$(63);else{if(W===61)break;throw new SyntaxError(`Unexpected base64 character ${a[I]}`)}}const K=_;for(;g>0;)$(0);return T.wrap(F).slice(0,K)}e.decodeBase64=i;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function s({buffer:a},h=!0,g=!1){const _=g?r:t;let F="";const $=a.byteLength%3;let K=0;for(;K<a.byteLength-$;K+=3){const I=a[K+0],W=a[K+1],M=a[K+2];F+=_[I>>>2],F+=_[(I<<4|W>>>4)&63],F+=_[(W<<2|M>>>6)&63],F+=_[M&63]}if($===1){const I=a[K+0];F+=_[I>>>2],F+=_[I<<4&63],h&&(F+="==")}else if($===2){const I=a[K+0],W=a[K+1];F+=_[I>>>2],F+=_[(I<<4|W>>>4)&63],F+=_[W<<2&63],h&&(F+="=")}return F}e.encodeBase64=s}),define(ve[15],we([0,1,124,119]),function(ee,e,k,n){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function C(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}e.isFalsyOrWhitespace=C;const T=/{(\d+)}/g;function D(ne,...Ce){return Ce.length===0?ne:ne.replace(T,function(Pe,Le){const Me=parseInt(Le,10);return isNaN(Me)||Me<0||Me>=Ce.length?Pe:Ce[Me]})}e.format=D;const v=/{([^}]+)}/g;function P(ne,Ce){return ne.replace(v,(Pe,Le)=>Ce[Le]??Pe)}e.format2=P;function A(ne){return ne.replace(/[<>&]/g,function(Ce){switch(Ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ce}})}e.escape=A;function R(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=R;function E(ne,Ce){let Pe=0;const Le=Ce.charCodeAt(0);for(let Me=ne.length-1;Me>=0;Me--)ne.charCodeAt(Me)===Le&&Pe++;return Pe}e.count=E;function S(ne,Ce,Pe="\u2026"){return ne.length<=Ce?ne:`${ne.substr(0,Ce)}${Pe}`}e.truncate=S;function u(ne,Ce=" "){const Pe=b(ne,Ce);return f(Pe,Ce)}e.trim=u;function b(ne,Ce){if(!ne||!Ce)return ne;const Pe=Ce.length;if(Pe===0||ne.length===0)return ne;let Le=0;for(;ne.indexOf(Ce,Le)===Le;)Le=Le+Pe;return ne.substring(Le)}e.ltrim=b;function f(ne,Ce){if(!ne||!Ce)return ne;const Pe=Ce.length,Le=ne.length;if(Pe===0||Le===0)return ne;let Me=Le,Ke=-1;for(;Ke=ne.lastIndexOf(Ce,Me-1),!(Ke===-1||Ke+Pe!==Me);){if(Ke===0)return"";Me=Ke}return ne.substring(0,Me)}e.rtrim=f;function d(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function p(ne){return ne.replace(/\*/g,"")}e.stripWildcards=p;function m(ne,Ce,Pe={}){if(!ne)throw new Error("Cannot create regex from empty string");Ce||(ne=R(ne)),Pe.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let Le="";return Pe.global&&(Le+="g"),Pe.matchCase||(Le+="i"),Pe.multiline&&(Le+="m"),Pe.unicode&&(Le+="u"),new RegExp(ne,Le)}e.createRegExp=m;function y(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}e.regExpLeadsToEndlessLoop=y;function c(ne){return!!ne.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function o(ne){return(ne.global?"g":"")+(ne.ignoreCase?"i":"")+(ne.multiline?"m":"")+(ne.unicode?"u":"")}e.regExpFlags=o;function l(ne){return ne.split(/\r\n|\r|\n/)}e.splitLines=l;function i(ne){for(let Ce=0,Pe=ne.length;Ce<Pe;Ce++){const Le=ne.charCodeAt(Ce);if(Le!==32&&Le!==9)return Ce}return-1}e.firstNonWhitespaceIndex=i;function t(ne,Ce=0,Pe=ne.length){for(let Le=Ce;Le<Pe;Le++){const Me=ne.charCodeAt(Le);if(Me!==32&&Me!==9)return ne.substring(Ce,Le)}return ne.substring(Ce,Pe)}e.getLeadingWhitespace=t;function r(ne,Ce=ne.length-1){for(let Pe=Ce;Pe>=0;Pe--){const Le=ne.charCodeAt(Pe);if(Le!==32&&Le!==9)return Pe}return-1}e.lastNonWhitespaceIndex=r;function s(ne,Ce){return ne<Ce?-1:ne>Ce?1:0}e.compare=s;function a(ne,Ce,Pe=0,Le=ne.length,Me=0,Ke=Ce.length){for(;Pe<Le&&Me<Ke;Pe++,Me++){let Qe=ne.charCodeAt(Pe),Ve=Ce.charCodeAt(Me);if(Qe<Ve)return-1;if(Qe>Ve)return 1}const $e=Le-Pe,He=Ke-Me;return $e<He?-1:$e>He?1:0}e.compareSubstring=a;function h(ne,Ce){return g(ne,Ce,0,ne.length,0,Ce.length)}e.compareIgnoreCase=h;function g(ne,Ce,Pe=0,Le=ne.length,Me=0,Ke=Ce.length){for(;Pe<Le&&Me<Ke;Pe++,Me++){let Qe=ne.charCodeAt(Pe),Ve=Ce.charCodeAt(Me);if(Qe===Ve)continue;if(Qe>=128||Ve>=128)return a(ne.toLowerCase(),Ce.toLowerCase(),Pe,Le,Me,Ke);_(Qe)&&(Qe-=32),_(Ve)&&(Ve-=32);const Ze=Qe-Ve;if(Ze!==0)return Ze}const $e=Le-Pe,He=Ke-Me;return $e<He?-1:$e>He?1:0}e.compareSubstringIgnoreCase=g;function _(ne){return ne>=97&&ne<=122}e.isLowerAsciiLetter=_;function F(ne){return ne>=65&&ne<=90}e.isUpperAsciiLetter=F;function $(ne,Ce){return ne.length===Ce.length&&g(ne,Ce)===0}e.equalsIgnoreCase=$;function K(ne,Ce){const Pe=Ce.length;return Ce.length>ne.length?!1:g(ne,Ce,0,Pe)===0}e.startsWithIgnoreCase=K;function I(ne,Ce){let Pe,Le=Math.min(ne.length,Ce.length);for(Pe=0;Pe<Le;Pe++)if(ne.charCodeAt(Pe)!==Ce.charCodeAt(Pe))return Pe;return Le}e.commonPrefixLength=I;function W(ne,Ce){let Pe,Le=Math.min(ne.length,Ce.length);const Me=ne.length-1,Ke=Ce.length-1;for(Pe=0;Pe<Le;Pe++)if(ne.charCodeAt(Me-Pe)!==Ce.charCodeAt(Ke-Pe))return Pe;return Le}e.commonSuffixLength=W;function M(ne){return 55296<=ne&&ne<=56319}e.isHighSurrogate=M;function q(ne){return 56320<=ne&&ne<=57343}e.isLowSurrogate=q;function Z(ne,Ce){return(ne-55296<<10)+(Ce-56320)+65536}e.computeCodePoint=Z;function H(ne,Ce,Pe){const Le=ne.charCodeAt(Pe);if(M(Le)&&Pe+1<Ce){const Me=ne.charCodeAt(Pe+1);if(q(Me))return Z(Le,Me)}return Le}e.getNextCodePoint=H;function U(ne,Ce){const Pe=ne.charCodeAt(Ce-1);if(q(Pe)&&Ce>1){const Le=ne.charCodeAt(Ce-2);if(M(Le))return Z(Le,Pe)}return Pe}class z{constructor(Ce,Pe=0){this._str=Ce,this._len=Ce.length,this._offset=Pe}get offset(){return this._offset}setOffset(Ce){this._offset=Ce}prevCodePoint(){const Ce=U(this._str,this._offset);return this._offset-=Ce>=65536?2:1,Ce}nextCodePoint(){const Ce=H(this._str,this._len,this._offset);return this._offset+=Ce>=65536?2:1,Ce}eol(){return this._offset>=this._len}}e.CodePointIterator=z;class Q{constructor(Ce,Pe=0){this._iterator=new z(Ce,Pe)}get offset(){return this._iterator.offset}nextGraphemeLength(){const Ce=Ee.getInstance(),Pe=this._iterator,Le=Pe.offset;let Me=Ce.getGraphemeBreakType(Pe.nextCodePoint());for(;!Pe.eol();){const Ke=Pe.offset,$e=Ce.getGraphemeBreakType(Pe.nextCodePoint());if(Ne(Me,$e)){Pe.setOffset(Ke);break}Me=$e}return Pe.offset-Le}prevGraphemeLength(){const Ce=Ee.getInstance(),Pe=this._iterator,Le=Pe.offset;let Me=Ce.getGraphemeBreakType(Pe.prevCodePoint());for(;Pe.offset>0;){const Ke=Pe.offset,$e=Ce.getGraphemeBreakType(Pe.prevCodePoint());if(Ne($e,Me)){Pe.setOffset(Ke);break}Me=$e}return Le-Pe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=Q;function ie(ne,Ce){return new Q(ne,Ce).nextGraphemeLength()}e.nextCharLength=ie;function re(ne,Ce){return new Q(ne,Ce).prevGraphemeLength()}e.prevCharLength=re;function ce(ne,Ce){Ce>0&&q(ne.charCodeAt(Ce))&&Ce--;const Pe=Ce+ie(ne,Ce);return[Pe-re(ne,Pe),Pe]}e.getCharContainingOffset=ce;const de=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function he(ne){return de.test(ne)}e.containsRTL=he;const j=/^[\t\n\r\x20-\x7E]*$/;function O(ne){return j.test(ne)}e.isBasicASCII=O,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function V(ne){return e.UNUSUAL_LINE_TERMINATORS.test(ne)}e.containsUnusualLineTerminators=V;function J(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}e.isFullWidthCharacter=J;function le(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}e.isEmojiImprecise=le;function ge(ne,Ce){if(ne.length<Ce)return ne;const Pe=/\b/g;let Le=0;for(;Pe.test(ne)&&!(ne.length-Pe.lastIndex<Ce);)Le=Pe.lastIndex,Pe.lastIndex+=1;return ne.substring(Le).replace(/^\s/,"")}e.lcut=ge;const ue=/\x1B\x5B[12]?K/g,oe=/\x1b\[\d+m/g,pe=/\x1b\[0?m/g;function X(ne){return ne&&(ne=ne.replace(ue,""),ne=ne.replace(oe,""),ne=ne.replace(pe,"")),ne}e.removeAnsiEscapeCodes=X,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function B(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===65279)}e.startsWithUTF8BOM=B;function x(ne){return B(ne)?ne.substr(1):ne}e.stripUTF8BOM=x;function Y(ne,Ce){if(!ne||!Ce||ne.length<Ce.length)return!1;const Pe=Ce.length,Le=ne.toLowerCase();let Me=0,Ke=-1;for(;Me<Pe;){const $e=Le.indexOf(Ce[Me],Ke+1);if($e<0)return!1;Ke=$e,Me++}return!0}e.fuzzyContains=Y;function fe(ne,Ce=!1){return ne?(Ce&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}e.containsUppercaseCharacter=fe;function ye(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}e.uppercaseFirstLetter=ye;function ke(ne,Ce=1){if(Ce===0)return"";let Pe=-1;do Pe=ne.indexOf(`
`,Pe+1),Ce--;while(Ce>0&&Pe>=0);return Pe===-1?ne:(ne[Pe-1]==="\r"&&Pe--,ne.substr(0,Pe))}e.getNLines=ke;function Re(ne){const Ce=90-65+1;return ne=ne%(2*Ce),ne<Ce?String.fromCharCode(97+ne):String.fromCharCode(65+ne-Ce)}e.singleLetterHash=Re;function Ue(ne){return Ee.getInstance().getGraphemeBreakType(ne)}e.getGraphemeBreakType=Ue;function Ne(ne,Ce){return ne===0?Ce!==5&&Ce!==7:ne===2&&Ce===3?!1:ne===4||ne===2||ne===3||Ce===4||Ce===2||Ce===3?!0:!(ne===8&&(Ce===8||Ce===9||Ce===11||Ce===12)||(ne===11||ne===9)&&(Ce===9||Ce===10)||(ne===12||ne===10)&&Ce===10||Ce===5||Ce===13||Ce===7||ne===1||ne===13&&Ce===14||ne===6&&Ce===6)}var se;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(se=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ee{constructor(){this._data=me()}static getInstance(){return Ee._INSTANCE||(Ee._INSTANCE=new Ee),Ee._INSTANCE}getGraphemeBreakType(Ce){if(Ce<32)return Ce===10?3:Ce===13?2:4;if(Ce<127)return 0;const Pe=this._data,Le=Pe.length/3;let Me=1;for(;Me<=Le;)if(Ce<Pe[3*Me])Me=2*Me;else if(Ce>Pe[3*Me+1])Me=2*Me+1;else return Pe[3*Me+2];return 0}}Ee._INSTANCE=null;function me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te(ne,Ce){if(ne===0)return 0;const Pe=Fe(ne,Ce);if(Pe!==void 0)return Pe;const Le=new z(Ce,ne);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=Te;function Fe(ne,Ce){const Pe=new z(Ce,ne);let Le=Pe.prevCodePoint();for(;Ye(Le)||Le===65039||Le===8419;){if(Pe.offset===0)return;Le=Pe.prevCodePoint()}if(!le(Le))return;let Me=Pe.offset;return Me>0&&Pe.prevCodePoint()===8205&&(Me=Pe.offset),Me}function Ye(ne){return 127995<=ne&&ne<=127999}var Be;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),e.noBreakWhitespace="\xA0";class je{constructor(Ce){this.confusableDictionary=Ce}static getInstance(Ce){return je.cache.get(Array.from(Ce))}static getLocales(){return je._locales.getValue()}isAmbiguous(Ce){return this.confusableDictionary.has(Ce)}getPrimaryConfusable(Ce){return this.confusableDictionary.get(Ce)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=je,w=je,je.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),je.cache=new k.LRUCachedComputed(ne=>{function Ce(Ve){const Ze=new Map;for(let it=0;it<Ve.length;it+=2)Ze.set(Ve[it],Ve[it+1]);return Ze}function Pe(Ve,Ze){const it=new Map(Ve);for(const[st,tt]of Ze)it.set(st,tt);return it}function Le(Ve,Ze){if(!Ve)return Ze;const it=new Map;for(const[st,tt]of Ve)Ze.has(st)&&it.set(st,tt);return it}const Me=w.ambiguousCharacterData.getValue();let Ke=ne.filter(Ve=>!Ve.startsWith("_")&&Ve in Me);Ke.length===0&&(Ke=["_default"]);let $e;for(const Ve of Ke){const Ze=Ce(Me[Ve]);$e=Le($e,Ze)}const He=Ce(Me._common),Qe=Pe(He,$e);return new je(Qe)}),je._locales=new n.Lazy(()=>Object.keys(je.ambiguousCharacterData.getValue()).filter(ne=>!ne.startsWith("_")));class Ge{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ge.getRawData())),this._data}static isInvisibleCharacter(Ce){return Ge.getData().has(Ce)}static get codePoints(){return Ge.getData()}}e.InvisibleCharacters=Ge,Ge._data=void 0}),define(ve[125],we([0,1,15]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(d){return w(d,0)}e.hash=n;function w(d,p){switch(typeof d){case"object":return d===null?C(349,p):Array.isArray(d)?v(d,p):P(d,p);case"string":return D(d,p);case"boolean":return T(d,p);case"number":return C(d,p);case"undefined":return C(937,p);default:return C(617,p)}}e.doHash=w;function C(d,p){return(p<<5)-p+d|0}e.numberHash=C;function T(d,p){return C(d?433:863,p)}function D(d,p){p=C(149417,p);for(let m=0,y=d.length;m<y;m++)p=C(d.charCodeAt(m),p);return p}e.stringHash=D;function v(d,p){return p=C(104579,p),d.reduce((m,y)=>w(y,m),p)}function P(d,p){return p=C(181387,p),Object.keys(d).sort().reduce((m,y)=>(m=D(y,m),w(d[y],m)),p)}class A{constructor(){this._value=0}get value(){return this._value}hash(p){return this._value=w(p,this._value),this._value}}e.Hasher=A;var R;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(R||(R={}));function E(d,p,m=32){const y=m-p,c=~((1<<y)-1);return(d<<p|(c&d)>>>y)>>>0}function S(d,p=0,m=d.byteLength,y=0){for(let c=0;c<m;c++)d[p+c]=y}function u(d,p,m="0"){for(;d.length<p;)d=m+d;return d}function b(d,p=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(m=>m.toString(16).padStart(2,"0")).join(""):u((d>>>0).toString(16),p/4)}e.toHexString=b;class f{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(p){const m=p.length;if(m===0)return;const y=this._buff;let c=this._buffLen,o=this._leftoverHighSurrogate,l,i;for(o!==0?(l=o,i=-1,o=0):(l=p.charCodeAt(0),i=0);;){let t=l;if(k.isHighSurrogate(l))if(i+1<m){const r=p.charCodeAt(i+1);k.isLowSurrogate(r)?(i++,t=k.computeCodePoint(l,r)):t=65533}else{o=l;break}else k.isLowSurrogate(l)&&(t=65533);if(c=this._push(y,c,t),i++,i<m)l=p.charCodeAt(i);else break}this._buffLen=c,this._leftoverHighSurrogate=o}_push(p,m,y){return y<128?p[m++]=y:y<2048?(p[m++]=192|(y&1984)>>>6,p[m++]=128|(y&63)>>>0):y<65536?(p[m++]=224|(y&61440)>>>12,p[m++]=128|(y&4032)>>>6,p[m++]=128|(y&63)>>>0):(p[m++]=240|(y&1835008)>>>18,p[m++]=128|(y&258048)>>>12,p[m++]=128|(y&4032)>>>6,p[m++]=128|(y&63)>>>0),m>=64&&(this._step(),m-=64,this._totalLen+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),m}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),b(this._h0)+b(this._h1)+b(this._h2)+b(this._h3)+b(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,S(this._buff,this._buffLen),this._buffLen>56&&(this._step(),S(this._buff));const p=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(p/4294967296),!1),this._buffDV.setUint32(60,p%4294967296,!1),this._step()}_step(){const p=f._bigBlock32,m=this._buffDV;for(let a=0;a<64;a+=4)p.setUint32(a,m.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)p.setUint32(a,E(p.getUint32(a-12,!1)^p.getUint32(a-32,!1)^p.getUint32(a-56,!1)^p.getUint32(a-64,!1),1),!1);let y=this._h0,c=this._h1,o=this._h2,l=this._h3,i=this._h4,t,r,s;for(let a=0;a<80;a++)a<20?(t=c&o|~c&l,r=1518500249):a<40?(t=c^o^l,r=1859775393):a<60?(t=c&o|c&l|o&l,r=2400959708):(t=c^o^l,r=3395469782),s=E(y,5)+t+i+r+p.getUint32(a*4,!1)&4294967295,i=l,l=o,o=E(c,30),c=y,y=s;this._h0=this._h0+y&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+o&4294967295,this._h3=this._h3+l&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=f,f._bigBlock32=new DataView(new ArrayBuffer(320))});var bt=this&&this.__classPrivateFieldSet||function(ee,e,k,n,w){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!w:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?w.call(ee,k):w?w.value=k:e.set(ee,k),k},et=this&&this.__classPrivateFieldGet||function(ee,e,k,n){if(k==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!n:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?n:k==="a"?n.call(ee):n?n.value:e.get(ee)};define(ve[31],we([0,1,18,15]),function(ee,e,k,n){"use strict";var w,C,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(i,t,r){let s=i.get(t);return s===void 0&&(s=r,i.set(t,s)),s}e.getOrSet=D;function v(i){const t=[];return i.forEach((r,s)=>{t.push(`${s} => ${r}`)}),`Map(${i.size}) {${t.join(", ")}}`}e.mapToString=v;function P(i){const t=[];return i.forEach(r=>{t.push(r)}),`Set(${i.size}) {${t.join(", ")}}`}e.setToString=P;class A{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const r=t.charCodeAt(0),s=this._value.charCodeAt(this._pos);return r-s}value(){return this._value[this._pos]}}e.StringIterator=A;class R{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=R;class E{constructor(t=!0,r=!0){this._splitOnBackslash=t,this._caseSensitive=r}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let r=t.length-1;r>=0;r--,this._valueLen--){const s=this._value.charCodeAt(r);if(!(s===47||this._splitOnBackslash&&s===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=E;var S;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(S||(S={}));class u{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new E(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,n.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=u;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var f;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(f||(f={}));class d{constructor(t){this._iter=t}static forUris(t=()=>!1){return new d(new u(t))}static forPaths(t=!1){return new d(new E(void 0,!t))}static forStrings(){return new d(new A)}static forConfigKeys(){return new d(new R)}clear(){this._root=void 0}fill(t,r){if(r){const s=r.slice(0);(0,k.shuffle)(s);for(let a of s)this.set(a,t)}else{const s=t.slice(0);(0,k.shuffle)(s);for(let a of s)this.set(a[0],a[1])}}set(t,r){const s=this._iter.reset(t);let a;this._root||(this._root=new b,this._root.segment=s.value());const h=[];for(a=this._root;;){const _=s.cmp(a.segment);if(_>0)a.left||(a.left=new b,a.left.segment=s.value()),h.push([-1,a]),a=a.left;else if(_<0)a.right||(a.right=new b,a.right.segment=s.value()),h.push([1,a]),a=a.right;else if(s.hasNext())s.next(),a.mid||(a.mid=new b,a.mid.segment=s.value()),h.push([0,a]),a=a.mid;else break}const g=a.value;a.value=r,a.key=t;for(let _=h.length-1;_>=0;_--){const F=h[_][1];F.updateHeight();const $=F.balanceFactor();if($<-1||$>1){const K=h[_][0],I=h[_+1][0];if(K===1&&I===1)h[_][1]=F.rotateLeft();else if(K===-1&&I===-1)h[_][1]=F.rotateRight();else if(K===1&&I===-1)F.right=h[_+1][1]=h[_+1][1].rotateRight(),h[_][1]=F.rotateLeft();else if(K===-1&&I===1)F.left=h[_+1][1]=h[_+1][1].rotateLeft(),h[_][1]=F.rotateRight();else throw new Error;if(_>0)switch(h[_-1][0]){case-1:h[_-1][1].left=h[_][1];break;case 1:h[_-1][1].right=h[_][1];break;case 0:h[_-1][1].mid=h[_][1];break}else this._root=h[0][1]}}return g}get(t){return this._getNode(t)?.value}_getNode(t){const r=this._iter.reset(t);let s=this._root;for(;s;){const a=r.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(r.hasNext())r.next(),s=s.mid;else break}return s}has(t){const r=this._getNode(t);return!(r?.value===void 0&&r?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,r){const s=this._iter.reset(t),a=[];let h=this._root;for(;h;){const g=s.cmp(h.segment);if(g>0)a.push([-1,h]),h=h.left;else if(g<0)a.push([1,h]),h=h.right;else if(s.hasNext())s.next(),a.push([0,h]),h=h.mid;else break}if(!!h){if(r?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const g=this._min(h.right),{key:_,value:F,segment:$}=g;this._delete(g.key,!1),h.key=_,h.value=F,h.segment=$}else{const g=h.left??h.right;if(a.length>0){const[_,F]=a[a.length-1];switch(_){case-1:F.left=g;break;case 0:F.mid=g;break;case 1:F.right=g;break}}else this._root=g}for(let g=a.length-1;g>=0;g--){const _=a[g][1];_.updateHeight();const F=_.balanceFactor();if(F>1?(_.right.balanceFactor()>=0||(_.right=_.right.rotateRight()),a[g][1]=_.rotateLeft()):F<-1&&(_.left.balanceFactor()<=0||(_.left=_.left.rotateLeft()),a[g][1]=_.rotateRight()),g>0)switch(a[g-1][0]){case-1:a[g-1][1].left=a[g][1];break;case 1:a[g-1][1].right=a[g][1];break;case 0:a[g-1][1].mid=a[g][1];break}else this._root=a[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const r=this._iter.reset(t);let s=this._root,a;for(;s;){const h=r.cmp(s.segment);if(h>0)s=s.left;else if(h<0)s=s.right;else if(r.hasNext())r.next(),a=s.value||a,s=s.mid;else break}return s&&s.value||a}findSuperstr(t){const r=this._iter.reset(t);let s=this._root;for(;s;){const a=r.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(r.hasNext())r.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(t){for(const[r,s]of this)t(s,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=r=>{if(!r)return!0;const s=r.balanceFactor();return s<-1||s>1?!1:t(r.left)&&t(r.right)};return t(this._root)}}e.TernarySearchTree=d;class p{constructor(t,r){this.uri=t,this.value=r}}class m{constructor(t,r){this[w]="ResourceMap",t instanceof m?(this.map=new Map(t.map),this.toKey=r??m.defaultToKey):(this.map=new Map,this.toKey=t??m.defaultToKey)}set(t,r){return this.map.set(this.toKey(t),new p(t,r)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,r){typeof r!="undefined"&&(t=t.bind(r));for(let[s,a]of this.map)t(a.value,a.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=m,m.defaultToKey=i=>i.toString();var y;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(y=e.Touch||(e.Touch={}));class c{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,r=0){const s=this._map.get(t);if(!!s)return r!==0&&this.touch(s,r),s.value}set(t,r,s=0){let a=this._map.get(t);if(a)a.value=r,s!==0&&this.touch(a,s);else{switch(a={key:t,value:r,next:void 0,previous:void 0},s){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(t,a),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const r=this._map.get(t);if(!!r)return this._map.delete(t),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,r){const s=this._state;let a=this._head;for(;a;){if(r?t.bind(r)(a.value,a.key,this):t(a.value,a.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const t=this,r=this._state;let s=this._head;const a={[Symbol.iterator](){return a},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const h={value:s.key,done:!1};return s=s.next,h}else return{value:void 0,done:!0}}};return a}values(){const t=this,r=this._state;let s=this._head;const a={[Symbol.iterator](){return a},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const h={value:s.value,done:!1};return s=s.next,h}else return{value:void 0,done:!0}}};return a}entries(){const t=this,r=this._state;let s=this._head;const a={[Symbol.iterator](){return a},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const h={value:[s.key,s.value],done:!1};return s=s.next,h}else return{value:void 0,done:!0}}};return a}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this._head,s=this.size;for(;r&&s>t;)this._map.delete(r.key),r=r.next,s--;this._head=r,this._size=s,r&&(r.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const r=t.next,s=t.previous;if(!r||!s)throw new Error("Invalid list");r.previous=s,s.next=r}t.next=void 0,t.previous=void 0,this._state++}touch(t,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(t===this._head)return;const s=t.next,a=t.previous;t===this._tail?(a.next=void 0,this._tail=a):(s.previous=a,a.next=s),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(r===2){if(t===this._tail)return;const s=t.next,a=t.previous;t===this._head?(s.previous=void 0,this._head=s):(s.previous=a,a.next=s),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((r,s)=>{t.push([s,r])}),t}fromJSON(t){this.clear();for(const[r,s]of t)this.set(r,s)}}e.LinkedMap=c;class o extends c{constructor(t,r=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,r=2){return super.get(t,r)}peek(t){return super.get(t,0)}set(t,r){return super.set(t,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class l{constructor(t){T.set(this,void 0),bt(this,T,t,"f")}get size(){return et(this,T,"f").size}forEach(t,r){et(this,T,"f").forEach(t,r)}get(t){return et(this,T,"f").get(t)}has(t){return et(this,T,"f").has(t)}entries(){return et(this,T,"f").entries()}keys(){return et(this,T,"f").keys()}values(){return et(this,T,"f").values()}[(T=new WeakMap,Symbol.iterator)](){return et(this,T,"f").entries()}}e.ReadonlyMapView=l}),define(ve[126],we([0,1,31,15]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function w(...B){return function(x,Y){for(let fe=0,ye=B.length;fe<ye;fe++){const ke=B[fe](x,Y);if(ke)return ke}return null}}e.or=w,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C(B,x,Y){if(!Y||Y.length<x.length)return null;let fe;return B?fe=n.startsWithIgnoreCase(Y,x):fe=Y.indexOf(x)===0,fe?x.length>0?[{start:0,end:x.length}]:[]:null}function T(B,x){const Y=x.toLowerCase().indexOf(B.toLowerCase());return Y===-1?null:[{start:Y,end:Y+B.length}]}e.matchesContiguousSubString=T;function D(B,x){return v(B.toLowerCase(),x.toLowerCase(),0,0)}e.matchesSubString=D;function v(B,x,Y,fe){if(Y===B.length)return[];if(fe===x.length)return null;if(B[Y]===x[fe]){let ye=null;return(ye=v(B,x,Y+1,fe+1))?d({start:fe,end:fe+1},ye):null}return v(B,x,Y,fe+1)}function P(B){return 97<=B&&B<=122}function A(B){return 65<=B&&B<=90}e.isUpper=A;function R(B){return 48<=B&&B<=57}function E(B){return B===32||B===9||B===10||B===13}const S=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(B=>S.add(B.charCodeAt(0)));function u(B){return E(B)||S.has(B)}function b(B,x){return B===x||u(B)&&u(x)}function f(B){return P(B)||A(B)||R(B)}function d(B,x){return x.length===0?x=[B]:B.end===x[0].start?x[0].start=B.start:x.unshift(B),x}function p(B,x){for(let Y=x;Y<B.length;Y++){const fe=B.charCodeAt(Y);if(A(fe)||R(fe)||Y>0&&!f(B.charCodeAt(Y-1)))return Y}return B.length}function m(B,x,Y,fe){if(Y===B.length)return[];if(fe===x.length)return null;if(B[Y]!==x[fe].toLowerCase())return null;{let ye=null,ke=fe+1;for(ye=m(B,x,Y+1,fe+1);!ye&&(ke=p(x,ke))<x.length;)ye=m(B,x,Y+1,ke),ke++;return ye===null?null:d({start:fe,end:fe+1},ye)}}function y(B){let x=0,Y=0,fe=0,ye=0,ke=0;for(let Ee=0;Ee<B.length;Ee++)ke=B.charCodeAt(Ee),A(ke)&&x++,P(ke)&&Y++,f(ke)&&fe++,R(ke)&&ye++;const Re=x/B.length,Ue=Y/B.length,Ne=fe/B.length,se=ye/B.length;return{upperPercent:Re,lowerPercent:Ue,alphaPercent:Ne,numericPercent:se}}function c(B){const{upperPercent:x,lowerPercent:Y}=B;return Y===0&&x>.6}function o(B){const{upperPercent:x,lowerPercent:Y,alphaPercent:fe,numericPercent:ye}=B;return Y>.2&&x<.8&&fe>.6&&ye<.2}function l(B){let x=0,Y=0,fe=0,ye=0;for(let ke=0;ke<B.length;ke++)fe=B.charCodeAt(ke),A(fe)&&x++,P(fe)&&Y++,E(fe)&&ye++;return(x===0||Y===0)&&ye===0?B.length<=30:x<=5}function i(B,x){if(!x||(x=x.trim(),x.length===0)||!l(B)||x.length>60)return null;const Y=y(x);if(!o(Y)){if(!c(Y))return null;x=x.toLowerCase()}let fe=null,ye=0;for(B=B.toLowerCase();ye<x.length&&(fe=m(B,x,0,ye))===null;)ye=p(x,ye+1);return fe}e.matchesCamelCase=i;function t(B,x,Y=!1){if(!x||x.length===0)return null;let fe=null,ye=0;for(B=B.toLowerCase(),x=x.toLowerCase();ye<x.length&&(fe=r(B,x,0,ye,Y))===null;)ye=s(x,ye+1);return fe}e.matchesWords=t;function r(B,x,Y,fe,ye){if(Y===B.length)return[];if(fe===x.length)return null;if(b(B.charCodeAt(Y),x.charCodeAt(fe))){let ke=null,Re=fe+1;if(ke=r(B,x,Y+1,fe+1,ye),!ye)for(;!ke&&(Re=s(x,Re))<x.length;)ke=r(B,x,Y+1,Re,ye),Re++;return ke===null?null:d({start:fe,end:fe+1},ke)}else return null}function s(B,x){for(let Y=x;Y<B.length;Y++)if(u(B.charCodeAt(Y))||Y>0&&u(B.charCodeAt(Y-1)))return Y;return B.length}const a=w(e.matchesPrefix,i,T),h=w(e.matchesPrefix,i,D),g=new k.LRUCache(1e4);function _(B,x,Y=!1){if(typeof B!="string"||typeof x!="string")return null;let fe=g.get(B);fe||(fe=new RegExp(n.convertSimple2RegExpPattern(B),"i"),g.set(B,fe));const ye=fe.exec(x);return ye?[{start:ye.index,end:ye.index+ye[0].length}]:Y?h(B,x):a(B,x)}e.matchesFuzzy=_;function F(B,x){const Y=J(B,B.toLowerCase(),0,x,x.toLowerCase(),0,!0);return Y?K(Y):null}e.matchesFuzzy2=F;function $(B,x,Y,fe,ye,ke){const Re=Math.min(13,B.length);for(;Y<Re;Y++){const Ue=J(B,x,Y,fe,ye,ke,!1);if(Ue)return Ue}return[0,ke]}e.anyScore=$;function K(B){if(typeof B=="undefined")return[];const x=[],Y=B[1];for(let fe=B.length-1;fe>1;fe--){const ye=B[fe]+Y,ke=x[x.length-1];ke&&ke.end===ye?ke.end=ye+1:x.push({start:ye,end:ye+1})}return x}e.createMatches=K;const I=128;function W(){const B=[],x=[];for(let Y=0;Y<=I;Y++)x[Y]=0;for(let Y=0;Y<=I;Y++)B.push(x.slice(0));return B}function M(B){const x=[];for(let Y=0;Y<=B;Y++)x[Y]=0;return x}const q=M(2*I),Z=M(2*I),H=W(),U=W(),z=W(),Q=!1;function ie(B,x,Y,fe,ye){function ke(Ue,Ne,se=" "){for(;Ue.length<Ne;)Ue=se+Ue;return Ue}let Re=` |   |${fe.split("").map(Ue=>ke(Ue,3)).join("|")}
`;for(let Ue=0;Ue<=Y;Ue++)Ue===0?Re+=" |":Re+=`${x[Ue-1]}|`,Re+=B[Ue].slice(0,ye+1).map(Ne=>ke(Ne.toString(),3)).join("|")+`
`;return Re}function re(B,x,Y,fe){B=B.substr(x),Y=Y.substr(fe),console.log(ie(U,B,B.length,Y,Y.length)),console.log(ie(z,B,B.length,Y,Y.length)),console.log(ie(H,B,B.length,Y,Y.length))}function ce(B,x){if(x<0||x>=B.length)return!1;const Y=B.codePointAt(x);switch(Y){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!n.isEmojiImprecise(Y)}}function de(B,x){if(x<0||x>=B.length)return!1;switch(B.charCodeAt(x)){case 32:case 9:return!0;default:return!1}}function he(B,x,Y){return x[B]!==Y[B]}function j(B,x,Y,fe,ye,ke,Re=!1){for(;x<Y&&ye<ke;)B[x]===fe[ye]&&(Re&&(q[x]=ye),x+=1),ye+=1;return x===Y}e.isPatternInWord=j;var O;(function(B){B[B.Diag=1]="Diag",B[B.Left=2]="Left",B[B.LeftLeft=3]="LeftLeft"})(O||(O={}));var V;(function(B){B.Default=[-100,0];function x(Y){return!Y||Y.length===2&&Y[0]===-100&&Y[1]===0}B.isDefault=x})(V=e.FuzzyScore||(e.FuzzyScore={}));function J(B,x,Y,fe,ye,ke,Re){const Ue=B.length>I?I:B.length,Ne=fe.length>I?I:fe.length;if(Y>=Ue||ke>=Ne||Ue-Y>Ne-ke||!j(x,Y,Ue,ye,ke,Ne,!0))return;le(Ue,Ne,Y,ke,x,ye);let se=1,Ee=1,me=Y,Te=ke;const Fe=[!1];for(se=1,me=Y;me<Ue;se++,me++){const ne=q[me],Ce=Z[me],Pe=me+1<Ue?Z[me+1]:Ne;for(Ee=ne-ke+1,Te=ne;Te<Pe;Ee++,Te++){let Le=Number.MIN_SAFE_INTEGER,Me=!1;Te<=Ce&&(Le=ge(B,x,me,Y,fe,ye,Te,Ne,ke,H[se-1][Ee-1]===0,Fe));let Ke=0;Le!==Number.MAX_SAFE_INTEGER&&(Me=!0,Ke=Le+U[se-1][Ee-1]);const $e=Te>ne,He=$e?U[se][Ee-1]+(H[se][Ee-1]>0?-5:0):0,Qe=Te>ne+1&&H[se][Ee-1]>0,Ve=Qe?U[se][Ee-2]+(H[se][Ee-2]>0?-5:0):0;if(Qe&&(!$e||Ve>=He)&&(!Me||Ve>=Ke))U[se][Ee]=Ve,z[se][Ee]=3,H[se][Ee]=0;else if($e&&(!Me||He>=Ke))U[se][Ee]=He,z[se][Ee]=2,H[se][Ee]=0;else if(Me)U[se][Ee]=Ke,z[se][Ee]=1,H[se][Ee]=H[se-1][Ee-1]+1;else throw new Error("not possible")}}if(Q&&re(B,Y,fe,ke),!Fe[0]&&!Re)return;se--,Ee--;const Ye=[U[se][Ee],ke];let Be=0,je=0;for(;se>=1;){let ne=Ee;do{const Ce=z[se][ne];if(Ce===3)ne=ne-2;else if(Ce===2)ne=ne-1;else break}while(ne>=1);Be>1&&x[Y+se-1]===ye[ke+Ee-1]&&!he(ne+ke-1,fe,ye)&&Be+1>H[se][ne]&&(ne=Ee),ne===Ee?Be++:Be=1,je||(je=ne),se--,Ee=ne-1,Ye.push(Ee)}Ne===Ue&&(Ye[0]+=2);const Ge=je-Ue;return Ye[0]-=Ge,Ye}e.fuzzyScore=J;function le(B,x,Y,fe,ye,ke){let Re=B-1,Ue=x-1;for(;Re>=Y&&Ue>=fe;)ye[Re]===ke[Ue]&&(Z[Re]=Ue,Re--),Ue--}function ge(B,x,Y,fe,ye,ke,Re,Ue,Ne,se,Ee){if(x[Y]!==ke[Re])return Number.MIN_SAFE_INTEGER;let me=1,Te=!1;return Re===Y-fe?me=B[Y]===ye[Re]?7:5:he(Re,ye,ke)&&(Re===0||!he(Re-1,ye,ke))?(me=B[Y]===ye[Re]?7:5,Te=!0):ce(ke,Re)&&(Re===0||!ce(ke,Re-1))?me=5:(ce(ke,Re-1)||de(ke,Re-1))&&(me=5,Te=!0),me>1&&Y===fe&&(Ee[0]=!0),Te||(Te=he(Re,ye,ke)||ce(ke,Re-1)||de(ke,Re-1)),Y===fe?Re>Ne&&(me-=Te?3:5):se?me+=Te?2:0:me+=Te?0:1,Re+1===Ue&&(me-=Te?3:5),me}function ue(B,x,Y,fe,ye,ke,Re){return pe(B,x,Y,fe,ye,ke,!0,Re)}e.fuzzyScoreGracefulAggressive=ue;function oe(B,x,Y,fe,ye,ke,Re){return pe(B,x,Y,fe,ye,ke,!1,Re)}e.fuzzyScoreGraceful=oe;function pe(B,x,Y,fe,ye,ke,Re,Ue){let Ne=J(B,x,Y,fe,ye,ke,Ue);if(Ne&&!Re)return Ne;if(B.length>=3){const se=Math.min(7,B.length-1);for(let Ee=Y+1;Ee<se;Ee++){const me=X(B,Ee);if(me){const Te=J(me,me.toLowerCase(),Y,fe,ye,ke,Ue);Te&&(Te[0]-=3,(!Ne||Te[0]>Ne[0])&&(Ne=Te))}}}return Ne}function X(B,x){if(x+1>=B.length)return;const Y=B[x],fe=B[x+1];if(Y!==fe)return B.slice(0,x)+fe+Y+B.slice(x+2)}}),define(ve[127],we([0,1,37,126,15]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const C=new RegExp(`\\$\\(${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(k.CSSIcon.iconNameCharacter),D=new RegExp(`(\\\\)?${C.source}`,"g");function v(f){return f.replace(D,(d,p)=>p?d:`\\${d}`)}e.escapeIcons=v;const P=new RegExp(`\\\\${C.source}`,"g");function A(f){return f.replace(P,d=>`\\${d}`)}e.markdownEscapeEscapedIcons=A;const R=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function E(f){return f.indexOf(e.iconStartMarker)===-1?f:f.replace(R,(d,p,m,y)=>m?d:p||y||"")}e.stripIcons=E;function S(f){const d=f.indexOf(e.iconStartMarker);return d===-1?{text:f}:u(f,d)}e.parseLabelWithIcons=S;function u(f,d){const p=[];let m="";function y(a){if(a){m+=a;for(const h of a)p.push(l)}}let c=-1,o="",l=0,i,t,r=d;const s=f.length;for(y(f.substr(0,d));r<s;)i=f[r],t=f[r+1],i===e.iconStartMarker[0]&&t===e.iconStartMarker[1]?(c=r,y(o),o=e.iconStartMarker,r++):i===")"&&c!==-1?(l+=r-c+1,c=-1,o=""):c!==-1?T.test(i)?o+=i:(y(o),c=-1,o=""):y(i),r++;return y(o),{text:m,iconOffsets:p}}function b(f,d,p=!1){const{text:m,iconOffsets:y}=d;if(!y||y.length===0)return(0,n.matchesFuzzy)(f,m,p);const c=(0,w.ltrim)(m," "),o=m.length-c.length,l=(0,n.matchesFuzzy)(f,c,p);if(l)for(const i of l){const t=y[i.start+o]+o;i.start+=t,i.end+=t}return l}e.matchesFuzzyIconAware=b}),define(ve[75],we([0,1,31]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new k.LRUCache(1e4);function w(P){return v(P,"NFC",n)}e.normalizeNFC=w;const C=new k.LRUCache(1e4);function T(P){return v(P,"NFD",C)}e.normalizeNFD=T;const D=/[^\u0000-\u0080]/;function v(P,A,R){if(!P)return P;const E=R.get(P);if(E)return E;let S;return D.test(P)?S=P.normalize(A):S=P,R.set(P,S),S}e.removeAccents=function(){const P=/[\u0300-\u036f]/g;return function(A){return T(A).replace(P,"")}}()}),define(ve[128],we([0,1,15]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var n;(function(w){w[w.Ignore=0]="Ignore",w[w.Info=1]="Info",w[w.Warning=2]="Warning",w[w.Error=3]="Error"})(n||(n={})),function(w){const C="error",T="warning",D="warn",v="info",P="ignore";function A(E){return E?k.equalsIgnoreCase(C,E)?w.Error:k.equalsIgnoreCase(T,E)||k.equalsIgnoreCase(D,E)?w.Warning:k.equalsIgnoreCase(v,E)?w.Info:w.Ignore:w.Ignore}w.fromValue=A;function R(E){switch(E){case w.Error:return C;case w.Warning:return T;case w.Info:return v;default:return P}}w.toString=R}(n||(n={})),e.default=n}),define(ve[12],we([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function k(a){return Array.isArray(a)}e.isArray=k;function n(a){return typeof a=="string"}e.isString=n;function w(a){return Array.isArray(a)&&a.every(h=>n(h))}e.isStringArray=w;function C(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=C;function T(a){return typeof a=="object"&&(a instanceof Uint8Array||a instanceof Uint16Array||a instanceof Uint32Array||a instanceof Float32Array||a instanceof Float64Array||a instanceof Int8Array||a instanceof Int16Array||a instanceof Int32Array||a instanceof BigInt64Array||a instanceof BigUint64Array||a instanceof Uint8ClampedArray)}e.isTypedArray=T;function D(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=D;function v(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=v;function P(a){return a===!0||a===!1}e.isBoolean=P;function A(a){return typeof a=="undefined"}e.isUndefined=A;function R(a){return!E(a)}e.isDefined=R;function E(a){return A(a)||a===null}e.isUndefinedOrNull=E;function S(a,h){if(!a)throw new Error(h?`Unexpected type, expected '${h}'`:"Unexpected type")}e.assertType=S;function u(a){if(E(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=u;function b(...a){const h=[];for(let g=0;g<a.length;g++){const _=a[g];if(E(_))throw new Error(`Assertion Failed: argument at index ${g} is undefined or null`);h.push(_)}return h}e.assertAllDefined=b;const f=Object.prototype.hasOwnProperty;function d(a){if(!C(a))return!1;for(let h in a)if(f.call(a,h))return!1;return!0}e.isEmptyObject=d;function p(a){return typeof a=="function"}e.isFunction=p;function m(...a){return a.length>0&&a.every(p)}e.areFunctions=m;function y(a,h){const g=Math.min(a.length,h.length);for(let _=0;_<g;_++)c(a[_],h[_])}e.validateConstraints=y;function c(a,h){if(n(h)){if(typeof a!==h)throw new Error(`argument does not match constraint: typeof ${h}`)}else if(p(h)){try{if(a instanceof h)return}catch{}if(!E(a)&&a.constructor===h||h.length===1&&h.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function o(a){let h=[],g=Object.getPrototypeOf(a);for(;Object.prototype!==g;)h=h.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return h}e.getAllPropertyNames=o;function l(a){const h=[];for(const g of o(a))typeof a[g]=="function"&&h.push(g);return h}e.getAllMethodNames=l;function i(a,h){const g=F=>function(){const $=Array.prototype.slice.call(arguments,0);return h(F,$)};let _={};for(const F of a)_[F]=g(F);return _}e.createProxyObject=i;function t(a){return a===null?void 0:a}e.withNullAsUndefined=t;function r(a){return typeof a=="undefined"?null:a}e.withUndefinedAsNull=r;function s(a,h="Unreachable"){throw new Error(h)}e.assertNever=s}),define(ve[33],we([0,1,5,3,15,12]),function(ee,e,k,n,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(r){return r===47||r===92}e.isPathSeparator=T;function D(r){return r.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=D;function v(r){return r.indexOf("/")===-1&&(r=D(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=v;function P(r,s=k.posix.sep){if(!r)return"";const a=r.length,h=r.charCodeAt(0);if(T(h)){if(T(r.charCodeAt(1))&&!T(r.charCodeAt(2))){let _=3;const F=_;for(;_<a&&!T(r.charCodeAt(_));_++);if(F!==_&&!T(r.charCodeAt(_+1))){for(_+=1;_<a;_++)if(T(r.charCodeAt(_)))return r.slice(0,_+1).replace(/[\\/]/g,s)}}return s}else if(d(h)&&r.charCodeAt(1)===58)return T(r.charCodeAt(2))?r.slice(0,2)+s:r.slice(0,2);let g=r.indexOf("://");if(g!==-1){for(g+=3;g<a;g++)if(T(r.charCodeAt(g)))return r.slice(0,g+1)}return""}e.getRoot=P;function A(r){if(!n.isWindows||!r||r.length<5)return!1;let s=r.charCodeAt(0);if(s!==92||(s=r.charCodeAt(1),s!==92))return!1;let a=2;const h=a;for(;a<r.length&&(s=r.charCodeAt(a),s!==92);a++);return!(h===a||(s=r.charCodeAt(a+1),isNaN(s)||s===92))}e.isUNC=A;const R=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(r,s=n.isWindows){const a=s?R:E;return!(!r||r.length===0||/^\s+$/.test(r)||(a.lastIndex=0,a.test(r))||s&&S.test(r)||r==="."||r===".."||s&&r[r.length-1]==="."||s&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=u;function b(r,s,a){const h=r===s;return!a||h?h:!r||!s?!1:(0,w.equalsIgnoreCase)(r,s)}e.isEqual=b;function f(r,s,a,h=k.sep){if(r===s)return!0;if(!r||!s||s.length>r.length)return!1;if(a){if(!(0,w.startsWithIgnoreCase)(r,s))return!1;if(s.length===r.length)return!0;let _=s.length;return s.charAt(s.length-1)===h&&_--,r.charAt(_)===h}return s.charAt(s.length-1)!==h&&(s+=h),r.indexOf(s)===0}e.isEqualOrParent=f;function d(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=d;function p(r,s){return n.isWindows&&r.endsWith(":")&&(r+=k.sep),(0,k.isAbsolute)(r)||(r=(0,k.join)(s,r)),r=(0,k.normalize)(r),n.isWindows?(r=(0,w.rtrim)(r,k.sep),r.endsWith(":")&&(r+=k.sep)):(r=(0,w.rtrim)(r,k.sep),r||(r=k.sep)),r}e.sanitizeFilePath=p;function m(r){const s=(0,k.normalize)(r);return n.isWindows?r.length>3?!1:y(s)&&(r.length===2||s.charCodeAt(2)===92):s===k.posix.sep}e.isRootOrDriveLetter=m;function y(r,s){return(s!==void 0?s:n.isWindows)?d(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=y;function c(r){return y(r)?r[0]:void 0}e.getDriveLetter=c;function o(r,s,a){return s.length>r.length?-1:r===s?0:(a&&(r=r.toLowerCase(),s=s.toLowerCase()),r.indexOf(s))}e.indexOfPath=o;function l(r){const s=r.split(":");let a,h,g;for(const _ of s){const F=Number(_);(0,C.isNumber)(F)?h===void 0?h=F:g===void 0&&(g=F):a=a?[a,_].join(":"):_}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:h!==void 0?h:void 0,column:g!==void 0?g:h!==void 0?1:void 0}}e.parseLineAndColumnAware=l;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function t(r,s,a=8){let h="";for(let _=0;_<a;_++)h+=i.charAt(Math.floor(Math.random()*i.length));let g;return s?g=`${s}-${h}`:g=h,r?(0,k.join)(r,g):g}e.randomPath=t}),define(ve[22],we([0,1,12]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(b){if(!b||typeof b!="object"||b instanceof RegExp)return b;const f=Array.isArray(b)?[]:{};return Object.keys(b).forEach(d=>{b[d]&&typeof b[d]=="object"?f[d]=n(b[d]):f[d]=b[d]}),f}e.deepClone=n;function w(b){if(!b||typeof b!="object")return b;const f=[b];for(;f.length>0;){const d=f.shift();Object.freeze(d);for(const p in d)if(C.call(d,p)){const m=d[p];typeof m=="object"&&!Object.isFrozen(m)&&!(0,k.isTypedArray)(m)&&f.push(m)}}return b}e.deepFreeze=w;const C=Object.prototype.hasOwnProperty;function T(b,f){return D(b,f,new Set)}e.cloneAndChange=T;function D(b,f,d){if((0,k.isUndefinedOrNull)(b))return b;const p=f(b);if(typeof p!="undefined")return p;if((0,k.isArray)(b)){const m=[];for(const y of b)m.push(D(y,f,d));return m}if((0,k.isObject)(b)){if(d.has(b))throw new Error("Cannot clone recursive data-structure");d.add(b);const m={};for(let y in b)C.call(b,y)&&(m[y]=D(b[y],f,d));return d.delete(b),m}return b}function v(b,f,d=!0){return(0,k.isObject)(b)?((0,k.isObject)(f)&&Object.keys(f).forEach(p=>{p in b?d&&((0,k.isObject)(b[p])&&(0,k.isObject)(f[p])?v(b[p],f[p],d):b[p]=f[p]):b[p]=f[p]}),b):f}e.mixin=v;function P(b,f){if(b===f)return!0;if(b==null||f===null||f===void 0||typeof b!=typeof f||typeof b!="object"||Array.isArray(b)!==Array.isArray(f))return!1;let d,p;if(Array.isArray(b)){if(b.length!==f.length)return!1;for(d=0;d<b.length;d++)if(!P(b[d],f[d]))return!1}else{const m=[];for(p in b)m.push(p);m.sort();const y=[];for(p in f)y.push(p);if(y.sort(),!P(m,y))return!1;for(d=0;d<m.length;d++)if(!P(b[m[d]],f[m[d]]))return!1}return!0}e.equals=P;function A(b){const f=new Set;return JSON.stringify(b,(d,p)=>{if((0,k.isObject)(p)||Array.isArray(p)){if(f.has(p))return"[Circular]";f.add(p)}return p})}e.safeStringify=A;function R(b,f,d){const p=f(b);return typeof p=="undefined"?d:p}e.getOrDefault=R;function E(b,f){const d=Object.create(null);return!b||!f||Object.keys(f).forEach(m=>{const y=b[m],c=f[m];P(y,c)||(d[m]=c)}),d}e.distinct=E;function S(b,f){const d=f.toLowerCase(),p=Object.keys(b).find(m=>m.toLowerCase()===d);return p?b[p]:b[f]}e.getCaseInsensitive=S;function u(b,f){const d=Object.create(null);for(const[p,m]of Object.entries(b))f(p,m)&&(d[p]=m);return d}e.filter=u}),define(ve[4],we([0,1,5,3]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const w=/^\w[\w\d+.-]*$/,C=/^\//,T=/^\/\//;function D(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!w.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!C.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function v(i,t){return!i&&!t?"file":i}function P(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==R&&(t=R+t):t=R;break}return t}const A="",R="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{constructor(t,r,s,a,h,g=!1){typeof t=="object"?(this.scheme=t.scheme||A,this.authority=t.authority||A,this.path=t.path||A,this.query=t.query||A,this.fragment=t.fragment||A):(this.scheme=v(t,g),this.authority=r||A,this.path=P(this.scheme,s||A),this.query=a||A,this.fragment=h||A,D(this,g))}static isUri(t){return t instanceof S?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return m(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:s,path:a,query:h,fragment:g}=t;return r===void 0?r=this.scheme:r===null&&(r=A),s===void 0?s=this.authority:s===null&&(s=A),a===void 0?a=this.path:a===null&&(a=A),h===void 0?h=this.query:h===null&&(h=A),g===void 0?g=this.fragment:g===null&&(g=A),r===this.scheme&&s===this.authority&&a===this.path&&h===this.query&&g===this.fragment?this:new b(r,s,a,h,g)}static parse(t,r=!1){const s=E.exec(t);return s?new b(s[2]||A,l(s[4]||A),l(s[5]||A),l(s[7]||A),l(s[9]||A),r):new b(A,A,A,A,A)}static file(t){let r=A;if(n.isWindows&&(t=t.replace(/\\/g,R)),t[0]===R&&t[1]===R){const s=t.indexOf(R,2);s===-1?(r=t.substring(2),t=R):(r=t.substring(2,s),t=t.substring(s)||R)}return new b("file",r,t,A,A)}static from(t){const r=new b(t.scheme,t.authority,t.path,t.query,t.fragment);return D(r,!0),r}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let s;return n.isWindows&&t.scheme==="file"?s=S.file(k.win32.join(m(t,!0),...r)).path:s=k.posix.join(t.path,...r),t.with({path:s})}toString(t=!1){return y(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof S)return t;{const r=new b(t);return r._formatted=t.external,r._fsPath=t._sep===u?t.fsPath:null,r}}else return t}}e.URI=S;const u=n.isWindows?1:void 0;class b extends S{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(t=!1){return t?y(this,!0):(this._formatted||(this._formatted=y(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=u),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(i,t){let r,s=-1;for(let a=0;a<i.length;a++){const h=i.charCodeAt(a);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||t&&h===47)s!==-1&&(r+=encodeURIComponent(i.substring(s,a)),s=-1),r!==void 0&&(r+=i.charAt(a));else{r===void 0&&(r=i.substr(0,a));const g=f[h];g!==void 0?(s!==-1&&(r+=encodeURIComponent(i.substring(s,a)),s=-1),r+=g):s===-1&&(s=a)}}return s!==-1&&(r+=encodeURIComponent(i.substring(s))),r!==void 0?r:i}function p(i){let t;for(let r=0;r<i.length;r++){const s=i.charCodeAt(r);s===35||s===63?(t===void 0&&(t=i.substr(0,r)),t+=f[s]):t!==void 0&&(t+=i[r])}return t!==void 0?t:i}function m(i,t){let r;return i.authority&&i.path.length>1&&i.scheme==="file"?r=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?r=i.path.substr(1):r=i.path[1].toLowerCase()+i.path.substr(2):r=i.path,n.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=m;function y(i,t){const r=t?p:d;let s="",{scheme:a,authority:h,path:g,query:_,fragment:F}=i;if(a&&(s+=a,s+=":"),(h||a==="file")&&(s+=R,s+=R),h){let $=h.indexOf("@");if($!==-1){const K=h.substr(0,$);h=h.substr($+1),$=K.indexOf(":"),$===-1?s+=r(K,!1):(s+=r(K.substr(0,$),!1),s+=":",s+=r(K.substr($+1),!1)),s+="@"}h=h.toLowerCase(),$=h.indexOf(":"),$===-1?s+=r(h,!1):(s+=r(h.substr(0,$),!1),s+=h.substr($))}if(g){if(g.length>=3&&g.charCodeAt(0)===47&&g.charCodeAt(2)===58){const $=g.charCodeAt(1);$>=65&&$<=90&&(g=`/${String.fromCharCode($+32)}:${g.substr(3)}`)}else if(g.length>=2&&g.charCodeAt(1)===58){const $=g.charCodeAt(0);$>=65&&$<=90&&(g=`${String.fromCharCode($+32)}:${g.substr(2)}`)}s+=r(g,!0)}return _&&(s+="?",s+=r(_,!1)),F&&(s+="#",s+=t?F:d(F,!1)),s}function c(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+c(i.substr(3)):i}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(i){return i.match(o)?i.replace(o,t=>c(t)):i}}),define(ve[76],we([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(P){const A=P;return A&&typeof A.type=="string"&&typeof A.severity=="string"}e.isRemoteConsoleLog=n;function w(P){const A=[];let R;try{const E=JSON.parse(P.arguments),S=E[E.length-1];S&&S.__$stack&&(E.pop(),R=S.__$stack),A.push(...E)}catch{A.push("Unable to log remote console arguments",P.arguments)}return{args:A,stack:R}}e.parse=w;function C(P){if(typeof P!="string")return C(w(P).stack);const A=P;if(A){const R=T(A),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(R||"");if(E&&E.length===4)return{uri:k.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}e.getFirstFrame=C;function T(P){if(!P)return P;const A=P.indexOf(`
`);return A===-1?P:P.substring(0,A)}function D(P,A){const{args:R,stack:E}=w(P),S=typeof R[0]=="string"&&R.length===1;let u=T(E);u&&(u=`(${u.trim()})`);let b=[];if(typeof R[0]=="string"?u&&S?b=[`%c[${A}] %c${R[0]} %c${u}`,v("blue"),v(""),v("grey")]:b=[`%c[${A}] %c${R[0]}`,v("blue"),v(""),...R.slice(1)]:b=[`%c[${A}]%`,v("blue"),...R],u&&!S&&b.push(u),typeof console[P.severity]!="function")throw new Error("Unknown console method");console[P.severity].apply(console,b)}e.log=D;function v(P){return`color: ${P}`}}),define(ve[50],we([0,1,16,15,4]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function C(P){return JSON.stringify(P,D)}e.stringify=C;function T(P){let A=JSON.parse(P);return A=v(A),A}e.parse=T;function D(P,A){return A instanceof RegExp?{$mid:2,source:A.source,flags:(0,n.regExpFlags)(A)}:A}function v(P,A=0){if(!P||A>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return w.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 14:return new Date(P.source)}if(P instanceof k.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let R=0;R<P.length;++R)P[R]=v(P[R],A+1);else for(const R in P)Object.hasOwnProperty.call(P,R)&&(P[R]=v(P[R],A+1))}return P}e.revive=v}),define(ve[8],we([0,1,3,4]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var w;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.vscodeUserData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeInteractive="vscode-interactive",D.vscodeInteractiveInput="vscode-interactive-input",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp",D.vsls="vsls"})(w=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(v){this._preferredWebSchema=v}setDelegate(v){this._delegate=v}set(v,P,A){this._hosts[v]=P,this._ports[v]=A}setConnectionToken(v,P){this._connectionTokens[v]=P}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(v){if(this._delegate)return this._delegate(v);const P=v.authority;let A=this._hosts[P];A&&A.indexOf(":")!==-1&&(A=`[${A}]`);const R=this._ports[P],E=this._connectionTokens[P];let S=`path=${encodeURIComponent(v.path)}`;return typeof E=="string"&&(S+=`&${e.connectionTokenQueryName}=${encodeURIComponent(E)}`),n.URI.from({scheme:k.isWeb?this._preferredWebSchema:w.vscodeRemoteResource,authority:`${A}:${R}`,path:"/vscode-remote-resource",query:S})}}e.RemoteAuthorities=new C;class T{asBrowserUri(v,P){const A=this.toUri(v,P);return A.scheme===w.vscodeRemote?e.RemoteAuthorities.rewrite(A):A.scheme===w.file&&(k.isNative||k.isWebWorker&&k.globals.origin===`${w.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?A.with({scheme:w.vscodeFileResource,authority:A.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):A}asFileUri(v,P){const A=this.toUri(v,P);return A.scheme===w.vscodeFileResource?A.with({scheme:w.file,authority:A.authority!==T.FALLBACK_AUTHORITY?A.authority:null,query:null,fragment:null}):A}toUri(v,P){return n.URI.isUri(v)?v:n.URI.parse(P.toUrl(v))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T}),define(ve[20],we([0,1,33,8,5,3,15,4]),function(ee,e,k,n,w,C,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function v(S){return(0,D.uriToFsPath)(S,!0)}e.originalFSPath=v;class P{constructor(u){this._ignorePathCasing=u}compare(u,b,f=!1){return u===b?0:(0,T.compare)(this.getComparisonKey(u,f),this.getComparisonKey(b,f))}isEqual(u,b,f=!1){return u===b?!0:!u||!b?!1:this.getComparisonKey(u,f)===this.getComparisonKey(b,f)}getComparisonKey(u,b=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,b,f=!1){if(u.scheme===b.scheme){if(u.scheme===n.Schemas.file)return k.isEqualOrParent(v(u),v(b),this._ignorePathCasing(u))&&u.query===b.query&&(f||u.fragment===b.fragment);if((0,e.isEqualAuthority)(u.authority,b.authority))return k.isEqualOrParent(u.path,b.path,this._ignorePathCasing(u),"/")&&u.query===b.query&&(f||u.fragment===b.fragment)}return!1}joinPath(u,...b){return D.URI.joinPath(u,...b)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return w.posix.basename(u.path)}extname(u){return w.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let b;return u.scheme===n.Schemas.file?b=D.URI.file(w.dirname(v(u))).path:(b=w.posix.dirname(u.path),u.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),b="/")),u.with({path:b})}normalizePath(u){if(!u.path.length)return u;let b;return u.scheme===n.Schemas.file?b=D.URI.file(w.normalize(v(u))).path:b=w.posix.normalize(u.path),u.with({path:b})}relativePath(u,b){if(u.scheme!==b.scheme||!(0,e.isEqualAuthority)(u.authority,b.authority))return;if(u.scheme===n.Schemas.file){const p=w.relative(v(u),v(b));return C.isWindows?k.toSlashes(p):p}let f=u.path||"/",d=b.path||"/";if(this._ignorePathCasing(u)){let p=0;for(const m=Math.min(f.length,d.length);p<m&&!(f.charCodeAt(p)!==d.charCodeAt(p)&&f.charAt(p).toLowerCase()!==d.charAt(p).toLowerCase());p++);f=d.substr(0,p)+f.substr(p)}return w.posix.relative(f,d)}resolvePath(u,b){if(u.scheme===n.Schemas.file){const f=D.URI.file(w.resolve(v(u),b));return u.with({authority:f.authority,path:f.path})}return b=k.toPosixPath(b),u.with({path:w.posix.resolve(u.path,b)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,b){return u===b||u!==void 0&&b!==void 0&&(0,T.equalsIgnoreCase)(u,b)}hasTrailingPathSeparator(u,b=w.sep){if(u.scheme===n.Schemas.file){const f=v(u);return f.length>k.getRoot(f).length&&f[f.length-1]===b}else{const f=u.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,b=w.sep){return(0,e.hasTrailingPathSeparator)(u,b)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,b=w.sep){let f=!1;if(u.scheme===n.Schemas.file){const d=v(u);f=d!==void 0&&d.length===k.getRoot(d).length&&d[d.length-1]===b}else{b="/";const d=u.path;f=d.length===1&&d.charCodeAt(d.length-1)===47}return!f&&!(0,e.hasTrailingPathSeparator)(u,b)?u.with({path:u.path+"/"}):u}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(S=>S.scheme===n.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new P(S=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function A(S,u){const b=[];for(let f=0;f<S.length;f++){const d=u(S[f]);S.some((p,m)=>m===f?!1:(0,e.isEqualOrParent)(d,u(p)))||b.push(S[f])}return b}e.distinctParents=A;var R;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function u(b){const f=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(m=>{const[y,c]=m.split(":");y&&c&&f.set(y,c)});const p=b.path.substring(0,b.path.indexOf(";"));return p&&f.set(S.META_DATA_MIME,p),f}S.parseMetaData=u})(R=e.DataUri||(e.DataUri={}));function E(S,u,b){if(u){let f=S.path;return f&&f[0]!==w.posix.sep&&(f=w.posix.sep+f),S.with({scheme:b,authority:u,path:f})}return S.with({scheme:b})}e.toLocalResource=E}),define(ve[14],we([0,1,21,9,7,2,20,3]),function(ee,e,k,n,w,C,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function v(he){return!!he&&typeof he.then=="function"}e.isThenable=v;function P(he){const j=new k.CancellationTokenSource,O=he(j.token),V=new Promise((J,le)=>{const ge=j.token.onCancellationRequested(()=>{ge.dispose(),j.dispose(),le(new n.CancellationError)});Promise.resolve(O).then(ue=>{ge.dispose(),j.dispose(),J(ue)},ue=>{ge.dispose(),j.dispose(),le(ue)})});return new class{cancel(){j.cancel()}then(J,le){return V.then(J,le)}catch(J){return this.then(void 0,J)}finally(J){return V.finally(J)}}}e.createCancelablePromise=P;function A(he,j,O){return new Promise((V,J)=>{const le=j.onCancellationRequested(()=>{le.dispose(),V(O)});he.then(V,J).finally(()=>le.dispose())})}e.raceCancellation=A;function R(he,j){return new Promise((O,V)=>{const J=j.onCancellationRequested(()=>{J.dispose(),V(new n.CancellationError)});he.then(O,V).finally(()=>J.dispose())})}e.raceCancellationError=R;async function E(he){let j=-1;const O=he.map((J,le)=>J.then(ge=>(j=le,ge))),V=await Promise.race(O);return he.forEach((J,le)=>{le!==j&&J.cancel()}),V}e.raceCancellablePromises=E;function S(he,j,O){let V;const J=setTimeout(()=>{V?.(void 0),O?.()},j);return Promise.race([he.finally(()=>clearTimeout(J)),new Promise(le=>V=le)])}e.raceTimeout=S;function u(he){return new Promise((j,O)=>{const V=he();v(V)?V.then(j,O):j(V)})}e.asPromise=u;class b{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(j){if(this.activePromise){if(this.queuedPromiseFactory=j,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(O,O).then(V)})}return new Promise((O,V)=>{this.queuedPromise.then(O,V)})}return this.activePromise=j(),new Promise((O,V)=>{this.activePromise.then(J=>{this.activePromise=null,O(J)},J=>{this.activePromise=null,V(J)})})}}e.Throttler=b;class f{constructor(){this.current=Promise.resolve(null)}queue(j){return this.current=this.current.then(()=>j(),()=>j())}}e.Sequencer=f;class d{constructor(){this.promiseMap=new Map}queue(j,O){const J=(this.promiseMap.get(j)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(j)===J&&this.promiseMap.delete(j)});return this.promiseMap.set(j,J),J}}e.SequencerByKey=d;const p=(he,j)=>{let O=!0;const V=setTimeout(()=>{O=!1,j()},he);return{isTriggered:()=>O,dispose:()=>{clearTimeout(V),O=!1}}},m=he=>{let j=!0;return queueMicrotask(()=>{j&&(j=!1,he())}),{isTriggered:()=>j,dispose:()=>{j=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class y{constructor(j){this.defaultDelay=j,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(j,O=this.defaultDelay){this.task=j,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((J,le)=>{this.doResolve=J,this.doReject=le}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const J=this.task;return this.task=null,J()}}));const V=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=O===e.MicrotaskDelay?m(V):p(O,V),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=y;class c{constructor(j){this.delayer=new y(j),this.throttler=new b}trigger(j,O){return this.delayer.trigger(()=>this.throttler.queue(j),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class o{constructor(){this._isOpen=!1,this._promise=new Promise((j,O)=>{this._completePromise=j})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class l extends o{constructor(j){super();this._timeout=setTimeout(()=>this.open(),j)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function i(he,j){return j?new Promise((O,V)=>{const J=setTimeout(()=>{le.dispose(),O()},he),le=j.onCancellationRequested(()=>{clearTimeout(J),le.dispose(),V(new n.CancellationError)})}):P(O=>i(he,O))}e.timeout=i;function t(he,j=0){const O=setTimeout(he,j);return(0,C.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=t;function r(he){const j=[];let O=0;const V=he.length;function J(){return O<V?he[O++]():null}function le(ge){ge!=null&&j.push(ge);const ue=J();return ue?ue.then(le):Promise.resolve(j)}return Promise.resolve(null).then(le)}e.sequence=r;function s(he,j=V=>!!V,O=null){let V=0;const J=he.length,le=()=>{if(V>=J)return Promise.resolve(O);const ge=he[V++];return Promise.resolve(ge()).then(oe=>j(oe)?Promise.resolve(oe):le())};return le()}e.first=s;function a(he,j=V=>!!V,O=null){if(he.length===0)return Promise.resolve(O);let V=he.length;const J=()=>{V=-1;for(const le of he)le.cancel?.()};return new Promise((le,ge)=>{for(const ue of he)ue.then(oe=>{--V>=0&&j(oe)?(J(),le(oe)):V===0&&le(O)}).catch(oe=>{--V>=0&&(J(),ge(oe))})})}e.firstParallel=a;class h{constructor(j){this._size=0,this.maxDegreeOfParalellism=j,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new w.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(j){return this._size++,new Promise((O,V)=>{this.outstandingPromises.push({factory:j,c:O,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const j=this.outstandingPromises.shift();this.runningPromises++;const O=j.factory();O.then(j.c,j.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=h;class g extends h{constructor(){super(1)}}e.Queue=g;class _{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const j=new z;return this.drainers.add(j),j.p}isDrained(){for(const[,j]of this.queues)if(j.size>0)return!1;return!0}queueFor(j,O=T.extUri){const V=O.getComparisonKey(j);let J=this.queues.get(V);return J||(J=new g,w.Event.once(J.onDrained)(()=>{J?.dispose(),this.queues.delete(V),this.onDidQueueDrain()}),this.queues.set(V,J)),J}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const j of this.drainers)j.complete();this.drainers.clear()}dispose(){for(const[,j]of this.queues)j.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=_;class F{constructor(j,O){this._token=-1,typeof j=="function"&&typeof O=="number"&&this.setIfNotSet(j,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(j,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,j()},O)}setIfNotSet(j,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,j()},O))}}e.TimeoutTimer=F;class ${constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(j,O){this.cancel(),this._token=setInterval(()=>{j()},O)}}e.IntervalTimer=$;class K{constructor(j,O){this.timeoutToken=-1,this.runner=j,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(j=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,j)}get delay(){return this.timeout}set delay(j){this.timeout=j}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=K;class I{constructor(j,O){O%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.runner=j,this.timeout=O,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(j=this.timeout){j%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(j/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=I;class W extends K{constructor(j,O){super(j,O);this.units=[]}work(j){this.units.push(j),this.isScheduled()||this.schedule()}doRun(){const j=this.units;this.units=[],this.runner&&this.runner(j)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=W;class M extends C.Disposable{constructor(j,O){super();this.options=j,this.handler=O,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(j){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+j.length>this.options.maxBufferedWork)return!1}else if(this.pending+j.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...j),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new K(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=he=>{(0,D.setTimeout0)(()=>{if(j)return;const O=Date.now()+15;he(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let j=!1;return{dispose(){j||(j=!0)}}}:e.runWhenIdle=(he,j)=>{const O=requestIdleCallback(he,typeof j=="number"?{timeout:j}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback(O))}}}}();class q{constructor(j){this._didRun=!1,this._executor=()=>{try{this._value=j()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=q;async function Z(he,j,O){let V;for(let J=0;J<O;J++)try{return await he()}catch(le){V=le,await i(j)}throw V}e.retry=Z;class H{hasPending(j){return this._pending?typeof j=="number"?this._pending.taskId===j:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(j,O,V){return this._pending={taskId:j,cancel:()=>V?.(),promise:O},O.then(()=>this.donePending(j),()=>this.donePending(j)),O}donePending(j){this._pending&&j===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const j=this._next;this._next=void 0,j.run().then(j.promiseResolve,j.promiseReject)}}setNext(j){if(this._next)this._next.run=j;else{let O,V;const J=new Promise((le,ge)=>{O=le,V=ge});this._next={run:j,promise:J,promiseResolve:O,promiseReject:V}}return this._next.promise}}e.TaskSequentializer=H;class U{constructor(j,O=()=>Date.now()){this.interval=j,this.nowFn=O,this.lastIncrementTime=0,this.value=0}increment(){const j=this.nowFn();return j-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=j,this.value=0),this.value++,this.value}}e.IntervalCounter=U;class z{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((j,O)=>{this.completeCallback=j,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(j){return new Promise(O=>{this.completeCallback(j),this.resolved=!0,O()})}error(j){return new Promise(O=>{this.errorCallback(j),this.rejected=!0,O()})}cancel(){new Promise(j=>{this.errorCallback(new n.CancellationError),this.rejected=!0,j()})}}e.DeferredPromise=z;var Q;(function(he){async function j(V){let J;const le=await Promise.all(V.map(ge=>ge.then(ue=>ue,ue=>{J||(J=ue)})));if(typeof J!="undefined")throw J;return le}he.settled=j;function O(V){return new Promise(async(J,le)=>{try{await V(J,le)}catch(ge){le(ge)}})}he.withAsyncBody=O})(Q=e.Promises||(e.Promises={}));var ie;(function(he){he[he.Initial=0]="Initial",he[he.DoneOK=1]="DoneOK",he[he.DoneError=2]="DoneError"})(ie||(ie={}));class re{constructor(j){this._state=0,this._results=[],this._error=null,this._onStateChanged=new w.Emitter,queueMicrotask(async()=>{const O={emitOne:V=>this.emitOne(V),emitMany:V=>this.emitMany(V),reject:V=>this.reject(V)};try{await Promise.resolve(j(O)),this.resolve()}catch(V){this.reject(V)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}static fromArray(j){return new re(O=>{O.emitMany(j)})}static fromPromise(j){return new re(async O=>{O.emitMany(await j)})}static fromPromises(j){return new re(async O=>{await Promise.all(j.map(async V=>O.emitOne(await V)))})}static merge(j){return new re(async O=>{await Promise.all(j.map(async V=>{for await(const J of V)O.emitOne(J)}))})}[Symbol.asyncIterator](){let j=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(j<this._results.length)return{done:!1,value:this._results[j++]};if(this._state===1)return{done:!0,value:void 0};await w.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(j,O){return new re(async V=>{for await(const J of j)V.emitOne(O(J))})}map(j){return re.map(this,j)}static filter(j,O){return new re(async V=>{for await(const J of j)O(J)&&V.emitOne(J)})}filter(j){return re.filter(this,j)}static coalesce(j){return re.filter(j,O=>!!O)}coalesce(){return re.coalesce(this)}static async toPromise(j){const O=[];for await(const V of j)O.push(V);return O}toPromise(){return re.toPromise(this)}emitOne(j){this._state===0&&(this._results.push(j),this._onStateChanged.fire())}emitMany(j){this._state===0&&(this._results=this._results.concat(j),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(j){this._state===0&&(this._state=2,this._error=j,this._onStateChanged.fire())}}e.AsyncIterableObject=re,re.EMPTY=re.fromArray([]);class ce extends re{constructor(j,O){super(O);this._source=j}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ce;function de(he){const j=new k.CancellationTokenSource,O=he(j.token);return new ce(j,async V=>{const J=j.token.onCancellationRequested(()=>{J.dispose(),j.dispose(),V.reject(new n.CancellationError)});try{for await(const le of O){if(j.token.isCancellationRequested)return;V.emitOne(le)}J.dispose(),j.dispose()}catch(le){J.dispose(),j.dispose(),V.reject(le)}})}e.createCancelableAsyncIterable=de}),define(ve[77],we([0,1,14,33,31,5,3,15]),function(ee,e,k,n,w,C,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function v(){return Object.create(null)}e.getEmptyExpression=v,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const P="[/\\\\]",A="[^/\\\\]",R=/\//g;function E(H,U){switch(H){case 0:return"";case 1:return`${A}*?`;default:return`(?:${P}|${A}+${P}${U?`|${P}${A}+`:""})*?`}}function S(H,U){if(!H)return[];const z=[];let Q=!1,ie=!1,re="";for(const ce of H){switch(ce){case U:if(!Q&&!ie){z.push(re),re="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}re+=ce}return re&&z.push(re),z}e.splitGlobAware=S;function u(H){if(!H)return"";let U="";const z=S(H,e.GLOB_SPLIT);if(z.every(Q=>Q===e.GLOBSTAR))U=".*";else{let Q=!1;z.forEach((ie,re)=>{if(ie===e.GLOBSTAR){if(Q)return;U+=E(2,re===z.length-1)}else{let ce=!1,de="",he=!1,j="";for(const O of ie){if(O!=="}"&&ce){de+=O;continue}if(he&&(O!=="]"||!j)){let V;O==="-"?V=O:(O==="^"||O==="!")&&!j?V="^":O===e.GLOB_SPLIT?V="":V=(0,D.escapeRegExpCharacters)(O),j+=V;continue}switch(O){case"{":ce=!0;continue;case"[":he=!0;continue;case"}":{U+=`(?:${S(de,",").map(le=>u(le)).join("|")})`,ce=!1,de="";break}case"]":{U+="["+j+"]",he=!1,j="";break}case"?":U+=A;continue;case"*":U+=E(1);continue;default:U+=(0,D.escapeRegExpCharacters)(O)}}re<z.length-1&&(z[re+1]!==e.GLOBSTAR||re+2<z.length)&&(U+=P)}Q=ie===e.GLOBSTAR})}return U}const b=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,p=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,m=/^\*\*((\/[\w\.-]+)+)\/?$/,y=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,c=new w.LRUCache(1e4),o=function(){return!1},l=function(){return null};function i(H,U){if(!H)return l;let z;typeof H!="string"?z=H.pattern:z=H,z=z.trim();const Q=`${z}_${!!U.trimForExclusions}`;let ie=c.get(Q);if(ie)return t(ie,H);let re;return b.test(z)?ie=s(z.substr(4),z):(re=f.exec(r(z,U)))?ie=a(re[1],z):(U.trimForExclusions?p:d).test(z)?ie=h(z,U):(re=m.exec(r(z,U)))?ie=g(re[1].substr(1),z,!0):(re=y.exec(r(z,U)))?ie=g(re[1],z,!1):ie=_(z),c.set(Q,ie),t(ie,H)}function t(H,U){return typeof U=="string"?H:function(z,Q){return(0,n.isEqualOrParent)(z,U.base,!T.isLinux)?H(z.substr(U.base.length+1),Q):null}}function r(H,U){return U.trimForExclusions&&H.endsWith("/**")?H.substr(0,H.length-2):H}function s(H,U){return function(z,Q){return typeof z=="string"&&z.endsWith(H)?U:null}}function a(H,U){const z=`/${H}`,Q=`\\${H}`,ie=function(ce,de){return typeof ce!="string"?null:de?de===H?U:null:ce===H||ce.endsWith(z)||ce.endsWith(Q)?U:null},re=[H];return ie.basenames=re,ie.patterns=[U],ie.allBasenames=re,ie}function h(H,U){const z=Z(H.slice(1,-1).split(",").map(de=>i(de,U)).filter(de=>de!==l),H),Q=z.length;if(!Q)return l;if(Q===1)return z[0];const ie=function(de,he){for(let j=0,O=z.length;j<O;j++)if(z[j](de,he))return H;return null},re=z.find(de=>!!de.allBasenames);re&&(ie.allBasenames=re.allBasenames);const ce=z.reduce((de,he)=>he.allPaths?de.concat(he.allPaths):de,[]);return ce.length&&(ie.allPaths=ce),ie}function g(H,U,z){const Q=C.sep===C.posix.sep,ie=Q?H:H.replace(R,C.sep),re=C.sep+ie,ce=C.posix.sep+H;let de;return z?de=function(he,j){return typeof he=="string"&&(he===ie||he.endsWith(re)||!Q&&(he===H||he.endsWith(ce)))?U:null}:de=function(he,j){return typeof he=="string"&&(he===ie||!Q&&he===H)?U:null},de.allPaths=[(z?"*/":"./")+H],de}function _(H){try{const U=new RegExp(`^${u(H)}$`);return function(z){return U.lastIndex=0,typeof z=="string"&&U.test(z)?H:null}}catch{return l}}function F(H,U,z){return!H||typeof U!="string"?!1:$(H)(U,void 0,z)}e.match=F;function $(H,U={}){if(!H)return o;if(typeof H=="string"||K(H)){const z=i(H,U);if(z===l)return o;const Q=function(ie,re){return!!z(ie,re)};return z.allBasenames&&(Q.allBasenames=z.allBasenames),z.allPaths&&(Q.allPaths=z.allPaths),Q}return M(H,U)}e.parse=$;function K(H){const U=H;return U?typeof U.base=="string"&&typeof U.pattern=="string":!1}e.isRelativePattern=K;function I(H){return H.allBasenames||[]}e.getBasenameTerms=I;function W(H){return H.allPaths||[]}e.getPathTerms=W;function M(H,U){const z=Z(Object.getOwnPropertyNames(H).map(de=>q(de,H[de],U)).filter(de=>de!==l)),Q=z.length;if(!Q)return l;if(!z.some(de=>!!de.requiresSiblings)){if(Q===1)return z[0];const de=function(O,V){for(let J=0,le=z.length;J<le;J++){const ge=z[J](O,V);if(ge)return ge}return null},he=z.find(O=>!!O.allBasenames);he&&(de.allBasenames=he.allBasenames);const j=z.reduce((O,V)=>V.allPaths?O.concat(V.allPaths):O,[]);return j.length&&(de.allPaths=j),de}const ie=function(de,he,j){let O;for(let V=0,J=z.length;V<J;V++){const le=z[V];le.requiresSiblings&&j&&(he||(he=(0,C.basename)(de)),O||(O=he.substr(0,he.length-(0,C.extname)(de).length)));const ge=le(de,he,O,j);if(ge)return ge}return null},re=z.find(de=>!!de.allBasenames);re&&(ie.allBasenames=re.allBasenames);const ce=z.reduce((de,he)=>he.allPaths?de.concat(he.allPaths):de,[]);return ce.length&&(ie.allPaths=ce),ie}function q(H,U,z){if(U===!1)return l;const Q=i(H,z);if(Q===l)return l;if(typeof U=="boolean")return Q;if(U){const ie=U.when;if(typeof ie=="string"){const re=(ce,de,he,j)=>{if(!j||!Q(ce,de))return null;const O=ie.replace("$(basename)",he),V=j(O);return(0,k.isThenable)(V)?V.then(J=>J?H:null):V?H:null};return re.requiresSiblings=!0,re}}return Q}function Z(H,U){const z=H.filter(de=>!!de.basenames);if(z.length<2)return H;const Q=z.reduce((de,he)=>{const j=he.basenames;return j?de.concat(j):de},[]);let ie;if(U){ie=[];for(let de=0,he=Q.length;de<he;de++)ie.push(U)}else ie=z.reduce((de,he)=>{const j=he.patterns;return j?de.concat(j):de},[]);const re=function(de,he){if(typeof de!="string")return null;if(!he){let O;for(O=de.length;O>0;O--){const V=de.charCodeAt(O-1);if(V===47||V===92)break}he=de.substr(O)}const j=Q.indexOf(he);return j!==-1?ie[j]:null};re.basenames=Q,re.patterns=ie,re.allBasenames=Q;const ce=H.filter(de=>!de.basenames);return ce.push(re),ce}}),define(ve[78],we([0,1,9,127,20,15,4]),function(ee,e,k,n,w,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var D;(function(b){b[b.Paragraph=0]="Paragraph",b[b.Break=1]="Break"})(D=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class v{constructor(f="",d=!1){if(this.value=f,typeof this.value!="string")throw(0,k.illegalArgument)("value");typeof d=="boolean"?(this.isTrusted=d,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=d.isTrusted??void 0,this.supportThemeIcons=d.supportThemeIcons??!1,this.supportHtml=d.supportHtml??!1)}appendText(f,d=0){return this.value+=E(this.supportThemeIcons?(0,n.escapeIcons)(f):f).replace(/([ \t]+)/g,(p,m)=>"&nbsp;".repeat(m.length)).replace(/\>/gm,"\\>").replace(/\n/g,d===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,d){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=d,this.value+="\n```\n",this}appendLink(f,d,p){return this.value+="[",this.value+=this._escape(d,"]"),this.value+="](",this.value+=this._escape(String(f),")"),p&&(this.value+=` "${this._escape(this._escape(p,'"'),")")}"`),this.value+=")",this}_escape(f,d){const p=new RegExp((0,C.escapeRegExpCharacters)(d),"g");return f.replace(p,(m,y)=>f.charAt(y-1)!=="\\"?`\\${m}`:m)}}e.MarkdownString=v;function P(b){return A(b)?!b.value:Array.isArray(b)?b.every(P):!0}e.isEmptyMarkdownString=P;function A(b){return b instanceof v?!0:b&&typeof b=="object"?typeof b.value=="string"&&(typeof b.isTrusted=="boolean"||b.isTrusted===void 0)&&(typeof b.supportThemeIcons=="boolean"||b.supportThemeIcons===void 0):!1}e.isMarkdownString=A;function R(b,f){return b===f?!0:!b||!f?!1:b.value===f.value&&b.isTrusted===f.isTrusted&&b.supportThemeIcons===f.supportThemeIcons&&b.supportHtml===f.supportHtml&&(b.baseUri===f.baseUri||!!b.baseUri&&!!f.baseUri&&(0,w.isEqual)(T.URI.from(b.baseUri),T.URI.from(f.baseUri)))}e.markdownStringEqual=R;function E(b){return b.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=E;function S(b){return b&&b.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=S;function u(b){const f=[],d=b.split("|").map(m=>m.trim());b=d[0];const p=d[1];if(p){const m=/height=(\d+)/.exec(p),y=/width=(\d+)/.exec(p),c=m?m[1]:"",o=y?y[1]:"",l=isFinite(parseInt(o)),i=isFinite(parseInt(c));l&&f.push(`width="${o}"`),i&&f.push(`height="${c}"`)}return{href:b,dimensions:f}}e.parseHrefAndDimensions=u}),define(ve[79],we([0,1,33,8,5,3,20,15,4]),function(ee,e,k,n,w,C,T,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(t,r,s){if(typeof t=="string"&&(t=v.URI.file(t)),s){const h=s.getWorkspaceFolder(t);if(h){const g=s.getWorkspace().folders.length>1;let _;if((0,T.isEqual)(h.uri,t)?_="":_=(0,T.relativePath)(h.uri,t),g){const F=h.name?h.name:(0,T.basename)(h.uri);_=_?F+" \u2022 "+_:F}return _}}if(t.scheme!==n.Schemas.file&&t.scheme!==n.Schemas.untitled)return t.with({query:null,fragment:null}).toString(!0);if((0,k.hasDriveLetter)(t.fsPath))return(0,w.normalize)(R(t.fsPath));let a=(0,w.normalize)(t.fsPath);return!C.isWindows&&r?.userHome&&(a=S(a,r.userHome.fsPath)),a}e.getPathLabel=P;function A(t){if(!t)return;typeof t=="string"&&(t=v.URI.file(t));const r=(0,T.basename)(t)||(t.scheme===n.Schemas.file?t.fsPath:t.path);return C.isWindows&&(0,k.isRootOrDriveLetter)(r)?R(r):r}e.getBaseLabel=A;function R(t,r){return(0,k.hasDriveLetter)(t,r)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=R;let E=Object.create(null);function S(t,r){if(C.isWindows||!t||!r)return t;let s=E.original===r?E.normalized:void 0;return s||(s=`${(0,D.rtrim)(r,w.posix.sep)}${w.posix.sep}`,E={original:r,normalized:s}),(C.isLinux?t.startsWith(s):(0,D.startsWithIgnoreCase)(t,s))&&(t=`~/${t.substr(s.length)}`),t}e.tildify=S;function u(t,r){return t.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=u;const b="\u2026",f="\\\\",d="~";function p(t,r=w.sep){const s=new Array(t.length);let a=!1;for(let h=0;h<t.length;h++){let g=t[h];if(g===""){s[h]=`.${r}`;continue}if(!g){s[h]=g;continue}a=!0;let _="";g.indexOf(f)===0?(_=g.substr(0,g.indexOf(f)+f.length),g=g.substr(g.indexOf(f)+f.length)):g.indexOf(r)===0?(_=g.substr(0,g.indexOf(r)+r.length),g=g.substr(g.indexOf(r)+r.length)):g.indexOf(d)===0&&(_=g.substr(0,g.indexOf(d)+d.length),g=g.substr(g.indexOf(d)+d.length));const F=g.split(r);for(let $=1;a&&$<=F.length;$++)for(let K=F.length-$;a&&K>=0;K--){a=!1;let I=F.slice(K,K+$).join(r);for(let W=0;!a&&W<t.length;W++)if(W!==h&&t[W]&&t[W].indexOf(I)>-1){const M=K+$===F.length,q=K>0&&t[W].indexOf(r)>-1?r+I:I,Z=t[W].endsWith(q);a=!M||Z}if(!a){let W="";(F[0].endsWith(":")||_!=="")&&(K===1&&(K=0,$++,I=F[0]+r+I),K>0&&(W=F[0]+r),W=_+W),K>0&&(W=W+b+r),W=W+I,K+$<F.length&&(W=W+r+b),s[h]=W}}a&&(s[h]=g)}return s}e.shorten=p;var m;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function y(t,r=Object.create(null)){const s=[];let a=!1,h="";for(const g of t)if(g==="$"||a&&g==="{")h&&s.push({value:h,type:m.TEXT}),h="",a=!0;else if(g==="}"&&a){const _=r[h];if(typeof _=="string")_.length&&s.push({value:_,type:m.VARIABLE});else if(_){const F=s[s.length-1];(!F||F.type!==m.SEPARATOR)&&s.push({value:_.label,type:m.SEPARATOR})}h="",a=!1}else h+=g;return h&&!a&&s.push({value:h,type:m.TEXT}),s.filter((g,_)=>{if(g.type===m.SEPARATOR){const F=s[_-1],$=s[_+1];return[F,$].every(K=>K&&(K.type===m.VARIABLE||K.type===m.TEXT)&&K.value.length>0)}return!0}).map(g=>g.value).join("")}e.template=y;function c(t,r){return C.isMacintosh||r?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):t.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function o(t,r){return C.isMacintosh||r?t.replace(/\(&&\w\)|&&/g,""):C.isWindows?t.replace(/&&|&/g,s=>s==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=o;function l(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=l;function i(t){const r=t.indexOf("/")!==-1?w.posix:w.win32,s=r.basename(t),a=r.dirname(t);return s.length?{name:s,parentPath:a}:{name:a,parentPath:""}}e.splitName=i}),define(ve[61],we([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(A){return A.toJSON()}class w{constructor(R){this._uriTransformer=R}transformIncoming(R){const E=this._uriTransformer.transformIncoming(R);return E===R?R:n(k.URI.from(E))}transformOutgoing(R){const E=this._uriTransformer.transformOutgoing(R);return E===R?R:n(k.URI.from(E))}transformOutgoingURI(R){const E=this._uriTransformer.transformOutgoing(R);return E===R?R:k.URI.from(E)}transformOutgoingScheme(R){return this._uriTransformer.transformOutgoingScheme(R)}}e.URITransformer=w,e.DefaultURITransformer=new class{transformIncoming(A){return A}transformOutgoing(A){return A}transformOutgoingURI(A){return A}transformOutgoingScheme(A){return A}};function C(A,R,E){if(!A||E>200)return null;if(typeof A=="object"){if(A instanceof k.URI)return R.transformOutgoing(A);for(let S in A)if(Object.hasOwnProperty.call(A,S)){const u=C(A[S],R,E+1);u!==null&&(A[S]=u)}}return null}function T(A,R){const E=C(A,R,0);return E===null?A:E}e.transformOutgoingURIs=T;function D(A,R,E,S){if(!A||S>200)return null;if(typeof A=="object"){if(A.$mid===1)return E?k.URI.revive(R.transformIncoming(A)):R.transformIncoming(A);for(let u in A)if(Object.hasOwnProperty.call(A,u)){const b=D(A[u],R,E,S+1);b!==null&&(A[u]=b)}}return null}function v(A,R){const E=D(A,R,!1,0);return E===null?A:E}e.transformIncomingURIs=v;function P(A,R){const E=D(A,R,!0,0);return E===null?A:E}e.transformAndReviveIncomingURIs=P}),define(ve[23],we([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(v){return k.test(v)}e.isUUID=n;const w=new Uint8Array(16),C=[];for(let v=0;v<256;v++)C.push(v.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(v){for(let P=0;P<v.length;P++)v[P]=Math.floor(Math.random()*256);return v};function D(){T(w),w[6]=w[6]&15|64,w[8]=w[8]&63|128;let v=0,P="";return P+=C[w[v++]],P+=C[w[v++]],P+=C[w[v++]],P+=C[w[v++]],P+="-",P+=C[w[v++]],P+=C[w[v++]],P+="-",P+=C[w[v++]],P+=C[w[v++]],P+="-",P+=C[w[v++]],P+=C[w[v++]],P+="-",P+=C[w[v++]],P+=C[w[v++]],P+=C[w[v++]],P+=C[w[v++]],P+=C[w[v++]],P+=C[w[v++]],P}e.generateUuid=D}),define(ve[129],we([0,1,256]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(C="utf8"){this.stringDecoder=new k.StringDecoder(C),this.remaining=null}write(C){const T=[],D=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(D.length<1)return T;let v=0,P,A=v;for(;A<D.length;)if(P=D.charCodeAt(A),P===13||P===10){if(T.push(D.substring(v,A)),A++,A<D.length){const R=P;P=D.charCodeAt(A),(R===13&&P===10||R===10&&P===13)&&A++}v=A}else A++;return this.remaining=v<D.length?D.substr(v):null,T}end(){return this.remaining}}e.LineDecoder=n}),function(){"use strict";function ee(e,k,n,w){function C(u){return new Promise(b=>n.exists(u,b))}function T(u){return new Promise((b,f)=>{const d=new Date;n.utimes(u,d,d,p=>p?f(p):b())})}function D(u){return new Promise((b,f)=>n.mkdir(u,{recursive:!0},d=>d&&d.code!=="EEXIST"?f(d):b(u)))}function v(u){return new Promise((b,f)=>n.rm(u,{recursive:!0,force:!0,maxRetries:3},d=>d?f(d):b()))}function P(u){return new Promise((b,f)=>n.readFile(u,"utf8",(d,p)=>d?f(d):b(p)))}function A(u,b){return new Promise((f,d)=>n.writeFile(u,b,"utf8",p=>p?d(p):f()))}function R(u){const b=k.join(u,"languagepacks.json");try{return e(b)}catch{}}function E(u,b){try{for(;b;){if(u[b])return b;{const f=b.lastIndexOf("-");if(f>0)b=b.substring(0,f);else return}}}catch(f){console.error("Resolving language pack configuration failed.",f)}}function S(u,b,f,d){if(d==="pseudo")return Promise.resolve({locale:d,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:d,availableLanguages:{}});if(d&&(d==="en"||d==="en-us"))return Promise.resolve({locale:d,availableLanguages:{}});const p=d;w.mark("code/willGenerateNls");const m=function(y){return w.mark("code/didGenerateNls"),Promise.resolve({locale:y,availableLanguages:{}})};try{if(!u)return m(p);const y=R(b);if(!y||(d=E(y,d),!d))return m(p);const c=y[d];let o;return!c||typeof c.hash!="string"||!c.translations||typeof(o=c.translations.vscode)!="string"?m(p):C(o).then(l=>{if(!l)return m(p);const i=c.hash+"."+d,t=k.join(b,"clp",i),r=k.join(t,u),s=k.join(t,"tcf.json"),a=k.join(t,"corrupted.info"),h={locale:p,availableLanguages:{"*":d},_languagePackId:i,_translationsConfigFile:s,_cacheRoot:t,_resolvedLanguagePackCoreLocation:r,_corruptedFile:a};return C(a).then(g=>{let _;return g?_=v(t):_=Promise.resolve(void 0),_.then(()=>C(r).then(F=>F?(T(r).catch(()=>{}),w.mark("code/didGenerateNls"),h):D(r).then(()=>Promise.all([P(f),P(o)])).then($=>{const K=JSON.parse($[0]),I=JSON.parse($[1]).contents,W=Object.keys(K.bundles),M=[];for(const q of W){const Z=K.bundles[q],H=Object.create(null);for(const U of Z){const z=K.keys[U],Q=K.messages[U],ie=I[U];let re;if(ie){re=[];for(let ce=0;ce<z.length;ce++){const de=z[ce],he=typeof de=="string"?de:de.key;let j=ie[he];j===void 0&&(j=Q[ce]),re.push(j)}}else re=Q;H[U]=re}M.push(A(k.join(r,q.replace(/\//g,"!")+".nls.json"),JSON.stringify(H)))}return M.push(A(s,JSON.stringify(c.translations))),Promise.all(M)}).then(()=>(w.mark("code/didGenerateNls"),h)).catch($=>(console.error("Generating translation files failed.",$),m(d)))))})})}catch(y){return console.error("Generating translation files failed.",y),m(d)}}return{getNLSConfiguration:S}}if(typeof define=="function")define(ve[130],we([0,80,29,44]),function(e,k,n,w){return ee(e.__$__nodeRequire,k,n,w)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),k=require("fs"),n=require("../common/performance");module.exports=ee(require,e,k,n)}else throw new Error("Unknown context")}(),define(ve[131],we([0,1,25]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function w(T){const D=T.replace(/\-/g,":").toLowerCase();return!n.has(D)}function C(){const T=(0,k.networkInterfaces)();for(let D in T){const v=T[D];if(v){for(const{mac:P}of v)if(w(P))return P}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=C}),define(ve[81],we([0,1,25,9,31,23,131]),function(ee,e,k,n,w,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(A){return this._virtualMachineOUIs||(this._virtualMachineOUIs=w.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(A)}value(){if(this._value===void 0){let A=0,R=0;const E=(0,k.networkInterfaces)();for(let S in E){const u=E[S];if(u)for(const{mac:b,internal:f}of u)f||(R+=1,this._isVirtualMachineMacAddress(b.toUpperCase())&&(A+=1))}this._value=R>0?A/R:0}return this._value}};let D;async function v(){return D||(D=(async()=>await P()||C.generateUuid())()),D}e.getMachineId=v;async function P(){try{const A=await new Promise((E,S)=>{ee(["crypto"],E,S)}),R=(0,T.getMac)();return A.createHash("sha256").update(R,"utf8").digest("hex")}catch(A){n.onUnexpectedError(A);return}}}),define(ve[19],we([0,1,29,25,132,14,33,75,5,3,20,4]),function(ee,e,k,n,w,C,T,D,v,P,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function S(M,q=E.UNLINK){if((0,T.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return q===E.UNLINK?b(M):u(M)}async function u(M){try{const q=(0,T.randomPath)((0,n.tmpdir)());try{await k.promises.rename(M,q)}catch{return b(M)}b(q).catch(Z=>{})}catch(q){if(q.code!=="ENOENT")throw q}}async function b(M){return(0,w.promisify)(k.rm)(M,{recursive:!0,force:!0,maxRetries:3})}function f(M){if((0,T.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");k.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=f;async function d(M,q){return y(await(q?p(M):(0,w.promisify)(k.readdir)(M)))}async function p(M){try{return await(0,w.promisify)(k.readdir)(M,{withFileTypes:!0})}catch(H){console.warn("[node.js fs] readdir with filetypes failed with error: ",H)}const q=[],Z=await d(M);for(const H of Z){let U=!1,z=!1,Q=!1;try{const ie=await e.Promises.lstat((0,v.join)(M,H));U=ie.isFile(),z=ie.isDirectory(),Q=ie.isSymbolicLink()}catch(ie){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ie)}q.push({name:H,isFile:()=>U,isDirectory:()=>z,isSymbolicLink:()=>Q})}return q}function m(M){return y(k.readdirSync(M))}e.readdirSync=m;function y(M){return M.map(q=>typeof q=="string"?P.isMacintosh?(0,D.normalizeNFC)(q):q:(q.name=P.isMacintosh?(0,D.normalizeNFC)(q.name):q.name,q))}async function c(M){const q=await d(M),Z=[];for(const H of q)await l.existsDirectory((0,v.join)(M,H))&&Z.push(H);return Z}function o(M,q=1e3){return new Promise(Z=>{let H=!1;const U=setInterval(()=>{H||(H=!0,k.access(M,z=>{H=!1,z&&(clearInterval(U),Z(void 0))}))},q)})}e.whenDeleted=o;var l;(function(M){async function q(U){let z;try{if(z=await e.Promises.lstat(U),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await e.Promises.stat(U),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(P.isWindows&&Q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(U)),symbolicLink:{dangling:!1}}}catch(ie){if(ie.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw ie}throw Q}}M.stat=q;async function Z(U){try{const{stat:z,symbolicLink:Q}=await M.stat(U);return z.isFile()&&Q?.dangling!==!0}catch{}return!1}M.existsFile=Z;async function H(U){try{const{stat:z,symbolicLink:Q}=await M.stat(U);return z.isDirectory()&&Q?.dangling!==!0}catch{}return!1}M.existsDirectory=H})(l=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new C.ResourceQueue;function t(M,q,Z){return i.queueFor(R.URI.file(M),A.extUriBiasedIgnorePathCase).queue(()=>{const H=h(Z);return new Promise((U,z)=>s(M,q,H,Q=>Q?z(Q):U()))})}let r=!0;function s(M,q,Z,H){if(!r)return k.writeFile(M,q,{mode:Z.mode,flag:Z.flag},H);k.open(M,Z.flag,Z.mode,(U,z)=>{if(U)return H(U);k.writeFile(z,q,Q=>{if(Q)return k.close(z,()=>H(Q));k.fdatasync(z,ie=>(ie&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ie),r=!1),k.close(z,re=>H(re))))})})}function a(M,q,Z){const H=h(Z);if(!r)return k.writeFileSync(M,q,{mode:H.mode,flag:H.flag});const U=k.openSync(M,H.flag,H.mode);try{k.writeFileSync(U,q);try{k.fdatasyncSync(U)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),r=!1}}finally{k.closeSync(U)}}e.writeFileSync=a;function h(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function g(M,q){if(M!==q)try{await e.Promises.rename(M,q)}catch(Z){if(M.toLowerCase()!==q.toLowerCase()&&Z.code==="EXDEV"||M.endsWith("."))await _(M,q,{preserveSymlinks:!1}),await S(M,E.MOVE);else throw Z}}async function _(M,q,Z){return $(M,q,{root:{source:M,target:q},options:Z,handledSourcePaths:new Set})}const F=511;async function $(M,q,Z){if(Z.handledSourcePaths.has(M))return;Z.handledSourcePaths.add(M);const{stat:H,symbolicLink:U}=await l.stat(M);if(U){if(Z.options.preserveSymlinks)try{return await W(M,q,Z)}catch(z){console.warn("[node.js fs] copy of symlink failed: ",z)}if(U.dangling)return}return H.isDirectory()?K(M,q,H.mode&F,Z):I(M,q,H.mode&F)}async function K(M,q,Z,H){await e.Promises.mkdir(q,{recursive:!0,mode:Z});const U=await d(M);for(const z of U)await $((0,v.join)(M,z),(0,v.join)(q,z),H)}async function I(M,q,Z){await e.Promises.copyFile(M,q),await e.Promises.chmod(q,Z)}async function W(M,q,Z){let H=await e.Promises.readlink(M);(0,T.isEqualOrParent)(H,Z.root.source,!P.isLinux)&&(H=(0,v.join)(Z.root.target,H.substr(Z.root.source.length+1))),await e.Promises.symlink(H,q)}e.Promises=new class{get access(){return(0,w.promisify)(k.access)}get stat(){return(0,w.promisify)(k.stat)}get lstat(){return(0,w.promisify)(k.lstat)}get utimes(){return(0,w.promisify)(k.utimes)}get read(){return(M,q,Z,H,U)=>new Promise((z,Q)=>{k.read(M,q,Z,H,U,(ie,re,ce)=>ie?Q(ie):z({bytesRead:re,buffer:ce}))})}get readFile(){return(0,w.promisify)(k.readFile)}get write(){return(M,q,Z,H,U)=>new Promise((z,Q)=>{k.write(M,q,Z,H,U,(ie,re,ce)=>ie?Q(ie):z({bytesWritten:re,buffer:ce}))})}get appendFile(){return(0,w.promisify)(k.appendFile)}get fdatasync(){return(0,w.promisify)(k.fdatasync)}get truncate(){return(0,w.promisify)(k.truncate)}get rename(){return(0,w.promisify)(k.rename)}get copyFile(){return(0,w.promisify)(k.copyFile)}get open(){return(0,w.promisify)(k.open)}get close(){return(0,w.promisify)(k.close)}get symlink(){return(0,w.promisify)(k.symlink)}get readlink(){return(0,w.promisify)(k.readlink)}get chmod(){return(0,w.promisify)(k.chmod)}get mkdir(){return(0,w.promisify)(k.mkdir)}get unlink(){return(0,w.promisify)(k.unlink)}get rmdir(){return(0,w.promisify)(k.rmdir)}get realpath(){return(0,w.promisify)(k.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return c}get writeFile(){return t}get rm(){return S}get move(){return g}get copy(){return _}}}),define(ve[133],we([0,1,29,5,3,15,19]),function(ee,e,k,n,w,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function D(E){if(w.isLinux)return E;const S=(0,n.dirname)(E);if(E===S)return E;const u=((0,n.basename)(E)||E).toLowerCase();try{const f=(0,T.readdirSync)(S).filter(d=>d.toLowerCase()===u);if(f.length===1){const d=D(S);if(d)return(0,n.join)(d,f[0])}else if(f.length>1){const d=f.indexOf(u);if(d>=0){const p=D(S);if(p)return(0,n.join)(p,f[d])}}}catch{}return null}e.realcaseSync=D;async function v(E){if(w.isLinux)return E;const S=(0,n.dirname)(E);if(E===S)return E;const u=((0,n.basename)(E)||E).toLowerCase();try{const f=(await T.Promises.readdir(S)).filter(d=>d.toLowerCase()===u);if(f.length===1){const d=await v(S);if(d)return(0,n.join)(d,f[0])}else if(f.length>1){const d=f.indexOf(u);if(d>=0){const p=await v(S);if(p)return(0,n.join)(p,f[d])}}}catch{}return null}e.realcase=v;async function P(E){try{return await T.Promises.realpath(E)}catch{const u=R(E);return await T.Promises.access(u,k.constants.R_OK),u}}e.realpath=P;function A(E){try{return k.realpathSync(E)}catch{const u=R(E);return k.accessSync(u,k.constants.R_OK),u}}e.realpathSync=A;function R(E){return(0,C.rtrim)((0,n.normalize)(E),n.sep)}}),define(ve[134],we([0,1,82]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(D,v,P,A=1){let R=!1;return new Promise(E=>{const S=setTimeout(()=>{if(!R)return R=!0,E(0)},P);w(D,v,A,u=>{if(!R)return R=!0,clearTimeout(S),E(u)})})}e.findFreePort=n;function w(D,v,P,A){if(v===0)return A(0);const R=new k.Socket;R.once("connect",()=>(T(R),w(D+P,v-1,P,A))),R.once("data",()=>{}),R.once("error",E=>(T(R),E.code!=="ECONNREFUSED"?w(D+P,v-1,P,A):A(D))),R.connect(D,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function C(D,v,P){let A=!1,R,E=1;const S=k.createServer({pauseOnConnect:!0});function u(b,f){A||(A=!0,S.removeAllListeners(),S.close(),R&&clearTimeout(R),f(b))}return new Promise(b=>{R=setTimeout(()=>{u(0,b)},P),S.on("listening",()=>{u(D,b)}),S.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&E<v?(D++,E++,S.listen(D,"127.0.0.1")):u(0,b)}),S.on("close",()=>{u(0,b)}),S.listen(D,"127.0.0.1")})}e.findFreePortFaster=C;function T(D){try{D.removeAllListeners("connect"),D.removeAllListeners("error"),D.end(),D.destroy(),D.unref()}catch(v){console.error(v)}}}),define(ve[83],we([0,1,25,5,19]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,T=/^Microsoft.PowerShell_.*/,D=/^Microsoft.PowerShellPreview_.*/;var v;(function(y){y[y.x64=0]="x64",y[y.x86=1]="x86",y[y.ARM=2]="ARM"})(v||(v={}));let P;switch(process.arch){case"ia32":case"x32":P=1;break;case"arm":case"arm64":P=2;break;default:P=0;break}let A;process.env.PROCESSOR_ARCHITEW6432?A=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?A=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?A=1:A=0;class R{constructor(c,o,l){this.exePath=c,this.displayName=o,this.knownToExist=l}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await w.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function E({useAlternateBitness:y=!1}={}){return y?P===0?process.env["ProgramFiles(x86)"]||null:A===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:y=!1,findPreview:c=!1}={}){const o=E({useAlternateBitness:y});if(!o)return null;const l=n.join(o,"PowerShell");if(!await w.SymlinkSupport.existsDirectory(l))return null;let i=-1,t=null;for(const a of await w.Promises.readdir(l)){let h=-1;if(c){const _=a.indexOf("-");if(_<0)continue;const F=a.substring(0,_);if(!C.test(F)||a.substring(_+1)!=="preview")continue;h=parseInt(F,10)}else{if(!C.test(a))continue;h=parseInt(a,10)}if(h<=i)continue;const g=n.join(l,a,"pwsh.exe");!await w.SymlinkSupport.existsFile(g)||(t=g,i=h)}if(!t)return null;const r=o.includes("x86")?" (x86)":"",s=c?" Preview":"";return new R(t,`PowerShell${s}${r}`,!0)}async function u({findPreview:y}={}){if(!process.env.LOCALAPPDATA)return null;const c=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await w.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:o,pwshMsixName:l}=y?{pwshMsixDirRegex:D,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const i of await w.Promises.readdir(c))if(o.test(i)){const t=n.join(c,i,"pwsh.exe");return new R(t,l)}return null}function b(){const y=n.join(k.homedir(),".dotnet","tools","pwsh.exe");return new R(y,".NET Core PowerShell Global Tool")}function f(){const y=n.join(process.env.windir,P===1&&A!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new R(y,"Windows PowerShell",!0)}async function*d(){let y=await S();y&&(yield y),y=await S({useAlternateBitness:!0}),y&&(yield y),y=await u(),y&&(yield y),y=b(),y&&(yield y),y=await S({findPreview:!0}),y&&(yield y),y=await u({findPreview:!0}),y&&(yield y),y=await S({useAlternateBitness:!0,findPreview:!0}),y&&(yield y),y=f(),y&&(yield y)}async function*p(){for await(const y of d())await y.exists()&&(yield y)}e.enumeratePowerShellInstallations=p;async function m(){for await(const y of p())return y;return null}e.getFirstAvailablePowerShellInstallation=m}),define(ve[84],we([0,1,38,8]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function w(T){return new Promise((D,v)=>{let P;const A=new Map;function R(S,u,b,f,d){const p=A.get(u);if(S===T||p){const m={name:E(b),cmd:b,pid:S,ppid:u,load:f,mem:d};A.set(S,m),S===T&&(P=m),p&&(p.children||(p.children=[]),p.children.push(m),p.children.length>1&&(p.children=p.children.sort((y,c)=>y.pid-c.pid)))}}function E(S){const u=/--vscode-window-kind=shared-process/,b=/--vscode-window-kind=issue-reporter/,f=/--vscode-window-kind=process-explorer/,d=/--utility-sub-type=network/,p=/--crashes-directory/,m=/\\pipe\\winpty-control/,y=/conhost\.exe/,c=/--type=([a-zA-Z-]+)/;if(p.exec(S))return"electron-crash-reporter";if(m.exec(S))return"winpty-process";if(y.exec(S))return"console-window-host (Windows internal process)";let o=c.exec(S);if(o&&o.length===2)return o[1]==="renderer"?u.exec(S)?"shared-process":b.exec(S)?"issue-reporter":f.exec(S)?"process-explorer":"window":o[1]==="utility"&&d.exec(S)?"utility-network-service":o[1];const l=/[a-zA-Z-]+\.js/g;let i="";do o=l.exec(S),o&&(i+=o+" ");while(o);return i&&S.indexOf("node ")<0&&S.indexOf("node.exe")<0?`electron_node ${i}`:S}if(process.platform==="win32"){const S=u=>u.indexOf("\\\\?\\")===0||u.indexOf("\\??\\")===0?u.substr(4):u.indexOf('"\\\\?\\')===0||u.indexOf('"\\??\\')===0?'"'+u.substr(5):u;new Promise((u,b)=>{ee(["windows-process-tree"],u,b)}).then(u=>{u.getProcessList(T,b=>{u.getProcessCpuUsage(b,f=>{const d=new Map;f.forEach(p=>{const m=S(p.commandLine||"");d.set(p.pid,{name:E(m),cmd:m,pid:p.pid,ppid:p.ppid,load:p.cpu||0,mem:p.memory||0})}),P=d.get(T),P?(d.forEach(p=>{const m=d.get(p.ppid);m&&(m.children||(m.children=[]),m.children.push(p))}),d.forEach(p=>{p.children&&(p.children=p.children.sort((m,y)=>m.pid-y.pid))}),D(P)):v(new Error(`Root process ${T} not found`))})},u.ProcessDataFlag.CommandLine|u.ProcessDataFlag.Memory)})}else{let S=function(){let u=[P];const b=[];for(;u.length;){const d=u.shift();d&&(b.push(d.pid),d.children&&(u=u.concat(d.children)))}let f=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",ee).fsPath);f+=" "+b.join(" "),(0,k.exec)(f,{},(d,p,m)=>{if(d||m)v(d||new Error(m.toString()));else{const y=p.toString().split(`
`);for(let c=0;c<b.length;c++){const o=A.get(b[c]);o.load=parseFloat(y[c])}if(!P){v(new Error(`Root process ${T} not found`));return}D(P)}})};(0,k.exec)("which ps",{},(u,b,f)=>{if(u||f)if(process.platform!=="linux")v(u||new Error(f.toString()));else{const d=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",ee).fsPath);(0,k.exec)(d,{},(p,m,y)=>{p||y?v(p||new Error(y.toString())):(C(m,R),S())})}else{const d=b.toString().trim(),p="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,k.exec)(`${d} ${p}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,y,c)=>{m||c&&!c.includes("screen size is bogus")?v(m||new Error(c.toString())):(C(y,R),process.platform==="linux"?S():P?D(P):v(new Error(`Root process ${T} not found`)))})}})}})}e.listProcesses=w;function C(T,D){const v=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,P=T.toString().split(`
`);for(const A of P){const R=v.exec(A.trim());R&&R.length===6&&D(parseInt(R[1]),parseInt(R[2]),R[5],parseFloat(R[3]),parseFloat(R[4]))}}});var Ae=this&&this.__decorate||function(ee,e,k,n){var w=arguments.length,C=w<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,k):n,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(ee,e,k,n);else for(var D=ee.length-1;D>=0;D--)(T=ee[D])&&(C=(w<3?T(C):w>3?T(e,k,C):T(e,k))||C);return w>3&&C&&Object.defineProperty(e,k,C),C};define(ve[39],we([0,1,18,14,16,21,72,9,7,2,50,15,12]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var S;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(S=e.RequestType||(e.RequestType={}));function u(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(b=e.ResponseType||(e.ResponseType={}));function f(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(d||(d={}));class p{constructor(Q){this.buffer=Q,this.pos=0}read(Q){const ie=this.buffer.slice(this.pos,this.pos+Q);return this.pos+=ie.byteLength,ie}}class m{constructor(){this.buffers=[]}get buffer(){return w.VSBuffer.concat(this.buffers)}write(Q){this.buffers.push(Q)}}var y;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object"})(y||(y={}));function c(z){const Q=w.VSBuffer.alloc(4);return Q.writeUInt32BE(z,0),Q}function o(z){return z.read(4).readUInt32BE(0)}function l(z){const Q=w.VSBuffer.alloc(1);return Q.writeUInt8(z,0),Q}const i={Undefined:l(y.Undefined),String:l(y.String),Buffer:l(y.Buffer),VSBuffer:l(y.VSBuffer),Array:l(y.Array),Object:l(y.Object)},t=typeof Buffer!="undefined";function r(z,Q){if(typeof Q=="undefined")z.write(i.Undefined);else if(typeof Q=="string"){const ie=w.VSBuffer.fromString(Q);z.write(i.String),z.write(c(ie.byteLength)),z.write(ie)}else if(t&&Buffer.isBuffer(Q)){const ie=w.VSBuffer.wrap(Q);z.write(i.Buffer),z.write(c(ie.byteLength)),z.write(ie)}else if(Q instanceof w.VSBuffer)z.write(i.VSBuffer),z.write(c(Q.byteLength)),z.write(Q);else if(Array.isArray(Q)){z.write(i.Array),z.write(c(Q.length));for(const ie of Q)r(z,ie)}else{const ie=w.VSBuffer.fromString(JSON.stringify(Q));z.write(i.Object),z.write(c(ie.byteLength)),z.write(ie)}}function s(z){switch(z.read(1).readUInt8(0)){case y.Undefined:return;case y.String:return z.read(o(z)).toString();case y.Buffer:return z.read(o(z)).buffer;case y.VSBuffer:return z.read(o(z));case y.Array:{const ie=o(z),re=[];for(let ce=0;ce<ie;ce++)re.push(s(z));return re}case y.Object:return JSON.parse(z.read(o(z)).toString())}}class a{constructor(Q,ie,re=null,ce=1e3){this.protocol=Q,this.ctx=ie,this.logger=re,this.timeoutDelay=ce,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(de=>this.onRawMessage(de)),this.sendResponse({type:200})}registerChannel(Q,ie){this.channels.set(Q,ie),setTimeout(()=>this.flushPendingRequests(Q),0)}sendResponse(Q){switch(Q.type){case 200:{const ie=this.send([Q.type]);this.logger?.logOutgoing(ie,0,1,f(Q.type));return}case 201:case 202:case 204:case 203:{const ie=this.send([Q.type,Q.id],Q.data);this.logger?.logOutgoing(ie,Q.id,1,f(Q.type),Q.data);return}}}send(Q,ie=void 0){const re=new m;return r(re,Q),r(re,ie),this.sendBuffer(re.buffer)}sendBuffer(Q){try{return this.protocol.send(Q),Q.byteLength}catch{return 0}}onRawMessage(Q){const ie=new p(Q),re=s(ie),ce=s(ie),de=re[0];switch(de){case 100:return this.logger?.logIncoming(Q.byteLength,re[1],1,`${u(de)}: ${re[2]}.${re[3]}`,ce),this.onPromise({type:de,id:re[1],channelName:re[2],name:re[3],arg:ce});case 102:return this.logger?.logIncoming(Q.byteLength,re[1],1,`${u(de)}: ${re[2]}.${re[3]}`,ce),this.onEventListen({type:de,id:re[1],channelName:re[2],name:re[3],arg:ce});case 101:return this.logger?.logIncoming(Q.byteLength,re[1],1,`${u(de)}`),this.disposeActiveRequest({type:de,id:re[1]});case 103:return this.logger?.logIncoming(Q.byteLength,re[1],1,`${u(de)}`),this.disposeActiveRequest({type:de,id:re[1]})}}onPromise(Q){const ie=this.channels.get(Q.channelName);if(!ie){this.collectPendingRequest(Q);return}const re=new C.CancellationTokenSource;let ce;try{ce=ie.call(this.ctx,Q.name,Q.arg,re.token)}catch(j){ce=Promise.reject(j)}const de=Q.id;ce.then(j=>{this.sendResponse({id:de,data:j,type:201}),this.activeRequests.delete(Q.id)},j=>{j instanceof Error?this.sendResponse({id:de,data:{message:j.message,name:j.name,stack:j.stack?j.stack.split?j.stack.split(`
`):j.stack:void 0},type:202}):this.sendResponse({id:de,data:j,type:203}),this.activeRequests.delete(Q.id)});const he=(0,P.toDisposable)(()=>re.cancel());this.activeRequests.set(Q.id,he)}onEventListen(Q){const ie=this.channels.get(Q.channelName);if(!ie){this.collectPendingRequest(Q);return}const re=Q.id,de=ie.listen(this.ctx,Q.name,Q.arg)(he=>this.sendResponse({id:re,data:he,type:204}));this.activeRequests.set(Q.id,de)}disposeActiveRequest(Q){const ie=this.activeRequests.get(Q.id);ie&&(ie.dispose(),this.activeRequests.delete(Q.id))}collectPendingRequest(Q){let ie=this.pendingRequests.get(Q.channelName);ie||(ie=[],this.pendingRequests.set(Q.channelName,ie));const re=setTimeout(()=>{console.error(`Unknown channel: ${Q.channelName}`),Q.type===100&&this.sendResponse({id:Q.id,data:{name:"Unknown channel",message:`Channel name '${Q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);ie.push({request:Q,timeoutTimer:re})}flushPendingRequests(Q){const ie=this.pendingRequests.get(Q);if(ie){for(const re of ie)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.onPromise(re.request);break;case 102:this.onEventListen(re.request);break}this.pendingRequests.delete(Q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,P.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var h;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class g{constructor(Q,ie=null){this.protocol=Q,this.isDisposed=!1,this.state=d.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(re=>this.onBuffer(re)),this.logger=ie}getChannel(Q){const ie=this;return{call(re,ce,de){return ie.isDisposed?Promise.reject(D.canceled()):ie.requestPromise(Q,re,ce,de)},listen(re,ce){return ie.isDisposed?v.Event.None:ie.requestEvent(Q,re,ce)}}}requestPromise(Q,ie,re,ce=C.CancellationToken.None){const de=this.lastRequestId++,j={id:de,type:100,channelName:Q,name:ie,arg:re};if(ce.isCancellationRequested)return Promise.reject(D.canceled());let O;return new Promise((J,le)=>{if(ce.isCancellationRequested)return le(D.canceled());const ge=()=>{const X=B=>{switch(B.type){case 201:this.handlers.delete(de),J(B.data);break;case 202:{this.handlers.delete(de);const x=new Error(B.data.message);x.stack=B.data.stack,x.name=B.data.name,le(x);break}case 203:this.handlers.delete(de),le(B.data);break}};this.handlers.set(de,X),this.sendRequest(j)};let ue=null;this.state===d.Idle?ge():(ue=(0,n.createCancelablePromise)(X=>this.whenInitialized()),ue.then(()=>{ue=null,ge()}));const oe=()=>{ue?(ue.cancel(),ue=null):this.sendRequest({id:de,type:101}),le(D.canceled())},pe=ce.onCancellationRequested(oe);O=(0,P.combinedDisposable)((0,P.toDisposable)(oe),pe),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(Q,ie,re){const ce=this.lastRequestId++,he={id:ce,type:102,channelName:Q,name:ie,arg:re};let j=null;const O=new v.Emitter({onFirstListenerAdd:()=>{j=(0,n.createCancelablePromise)(J=>this.whenInitialized()),j.then(()=>{j=null,this.activeRequests.add(O),this.sendRequest(he)})},onLastListenerRemove:()=>{j?(j.cancel(),j=null):(this.activeRequests.delete(O),this.sendRequest({id:ce,type:103}))}}),V=J=>O.fire(J.data);return this.handlers.set(ce,V),O.event}sendRequest(Q){switch(Q.type){case 100:case 102:{const ie=this.send([Q.type,Q.id,Q.channelName,Q.name],Q.arg);this.logger&&this.logger.logOutgoing(ie,Q.id,0,`${u(Q.type)}: ${Q.channelName}.${Q.name}`,Q.arg);return}case 101:case 103:{const ie=this.send([Q.type,Q.id]);this.logger&&this.logger.logOutgoing(ie,Q.id,0,u(Q.type));return}}}send(Q,ie=void 0){const re=new m;return r(re,Q),r(re,ie),this.sendBuffer(re.buffer)}sendBuffer(Q){try{return this.protocol.send(Q),Q.byteLength}catch{return 0}}onBuffer(Q){const ie=new p(Q),re=s(ie),ce=s(ie),de=re[0];switch(de){case 200:return this.logger&&this.logger.logIncoming(Q.byteLength,0,0,f(de)),this.onResponse({type:re[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(Q.byteLength,re[1],0,f(de),ce),this.onResponse({type:re[0],id:re[1],data:ce})}}onResponse(Q){if(Q.type===200){this.state=d.Idle,this._onDidInitialize.fire();return}const ie=this.handlers.get(Q.id);ie&&ie(Q)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,P.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Ae([T.memoize],g.prototype,"onDidInitializePromise",null),e.ChannelClient=g;class _{constructor(Q){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,Q(({protocol:ie,onDidClientDisconnect:re})=>{v.Event.once(ie.onMessage)(de=>{const he=new p(de),j=s(he),O=new a(ie,j),V=new g(ie);this.channels.forEach((le,ge)=>O.registerChannel(ge,le));const J={channelServer:O,channelClient:V,ctx:j};this._connections.add(J),this._onDidAddConnection.fire(J),re(()=>{O.dispose(),V.dispose(),this._connections.delete(J),this._onDidRemoveConnection.fire(J)})})})}get connections(){const Q=[];return this._connections.forEach(ie=>Q.push(ie)),Q}getChannel(Q,ie){const re=this;return{call(ce,de,he){let j;if((0,E.isFunction)(ie)){let V=(0,k.getRandomElement)(re.connections.filter(ie));j=V?Promise.resolve(V):v.Event.toPromise(v.Event.filter(re.onDidAddConnection,ie))}else j=ie.routeCall(re,ce,de);const O=j.then(V=>V.channelClient.getChannel(Q));return $(O).call(ce,de,he)},listen(ce,de){if((0,E.isFunction)(ie))return re.getMulticastEvent(Q,ie,ce,de);const he=ie.routeEvent(re,ce,de).then(j=>j.channelClient.getChannel(Q));return $(he).listen(ce,de)}}}getMulticastEvent(Q,ie,re,ce){const de=this;let he=new P.DisposableStore;const j=new v.Emitter({onFirstListenerAdd:()=>{he=new P.DisposableStore;const O=new v.EventMultiplexer,V=new Map,J=ge=>{const oe=ge.channelClient.getChannel(Q).listen(re,ce),pe=O.add(oe);V.set(ge,pe)},le=ge=>{const ue=V.get(ge);!ue||(ue.dispose(),V.delete(ge))};de.connections.filter(ie).forEach(J),v.Event.filter(de.onDidAddConnection,ie)(J,void 0,he),de.onDidRemoveConnection(le,void 0,he),O.event(j.fire,j,he),he.add(O)},onLastListenerRemove:()=>{he.dispose()}});return j.event}registerChannel(Q,ie){this.channels.set(Q,ie),this._connections.forEach(re=>{re.channelServer.registerChannel(Q,ie)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=_;class F{constructor(Q,ie,re=null){const ce=new m;r(ce,ie),Q.send(ce.buffer),this.channelClient=new g(Q,re),this.channelServer=new a(Q,ie,re)}getChannel(Q){return this.channelClient.getChannel(Q)}registerChannel(Q,ie){this.channelServer.registerChannel(Q,ie)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=F;function $(z){return{call(Q,ie,re){return z.then(ce=>ce.call(Q,ie,re))},listen(Q,ie){const re=new v.Relay;return z.then(ce=>re.input=ce.listen(Q,ie)),re.event}}}e.getDelayedChannel=$;function K(z){let Q=!1;return{call(ie,re,ce){return Q?z.call(ie,re,ce):(0,n.timeout)(0).then(()=>Q=!0).then(()=>z.call(ie,re,ce))},listen(ie,re){if(Q)return z.listen(ie,re);const ce=new v.Relay;return(0,n.timeout)(0).then(()=>Q=!0).then(()=>ce.input=z.listen(ie,re)),ce.event}}}e.getNextTickChannel=K;class I{constructor(Q){this.fn=Q}routeCall(Q){return this.route(Q)}routeEvent(Q){return this.route(Q)}async route(Q){for(const ie of Q.connections)if(await Promise.resolve(this.fn(ie.ctx)))return Promise.resolve(ie);return await v.Event.toPromise(Q.onDidAddConnection),await this.route(Q)}}e.StaticRouter=I;var W;(function(z){function Q(de,he){const j=de,O=he&&he.disableMarshalling,V=new Map;for(const J in j)re(J)&&V.set(J,v.Event.buffer(j[J],!0));return new class{listen(J,le,ge){const ue=V.get(le);if(ue)return ue;if(ce(le)){const oe=j[le];if(typeof oe=="function")return oe.call(j,ge)}throw new Error(`Event not found: ${le}`)}call(J,le,ge){const ue=j[le];if(typeof ue=="function"){if(!O&&Array.isArray(ge))for(let oe=0;oe<ge.length;oe++)ge[oe]=(0,A.revive)(ge[oe]);return ue.apply(j,ge)}throw new Error(`Method not found: ${le}`)}}}z.fromService=Q;function ie(de,he){const j=he&&he.disableMarshalling;return new Proxy({},{get(O,V){if(typeof V=="string")return he?.properties?.has(V)?he.properties.get(V):ce(V)?function(J){return de.listen(V,J)}:re(V)?de.listen(V):async function(...J){let le;he&&!(0,E.isUndefinedOrNull)(he.context)?le=[he.context,...J]:le=J;const ge=await de.call(V,le);return j?ge:(0,A.revive)(ge)};throw new Error(`Property not found: ${String(V)}`)}})}z.toService=ie;function re(de){return de[0]==="o"&&de[1]==="n"&&R.isUpperAsciiLetter(de.charCodeAt(2))}function ce(de){return/^onDynamic/.test(de)&&R.isUpperAsciiLetter(de.charCodeAt(9))}})(W=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function q(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){let Q=z.toString();if(Q!=="[object Object]")return Q}return z}function Z(z){return Array.isArray(z)?z.map(q):q(z)}function H(z,Q,ie,re,ce,de,he){he=Z(he);const j=M[ce],O=j[re%j.length];let V=[`%c[${z}]%c[${String(Q).padStart(7," ")}]%c[len: ${String(ie).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${de}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(de)?(V=V.concat(he),V.push(")")):V.push(he),console.log.apply(console,V)}e.logWithColors=H;class U{constructor(Q,ie){this._outgoingPrefix=Q,this._incomingPrefix=ie,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(Q,ie,re,ce,de){this._totalOutgoing+=Q,H(this._outgoingPrefix,this._totalOutgoing,Q,ie,re,ce,de)}logIncoming(Q,ie,re,ce,de){this._totalIncoming+=Q,H(this._incomingPrefix,this._totalIncoming,Q,ie,re,ce,de)}}e.IPCLogger=U}),define(ve[85],we([0,1,16,7,2,39]),function(ee,e,k,n,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(T=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var D;(function(t){t.enableDiagnostics=!1,t.records=[];const r=new WeakMap;let s=0;function a(g,_){if(!r.has(g)){const F=String(++s);r.set(g,F)}return r.get(g)}function h(g,_,F,$){if(!t.enableDiagnostics)return;const K=a(g,_);if($ instanceof k.VSBuffer||$ instanceof Uint8Array||$ instanceof ArrayBuffer||ArrayBuffer.isView($)){const I=k.VSBuffer.alloc($.byteLength);I.set($),t.records.push({timestamp:Date.now(),id:K,label:_,type:F,buff:I})}else t.records.push({timestamp:Date.now(),id:K,label:_,type:F,data:$})}t.traceSocketEvent=h})(D=e.SocketDiagnostics||(e.SocketDiagnostics={}));var v;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(v=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function A(){return P||(P=k.VSBuffer.alloc(0)),P}class R{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,s){if(r===0)return A();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const _=this._chunks[0];return s&&(this._chunks.shift(),this._totalLength-=r),_}if(this._chunks[0].byteLength>r){const _=this._chunks[0].slice(0,r);return s&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),_}let a=k.VSBuffer.alloc(r),h=0,g=0;for(;r>0;){const _=this._chunks[g];if(_.byteLength>r){const F=_.slice(0,r);a.set(F,h),h+=r,s&&(this._chunks[g]=_.slice(r),this._totalLength-=r),r-=r}else a.set(_,h),h+=_.byteLength,s?(this._chunks.shift(),this._totalLength-=_.byteLength):g++,r-=_.byteLength}return a}}e.ChunkStream=R;var E;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(E||(E={}));function S(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var u;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(u=e.ProtocolConstants||(e.ProtocolConstants={}));class b{constructor(r,s,a,h){this.type=r,this.id=s,this.ack=a,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends w.Disposable{constructor(r){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new R,this._register(this._socket.onData(s=>this.acceptChunk(s))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const s=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=s.readUInt32BE(9),this._state.messageType=s.readUInt8(0),this._state.id=s.readUInt32BE(1),this._state.ack=s.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:S(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,h=this._state.id,g=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",s),this._onMessage.fire(new b(a,h,g,s)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class d{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const s=k.VSBuffer.alloc(13);s.writeUInt8(r.type,0),s.writeUInt32BE(r.id,1),s.writeUInt32BE(r.ack,5),s.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:S(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(s,r.data)}_bufferAdd(r,s){const a=this._totalLength===0;return this._data.push(r,s),this._totalLength+=r.byteLength+s.byteLength,a}_bufferTake(){const r=k.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,s){this._bufferAdd(r,s)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class p extends w.Disposable{constructor(r){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new d(this._socket)),this._socketReader=this._register(new f(this._socket)),this._register(this._socketReader.onMessage(s=>{s.type===1&&this._onMessage.fire(s.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new b(1,0,0,r))}}e.Protocol=p;class m extends C.IPCClient{constructor(r,s,a=null){super(r,s,a);this.protocol=r}static fromSocket(r,s){return new m(new p(r),s)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=m;class y{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=y;class c{constructor(r){this.data=r,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],s=0,a=this._first;for(;a;)r[s++]=a.data,a=a.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const s=new c(r);if(!this._first){this._first=s,this._last=s;return}this._last.next=s,this._last=s}}class l{constructor(){this.lastRuns=[];const r=Date.now();for(let s=0;s<l._HISTORY_LENGTH;s++)this.lastRuns[s]=r-1e3*s;setInterval(()=>{for(let s=l._HISTORY_LENGTH;s>=1;s--)this.lastRuns[s]=this.lastRuns[s-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return l._INSTANCE||(l._INSTANCE=new l),l._INSTANCE}load(){const r=Date.now(),s=(1+l._HISTORY_LENGTH)*1e3;let a=0;for(let h=0;h<l._HISTORY_LENGTH;h++)r-this.lastRuns[h]<=s&&a++;return 1-a/l._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}l._HISTORY_LENGTH=10,l._INSTANCE=null;class i{constructor(r,s=null,a=l.getInstance()){this._onControlMessage=new y,this.onControlMessage=this._onControlMessage.event,this._onMessage=new y,this.onMessage=this._onMessage.event,this._onDidDispose=new y,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new y,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new y,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),s&&this._socketReader.acceptChunk(s)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,w.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new b(5,0,0,A());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new b(7,0,0,A());this._socketWriter.write(r)}sendResume(){const r=new b(8,0,0,A());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,s){this._isReconnecting=!0,this._socketDisposables=(0,w.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(s)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new b(3,0,this._incomingAckId,A());this._socketWriter.write(r);const s=this._outgoingUnackMsg.toArray();for(let a=0,h=s.length;a<h;a++)this._socketWriter.write(s[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const s=this._outgoingUnackMsg.peek();if(s&&s.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const s=Date.now();s-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=s,this._socketWriter.write(new b(6,0,0,A())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const s=this._outgoingUnackMsg.toArray();for(let a=0,h=s.length;a<h;a++)this._socketWriter.write(s[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const s=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new b(1,s,this._incomingAckId,r);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(r){const s=new b(2,0,0,r);this._socketWriter.write(s)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),s=Date.now()-r.writtenTime,a=Date.now()-this._socketReader.lastReadTime,h=Date.now()-this._lastSocketTimeoutTime;if(s>=2e4&&a>=2e4&&h>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const g=Math.max(2e4-s,2e4-a,2e4-h,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},g)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new b(3,0,this._incomingAckId,A());this._socketWriter.write(r)}}e.PersistentProtocol=i}),define(ve[135],we([0,1,14,7,2,12]),function(ee,e,k,n,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var T;(function(R){R[R.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=e.StorageHint||(e.StorageHint={}));function D(R){const E=R;return E?.changed instanceof Map||E?.deleted instanceof Set}e.isStorageItemsChangeEvent=D;var v;(function(R){R[R.None=0]="None",R[R.Initialized=1]="Initialized",R[R.Closed=2]="Closed"})(v=e.StorageState||(e.StorageState={}));class P extends w.Disposable{constructor(E,S=Object.create(null)){super();this.database=E,this.options=S,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=v.None,this.cache=new Map,this.flushDelayer=new k.ThrottledDelayer(P.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(E=>this.onDidChangeItemsExternal(E)))}onDidChangeItemsExternal(E){E.changed?.forEach((S,u)=>this.accept(u,S)),E.deleted?.forEach(S=>this.accept(S,void 0))}accept(E,S){if(this.state===v.Closed)return;let u=!1;(0,C.isUndefinedOrNull)(S)?u=this.cache.delete(E):this.cache.get(E)!==S&&(this.cache.set(E,S),u=!0),u&&this._onDidChangeStorage.fire(E)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===v.None&&(this.state=v.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(E,S){const u=this.cache.get(E);return(0,C.isUndefinedOrNull)(u)?S:u}getBoolean(E,S){const u=this.get(E);return(0,C.isUndefinedOrNull)(u)?S:u==="true"}getNumber(E,S){const u=this.get(E);return(0,C.isUndefinedOrNull)(u)?S:parseInt(u,10)}async set(E,S){if(this.state===v.Closed)return;if((0,C.isUndefinedOrNull)(S))return this.delete(E);const u=String(S);if(this.cache.get(E)!==u)return this.cache.set(E,u),this.pendingInserts.set(E,u),this.pendingDeletes.delete(E),this._onDidChangeStorage.fire(E),this.doFlush()}async delete(E){if(!(this.state===v.Closed||!this.cache.delete(E)))return this.pendingDeletes.has(E)||this.pendingDeletes.add(E),this.pendingInserts.delete(E),this._onDidChangeStorage.fire(E),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=v.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const E={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(E).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(E){if(!!this.hasPending)return this.doFlush(E)}async doFlush(E){return this.flushDelayer.trigger(()=>this.flushPending(),E)}async whenFlushed(){if(!!this.hasPending)return new Promise(E=>this.whenFlushedCallbacks.push(E))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=P,P.DEFAULT_FLUSH_DELAY=100;class A{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(E){E.insert&&E.insert.forEach((S,u)=>this.items.set(u,S)),E.delete&&E.delete.forEach(S=>this.items.delete(S))}async close(){}}e.InMemoryStorageDatabase=A}),define(ve[86],we([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class k{constructor(w,C){this.lineNumber=w,this.column=C}with(w=this.lineNumber,C=this.column){return w===this.lineNumber&&C===this.column?this:new k(w,C)}delta(w=0,C=0){return this.with(this.lineNumber+w,this.column+C)}equals(w){return k.equals(this,w)}static equals(w,C){return!w&&!C?!0:!!w&&!!C&&w.lineNumber===C.lineNumber&&w.column===C.column}isBefore(w){return k.isBefore(this,w)}static isBefore(w,C){return w.lineNumber<C.lineNumber?!0:C.lineNumber<w.lineNumber?!1:w.column<C.column}isBeforeOrEqual(w){return k.isBeforeOrEqual(this,w)}static isBeforeOrEqual(w,C){return w.lineNumber<C.lineNumber?!0:C.lineNumber<w.lineNumber?!1:w.column<=C.column}static compare(w,C){const T=w.lineNumber|0,D=C.lineNumber|0;if(T===D){const v=w.column|0,P=C.column|0;return v-P}return T-D}clone(){return new k(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(w){return new k(w.lineNumber,w.column)}static isIPosition(w){return w&&typeof w.lineNumber=="number"&&typeof w.column=="number"}}e.Position=k}),define(ve[51],we([0,1,86]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class n{constructor(C,T,D,v){C>D||C===D&&T>v?(this.startLineNumber=D,this.startColumn=v,this.endLineNumber=C,this.endColumn=T):(this.startLineNumber=C,this.startColumn=T,this.endLineNumber=D,this.endColumn=v)}isEmpty(){return n.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return n.containsPosition(this,C)}static containsPosition(C,T){return!(T.lineNumber<C.startLineNumber||T.lineNumber>C.endLineNumber||T.lineNumber===C.startLineNumber&&T.column<C.startColumn||T.lineNumber===C.endLineNumber&&T.column>C.endColumn)}static strictContainsPosition(C,T){return!(T.lineNumber<C.startLineNumber||T.lineNumber>C.endLineNumber||T.lineNumber===C.startLineNumber&&T.column<=C.startColumn||T.lineNumber===C.endLineNumber&&T.column>=C.endColumn)}containsRange(C){return n.containsRange(this,C)}static containsRange(C,T){return!(T.startLineNumber<C.startLineNumber||T.endLineNumber<C.startLineNumber||T.startLineNumber>C.endLineNumber||T.endLineNumber>C.endLineNumber||T.startLineNumber===C.startLineNumber&&T.startColumn<C.startColumn||T.endLineNumber===C.endLineNumber&&T.endColumn>C.endColumn)}strictContainsRange(C){return n.strictContainsRange(this,C)}static strictContainsRange(C,T){return!(T.startLineNumber<C.startLineNumber||T.endLineNumber<C.startLineNumber||T.startLineNumber>C.endLineNumber||T.endLineNumber>C.endLineNumber||T.startLineNumber===C.startLineNumber&&T.startColumn<=C.startColumn||T.endLineNumber===C.endLineNumber&&T.endColumn>=C.endColumn)}plusRange(C){return n.plusRange(this,C)}static plusRange(C,T){let D,v,P,A;return T.startLineNumber<C.startLineNumber?(D=T.startLineNumber,v=T.startColumn):T.startLineNumber===C.startLineNumber?(D=T.startLineNumber,v=Math.min(T.startColumn,C.startColumn)):(D=C.startLineNumber,v=C.startColumn),T.endLineNumber>C.endLineNumber?(P=T.endLineNumber,A=T.endColumn):T.endLineNumber===C.endLineNumber?(P=T.endLineNumber,A=Math.max(T.endColumn,C.endColumn)):(P=C.endLineNumber,A=C.endColumn),new n(D,v,P,A)}intersectRanges(C){return n.intersectRanges(this,C)}static intersectRanges(C,T){let D=C.startLineNumber,v=C.startColumn,P=C.endLineNumber,A=C.endColumn,R=T.startLineNumber,E=T.startColumn,S=T.endLineNumber,u=T.endColumn;return D<R?(D=R,v=E):D===R&&(v=Math.max(v,E)),P>S?(P=S,A=u):P===S&&(A=Math.min(A,u)),D>P||D===P&&v>A?null:new n(D,v,P,A)}equalsRange(C){return n.equalsRange(this,C)}static equalsRange(C,T){return!!C&&!!T&&C.startLineNumber===T.startLineNumber&&C.startColumn===T.startColumn&&C.endLineNumber===T.endLineNumber&&C.endColumn===T.endColumn}getEndPosition(){return n.getEndPosition(this)}static getEndPosition(C){return new k.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return n.getStartPosition(this)}static getStartPosition(C){return new k.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,T){return new n(this.startLineNumber,this.startColumn,C,T)}setStartPosition(C,T){return new n(C,T,this.endLineNumber,this.endColumn)}collapseToStart(){return n.collapseToStart(this)}static collapseToStart(C){return new n(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}static fromPositions(C,T=C){return new n(C.lineNumber,C.column,T.lineNumber,T.column)}static lift(C){return C?new n(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,T){return!(C.endLineNumber<T.startLineNumber||C.endLineNumber===T.startLineNumber&&C.endColumn<T.startColumn||T.endLineNumber<C.startLineNumber||T.endLineNumber===C.startLineNumber&&T.endColumn<C.startColumn)}static areIntersecting(C,T){return!(C.endLineNumber<T.startLineNumber||C.endLineNumber===T.startLineNumber&&C.endColumn<=T.startColumn||T.endLineNumber<C.startLineNumber||T.endLineNumber===C.startLineNumber&&T.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,T){if(C&&T){const P=C.startLineNumber|0,A=T.startLineNumber|0;if(P===A){const R=C.startColumn|0,E=T.startColumn|0;if(R===E){const S=C.endLineNumber|0,u=T.endLineNumber|0;if(S===u){const b=C.endColumn|0,f=T.endColumn|0;return b-f}return S-u}return R-E}return P-A}return(C?1:0)-(T?1:0)}static compareRangesUsingEnds(C,T){return C.endLineNumber===T.endLineNumber?C.endColumn===T.endColumn?C.startLineNumber===T.startLineNumber?C.startColumn-T.startColumn:C.startLineNumber-T.startLineNumber:C.endColumn-T.endColumn:C.endLineNumber-T.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}toJSON(){return this}}e.Range=n}),define(ve[136],we([0,1,7,2]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class w{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(D){this._onDidChange.fire({changedLanguages:D,changedColorMap:!1})}register(D,v){return this._map.set(D,v),this.fire([D]),(0,n.toDisposable)(()=>{this._map.get(D)===v&&(this._map.delete(D),this.fire([D]))})}registerFactory(D,v){this._factories.get(D)?.dispose();const P=new C(this,D,v);return this._factories.set(D,P),(0,n.toDisposable)(()=>{const A=this._factories.get(D);!A||A!==P||(this._factories.delete(D),A.dispose())})}async getOrCreate(D){const v=this.get(D);if(v)return v;const P=this._factories.get(D);return!P||P.isResolved?null:(await P.resolve(),this.get(D))}get(D){return this._map.get(D)||null}isResolved(D){if(this.get(D))return!0;const P=this._factories.get(D);return!!(!P||P.isResolved)}setColorMap(D){this._colorMap=D,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=w;class C extends n.Disposable{constructor(D,v,P){super();this._registry=D,this._languageId=v,this._factory=P,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const D=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,D&&!this._isDisposed&&this._register(this._registry.register(this._languageId,D))}}}),define(ve[137],we([0,1,4,51,136,37]),function(ee,e,k,n,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var T;(function(I){I[I.Null=0]="Null",I[I.PlainText=1]="PlainText"})(T=e.LanguageId||(e.LanguageId={}));var D;(function(I){I[I.NotSet=-1]="NotSet",I[I.None=0]="None",I[I.Italic=1]="Italic",I[I.Bold=2]="Bold",I[I.Underline=4]="Underline",I[I.Strikethrough=8]="Strikethrough"})(D=e.FontStyle||(e.FontStyle={}));var v;(function(I){I[I.None=0]="None",I[I.DefaultForeground=1]="DefaultForeground",I[I.DefaultBackground=2]="DefaultBackground"})(v=e.ColorId||(e.ColorId={}));var P;(function(I){I[I.Other=0]="Other",I[I.Comment=1]="Comment",I[I.String=2]="String",I[I.RegEx=3]="RegEx"})(P=e.StandardTokenType||(e.StandardTokenType={}));var A;(function(I){I[I.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",I[I.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",I[I.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",I[I.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",I[I.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",I[I.ITALIC_MASK=1024]="ITALIC_MASK",I[I.BOLD_MASK=2048]="BOLD_MASK",I[I.UNDERLINE_MASK=4096]="UNDERLINE_MASK",I[I.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",I[I.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",I[I.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",I[I.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",I[I.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",I[I.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",I[I.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",I[I.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",I[I.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",I[I.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",I[I.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",I[I.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(A=e.MetadataConsts||(e.MetadataConsts={}));class R{static getLanguageId(W){return(W&255)>>>0}static getTokenType(W){return(W&768)>>>8}static getFontStyle(W){return(W&15360)>>>10}static getForeground(W){return(W&8372224)>>>14}static getBackground(W){return(W&4286578688)>>>23}static getClassNameFromMetadata(W){const M=this.getForeground(W);let q="mtk"+M;const Z=this.getFontStyle(W);return Z&1&&(q+=" mtki"),Z&2&&(q+=" mtkb"),Z&4&&(q+=" mtku"),Z&8&&(q+=" mtks"),q}static getInlineStyleFromMetadata(W,M){const q=this.getForeground(W),Z=this.getFontStyle(W);let H=`color: ${M[q]};`;Z&1&&(H+="font-style: italic;"),Z&2&&(H+="font-weight: bold;");let U="";return Z&4&&(U+=" underline"),Z&8&&(U+=" line-through"),U&&(H+=`text-decoration:${U};`),H}static getPresentationFromMetadata(W){const M=this.getForeground(W),q=this.getFontStyle(W);return{foreground:M,italic:Boolean(q&1),bold:Boolean(q&2),underline:Boolean(q&4),strikethrough:Boolean(q&8)}}}e.TokenMetadata=R;class E{constructor(W,M,q){this._tokenBrand=void 0,this.offset=W,this.type=M,this.language=q}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=E;class S{constructor(W,M){this._tokenizationResultBrand=void 0,this.tokens=W,this.endState=M}}e.TokenizationResult=S;class u{constructor(W,M){this._encodedTokenizationResultBrand=void 0,this.tokens=W,this.endState=M}}e.EncodedTokenizationResult=u;var b;(function(I){I[I.Method=0]="Method",I[I.Function=1]="Function",I[I.Constructor=2]="Constructor",I[I.Field=3]="Field",I[I.Variable=4]="Variable",I[I.Class=5]="Class",I[I.Struct=6]="Struct",I[I.Interface=7]="Interface",I[I.Module=8]="Module",I[I.Property=9]="Property",I[I.Event=10]="Event",I[I.Operator=11]="Operator",I[I.Unit=12]="Unit",I[I.Value=13]="Value",I[I.Constant=14]="Constant",I[I.Enum=15]="Enum",I[I.EnumMember=16]="EnumMember",I[I.Keyword=17]="Keyword",I[I.Text=18]="Text",I[I.Color=19]="Color",I[I.File=20]="File",I[I.Reference=21]="Reference",I[I.Customcolor=22]="Customcolor",I[I.Folder=23]="Folder",I[I.TypeParameter=24]="TypeParameter",I[I.User=25]="User",I[I.Issue=26]="Issue",I[I.Snippet=27]="Snippet"})(b=e.CompletionItemKind||(e.CompletionItemKind={}));var f;(function(I){const W=new Map;W.set(0,C.Codicon.symbolMethod),W.set(1,C.Codicon.symbolFunction),W.set(2,C.Codicon.symbolConstructor),W.set(3,C.Codicon.symbolField),W.set(4,C.Codicon.symbolVariable),W.set(5,C.Codicon.symbolClass),W.set(6,C.Codicon.symbolStruct),W.set(7,C.Codicon.symbolInterface),W.set(8,C.Codicon.symbolModule),W.set(9,C.Codicon.symbolProperty),W.set(10,C.Codicon.symbolEvent),W.set(11,C.Codicon.symbolOperator),W.set(12,C.Codicon.symbolUnit),W.set(13,C.Codicon.symbolValue),W.set(15,C.Codicon.symbolEnum),W.set(14,C.Codicon.symbolConstant),W.set(15,C.Codicon.symbolEnum),W.set(16,C.Codicon.symbolEnumMember),W.set(17,C.Codicon.symbolKeyword),W.set(27,C.Codicon.symbolSnippet),W.set(18,C.Codicon.symbolText),W.set(19,C.Codicon.symbolColor),W.set(20,C.Codicon.symbolFile),W.set(21,C.Codicon.symbolReference),W.set(22,C.Codicon.symbolCustomColor),W.set(23,C.Codicon.symbolFolder),W.set(24,C.Codicon.symbolTypeParameter),W.set(25,C.Codicon.account),W.set(26,C.Codicon.issues);function M(H){let U=W.get(H);return U||(console.info("No codicon found for CompletionItemKind "+H),U=C.Codicon.symbolProperty),U}I.toIcon=M;const q=new Map;q.set("method",0),q.set("function",1),q.set("constructor",2),q.set("field",3),q.set("variable",4),q.set("class",5),q.set("struct",6),q.set("interface",7),q.set("module",8),q.set("property",9),q.set("event",10),q.set("operator",11),q.set("unit",12),q.set("value",13),q.set("constant",14),q.set("enum",15),q.set("enum-member",16),q.set("enumMember",16),q.set("keyword",17),q.set("snippet",27),q.set("text",18),q.set("color",19),q.set("file",20),q.set("reference",21),q.set("customcolor",22),q.set("folder",23),q.set("type-parameter",24),q.set("typeParameter",24),q.set("account",25),q.set("issue",26);function Z(H,U){let z=q.get(H);return typeof z=="undefined"&&!U&&(z=9),z}I.fromString=Z})(f=e.CompletionItemKinds||(e.CompletionItemKinds={}));var d;(function(I){I[I.Deprecated=1]="Deprecated"})(d=e.CompletionItemTag||(e.CompletionItemTag={}));var p;(function(I){I[I.KeepWhitespace=1]="KeepWhitespace",I[I.InsertAsSnippet=4]="InsertAsSnippet"})(p=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var m;(function(I){I[I.Invoke=0]="Invoke",I[I.TriggerCharacter=1]="TriggerCharacter",I[I.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var y;(function(I){I[I.Automatic=0]="Automatic",I[I.Explicit=1]="Explicit"})(y=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var c;(function(I){I[I.Invoke=1]="Invoke",I[I.Auto=2]="Auto"})(c=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var o;(function(I){I[I.Invoke=1]="Invoke",I[I.TriggerCharacter=2]="TriggerCharacter",I[I.ContentChange=3]="ContentChange"})(o=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var l;(function(I){I[I.Text=0]="Text",I[I.Read=1]="Read",I[I.Write=2]="Write"})(l=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function i(I){return I&&k.URI.isUri(I.uri)&&n.Range.isIRange(I.range)&&(n.Range.isIRange(I.originSelectionRange)||n.Range.isIRange(I.targetSelectionRange))}e.isLocationLink=i;var t;(function(I){I[I.File=0]="File",I[I.Module=1]="Module",I[I.Namespace=2]="Namespace",I[I.Package=3]="Package",I[I.Class=4]="Class",I[I.Method=5]="Method",I[I.Property=6]="Property",I[I.Field=7]="Field",I[I.Constructor=8]="Constructor",I[I.Enum=9]="Enum",I[I.Interface=10]="Interface",I[I.Function=11]="Function",I[I.Variable=12]="Variable",I[I.Constant=13]="Constant",I[I.String=14]="String",I[I.Number=15]="Number",I[I.Boolean=16]="Boolean",I[I.Array=17]="Array",I[I.Object=18]="Object",I[I.Key=19]="Key",I[I.Null=20]="Null",I[I.EnumMember=21]="EnumMember",I[I.Struct=22]="Struct",I[I.Event=23]="Event",I[I.Operator=24]="Operator",I[I.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var r;(function(I){I[I.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var s;(function(I){const W=new Map;W.set(0,C.Codicon.symbolFile),W.set(1,C.Codicon.symbolModule),W.set(2,C.Codicon.symbolNamespace),W.set(3,C.Codicon.symbolPackage),W.set(4,C.Codicon.symbolClass),W.set(5,C.Codicon.symbolMethod),W.set(6,C.Codicon.symbolProperty),W.set(7,C.Codicon.symbolField),W.set(8,C.Codicon.symbolConstructor),W.set(9,C.Codicon.symbolEnum),W.set(10,C.Codicon.symbolInterface),W.set(11,C.Codicon.symbolFunction),W.set(12,C.Codicon.symbolVariable),W.set(13,C.Codicon.symbolConstant),W.set(14,C.Codicon.symbolString),W.set(15,C.Codicon.symbolNumber),W.set(16,C.Codicon.symbolBoolean),W.set(17,C.Codicon.symbolArray),W.set(18,C.Codicon.symbolObject),W.set(19,C.Codicon.symbolKey),W.set(20,C.Codicon.symbolNull),W.set(21,C.Codicon.symbolEnumMember),W.set(22,C.Codicon.symbolStruct),W.set(23,C.Codicon.symbolEvent),W.set(24,C.Codicon.symbolOperator),W.set(25,C.Codicon.symbolTypeParameter);function M(q){let Z=W.get(q);return Z||(console.info("No codicon found for SymbolKind "+q),Z=C.Codicon.symbolProperty),Z}I.toIcon=M})(s=e.SymbolKinds||(e.SymbolKinds={}));class a{constructor(W){this.value=W}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var h;(function(I){function W(M){return!M||typeof M!="object"?!1:typeof M.id=="string"&&typeof M.title=="string"}I.is=W})(h=e.Command||(e.Command={}));var g;(function(I){I[I.Collapsed=0]="Collapsed",I[I.Expanded=1]="Expanded"})(g=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _;(function(I){I[I.Unresolved=0]="Unresolved",I[I.Resolved=1]="Resolved"})(_=e.CommentThreadState||(e.CommentThreadState={}));var F;(function(I){I[I.Editing=0]="Editing",I[I.Preview=1]="Preview"})(F=e.CommentMode||(e.CommentMode={}));var $;(function(I){I[I.Type=1]="Type",I[I.Parameter=2]="Parameter"})($=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new w.TokenizationRegistry;var K;(function(I){I[I.None=0]="None",I[I.Option=1]="Option",I[I.Default=2]="Default",I[I.Preferred=3]="Preferred"})(K=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ve[138],we([10,11]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(ve[139],we([0,1,138]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,w=n*60,C=w*24,T=C*7,D=C*30,v=C*365;function P(R,E,S){typeof R!="number"&&(R=R.getTime());const u=Math.round((new Date().getTime()-R)/1e3);if(u<-30)return(0,k.localize)(0,null,P(new Date().getTime()+u*1e3,!1));if(u<30)return(0,k.localize)(1,null);let b;return u<n?(b=u,E?b===1?S?(0,k.localize)(2,null,b):(0,k.localize)(3,null,b):S?(0,k.localize)(4,null,b):(0,k.localize)(5,null,b):b===1?S?(0,k.localize)(6,null,b):(0,k.localize)(7,null,b):S?(0,k.localize)(8,null,b):(0,k.localize)(9,null,b)):u<w?(b=Math.floor(u/n),E?b===1?S?(0,k.localize)(10,null,b):(0,k.localize)(11,null,b):S?(0,k.localize)(12,null,b):(0,k.localize)(13,null,b):b===1?S?(0,k.localize)(14,null,b):(0,k.localize)(15,null,b):S?(0,k.localize)(16,null,b):(0,k.localize)(17,null,b)):u<C?(b=Math.floor(u/w),E?b===1?S?(0,k.localize)(18,null,b):(0,k.localize)(19,null,b):S?(0,k.localize)(20,null,b):(0,k.localize)(21,null,b):b===1?S?(0,k.localize)(22,null,b):(0,k.localize)(23,null,b):S?(0,k.localize)(24,null,b):(0,k.localize)(25,null,b)):u<T?(b=Math.floor(u/C),E?b===1?(0,k.localize)(26,null,b):(0,k.localize)(27,null,b):b===1?(0,k.localize)(28,null,b):(0,k.localize)(29,null,b)):u<D?(b=Math.floor(u/T),E?b===1?S?(0,k.localize)(30,null,b):(0,k.localize)(31,null,b):S?(0,k.localize)(32,null,b):(0,k.localize)(33,null,b):b===1?S?(0,k.localize)(34,null,b):(0,k.localize)(35,null,b):S?(0,k.localize)(36,null,b):(0,k.localize)(37,null,b)):u<v?(b=Math.floor(u/D),E?b===1?S?(0,k.localize)(38,null,b):(0,k.localize)(39,null,b):S?(0,k.localize)(40,null,b):(0,k.localize)(41,null,b):b===1?S?(0,k.localize)(42,null,b):(0,k.localize)(43,null,b):S?(0,k.localize)(44,null,b):(0,k.localize)(45,null,b)):(b=Math.floor(u/v),E?b===1?S?(0,k.localize)(46,null,b):(0,k.localize)(47,null,b):S?(0,k.localize)(48,null,b):(0,k.localize)(49,null,b):b===1?S?(0,k.localize)(50,null,b):(0,k.localize)(51,null,b):S?(0,k.localize)(52,null,b):(0,k.localize)(53,null,b))}e.fromNow=P;function A(R){return R.getFullYear()+"-"+String(R.getMonth()+1).padStart(2,"0")+"-"+String(R.getDate()).padStart(2,"0")+"T"+String(R.getHours()).padStart(2,"0")+":"+String(R.getMinutes()).padStart(2,"0")+":"+String(R.getSeconds()).padStart(2,"0")+"."+(R.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=A}),define(ve[140],we([10,11]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(ve[36],we([0,1,18,12,140]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function C(R,E){return E&&(R.stack||R.stacktrace)?w.localize(0,null,D(R),T(R.stack)||T(R.stacktrace)):D(R)}function T(R){return Array.isArray(R)?R.join(`
`):R}function D(R){return typeof R.code=="string"&&typeof R.errno=="number"&&typeof R.syscall=="string"?w.localize(1,null,R.message):R.message||w.localize(2,null)}function v(R=null,E=!1){if(!R)return w.localize(3,null);if(Array.isArray(R)){const S=k.coalesce(R),u=v(S[0],E);return S.length>1?w.localize(4,null,u,S.length):u}if(n.isString(R))return R;if(R.detail){const S=R.detail;if(S.error)return C(S.error,E);if(S.exception)return C(S.exception,E)}return R.stack?C(R,E):R.message?R.message:w.localize(5,null)}e.toErrorMessage=v;function P(R){const E=R;return E instanceof Error&&Array.isArray(E.actions)}e.isErrorWithActions=P;function A(R,E=Object.create(null)){const S=new Error(R);return E.actions&&(S.actions=E.actions),S}e.createErrorWithActions=A}),define(ve[141],we([10,11]),function(ee,e){return ee.create("vs/base/common/jsonErrorMessages",e)}),define(ve[142],we([0,1,141]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function n(w){switch(w){case 1:return(0,k.localize)(0,null);case 2:return(0,k.localize)(1,null);case 3:return(0,k.localize)(2,null);case 4:return(0,k.localize)(3,null);case 5:return(0,k.localize)(4,null);case 6:return(0,k.localize)(5,null);case 7:return(0,k.localize)(6,null);case 8:return(0,k.localize)(7,null);case 9:return(0,k.localize)(8,null);default:return""}}e.getParseErrorMessage=n}),define(ve[143],we([10,11]),function(ee,e){return ee.create("vs/base/node/processes",e)}),define(ve[62],we([0,1,38,33,8,22,5,3,24,74,12,129,19,143]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function u(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function b(o,l){if(D.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};l&&(i.cwd=l);const t=k.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],i);return new Promise(r=>{t.once("error",s=>{r({success:!1,error:s})}),t.once("exit",(s,a)=>{r(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?u(i.status):1})}else if(D.isLinux||D.isMacintosh)try{const i=w.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",ee).fsPath;return new Promise(t=>{k.execFile(i,[o.pid.toString()],{encoding:"utf8",shell:!0},(r,s,a)=>{t(r?{success:!1,error:r}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function f(o){!o||(delete o.DEBUG,D.isMacintosh&&delete o.DYLD_LIBRARY_PATH,D.isLinux&&delete o.LD_PRELOAD)}e.removeDangerousEnvVariables=f;function d(o=v.env){return o.comspec||"cmd.exe"}e.getWindowsShell=d;class p{constructor(l,i,t,r){if(i!==void 0&&t!==void 0&&r!==void 0)this.cmd=l,this.args=i,this.shell=t,this.options=r;else{const s=l;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(v.env).forEach(a=>{s[a]=v.env[a]}),Object.keys(this.options.env).forEach(a=>{s[a]=this.options.env[a]}),this.options.env=s}}getSanitizedCommand(){let l=this.cmd.toLowerCase();const i=l.lastIndexOf(T.sep);return i!==-1&&(l=l.substring(i+1)),p.WellKnowCommands[l]?l:"other"}start(l){return D.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(v.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(i=>{let t,r;const s=new Promise((a,h)=>{t=a,r=h});if(i){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=k.exec(a,this.options,(h,g,_)=>{this.childProcess=null;const F=h;F&&F.killed?r({killed:this.terminateRequested,stdout:g.toString(),stderr:_.toString()}):this.handleExec(t,l,h,g,_)})}else{let a=null;const h=g=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(g,t,l,r);const _={terminated:this.terminateRequested};A.isNumber(g)&&(_.cmdCode=g),t(_)};if(this.shell&&D.isWindows){const g=C.deepClone(this.options);g.windowsVerbatimArguments=!0,g.detached=!1;let _=!1,F=!1;const $=[];let K=this.ensureQuotes(this.cmd);$.push(K.value),_=K.quoted,this.args&&this.args.forEach(W=>{K=this.ensureQuotes(W),$.push(K.value),F=F&&K.quoted});const I=["/s","/c"];_?F?I.push('"'+$.join(" ")+'"'):$.length>1?I.push('"'+$[0]+'" '+$.slice(1).join(" ")):I.push('"'+$[0]+'"'):I.push($.join(" ")),a=k.spawn(d(),I,g)}else this.cmd&&(a=k.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(A.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",g=>{this.childProcess=null,r({terminated:this.terminateRequested,error:g})}),a.pid&&(this.childProcess.on("close",h),this.handleSpawn(a,t,l,r,!0)))}return s})}handleClose(l,i,t,r){}ensureQuotes(l){return p.regexp.test(l)?{value:'"'+l+'"',quoted:!0}:{value:l,quoted:l.length>0&&l[0]==='"'&&l[l.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(l=>l.pid,l=>-1):new Promise(l=>{this.pidResolve=l})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(l=>(this.terminateRequested=!0,b(l,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),l=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(l=>{if(!this.shell||!D.isWindows)return l(!1);const i=k.spawn(d(),["/s","/c"]);i.on("error",t=>l(!0)),i.on("exit",t=>l(!1))})}}e.AbstractProcess=p,p.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},p.regexp=/^[^"].* .*[^"]/;class m extends p{constructor(l,i,t,r){super(l,i,t,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(l,i,t,r,s){[r,s].forEach((a,h)=>{const g=new R.LineDecoder;g.write(a).forEach($=>{i({line:$,source:h===0?0:1})});const F=g.end();F&&i({line:F,source:h===0?0:1})}),l({terminated:this.terminateRequested,error:t})}handleSpawn(l,i,t,r,s){const a=new R.LineDecoder,h=new R.LineDecoder;l.stdout.on("data",g=>{a.write(g).forEach(F=>t({line:F,source:0}))}),l.stderr.on("data",g=>{h.write(g).forEach(F=>t({line:F,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=h}handleClose(l,i,t,r){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&t({line:s,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&t({line:a,source:1})}}e.LineProcess=m;function y(o){let l=[],i=!1;const t=function(r){if(i){l.push(r);return}(!o.send(r,a=>{if(a&&console.error(a),i=!1,l.length>0){const h=l.slice(0);l=[],h.forEach(g=>t(g))}})||D.isWindows)&&(i=!0)};return{send:t}}e.createQueuedSender=y;var c;(function(o){async function l(i,t,r){if(T.isAbsolute(i))return i;if(t===void 0&&(t=v.cwd()),T.dirname(i)!=="."||(r===void 0&&A.isString(v.env.PATH)&&(r=v.env.PATH.split(T.delimiter)),r===void 0||r.length===0))return T.join(t,i);async function a(h){if(await E.Promises.exists(h)){let g;try{g=await E.Promises.stat(h)}catch(_){_.message.startsWith("EACCES")&&(g=await E.Promises.lstat(h))}return g?!g.isDirectory():!1}return!1}for(let h of r){let g;if(T.isAbsolute(h)?g=T.join(h,i):g=T.join(t,h,i),await a(g))return g;let _=g+".com";if(await a(_)||(_=g+".exe",await a(_)))return _}return T.join(t,i)}o.findExecutable=l})(c=e.win32||(e.win32={}))}),define(ve[144],we([0,1,25,3,83,62]),function(ee,e,k,n,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function T(S,u){return S===1?n.isWindows?R():C.getWindowsShell(u):P(S,u)}e.getSystemShell=T;function D(S,u){return S===1?n.isWindows?E(u):C.getWindowsShell(u):P(S,u)}e.getSystemShellSync=D;let v=null;function P(S,u){if(n.isLinux&&S===2||n.isMacintosh&&S===3)return"/bin/bash";if(!v){let b;if(n.isWindows)b="/bin/bash";else{if(b=u.SHELL,!b)try{b=(0,k.userInfo)().shell}catch{}b||(b="sh"),b==="/bin/false"&&(b="/bin/bash")}v=b}return v}let A=null;async function R(){return A||(A=(await(0,w.getFirstAvailablePowerShellInstallation)()).exePath),A}function E(S){if(A)return A;const u=n.isWindows&&parseFloat((0,k.release)())>=10,b=S.hasOwnProperty("PROCESSOR_ARCHITEW6432"),f=`${S.windir}\\${b?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?f:C.getWindowsShell(S)}}),define(ve[87],we([0,1,38,14,16,21,76,9,7,2,22,62,39]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class S extends E.ChannelServer{constructor(f){super({send:d=>{try{process.send&&process.send(d.buffer.toString("base64"))}catch{}},onMessage:v.Event.fromNodeEventEmitter(process,"message",d=>w.VSBuffer.wrap(Buffer.from(d,"base64")))},f);process.once("disconnect",()=>this.dispose())}}e.Server=S;class u{constructor(f,d){this.modulePath=f,this.options=d,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new v.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const p=d&&d.timeout?d.timeout:6e4;this.disposeDelayer=new n.Delayer(p),this.child=null,this._client=null}getChannel(f){const d=this;return{call(p,m,y){return d.requestPromise(f,p,m,y)},listen(p,m){return d.requestEvent(f,p,m)}}}requestPromise(f,d,p,m=C.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(D.canceled());this.disposeDelayer.cancel();const y=this.getCachedChannel(f),c=(0,n.createCancelablePromise)(i=>y.call(d,p,i)),o=m.onCancellationRequested(()=>c.cancel()),l=(0,P.toDisposable)(()=>c.cancel());return this.activeRequests.add(l),c.finally(()=>{o.dispose(),this.activeRequests.delete(l),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),c}requestEvent(f,d,p){if(!this.disposeDelayer)return v.Event.None;this.disposeDelayer.cancel();let m;const y=new v.Emitter({onFirstListenerAdd:()=>{m=this.getCachedChannel(f).listen(d,p)(y.fire,y),this.activeRequests.add(m)},onLastListenerRemove:()=>{this.activeRequests.delete(m),m.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return y.event}get client(){if(!this._client){const f=this.options&&this.options.args?this.options.args:[],d=Object.create(null);d.env={...(0,A.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(d.env={...d.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(d.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,R.removeDangerousEnvVariables)(d.env),this.child=(0,k.fork)(this.modulePath,f,d);const p=new v.Emitter;v.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,T.isRemoteConsoleLog)(t)){(0,T.log)(t,`IPC Library: ${this.options.serverName}`);return}p.fire(w.VSBuffer.wrap(Buffer.from(t,"base64")))});const y=this.options.useQueue?(0,R.createQueuedSender)(this.child):this.child,c=t=>this.child&&this.child.connected&&y.send(t.buffer.toString("base64")),o=p.event,l={send:c,onMessage:o};this._client=new E.ChannelClient(l);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,r)=>{process.removeListener("exit",i),this.activeRequests.forEach(s=>(0,P.dispose)(s)),this.activeRequests.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+r),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:r})})}return this._client}getCachedChannel(f){let d=this.channels.get(f);return d||(d=this.client.getChannel(f),this.channels.set(f,d)),d}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=u}),define(ve[145],we([10,11]),function(ee,e){return ee.create("vs/base/node/zip",e)}),define(ve[146],we([10,11]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[147],we([10,11]),function(ee,e){return ee.create("vs/platform/environment/node/argv",e)}),define(ve[148],we([10,11]),function(ee,e){return ee.create("vs/platform/environment/node/argvHelper",e)}),define(ve[149],we([10,11]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ve[150],we([10,11]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ve[151],we([10,11]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionManagementCLIService",e)}),define(ve[152],we([10,11]),function(ee,e){return ee.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ve[153],we([10,11]),function(ee,e){return ee.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ve[154],we([10,11]),function(ee,e){return ee.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(ve[155],we([10,11]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[156],we([10,11]),function(ee,e){return ee.create("vs/platform/files/common/fileService",e)}),define(ve[157],we([10,11]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(ve[158],we([10,11]),function(ee,e){return ee.create("vs/platform/files/common/io",e)}),define(ve[159],we([10,11]),function(ee,e){return ee.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ve[160],we([10,11]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(ve[161],we([10,11]),function(ee,e){return ee.create("vs/platform/request/common/request",e)}),define(ve[162],we([10,11]),function(ee,e){return ee.create("vs/platform/shell/node/shellEnv",e)}),define(ve[163],we([10,11]),function(ee,e){return ee.create("vs/platform/telemetry/common/telemetryService",e)}),define(ve[164],we([10,11]),function(ee,e){return ee.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ve[165],we([10,11]),function(ee,e){return ee.create("vs/platform/workspace/common/workspace",e)}),define(ve[166],we([10,11]),function(ee,e){return ee.create("vs/server/node/remoteAgentEnvironmentImpl",e)}),define(ve[167],we([10,11]),function(ee,e){return ee.create("vs/server/node/serverEnvironmentService",e)}),define(ve[168],we([10,11]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(ve[169],we([10,11]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[170],we([10,11]),function(ee,e){return ee.create("vs/workbench/services/extensions/common/extensionPoints",e)}),define(ve[171],we([0,1,7,2]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class w{constructor(){this._onCloseEmitter=new k.Emitter,this._onReloadEmitter=new k.Emitter,this._onTerminateEmitter=new k.Emitter,this._onAttachEmitter=new k.Emitter}call(D,v,P){switch(v){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:P[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:P[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:P[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:P[0],port:P[1],subId:P[2]}))}throw new Error("Method not implemented.")}listen(D,v,P){switch(v){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=w,w.ChannelName="extensionhostdebugservice";class C extends n.Disposable{constructor(D){super();this.channel=D}reload(D){this.channel.call("reload",[D])}get onReload(){return this.channel.listen("reload")}close(D){this.channel.call("close",[D])}get onClose(){return this.channel.listen("close")}attachSession(D,v,P){this.channel.call("attach",[D,v,P])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(D,v){this.channel.call("terminate",[D,v])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(D,v){return this.channel.call("openExtensionDevelopmentHostWindow",[D,v])}}e.ExtensionHostDebugChannelClient=C}),define(ve[172],we([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class n{constructor(T){this.service=T}listen(T,D,v){throw new Error("Invalid listen")}call(T,D,v){switch(D){case"download":return this.service.download(k.URI.revive(v[0]),k.URI.revive(v[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=n;class w{constructor(T,D){this.channel=T,this.getUriTransformer=D}async download(T,D){const v=this.getUriTransformer();v&&(T=v.transformOutgoingURI(T),D=v.transformOutgoingURI(D)),await this.channel.call("download",[T,D])}}e.DownloadServiceChannelClient=w}),define(ve[173],we([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var k;(function(D){D[D.ACTIVATE=1]="ACTIVATE",D[D.RESTORE=2]="RESTORE",D[D.PRESERVE=3]="PRESERVE"})(k=e.EditorActivation||(e.EditorActivation={}));var n;(function(D){D[D.PICK=0]="PICK",D[D.DISABLED=1]="DISABLED",D[D.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(n=e.EditorResolution||(e.EditorResolution={}));var w;(function(D){D[D.API=0]="API",D[D.USER=1]="USER"})(w=e.EditorOpenSource||(e.EditorOpenSource={}));var C;(function(D){D[D.Center=0]="Center",D[D.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",D[D.NearTop=2]="NearTop",D[D.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(C=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var T;(function(D){D.PROGRAMMATIC="api",D.NAVIGATION="code.navigation",D.JUMP="code.jump"})(T=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(ve[174],we([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class k{constructor(w){this.machineId=w}encryption(){return new Promise((w,C)=>ee(["vscode-encrypt"],w,C))}async encrypt(w){try{return(await this.encryption()).encrypt(this.machineId,w)}catch{return w}}async decrypt(w){try{return(await this.encryption()).decrypt(this.machineId,w)}catch{return w}}}e.EncryptionMainService=k}),define(ve[88],we([0,1,139,72,8,5,24,20,4]),function(ee,e,k,n,w,C,T,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class P{constructor(b,f,d){this._args=b,this.paths=f,this.productService=d}get appRoot(){return(0,C.dirname)(w.FileAccess.asFileUri("",ee).fsPath)}get userHome(){return v.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return v.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return v.URI.file(this.paths.tmpDir)}get cacheHome(){return v.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,D.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,D.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const b=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",b)}return this.args.logsPath}get userDataSyncLogResource(){return v.URI.file((0,C.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,D.joinPath)(v.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return(0,D.joinPath)(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return(0,D.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,D.joinPath)(this.appSettingsHome,"History")}get keybindingsResource(){return(0,D.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,D.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const b=T.env.VSCODE_PORTABLE;return b?v.URI.file((0,C.join)(b,"argv.json")):(0,D.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,D.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return v.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,C.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const b=this.args["builtin-extensions-dir"];return b?(0,C.resolve)(b):(0,C.normalize)((0,C.join)(w.FileAccess.asFileUri("",ee).fsPath,"..","extensions"))}get extensionsDownloadPath(){const b=this.args["extensions-download-dir"];return b?(0,C.resolve)(b):(0,C.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const b=this.args["extensions-dir"];if(b)return(0,C.resolve)(b);const f=T.env.VSCODE_EXTENSIONS;if(f)return f;const d=T.env.VSCODE_PORTABLE;return d?(0,C.join)(d,"extensions"):(0,D.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const b=this.args.extensionDevelopmentPath;if(Array.isArray(b))return b.map(f=>/^[^:/?#]+?:\/\//.test(f)?v.URI.parse(f):v.URI.file((0,C.normalize)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(b=>b==="ui"||b==="workspace"||b==="web"?b:"workspace")}get extensionTestsLocationURI(){const b=this.args.extensionTestsPath;if(b)return/^[^:/?#]+?:\/\//.test(b)?v.URI.parse(b):v.URI.file((0,C.normalize)(b))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const b=this.args["disable-extension"];if(b){if(typeof b=="string")return[b];if(Array.isArray(b)&&b.length>0)return b}return!1}get debugExtensionHost(){return A(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,D.joinPath)(v.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return v.URI.file((0,C.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}Ae([n.memoize],P.prototype,"appRoot",null),Ae([n.memoize],P.prototype,"userHome",null),Ae([n.memoize],P.prototype,"userDataPath",null),Ae([n.memoize],P.prototype,"appSettingsHome",null),Ae([n.memoize],P.prototype,"tmpDir",null),Ae([n.memoize],P.prototype,"cacheHome",null),Ae([n.memoize],P.prototype,"userRoamingDataHome",null),Ae([n.memoize],P.prototype,"settingsResource",null),Ae([n.memoize],P.prototype,"userDataSyncHome",null),Ae([n.memoize],P.prototype,"userDataSyncLogResource",null),Ae([n.memoize],P.prototype,"sync",null),Ae([n.memoize],P.prototype,"machineSettingsResource",null),Ae([n.memoize],P.prototype,"globalStorageHome",null),Ae([n.memoize],P.prototype,"workspaceStorageHome",null),Ae([n.memoize],P.prototype,"localHistoryHome",null),Ae([n.memoize],P.prototype,"keybindingsResource",null),Ae([n.memoize],P.prototype,"keyboardLayoutResource",null),Ae([n.memoize],P.prototype,"argvResource",null),Ae([n.memoize],P.prototype,"snippetsHome",null),Ae([n.memoize],P.prototype,"isExtensionDevelopment",null),Ae([n.memoize],P.prototype,"untitledWorkspacesHome",null),Ae([n.memoize],P.prototype,"installSourcePath",null),Ae([n.memoize],P.prototype,"builtinExtensionsPath",null),Ae([n.memoize],P.prototype,"extensionsPath",null),Ae([n.memoize],P.prototype,"extensionDevelopmentLocationURI",null),Ae([n.memoize],P.prototype,"extensionDevelopmentKind",null),Ae([n.memoize],P.prototype,"extensionTestsLocationURI",null),Ae([n.memoize],P.prototype,"debugExtensionHost",null),Ae([n.memoize],P.prototype,"serviceMachineIdResource",null),Ae([n.memoize],P.prototype,"telemetryLogResource",null),Ae([n.memoize],P.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=P;function A(u,b){return S(u["inspect-extensions"],u["inspect-brk-extensions"],5870,b,u.debugId,u.extensionEnvironment)}e.parseExtensionHostPort=A;function R(u,b){return S(u["inspect-search"],u["inspect-brk-search"],5876,b,u.extensionEnvironment)}e.parseSearchPort=R;function E(u,b){return S(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,b,u.extensionEnvironment)}e.parsePtyHostPort=E;function S(u,b,f,d,p,m){const c=Number(b||u)||(d?null:f),o=c?Boolean(!!b):!1;let l;if(m)try{l=JSON.parse(m)}catch{}return{port:c,break:o,debugId:p,env:l}}}),define(ve[52],we([0,1,257,3,147]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const C={o:(0,w.localize)(0,null),e:(0,w.localize)(1,null),t:(0,w.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,w.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,w.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,w.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,w.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,w.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,w.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,w.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,w.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,w.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,w.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,w.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,w.localize)(14,null)},category:{type:"string",cat:"e",description:(0,w.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,w.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,w.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,w.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"ext-id",description:(0,w.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,w.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,w.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,w.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,w.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,w.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,w.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,w.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,w.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,w.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,w.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,w.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,w.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,w.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function D(u,b,f=T){const d={},p=["_"],m=[];for(let l in b){const i=b[l];i.alias&&(d[l]=i.alias),i.type==="string"||i.type==="string[]"?(p.push(l),i.deprecates&&p.push(...i.deprecates)):i.type==="boolean"&&(m.push(l),i.deprecates&&m.push(...i.deprecates))}const y=k(u,{string:p,boolean:m,alias:d}),c={},o=y;c._=y._.map(l=>String(l)).filter(l=>l.length>0),delete o._;for(let l in b){const i=b[l];i.alias&&delete o[i.alias];let t=o[l];if(i.deprecates)for(const r of i.deprecates)o.hasOwnProperty(r)&&(t||(t=o[r],t&&f.onDeprecatedOption(r,i.deprecationMessage||(0,w.localize)(33,null))),delete o[r]);typeof t!="undefined"&&(i.type==="string[]"?t&&!Array.isArray(t)&&(t=[t]):i.type==="string"&&Array.isArray(t)&&(t=t.pop(),f.onMultipleValues(l,t)),c[l]=t,i.deprecationMessage&&f.onDeprecatedOption(l,i.deprecationMessage)),delete o[l]}for(let l in o)f.onUnknownOption(l);return c}e.parseArgs=D;function v(u,b){let f="";return b.args&&(Array.isArray(b.args)?f=` <${b.args.join("> <")}>`:f=` <${b.args}>`),b.alias?`-${b.alias} --${u}${f}`:`--${u}${f}`}function P(u,b){let f=0,d=[];for(const c in u){const o=u[c],l=v(c,o);f=Math.max(f,l.length),d.push([l,o.description])}let p=f+2+1;if(b-p<25)return d.reduce((c,o)=>c.concat([`  ${o[0]}`,`      ${o[1]}`]),[]);let m=b-p-1,y=[];for(const c of d){let o=c[0],l=R(c[1],m),i=A(p-o.length-2);y.push("  "+o+i+l[0]);for(let t=1;t<l.length;t++)y.push(A(p)+l[t])}return y}e.formatOptions=P;function A(u){return" ".repeat(u)}function R(u,b){let f=[];for(;u.length;){let d=u.length<b?u.length:u.lastIndexOf(" ",b),p=u.slice(0,d).trim();u=u.slice(d),f.push(p)}return f}function E(u,b,f,d,p){const m=process.stdout.isTTY&&process.stdout.columns||80,y=p?.noInputFiles!==!0?`[${(0,w.localize)(34,null)}...]`:"",c=[`${u} ${f}`];c.push(""),c.push(`${(0,w.localize)(35,null)}: ${b} [${(0,w.localize)(36,null)}]${y}`),c.push(""),p?.noPipe!==!0&&(n.isWindows?c.push((0,w.localize)(37,null,b)):c.push((0,w.localize)(38,null,b)),c.push(""));const o={};for(const l in d){const i=d[l];if(i.description&&i.cat){let t=o[i.cat];t||(o[i.cat]=t={}),t[l]=i}}for(let l in o){const i=l;let t=o[i];t&&(c.push(C[i]),c.push(...P(t,m)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=E;function S(u,b){return`${u||(0,w.localize)(39,null)}
${b||(0,w.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=S}),define(ve[175],we([0,1,258,148,52]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const C=2048;function T(E,S){const u={onUnknownOption:f=>{console.warn((0,n.localize)(0,null,f))},onMultipleValues:(f,d)=>{console.warn((0,n.localize)(1,null,f,d))},onDeprecatedOption:(f,d)=>{console.warn((0,n.localize)(2,null,f,d))}},b=(0,w.parseArgs)(E,w.OPTIONS,S?u:void 0);return b.goto&&b._.forEach(f=>k(/^(\w:)?[^:]+(:\d*){0,2}$/.test(f),(0,n.localize)(3,null))),b["max-memory"]&&k(parseInt(b["max-memory"])>=C,`The max-memory argument cannot be specified lower than ${C} MB.`),b}function D(E){const S=E.findIndex(u=>!/^-/.test(u));if(S>-1)return[...E.slice(0,S),...E.slice(S+1)]}function v(E){let[,...S]=E;process.env.VSCODE_DEV&&(S=D(S)||[]);const u=!R(process.env);return T(S,u)}e.parseMainProcessArgv=v;function P(E){const[,,...S]=E;return T(S,!0)}e.parseCLIProcessArgv=P;function A(E,...S){const u=E.indexOf("--");return u===-1?E.push(...S):E.splice(u,0,...S),E}e.addArg=A;function R(E){return E.VSCODE_CLI==="1"}e.isLaunchedFromCli=R}),function(){"use strict";function ee(e,k,n,w){function C(D){const v=T(D),P=[v];return e.isAbsolute(v)||P.unshift(w),e.resolve(...P)}function T(D){const v=process.env.VSCODE_PORTABLE;if(v)return e.join(v,"user-data");let P=process.env.VSCODE_APPDATA;if(P)return e.join(P,n);const A=D["user-data-dir"];if(A)return A;switch(process.platform){case"win32":if(P=process.env.APPDATA,!P){const R=process.env.USERPROFILE;if(typeof R!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");P=e.join(R,"AppData","Roaming")}break;case"darwin":P=e.join(k.homedir(),"Library","Application Support");break;case"linux":P=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(P,n)}return{getUserDataPath:C}}if(typeof define=="function")define(ve[176],we([0,80,25,8,20,24]),function(e,k,n,w,C,T){const D=C.dirname(w.FileAccess.asFileUri("",e)),v=e.__$__nodeRequire(C.joinPath(D,"package.json").fsPath);return ee(k,n,v.name,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),k=require("path"),n=require("os");module.exports=ee(k,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ve[177],we([0,1,25,88,176]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class C extends n.AbstractNativeEnvironmentService{constructor(D,v){super(D,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,w.getUserDataPath)(D)},v)}}e.NativeEnvironmentService=C}),define(ve[178],we([0,1,22]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const n=/^%([\w\d.-]+)%$/i;function w(C,T){const D=v=>{if(typeof v!="string")return;const P=n.exec(v);if(!P)return;const A=T[P[1]]??v;return typeof A=="string"?A:typeof A.message=="string"?A.message:v};return(0,k.cloneAndChange)(C,D)}e.localizeManifest=w}),define(ve[63],we([0,1,155]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const n=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function C(E){return E=E.trim(),E==="*"||n.test(E)}e.isValidVersionStr=C;function T(E){if(!C(E))return null;if(E=E.trim(),E==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let S=E.match(n);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}e.parseVersion=T;function D(E){if(!E)return null;let S=E.majorBase,u=E.majorMustEqual,b=E.minorBase,f=E.minorMustEqual,d=E.patchBase,p=E.patchMustEqual;E.hasCaret&&(S===0||(f=!1),p=!1);let m=0;if(E.preRelease){const y=w.exec(E.preRelease);if(y){const[,c,o,l]=y;m=Date.UTC(Number(c),Number(o)-1,Number(l))}}return{majorBase:S,majorMustEqual:u,minorBase:b,minorMustEqual:f,patchBase:d,patchMustEqual:p,isMinimum:E.hasGreaterEquals,notBefore:m}}e.normalizeVersion=D;function v(E,S,u){let b;typeof E=="string"?b=D(T(E)):b=E;let f;S instanceof Date?f=S.getTime():typeof S=="string"&&(f=new Date(S).getTime());let d;if(typeof u=="string"?d=D(T(u)):d=u,!b||!d)return!1;let p=b.majorBase,m=b.minorBase,y=b.patchBase,c=d.majorBase,o=d.minorBase,l=d.patchBase,i=d.notBefore,t=d.majorMustEqual,r=d.minorMustEqual,s=d.patchMustEqual;return d.isMinimum?p>c?!0:p<c?!1:m>o?!0:m<o||f&&f<i?!1:y>=l:(p===1&&c===0&&(!t||!r||!s)&&(c=1,o=0,l=0,t=!0,r=!1,s=!1),p<c?!1:p>c?!t:m<o?!1:m>o?!r:y<l?!1:y>l?!s:!(f&&f<i))}e.isValidVersion=v;function P(E,S,u,b,f){return b||typeof u.main=="undefined"&&typeof u.browser=="undefined"?!0:R(E,S,u.engines.vscode,f)}e.isValidExtensionVersion=P;function A(E,S,u){return E==="*"||R(S,u,E)}e.isEngineValid=A;function R(E,S,u,b=[]){let f=D(T(u));if(!f)return b.push(k.localize(0,null,u)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return b.push(k.localize(1,null,u)),!1}else if(!f.majorMustEqual)return b.push(k.localize(2,null,u)),!1;return v(E,S,f)?!0:(b.push(k.localize(3,null,E,u)),!1)}}),define(ve[179],we([0,1,16,23]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function w(C,T,D){let v=D&&D.get("storage.serviceMachineId",0)||null;if(v)return v;try{const A=(await T.readFile(C.serviceMachineIdResource)).value.toString();v=(0,n.isUUID)(A)?A:null}catch{v=null}if(!v){v=(0,n.generateUuid)();try{await T.writeFile(C.serviceMachineIdResource,k.VSBuffer.fromString(v))}catch{}}return D&&D.store("storage.serviceMachineId",v,0,1),v}e.getServiceMachineId=w}),define(ve[53],we([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class k{constructor(w,C=[],T=!1){this.ctor=w,this.staticArguments=C,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=k}),define(ve[180],we([0,1,53]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const n=[];function w(T,D,v){D instanceof k.SyncDescriptor||(D=new k.SyncDescriptor(D,[],v)),n.push([T,D])}e.registerSingleton=w;function C(){return n}e.getSingletonServiceDescriptors=C}),define(ve[181],we([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class k{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=k;class n{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let T of this._nodes.values())T.outgoing.size===0&&C.push(T);return C}insertEdge(C,T){const D=this.lookupOrInsertNode(C),v=this.lookupOrInsertNode(T);D.outgoing.set(this._hashFn(T),v),v.incoming.set(this._hashFn(C),D)}removeNode(C){const T=this._hashFn(C);this._nodes.delete(T);for(let D of this._nodes.values())D.outgoing.delete(T),D.incoming.delete(T)}lookupOrInsertNode(C){const T=this._hashFn(C);let D=this._nodes.get(T);return D||(D=new k(C),this._nodes.set(T,D)),D}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[T,D]of this._nodes)C.push(`${T}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,T]of this._nodes){const D=new Set([C]),v=this._findCycle(T,D);if(v)return v}}_findCycle(C,T){for(let[D,v]of C.outgoing){if(T.has(D))return[...T,D].join(" -> ");T.add(D);const P=this._findCycle(v,T);if(P)return P;T.delete(D)}}}e.Graph=n}),define(ve[6],we([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var k;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function D(v){return v[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=D})(k=e._util||(e._util={})),e.IInstantiationService=w("instantiationService");function n(T,D,v){D[k.DI_TARGET]===D?D[k.DI_DEPENDENCIES].push({id:T,index:v}):(D[k.DI_DEPENDENCIES]=[{id:T,index:v}],D[k.DI_TARGET]=D)}function w(T){if(k.serviceIds.has(T))return k.serviceIds.get(T);const D=function(v,P,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(D,v,A)};return D.toString=()=>T,k.serviceIds.set(T,D),D}e.createDecorator=w;function C(T){return T}e.refineServiceDecorator=C}),define(ve[26],we([0,1,12,4,6]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,w.createDecorator)("configurationService");function C(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof n.URI)}e.isConfigurationOverrides=C;function T(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||k.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=T;var D;(function(d){d[d.USER=1]="USER",d[d.USER_LOCAL=2]="USER_LOCAL",d[d.USER_REMOTE=3]="USER_REMOTE",d[d.WORKSPACE=4]="WORKSPACE",d[d.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",d[d.DEFAULT=6]="DEFAULT",d[d.MEMORY=7]="MEMORY"})(D=e.ConfigurationTarget||(e.ConfigurationTarget={}));function v(d){switch(d){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=v;function P(d,p){const m=Object.create(null);for(let y in d)A(m,y,d[y],p);return m}e.toValuesTree=P;function A(d,p,m,y){const c=p.split("."),o=c.pop();let l=d;for(let i=0;i<c.length;i++){let t=c[i],r=l[t];switch(typeof r){case"undefined":r=l[t]=Object.create(null);break;case"object":break;default:y(`Ignoring ${p} as ${c.slice(0,i+1).join(".")} is ${JSON.stringify(r)}`);return}l=r}if(typeof l=="object"&&l!==null)try{l[o]=m}catch{y(`Ignoring ${p} as ${c.join(".")} is ${JSON.stringify(l)}`)}else y(`Ignoring ${p} as ${c.join(".")} is ${JSON.stringify(l)}`)}e.addToValueTree=A;function R(d,p){const m=p.split(".");E(d,m)}e.removeFromValueTree=R;function E(d,p){const m=p.shift();if(p.length===0){delete d[m];return}if(Object.keys(d).indexOf(m)!==-1){const y=d[m];typeof y=="object"&&!Array.isArray(y)&&(E(y,p),Object.keys(y).length===0&&delete d[m])}}function S(d,p,m){function y(l,i){let t=l;for(const r of i){if(typeof t!="object"||t===null)return;t=t[r]}return t}const c=p.split("."),o=y(d,c);return typeof o=="undefined"?m:o}e.getConfigurationValue=S;function u(d,p,m){Object.keys(p).forEach(y=>{y!=="__proto__"&&(y in d?k.isObject(d[y])&&k.isObject(p[y])?u(d[y],p[y],m):m&&(d[y]=p[y]):d[y]=p[y])})}e.merge=u;function b(d,p,m){const y=d.inspect(p),c=d.inspect(m);return typeof y.userValue!="undefined"||typeof y.workspaceValue!="undefined"||typeof y.workspaceFolderValue!="undefined"?y.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:y.defaultValue}e.getMigratedSettingValue=b;function f(d){return d.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=f}),define(ve[89],we([0,1,3,15,6]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const C=new Map;C.set("false",!1),C.set("true",!0),C.set("isMac",k.isMacintosh),C.set("isLinux",k.isLinux),C.set("isWindows",k.isWindows),C.set("isWeb",k.isWeb),C.set("isMacNative",k.isMacintosh&&!k.isWeb),C.set("isEdge",k.isEdge),C.set("isFirefox",k.isFirefox),C.set("isChrome",k.isChrome),C.set("isSafari",k.isSafari);const T=Object.prototype.hasOwnProperty;var D;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class v{static false(){return R.INSTANCE}static true(){return E.INSTANCE}static has(I){return S.create(I)}static equals(I,W){return u.create(I,W)}static notEquals(I,W){return d.create(I,W)}static regex(I,W){return i.create(I,W)}static in(I,W){return b.create(I,W)}static not(I){return p.create(I)}static and(...I){return s.create(I,null)}static or(...I){return a.create(I,null,!0)}static greater(I,W){return y.create(I,W)}static greaterEquals(I,W){return c.create(I,W)}static smaller(I,W){return o.create(I,W)}static smallerEquals(I,W){return l.create(I,W)}static deserialize(I,W=!1){if(!!I)return this._deserializeOrExpression(I,W)}static _deserializeOrExpression(I,W){let M=I.split("||");return a.create(M.map(q=>this._deserializeAndExpression(q,W)),null,!0)}static _deserializeAndExpression(I,W){let M=I.split("&&");return s.create(M.map(q=>this._deserializeOne(q,W)),null)}static _deserializeOne(I,W){if(I=I.trim(),I.indexOf("!=")>=0){let M=I.split("!=");return d.create(M[0].trim(),this._deserializeValue(M[1],W))}if(I.indexOf("==")>=0){let M=I.split("==");return u.create(M[0].trim(),this._deserializeValue(M[1],W))}if(I.indexOf("=~")>=0){let M=I.split("=~");return i.create(M[0].trim(),this._deserializeRegexValue(M[1],W))}if(I.indexOf(" in ")>=0){let M=I.split(" in ");return b.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(I)){const M=I.split(">=");return c.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(I)){const M=I.split(">");return y.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(I)){const M=I.split("<=");return l.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(I)){const M=I.split("<");return o.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(I)?p.create(I.substr(1).trim()):S.create(I)}static _deserializeValue(I,W){if(I=I.trim(),I==="true")return!0;if(I==="false")return!1;let M=/^'([^']*)'$/.exec(I);return M?M[1].trim():I}static _deserializeRegexValue(I,W){if((0,n.isFalsyOrWhitespace)(I)){if(W)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=I.indexOf("/"),q=I.lastIndexOf("/");if(M===q||M<0){if(W)throw new Error(`bad regexp-value '${I}', missing /-enclosure`);return console.warn(`bad regexp-value '${I}', missing /-enclosure`),null}let Z=I.slice(M+1,q),H=I[q+1]==="i"?"i":"";try{return new RegExp(Z,H)}catch(U){if(W)throw new Error(`bad regexp-value '${I}', parse error: ${U}`);return console.warn(`bad regexp-value '${I}', parse error: ${U}`),null}}}e.ContextKeyExpr=v;function P(K,I){const W=K?K.substituteConstants():void 0,M=I?I.substituteConstants():void 0;return!W&&!M?!0:!W||!M?!1:W.equals(M)}e.expressionsAreEqualWithConstantSubstitution=P;function A(K,I){return K.cmp(I)}class R{constructor(){this.type=0}cmp(I){return this.type-I.type}equals(I){return I.type===this.type}substituteConstants(){return this}evaluate(I){return!1}serialize(){return"false"}keys(){return[]}map(I){return this}negate(){return E.INSTANCE}}e.ContextKeyFalseExpr=R,R.INSTANCE=new R;class E{constructor(){this.type=1}cmp(I){return this.type-I.type}equals(I){return I.type===this.type}substituteConstants(){return this}evaluate(I){return!0}serialize(){return"true"}keys(){return[]}map(I){return this}negate(){return R.INSTANCE}}e.ContextKeyTrueExpr=E,E.INSTANCE=new E;class S{constructor(I,W){this.key=I,this.negated=W,this.type=2}static create(I,W=null){const M=C.get(I);return typeof M=="boolean"?M?E.INSTANCE:R.INSTANCE:new S(I,W)}cmp(I){return I.type!==this.type?this.type-I.type:g(this.key,I.key)}equals(I){return I.type===this.type?this.key===I.key:!1}substituteConstants(){const I=C.get(this.key);return typeof I=="boolean"?I?E.INSTANCE:R.INSTANCE:this}evaluate(I){return!!I.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(I){return I.mapDefined(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=S;class u{constructor(I,W,M){this.key=I,this.value=W,this.negated=M,this.type=4}static create(I,W,M=null){if(typeof W=="boolean")return W?S.create(I,M):p.create(I,M);const q=C.get(I);return typeof q=="boolean"?W===(q?"true":"false")?E.INSTANCE:R.INSTANCE:new u(I,W,M)}cmp(I){return I.type!==this.type?this.type-I.type:_(this.key,this.value,I.key,I.value)}equals(I){return I.type===this.type?this.key===I.key&&this.value===I.value:!1}substituteConstants(){const I=C.get(this.key);if(typeof I=="boolean"){const W=I?"true":"false";return this.value===W?E.INSTANCE:R.INSTANCE}return this}evaluate(I){return I.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(I){return I.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=u;class b{constructor(I,W){this.key=I,this.valueKey=W,this.type=10,this.negated=null}static create(I,W){return new b(I,W)}cmp(I){return I.type!==this.type?this.type-I.type:_(this.key,this.valueKey,I.key,I.valueKey)}equals(I){return I.type===this.type?this.key===I.key&&this.valueKey===I.valueKey:!1}substituteConstants(){return this}evaluate(I){const W=I.getValue(this.valueKey),M=I.getValue(this.key);return Array.isArray(W)?W.indexOf(M)>=0:typeof M=="string"&&typeof W=="object"&&W!==null?T.call(W,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(I){return I.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=f.create(this)),this.negated}}e.ContextKeyInExpr=b;class f{constructor(I){this._actual=I,this.type=11}static create(I){return new f(I)}cmp(I){return I.type!==this.type?this.type-I.type:this._actual.cmp(I._actual)}equals(I){return I.type===this.type?this._actual.equals(I._actual):!1}substituteConstants(){return this}evaluate(I){return!this._actual.evaluate(I)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(I){return new f(this._actual.map(I))}negate(){return this._actual}}e.ContextKeyNotInExpr=f;class d{constructor(I,W,M){this.key=I,this.value=W,this.negated=M,this.type=5}static create(I,W,M=null){if(typeof W=="boolean")return W?p.create(I,M):S.create(I,M);const q=C.get(I);return typeof q=="boolean"?W===(q?"true":"false")?R.INSTANCE:E.INSTANCE:new d(I,W,M)}cmp(I){return I.type!==this.type?this.type-I.type:_(this.key,this.value,I.key,I.value)}equals(I){return I.type===this.type?this.key===I.key&&this.value===I.value:!1}substituteConstants(){const I=C.get(this.key);if(typeof I=="boolean"){const W=I?"true":"false";return this.value===W?R.INSTANCE:E.INSTANCE}return this}evaluate(I){return I.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(I){return I.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=d;class p{constructor(I,W){this.key=I,this.negated=W,this.type=3}static create(I,W=null){const M=C.get(I);return typeof M=="boolean"?M?R.INSTANCE:E.INSTANCE:new p(I,W)}cmp(I){return I.type!==this.type?this.type-I.type:g(this.key,I.key)}equals(I){return I.type===this.type?this.key===I.key:!1}substituteConstants(){const I=C.get(this.key);return typeof I=="boolean"?I?R.INSTANCE:E.INSTANCE:this}evaluate(I){return!I.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(I){return I.mapNot(this.key)}negate(){return this.negated||(this.negated=S.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=p;function m(K,I){if(typeof K=="string"){const W=parseFloat(K);isNaN(W)||(K=W)}return typeof K=="string"||typeof K=="number"?I(K):R.INSTANCE}class y{constructor(I,W,M){this.key=I,this.value=W,this.negated=M,this.type=12}static create(I,W,M=null){return m(W,q=>new y(I,q,M))}cmp(I){return I.type!==this.type?this.type-I.type:_(this.key,this.value,I.key,I.value)}equals(I){return I.type===this.type?this.key===I.key&&this.value===I.value:!1}substituteConstants(){return this}evaluate(I){return typeof this.value=="string"?!1:parseFloat(I.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(I){return I.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=y;class c{constructor(I,W,M){this.key=I,this.value=W,this.negated=M,this.type=13}static create(I,W,M=null){return m(W,q=>new c(I,q,M))}cmp(I){return I.type!==this.type?this.type-I.type:_(this.key,this.value,I.key,I.value)}equals(I){return I.type===this.type?this.key===I.key&&this.value===I.value:!1}substituteConstants(){return this}evaluate(I){return typeof this.value=="string"?!1:parseFloat(I.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(I){return I.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=c;class o{constructor(I,W,M){this.key=I,this.value=W,this.negated=M,this.type=14}static create(I,W,M=null){return m(W,q=>new o(I,q,M))}cmp(I){return I.type!==this.type?this.type-I.type:_(this.key,this.value,I.key,I.value)}equals(I){return I.type===this.type?this.key===I.key&&this.value===I.value:!1}substituteConstants(){return this}evaluate(I){return typeof this.value=="string"?!1:parseFloat(I.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(I){return I.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=o;class l{constructor(I,W,M){this.key=I,this.value=W,this.negated=M,this.type=15}static create(I,W,M=null){return m(W,q=>new l(I,q,M))}cmp(I){return I.type!==this.type?this.type-I.type:_(this.key,this.value,I.key,I.value)}equals(I){return I.type===this.type?this.key===I.key&&this.value===I.value:!1}substituteConstants(){return this}evaluate(I){return typeof this.value=="string"?!1:parseFloat(I.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(I){return I.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=l;class i{constructor(I,W){this.key=I,this.regexp=W,this.type=7,this.negated=null}static create(I,W){return new i(I,W)}cmp(I){if(I.type!==this.type)return this.type-I.type;if(this.key<I.key)return-1;if(this.key>I.key)return 1;const W=this.regexp?this.regexp.source:"",M=I.regexp?I.regexp.source:"";return W<M?-1:W>M?1:0}equals(I){if(I.type===this.type){const W=this.regexp?this.regexp.source:"",M=I.regexp?I.regexp.source:"";return this.key===I.key&&W===M}return!1}substituteConstants(){return this}evaluate(I){let W=I.getValue(this.key);return this.regexp?this.regexp.test(W):!1}serialize(){const I=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${I}`}keys(){return[this.key]}map(I){return I.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=t.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class t{constructor(I){this._actual=I,this.type=8}static create(I){return new t(I)}cmp(I){return I.type!==this.type?this.type-I.type:this._actual.cmp(I._actual)}equals(I){return I.type===this.type?this._actual.equals(I._actual):!1}substituteConstants(){return this}evaluate(I){return!this._actual.evaluate(I)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(I){return new t(this._actual.map(I))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=t;function r(K){let I=null;for(let W=0,M=K.length;W<M;W++){const q=K[W].substituteConstants();if(K[W]!==q&&I===null){I=[];for(let Z=0;Z<W;Z++)I[Z]=K[Z]}I!==null&&(I[W]=q)}return I===null?K:I}class s{constructor(I,W){this.expr=I,this.negated=W,this.type=6}static create(I,W){return s._normalizeArr(I,W)}cmp(I){if(I.type!==this.type)return this.type-I.type;if(this.expr.length<I.expr.length)return-1;if(this.expr.length>I.expr.length)return 1;for(let W=0,M=this.expr.length;W<M;W++){const q=A(this.expr[W],I.expr[W]);if(q!==0)return q}return 0}equals(I){if(I.type===this.type){if(this.expr.length!==I.expr.length)return!1;for(let W=0,M=this.expr.length;W<M;W++)if(!this.expr[W].equals(I.expr[W]))return!1;return!0}return!1}substituteConstants(){const I=r(this.expr);return I===this.expr?this:s.create(I,this.negated)}evaluate(I){for(let W=0,M=this.expr.length;W<M;W++)if(!this.expr[W].evaluate(I))return!1;return!0}static _normalizeArr(I,W){const M=[];let q=!1;for(const Z of I)if(!!Z){if(Z.type===1){q=!0;continue}if(Z.type===0)return R.INSTANCE;if(Z.type===6){M.push(...Z.expr);continue}M.push(Z)}if(M.length===0&&q)return E.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(A);for(let Z=1;Z<M.length;Z++)M[Z-1].equals(M[Z])&&(M.splice(Z,1),Z--);if(M.length===1)return M[0];for(;M.length>1;){const Z=M[M.length-1];if(Z.type!==9)break;M.pop();const H=M.pop(),U=M.length===0,z=a.create(Z.expr.map(Q=>s.create([Q,H],null)),null,U);z&&(M.push(z),M.sort(A))}return M.length===1?M[0]:new s(M,W)}}serialize(){return this.expr.map(I=>I.serialize()).join(" && ")}keys(){const I=[];for(let W of this.expr)I.push(...W.keys());return I}map(I){return new s(this.expr.map(W=>W.map(I)),null)}negate(){if(!this.negated){const I=[];for(let W of this.expr)I.push(W.negate());this.negated=a.create(I,this,!0)}return this.negated}}class a{constructor(I,W){this.expr=I,this.negated=W,this.type=9}static create(I,W,M){return a._normalizeArr(I,W,M)}cmp(I){if(I.type!==this.type)return this.type-I.type;if(this.expr.length<I.expr.length)return-1;if(this.expr.length>I.expr.length)return 1;for(let W=0,M=this.expr.length;W<M;W++){const q=A(this.expr[W],I.expr[W]);if(q!==0)return q}return 0}equals(I){if(I.type===this.type){if(this.expr.length!==I.expr.length)return!1;for(let W=0,M=this.expr.length;W<M;W++)if(!this.expr[W].equals(I.expr[W]))return!1;return!0}return!1}substituteConstants(){const I=r(this.expr);return I===this.expr?this:a.create(I,this.negated,!1)}evaluate(I){for(let W=0,M=this.expr.length;W<M;W++)if(this.expr[W].evaluate(I))return!0;return!1}static _normalizeArr(I,W,M){let q=[],Z=!1;if(I){for(let H=0,U=I.length;H<U;H++){const z=I[H];if(!!z){if(z.type===0){Z=!0;continue}if(z.type===1)return E.INSTANCE;if(z.type===9){q=q.concat(z.expr);continue}q.push(z)}}if(q.length===0&&Z)return R.INSTANCE;q.sort(A)}if(q.length!==0){if(q.length===1)return q[0];for(let H=1;H<q.length;H++)q[H-1].equals(q[H])&&(q.splice(H,1),H--);if(q.length===1)return q[0];if(M){for(let H=0;H<q.length;H++)for(let U=H+1;U<q.length;U++)F(q[H],q[U])&&(q.splice(U,1),U--);if(q.length===1)return q[0]}return new a(q,W)}}serialize(){return this.expr.map(I=>I.serialize()).join(" || ")}keys(){const I=[];for(let W of this.expr)I.push(...W.keys());return I}map(I){return new a(this.expr.map(W=>W.map(I)),null)}negate(){if(!this.negated){let I=[];for(let W of this.expr)I.push(W.negate());for(;I.length>1;){const W=I.shift(),M=I.shift(),q=[];for(const H of $(W))for(const U of $(M))q.push(s.create([H,U],null));const Z=I.length===0;I.unshift(a.create(q,null,Z))}this.negated=I[0]}return this.negated}}class h extends S{constructor(I,W,M){super(I,null);this._defaultValue=W,typeof M=="object"?h._info.push({...M,key:I}):M!==!0&&h._info.push({key:I,description:M,type:W!=null?typeof W:void 0})}static all(){return h._info.values()}bindTo(I){return I.createKey(this.key,this._defaultValue)}getValue(I){return I.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(I){return u.create(this.key,I)}notEqualsTo(I){return d.create(this.key,I)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,w.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function g(K,I){return K<I?-1:K>I?1:0}function _(K,I,W,M){return K<W?-1:K>W?1:I<M?-1:I>M?1:0}function F(K,I){if(I.type===6&&K.type!==9&&K.type!==6){for(const q of I.expr)if(K.equals(q))return!0}const W=K.negate(),M=$(W).concat($(I));M.sort(A);for(let q=0;q<M.length;q++){const H=M[q].negate();for(let U=q+1;U<M.length;U++){const z=M[U];if(H.equals(z))return!0}}return!1}e.implies=F;function $(K){return K.type===9?K.expr:[K]}}),define(ve[64],we([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,k.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,k.createDecorator)("credentialsMainService");class n{constructor(){this.secretVault={}}async getPassword(C,T){return this.secretVault[C]?.[T]??null}async setPassword(C,T,D){this.secretVault[C]=this.secretVault[C]??{},this.secretVault[C][T]=D}async deletePassword(C,T){return this.secretVault[C]?.[T]?(delete this.secretVault[C][T],Object.keys(this.secretVault[C]).length===0&&delete this.secretVault[C],!0):!1}async findPassword(C){return JSON.stringify(this.secretVault[C])??null}async findCredentials(C){const T=[];for(const D of Object.keys(this.secretVault[C]||{}))T.push({account:D,password:this.secretVault[C][D]});return T}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=n}),define(ve[182],we([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,k.createDecorator)(e.ID);function n(C){return!!C.hostName&&!!C.errorMessage}e.isRemoteDiagnosticError=n;class w{async getPerformanceInfo(T,D){return{}}async getSystemInfo(T,D){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,D){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.NullDiagnosticsService=w}),define(ve[65],we([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,k.createDecorator)("downloadService")}),define(ve[183],we([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,k.createDecorator)("encryptionMainService")}),define(ve[27],we([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,k.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,k.refineServiceDecorator)(e.IEnvironmentService)}),define(ve[30],we([0,1,150,6]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function w(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=w;function C(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=C;function T(d,p){switch(d){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function D(d,p){return p==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=D;function v(d,p,m){return D(p,m)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===m?!0:P(m).includes(d)}e.isTargetPlatformCompatible=v;function P(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=P;function A(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=A;var R;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(R=e.SortBy||(e.SortBy={}));var E;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(E=e.SortOrder||(e.SortOrder={}));var S;(function(d){d.Install="install",d.Uninstall="uninstall"})(S=e.StatisticType||(e.StatisticType={}));var u;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(u=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,n.createDecorator)("extensionGalleryService");var b;(function(d){d.Unsupported="Unsupported",d.UnsupportedPreRelease="UnsupportedPreRelease",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Internal="Internal"})(b=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class f extends Error{constructor(p,m){super(p);this.code=m,this.name=m}}e.ExtensionManagementError=f,e.IExtensionManagementService=(0,n.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,n.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,n.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,k.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,k.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,n.createDecorator)("IExtensionManagementCLIService")}),define(ve[184],we([0,1,7,2,22,4,61,30]),function(ee,e,k,n,w,C,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function v(b,f){return C.URI.revive(f?f.transformIncoming(b):b)}function P(b,f){return f?f.transformOutgoingURI(b):b}function A(b,f){f=f||T.DefaultURITransformer;const d=b.manifest;return{...(0,T.transformAndReviveIncomingURIs)({...b,manifest:void 0},f),manifest:d}}function R(b,f){return f?(0,w.cloneAndChange)(b,d=>d instanceof C.URI?f.transformOutgoingURI(d):void 0):b}class E{constructor(f,d){this.service=f,this.getUriTransformer=d,this.onInstallExtension=k.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=k.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=k.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=k.Event.buffer(f.onDidUninstallExtension,!0)}listen(f,d){const p=this.getUriTransformer(f);switch(d){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return k.Event.map(this.onDidInstallExtensions,m=>m.map(y=>({...y,local:y.local?R(y.local,p):y.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(f,d,p){const m=this.getUriTransformer(f);switch(d){case"zip":return this.service.zip(A(p[0],m)).then(y=>P(y,m));case"unzip":return this.service.unzip(v(p[0],m));case"install":return this.service.install(v(p[0],m),p[1]);case"getManifest":return this.service.getManifest(v(p[0],m));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(p[0]);case"installFromGallery":return this.service.installFromGallery(p[0],p[1]);case"uninstall":return this.service.uninstall(A(p[0],m),p[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(A(p[0],m));case"getInstalled":return this.service.getInstalled(p[0]).then(y=>y.map(c=>R(c,m)));case"updateMetadata":return this.service.updateMetadata(A(p[0],m),p[1]).then(y=>R(y,m));case"updateExtensionScope":return this.service.updateExtensionScope(A(p[0],m),p[1]).then(y=>R(y,m));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=E;class S extends n.Disposable{constructor(f){super();this.channel=f,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(d=>this._onInstallExtension.fire({identifier:d.identifier,source:this.isUriComponents(d.source)?C.URI.revive(d.source):d.source}))),this._register(this.channel.listen("onDidInstallExtensions")(d=>this._onDidInstallExtensions.fire(d.map(p=>({...p,local:p.local?A(p.local,null):p.local,source:this.isUriComponents(p.source)?C.URI.revive(p.source):p.source}))))),this._register(this.channel.listen("onUninstallExtension")(d=>this._onUninstallExtension.fire(d))),this._register(this.channel.listen("onDidUninstallExtension")(d=>this._onDidUninstallExtension.fire(d)))}isUriComponents(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(f){const d=await this.getTargetPlatform();return f.allTargetPlatforms.some(p=>(0,D.isTargetPlatformCompatible)(p,f.allTargetPlatforms,d))}zip(f){return Promise.resolve(this.channel.call("zip",[f]).then(d=>C.URI.revive(d)))}unzip(f){return Promise.resolve(this.channel.call("unzip",[f]))}install(f,d){return Promise.resolve(this.channel.call("install",[f,d])).then(p=>A(p,null))}getManifest(f){return Promise.resolve(this.channel.call("getManifest",[f]))}installFromGallery(f,d){return Promise.resolve(this.channel.call("installFromGallery",[f,d])).then(p=>A(p,null))}uninstall(f,d){return Promise.resolve(this.channel.call("uninstall",[f,d]))}reinstallFromGallery(f){return Promise.resolve(this.channel.call("reinstallFromGallery",[f]))}getInstalled(f=null){return Promise.resolve(this.channel.call("getInstalled",[f])).then(d=>d.map(p=>A(p,null)))}updateMetadata(f,d){return Promise.resolve(this.channel.call("updateMetadata",[f,d])).then(p=>A(p,null))}updateExtensionScope(f,d){return Promise.resolve(this.channel.call("updateExtensionScope",[f,d])).then(p=>A(p,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=S;class u{constructor(f){this.service=f}listen(f,d){throw new Error("Invalid listen")}call(f,d,p){switch(d){case"getConfigBasedTips":return this.service.getConfigBasedTips(C.URI.revive(p[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=u}),define(ve[17],we([0,1,9,31,5,15,12,4,157,6]),function(ee,e,k,n,w,C,T,D,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");function A(U){return U.create===!0}e.isFileOpenForWriteOptions=A;var R;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var E;(function(U){U[U.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var S;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead",U[U.FileClone=32768]="FileClone"})(S=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function u(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=u;function b(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=b;function f(U){return!!(U.capabilities&32768)}e.hasFileCloneCapability=f;function d(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function p(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=p;function m(U){return u(U)?!!(U.capabilities&16384):!1}e.hasFileAtomicReadCapability=m;var y;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(y=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(z,Q){super(z);this.code=Q}}e.FileSystemProviderError=c;function o(U,z){const Q=new c(U.toString(),z);return i(Q,z),Q}e.createFileSystemProviderError=o;function l(U){return U||o((0,v.localize)(0,null),y.Unknown)}e.ensureFileSystemProviderError=l;function i(U,z){return U.name=z?`${z} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=i;function t(U){if(!U)return y.Unknown;if(U instanceof c)return U.code;const z=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!z)return y.Unknown;switch(z[1]){case y.FileExists:return y.FileExists;case y.FileIsADirectory:return y.FileIsADirectory;case y.FileNotADirectory:return y.FileNotADirectory;case y.FileNotFound:return y.FileNotFound;case y.FileExceedsMemoryLimit:return y.FileExceedsMemoryLimit;case y.FileTooLarge:return y.FileTooLarge;case y.FileWriteLocked:return y.FileWriteLocked;case y.NoPermissions:return y.NoPermissions;case y.Unavailable:return y.Unavailable}return y.Unknown}e.toFileSystemProviderErrorCode=t;function r(U){if(U instanceof F)return U.fileOperationResult;switch(t(U)){case y.FileNotFound:return 1;case y.FileIsADirectory:return 0;case y.FileNotADirectory:return 10;case y.FileWriteLocked:return 5;case y.NoPermissions:return 6;case y.FileExists:return 4;case y.FileExceedsMemoryLimit:return 9;case y.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY",U[U.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class a{constructor(z,Q,ie){this.resource=z,this.operation=Q,this.target=ie}isOperation(z){return this.operation===z}}e.FileOperationEvent=a;var h;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(h=e.FileChangeType||(e.FileChangeType={}));class g{constructor(z,Q){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=z;const ie=new Map;for(const re of z){const ce=ie.get(re.type);switch(ce?ce.push([re.resource,re]):ie.set(re.type,[[re.resource,re]]),re.type){case 1:this.rawAdded.push(re.resource);break;case 0:this.rawUpdated.push(re.resource);break;case 2:this.rawDeleted.push(re.resource);break}}for(const[re,ce]of ie)switch(re){case 1:this.added=n.TernarySearchTree.forUris(()=>Q),this.added.fill(ce);break;case 0:this.updated=n.TernarySearchTree.forUris(()=>Q),this.updated.fill(ce);break;case 2:this.deleted=n.TernarySearchTree.forUris(()=>Q),this.deleted.fill(ce);break}}contains(z,...Q){return this.doContains(z,{includeChildren:!1},...Q)}affects(z,...Q){return this.doContains(z,{includeChildren:!0},...Q)}doContains(z,Q,...ie){if(!z)return!1;const re=ie.length>0;return!!((!re||ie.includes(1))&&(this.added?.get(z)||Q.includeChildren&&this.added?.findSuperstr(z))||(!re||ie.includes(0))&&(this.updated?.get(z)||Q.includeChildren&&this.updated?.findSuperstr(z))||(!re||ie.includes(2))&&(this.deleted?.findSubstr(z)||Q.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=g;function _(U,z,Q){return!U||!z||U===z||z.length>U.length?!1:(z.charAt(z.length-1)!==w.sep&&(z+=w.sep),Q?(0,C.startsWithIgnoreCase)(U,z):U.indexOf(z)===0)}e.isParent=_;class F extends k.ErrorNoTelemetry{constructor(z,Q,ie){super(z);this.fileOperationResult=Q,this.options=ie}}e.FileOperationError=F;class $ extends F{constructor(z,Q,ie){super(z,2,ie);this.stat=Q}}e.NotModifiedSinceFileOperationError=$;var K;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(K=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var I;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(I=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function W(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=W;async function M(U,z){if(!z.hasProvider(D.URI.from({scheme:U.scheme})))return new Promise(Q=>{const ie=z.onDidChangeFileSystemProviderRegistrations(re=>{re.scheme===U.scheme&&re.added&&(ie.dispose(),Q())})})}e.whenProviderRegistered=M,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class q{static formatSize(z){return(0,T.isNumber)(z)||(z=0),z<q.KB?(0,v.localize)(1,null,z.toFixed(0)):z<q.MB?(0,v.localize)(2,null,(z/q.KB).toFixed(2)):z<q.GB?(0,v.localize)(3,null,(z/q.MB).toFixed(2)):z<q.TB?(0,v.localize)(4,null,(z/q.GB).toFixed(2)):(0,v.localize)(5,null,(z/q.TB).toFixed(2))}}e.ByteSize=q,q.KB=1024,q.MB=q.KB*q.KB,q.GB=q.MB*q.KB,q.TB=q.GB*q.KB;var Z;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(Z=e.Arch||(e.Arch={}));function H(U){return{maxFileSize:U===0?300*q.MB:16*q.GB,maxHeapSize:U===0?700*q.MB:2*700*q.MB}}e.getPlatformLimits=H}),define(ve[185],we([0,1,16,36,9,7,2,43,4,23,17]),function(ee,e,k,n,w,C,T,D,v,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class R extends T.Disposable{constructor(S,u){super();this.channel=S,this.extraCapabilities=u,this.onDidChangeCapabilities=C.Event.None,this._onDidChange=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,P.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(S){return this.channel.call("stat",[S])}readdir(S){return this.channel.call("readdir",[S])}async readFile(S,u){const{buffer:b}=await this.channel.call("readFile",[S,u]);return b}readFileStream(S,u,b){const f=(0,D.newWriteableStream)(p=>k.VSBuffer.concat(p.map(m=>k.VSBuffer.wrap(m))).buffer),d=this.channel.listen("readFileStream",[S,u])(p=>{if(p instanceof k.VSBuffer)f.write(p.buffer);else{if(p==="end")f.end();else{let m=p;m instanceof Error||(m=(0,A.createFileSystemProviderError)((0,n.toErrorMessage)(m),A.FileSystemProviderErrorCode.Unknown)),f.error(m),f.end()}d.dispose()}});return b.onCancellationRequested(()=>{f.error((0,w.canceled)()),f.end(),d.dispose()}),f}writeFile(S,u,b){return this.channel.call("writeFile",[S,k.VSBuffer.wrap(u),b])}open(S,u){return this.channel.call("open",[S,u])}close(S){return this.channel.call("close",[S])}async read(S,u,b,f,d){const[p,m]=await this.channel.call("read",[S,u,d]);return b.set(p.buffer.slice(0,m),f),m}write(S,u,b,f,d){return this.channel.call("write",[S,u,k.VSBuffer.wrap(b),f,d])}mkdir(S){return this.channel.call("mkdir",[S])}delete(S,u){return this.channel.call("delete",[S,u])}rename(S,u,b){return this.channel.call("rename",[S,u,b])}copy(S,u,b){return this.channel.call("copy",[S,u,b])}cloneFile(S,u){return this.channel.call("cloneFile",[S,u])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(S=>{if(Array.isArray(S)){const u=S;this._onDidChange.fire(u.map(b=>({resource:v.URI.revive(b.resource),type:b.type})))}else{const u=S;this._onDidWatchError.fire(u)}}))}watch(S,u){const b=(0,P.generateUuid)();return this.channel.call("watch",[this.sessionId,b,S,u]),(0,T.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,b]))}}e.DiskFileSystemProviderClient=R}),define(ve[90],we([0,1,16,9,158,17]),function(ee,e,k,n,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(A,R,E,S,u,b){let f;try{await D(A,R,E,S,u,b)}catch(d){f=d}finally{f&&u.errorTransformer&&(f=u.errorTransformer(f)),typeof f!="undefined"&&E.error(f),E.end()}}e.readFileIntoStream=T;async function D(A,R,E,S,u,b){v(b);const f=await A.open(R,{create:!1});try{v(b);let d=0,p=0,m=u&&typeof u.length=="number"?u.length:void 0,y=k.VSBuffer.alloc(Math.min(u.bufferSize,typeof m=="number"?m:u.bufferSize)),c=u&&typeof u.position=="number"?u.position:0,o=0;do p=await A.read(f,c,y.buffer,o,y.byteLength-o),c+=p,o+=p,d+=p,typeof m=="number"&&(m-=p),o===y.byteLength&&(await E.write(S(y)),y=k.VSBuffer.alloc(Math.min(u.bufferSize,typeof m=="number"?m:u.bufferSize)),o=0);while(p>0&&(typeof m!="number"||m>0)&&v(b)&&P(d,u));if(o>0){let l=o;typeof m=="number"&&(l=Math.min(o,m)),E.write(S(y.slice(0,l)))}}catch(d){throw(0,C.ensureFileSystemProviderError)(d)}finally{await A.close(f)}}function v(A){if(A.isCancellationRequested)throw(0,n.canceled)();return!0}function P(A,R){if(R?.limits){if(typeof R.limits.memory=="number"&&A>R.limits.memory)throw(0,C.createFileSystemProviderError)((0,w.localize)(0,null),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof R.limits.size=="number"&&A>R.limits.size)throw(0,C.createFileSystemProviderError)((0,w.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ve[54],we([0,1,2,3,4,17]),function(ee,e,k,n,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function T(S){return S.recursive===!0}e.isRecursiveWatchRequest=T;class D extends k.Disposable{constructor(u,b,f,d){super();this.onFileChanges=u,this.onLogMessage=b,this.verboseLogging=f,this.options=d,this.watcherDisposables=this._register(new k.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const u=new k.DisposableStore;this.watcherDisposables.value=u,this.watcher=this.createWatcher(u),this.watcher.setVerboseLogging(this.verboseLogging),u.add(this.watcher.onDidChangeFile(b=>this.onFileChanges(b))),u.add(this.watcher.onDidLogMessage(b=>this.onLogMessage(b))),u.add(this.watcher.onDidError(b=>this.onError(b)))}onError(u){this.options.restartOnError?this.restartCounter<D.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${u}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${u}`):this.error(u)}restart(u){this.restartCounter++,this.init(),this.watch(u)}async watch(u){this.requests=u,await this.watcher?.watch(u)}async setVerboseLogging(u){this.verboseLogging=u,await this.watcher?.setVerboseLogging(u)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${u}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=D,D.MAX_RESTARTS=5;class v extends D{constructor(u,b,f){super(u,b,f,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=v;class P extends D{constructor(u,b,f){super(u,b,f,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=P;function A(S){return S.map(u=>({type:u.type,resource:w.URI.file(u.path)}))}e.toFileChanges=A;function R(S){const u=new E;for(const b of S)u.processEvent(b);return u.coalesce()}e.coalesceEvents=R;class E{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(u){return n.isLinux?u.path:u.path.toLowerCase()}processEvent(u){const b=this.mapPathToChange.get(this.toKey(u));let f=!1;if(b){const d=b.type,p=u.type;b.path!==u.path&&(u.type===2||u.type===1)?f=!0:d===1&&p===2?(this.mapPathToChange.delete(this.toKey(u)),this.coalesced.delete(b)):d===2&&p===1?b.type=0:d===1&&p===0||(b.type=p)}else f=!0;f&&(this.coalesced.add(u),this.mapPathToChange.set(this.toKey(u),u))}coalesce(){const u=[],b=[];return Array.from(this.coalesced).filter(f=>f.type!==2?(u.push(f),!1):!0).sort((f,d)=>f.path.length-d.path.length).filter(f=>b.some(d=>(0,C.isParent)(f.path,d,!n.isLinux))?!1:(b.push(f.path),!0)).concat(u)}}}),define(ve[186],we([0,1,29,14,21,33,77,2,75,5,3,133,19,54]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class u extends D.Disposable{constructor(d,p,m,y){super();this.request=d,this.onDidFilesChange=p,this.onLogMessage=m,this.verboseLogging=y,this.throttledFileChangesWorker=new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},c=>this.onDidFilesChange(c)),this.fileChangesDelayer=this._register(new n.ThrottledDelayer(u.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(c=>(0,T.parse)(c)),this.cts=new w.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const d=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const p=await E.Promises.stat(d);this._register(await this.doWatch(d,p.isDirectory()))}catch(d){d.code!=="ENOENT"?this.error(d):this.trace(d)}}async normalizePath(d){let p=d.path;try{p=await E.Promises.realpath(d.path),d.path===p&&(p=await(0,R.realcase)(d.path)??d.path),d.path!==p&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${p})`)}catch{}return p}async doWatch(d,p){if(A.isMacintosh&&(0,C.isEqualOrParent)(d,"/Volumes/",!0))return this.error(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const m=new w.CancellationTokenSource(this.cts.token);let y=new D.DisposableStore;try{const c=(0,P.basename)(d),o=(0,k.watch)(d);y.add((0,D.toDisposable)(()=>{o.removeAllListeners(),o.close()})),this.trace(`Started watching: '${d}'`);const l=new Set;if(p)try{for(const t of await E.Promises.readdir(d))l.add(t)}catch(t){this.error(t)}const i=new Map;y.add((0,D.toDisposable)(()=>{for(const[,t]of i)t.dispose();i.clear()})),o.on("error",(t,r)=>{this.error(`Failed to watch ${d} for changes using fs.watch() (${t}, ${r})`),this.dispose()}),o.on("change",(t,r)=>{if(m.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${r}`);let s="";if(r&&(s=r.toString(),A.isMacintosh&&(s=(0,v.normalizeNFC)(s))),!(!s||t!=="change"&&t!=="rename"))if(p)if(t==="rename"){i.get(s)?.dispose();const a=setTimeout(async()=>{if(i.delete(s),s===c&&!await E.Promises.exists(d)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const h=await this.existsChildStrictCase((0,P.join)(d,s));if(m.token.isCancellationRequested)return;let g;h?l.has(s)?g=0:(g=1,l.add(s)):(l.delete(s),g=2),this.onFileChange({path:(0,P.join)(this.request.path,s),type:g})},u.FILE_DELETE_HANDLER_DELAY);i.set(s,(0,D.toDisposable)(()=>clearTimeout(a)))}else{let a;l.has(s)?a=0:(a=1,l.add(s)),this.onFileChange({path:(0,P.join)(this.request.path,s),type:a})}else if(t==="rename"||s!==c){const a=setTimeout(async()=>{const h=await E.Promises.exists(d);m.token.isCancellationRequested||(h?(this.onFileChange({path:this.request.path,type:0},!0),y.add(await this.doWatch(d,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},u.FILE_DELETE_HANDLER_DELAY);y.clear(),y.add((0,D.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(c){await E.Promises.exists(d)&&!m.token.isCancellationRequested&&this.error(`Failed to watch ${d} for changes using fs.watch() (${c.toString()})`)}return(0,D.toDisposable)(()=>{m.dispose(!0),y.dispose()})}async onFileChange(d,p=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`),!p&&this.excludes.some(m=>m(d.path))?this.verboseLogging&&this.trace(` >> ignored ${d.path}`):this.fileChangesBuffer.push(d);try{await this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const y=(0,S.coalesceEvents)(m);if(y.length>0){if(this.verboseLogging)for(const o of y)this.trace(`>> normalized ${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.path}`);this.throttledFileChangesWorker.work(y)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${y[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${y.length}, most recent change: ${y[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(d){if(A.isLinux)return E.Promises.exists(d);try{const p=(0,P.basename)(d);return(await E.Promises.readdir((0,P.dirname)(d))).some(y=>y===p)}catch(p){return this.trace(p),!1}}setVerboseLogging(d){this.verboseLogging=d}error(d){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}warn(d){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}trace(d){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=u,u.FILE_DELETE_HANDLER_DELAY=100,u.FILE_CHANGES_HANDLER_DELAY=50;async function b(f,d,p,m,y=512){const c=await E.Promises.open(f,"r"),o=Buffer.allocUnsafe(y),l=new w.CancellationTokenSource(m);let i,t=!1;const r={path:f,excludes:[],recursive:!1},s=new u(r,a=>{(async()=>{for(const{type:h}of a)if(h===0){if(t)return;t=!0;try{for(;!l.token.isCancellationRequested;){const{bytesRead:g}=await E.Promises.read(c,o,0,y,null);if(!g||l.token.isCancellationRequested)break;d(o.slice(0,g))}}catch(g){i=new Error(g),l.dispose(!0)}finally{t=!1}}})()});return await s.ready,p(),new Promise((a,h)=>{l.token.onCancellationRequested(async()=>{s.dispose();try{await E.Promises.close(c)}catch(g){i=new Error(g)}i?h(i):a()})})}e.watchFileContents=b}),define(ve[187],we([0,1,18,7,2,3,186]),function(ee,e,k,n,w,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class D extends w.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new n.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new n.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=n.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(P){const A=this.normalizeRequests(P),R=A.filter(S=>{const u=this.watchers.get(S.path);return u?!(0,k.equals)(u.request.excludes,S.excludes):!0}),E=Array.from(this.watchers.values()).filter(({request:S})=>!A.find(u=>u.path===S.path&&(0,k.equals)(u.excludes,S.excludes))).map(({request:S})=>S.path);R.length&&this.trace(`Request to start watching: ${R.map(S=>`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"})`).join(",")}`),E.length&&this.trace(`Request to stop watching: ${E.join(",")}`);for(const S of E)this.stopWatching(S);for(const S of R)this.startWatching(S)}startWatching(P){const A=new T.NodeJSFileWatcherLibrary(P,E=>this._onDidChangeFile.fire(E),E=>this._onDidLogMessage.fire(E),this.verboseLogging),R={request:P,instance:A};this.watchers.set(P.path,R)}async stop(){for(const[P]of this.watchers)this.stopWatching(P);this.watchers.clear()}stopWatching(P){const A=this.watchers.get(P);A&&(this.watchers.delete(P),A.instance.dispose())}normalizeRequests(P){const A=new Map;for(const R of P){const E=C.isLinux?R.path:R.path.toLowerCase();A.set(E,R)}return Array.from(A.values())}async setVerboseLogging(P){this.verboseLogging=P;for(const[,A]of this.watchers)A.instance.setVerboseLogging(P)}trace(P){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(P)})}toMessage(P,A){return A?`[File Watcher (node.js)] ${P} (path: ${A.request.path})`:`[File Watcher (node.js)] ${P}`}}e.NodeJSWatcher=D}),define(ve[188],we([0,1,54,187]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class w extends k.AbstractNonRecursiveWatcherClient{constructor(T,D,v){super(T,D,v);this.init()}createWatcher(){return new n.NodeJSWatcher}}e.NodeJSWatcherClient=w}),define(ve[189],we([0,1,8,39,87,54]),function(ee,e,k,n,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends C.AbstractUniversalWatcherClient{constructor(v,P,A){super(v,P,A);this.init()}createWatcher(v){const P=v.add(new w.Client(k.FileAccess.asFileUri("bootstrap-fork",ee).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return v.add(P.onDidProcessExit(({code:A,signal:R})=>this.onError(`terminated by itself with code ${A}, signal: ${R}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(P.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(ve[66],we([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class k{constructor(...w){this._entries=new Map;for(let[C,T]of w)this.set(C,T)}set(w,C){const T=this._entries.get(w);return this._entries.set(w,C),T}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}e.ServiceCollection=k}),define(ve[91],we([0,1,14,9,53,181,6,66]),function(ee,e,k,n,w,C,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const v=!1;class P extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class A{constructor(u=new D.ServiceCollection,b=!1,f){this._activeInstantiations=new Set,this._services=u,this._strict=b,this._parent=f,this._services.set(T.IInstantiationService,this)}createChild(u){return new A(u,this._strict,this)}invokeFunction(u,...b){let f=E.traceInvocation(u),d=!1;try{return u({get:m=>{if(d)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const y=this._getOrCreateServiceInstance(m,f);if(!y)throw new Error(`[invokeFunction] unknown service '${m}'`);return y}},...b)}finally{d=!0,f.stop()}}createInstance(u,...b){let f,d;return u instanceof w.SyncDescriptor?(f=E.traceCreation(u.ctor),d=this._createInstance(u.ctor,u.staticArguments.concat(b),f)):(f=E.traceCreation(u),d=this._createInstance(u,b,f)),f.stop(),d}_createInstance(u,b=[],f){let d=T._util.getServiceDependencies(u).sort((y,c)=>y.index-c.index),p=[];for(const y of d){let c=this._getOrCreateServiceInstance(y.id,f);c||this._throwIfStrict(`[createInstance] ${u.name} depends on UNKNOWN service ${y.id}.`,!1),p.push(c)}let m=d.length>0?d[0].index:b.length;if(b.length!==m){console.trace(`[createInstance] First service dependency of ${u.name} at position ${m+1} conflicts with ${b.length} static arguments`);let y=m-b.length;y>0?b=b.concat(new Array(y)):b=b.slice(0,m)}return new u(...[...b,...p])}_setServiceInstance(u,b){if(this._services.get(u)instanceof w.SyncDescriptor)this._services.set(u,b);else if(this._parent)this._parent._setServiceInstance(u,b);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let b=this._services.get(u);return!b&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):b}_getOrCreateServiceInstance(u,b){let f=this._getServiceInstanceOrDescriptor(u);return f instanceof w.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,f,b.branch(u,!0)):(b.branch(u,!1),f)}_safeCreateAndCacheServiceInstance(u,b,f){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,b,f)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,b,f){const d=new C.Graph(y=>y.id.toString());let p=0;const m=[{id:u,desc:b,_trace:f}];for(;m.length;){const y=m.pop();if(d.lookupOrInsertNode(y),p++>1e3)throw new P(d);for(let c of T._util.getServiceDependencies(y.desc.ctor)){let o=this._getServiceInstanceOrDescriptor(c.id);if(o||this._throwIfStrict(`[createInstance] ${u} depends on ${c.id} which is NOT registered.`,!0),o instanceof w.SyncDescriptor){const l={id:c.id,desc:o,_trace:y._trace.branch(c.id,!0)};d.insertEdge(y,l),m.push(l)}}}for(;;){const y=d.roots();if(y.length===0){if(!d.isEmpty())throw new P(d);break}for(const{data:c}of y){if(this._getServiceInstanceOrDescriptor(c.id)instanceof w.SyncDescriptor){const l=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,l)}d.removeNode(c)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,b,f=[],d,p){if(this._services.get(u)instanceof w.SyncDescriptor)return this._createServiceInstance(b,f,d,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,b,f,d,p);throw new Error(`illegalState - creating UNKNOWN service instance ${b.name}`)}_createServiceInstance(u,b=[],f,d){if(f){const p=new k.IdleValue(()=>this._createInstance(u,b,d));return new Proxy(Object.create(null),{get(m,y){if(y in m)return m[y];let c=p.value,o=c[y];return typeof o!="function"||(o=o.bind(c),m[y]=o),o},set(m,y,c){return p.value[y]=c,!0}})}else return this._createInstance(u,b,d)}_throwIfStrict(u,b){if(b&&console.warn(b),this._strict)throw new Error(u)}}e.InstantiationService=A;var R;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(R||(R={}));class E{constructor(u,b){this.type=u,this.name=b,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return v?new E(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):E._None}static traceCreation(u){return v?new E(0,u.name):E._None}branch(u,b){let f=new E(2,u.toString());return this._dep.push([u,b,f]),f}stop(){let u=Date.now()-this._start;E._totals+=u;let b=!1;function f(p,m){let y=[],c=new Array(p+1).join("	");for(const[o,l,i]of m._dep)if(l&&i){b=!0,y.push(`${c}CREATES -> ${o}`);let t=f(p+1,i);t&&y.push(t)}else y.push(`${c}uses -> ${o}`);return y.join(`
`)}let d=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${E._totals.toFixed(2)}ms)`];(u>2||b)&&console.log(d.join(`
`))}}e.Trace=E,E._None=new class extends E{constructor(){super(-1,null)}stop(){}branch(){return this}},E._totals=0}),define(ve[190],we([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILabelService=void 0,e.ILabelService=(0,k.createDecorator)("labelService")}),define(ve[67],we([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,k.createDecorator)("localizationsService");function n(w){if(typeof w.languageId!="string"||!Array.isArray(w.translations)||w.translations.length===0)return!1;for(const C of w.translations)if(typeof C.id!="string"||typeof C.path!="string")return!1;return!(w.languageName&&typeof w.languageName!="string"||w.localizedLanguageName&&typeof w.localizedLanguageName!="string")}e.isValidLocalization=n}),define(ve[13],we([0,1,36,7,2,3,6]),function(ee,e,k,n,w,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function D(){return new Date().toISOString()}var v;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(v=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=v.Info;function P(l,i,t){switch(i){case v.Trace:l.trace(t);break;case v.Debug:l.debug(t);break;case v.Info:l.info(t);break;case v.Warning:l.warn(t);break;case v.Error:l.error(t);break;case v.Critical:l.critical(t);break;default:throw new Error("Invalid log level")}}e.log=P;function A(l){let i="";for(let t=0;t<l.length;t++){let r=l[t];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}i+=(t>0?" ":"")+r}return i}e.format=A;class R extends w.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=R;class E extends R{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...t){this.checkLogLevel(v.Trace)&&this.log(v.Trace,A([i,...t]))}debug(i,...t){this.checkLogLevel(v.Debug)&&this.log(v.Debug,A([i,...t]))}info(i,...t){this.checkLogLevel(v.Info)&&this.log(v.Info,A([i,...t]))}warn(i,...t){this.checkLogLevel(v.Warning)&&this.log(v.Warning,A([i,...t]))}error(i,...t){if(this.checkLogLevel(v.Error))if(i instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=i.stack,this.log(v.Error,A(r))}else this.log(v.Error,A([i,...t]))}critical(i,...t){this.checkLogLevel(v.Critical)&&this.log(v.Critical,A([i,...t]))}flush(){}}e.AbstractMessageLogger=E;class S extends R{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!C.isWindows}trace(i,...t){this.getLevel()<=v.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,i,...t):console.log(`[main ${D()}]`,i,...t))}debug(i,...t){this.getLevel()<=v.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,i,...t):console.log(`[main ${D()}]`,i,...t))}info(i,...t){this.getLevel()<=v.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,i,...t):console.log(`[main ${D()}]`,i,...t))}warn(i,...t){this.getLevel()<=v.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,i,...t):console.warn(`[main ${D()}]`,i,...t))}error(i,...t){this.getLevel()<=v.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,i,...t):console.error(`[main ${D()}]`,i,...t))}critical(i,...t){this.getLevel()<=v.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,i,...t):console.error(`[main ${D()}]`,i,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class u extends R{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...t){this.getLevel()<=v.Trace&&console.log("%cTRACE","color: #888",i,...t)}debug(i,...t){this.getLevel()<=v.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...t)}info(i,...t){this.getLevel()<=v.Info&&console.log("%c INFO","color: #33f",i,...t)}warn(i,...t){this.getLevel()<=v.Warning&&console.log("%c WARN","color: #993",i,...t)}error(i,...t){this.getLevel()<=v.Error&&console.log("%c  ERR","color: #f33",i,...t)}critical(i,...t){this.getLevel()<=v.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...t)}dispose(){}flush(){}}e.ConsoleLogger=u;class b extends R{constructor(i,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(t)}trace(i,...t){this.getLevel()<=v.Trace&&this.adapter.log(v.Trace,[this.extractMessage(i),...t])}debug(i,...t){this.getLevel()<=v.Debug&&this.adapter.log(v.Debug,[this.extractMessage(i),...t])}info(i,...t){this.getLevel()<=v.Info&&this.adapter.log(v.Info,[this.extractMessage(i),...t])}warn(i,...t){this.getLevel()<=v.Warning&&this.adapter.log(v.Warning,[this.extractMessage(i),...t])}error(i,...t){this.getLevel()<=v.Error&&this.adapter.log(v.Error,[this.extractMessage(i),...t])}critical(i,...t){this.getLevel()<=v.Critical&&this.adapter.log(v.Critical,[this.extractMessage(i),...t])}extractMessage(i){return typeof i=="string"?i:(0,k.toErrorMessage)(i,this.getLevel()<=v.Trace)}dispose(){}flush(){}}e.AdapterLogger=b;class f extends R{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const t of this.logServices)t.setLevel(i);super.setLevel(i)}trace(i,...t){for(const r of this.logServices)r.trace(i,...t)}debug(i,...t){for(const r of this.logServices)r.debug(i,...t)}info(i,...t){for(const r of this.logServices)r.info(i,...t)}warn(i,...t){for(const r of this.logServices)r.warn(i,...t)}error(i,...t){for(const r of this.logServices)r.error(i,...t)}critical(i,...t){for(const r of this.logServices)r.critical(i,...t)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=f;class d extends w.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...t){this.logger.trace(i,...t)}debug(i,...t){this.logger.debug(i,...t)}info(i,...t){this.logger.info(i,...t)}warn(i,...t){this.logger.warn(i,...t)}error(i,...t){this.logger.error(i,...t)}critical(i,...t){this.logger.critical(i,...t)}flush(){this.logger.flush()}}e.LogService=d;class p extends w.Disposable{constructor(i,t){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(r))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,t){let r=this.loggers.get(i.toString());return r||(r=this.doCreateLogger(i,t?.always?v.Trace:this.logLevel,t),this.loggers.set(i.toString(),r),t?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class m{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(i){}getLevel(){return v.Info}trace(i,...t){}debug(i,...t){}info(i,...t){}warn(i,...t){}error(i,...t){}critical(i,...t){}dispose(){}flush(){}}e.NullLogService=m;function y(l){if(l.verbose)return v.Trace;if(typeof l.logLevel=="string"){const i=c(l.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=y;function c(l){switch(l){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Critical;case"off":return v.Off}}e.parseLogLevel=c;function o(l){switch(l){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Critical:return"critical";case v.Off:return"off"}}e.LogLevelToString=o});var Oe=this&&this.__param||function(ee,e){return function(k,n){e(k,n,ee)}};define(ve[191],we([0,1,64,7,2,13,3]),function(ee,e,k,n,w,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let D=class Ot extends w.Disposable{constructor(P){super();this.logService=P,this._onDidChangePassword=this._register(new n.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(P,A){const R=await this.withKeytar(),E=await R.getPassword(P,A);if(E)try{let{content:S,hasNextChunk:u}=JSON.parse(E);if(!S||!u)return E;let b=1;for(;u;){const f=await R.getPassword(P,`${A}-${b}`),d=JSON.parse(f);S+=d.content,u=d.hasNextChunk,b++}return S}catch{return E}return E}async setPassword(P,A,R){const E=await this.withKeytar(),S=3,u=async(b,f,d)=>{let p=0,m;for(;p<S;)try{await E.setPassword(b,f,d);return}catch(y){m=y,this.logService.warn("Error attempting to set a password: ",y),p++,await new Promise(c=>setTimeout(c,200))}throw m};if(T.isWindows&&R.length>Ot.MAX_PASSWORD_LENGTH){let b=0,f=0,d=!0;for(;d;){const p=R.substring(b,b+Ot.PASSWORD_CHUNK_SIZE);b+=Ot.PASSWORD_CHUNK_SIZE,d=R.length-b>0;const m={content:p,hasNextChunk:d};await u(P,f?`${A}-${f}`:A,JSON.stringify(m)),f++}}else await u(P,A,R);this._onDidChangePassword.fire({service:P,account:A})}async deletePassword(P,A){const E=await(await this.withKeytar()).deletePassword(P,A);return E&&this._onDidChangePassword.fire({service:P,account:A}),E}async findPassword(P){return(await this.withKeytar()).findPassword(P)}async findCredentials(P){return(await this.withKeytar()).findCredentials(P)}clear(){return this._keytarCache instanceof k.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};D.MAX_PASSWORD_LENGTH=2500,D.PASSWORD_CHUNK_SIZE=D.MAX_PASSWORD_LENGTH-100,D=Ae([Oe(0,C.ILogService)],D),e.BaseCredentialsMainService=D}),define(ve[192],we([0,1,38,14,36,7,2,8,5,19,27,13]),function(ee,e,k,n,w,C,T,D,v,P,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let E=class extends T.Disposable{constructor(u,b){super();this.environmentService=u,this.logService=b,this.processesLimiter=new n.Limiter(5)}async postUninstall(u){const b=this.parseScript(u,"uninstall");return b&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(b.script,"uninstall",b.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),f=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${f}`)))),P.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,f=>this.logService.error("Error while removing extension storage path",f))}parseScript(u,b){const f=`vscode:${b}`;if(u.location.scheme===D.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[f]=="string"){const d=u.manifest.scripts[f].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${f} should be a node script`),null):{script:(0,v.join)(u.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}runLifecycleHook(u,b,f,d,p){return new Promise((m,y)=>{const c=this.start(u,b,f,p);let o;const l=i=>{o&&(clearTimeout(o),o=null),i?y(i):m(void 0)};c.on("error",i=>{l((0,w.toErrorMessage)(i)||"Unknown")}),c.on("exit",(i,t)=>{l(i?`post-${b} process exited with code ${i}`:void 0)}),d&&(o=setTimeout(()=>{o=null,c.kill(),y("timed out")},5e3))})}start(u,b,f,d){const p={silent:!0,execArgv:void 0},m=(0,k.fork)(u,[`--type=extension-post-${b}`,...f],p);m.stdout.setEncoding("utf8"),m.stderr.setEncoding("utf8");const y=C.Event.fromNodeEventEmitter(m.stdout,"data"),c=C.Event.fromNodeEventEmitter(m.stderr,"data");y(i=>this.logService.info(d.identifier.id,d.manifest.version,`post-${b}`,i)),c(i=>this.logService.error(d.identifier.id,d.manifest.version,`post-${b}`,i));const o=C.Event.any(C.Event.map(y,i=>({data:`%c${i}`,format:[""]})),C.Event.map(c,i=>({data:`%c${i}`,format:["color: red"]})));return C.Event.debounce(o,(i,t)=>i?{data:i.data+t.data,format:[...i.format,...t.format]}:{data:t.data,format:t.format},100)(i=>{console.group(d.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),m}getExtensionStoragePath(u){return(0,v.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};E=Ae([Oe(0,A.IEnvironmentService),Oe(1,R.ILogService)],E),e.ExtensionsLifecycle=E}),define(ve[193],we([0,1,18,14,9,7,2,5,54,13]),function(ee,e,k,n,w,C,T,D,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class A extends T.Disposable{constructor(E,S){super();this.logService=E,this.options=S,this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new n.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(E,S){return S.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(E,S):this.watchNonRecursive(E,S)}watchUniversal(E,S){const u={path:this.toFilePath(E),excludes:S.excludes,recursive:S.recursive},b=(0,k.insert)(this.universalPathsToWatch,u);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{b(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(E=>(0,w.onUnexpectedError)(E))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(S=>this._onDidChangeFile.fire((0,v.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===P.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===P.LogLevel.Trace)})));const E=this.options?.watcher?.recursive?.usePolling;if(E===!0)for(const S of this.universalPathsToWatch)(0,v.isRecursiveWatchRequest)(S)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(E))for(const S of this.universalPathsToWatch)(0,v.isRecursiveWatchRequest)(S)&&E.includes(S.path)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(E,S){const u={path:this.toFilePath(E),excludes:S.excludes,recursive:!1},b=(0,k.insert)(this.nonRecursivePathsToWatch,u);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{b(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(E=>(0,w.onUnexpectedError)(E))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(E=>this._onDidChangeFile.fire((0,v.toFileChanges)(E)),E=>this.onWatcherLogMessage(E),this.logService.getLevel()===P.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===P.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(E){E.type==="error"&&this._onDidWatchError.fire(E.message),this.logService[E.type](E.message)}toFilePath(E){return(0,D.normalize)(E.fsPath)}}e.AbstractDiskFileSystemProvider=A}),define(ve[92],we([0,1,18,14,16,21,7,125,49,2,31,8,44,20,43,156,17,90,13]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E,S,u,b,f,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let m=class extends P.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(c,o){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${c}`);const l=new P.DisposableStore;return this.provider.set(c,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:o}),l.add(o.onDidChangeFile(i=>this._onDidFilesChange.fire(new f.FileChangesEvent(i,!this.isPathCaseSensitive(o))))),typeof o.onDidWatchError=="function"&&l.add(o.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),l.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:c}))),(0,P.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:o}),this.provider.delete(c),(0,P.dispose)(l)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(l){o.push(l)}}),!this.provider.has(c)&&await n.Promises.settled(o)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,o){const l=this.provider.get(c.scheme);return!!(l&&l.capabilities&o)}listCapabilities(){return v.Iterable.map(this.provider,([c,o])=>({scheme:c,capabilities:o.capabilities}))}async withProvider(c){if(!(0,S.isAbsolutePath)(c))throw new f.FileOperationError((0,b.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const o=this.provider.get(c.scheme);if(!o){const l=new Error;throw l.name="ENOPRO",l.message=(0,b.localize)(1,null,c.toString()),l}return o}async withReadProvider(c){const o=await this.withProvider(c);if((0,f.hasOpenReadWriteCloseCapability)(o)||(0,f.hasReadWriteCapability)(o)||(0,f.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const o=await this.withProvider(c);if((0,f.hasOpenReadWriteCloseCapability)(o)||(0,f.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,o){try{return await this.doResolveFile(c,o)}catch(l){throw(0,f.toFileSystemProviderErrorCode)(l)===f.FileSystemProviderErrorCode.FileNotFound?new f.FileOperationError((0,b.localize)(2,null,this.resourceForError(c)),1):(0,f.ensureFileSystemProviderError)(l)}}async doResolveFile(c,o){const l=await this.withProvider(c),i=this.isPathCaseSensitive(l),t=o?.resolveTo,r=o?.resolveSingleChildDescendants,s=o?.resolveMetadata,a=await l.stat(c);let h;return this.toFileStat(l,c,a,void 0,!!s,(g,_)=>(h||(h=A.TernarySearchTree.forUris(()=>!i),h.set(c,!0),t&&h.fill(!0,t)),h.get(g.resource)||h.findSuperstr(g.resource.with({query:null,fragment:null}))?!0:g.isDirectory&&r?_===1:!1))}async toFileStat(c,o,l,i,t,r){const{providerExtUri:s}=this.getExtUri(c),a={resource:o,name:s.basename(o),isFile:(l.type&f.FileType.File)!=0,isDirectory:(l.type&f.FileType.Directory)!=0,isSymbolicLink:(l.type&f.FileType.SymbolicLink)!=0,mtime:l.mtime,ctime:l.ctime,size:l.size,readonly:Boolean((l.permissions??0)&f.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,f.etag)({mtime:l.mtime,size:l.size}),children:void 0};if(a.isDirectory&&r(a,i)){try{const h=await c.readdir(o),g=await n.Promises.settled(h.map(async([_,F])=>{try{const $=s.joinPath(o,_),K=t?await c.stat($):{type:F};return await this.toFileStat(c,$,K,h.length,t,r)}catch($){return this.logService.trace($),null}}));a.children=(0,k.coalesce)(g)}catch(h){this.logService.trace(h),a.children=[]}return a}return a}async resolveAll(c){return n.Promises.settled(c.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(l){return this.logService.trace(l),{stat:void 0,success:!1}}}))}async stat(c){const o=await this.withProvider(c),l=await o.stat(c);return this.toFileStat(o,c,l,void 0,!0,()=>!1)}async exists(c){const o=await this.withProvider(c);try{return!!await o.stat(c)}catch{return!1}}async canCreateFile(c,o){try{await this.doValidateCreateFile(c,o)}catch(l){return l}return!0}async doValidateCreateFile(c,o){if(!o?.overwrite&&await this.exists(c))throw new f.FileOperationError((0,b.localize)(3,null,this.resourceForError(c)),3,o)}async createFile(c,o=w.VSBuffer.fromString(""),l){await this.doValidateCreateFile(c,l);const i=await this.writeFile(c,o);return this._onDidRunOperation.fire(new f.FileOperationEvent(c,0,i)),i}async writeFile(c,o,l){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:t}=this.getExtUri(i);try{await this.validateWriteFile(i,c,l)||await this.mkdirp(i,t.dirname(c));let s;if((0,f.hasReadWriteCapability)(i)&&!(o instanceof w.VSBuffer))if((0,u.isReadableStream)(o)){const a=await(0,u.peekStream)(o,3);a.ended?s=w.VSBuffer.concat(a.buffer):s=a}else s=(0,u.peekReadable)(o,a=>w.VSBuffer.concat(a),3);else s=o;!(0,f.hasOpenReadWriteCloseCapability)(i)||(0,f.hasReadWriteCapability)(i)&&s instanceof w.VSBuffer?await this.doWriteUnbuffered(i,c,l,s):await this.doWriteBuffered(i,c,l,s instanceof w.VSBuffer?(0,w.bufferToReadable)(s):s),this._onDidRunOperation.fire(new f.FileOperationEvent(c,4))}catch(r){throw new f.FileOperationError((0,b.localize)(4,null,this.resourceForError(c),(0,f.ensureFileSystemProviderError)(r).toString()),(0,f.toFileOperationResult)(r),l)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,o,l){if(!!l?.unlock&&!(c.capabilities&8192))throw new Error((0,b.localize)(5,null,this.resourceForError(o)));let t;try{t=await c.stat(o)}catch{return}if((t.type&f.FileType.Directory)!=0)throw new f.FileOperationError((0,b.localize)(6,null,this.resourceForError(o)),0,l);if(this.throwIfFileIsReadonly(o,t),typeof l?.mtime=="number"&&typeof l.etag=="string"&&l.etag!==f.ETAG_DISABLED&&typeof t.mtime=="number"&&typeof t.size=="number"&&l.mtime<t.mtime&&l.etag!==(0,f.etag)({mtime:l.mtime,size:t.size}))throw new f.FileOperationError((0,b.localize)(7,null),3,l);return t}async readFile(c,o,l){const i=await this.withReadProvider(c);return o?.atomic?this.doReadFileAtomic(i,c,o,l):this.doReadFile(i,c,o,l)}async doReadFileAtomic(c,o,l,i){return new Promise((t,r)=>{this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(c,o,l,i);t(s)}catch(s){r(s)}})})}async doReadFile(c,o,l,i){const t=await this.doReadFileStream(c,o,{...l,preferUnbuffered:!0},i);return{...t,value:await(0,w.streamToBuffer)(t.value)}}async readFileStream(c,o,l){const i=await this.withReadProvider(c);return this.doReadFileStream(i,c,o,l)}async doReadFileStream(c,o,l,i){const t=new C.CancellationTokenSource(i),r=this.validateReadFile(o,l).then(a=>a,a=>{throw t.cancel(),a});let s;try{return typeof l?.etag=="string"&&l.etag!==f.ETAG_DISABLED&&await r,l?.atomic&&(0,f.hasFileAtomicReadCapability)(c)||!((0,f.hasOpenReadWriteCloseCapability)(c)||(0,f.hasFileReadStreamCapability)(c))||(0,f.hasReadWriteCapability)(c)&&l?.preferUnbuffered?s=this.readFileUnbuffered(c,o,l):(0,f.hasFileReadStreamCapability)(c)?s=this.readFileStreamed(c,o,t.token,l):s=this.readFileBuffered(c,o,t.token,l),{...await r,value:s}}catch(a){s&&await(0,u.consumeStream)(s);const h=(0,b.localize)(8,null,this.resourceForError(o),(0,f.ensureFileSystemProviderError)(a).toString());throw a instanceof f.NotModifiedSinceFileOperationError?new f.NotModifiedSinceFileOperationError(h,a.stat,l):new f.FileOperationError(h,(0,f.toFileOperationResult)(a),l)}}readFileStreamed(c,o,l,i=Object.create(null)){const t=c.readFileStream(o,i,l);return(0,u.transform)(t,{data:r=>r instanceof w.VSBuffer?r:w.VSBuffer.wrap(r),error:r=>new f.FileOperationError((0,b.localize)(9,null,this.resourceForError(o),(0,f.ensureFileSystemProviderError)(r).toString()),(0,f.toFileOperationResult)(r),i)},r=>w.VSBuffer.concat(r))}readFileBuffered(c,o,l,i=Object.create(null)){const t=(0,w.newWriteableBufferStream)();return(0,d.readFileIntoStream)(c,o,t,r=>r,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new f.FileOperationError((0,b.localize)(10,null,this.resourceForError(o),(0,f.ensureFileSystemProviderError)(r).toString()),(0,f.toFileOperationResult)(r),i)},l),t}readFileUnbuffered(c,o,l){const i=(0,u.newWriteableStream)(t=>w.VSBuffer.concat(t));return(async()=>{try{let t;l?.atomic&&(0,f.hasFileAtomicReadCapability)(c)?t=await c.readFile(o,{atomic:!0}):t=await c.readFile(o),typeof l?.position=="number"&&(t=t.slice(l.position)),typeof l?.length=="number"&&(t=t.slice(0,l.length)),this.validateReadFileLimits(o,t.byteLength,l),i.end(w.VSBuffer.wrap(t))}catch(t){i.error(t),i.end()}})(),i}async validateReadFile(c,o){const l=await this.resolve(c,{resolveMetadata:!0});if(l.isDirectory)throw new f.FileOperationError((0,b.localize)(11,null,this.resourceForError(c)),0,o);if(typeof o?.etag=="string"&&o.etag!==f.ETAG_DISABLED&&o.etag===l.etag)throw new f.NotModifiedSinceFileOperationError((0,b.localize)(12,null),l,o);return this.validateReadFileLimits(c,l.size,o),l}validateReadFileLimits(c,o,l){if(l?.limits){let i;if(typeof l.limits.memory=="number"&&o>l.limits.memory&&(i=9),typeof l.limits.size=="number"&&o>l.limits.size&&(i=7),typeof i=="number")throw new f.FileOperationError((0,b.localize)(13,null,this.resourceForError(c)),i)}}async canMove(c,o,l){return this.doCanMoveCopy(c,o,"move",l)}async canCopy(c,o,l){return this.doCanMoveCopy(c,o,"copy",l)}async doCanMoveCopy(c,o,l,i){if(c.toString()!==o.toString())try{const t=l==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(t,c,r,o,l,i)}catch(t){return t}return!0}async move(c,o,l){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=await this.doMoveCopy(i,c,t,o,"move",!!l),s=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(c,r==="move"?2:3,s)),s}async copy(c,o,l){const i=await this.withReadProvider(c),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=await this.doMoveCopy(i,c,t,o,"copy",!!l),s=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(c,r==="copy"?3:2,s)),s}async doMoveCopy(c,o,l,i,t,r){if(o.toString()===i.toString())return t;const{exists:s,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(c,o,l,i,t,r);if(s&&!a&&r&&await this.del(i,{recursive:!0}),await this.mkdirp(l,this.getExtUri(l).providerExtUri.dirname(i)),t==="copy"){if(c===l&&(0,f.hasFileFolderCopyCapability)(c))await c.copy(o,i,{overwrite:r});else{const h=await this.resolve(o);h.isDirectory?await this.doCopyFolder(c,h,l,i):await this.doCopyFile(c,o,l,i)}return t}else return c===l?(await c.rename(o,i,{overwrite:r}),t):(await this.doMoveCopy(c,o,l,i,"copy",r),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(c,o,l,i){if((0,f.hasOpenReadWriteCloseCapability)(c)&&(0,f.hasOpenReadWriteCloseCapability)(l))return this.doPipeBuffered(c,o,l,i);if((0,f.hasOpenReadWriteCloseCapability)(c)&&(0,f.hasReadWriteCapability)(l))return this.doPipeBufferedToUnbuffered(c,o,l,i);if((0,f.hasReadWriteCapability)(c)&&(0,f.hasOpenReadWriteCloseCapability)(l))return this.doPipeUnbufferedToBuffered(c,o,l,i);if((0,f.hasReadWriteCapability)(c)&&(0,f.hasReadWriteCapability)(l))return this.doPipeUnbuffered(c,o,l,i)}async doCopyFolder(c,o,l,i){await l.mkdir(i),Array.isArray(o.children)&&await n.Promises.settled(o.children.map(async t=>{const r=this.getExtUri(l).providerExtUri.joinPath(i,t.name);return t.isDirectory?this.doCopyFolder(c,await this.resolve(t.resource),l,r):this.doCopyFile(c,t.resource,l,r)}))}async doValidateMoveCopy(c,o,l,i,t,r){let s=!1;if(c===l){const{providerExtUri:h,isPathCaseSensitive:g}=this.getExtUri(c);if(g||(s=h.isEqual(o,i)),s&&t==="copy")throw new Error((0,b.localize)(14,null,this.resourceForError(o),this.resourceForError(i)));if(!s&&h.isEqualOrParent(i,o))throw new Error((0,b.localize)(15,null,this.resourceForError(o),this.resourceForError(i)))}const a=await this.exists(i);if(a&&!s){if(!r)throw new f.FileOperationError((0,b.localize)(16,null,this.resourceForError(o),this.resourceForError(i)),4);if(c===l){const{providerExtUri:h}=this.getExtUri(c);if(h.isEqualOrParent(o,i))throw new Error((0,b.localize)(17,null,this.resourceForError(o),this.resourceForError(i)))}}return{exists:a,isSameResourceWithDifferentPathCase:s}}getExtUri(c){const o=this.isPathCaseSensitive(c);return{providerExtUri:o?S.extUri:S.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(o,c);const l=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(c,0,l)),l}async mkdirp(c,o){const l=[],{providerExtUri:i}=this.getExtUri(c);for(;!i.isEqual(o,i.dirname(o));)try{if(((await c.stat(o)).type&f.FileType.Directory)==0)throw new Error((0,b.localize)(18,null,this.resourceForError(o)));break}catch(t){if((0,f.toFileSystemProviderErrorCode)(t)!==f.FileSystemProviderErrorCode.FileNotFound)throw t;l.push(i.basename(o)),o=i.dirname(o)}for(let t=l.length-1;t>=0;t--){o=i.joinPath(o,l[t]);try{await c.mkdir(o)}catch(r){if((0,f.toFileSystemProviderErrorCode)(r)!==f.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(c,o){try{await this.doValidateDelete(c,o)}catch(l){return l}return!0}async doValidateDelete(c,o){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!o?.useTrash&&!(l.capabilities&4096))throw new Error((0,b.localize)(19,null,this.resourceForError(c)));let t;try{t=await l.stat(c)}catch{}if(t)this.throwIfFileIsReadonly(c,t);else throw new f.FileOperationError((0,b.localize)(20,null,this.resourceForError(c)),1);if(!!!o?.recursive){const s=await this.resolve(c);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,b.localize)(21,null,this.resourceForError(c)))}return l}async del(c,o){const l=await this.doValidateDelete(c,o),i=!!o?.useTrash,t=!!o?.recursive;await l.delete(c,{recursive:t,useTrash:i}),this._onDidRunOperation.fire(new f.FileOperationEvent(c,1))}async cloneFile(c,o){const l=await this.withProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);if(l===i&&this.getExtUri(l).providerExtUri.isEqual(c,o))return;if(l===i&&(0,f.hasFileCloneCapability)(l))return l.cloneFile(c,o);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(o));const t=this.writeQueue.queueFor(c,this.getExtUri(l).providerExtUri);return l===i&&(0,f.hasFileFolderCopyCapability)(l)?t.queue(()=>l.copy(c,o,{overwrite:!0})):t.queue(()=>this.doCopyFile(l,c,i,o))}watch(c,o={recursive:!1,excludes:[]}){const l=new P.DisposableStore;let i=!1,t=()=>{i=!0};return l.add((0,P.toDisposable)(()=>t())),(async()=>{try{const r=await this.doWatch(c,o);i?(0,P.dispose)(r):t=()=>(0,P.dispose)(r)}catch(r){this.logService.error(r)}})(),l}async doWatch(c,o){const l=await this.withProvider(c),i=(0,D.hash)([this.getExtUri(l).providerExtUri.getComparisonKey(c),o]);let t=this.activeWatchers.get(i);return t||(t={count:0,disposable:l.watch(c,o)},this.activeWatchers.set(i,t)),t.count+=1,(0,P.toDisposable)(()=>{t&&(t.count--,t.count===0&&((0,P.dispose)(t.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,P.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,o,l,i){return this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(async()=>{const t=await c.open(o,{create:!0,unlock:l?.unlock??!1});try{(0,u.isReadableStream)(i)||(0,u.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(c,t,i):await this.doWriteReadableBufferedQueued(c,t,i)}catch(r){throw(0,f.ensureFileSystemProviderError)(r)}finally{await c.close(t)}})}async doWriteStreamBufferedQueued(c,o,l){let i=0,t;if((0,u.isReadableBufferedStream)(l)){if(l.buffer.length>0){const r=w.VSBuffer.concat(l.buffer);await this.doWriteBuffer(c,o,r,r.byteLength,i,0),i+=r.byteLength}if(l.ended)return;t=l.stream}else t=l;return new Promise((r,s)=>{(0,u.listenStream)(t,{onData:async a=>{t.pause();try{await this.doWriteBuffer(c,o,a,a.byteLength,i,0)}catch(h){return s(h)}i+=a.byteLength,setTimeout(()=>t.resume())},onError:a=>s(a),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(c,o,l){let i=0,t;for(;(t=l.read())!==null;)await this.doWriteBuffer(c,o,t,t.byteLength,i,0),i+=t.byteLength}async doWriteBuffer(c,o,l,i,t,r){let s=0;for(;s<i;)s+=await c.write(o,t+s,l.buffer,r+s,i-s)}async doWriteUnbuffered(c,o,l,i){return this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,o,l,i))}async doWriteUnbufferedQueued(c,o,l,i){let t;i instanceof w.VSBuffer?t=i:(0,u.isReadableStream)(i)?t=await(0,w.streamToBuffer)(i):(0,u.isReadableBufferedStream)(i)?t=await(0,w.bufferedStreamToBuffer)(i):t=(0,w.readableToBuffer)(i),await c.writeFile(o,t.buffer,{create:!0,overwrite:!0,unlock:l?.unlock??!1})}async doPipeBuffered(c,o,l,i){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,o,l,i))}async doPipeBufferedQueued(c,o,l,i){let t,r;try{t=await c.open(o,{create:!1}),r=await l.open(i,{create:!0,unlock:!1});const s=w.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,h=0,g=0;do g=await c.read(t,a,s.buffer,h,s.byteLength-h),await this.doWriteBuffer(l,r,s,g,a,h),a+=g,h+=g,h===s.byteLength&&(h=0);while(g>0)}catch(s){throw(0,f.ensureFileSystemProviderError)(s)}finally{await n.Promises.settled([typeof t=="number"?c.close(t):Promise.resolve(),typeof r=="number"?l.close(r):Promise.resolve()])}}async doPipeUnbuffered(c,o,l,i){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,o,l,i))}async doPipeUnbufferedQueued(c,o,l,i){return l.writeFile(i,await c.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,o,l,i){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,o,l,i))}async doPipeUnbufferedToBufferedQueued(c,o,l,i){const t=await l.open(i,{create:!0,unlock:!1});try{const r=await c.readFile(o);await this.doWriteBuffer(l,t,w.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,f.ensureFileSystemProviderError)(r)}finally{await l.close(t)}}async doPipeBufferedToUnbuffered(c,o,l,i){const t=await(0,w.streamToBuffer)(this.readFileBuffered(c,o,C.CancellationToken.None));await this.doWriteUnbuffered(l,i,void 0,t)}throwIfFileSystemIsReadonly(c,o){if(c.capabilities&2048)throw new f.FileOperationError((0,b.localize)(22,null,this.resourceForError(o)),6);return c}throwIfFileIsReadonly(c,o){if((o.permissions??0)&f.FilePermission.Readonly)throw new f.FileOperationError((0,b.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===R.Schemas.file?c.fsPath:c.toString(!0)}};m=Ae([Oe(0,p.ILogService)],m),e.FileService=m}),define(ve[55],we([0,1,29,259,14,31,16,7,33,2,5,3,20,43,19,159,17,90,193,36,189,188]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E,S,u,b,f,d,p,m,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(k)}catch(l){console.error(`Error enabling graceful-fs: ${(0,m.toErrorMessage)(l)}`)}})();class o extends p.AbstractDiskFileSystemProvider{constructor(i,t){super(i,t);this.onDidChangeCapabilities=D.Event.None,this.resourceLocks=new C.ResourceMap(r=>E.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,R.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:t,symbolicLink:r}=await u.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(t,r),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size}}catch(t){throw this.toFileSystemProviderError(t)}}async readdir(i){try{const t=await u.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),r=[];return await Promise.all(t.map(async s=>{try{let a;s.isSymbolicLink()?a=(await this.stat((0,E.joinPath)(i,s.name))).type:a=this.toType(s),r.push([s.name,a])}catch(a){this.logService.trace(a)}})),r}catch(t){throw this.toFileSystemProviderError(t)}}toType(i,t){let r;return t?.dangling?r=f.FileType.Unknown:i.isFile()?r=f.FileType.File:i.isDirectory()?r=f.FileType.Directory:r=f.FileType.Unknown,t&&(r|=f.FileType.SymbolicLink),r}async createResourceLock(i){const t=this.toFilePath(i);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let r;for(;r=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await r.wait();const s=new w.Barrier;return this.resourceLocks.set(i,s),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,P.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.resourceLocks.get(i)===s&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.resourceLocks.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),s.open()})}async readFile(i,t){let r;try{t?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),r=await this.createResourceLock(i));const s=this.toFilePath(i);return await u.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}finally{r?.dispose()}}readFileStream(i,t,r){const s=(0,S.newWriteableStream)(a=>T.VSBuffer.concat(a.map(h=>T.VSBuffer.wrap(h))).buffer);return(0,d.readFileIntoStream)(this,i,s,a=>a.buffer,{...t,bufferSize:256*1024},r),s}async writeFile(i,t,r){let s;try{const a=this.toFilePath(i);if(!r.create||!r.overwrite){if(await u.Promises.exists(a)){if(!r.overwrite)throw(0,f.createFileSystemProviderError)((0,b.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,f.createFileSystemProviderError)((0,b.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(i,{create:!0,unlock:r.unlock}),await this.write(s,0,t,0,t.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(i,a)}finally{typeof s=="number"&&await this.close(s)}}async open(i,t){const r=this.toFilePath(i);let s;(0,f.isFileOpenForWriteOptions)(t)&&(s=await this.createResourceLock(i));let a;try{if((0,f.isFileOpenForWriteOptions)(t)&&t.unlock)try{const{stat:g}=await u.SymlinkSupport.stat(r);g.mode&128||await u.Promises.chmod(r,g.mode|128)}catch(g){this.logService.trace(g)}let h;if((0,f.isFileOpenForWriteOptions)(t)){if(R.isWindows)try{await u.Promises.truncate(r,0),h="r+"}catch(g){g.code!=="ENOENT"&&this.logService.trace(g)}h||(h="w")}else h="r";a=await u.Promises.open(r,h)}catch(h){throw s?.dispose(),(0,f.isFileOpenForWriteOptions)(t)?await this.toFileSystemProviderWriteError(i,h):this.toFileSystemProviderError(h)}if(this.mapHandleToPos.set(a,0),(0,f.isFileOpenForWriteOptions)(t)&&this.writeHandles.set(a,i),s){const h=this.mapHandleToLock.get(a);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${r})`),this.mapHandleToLock.set(a,s),h&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${r})`),h.dispose())}return a}async close(i){const t=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await u.Promises.fdatasync(i)}catch(r){this.canFlush=!1,this.logService.error(r)}return await u.Promises.close(i)}catch(r){throw this.toFileSystemProviderError(r)}finally{t&&(this.mapHandleToLock.get(i)===t&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),t.dispose())}}async read(i,t,r,s,a){const h=this.normalizePos(i,t);let g=null;try{g=(await u.Promises.read(i,r,s,a,h)).bytesRead}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(i,h,g)}return g}normalizePos(i,t){return t===this.mapHandleToPos.get(i)?null:t}updatePos(i,t,r){const s=this.mapHandleToPos.get(i);typeof s=="number"&&(typeof t=="number"||(typeof r=="number"?this.mapHandleToPos.set(i,s+r):this.mapHandleToPos.delete(i)))}async write(i,t,r,s,a){return(0,w.retry)(()=>this.doWrite(i,t,r,s,a),100,3)}async doWrite(i,t,r,s,a){const h=this.normalizePos(i,t);let g=null;try{g=(await u.Promises.write(i,r,s,a,h)).bytesWritten}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),_)}finally{this.updatePos(i,h,g)}return g}async mkdir(i){try{await u.Promises.mkdir(this.toFilePath(i))}catch(t){throw this.toFileSystemProviderError(t)}}async delete(i,t){try{const r=this.toFilePath(i);t.recursive?await u.Promises.rm(r,u.RimRafMode.MOVE):await u.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(i,t,r){const s=this.toFilePath(i),a=this.toFilePath(t);if(s!==a)try{await this.validateTargetDeleted(i,t,"move",r.overwrite),await u.Promises.move(s,a)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,b.localize)(2,null,(0,A.basename)(s),(0,A.basename)((0,A.dirname)(a)),h.toString()))),this.toFileSystemProviderError(h)}}async copy(i,t,r){const s=this.toFilePath(i),a=this.toFilePath(t);if(s!==a)try{await this.validateTargetDeleted(i,t,"copy",r.overwrite),await u.Promises.copy(s,a,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,b.localize)(3,null,(0,A.basename)(s),(0,A.basename)((0,A.dirname)(a)),h.toString()))),this.toFileSystemProviderError(h)}}async validateTargetDeleted(i,t,r,s){const a=this.toFilePath(i),h=this.toFilePath(t);let g=!1;if(!!(this.capabilities&1024)||(g=(0,v.isEqual)(a,h,!0)),g&&r==="copy")throw(0,f.createFileSystemProviderError)((0,b.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(!g&&await u.Promises.exists(h)){if(!s)throw(0,f.createFileSystemProviderError)((0,b.localize)(5,null),f.FileSystemProviderErrorCode.FileExists);await this.delete(t,{recursive:!0,useTrash:!1})}}async cloneFile(i,t){return this.doCloneFile(i,t,!1)}async doCloneFile(i,t,r){const s=this.toFilePath(i),a=this.toFilePath(t),h=!!(this.capabilities&1024);if((0,v.isEqual)(s,a,!h))return;const g=new P.DisposableStore;try{const[_,F]=await Promise.all([this.createResourceLock(i),this.createResourceLock(t)]);g.add(_),g.add(F),r&&await u.Promises.mkdir((0,A.dirname)(a),{recursive:!0}),await u.Promises.copyFile(s,a)}catch(_){if(_.code==="ENOENT"&&!r)return this.doCloneFile(i,t,!0);throw this.toFileSystemProviderError(_)}finally{g.dispose()}}createUniversalWatcher(i,t,r){return new y.UniversalWatcherClient(s=>i(s),s=>t(s),r)}createNonRecursiveWatcher(i,t,r){return new c.NodeJSWatcherClient(s=>i(s),s=>t(s),r)}toFileSystemProviderError(i){if(i instanceof f.FileSystemProviderError)return i;let t;switch(i.code){case"ENOENT":t=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=f.FileSystemProviderErrorCode.NoPermissions;break;default:t=f.FileSystemProviderErrorCode.Unknown}return(0,f.createFileSystemProviderError)(i,t)}async toFileSystemProviderWriteError(i,t){let r=this.toFileSystemProviderError(t);if(i&&r.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await u.SymlinkSupport.stat(this.toFilePath(i));s.mode&128||(r=(0,f.createFileSystemProviderError)(t,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.logService.trace(s)}return r}}e.DiskFileSystemProvider=o}),define(ve[194],we([0,1,7,55,2,16,43,21]),function(ee,e,k,n,w,C,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class v extends w.Disposable{constructor(R,E){super();this.provider=R,this.logService=E,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(R,E,S){const u=this.getUriTransformer(R);switch(E){case"stat":return this.stat(u,S[0]);case"readdir":return this.readdir(u,S[0]);case"open":return this.open(u,S[0],S[1]);case"close":return this.close(S[0]);case"read":return this.read(S[0],S[1],S[2]);case"readFile":return this.readFile(u,S[0],S[1]);case"write":return this.write(S[0],S[1],S[2],S[3],S[4]);case"writeFile":return this.writeFile(u,S[0],S[1],S[2]);case"rename":return this.rename(u,S[0],S[1],S[2]);case"copy":return this.copy(u,S[0],S[1],S[2]);case"cloneFile":return this.cloneFile(u,S[0],S[1]);case"mkdir":return this.mkdir(u,S[0]);case"delete":return this.delete(u,S[0],S[1]);case"watch":return this.watch(u,S[0],S[1],S[2],S[3]);case"unwatch":return this.unwatch(S[0],S[1])}throw new Error(`IPC Command ${E} not found`)}listen(R,E,S){const u=this.getUriTransformer(R);switch(E){case"fileChange":return this.onFileChange(u,S[0]);case"readFileStream":return this.onReadFileStream(u,S[0],S[1])}throw new Error(`Unknown event ${E}`)}stat(R,E){const S=this.transformIncoming(R,E,!0);return this.provider.stat(S)}readdir(R,E){const S=this.transformIncoming(R,E);return this.provider.readdir(S)}async readFile(R,E,S){const u=this.transformIncoming(R,E,!0),b=await this.provider.readFile(u,S);return C.VSBuffer.wrap(b)}onReadFileStream(R,E,S){const u=this.transformIncoming(R,E,!0),b=new D.CancellationTokenSource,f=new k.Emitter({onLastListenerRemove:()=>{b.cancel()}}),d=this.provider.readFileStream(u,S,b.token);return(0,T.listenStream)(d,{onData:p=>f.fire(C.VSBuffer.wrap(p)),onError:p=>f.fire(p),onEnd:()=>{f.fire("end"),f.dispose(),b.dispose()}}),f.event}writeFile(R,E,S,u){const b=this.transformIncoming(R,E);return this.provider.writeFile(b,S.buffer,u)}open(R,E,S){const u=this.transformIncoming(R,E,!0);return this.provider.open(u,S)}close(R){return this.provider.close(R)}async read(R,E,S){const u=C.VSBuffer.alloc(S),b=0,f=await this.provider.read(R,E,u.buffer,b,S);return[u,f]}write(R,E,S,u,b){return this.provider.write(R,E,S.buffer,u,b)}mkdir(R,E){const S=this.transformIncoming(R,E);return this.provider.mkdir(S)}delete(R,E,S){const u=this.transformIncoming(R,E);return this.provider.delete(u,S)}rename(R,E,S,u){const b=this.transformIncoming(R,E),f=this.transformIncoming(R,S);return this.provider.rename(b,f,u)}copy(R,E,S,u){const b=this.transformIncoming(R,E),f=this.transformIncoming(R,S);return this.provider.copy(b,f,u)}cloneFile(R,E,S){const u=this.transformIncoming(R,E),b=this.transformIncoming(R,S);return this.provider.cloneFile(u,b)}onFileChange(R,E){const S=new k.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(E,this.createSessionFileWatcher(R,S))},onLastListenerRemove:()=>{(0,w.dispose)(this.sessionToWatcher.get(E)),this.sessionToWatcher.delete(E)}});return S.event}async watch(R,E,S,u,b){const f=this.sessionToWatcher.get(E);if(f){const d=this.transformIncoming(R,u),p=f.watch(S,d,b);this.watchRequests.set(E+S,p)}}async unwatch(R,E){const S=R+E,u=this.watchRequests.get(S);u&&((0,w.dispose)(u),this.watchRequests.delete(S))}dispose(){super.dispose();for(const[,R]of this.watchRequests)R.dispose();this.watchRequests.clear();for(const[,R]of this.sessionToWatcher)R.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=v;class P extends w.Disposable{constructor(R,E,S,u){super();this.uriTransformer=R,this.logService=S,this.environmentService=u,this.watcherRequests=new Map,this.fileWatcher=this._register(new n.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(E)}registerListeners(R){const E=this._register(new k.Emitter);this._register(E.event(S=>{R.fire(S.map(u=>({resource:this.uriTransformer.transformOutgoingURI(u.resource),type:u.type})))})),this._register(this.fileWatcher.onDidChangeFile(S=>E.fire(S))),this._register(this.fileWatcher.onDidWatchError(S=>R.fire(S)))}getRecursiveWatcherOptions(R){}getExtraExcludes(R){}watch(R,E,S){const u=this.getExtraExcludes(this.environmentService);return Array.isArray(u)&&(S.excludes=[...S.excludes,...u]),this.watcherRequests.set(R,this.fileWatcher.watch(E,S)),(0,w.toDisposable)(()=>{(0,w.dispose)(this.watcherRequests.get(R)),this.watcherRequests.delete(R)})}dispose(){super.dispose();for(const[,R]of this.watcherRequests)R.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=P}),define(ve[93],we([0,1,7,4,13]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class C{constructor(E){this.service=E,this.onDidChangeLogLevel=k.Event.buffer(E.onDidChangeLogLevel,!0)}listen(E,S){switch(S){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${S}`)}async call(E,S,u){switch(S){case"setLevel":return this.service.setLevel(u)}throw new Error(`Call not found: ${S}`)}}e.LogLevelChannel=C;class T{constructor(E){this.channel=E}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(E){T.setLevel(this.channel,E)}static setLevel(E,S){return E.call("setLevel",S)}}e.LogLevelChannelClient=T;class D{constructor(E){this.loggerService=E,this.loggers=new Map}listen(E,S){throw new Error(`Event not found: ${S}`)}async call(E,S,u){switch(S){case"createLogger":this.createLogger(n.URI.revive(u[0]),u[1]);return;case"log":return this.log(n.URI.revive(u[0]),u[1]);case"consoleLog":return this.consoleLog(u[0],u[1])}throw new Error(`Call not found: ${S}`)}createLogger(E,S){this.loggers.set(E.toString(),this.loggerService.createLogger(E,S))}consoleLog(E,S){let u=console.log;switch(E){case w.LogLevel.Error:u=console.error;break;case w.LogLevel.Warning:u=console.warn;break;case w.LogLevel.Info:u=console.info;break}u.call(console,...S)}log(E,S){const u=this.loggers.get(E.toString());if(!u)throw new Error("Create the logger before logging");for(const[b,f]of S)(0,w.log)(u,b,f)}}e.LoggerChannel=D;class v extends w.AbstractLoggerService{constructor(E,S,u){super(E,S);this.channel=u}createConsoleMainLogger(){return new w.AdapterLogger({log:(E,S)=>{this.channel.call("consoleLog",[E,S])}})}doCreateLogger(E,S,u){return new P(this.channel,E,S,u)}}e.LoggerChannelClient=v;class P extends w.AbstractMessageLogger{constructor(E,S,u,b){super(b?.always);this.channel=E,this.file=S,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.channel.call("createLogger",[S,b]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(E,S){const u=[[E,S]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(E){this.channel.call("log",[this.file,E])}}class A extends w.LogService{constructor(E,S){super(S);this.parent=E,this._register(E.onDidChangeLogLevel(u=>S.setLevel(u)))}setLevel(E){super.setLevel(E),this.parent.setLevel(E)}}e.FollowerLogService=A}),define(ve[94],we([0,1,17,13]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function w(D,v,P,A,R){try{const E=await new Promise((u,b)=>{ee(["spdlog"],u,b)});E.setFlushOn(n.LogLevel.Trace);const S=await E.createAsyncRotatingLogger(D,v,P,A);return R&&S.clearFormatters(),S}catch(E){console.error(E)}return null}function C(D,v,P){switch(v){case n.LogLevel.Trace:D.trace(P);break;case n.LogLevel.Debug:D.debug(P);break;case n.LogLevel.Info:D.info(P);break;case n.LogLevel.Warning:D.warn(P);break;case n.LogLevel.Error:D.error(P);break;case n.LogLevel.Critical:D.critical(P);break;default:throw new Error("Invalid log level")}}class T extends n.AbstractMessageLogger{constructor(v,P,A,R,E){super();this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(v,P,A,R),this._register(this.onDidChangeLogLevel(S=>{this._logger&&this._logger.setLevel(S)}))}async _createSpdLogLogger(v,P,A,R){const E=A?6:1,S=30/E*k.ByteSize.MB,u=await w(v,P,S,E,R);if(u){this._logger=u,this._logger.setLevel(this.getLevel());for(const{level:b,message:f}of this.buffer)C(this._logger,b,f);this.buffer=[]}}log(v,P){this._logger?C(this._logger,v,P):this.getLevel()<=v&&this.buffer.push({level:v,message:P})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=T}),define(ve[195],we([0,1,128,160,6]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(v){v[v.Unnecessary=1]="Unnecessary",v[v.Deprecated=2]="Deprecated"})(C=e.MarkerTag||(e.MarkerTag={}));var T;(function(v){v[v.Hint=1]="Hint",v[v.Info=2]="Info",v[v.Warning=4]="Warning",v[v.Error=8]="Error"})(T=e.MarkerSeverity||(e.MarkerSeverity={})),function(v){function P(u,b){return b-u}v.compare=P;const A=Object.create(null);A[v.Error]=(0,n.localize)(0,null),A[v.Warning]=(0,n.localize)(1,null),A[v.Info]=(0,n.localize)(2,null);function R(u){return A[u]||""}v.toString=R;function E(u){switch(u){case k.default.Error:return v.Error;case k.default.Warning:return v.Warning;case k.default.Info:return v.Info;case k.default.Ignore:return v.Hint}}v.fromSeverity=E;function S(u){switch(u){case v.Error:return k.default.Error;case v.Warning:return k.default.Warning;case v.Info:return k.default.Info;case v.Hint:return k.default.Ignore}}v.toSeverity=S}(T=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(v){const P="";function A(E){return R(E,!0)}v.makeKey=A;function R(E,S){let u=[P];return E.source?u.push(E.source.replace("\xA6","\\\xA6")):u.push(P),E.code?typeof E.code=="string"?u.push(E.code.replace("\xA6","\\\xA6")):u.push(E.code.value.replace("\xA6","\\\xA6")):u.push(P),E.severity!==void 0&&E.severity!==null?u.push(T.toString(E.severity)):u.push(P),E.message&&S?u.push(E.message.replace("\xA6","\\\xA6")):u.push(P),E.startLineNumber!==void 0&&E.startLineNumber!==null?u.push(E.startLineNumber.toString()):u.push(P),E.startColumn!==void 0&&E.startColumn!==null?u.push(E.startColumn.toString()):u.push(P),E.endLineNumber!==void 0&&E.endLineNumber!==null?u.push(E.endLineNumber.toString()):u.push(P),E.endColumn!==void 0&&E.endColumn!==null?u.push(E.endColumn.toString()):u.push(P),u.push(P),u.join("\xA6")}v.makeKeyOptionalMessage=R})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,w.createDecorator)("markerService")}),define(ve[45],we([0,1,8,3,24,20]),function(ee,e,k,n,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const D=n.globals.vscode.context.configuration();if(D)T=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof ee?.__$__nodeRequire=="function"){const D=(0,C.dirname)(k.FileAccess.asFileUri("",ee));T=ee.__$__nodeRequire((0,C.joinPath)(D,"product.json").fsPath);const v=ee.__$__nodeRequire((0,C.joinPath)(D,"package.json").fsPath);w.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`,serverDataFolderName:T.serverDataFolderName?`${T.serverDataFolderName}-dev`:void 0}),Object.assign(T,{version:v.version})}else T={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32AppId:"{{F8A2A208-72B3-4D61-95FC-8A65D340689B}",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32UserAppId:"{{D628A17A-9713-46BF-8D57-E671B46A741E}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"com.visualstudio.code",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverLicense:["*","* Visual Studio Code Server","*","* By using the software, you agree to","* the Visual Studio Code Server License Terms (https://aka.ms/vscode-server-license) and","* the Microsoft Privacy Statement (https://privacy.microsoft.com/en-US/privacystatement).","*"],serverLicensePrompt:"Do you accept the terms in the License Agreement (Y/n)?",serverApplicationName:"code-server",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webEndpointUrl:"https://vscodeweb.azureedge.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-webview.net/{{quality}}/{{commit}}",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-webview.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"stable",extensionsGallery:{serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",cacheUrl:"https://vscode.blob.core.windows.net/gallery/index",itemUrl:"https://marketplace.visualstudio.com/items",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json",recommendationsUrl:"https://az764295.vo.msecnd.net/extensions/workspaceRecommendations.json.gz"},extensionTips:{"ms-dotnettools.csharp":"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json}","firefox-devtools.vscode-firefox-debug":"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}","ms-edgedevtools.vscode-edge-devtools":"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}","golang.Go":"**/*.go","ms-vscode.PowerShell":"{**/*.ps1,**/*.psd1,**/*.psm1,**/*.ps.config,**/*.ps1.config}","Ionide.Ionide-fsharp":"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}","dbaeumer.vscode-eslint":"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}","ms-vscode.vscode-typescript-tslint-plugin":"{**/tslint.json}","bmewburn.vscode-intelephense-client":"{**/*.php,**/php.ini}","xdebug.php-debug":"{**/*.php,**/php.ini}","matklad.rust-analyzer":"{**/*.rs,**/*.rslib}","ms-vscode.cpptools-extension-pack":"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}","DavidAnson.vscode-markdownlint":"{**/*.md}","ms-azuretools.vscode-docker":"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml,**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}","EditorConfig.EditorConfig":"{**/.editorconfig}","HookyQR.beautify":"{**/.jsbeautifyrc}","donjayamanne.githistory":"{**/.gitignore,**/.git}","felipecaputo.git-project-manager":"{**/.gitignore,**/.git}","eamodio.gitlens":"{**/.gitignore,**/.git}","rebornix.Ruby":"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}","DotJoshJohnson.xml":"{**/*.xml}","stylelint.vscode-stylelint":"{**/.stylelintrc,**/stylelint.config.js}","eg2.vscode-npm-script":"{**/package.json}","ms-mssql.mssql":"{**/*.sql}","mtxr.sqltools":"{**/*.sql}","usqlextpublisher.usql-vscode-ext":"{**/*.usql}","ms-vscode.sublime-keybindings":"{**/.sublime-project,**/.sublime-workspace}","k--kato.intellij-idea-keybindings":"{**/.idea}","christian-kohler.npm-intellisense":"{**/package.json}","octref.vetur":"{**/*.vue}","ms-python.python":"{**/*.py,**/*.ipynb}","ms-toolsai.jupyter":"{**/*.ipynb}","cake-build.cake-vscode":"{**/build.cake}","Angular.ng-template":"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}","vscjava.vscode-maven":"**/pom.xml","ms-azuretools.vscode-azureterraform":"**/*.tf","HashiCorp.terraform":"**/*.tf","vsciot-vscode.vscode-arduino":"**/*.ino","ms-kubernetes-tools.vscode-kubernetes-tools":"{**/Chart.yaml}","GoogleCloudTools.cloudcode":"{**/skaffold.yaml}","Oracle.oracledevtools":"{**/*.sql}","ms-vscode.vscode-github-issue-notebooks":"{**/*.github-issues}"},extensionImportantTips:{"ms-dotnettools.csharp":{name:"C#",languages:["csharp"],pattern:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}"},"ms-python.python":{name:"Python",languages:["python"],pattern:"{**/*.py}"},"ms-toolsai.jupyter":{name:"Jupyter",pattern:"{**/*.ipynb}"},"golang.Go":{name:"Go",languages:["go"],pattern:"**/*.go"},"vscjava.vscode-java-pack":{name:"Java",languages:["java"],pattern:"{**/*.java}",isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"ms-vscode.PowerShell":{name:"PowerShell",languages:["powershell"],pattern:"{**/*.ps1,**/*.psd1,**/*.psm1}"},"ms-vscode.cpptools-extension-pack":{name:"C/C++",languages:["c","cpp"],pattern:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}"},"ms-azuretools.vscode-docker":{name:"Docker",languages:["dockerfile"],pattern:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}"},"octref.vetur":{name:"Vetur",languages:["vue"],pattern:"{**/*.vue}"},"ms-vscode.cmake-tools":{name:"CMake Tools",pattern:"{**/CMakeLists.txt}"},"ms-azure-devops.azure-pipelines":{name:"Azure Pipelines",pattern:"{**/azure-pipelines.yaml}"},"msazurermtools.azurerm-vscode-tools":{name:"Azure Resource Manager",pattern:"{**/azuredeploy.json}"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",pattern:"{**/devcontainer.json}"},"ms-azuretools.vscode-bicep":{name:"Bicep",pattern:"{**/*.bicep}"},"svelte.svelte-vscode":{name:"Svelte",pattern:"{**/*.svelte}"},"ms-vscode.vscode-github-issue-notebooks":{name:"GitHub Issue Notebooks",pattern:"{**/*.github-issues}"},"ms-playwright.playwright":{name:"Playwright",pattern:"{**/*playwright*.config.ts,**/*playwright*.config.js,**/*playwright*.config.mjs}"}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","lfs.vscode-emacs-friendly","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csharp","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","octref.vetur","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","matklad.rust-analyzer","rebornix.ruby"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",remotes:["github.com"]},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"Pivotal.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"Remote - WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],remoteExtensionTips:{wsl:{friendlyName:"Remote - WSL",extensionId:"ms-vscode-remote.remote-wsl"},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh"},"dev-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},"attached-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},vsonline:{friendlyName:"Visual Studio Online",extensionId:"ms-vsonline.vsonline"}},extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/(actions\\/)?workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-ia32":"appcenter://code?aid=f4289815-a66e-4ad9-b74f-d8e5bc093e41","win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{asimovKey:"AIF-444c3af9-8e69-4462-ab49-4191e6ad1916"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],sendASmile:{reportIssueUrl:"https://go.microsoft.com/fwlink/?LinkId=534872",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482"},documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",twitterUrl:"https://go.microsoft.com/fwlink/?LinkID=533687",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=786907",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05}],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletions"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookContentProvider","notebookDocumentEvents","notebookEditor","notebookEditorEdit","notebookLiveShare","terminalDimensions","terminalDataWriteEvent","textDocumentNotebook","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","resolvers"],"ms-toolsai.vscode-ai-remote":["resolvers","notebookEditor"],"ms-python.python":["quickPickSortByLabel","testObserver","notebookEditor"],"ms-dotnettools.dotnet-interactive-vscode":["notebookConcatTextDocument","notebookContentProvider","notebookCellExecutionState","notebookControllerKind","notebookDebugOptions","notebookDeprecated","notebookEditor","notebookEditorDecorationType","notebookEditorEdit","notebookLiveShare","notebookMessaging","notebookMime","textDocumentNotebook"],"GitHub.codespaces":["contribMenuBarHome","contribRemoteHelp","contribViewsRemote","notebookEditor","resolvers","terminalDataWriteEvent","treeViewReveal"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","resolvers","textSearchProvider"],"ms-vscode.remote-repositories":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline","notebookEditor"],"ms-vscode.vscode-github-issue-notebooks":["notebookEditor"],"tanhakabir.rest-book":["notebookEditor"],"ms-vscode-remote.remote-wsl":["resolvers","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-ssh":["resolvers","terminalDataWriteEvent","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-containers":["resolvers","workspaceTrust","terminalDimensions","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","resolvers"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"GitHub.vscode-pull-request-github":["tokenInformation"],"GitHub.copilot":["inlineCompletions","textDocumentNotebook"],"GitHub.copilot-nightly":["inlineCompletions","textDocumentNotebook"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","resolvers","scmSelectedProvider","scmValidation","textSearchProvider","timeline","notebookEditor"],"GitHub.remotehub-insiders":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","resolvers","scmSelectedProvider","scmValidation","textSearchProvider","timeline","notebookEditor"],"ms-python.gather":["notebookEditor","notebookCellExecutionState"],"ms-python.vscode-pylance":["notebookDocumentEvents","notebookEditor","notebookCellExecutionState"],"ms-toolsai.jupyter":["notebookConcatTextDocument","notebookControllerKind","notebookDebugOptions","notebookDeprecated","notebookEditor","notebookDocumentEvents","notebookEditorDecorationType","notebookEditorEdit","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","textDocumentNotebook","quickPickSortByLabel"],"dbaeumer.vscode-eslint":["tabs","notebookDocumentEvents","notebookEditor","notebookCellExecutionState"],"ms-vscode.azure-sphere-tools-ui":["resolvers"],"ms-azuretools.vscode-azureappservice":["terminalDataWriteEvent"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",featuresTelemetryPropertyName:"VSCode.ABExp.Features",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},experimentsUrl:"https://vscodeexperiments.azureedge.net/experiments/vscode-experiments.json",extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://vscode-auth.github.com","https://client-auth-staging-14a768b.herokuapp.com","https://*.gallerycdn.vsassets.io","https://github.com/microsoft/","https://github.com/MicrosoftDocs/","https://login.microsoftonline.com"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},builtInExtensions:[{name:"ms-vscode.references-view",version:"0.0.89",repo:"https://github.com/microsoft/vscode-references-view",metadata:{id:"dc489f46-520d-4556-ae85-1f9eab3c412d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug-companion",version:"1.0.17",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.66.1",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.0",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode-remote.remote-wsl-recommender",version:"0.0.15",repo:"https://github.com/microsoft/vscode-remote-wsl-recommender",metadata:{id:"cb296d3c-017a-4dee-83af-ebb5a5a16e9a",publisherId:{publisherId:"ac9410a2-0d75-40ec-90de-b59bb705801d",publisherName:"ms-vscode-remote",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"},platforms:["win32"],clientOnly:!0}],version:"1.66.2",commit:"dfd34e8260c270da74b5c2d86d61aee4b6d56977",date:"2022-04-11T07:32:42.744Z"},Object.keys(T).length===0&&Object.assign(T,{version:"1.66.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=T}),define(ve[28],we([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,k.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ve[196],we([0,1,64,13,27,28,191]),function(ee,e,k,n,w,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsWebMainService=void 0;let D=class extends T.BaseCredentialsMainService{constructor(P,A,R){super(P);this.environmentMainService=A,this.productService=R}async getSecretStoragePrefix(){return Promise.resolve(`${this.productService.urlProtocol}-server`)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new k.InMemoryCredentialsProvider,this._keytarCache;try{this._keytarCache=await new Promise((P,A)=>{ee(["keytar"],P,A)}),await this._keytarCache.findCredentials("test-keytar-loads")}catch(P){this.logService.warn(`Using the in-memory credential store as the operating system's credential store could not be accessed. Please see https://aka.ms/vscode-server-keyring on how to set this up. Details: ${P.message??P}`),this._keytarCache=new k.InMemoryCredentialsProvider}return this._keytarCache}};D=Ae([Oe(0,n.ILogService),Oe(1,w.INativeEnvironmentService),Oe(2,C.IProductService)],D),e.CredentialsWebMainService=D}),define(ve[34],we([0,1,118,12]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class w{constructor(){this.data=new Map}add(T,D){k.ok(n.isString(T)),k.ok(n.isObject(D)),k.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,D)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new w}),define(ve[197],we([0,1,7,34]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function w(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class C{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(v,P){this.schemasById[w(v)]=P,this._onDidChangeSchema.fire(v)}notifySchemaChanged(v){this._onDidChangeSchema.fire(v)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new C;n.Registry.add(e.Extensions.JSONContribution,T)}),define(ve[46],we([0,1,18,7,12,146,26,197,34]),function(ee,e,k,n,w,C,T,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var A;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const R=v.Registry.as(D.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(o,l=!0){this.registerConfigurations([o],l)}registerConfigurations(o,l=!0){const i=this.doRegisterConfigurations(o,l);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(o){const l=this.doDeregisterConfigurations(o);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}updateConfigurations({add:o,remove:l}){const i=[];i.push(...this.doDeregisterConfigurations(l)),i.push(...this.doRegisterConfigurations(o,!1)),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,k.distinct)(i)})}registerDefaultConfigurations(o){const l=[],i=[];for(const{overrides:t,source:r}of o)for(const s in t)if(l.push(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const a={...this.configurationDefaultsOverrides.get(s)?.value||{},...t[s]};this.configurationDefaultsOverrides.set(s,{source:r,value:a});const h=(0,T.getLanguageTagSettingPlainKey)(s),g={type:"object",default:a,description:C.localize(1,null,h),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:a,source:w.isString(r)?void 0:r};i.push(...b(s)),this.configurationProperties[s]=g,this.defaultLanguageConfigurationOverridesNode.properties[s]=g}else{this.configurationDefaultsOverrides.set(s,{value:t[s],source:r});const a=this.configurationProperties[s];a&&(this.updatePropertyDefaultValue(s,a),this.updateSchema(s,a))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}deregisterDefaultConfigurations(o){const l=[];for(const{overrides:i,source:t}of o)for(const r in i){const s=this.configurationDefaultsOverrides.get(r),a=w.isString(t)?t:t?.id,h=w.isString(s?.source)?s?.source:s?.source?.id;if(a===h)if(l.push(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const g=this.configurationProperties[r];g&&(this.updatePropertyDefaultValue(r,g),this.updateSchema(r,g))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const l of o)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,l){const i=[];return o.forEach(t=>{i.push(...this.validateAndRegisterProperties(t,l,t.extensionInfo,t.restrictedProperties)),this.configurationContributors.push(t),this.registerJSONConfiguration(t)}),i}doDeregisterConfigurations(o){const l=[],i=t=>{if(t.properties)for(const r in t.properties)l.push(r),delete this.configurationProperties[r],this.removeFromSchema(r,t.properties[r]);t.allOf&&t.allOf.forEach(r=>i(r))};for(const t of o){i(t);const r=this.configurationContributors.indexOf(t);r!==-1&&this.configurationContributors.splice(r,1)}return l}validateAndRegisterProperties(o,l=!0,i,t,r=3){r=w.isUndefinedOrNull(o.scope)?r:o.scope;let s=[],a=o.properties;if(a)for(let g in a){if(l&&m(g)){delete a[g];continue}const _=a[g];if(_.source=i,_.defaultDefaultValue=a[g].default,this.updatePropertyDefaultValue(g,_),e.OVERRIDE_PROPERTY_REGEX.test(g)?_.scope=void 0:(_.scope=w.isUndefinedOrNull(_.scope)?r:_.scope,_.restricted=w.isUndefinedOrNull(_.restricted)?!!t?.includes(g):_.restricted),a[g].hasOwnProperty("included")&&!a[g].included){this.excludedConfigurationProperties[g]=a[g],delete a[g];continue}else this.configurationProperties[g]=a[g];!a[g].deprecationMessage&&a[g].markdownDeprecationMessage&&(a[g].deprecationMessage=a[g].markdownDeprecationMessage),s.push(g)}let h=o.allOf;if(h)for(let g of h)s.push(...this.validateAndRegisterProperties(g,l,i,t,r));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(o){const l=i=>{let t=i.properties;if(t)for(const s in t)this.updateSchema(s,t[s]);let r=i.allOf;r&&r.forEach(l)};l(o)}updateSchema(o,l){switch(e.allSettings.properties[o]=l,l.scope){case 1:e.applicationSettings.properties[o]=l;break;case 2:e.machineSettings.properties[o]=l;break;case 6:e.machineOverridableSettings.properties[o]=l;break;case 3:e.windowSettings.properties[o]=l;break;case 4:e.resourceSettings.properties[o]=l;break;case 5:e.resourceSettings.properties[o]=l,this.resourceLanguageSettingsSchema.properties[o]=l;break}}removeFromSchema(o,l){switch(delete e.allSettings.properties[o],l.scope){case 1:delete e.applicationSettings.properties[o];break;case 2:delete e.machineSettings.properties[o];break;case 6:delete e.machineOverridableSettings.properties[o];break;case 3:delete e.windowSettings.properties[o];break;case 4:case 5:delete e.resourceSettings.properties[o],delete this.resourceLanguageSettingsSchema.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const l=`[${o}]`,i={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,i),e.allSettings.properties[l]=i,e.applicationSettings.properties[l]=i,e.machineSettings.properties[l]=i,e.machineOverridableSettings.properties[l]=i,e.windowSettings.properties[l]=i,e.resourceSettings.properties[l]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const o={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,l){const i=this.configurationDefaultsOverrides.get(o);let t=i?.value,r=i?.source;w.isUndefined(t)&&(t=l.defaultDefaultValue,r=void 0),w.isUndefined(t)&&(t=d(l.type)),l.default=t,l.defaultValueSource=r}}const S="\\[([^\\]]+)\\]",u=new RegExp(S,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${S})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function b(c){const o=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let l=u.exec(c);for(;l?.length;){const i=l[1].trim();i&&o.push(i),l=u.exec(c)}}return(0,k.distinct)(o)}e.overrideIdentifiersFromKey=b;function f(c){return c.reduce((o,l)=>`${o}[${l}]`,"")}e.keyFromOverrideIdentifiers=f;function d(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const p=new E;v.Registry.add(e.Extensions.Configuration,p);function m(c){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?C.localize(7,null,c):p.getConfigurationProperties()[c]!==void 0?C.localize(8,null,c):null:C.localize(6,null)}e.validateProperty=m;function y(){const c=[],o=p.getConfigurationProperties();for(const l of Object.keys(o))c.push([l,o[l].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=y}),define(ve[198],we([0,1,18,7,59,2,31,22,12,4,26,46,34]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class S{constructor(i={},t=[],r=[]){this._contents=i,this._keys=t,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,A.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,t){const r=this.getContentsForOverrideIdentifer(t);return r?i?(0,A.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){const t=[];for(const r of this.overrides)r.identifiers.includes(i)&&t.push(...r.keys);return k.distinct(t)}getAllOverrideIdentifiers(){const i=[];for(const t of this.overrides)i.push(...t.identifiers);return k.distinct(i)}override(i){let t=this.overrideConfigurations.get(i);return t||(t=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,t)),t}merge(...i){const t=D.deepClone(this.contents),r=D.deepClone(this.overrides),s=[...this.keys];for(const a of i){this.mergeContents(t,a.contents);for(const h of a.overrides){const[g]=r.filter(_=>k.equals(_.identifiers,h.identifiers));g?(this.mergeContents(g.contents,h.contents),g.keys.push(...h.keys),g.keys=k.distinct(g.keys)):r.push(D.deepClone(h))}for(const h of a.keys)s.indexOf(h)===-1&&s.push(h)}return new S(t,s,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const t=this.getContentsForOverrideIdentifer(i);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let r={};for(const s of k.distinct([...Object.keys(this.contents),...Object.keys(t)])){let a=this.contents[s],h=t[s];h&&(typeof a=="object"&&typeof h=="object"?(a=D.deepClone(a),this.mergeContents(a,h)):a=h),r[s]=a}return new S(r,this.keys,this.overrides)}mergeContents(i,t){for(const r of Object.keys(t)){if(r in i&&v.isObject(i[r])&&v.isObject(t[r])){this.mergeContents(i[r],t[r]);continue}i[r]=D.deepClone(t[r])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?D.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let t=null,r=null;const s=a=>{a&&(r?this.mergeContents(r,a):r=D.deepClone(a))};for(const a of this.overrides)k.equals(a.identifiers,[i])?t=a.contents:a.identifiers.includes(i)&&s(a.contents);return s(t),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,t){this.addKey(i),(0,A.addToValueTree)(this.contents,i,t,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,A.removeFromValueTree)(this.contents,i)}addKey(i){let t=this.keys.length;for(let r=0;r<t;r++)i.indexOf(this.keys[r])===0&&(t=r);this.keys.splice(t,1,i)}removeKey(i){let t=this.keys.indexOf(i);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=S;class u extends S{constructor(i={}){const t=E.Registry.as(R.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(t),s=Object.create(null),a=[];for(const h in t){const g=i[h],_=g!==void 0?g:t[h].default;(0,A.addToValueTree)(s,h,_,F=>console.error(`Conflict in default settings: ${F}`))}for(const h of Object.keys(s))R.OVERRIDE_PROPERTY_REGEX.test(h)&&a.push({identifiers:(0,R.overrideIdentifiersFromKey)(h),keys:Object.keys(s[h]),contents:(0,A.toValuesTree)(s[h],g=>console.error(`Conflict in default settings file: ${g}`))});super(s,r,a)}}e.DefaultConfigurationModel=u;class b{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,t){if(!v.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,t)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,t){this._raw=i;const{contents:r,keys:s,overrides:a,restricted:h}=this.doParseRaw(i,t);this._configurationModel=new S(r,s,a),this._restrictedConfigurations=h||[]}doParseContent(i){let t={},r=null,s=[],a=[],h=[];function g(F){Array.isArray(s)?s.push(F):r!==null&&(s[r]=F)}let _={onObjectBegin:()=>{let F={};g(F),a.push(s),s=F,r=null},onObjectProperty:F=>{r=F},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{let F=[];g(F),a.push(s),s=F,r=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:g,onError:(F,$,K)=>{h.push({error:F,offset:$,length:K})}};if(i)try{w.visit(i,_),t=s[0]||{}}catch(F){console.error(`Error while parsing settings file ${this._name}: ${F}`),this._parseErrors=[F]}return t}doParseRaw(i,t){const r=E.Registry.as(R.Extensions.Configuration).getConfigurationProperties(),s=this.filter(i,r,!0,t);i=s.raw;const a=(0,A.toValuesTree)(i,_=>console.error(`Conflict in settings file ${this._name}: ${_}`)),h=Object.keys(i),g=this.toOverrides(i,_=>console.error(`Conflict in settings file ${this._name}: ${_}`));return{contents:a,keys:h,overrides:g,restricted:s.restricted}}filter(i,t,r,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:i,restricted:[]};const a={},h=[];for(let g in i)if(R.OVERRIDE_PROPERTY_REGEX.test(g)&&r){const _=this.filter(i[g],t,!1,s);a[g]=_.raw,h.push(..._.restricted)}else{const _=t[g],F=_?typeof _.scope!="undefined"?_.scope:3:void 0;_?.restricted&&h.push(g),(F===void 0||s.scopes===void 0||s.scopes.includes(F))&&(s.skipRestricted&&_?.restricted||(a[g]=i[g]))}return{raw:a,restricted:h}}toOverrides(i,t){const r=[];for(const s of Object.keys(i))if(R.OVERRIDE_PROPERTY_REGEX.test(s)){const a={};for(const h in i[s])a[h]=i[s][h];r.push({identifiers:(0,R.overrideIdentifiersFromKey)(s),keys:Object.keys(a),contents:(0,A.toValuesTree)(a,t)})}return r}}e.ConfigurationModelParser=b;class f extends C.Disposable{constructor(i,t,r,s){super();this.userSettingsResource=i,this.scopes=t,this.fileService=s,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new b(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.any(n.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),n.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&r.isEqual(a.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new S}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=f;class d{constructor(i,t,r=new S,s=new S,a=new T.ResourceMap,h=new S,g=new T.ResourceMap,_=!0){this._defaultConfiguration=i,this._localUserConfiguration=t,this._remoteUserConfiguration=r,this._workspaceConfiguration=s,this._folderConfigurations=a,this._memoryConfiguration=h,this._memoryConfigurationByResource=g,this._freeze=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(i,t,r){return this.getConsolidateConfigurationModel(t,r).getValue(i)}updateValue(i,t,r={}){let s;r.resource?(s=this._memoryConfigurationByResource.get(r.resource),s||(s=new S,this._memoryConfigurationByResource.set(r.resource,s))):s=this._memoryConfiguration,t===void 0?s.removeValue(i):s.setValue(i,t),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,t,r){const s=this.getConsolidateConfigurationModel(t,r),a=this.getFolderConfigurationModelForResource(t.resource,r),h=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,g=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),_=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),F=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),$=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),K=r?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,I=a?t.overrideIdentifier?a.freeze().override(t.overrideIdentifier).getValue(i):a.freeze().getValue(i):void 0,W=t.overrideIdentifier?h.override(t.overrideIdentifier).getValue(i):h.getValue(i),M=s.getValue(i),q=k.distinct(k.flatten(s.overrides.map(Z=>Z.identifiers))).filter(Z=>s.getOverrideValue(i,Z)!==void 0);return{defaultValue:g,userValue:_,userLocalValue:F,userRemoteValue:$,workspaceValue:K,workspaceFolderValue:I,memoryValue:W,value:M,default:g!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,user:_!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,userLocal:F!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,userRemote:$!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,workspace:K!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,workspaceFolder:I!==void 0?{value:a?.freeze().getValue(i),override:t.overrideIdentifier?a?.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,memory:W!==void 0?{value:h.getValue(i),override:t.overrideIdentifier?h.getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:q.length?q:void 0}}keys(i){const t=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,t){this._folderConfigurations.set(i,t),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,t){const r=[];if(!t){const{added:s,updated:a,removed:h}=c(this._defaultConfiguration,i);t=[...s,...a,...h]}for(const s of t)for(const a of(0,R.overrideIdentifiersFromKey)(s)){const h=this._defaultConfiguration.getKeysForOverrideIdentifier(a),g=i.getKeysForOverrideIdentifier(a),_=[...g.filter(F=>h.indexOf(F)===-1),...h.filter(F=>g.indexOf(F)===-1),...h.filter(F=>!D.equals(this._defaultConfiguration.override(a).getValue(F),i.override(a).getValue(F)))];r.push([a,_])}return this.updateDefaultConfiguration(i),{keys:t,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:t,updated:r,removed:s,overrides:a}=c(this.localUserConfiguration,i),h=[...t,...r,...s];return h.length&&this.updateLocalUserConfiguration(i),{keys:h,overrides:a}}compareAndUpdateRemoteUserConfiguration(i){const{added:t,updated:r,removed:s,overrides:a}=c(this.remoteUserConfiguration,i);let h=[...t,...r,...s];return h.length&&this.updateRemoteUserConfiguration(i),{keys:h,overrides:a}}compareAndUpdateWorkspaceConfiguration(i){const{added:t,updated:r,removed:s,overrides:a}=c(this.workspaceConfiguration,i);let h=[...t,...r,...s];return h.length&&this.updateWorkspaceConfiguration(i),{keys:h,overrides:a}}compareAndUpdateFolderConfiguration(i,t){const r=this.folderConfigurations.get(i),{added:s,updated:a,removed:h,overrides:g}=c(r,t);let _=[...s,...a,...h];return(_.length||!r)&&this.updateFolderConfiguration(i,t),{keys:_,overrides:g}}compareAndDeleteFolderConfiguration(i){const t=this.folderConfigurations.get(i);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:s,removed:a,overrides:h}=c(t,void 0);return{keys:[...r,...s,...a],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,t){let r=this.getConsolidatedConfigurationModelForResource(i,t);return i.overrideIdentifier?r.override(i.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:i},t){let r=this.getWorkspaceConsolidatedConfiguration();if(t&&i){const s=t.getFolder(i);s&&(r=this.getFolderConsolidatedConfiguration(s.uri)||r);const a=this._memoryConfigurationByResource.get(i);a&&(r=r.merge(a))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let t=this._foldersConsolidatedConfigurations.get(i);if(!t){const r=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(i);s?(t=r.merge(s),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(i,t)):t=r}return t}getFolderConfigurationModelForResource(i,t){if(t&&i){const r=t.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,t)=>{const{contents:r,overrides:s,keys:a}=this._folderConfigurations.get(t);return i.push([t,{contents:r,overrides:s,keys:a}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>i.add(t)),this.userConfiguration.freeze().keys.forEach(t=>i.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>t.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>t.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s))),[...t.values()]}static parse(i){const t=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.user),s=this.parseConfigurationModel(i.workspace),a=i.folders.reduce((h,g)=>(h.set(P.URI.revive(g[0]),this.parseConfigurationModel(g[1])),h),new T.ResourceMap);return new d(t,r,new S,s,a,new S,new T.ResourceMap,!1)}static parseConfigurationModel(i){return new S(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=d;function p(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const i=new Set,t=new Map;for(const s of l)s.keys.forEach(a=>i.add(a)),s.overrides.forEach(([a,h])=>{const g=(0,T.getOrSet)(t,a,new Set);h.forEach(_=>g.add(_))});const r=[];return t.forEach((s,a)=>r.push([a,[...s.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=p;class m{constructor(i,t,r,s){this.change=i,this.previous=t,this.currentConfiguraiton=r,this.currentWorkspace=s,this._previousConfiguration=void 0;const a=new Set;i.keys.forEach(g=>a.add(g)),i.overrides.forEach(([,g])=>g.forEach(_=>a.add(_))),this.affectedKeys=[...a.values()];const h=new S;this.affectedKeys.forEach(g=>h.setValue(g,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=d.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(t){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,t,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(i,t,this.currentWorkspace);return!D.equals(r,s)}return!0}return!1}doesAffectedKeysTreeContains(i,t){let r=(0,A.toValuesTree)({[t]:!0},()=>{}),s;for(;typeof r=="object"&&(s=Object.keys(r)[0]);){if(i=i[s],!i)return!1;r=r[s]}return!0}}e.ConfigurationChangeEvent=m;class y extends m{constructor(i,t,r,s){super({keys:i.allKeys(),overrides:[]},void 0,i,t);this.source=r,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=y;function c(l,i){const{added:t,removed:r,updated:s}=o(i,l),a=[],h=l?.getAllOverrideIdentifiers()||[],g=i?.getAllOverrideIdentifiers()||[];if(i){const _=g.filter(F=>!h.includes(F));for(const F of _)a.push([F,i.getKeysForOverrideIdentifier(F)])}if(l){const _=h.filter(F=>!g.includes(F));for(const F of _)a.push([F,l.getKeysForOverrideIdentifier(F)])}if(i&&l){for(const _ of h)if(g.includes(_)){const F=o({contents:l.getOverrideValue(void 0,_)||{},keys:l.getKeysForOverrideIdentifier(_)},{contents:i.getOverrideValue(void 0,_)||{},keys:i.getKeysForOverrideIdentifier(_)});a.push([_,[...F.added,...F.removed,...F.updated]])}}return{added:t,removed:r,updated:s,overrides:a}}function o(l,i){const t=l?i?l.keys.filter(a=>i.keys.indexOf(a)===-1):[...l.keys]:[],r=i?l?i.keys.filter(a=>l.keys.indexOf(a)===-1):[...i.keys]:[],s=[];if(l&&i){for(const a of i.keys)if(l.keys.indexOf(a)!==-1){const h=(0,A.getConfigurationValue)(i.contents,a),g=(0,A.getConfigurationValue)(l.contents,a);D.equals(h,g)||s.push(a)}}return{added:t,removed:r,updated:s}}}),define(ve[95],we([0,1,14,7,2,20,26,198,46,34]),function(ee,e,k,n,w,C,T,D,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class A extends w.Disposable{constructor(E,S){super();this.settingsResource=E,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new D.UserSettings(this.settingsResource,void 0,C.extUriBiasedIgnorePathCase,S)),this.configuration=new D.Configuration(new D.DefaultConfigurationModel,new D.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new k.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(P.Registry.as(v.Extensions.Configuration).onDidUpdateConfiguration(({properties:u})=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const E=await this.userConfiguration.loadConfiguration();this.configuration=new D.Configuration(new D.DefaultConfigurationModel,E)}getConfigurationData(){return this.configuration.toData()}getValue(E,S){const u=typeof E=="string"?E:void 0,b=(0,T.isConfigurationOverrides)(E)?E:(0,T.isConfigurationOverrides)(S)?S:{};return this.configuration.getValue(u,b,void 0)}updateValue(E,S,u,b){return Promise.reject(new Error("not supported"))}inspect(E){return this.configuration.inspect(E,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const E=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(E)}onDidChangeUserConfiguration(E){const S=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(E);this.trigger(u,S,1)}onDidDefaultConfigurationChange(E){const S=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new D.DefaultConfigurationModel,E);this.trigger(u,S,6)}trigger(E,S,u){const b=new D.ConfigurationChangeEvent(E,{data:S},this.configuration);b.source=u,b.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(b)}getTargetConfiguration(E){switch(E){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=A}),define(ve[96],we([0,1,9,6]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,n.createDecorator)("remoteAuthorityResolverService");var w;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(w=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class C extends k.ErrorNoTelemetry{constructor(D,v=w.Unknown,P){super(D);this._message=D,this._code=v,this._detail=P,this.isHandled=v===w.NotAvailable&&P===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype)}static isTemporarilyNotAvailable(D){return D instanceof C&&D._code===w.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof C&&D._code===w.NoResolverFound}static isHandled(D){return D instanceof C&&D.isHandled}}e.RemoteAuthorityResolverError=C}),define(ve[199],we([0,1,8]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function n(C){return C.scheme===k.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=n;function w(C){if(!C)return;const T=C.indexOf("+");return T<0?C:C.substr(0,T)}e.getRemoteName=w}),define(ve[40],we([0,1,15,6,199]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(S){if(typeof S=="object"&&S!==null&&S.supported!==!0)return S.description}e.getWorkspaceSupportTypeMessage=C;function T(S){return S&&typeof S=="object"&&typeof S.id=="string"&&(!S.uuid||typeof S.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(S){S[S.System=0]="System",S[S.User=1]="User"})(D=e.ExtensionType||(e.ExtensionType={}));var v;(function(S){S.WIN32_X64="win32-x64",S.WIN32_IA32="win32-ia32",S.WIN32_ARM64="win32-arm64",S.LINUX_X64="linux-x64",S.LINUX_ARM64="linux-arm64",S.LINUX_ARMHF="linux-armhf",S.ALPINE_X64="alpine-x64",S.ALPINE_ARM64="alpine-arm64",S.DARWIN_X64="darwin-x64",S.DARWIN_ARM64="darwin-arm64",S.WEB="web",S.UNIVERSAL="universal",S.UNKNOWN="unknown",S.UNDEFINED="undefined"})(v=e.TargetPlatform||(e.TargetPlatform={}));class P{constructor(u){this.value=u,this._lower=u.toLowerCase()}static equals(u,b){if(typeof u=="undefined"||u===null)return typeof b=="undefined"||b===null;if(typeof b=="undefined"||b===null)return!1;if(typeof u=="string"||typeof b=="string"){let f=typeof u=="string"?u:u.value,d=typeof b=="string"?b:b.value;return k.equalsIgnoreCase(f,d)}return u._lower===b._lower}static toKey(u){return typeof u=="string"?u.toLowerCase():u._lower}}e.ExtensionIdentifier=P;function A(S){return S.contributes&&S.contributes.localizations?S.contributes.localizations.length>0:!1}e.isLanguagePackExtension=A;function R(S){return S.contributes&&S.contributes.authentication?S.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=R;function E(S,u){if(u){const b=`onResolveRemoteAuthority:${(0,w.getRemoteName)(u)}`;return S.activationEvents?.indexOf(b)!==-1}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(ve[35],we([0,1,15,30,40,3,4,9,24]),function(ee,e,k,n,w,C,T,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(i,t){return i.uuid&&t.uuid?i.uuid===t.uuid:i.id===t.id?!0:(0,k.compareIgnoreCase)(i.id,t.id)===0}e.areSameExtensions=P;const A=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class R{constructor(t,r,s="undefined"){this.version=r,this.targetPlatform=s,this.id=t.id}static create(t){const r=t.manifest?t.manifest.version:t.version,s=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new R(t.identifier,r,s)}static parse(t){const r=A.exec(t);return r&&r[1]&&r[2]?new R({id:r[1]},r[2],r[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof R?P(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=R;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(i){const t=E.exec(i);return t&&t[1]?[b(t[1]),t[2]]:[b(i),void 0]}e.getIdAndVersion=S;function u(i,t){return`${i}.${t}`}e.getExtensionId=u;function b(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=b;function f(i,t){return b(u(i,t))}e.getGalleryExtensionId=f;function d(i,t){const r=[],s=a=>{for(const h of r)if(h.some(g=>P(t(g),t(a))))return h;return null};for(const a of i){const h=s(a);h?h.push(a):r.push([a])}return r}e.groupByExtension=d;function p(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=p;function m(i){return{id:i.identifier.id,name:i.name,galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),...i.telemetryData}}e.getGalleryExtensionTelemetryData=m,e.BetterMergeId=new w.ExtensionIdentifier("pprice.better-merge");function y(i){const t=new Set;if(i.malicious)for(const r of i.malicious)t.add(r.id);return t}e.getMaliciousExtensionsSet=y;function c(i,t){const r=[],s=t.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const a=s.shift();if(a&&r.every(h=>!P(h.identifier,{id:a}))){const h=i.filter(g=>P(g.identifier,{id:a}));h.length===1&&(r.push(h[0]),s.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=c;async function o(i,t){if(!C.isLinux)return!1;let r;try{r=(await i.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await i.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){t.debug("Error while getting the os-release file.",(0,D.getErrorMessage)(a))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=o;async function l(i,t){const r=await o(i,t),s=(0,n.getTargetPlatform)(r?"alpine":C.platform,v.arch);return t.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=l}),define(ve[97],we([0,1,21,9,79,8,56,4,151,30,35,40]),function(ee,e,k,n,w,C,T,D,v,P,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLIService=void 0;const E=f=>(0,v.localize)(0,null,f),S=(0,v.localize)(1,null,"ms-dotnettools.csharp");function u(f,d){return d?`${f.publisher}.${f.name}@${f.version}`:`${f.publisher}.${f.name}`}let b=class{constructor(d,p){this.extensionManagementService=d,this.extensionGalleryService=p}get location(){}async listExtensions(d,p,m=console){let y=await this.extensionManagementService.getInstalled(1);const c=R.EXTENSION_CATEGORIES.map(l=>l.toLowerCase());if(p&&p!==""){if(c.indexOf(p.toLowerCase())<0){m.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}y=y.filter(l=>l.manifest.categories?l.manifest.categories.map(t=>t.toLowerCase()).indexOf(p.toLowerCase())>-1:!1)}else if(p===""){m.log("Possible Categories: "),c.forEach(l=>{m.log(l)});return}this.location&&m.log((0,v.localize)(2,null,this.location)),y=y.sort((l,i)=>l.identifier.id.localeCompare(i.identifier.id));let o;for(let l of y)o!==l.identifier.id&&(o=l.identifier.id,m.log(u(l.manifest,d)))}async installExtensions(d,p,m,y,c=console){const o=[],l=[];d.length&&c.log(this.location?(0,v.localize)(3,null,this.location):(0,v.localize)(4,null));const i=await this.extensionManagementService.getInstalled(1),t=(h,g)=>{const _=i.find(F=>(0,A.areSameExtensions)(F.identifier,{id:h}));if(_){if(!y&&(!g||g==="prerelease"&&_.preRelease))return c.log((0,v.localize)(5,null,h,_.manifest.version,h)),!1;if(g&&_.manifest.version===g)return c.log((0,v.localize)(6,null,`${h}@${g}`)),!1}return!0},r=(h,g,_)=>{a.push({id:h,version:g!=="prerelease"?g:void 0,installOptions:{...m,isBuiltin:_,installPreReleaseVersion:g==="prerelease"||m.installPreReleaseVersion}})},s=[],a=[];for(const h of d)if(h instanceof D.URI)s.push(h);else{const[g,_]=(0,A.getIdAndVersion)(h);t(g,_)&&r(g,_,!1)}for(const h of p){const[g,_]=(0,A.getIdAndVersion)(h);t(g,_)&&r(g,_,!0)}if(s.length&&await Promise.all(s.map(async h=>{try{const g=await this.installVSIX(h,{...m,isBuiltin:!1},y,c);g&&l.push(g)}catch(g){c.error(g.message||g.stack||g),o.push(h.toString())}})),a.length){const h=await this.getGalleryExtensions(a);await Promise.all(a.map(async g=>{const _=h.get(g.id.toLowerCase());if(_)try{const F=await this.installFromGallery(g,_,i,y,c);F&&l.push(F)}catch(F){c.error(F.message||F.stack||F),o.push(g.id)}else c.error(`${E(g.version?`${g.id}@${g.version}`:g.id)}
${S}`),o.push(g.id)}))}if(o.length)throw new Error((0,v.localize)(7,null,o.join(", ")))}async installVSIX(d,p,m,y){const c=await this.extensionManagementService.getManifest(d);if(!c)throw new Error("Invalid vsix");if(await this.validateVSIX(c,m,y))try{return await this.extensionManagementService.install(d,p),y.log((0,v.localize)(8,null,(0,w.getBaseLabel)(d))),c}catch(l){if((0,n.isCancellationError)(l))return y.log((0,v.localize)(9,null,(0,w.getBaseLabel)(d))),null;throw l}return null}async getGalleryExtensions(d){const p=new Map,m=d.some(c=>c.installOptions.installPreReleaseVersion),y=await this.extensionGalleryService.getExtensions(d.map(c=>({...c,preRelease:m})),k.CancellationToken.None);for(const c of y)p.set(c.identifier.id.toLowerCase(),c);return p}async installFromGallery({id:d,version:p,installOptions:m},y,c,o,l){const i=await this.extensionGalleryService.getManifest(y,k.CancellationToken.None);if(i&&!this.validateExtensionKind(i,l))return null;const t=c.find(r=>(0,A.areSameExtensions)(r.identifier,y.identifier));if(t){if(y.version===t.manifest.version)return l.log((0,v.localize)(10,null,p?`${d}@${p}`:d)),null;l.log((0,v.localize)(11,null,d,y.version))}try{return m.isBuiltin?l.log(p?(0,v.localize)(12,null,d,p):(0,v.localize)(13,null,d)):l.log(p?(0,v.localize)(14,null,d,p):(0,v.localize)(15,null,d)),await this.extensionManagementService.installFromGallery(y,{...m,installGivenVersion:!!p}),l.log((0,v.localize)(16,null,d,y.version)),i}catch(r){if((0,n.isCancellationError)(r))return l.log((0,v.localize)(17,null,d)),null;throw r}}validateExtensionKind(d,p){return!0}async validateVSIX(d,p,m){const y={id:(0,A.getGalleryExtensionId)(d.publisher,d.name)},o=(await this.extensionManagementService.getInstalled(1)).find(l=>(0,A.areSameExtensions)(y,l.identifier)&&(0,T.gt)(l.manifest.version,d.version));return o&&!p?(m.log((0,v.localize)(18,null,o.identifier.id,o.manifest.version,d.version)),!1):this.validateExtensionKind(d,m)}async uninstallExtensions(d,p,m=console){const y=async o=>{if(o instanceof D.URI){const l=await this.extensionManagementService.getManifest(o);return u(l)}return o},c=[];for(const o of d){const l=await y(o),t=(await this.extensionManagementService.getInstalled()).filter(r=>(0,A.areSameExtensions)(r.identifier,{id:l}));if(!t.length)throw new Error(`${this.notInstalled(l)}
${S}`);if(t.some(r=>r.type===0)){m.log((0,v.localize)(19,null,l));return}if(!p&&t.some(r=>r.isBuiltin)){m.log((0,v.localize)(20,null,l));return}m.log((0,v.localize)(21,null,l));for(const r of t)await this.extensionManagementService.uninstall(r),c.push(r);this.location?m.log((0,v.localize)(22,null,l,this.location)):m.log((0,v.localize)(23,null,l))}}async locateExtension(d,p=console){const m=await this.extensionManagementService.getInstalled();d.forEach(y=>{m.forEach(c=>{if(c.identifier.id===y&&c.location.scheme===C.Schemas.file){p.log(c.location.fsPath);return}})})}notInstalled(d){return this.location?(0,v.localize)(24,null,d,this.location):(0,v.localize)(25,null,d)}};b=Ae([Oe(0,P.IExtensionManagementService),Oe(1,P.IExtensionGalleryService)],b),e.ExtensionManagementCLIService=b}),define(ve[200],we([0,1,14,9,2,3,20,56,4,23,19,27,30,35,17,13]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E,S,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let f=class extends w.Disposable{constructor(p,m,y,c){super();this.fileService=m,this.extensionGalleryService=y,this.logService=c,this.extensionsDownloadDir=v.URI.file(p.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(p,m){await this.cleanUpPromise;const y=this.getName(p),c=(0,T.joinPath)(this.extensionsDownloadDir,y);if(!await this.fileService.exists(c)){const o=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,P.generateUuid)()}`);await this.fileService.exists(o)||await this.extensionGalleryService.download(p,o,m);try{await this.rename(o,c,Date.now()+2*60*1e3)}catch(l){try{await this.fileService.del(o)}catch{}if(l.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",p.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,n.getErrorMessage)(l)}. Deleted the vsix from downloaded location`,o.path),l}}return c}async delete(p){await this.cleanUpPromise,await this.fileService.del(p)}async rename(p,m,y){try{await A.Promises.rename(p.fsPath,m.fsPath)}catch(c){if(C.isWindows&&c&&c.code==="EPERM"&&Date.now()<y)return this.logService.info(`Failed renaming ${p} to ${m} with 'EPERM' error. Trying again...`),this.rename(p,m,y);throw c}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const p=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(p.children){const m=[],y=[];for(const l of p.children){const i=S.ExtensionKey.parse(l.name);i&&y.push([i,l])}const c=(0,S.groupByExtension)(y,([l])=>l),o=[];for(const l of c)l.sort((i,t)=>D.rcompare(i[0].version,t[0].version)),m.push(...l.slice(1).map(i=>i[1].resource)),o.push(l[0][1]);o.sort((l,i)=>l.mtime-i.mtime),m.push(...o.slice(0,Math.max(0,o.length-this.cache)).map(l=>l.resource)),await k.Promises.settled(m.map(l=>(this.logService.trace("Deleting vsix from cache",l.path),this.fileService.del(l))))}}catch(p){this.logService.error(p)}}getName(p){return this.cache?S.ExtensionKey.create(p).toString().toLowerCase():(0,P.generateUuid)()}};f=Ae([Oe(0,R.INativeEnvironmentService),Oe(1,u.IFileService),Oe(2,E.IExtensionGalleryService),Oe(3,b.ILogService)],f),e.ExtensionsDownloader=f}),define(ve[201],we([0,1,2,5,19,40]),function(ee,e,k,n,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class T extends k.Disposable{constructor(v,P){super();this.environmentService=v,this.extensionsManifestCache=(0,n.join)(this.environmentService.userDataPath,C.MANIFEST_CACHE_FOLDER,C.USER_MANIFEST_CACHE_FILE),this._register(P.onDidInstallExtensions(A=>this.onDidInstallExtensions(A))),this._register(P.onDidUninstallExtension(A=>this.onDidUnInstallExtension(A)))}onDidInstallExtensions(v){v.some(P=>!!P.local)&&this.invalidate()}onDidUnInstallExtension(v){v.error||this.invalidate()}invalidate(){w.Promises.rm(this.extensionsManifestCache,w.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=T}),define(ve[98],we([0,1,68,18,14,2,8,5,19,27,30,35,67,13]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let u=class extends C.Disposable{constructor(d,p,m){super();this.extensionManagementService=d,this.logService=m,this.cache=this._register(new b(p,m)),this.extensionManagementService.registerParticipant({postInstall:async y=>this.postInstallExtension(y),postUninstall:async y=>this.postUninstallExtension(y)})}async getLanguageIds(){const d=await this.cache.getLanguagePacks(),p=["en",...Object.keys(d)];return(0,n.distinct)(p)}async postInstallExtension(d){d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",d.identifier.id),await this.update())}async postUninstallExtension(d){const p=await this.cache.getLanguagePacks();Object.keys(p).some(m=>p[m]&&p[m].extensions.some(y=>(0,R.areSameExtensions)(y.extensionIdentifier,d.identifier)))&&(this.logService.info("Removing language packs from the extension",d.identifier.id),await this.update())}async update(){const[d,p]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),m=await this.cache.update(p);return!(0,n.equals)(Object.keys(d),Object.keys(m))}};u=Ae([Oe(0,A.IExtensionManagementService),Oe(1,P.INativeEnvironmentService),Oe(2,S.ILogService)],u),e.LocalizationsService=u;let b=class extends C.Disposable{constructor(d,p){super();this.logService=p,this.languagePacks={},this.languagePacksFilePath=(0,D.join)(d.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new w.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(d){return this.withLanguagePacks(p=>{Object.keys(p).forEach(m=>delete p[m]),this.createLanguagePacksFromExtensions(p,...d)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(d,...p){for(const m of p)m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(d,m);Object.keys(d).forEach(m=>this.updateHash(d[m]))}createLanguagePacksFromExtension(d,p){const m=p.identifier,y=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const c of y)if(p.location.scheme===T.Schemas.file&&(0,E.isValidLocalization)(c)){let o=d[c.languageId];o||(o={hash:"",extensions:[],translations:{}},d[c.languageId]=o);let l=o.extensions.filter(i=>(0,R.areSameExtensions)(i.extensionIdentifier,m))[0];l?l.version=p.manifest.version:o.extensions.push({extensionIdentifier:m,version:p.manifest.version});for(const i of c.translations)o.translations[i.id]=(0,D.join)(p.location.fsPath,i.path)}}updateHash(d){if(d){const p=(0,k.createHash)("md5");for(const m of d.extensions)p.update(m.extensionIdentifier.uuid||m.extensionIdentifier.id).update(m.version);d.hash=p.digest("hex")}}withLanguagePacks(d=()=>null){return this.languagePacksFileLimiter.queue(()=>{let p=null;return v.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,m=>m.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(m)).then(m=>{try{return JSON.parse(m)}catch{return{}}}).then(m=>(p=d(m),m)).then(m=>{for(const c of Object.keys(m))m[c]||delete m[c];this.languagePacks=m,this.initializedCache=!0;const y=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",y),v.Promises.writeFile(this.languagePacksFilePath,y)}).then(()=>p,m=>this.logService.error(m))})}};b=Ae([Oe(0,P.INativeEnvironmentService),Oe(1,S.ILogService)],b)}),define(ve[47],we([0,1,16,161,46,6,34]),function(ee,e,k,n,w,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,C.createDecorator)("requestService");function D(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}e.isSuccess=D;function v(u){return u.res.statusCode===204}async function P(u){if(!D(u))throw new Error("Server returned "+u.res.statusCode);return v(u)?null:(await(0,k.streamToBuffer)(u.stream)).toString()}e.asText=P;async function A(u){if(!D(u))throw new Error("Server returned "+u.res.statusCode);if(v(u))return null;const f=(await(0,k.streamToBuffer)(u.stream)).toString();try{return JSON.parse(f)}catch(d){throw d.message+=`:
`+f,d}}e.asJson=A;function R(u){S(u)}e.updateProxyConfigurationsScope=R;let E;function S(u){const b=T.Registry.as(w.Extensions.Configuration),f=E;E={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},b.updateConfigurations({add:[E],remove:f?[f]:[]})}S(2)}),define(ve[202],we([0,1,21,8,17,47]),function(ee,e,k,n,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(v,P){this.requestService=v,this.fileService=P}async download(v,P,A=k.CancellationToken.None){if(v.scheme===n.Schemas.file||v.scheme===n.Schemas.vscodeRemote){await this.fileService.copy(v,P);return}const R={type:"GET",url:v.toString()},E=await this.requestService.request(R,A);if(E.res.statusCode===200)await this.fileService.writeFile(P,E.stream);else{const S=await(0,C.asText)(E);throw new Error(`Expected 200, got back ${E.res.statusCode} instead.

${S}`)}}};T=Ae([Oe(0,C.IRequestService),Oe(1,w.IFileService)],T),e.DownloadService=T}),define(ve[203],we([0,1,16,21]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class w{constructor(D){this.service=D}listen(D,v){throw new Error("Invalid listen")}call(D,v,P){switch(v){case"request":return this.service.request(P[0],n.CancellationToken.None).then(async({res:A,stream:R})=>{const E=await(0,k.streamToBuffer)(R);return[{statusCode:A.statusCode,headers:A.headers},E]})}throw new Error("Invalid call")}}e.RequestChannel=w;class C{constructor(D){this.channel=D}async request(D,v){return C.request(this.channel,D,v)}static async request(D,v,P){const[A,R]=await D.call("request",[v]);return{res:A,stream:(0,k.bufferToStream)(R)}}}e.RequestChannelClient=C}),define(ve[204],we([0,1,69,12]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function w(T,D){return T.protocol==="http:"?D.HTTP_PROXY||D.http_proxy||null:T.protocol==="https:"&&(D.HTTPS_PROXY||D.https_proxy||D.HTTP_PROXY||D.http_proxy)||null}async function C(T,D,v={}){const P=(0,k.parse)(T),A=v.proxyUrl||w(P,D);if(!A)return null;const R=(0,k.parse)(A);if(!/^https?:$/.test(R.protocol||""))return null;const E={host:R.hostname||"",port:R.port||(R.protocol==="https"?"443":"80"),auth:R.auth,rejectUnauthorized:(0,n.isBoolean)(v.strictSSL)?v.strictSSL:!0};return P.protocol==="http:"?new(await new Promise((S,u)=>{ee(["http-proxy-agent"],S,u)}))(E):new(await new Promise((S,u)=>{ee(["https-proxy-agent"],S,u)}))(E)}e.getProxyAgent=C}),define(ve[70],we([0,1,38,5,162,21,36,9,3,23,144,175,14]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const S=1e4;let u;async function b(d,p,m){return p["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):v.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,R.isLaunchedFromCli)(m)&&!p["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,R.isLaunchedFromCli)(m)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),u||(u=E.Promises.withAsyncBody(async(y,c)=>{const o=new C.CancellationTokenSource,l=setTimeout(()=>{o.dispose(!0),c(new Error((0,w.localize)(0,null)))},S);try{y(await f(d,o.token))}catch(i){!(0,D.isCancellationError)(i)&&!o.token.isCancellationRequested?c(new Error((0,w.localize)(1,null,(0,T.toErrorMessage)(i)))):y({})}finally{clearTimeout(l),o.dispose()}})),u)}e.getResolvedShellEnv=b;async function f(d,p){const m=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",m);const y=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",y);const c=(0,P.generateUuid)().replace(/-/g,"").substr(0,12),o=new RegExp(c+"(.*)"+c),l={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};d.trace("getUnixShellEnvironment#env",l);const i=await(0,A.getSystemShell)(v.OS,l);return d.trace("getUnixShellEnvironment#shell",i),new Promise((t,r)=>{if(p.isCancellationRequested)return r((0,D.canceled)());const s=(0,n.basename)(i);let a,h;const g=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(s)?(a=`& '${process.execPath}' ${g} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,h=["-Login","-Command"]):(a=`'${process.execPath}' ${g} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,s==="tcsh"?h=["-ic"]:h=["-ilc"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),a);const _=(0,k.spawn)(i,[...h,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});p.onCancellationRequested(()=>(_.kill(),r((0,D.canceled)()))),_.on("error",K=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(K)),r(K)});const F=[];_.stdout.on("data",K=>F.push(K));const $=[];_.stderr.on("data",K=>$.push(K)),_.on("close",(K,I)=>{const W=Buffer.concat(F).toString("utf8");d.trace("getUnixShellEnvironment#raw",W);const M=Buffer.concat($).toString("utf8");if(M.trim()&&d.trace("getUnixShellEnvironment#stderr",M),K||I)return r(new Error((0,w.localize)(2,null,K,I)));const q=o.exec(W),Z=q?q[1]:"{}";try{const H=JSON.parse(Z);m?H.ELECTRON_RUN_AS_NODE=m:delete H.ELECTRON_RUN_AS_NODE,y?H.ELECTRON_NO_ATTACH_CONSOLE=y:delete H.ELECTRON_NO_ATTACH_CONSOLE,delete H.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",H),t(H)}catch(H){d.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(H)),r(H)}})})}}),define(ve[205],we([0,1,14,7,2,44,12,135,6]),function(ee,e,k,n,w,C,T,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const P="__$__targetStorageMarker";e.IStorageService=(0,v.createDecorator)("storageService");var A;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(A=e.WillSaveStateReason||(e.WillSaveStateReason={}));var R;(function(f){f[f.GLOBAL=0]="GLOBAL",f[f.WORKSPACE=1]="WORKSPACE"})(R=e.StorageScope||(e.StorageScope={}));var E;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(E=e.StorageTarget||(e.StorageTarget={}));class S extends w.Disposable{constructor(d={flushInterval:S.DEFAULT_FLUSH_INTERVAL}){super();this.options=d,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new k.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new w.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,k.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,w.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,C.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(d,p){p===P?(d===0?this._globalKeyTargets=void 0:d===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:d})):this._onDidChangeValue.fire({scope:d,key:p,target:this.getKeyTargets(d)[p]})}emitWillSaveState(d){this._onWillSaveState.fire({reason:d})}get(d,p,m){return this.getStorage(p)?.get(d,m)}getBoolean(d,p,m){return this.getStorage(p)?.getBoolean(d,m)}getNumber(d,p,m){return this.getStorage(p)?.getNumber(d,m)}store(d,p,m,y){if((0,T.isUndefinedOrNull)(p)){this.remove(d,m);return}this.withPausedEmitters(()=>{this.updateKeyTarget(d,m,y),this.getStorage(m)?.set(d,p)})}remove(d,p){this.withPausedEmitters(()=>{this.updateKeyTarget(d,p,void 0),this.getStorage(p)?.delete(d)})}withPausedEmitters(d){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{d()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(d,p){const m=[],y=this.getKeyTargets(d);for(const c of Object.keys(y))y[c]===p&&m.push(c);return m}updateKeyTarget(d,p,m){const y=this.getKeyTargets(p);typeof m=="number"?y[d]!==m&&(y[d]=m,this.getStorage(p)?.set(P,JSON.stringify(y))):typeof y[d]=="number"&&(delete y[d],this.getStorage(p)?.set(P,JSON.stringify(y)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(d){return d===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(d){const p=this.get(P,d);if(p)try{return JSON.parse(p)}catch{}return Object.create(null)}isNew(d){return this.getBoolean(e.IS_NEW_KEY,d)===!0}async flush(d=A.NONE){this._onWillSaveState.fire({reason:d});const p=this.getStorage(0),m=this.getStorage(1);switch(d){case A.NONE:await k.Promises.settled([p?.whenFlushed()??Promise.resolve(),m?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await k.Promises.settled([p?.flush(0)??Promise.resolve(),m?.flush(0)??Promise.resolve()]);break}}async logStorage(){const d=this.getStorage(0)?.items??new Map,p=this.getStorage(1)?.items??new Map;return b(d,p,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=S,S.DEFAULT_FLUSH_INTERVAL=60*1e3;class u extends S{constructor(){super();this.globalStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(d=>this.emitDidChangeValue(1,d))),this._register(this.globalStorage.onDidChangeStorage(d=>this.emitDidChangeValue(0,d)))}getStorage(d){return d===0?this.globalStorage:this.workspaceStorage}getLogDetails(d){return d===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(d){}}e.InMemoryStorageService=u;async function b(f,d,p,m){const y=s=>{try{return JSON.parse(s)}catch{return s}},c=new Map,o=new Map;f.forEach((s,a)=>{c.set(a,s),o.set(a,y(s))});const l=new Map,i=new Map;d.forEach((s,a)=>{l.set(a,s),i.set(a,y(s))}),console.group(`Storage: Global (path: ${p})`);let t=[];c.forEach((s,a)=>{t.push({key:a,value:s})}),console.table(t),console.groupEnd(),console.log(o),console.group(`Storage: Workspace (path: ${m})`);let r=[];l.forEach((s,a)=>{r.push({key:a,value:s})}),console.table(r),console.groupEnd(),console.log(i)}e.logStorage=b}),define(ve[206],we([0,1,3,24,4,23]),function(ee,e,k,n,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function T(P){if(k.platform===2&&/^penguin(\.|$)/i.test(P))return"chromebook"}async function D(P,A,R,E,S,u,b,f,d,p){const m=Object.create(null);m["common.machineId"]=b,m.sessionID=(0,C.generateUuid)()+Date.now(),m.commitHash=S,m.version=u,m["common.platformVersion"]=(A||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,k.PlatformToString)(k.platform),m["common.nodePlatform"]=n.platform,m["common.nodeArch"]=E,m["common.product"]=p||"desktop";const y=v(f||[]);y&&(m["common.msftInternal"]=y);let c=0;const o=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),k.isLinuxSnap&&(m["common.snap"]="true");const l=T(R);l&&(m["common.platformDetail"]=l);try{const i=await P.readFile(w.URI.file(d));m["common.source"]=i.value.toString().slice(0,30)}catch{}return m}e.resolveCommonProperties=D;function v(P){const A=n.env.USERDNSDOMAIN;if(!A)return!1;const R=A.toLowerCase();return P.some(E=>R===E)}e.verifyMicrosoftInternalDomain=v}),define(ve[207],we([0,1,18,9,2,22]),function(ee,e,k,n,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var T;(function(v){function P(A,R){return A.callstack<R.callstack?-1:A.callstack>R.callstack?1:0}v.compare=P})(T=e.ErrorEvent||(e.ErrorEvent={}));class D{constructor(P,A=D.ERROR_FLUSH_TIMEOUT){this._flushHandle=-1,this._buffer=[],this._disposables=new w.DisposableStore,this._telemetryService=P,this._flushDelay=A;const R=n.errorHandler.addListener(E=>this._onErrorEvent(E));this._disposables.add((0,w.toDisposable)(R)),this.installErrorListeners()}dispose(){clearTimeout(this._flushHandle),this._flushBuffer(),this._disposables.dispose()}installErrorListeners(){}_onErrorEvent(P){if(!P||(P.detail&&P.detail.stack&&(P=P.detail),P instanceof n.ErrorNoTelemetry))return;let A=Array.isArray(P.stack)?P.stack.join(`
`):P.stack,R=P.message?P.message:(0,C.safeStringify)(P);!A||this._enqueue({msg:R,callstack:A})}_enqueue(P){const A=(0,k.binarySearch)(this._buffer,P,T.compare);A<0?(P.count=1,this._buffer.splice(~A,0,P)):(this._buffer[A].count||(this._buffer[A].count=0),this._buffer[A].count+=1),this._flushHandle===-1&&(this._flushHandle=setTimeout(()=>{this._flushBuffer(),this._flushHandle=-1},this._flushDelay))}_flushBuffer(){for(let P of this._buffer)this._telemetryService.publicLogError2("UnhandledError",P);this._buffer.length=0}}e.default=D,D.ERROR_FLUSH_TIMEOUT=5*1e3}),define(ve[208],we([0,1,2]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerTelemetryChannel=void 0;class n extends k.Disposable{constructor(C,T){super();this.telemetryService=C,this.telemetryAppender=T}async call(C,T,D){switch(T){case"updateTelemetryLevel":{const{telemetryLevel:v}=D;return this.telemetryService.updateInjectedTelemetryLevel(v)}case"logTelemetry":{const{eventName:v,data:P}=D;return this.telemetryAppender?this.telemetryAppender.log(v,P):Promise.resolve()}case"flushTelemetry":return this.telemetryAppender?this.telemetryAppender.flush():Promise.resolve()}throw new Error(`IPC Command ${T} not found`)}listen(C,T,D){throw new Error("Not supported")}dispose(){this.telemetryService.updateInjectedTelemetryLevel(0),super.dispose()}}e.ServerTelemetryChannel=n}),define(ve[32],we([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,k.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,k.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var w;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(w=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ve[209],we([0,1,25,49,14,59,8,5,3,4,81,19,84,182,17,28,32]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E,S,u,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const d=new Map;async function p(l,i){const t=`${l}::${i.join(":")}`,r=d.get(t);if(r)return r;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,h=new Map,g=2e4;function _($,K,I,W){const M=K.substring($.length+1);return w.Promises.withAsyncBody(async q=>{let Z;try{Z=await R.Promises.readdir(K,{withFileTypes:!0})}catch{q();return}if(W.count>=g){W.count+=Z.length,W.maxReached=!0,q();return}let H=Z.length;if(H===0){q();return}let U=Z;W.count+Z.length>g&&(W.maxReached=!0,H=g-W.count,U=Z.slice(0,H)),W.count+=Z.length;for(const z of U)if(z.isDirectory()){if(I.includes(z.name)||await _($,(0,D.join)(K,z.name),I,W),--H==0){q();return}}else{const Q=z.name.lastIndexOf(".");if(Q>=0){const ie=z.name.substring(Q+1);ie&&a.set(ie,(a.get(ie)??0)+1)}for(const ie of s)ie.relativePathPattern?.test(M)!==!1&&ie.filePattern.test(z.name)&&h.set(ie.tag,(h.get(ie.tag)??0)+1);if(--H==0){q();return}}})}const F=w.Promises.withAsyncBody(async $=>{const K={count:0,maxReached:!1};await _(l,l,i,K);const I=await c(l);$({configFiles:m(h),fileTypes:m(a),fileCount:K.count,maxFilesReached:K.maxReached,launchConfigFiles:I})});return d.set(t,F),F}e.collectWorkspaceStats=p;function m(l){return[...n.Iterable.map(l.entries(),([i,t])=>({name:i,count:t}))].sort((i,t)=>t.count-i.count)}function y(){const l={os:`${k.type()} ${k.arch()} ${k.release()}`,memory:`${(k.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(A.virtualMachineHint.value()*100)}%`},i=k.cpus();return i&&i.length>0&&(l.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),l}e.getMachineInfo=y;async function c(l){try{const i=new Map,t=(0,D.join)(l,".vscode","launch.json"),r=await R.Promises.readFile(t),s=[],a=(0,C.parse)(r.toString(),s);if(s.length)return console.log(`Unable to parse ${t}`),[];if((0,C.getNodeType)(a)==="object"&&a.configurations)for(const h of a.configurations){const g=h.type;g&&(i.has(g)?i.set(g,i.get(g)+1):i.set(g,1))}return m(i)}catch{return[]}}e.collectLaunchConfigs=c;let o=class{constructor(i,t){this.telemetryService=i,this.productService=t}formatMachineInfo(i){const t=[];return t.push(`OS Version:       ${i.os}`),t.push(`CPUs:             ${i.cpus}`),t.push(`Memory (System):  ${i.memory}`),t.push(`VM:               ${i.vmHint}`),t.join(`
`)}formatEnvironment(i){const t=[];t.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),t.push(`OS Version:       ${k.type()} ${k.arch()} ${k.release()}`);const r=k.cpus();return r&&r.length>0&&t.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),t.push(`Memory (System):  ${(k.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`),v.isWindows||t.push(`Load (avg):       ${k.loadavg().map(s=>Math.round(s)).join(", ")}`),t.push(`VM:               ${Math.round(A.virtualMachineHint.value()*100)}%`),t.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${i.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),t.join(`
`)}async getPerformanceInfo(i,t){return Promise.all([(0,E.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async r=>{let[s,a]=r,h=this.formatProcessList(i,s);return t.forEach(g=>{if((0,S.isRemoteDiagnosticError)(g))h+=`
${g.errorMessage}`,a+=`
${g.errorMessage}`;else if(h+=`

Remote: ${g.hostName}`,g.processes&&(h+=`
${this.formatProcessList(i,g.processes)}`),g.workspaceMetadata){a+=`
|  Remote: ${g.hostName}`;for(const _ of Object.keys(g.workspaceMetadata)){const F=g.workspaceMetadata[_];let $=`${F.fileCount} files`;F.maxFilesReached&&($=`more than ${$}`),a+=`|    Folder (${_}): ${$}`,a+=this.formatWorkspaceStats(F)}}}),{processInfo:h,workspaceInfo:a}})}async getSystemInfo(i,t){const{memory:r,vmHint:s,os:a,cpus:h}=y(),g={os:a,memory:r,cpus:h,vmHint:s,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:t};return v.isWindows||(g.load=`${k.loadavg().map(_=>Math.round(_)).join(", ")}`),v.isLinux&&(g.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(g)}async getDiagnostics(i,t){const r=[];return(0,E.listProcesses)(i.mainPID).then(async s=>(r.push(""),r.push(this.formatEnvironment(i)),r.push(""),r.push(this.formatProcessList(i,s)),i.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(i))),t.forEach(a=>{if((0,S.isRemoteDiagnosticError)(a))r.push(`
${a.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${a.hostName}`),r.push(this.formatMachineInfo(a.machineInfo)),a.processes&&r.push(this.formatProcessList(i,a.processes)),a.workspaceMetadata)for(const h of Object.keys(a.workspaceMetadata)){const g=a.workspaceMetadata[h];let _=`${g.fileCount} files`;g.maxFilesReached&&(_=`more than ${_}`),r.push(`Folder (${h}): ${_}`),r.push(this.formatWorkspaceStats(g))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(i){const t=[],r=60;let s=0;const a=(F,$)=>{const K=` ${F}(${$})`;s+K.length>r?(t.push(h),h="|                 ",s=h.length):s+=K.length,h+=K};let h="|      File types:";const g=10;let _=i.fileTypes.length>g?g:i.fileTypes.length;for(let F=0;F<_;F++){const $=i.fileTypes[F];a($.name,$.count)}if(t.push(h),i.configFiles.length>=0&&(h="|      Conf files:",s=0,i.configFiles.forEach(F=>{a(F.name,F.count)}),t.push(h)),i.launchConfigFiles.length>0){let F="|      Launch Configs:";i.launchConfigFiles.forEach($=>{F+=$.count>1?` ${$.name}(${$.count})`:` ${$.name}`}),t.push(F)}return t.join(`
`)}expandGPUFeatures(i){const t=Math.max(...Object.keys(i).map(r=>r.length));return Object.keys(i).map(r=>`${r}:  ${" ".repeat(t-r.length)}  ${i[r]}`).join(`
                  `)}formatWorkspaceMetadata(i){const t=[],r=[];return i.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(t.push(`|  Window (${s.title})`),s.folderURIs.forEach(a=>{const h=P.URI.revive(a);if(h.scheme===T.Schemas.file){const g=h.fsPath;r.push(p(g,["node_modules",".git"]).then(_=>{let F=`${_.fileCount} files`;_.maxFilesReached&&(F=`more than ${F}`),t.push(`|    Folder (${(0,D.basename)(g)}): ${F}`),t.push(this.formatWorkspaceStats(_))}).catch(_=>{t.push(`|      Error: Unable to collect workspace stats for folder ${g} (${_.toString()})`)}))}else t.push(`|    Folder (${h.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(s=>t.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(i,t){const r=new Map;i.windows.forEach(a=>r.set(a.pid,a.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),t&&this.formatProcessItem(i.mainPID,r,s,t,0),s.join(`
`)}formatProcessItem(i,t,r,s,a){const h=a===0;let g;h?g=s.pid===i?`${this.productService.applicationName} main`:"remote agent":(g=`${"  ".repeat(a)} ${s.name}`,s.name==="window"&&(g=`${g} (${t.get(s.pid)})`));const _=process.platform==="win32"?s.mem:k.totalmem()*(s.mem/100);r.push(`${s.load.toFixed(0).padStart(5," ")}	${(_/u.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${g}`),Array.isArray(s.children)&&s.children.forEach(F=>this.formatProcessItem(i,t,r,F,a+1))}async getWorkspaceFileExtensions(i){const t=new Set;for(const{uri:r}of i.folders){const s=P.URI.revive(r);if(s.scheme!==T.Schemas.file)continue;const a=s.fsPath;try{(await p(a,["node_modules",".git"])).fileTypes.forEach(g=>t.add(g.name))}catch{}}return{extensions:[...t]}}async reportWorkspaceStats(i){for(const{uri:t}of i.folders){const r=P.URI.revive(t);if(r.scheme!==T.Schemas.file)continue;const s=r.fsPath;try{const a=await p(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),a.fileTypes.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:h.name,count:h.count})}),a.launchConfigFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:h.name,count:h.count})}),a.configFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:h.name,count:h.count})})}catch{}}}};o=Ae([Oe(0,f.ITelemetryService),Oe(1,b.IProductService)],o),e.DiagnosticsService=o}),define(ve[210],we([0,1,18,14,21,9,7,2,3,4,149,30,35,13,28,32]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E,S,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let f=class extends D.Disposable{constructor(o,l,i,t){super();this.galleryService=o,this.telemetryService=l,this.logService=i,this.productService=t,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new T.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new T.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new T.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,D.toDisposable)(()=>{this.installingExtensions.forEach(r=>r.cancel()),this.uninstallingExtensions.forEach(r=>r.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(o){const l=await this.getTargetPlatform();return o.allTargetPlatforms.some(i=>(0,R.isTargetPlatformCompatible)(i,o.allTargetPlatforms,l))}async installFromGallery(o,l={}){try{if(!this.galleryService.isEnabled())throw new R.ExtensionManagementError(A.localize(0,null),R.ExtensionManagementErrorCode.Internal);const i=await this.checkAndGetCompatibleVersion(o,!l.installGivenVersion,!!l.installPreReleaseVersion);return await this.installExtension(i.manifest,i.extension,l)}catch(i){throw m(this.telemetryService,"extensionGallery:install",(0,E.getGalleryExtensionTelemetryData)(o),void 0,i),this.logService.error("Failed to install extension.",o.identifier.id),this.logService.error(i),p(i)}}async uninstall(o,l={}){return this.logService.trace("ExtensionManagementService#uninstall",o.identifier.id),this.unininstallExtension(o,l)}async reinstallFromGallery(o){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",o.identifier.id),!this.galleryService.isEnabled())throw new Error(A.localize(1,null));const l=await this.getTargetPlatform(),[i]=await this.galleryService.getExtensions([{...o.identifier,preRelease:o.preRelease}],{targetPlatform:l,compatible:!0},w.CancellationToken.None);if(!i)throw new Error(A.localize(2,null));await this.createUninstallExtensionTask(o,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(i)}getExtensionsControlManifest(){const o=new Date().getTime();return(!this.extensionsControlManifest||o-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=o),this.extensionsControlManifest}registerParticipant(o){this.participants.push(o)}async installExtension(o,l,i){if(!P.URI.isUri(l)){let h=this.installingExtensions.get(E.ExtensionKey.create(l).toString());if(h)return this.logService.info("Extensions is already requested to install",l.identifier.id),h.waitUntilTaskIsFinished();i={...i,installOnlyNewlyAddedFromExtensionPack:!0}}const t=[],r=[],s=this.createInstallExtensionTask(o,l,i);P.URI.isUri(l)||this.installingExtensions.set(E.ExtensionKey.create(l).toString(),s),this._onInstallExtension.fire({identifier:s.identifier,source:l}),this.logService.info("Installing extension:",s.identifier.id),t.push({task:s,manifest:o});let a=!1;try{if(i.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",s.identifier.id);else try{const g=await this.getAllDepsAndPackExtensionsToInstall(s.identifier,o,!!i.installOnlyNewlyAddedFromExtensionPack,!!i.installPreReleaseVersion);for(const{gallery:_,manifest:F}of g){a=a||!!F.extensionDependencies?.some(K=>(0,E.areSameExtensions)({id:K},s.identifier));const $=E.ExtensionKey.create(_).toString();if(this.installingExtensions.has($))this.logService.info("Extension is already requested to install",_.identifier.id);else{const K=this.createInstallExtensionTask(F,_,{...i,donotIncludePackAndDependencies:!0});this.installingExtensions.set($,K),this._onInstallExtension.fire({identifier:K.identifier,source:_}),this.logService.info("Installing extension:",K.identifier.id),t.push({task:K,manifest:F})}}}catch(g){if(P.URI.isUri(s.source))(0,k.isNonEmptyArray)(o.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",s.identifier.id,g.message),(0,k.isNonEmptyArray)(o.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",s.identifier.id,g.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",s.identifier.id),g}const h=t.reduce((g,{task:_,manifest:F})=>(g.set(_.identifier.id.toLowerCase(),{task:_,manifest:F}),g),new Map);for(;h.size;){let g;const _=[...h.values()].filter(({manifest:F})=>!F.extensionDependencies?.some($=>h.has($.toLowerCase())));_.length?g=h.size===1?_:_.filter(({task:F})=>!(F===s&&!a)):(this.logService.info("Found extensions with circular dependencies",_.map(({task:F})=>F.identifier.id)),g=[...h.values()]),await this.joinAllSettled(g.map(async({task:F})=>{const $=new Date().getTime();try{const K=await F.run();if(await this.joinAllSettled(this.participants.map(I=>I.postInstall(K,F.source,i,w.CancellationToken.None))),!P.URI.isUri(F.source)&&(m(this.telemetryService,F.operation===3?"extensionGallery:update":"extensionGallery:install",(0,E.getGalleryExtensionTelemetryData)(F.source),new Date().getTime()-$,void 0),v.isWeb&&F.operation!==3))try{await this.galleryService.reportStatistic(K.manifest.publisher,K.manifest.name,K.manifest.version,"install")}catch{}r.push({local:K,identifier:F.identifier,operation:F.operation,source:F.source})}catch(K){throw P.URI.isUri(F.source)||m(this.telemetryService,F.operation===3?"extensionGallery:update":"extensionGallery:install",(0,E.getGalleryExtensionTelemetryData)(F.source),new Date().getTime()-$,K),this.logService.error("Error while installing the extension:",F.identifier.id),K}finally{h.delete(F.identifier.id.toLowerCase())}}))}return r.forEach(({identifier:g})=>this.logService.info("Extension installed successfully:",g.id)),this._onDidInstallExtensions.fire(r),r.filter(({identifier:g})=>(0,E.areSameExtensions)(g,s.identifier))[0].local}catch(h){if(t.forEach(({task:g})=>g.cancel()),r.length)try{const g=await Promise.allSettled(r.map(({local:_})=>this.createUninstallExtensionTask(_,{versionOnly:!0}).run()));for(let _=0;_<g.length;_++){const F=g[_],{identifier:$}=r[_];F.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",$.id):this.logService.warn("Rollback: Error while uninstalling extension",$.id,(0,C.getErrorMessage)(F.reason))}}catch(g){this.logService.warn("Error while rolling back extensions",(0,C.getErrorMessage)(g),r.map(({identifier:_})=>_.id))}throw this._onDidInstallExtensions.fire(t.map(({task:g})=>({identifier:g.identifier,operation:2,source:g.source}))),h}finally{for(const{task:h}of t)if(!P.URI.isUri(h.source)){const g=E.ExtensionKey.create(h.source).toString();this.installingExtensions.delete(g)||this.logService.warn("Installation task is not found in the cache",g)}}}async joinAllSettled(o){const l=[],i=[],t=await Promise.allSettled(o);for(const r of t)r.status==="fulfilled"?l.push(r.value):i.push(r.reason);if(i.length)throw d(i);return l}async getAllDepsAndPackExtensionsToInstall(o,l,i,t){if(!this.galleryService.isEnabled())return[];let r=await this.getInstalled();const s=[o,...r.map(g=>g.identifier)],a=[],h=async(g,_)=>{const F=_.extensionDependencies||[],$=[...F];if(_.extensionPack){const K=i?r.find(I=>(0,E.areSameExtensions)(I.identifier,g)):void 0;for(const I of _.extensionPack)K&&K.manifest.extensionPack&&K.manifest.extensionPack.some(W=>(0,E.areSameExtensions)({id:W},{id:I}))||$.every(W=>!(0,E.areSameExtensions)({id:W},{id:I}))&&$.push(I)}if($.length){const K=[...s,...a.map(W=>W.gallery.identifier)],I=$.filter(W=>K.every(M=>!(0,E.areSameExtensions)(M,{id:W})));if(I.length){const W=await this.galleryService.getExtensions(I.map(M=>({id:M,preRelease:t})),w.CancellationToken.None);for(const M of W){if(K.find(H=>(0,E.areSameExtensions)(H,M.identifier)))continue;const q=F.some(H=>(0,E.areSameExtensions)({id:H},M.identifier));let Z;try{Z=await this.checkAndGetCompatibleVersion(M,!0,t)}catch(H){if(H instanceof R.ExtensionManagementError&&H.code===R.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!q){this.logService.info("Skipping the packed extension as it cannot be installed",M.identifier.id);continue}else throw H}a.push({gallery:Z.extension,manifest:Z.manifest}),await h(Z.extension.identifier,Z.manifest)}}}};return await h(o,l),r=await this.getInstalled(),a.filter(g=>!r.some(_=>(0,E.areSameExtensions)(_.identifier,g.gallery.identifier)))}async checkAndGetCompatibleVersion(o,l,i){const t=await this.getExtensionsControlManifest();if((0,E.getMaliciousExtensionsSet)(t).has(o.identifier.id))throw new R.ExtensionManagementError(A.localize(3,null,o.identifier.id),R.ExtensionManagementErrorCode.Malicious);if(!!t.unsupportedPreReleaseExtensions&&!!t.unsupportedPreReleaseExtensions[o.identifier.id])throw new R.ExtensionManagementError(A.localize(4,null,o.identifier.id,t.unsupportedPreReleaseExtensions[o.identifier.id].displayName),R.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(o)){const a=await this.getTargetPlatform();throw new R.ExtensionManagementError(A.localize(5,null,o.identifier.id,this.productService.nameLong,(0,R.TargetPlatformToString)(a)),R.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const r=await this.getCompatibleVersion(o,l,i);if(r){if(i&&l&&o.hasPreReleaseVersion&&!r.properties.isPreReleaseVersion)throw new R.ExtensionManagementError(A.localize(6,null,o.identifier.id,this.productService.nameLong,this.productService.version),R.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!i&&o.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([o.identifier],w.CancellationToken.None))[0]?new R.ExtensionManagementError(A.localize(7,null,o.identifier.id),R.ExtensionManagementErrorCode.ReleaseVersionNotFound):new R.ExtensionManagementError(A.localize(8,null,o.identifier.id,this.productService.nameLong,this.productService.version),R.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",r.identifier.id);const s=await this.galleryService.getManifest(r,w.CancellationToken.None);if(s===null)throw new R.ExtensionManagementError(`Missing manifest for extension ${o.identifier.id}`,R.ExtensionManagementErrorCode.Invalid);if(s.version!==r.version)throw new R.ExtensionManagementError(`Cannot install '${o.identifier.id}' extension because of version mismatch in Marketplace`,R.ExtensionManagementErrorCode.Invalid);return{extension:r,manifest:s}}async getCompatibleVersion(o,l,i){const t=await this.getTargetPlatform();let r=null;return l&&o.hasPreReleaseVersion&&o.properties.isPreReleaseVersion!==i&&(r=(await this.galleryService.getExtensions([{...o.identifier,preRelease:i}],{targetPlatform:t,compatible:!0},w.CancellationToken.None))[0]||null),!r&&await this.galleryService.isExtensionCompatible(o,i,t)&&(r=o),!r&&l&&(r=await this.galleryService.getCompatibleExtension(o,i,t)),r}async unininstallExtension(o,l){const i=this.uninstallingExtensions.get(o.identifier.id.toLowerCase());if(i)return this.logService.info("Extensions is already requested to uninstall",o.identifier.id),i.waitUntilTaskIsFinished();const t=(h,g)=>{const _=this.createUninstallExtensionTask(h,g);return this.uninstallingExtensions.set(_.extension.identifier.id.toLowerCase(),_),this.logService.info("Uninstalling extension:",h.identifier.id),this._onUninstallExtension.fire(h.identifier),_},r=(h,g)=>{g?this.logService.error("Failed to uninstall extension:",h.identifier.id,g.message):this.logService.info("Successfully uninstalled extension:",h.identifier.id),m(this.telemetryService,"extensionGallery:uninstall",(0,E.getLocalExtensionTelemetryData)(h),void 0,g),this._onDidUninstallExtension.fire({identifier:h.identifier,error:g?.code})},s=[],a=[];try{s.push(t(o,{}));const h=await this.getInstalled(1);if(l.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",o.identifier.id);else{const g=this.getAllPackExtensionsToUninstall(o,h);for(const _ of g)this.uninstallingExtensions.has(_.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",_.identifier.id):s.push(t(_,{}))}l.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",o.identifier.id):this.checkForDependents(s.map(g=>g.extension),h,o),await this.joinAllSettled(s.map(async g=>{try{if(await g.run(),await this.joinAllSettled(this.participants.map(_=>_.postUninstall(g.extension,l,w.CancellationToken.None))),g.extension.identifier.uuid)try{await this.galleryService.reportStatistic(g.extension.manifest.publisher,g.extension.manifest.name,g.extension.manifest.version,"uninstall")}catch{}r(g.extension)}catch(_){const F=_ instanceof R.ExtensionManagementError?_:new R.ExtensionManagementError((0,C.getErrorMessage)(_),R.ExtensionManagementErrorCode.Internal);throw r(g.extension,F),F}finally{a.push(g)}}))}catch(h){const g=h instanceof R.ExtensionManagementError?h:new R.ExtensionManagementError((0,C.getErrorMessage)(h),R.ExtensionManagementErrorCode.Internal);for(const _ of s){try{_.cancel()}catch{}a.includes(_)||r(_.extension,g)}throw g}finally{for(const h of s)this.uninstallingExtensions.delete(h.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",h.extension.identifier.id)}}checkForDependents(o,l,i){for(const t of o){const r=this.getDependents(t,l);if(r.length){const s=r.filter(a=>!o.some(h=>(0,E.areSameExtensions)(h.identifier,a.identifier)));if(s.length)throw new Error(this.getDependentsErrorMessage(t,s,i))}}}getDependentsErrorMessage(o,l,i){return i===o?l.length===1?A.localize(9,null,i.manifest.displayName||i.manifest.name,l[0].manifest.displayName||l[0].manifest.name):l.length===2?A.localize(10,null,i.manifest.displayName||i.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name):A.localize(11,null,i.manifest.displayName||i.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name):l.length===1?A.localize(12,null,i.manifest.displayName||i.manifest.name,o.manifest.displayName||o.manifest.name,l[0].manifest.displayName||l[0].manifest.name):l.length===2?A.localize(13,null,i.manifest.displayName||i.manifest.name,o.manifest.displayName||o.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name):A.localize(14,null,i.manifest.displayName||i.manifest.name,o.manifest.displayName||o.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name)}getAllPackExtensionsToUninstall(o,l,i=[]){if(i.indexOf(o)!==-1)return[];i.push(o);const t=o.manifest.extensionPack?o.manifest.extensionPack:[];if(t.length){const r=l.filter(a=>!a.isBuiltin&&t.some(h=>(0,E.areSameExtensions)({id:h},a.identifier))),s=[];for(const a of r)s.push(...this.getAllPackExtensionsToUninstall(a,l,i));return[...r,...s]}return[]}getDependents(o,l){return l.filter(i=>i.manifest.extensionDependencies&&i.manifest.extensionDependencies.some(t=>(0,E.areSameExtensions)({id:t},o.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const o=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",o),o}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};f=Ae([Oe(0,R.IExtensionGalleryService),Oe(1,b.ITelemetryService),Oe(2,S.ILogService),Oe(3,u.IProductService)],f),e.AbstractExtensionManagementService=f;function d(c){const o=Array.isArray(c)?c:[c];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((l,i)=>new Error(`${l.message}${l.message?",":""}${i instanceof Error?i.message:i}`),new Error(""))}e.joinErrors=d;function p(c){if(c instanceof R.ExtensionManagementError)return c;const o=new R.ExtensionManagementError(c.message,R.ExtensionManagementErrorCode.Internal);return o.stack=c.stack,o}function m(c,o,l,i,t){const r=t?t instanceof R.ExtensionManagementError?t.code:R.ExtensionManagementErrorCode.Internal:void 0;c.publicLogError(o,{...l,success:!t,duration:i,errorcode:r})}e.reportTelemetry=m;class y{constructor(){this.barrier=new n.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(o=>this.doRun(o))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(o=>new Promise((l,i)=>{const t=o.onCancellationRequested(()=>{t.dispose(),i((0,C.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=y}),define(ve[41],we([0,1,22,12,26,32]),function(ee,e,k,n,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class T{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(p,m){return Promise.resolve(void 0)}publicLog2(p,m){return this.publicLog(p,m)}publicLogError(p,m){return Promise.resolve(void 0)}publicLogError2(p,m){return this.publicLogError(p,m)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=T,e.NullTelemetryService=new T;class D{async publicLog(p,m,y){}async publicLogError(p,m,y){}}e.NullEndpointTelemetryService=D,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(d,p){return p.onDidChangeConfiguration(m=>{m.source!==6&&d.publicLog2("updateConfiguration",{configurationSource:(0,w.ConfigurationTargetToString)(m.source),configurationKeys:u(m.sourceConfig)})})}e.configurationTelemetry=v;function P(d,p){return!(p.disableTelemetry||!d.enableTelemetry||p.extensionTestsLocationURI)}e.supportsTelemetry=P;function A(d){const p=d.getValue(C.TELEMETRY_SETTING_ID),m=d.getValue("telemetry.enableCrashReporter");if(d.getValue(C.TELEMETRY_OLD_SETTING_ID)===!1||m===!1)return 0;switch(p??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=A;function R(d){const p=Object.create(null),m=Object.create(null),y=Object.create(null);S(d,y);for(let c in y){c=c.length>150?c.substr(c.length-149):c;const o=y[c];typeof o=="number"?m[c]=o:typeof o=="boolean"?m[c]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${o.length}`),p[c]=o.substring(0,8191)):typeof o!="undefined"&&o!==null&&(p[c]=o)}return{properties:p,measurements:m}}e.validateTelemetryData=R;function E(d){if(!d)return"none";let p="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(y=>{d.indexOf(`${y}+`)===0&&(p=y)}),p}e.cleanRemoteAuthority=E;function S(d,p,m=0,y){if(!!d)for(let c of Object.getOwnPropertyNames(d)){const o=d[c],l=y?y+c:c;Array.isArray(o)?p[l]=(0,k.safeStringify)(o):o instanceof Date?p[l]=o.toISOString():(0,n.isObject)(o)?m<2?S(o,p,m+1,l+"."):p[l]=(0,k.safeStringify)(o):p[l]=o}}function u(d){if(!d)return[];const p=[];return b(p,"",d),p}function b(d,p,m){m&&typeof m=="object"&&!Array.isArray(m)?Object.keys(m).forEach(y=>b(d,p?`${p}.${y}`:y,m[y])):d.push(p)}function f(d){return[d.appRoot,d.extensionsPath,d.userHome.fsPath,d.tmpDir.fsPath,d.userDataPath]}e.getPiiPathsFromEnvironment=f}),define(ve[211],we([0,1,179,41]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function w(C,T,D,v,P,A){const R={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C} (${T.nameShort})`},E=await(0,k.getServiceMachineId)(D,P,A);return(0,n.supportsTelemetry)(T,D)&&(0,n.getTelemetryLevel)(v)===3&&(R["X-Market-User-Id"]=E),R}e.resolveMarketplaceHeaders=w}),define(ve[99],we([0,1,18,21,9,22,3,24,12,4,26,27,30,35,63,17,13,28,47,211,205,32]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E,S,u,b,f,d,p,m,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const o=T.isWeb?"web":(0,E.getTargetPlatform)(T.platform,D.arch);var l;(function(j){j[j.None=0]="None",j[j.IncludeVersions=1]="IncludeVersions",j[j.IncludeFiles=2]="IncludeFiles",j[j.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",j[j.IncludeSharedAccounts=8]="IncludeSharedAccounts",j[j.IncludeVersionProperties=16]="IncludeVersionProperties",j[j.ExcludeNonValidated=32]="ExcludeNonValidated",j[j.IncludeInstallationTargets=64]="IncludeInstallationTargets",j[j.IncludeAssetUri=128]="IncludeAssetUri",j[j.IncludeStatistics=256]="IncludeStatistics",j[j.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",j[j.Unpublished=4096]="Unpublished",j[j.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(l||(l={}));function i(...j){return String(j.reduce((O,V)=>O|V,0))}var t;(function(j){j[j.Tag=1]="Tag",j[j.ExtensionId=4]="ExtensionId",j[j.Category=5]="Category",j[j.ExtensionName=7]="ExtensionName",j[j.Target=8]="Target",j[j.Featured=9]="Featured",j[j.SearchText=10]="SearchText",j[j.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},h={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:l.None,criteria:[],assetTypes:[]};class g{constructor(O=h){this.state=O}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(O,V=this.state.pageSize){return new g({...this.state,pageNumber:O,pageSize:V})}withFilter(O,...V){const J=[...this.state.criteria,...V.length?V.map(le=>({filterType:O,value:le})):[{filterType:O}]];return new g({...this.state,criteria:J})}withSortBy(O){return new g({...this.state,sortBy:O})}withSortOrder(O){return new g({...this.state,sortOrder:O})}withFlags(...O){return new g({...this.state,flags:O.reduce((V,J)=>V|J,0)})}withAssetTypes(...O){return new g({...this.state,assetTypes:O})}get raw(){const{criteria:O,pageNumber:V,pageSize:J,sortBy:le,sortOrder:ge,flags:ue,assetTypes:oe}=this.state;return{filters:[{criteria:O,pageNumber:V,pageSize:J,sortBy:le,sortOrder:ge}],assetTypes:oe,flags:ue}}get searchText(){const O=this.state.criteria.filter(V=>V.filterType===t.SearchText)[0];return O&&O.value?O.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(O=>String(O.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber)}}}function _(j,O){const V=(j||[]).filter(J=>J.statisticName===O)[0];return V?V.value:0}function F(j){const O="Microsoft.VisualStudio.Code.Translation.";return j.files.filter(J=>J.assetType.indexOf(O)===0).reduce((J,le)=>{const ge=I(j,le.assetType);return ge&&J.push([le.assetType.substring(O.length),ge]),J},[])}function $(j){if(j.properties){const O=j.properties.filter(le=>le.key===r.Repository),V=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),J=O.filter(le=>V.test(le.value))[0];return J?{uri:J.value,fallbackUri:J.value}:null}return I(j,r.Repository)}function K(j){return{uri:`${j.fallbackAssetUri}/${r.VSIX}?redirect=true${j.targetPlatform?`&targetPlatform=${j.targetPlatform}`:""}`,fallbackUri:`${j.fallbackAssetUri}/${r.VSIX}${j.targetPlatform?`?targetPlatform=${j.targetPlatform}`:""}`}}function I(j,O){return j.files.filter(J=>J.assetType===O)[0]?{uri:`${j.assetUri}/${O}${j.targetPlatform?`?targetPlatform=${j.targetPlatform}`:""}`,fallbackUri:`${j.fallbackAssetUri}/${O}${j.targetPlatform?`?targetPlatform=${j.targetPlatform}`:""}`}:null}function W(j,O){const V=j.properties?j.properties.filter(le=>le.key===O):[],J=V.length>0&&V[0].value;return J?J.split(",").map(le=>(0,S.adoptToGalleryExtensionId)(le)):[]}function M(j){const O=j.properties?j.properties.filter(V=>V.key===s.Engine):[];return O.length>0&&O[0].value||""}function q(j){const O=j.properties?j.properties.filter(V=>V.key===s.PreRelease):[];return O.length>0&&O[0].value==="true"}function Z(j){const O=j.properties?j.properties.filter(J=>J.key===s.LocalizedLanguages):[],V=O.length>0&&O[0].value||"";return V?V.split(","):[]}function H(j){return j.indexOf("preview")!==-1}function U(j){return j.targetPlatform?(0,E.toTargetPlatform)(j.targetPlatform):"undefined"}function z(j){const O=(0,k.distinct)(j.versions.map(U)),V=!!j.tags?.includes(E.WEB_EXTENSION_TAG),J=O.indexOf("web");return V?J===-1&&O.push("web"):J!==-1&&O.splice(J,1),O}function Q(j,O){const V=(0,E.getFallbackTargetPlarforms)(O);for(let J=0;J<j.length;J++){const le=j[J];if(le.version===j[J-1]?.version){let ge=J;const ue=U(le);if(ue===O)for(;ge>0&&j[ge-1].version===le.version;)ge--;else if(V.includes(ue))for(;ge>0&&j[ge-1].version===le.version&&U(j[ge-1])!==O;)ge--;ge!==J&&(j.splice(J,1),j.splice(ge,0,le))}}return j}e.sortExtensionVersions=Q;function ie(j,O,V){j.telemetryData={index:O,querySource:V}}function re(j,O,V){const J=j.versions[0],le={manifest:I(O,r.Manifest),readme:I(O,r.Details),changelog:I(O,r.Changelog),license:I(O,r.License),repository:$(O),download:K(O),icon:I(O,r.Icon),coreTranslations:F(O)};return{identifier:{id:(0,S.getGalleryExtensionId)(j.publisher.publisherName,j.extensionName),uuid:j.extensionId},name:j.extensionName,version:O.version,displayName:j.displayName,publisherId:j.publisher.publisherId,publisher:j.publisher.publisherName,publisherDisplayName:j.publisher.displayName,publisherDomain:j.publisher.domain?{link:j.publisher.domain,verified:!!j.publisher.isDomainVerified}:void 0,description:j.shortDescription||"",installCount:_(j.statistics,"install"),rating:_(j.statistics,"averagerating"),ratingCount:_(j.statistics,"ratingcount"),categories:j.categories||[],tags:j.tags||[],releaseDate:Date.parse(j.releaseDate),lastUpdated:Date.parse(j.lastUpdated),allTargetPlatforms:V,assets:le,properties:{dependencies:W(O,s.Dependency),extensionPack:W(O,s.ExtensionPack),engine:M(O),localizedLanguages:Z(O),targetPlatform:U(O),isPreReleaseVersion:q(O)},hasPreReleaseVersion:q(J),hasReleaseVersion:!0,preview:H(j.flags)}}let ce=class{constructor(O,V,J,le,ge,ue,oe,pe){this.requestService=V,this.logService=J,this.environmentService=le,this.telemetryService=ge,this.fileService=ue,this.productService=oe,this.configurationService=pe;const X=oe.extensionsGallery;this.extensionsGalleryUrl=X&&X.serviceUrl,this.extensionsControlUrl=X&&X.controlUrl,this.commonHeadersPromise=(0,m.resolveMarketplaceHeaders)(oe.version,oe,this.environmentService,this.configurationService,this.fileService,O)}api(O=""){return`${this.extensionsGalleryUrl}${O}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(O,V,J){const le=n.CancellationToken.isCancellationToken(V)?{}:V,ge=n.CancellationToken.isCancellationToken(V)?V:J,ue=[],oe=[],pe=[],X=[];let B=!0;for(const fe of O){fe.uuid?oe.push(fe.uuid):ue.push(fe.id);const ye=!!(fe.version||fe.preRelease);pe.push({id:fe.id,uuid:fe.uuid,includePreRelease:ye}),fe.version&&X.push({id:fe.id,uuid:fe.uuid,version:fe.version}),B=B&&!!fe.hasPreRelease&&!ye}if(!oe.length&&!ue.length)return[];let x=new g().withPage(1,O.length);oe.length&&(x=x.withFilter(t.ExtensionId,...oe)),ue.length&&(x=x.withFilter(t.ExtensionName,...ue)),(le.queryAllVersions||B)&&(x=x.withFlags(x.flags,l.IncludeVersions));const{extensions:Y}=await this.queryGalleryExtensions(x,{targetPlatform:le.targetPlatform??o,includePreRelease:pe,versions:X,compatible:!!le.compatible},ge);return le.source&&Y.forEach((fe,ye)=>ie(fe,ye,le.source)),Y}async getCompatibleExtension(O,V,J){if((0,E.isNotWebExtensionInWebTargetPlatform)(O.allTargetPlatforms,J))return null;if(await this.isExtensionCompatible(O,V,J))return O;const le=new g().withFlags(l.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,O.identifier.uuid),{extensions:ge}=await this.queryGalleryExtensions(le,{targetPlatform:J,compatible:!0,includePreRelease:V},n.CancellationToken.None);return ge[0]||null}async isExtensionCompatible(O,V,J){if(!(0,E.isTargetPlatformCompatible)(O.properties.targetPlatform,O.allTargetPlatforms,J)||!V&&O.properties.isPreReleaseVersion)return!1;let le=O.properties.engine;if(!le){const ge=await this.getManifest(O,n.CancellationToken.None);if(!ge)throw new Error("Manifest was not found");le=ge.engines.vscode}return(0,u.isEngineValid)(le,this.productService.version,this.productService.date)}async isValidVersion(O,V,J,le,ge){if(!(0,E.isTargetPlatformCompatible)(U(O),le,ge)||V!=="any"&&q(O)!==(V==="prerelease"))return!1;if(J){const ue=await this.getEngine(O);if(!(0,u.isEngineValid)(ue,this.productService.version,this.productService.date))return!1}return!0}async query(O,V){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let J=O.text||"";const le=(0,C.getOrDefault)(O,B=>B.pageSize,50);let ge=new g().withPage(1,le);J?(J=J.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(B,x,Y)=>(ge=ge.withFilter(t.Category,Y||x),"")),J=J.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(B,x,Y)=>(ge=ge.withFilter(t.Tag,Y||x),"")),J=J.replace(/\bfeatured(\s+|\b|$)/g,()=>(ge=ge.withFilter(t.Featured),"")),J=J.trim(),J&&(J=J.length<200?J:J.substring(0,200),ge=ge.withFilter(t.SearchText,J)),ge=ge.withSortBy(0)):O.ids?ge=ge.withFilter(t.ExtensionId,...O.ids):O.names?ge=ge.withFilter(t.ExtensionName,...O.names):ge=ge.withSortBy(4),typeof O.sortBy=="number"&&(ge=ge.withSortBy(O.sortBy)),typeof O.sortOrder=="number"&&(ge=ge.withSortOrder(O.sortOrder));const ue=async(B,x)=>{const{extensions:Y,total:fe}=await this.queryGalleryExtensions(B,{targetPlatform:o,compatible:!1,includePreRelease:!!O.includePreRelease},x);return Y.forEach((ye,ke)=>ie(ye,(B.pageNumber-1)*B.pageSize+ke,O.source)),{extensions:Y,total:fe}},{extensions:oe,total:pe}=await ue(ge,V),X=async(B,x)=>{if(x.isCancellationRequested)throw new w.CancellationError;const{extensions:Y}=await ue(ge.withPage(B+1),x);return Y};return{firstPage:oe,total:pe,pageSize:ge.pageSize,getPage:X}}async queryGalleryExtensions(O,V,J){const le=O.flags;!!(O.flags&l.IncludeLatestVersionOnly)&&!!(O.flags&l.IncludeVersions)&&(O=O.withFlags(O.flags&~l.IncludeVersions,l.IncludeLatestVersionOnly)),!(O.flags&l.IncludeLatestVersionOnly)&&!(O.flags&l.IncludeVersions)&&(O=O.withFlags(O.flags,l.IncludeLatestVersionOnly)),V.versions?.length&&(O=O.withFlags(O.flags&~l.IncludeLatestVersionOnly,l.IncludeVersions)),O=O.withFlags(O.flags,l.IncludeAssetUri,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeStatistics,l.IncludeVersionProperties);const{galleryExtensions:ge,total:ue}=await this.queryRawGalleryExtensions(O,J);if(!(O.flags&l.IncludeLatestVersionOnly)){const B=[];for(const x of ge){const Y=await this.toGalleryExtensionWithCriteria(x,V);Y&&B.push(Y)}return{extensions:B,total:ue}}const pe=[],X=new Map;for(let B=0;B<ge.length;B++){const x=ge[B],Y={id:(0,S.getGalleryExtensionId)(x.publisher.publisherName,x.extensionName),uuid:x.extensionId},fe=(0,v.isBoolean)(V.includePreRelease)?V.includePreRelease:!!V.includePreRelease.find(ke=>(0,S.areSameExtensions)(ke,Y))?.includePreRelease;if(V.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(z(x),V.targetPlatform))continue;const ye=await this.toGalleryExtensionWithCriteria(x,V);!ye||ye.properties.isPreReleaseVersion&&(!fe||!ye.hasReleaseVersion)||!ye.properties.isPreReleaseVersion&&ye.properties.targetPlatform!==V.targetPlatform&&ye.hasPreReleaseVersion?X.set(x.extensionId,B):pe.push([B,ye])}if(X.size){const B=new Date().getTime(),x=new g().withFlags(le&~l.IncludeLatestVersionOnly,l.IncludeVersions).withPage(1,X.size).withFilter(t.ExtensionId,...X.keys()),{extensions:Y}=await this.queryGalleryExtensions(x,V,J);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-B,count:X.size});for(const fe of Y){const ye=X.get(fe.identifier.uuid);pe.push([ye,fe])}}return{extensions:pe.sort((B,x)=>B[0]-x[0]).map(([,B])=>B),total:ue}}async toGalleryExtensionWithCriteria(O,V){const J={id:(0,S.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},le=V.versions?.find(pe=>(0,S.areSameExtensions)(pe,J))?.version,ge=(0,v.isBoolean)(V.includePreRelease)?V.includePreRelease:!!V.includePreRelease.find(pe=>(0,S.areSameExtensions)(pe,J))?.includePreRelease,ue=z(O),oe=Q(O.versions,V.targetPlatform);if(V.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(ue,V.targetPlatform))return null;for(let pe=0;pe<oe.length;pe++){const X=oe[pe];if(!(le&&X.version!==le)){if(await this.isValidVersion(X,ge?"any":"release",V.compatible,ue,V.targetPlatform))return re(O,X,ue);if(le&&X.version===le)return null}}return le||V.compatible?null:re(O,O.versions[0],ue)}async queryRawGalleryExtensions(O,V){if(!this.isEnabled())throw new Error("No extension gallery service configured.");O=O.withFlags(O.flags,l.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,i(l.Unpublished));const J=await this.commonHeadersPromise,le=JSON.stringify(O.raw),ge={...J,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(le.length)},ue=new Date().getTime();let oe,pe,X=0;try{if(oe=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:le,headers:ge},V),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:X};const B=await(0,p.asJson)(oe);if(B){const x=B.results[0],Y=x.extensions,fe=x.resultMetadata&&x.resultMetadata.filter(ye=>ye.metadataType==="ResultCount")[0];return X=fe&&fe.metadataItems.filter(ye=>ye.name==="TotalCount")[0].count||0,{galleryExtensions:Y,total:X}}return{galleryExtensions:[],total:X}}catch(B){throw pe=B,B}finally{this.telemetryService.publicLog2("galleryService:query",{...O.telemetryData,requestBodySize:String(le.length),duration:new Date().getTime()-ue,success:!!oe&&(0,p.isSuccess)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:pe?(0,w.isCancellationError)(pe)?"canceled":(0,w.getErrorMessage)(pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(X)})}}async reportStatistic(O,V,J,le){if(!this.isEnabled())return;const ge=T.isWeb?this.api(`/itemName/${O}.${V}/version/${J}/statType/${le==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${O}/extensions/${V}/${J}/stats?statType=${le}`),ue=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.commonHeadersPromise,Accept:ue};try{await this.requestService.request({type:"POST",url:ge,headers:pe},n.CancellationToken.None)}catch{}}async download(O,V,J){this.logService.trace("ExtensionGalleryService#download",O.identifier.id);const le=(0,S.getGalleryExtensionTelemetryData)(O),ge=new Date().getTime(),ue=B=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...le,duration:B}),oe=J===2?"install":J===3?"update":"",pe=oe?{uri:`${O.assets.download.uri}${P.URI.parse(O.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${O.assets.download.fallbackUri}${P.URI.parse(O.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:O.assets.download,X=await this.getAsset(pe);await this.fileService.writeFile(V,X.stream),ue(new Date().getTime()-ge)}async getReadme(O,V){if(O.assets.readme){const J=await this.getAsset(O.assets.readme,{},V);return await(0,p.asText)(J)||""}return""}async getManifest(O,V){if(O.assets.manifest){const J=await this.getAsset(O.assets.manifest,{},V),le=await(0,p.asText)(J);return le?JSON.parse(le):null}return null}async getManifestFromRawExtensionVersion(O,V){const J=I(O,r.Manifest);if(!J)throw new Error("Manifest was not found");const le={"Accept-Encoding":"gzip"},ge=await this.getAsset(J,{headers:le});return await(0,p.asJson)(ge)}async getCoreTranslation(O,V){const J=O.assets.coreTranslations.filter(le=>le[0]===V.toUpperCase())[0];if(J){const le=await this.getAsset(J[1]),ge=await(0,p.asText)(le);return ge?JSON.parse(ge):null}return null}async getChangelog(O,V){if(O.assets.changelog){const J=await this.getAsset(O.assets.changelog,{},V);return await(0,p.asText)(J)||""}return""}async getAllCompatibleVersions(O,V,J){let le=new g().withFlags(l.IncludeVersions,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,1);O.identifier.uuid?le=le.withFilter(t.ExtensionId,O.identifier.uuid):le=le.withFilter(t.ExtensionName,O.identifier.id);const{galleryExtensions:ge}=await this.queryRawGalleryExtensions(le,n.CancellationToken.None);if(!ge.length)return[];const ue=z(ge[0]);if((0,E.isNotWebExtensionInWebTargetPlatform)(ue,J))return[];const oe=[];await Promise.all(ge[0].versions.map(async B=>{try{await this.isValidVersion(B,V?"any":"release",!0,ue,J)&&oe.push(B)}catch{}}));const pe=[],X=new Set;for(const B of Q(oe,J))X.has(B.version)||(X.add(B.version),pe.push({version:B.version,date:B.lastUpdated,isPreReleaseVersion:q(B)}));return pe}async getAsset(O,V={},J=n.CancellationToken.None){const le=await this.commonHeadersPromise,ge={type:"GET"},ue={...le,...V.headers||{}};V={...V,...ge,headers:ue};const oe=O.uri,pe=O.fallbackUri,X={...V,url:oe};try{const B=await this.requestService.request(X,J);if(B.res.statusCode===200)return B;const x=await(0,p.asText)(B);throw new Error(`Expected 200, got back ${B.res.statusCode} instead.

${x}`)}catch(B){if((0,w.isCancellationError)(B))throw B;const x=(0,w.getErrorMessage)(B);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:oe,message:x});const Y={...V,url:pe};return this.requestService.request(Y,J)}}async getEngine(O){let V=M(O);if(!V){const J=await this.getManifestFromRawExtensionVersion(O,n.CancellationToken.None);if(!J)throw new Error("Manifest was not found");V=J.engines.vscode}return V}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const O=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(O.res.statusCode!==200)throw new Error("Could not get extensions report.");const V=await(0,p.asJson)(O),J=[],le={};if(V){for(const ge of V.malicious)J.push({id:ge});if(V.unsupported)for(const ge of Object.keys(V.unsupported)){const ue=V.unsupported[ge];(0,v.isBoolean)(ue)||(le[ge.toLowerCase()]=ue.preReleaseExtension)}if(V.migrateToPreRelease)for(const[ge,ue]of Object.entries(V.migrateToPreRelease))(!ue.engine||(0,u.isEngineValid)(ue.engine,this.productService.version,this.productService.date))&&(le[ge.toLowerCase()]=ue)}return{malicious:J,unsupportedPreReleaseExtensions:le}}};ce=Ae([Oe(1,p.IRequestService),Oe(2,f.ILogService),Oe(3,R.IEnvironmentService),Oe(4,c.ITelemetryService),Oe(5,b.IFileService),Oe(6,d.IProductService),Oe(7,A.IConfigurationService)],ce);let de=class extends ce{constructor(O,V,J,le,ge,ue,oe,pe){super(O,V,J,le,ge,ue,oe,pe)}};de=Ae([Oe(0,y.IStorageService),Oe(1,p.IRequestService),Oe(2,f.ILogService),Oe(3,R.IEnvironmentService),Oe(4,c.ITelemetryService),Oe(5,b.IFileService),Oe(6,d.IProductService),Oe(7,A.IConfigurationService)],de),e.ExtensionGalleryService=de;let he=class extends ce{constructor(O,V,J,le,ge,ue,oe){super(void 0,O,V,J,le,ge,ue,oe)}};he=Ae([Oe(0,p.IRequestService),Oe(1,f.ILogService),Oe(2,R.IEnvironmentService),Oe(3,c.ITelemetryService),Oe(4,b.IFileService),Oe(5,d.IProductService),Oe(6,A.IConfigurationService)],he),e.ExtensionGalleryServiceWithNoStorageService=he}),define(ve[212],we([0,1,2,22,3,15,163,26,46,45,28,34,32,41]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let u=class{constructor(d,p,m){this._configurationService=p,this._productService=m,this._experimentProperties={},this._disposables=new k.DisposableStore,this._cleanupPatterns=[],this._appenders=d.appenders,this._commonProperties=d.commonProperties||Promise.resolve({}),this._piiPaths=d.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let y of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,C.escapeRegExpCharacters)(y),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(d,p){this._experimentProperties[d]=p}_updateTelemetryLevel(){this._telemetryLevel=(0,S.getTelemetryLevel)(this._configurationService);const d=this._productService.enabledTelemetryLevels;if(d){this._sendErrorTelemetry=this.sendErrorTelemetry?d.error:!1;const p=d.usage?3:d.error?2:0;this._telemetryLevel=Math.min(this._telemetryLevel,p)}}get telemetryLevel(){return this._telemetryLevel}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const d=await this._commonProperties;let p=d.sessionID,m=d["common.machineId"],y=d["common.firstSessionDate"],c=d["common.msftInternal"];return{sessionId:p,machineId:m,firstSessionDate:y,msftInternal:c}}dispose(){this._disposables.dispose()}_log(d,p,m,y){return this.telemetryLevel<p?Promise.resolve(void 0):this._commonProperties.then(c=>{m=(0,n.mixin)(m,c),m=(0,n.mixin)(m,this._experimentProperties),m=(0,n.cloneAndChange)(m,o=>{if(typeof o=="string")return this._cleanupInfo(o,y)}),this._appenders.forEach(o=>o.log(d,m))},c=>{console.error(c)})}publicLog(d,p,m){return this._log(d,3,p,m)}publicLog2(d,p,m){return this.publicLog(d,p,m)}publicLogError(d,p){return this._sendErrorTelemetry?this._log(d,2,p,!0):Promise.resolve(void 0)}publicLogError2(d,p){return this.publicLogError(d,p)}_anonymizeFilePaths(d){let p=d;const m=[];for(let l of this._cleanupPatterns)for(;;){const i=l.exec(d);if(!i)break;m.push([i.index,l.lastIndex])}const y=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(p="";;){const l=c.exec(d);if(!l)break;!y.test(l[0])&&m.every(([i,t])=>l.index<i||l.index>=t)&&(p+=d.substring(o,l.index)+"<REDACTED: user-file-path>",o=c.lastIndex)}return o<d.length&&(p+=d.substr(o)),p}_removePropertiesWithPossibleUserInfo(d){if(!d)return d;const p=d.toLowerCase(),m=/@[a-zA-Z0-9-.]+/,y=/(key|token|sig|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/,c=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return y.test(p)?"<REDACTED: secret>":m.test(p)?"<REDACTED: email>":c.test(p)?"<REDACTED: token>":d}_cleanupInfo(d,p){let m=d;p&&(m=this._anonymizeFilePaths(m));for(let y of this._cleanupPatterns)m=m.replace(y,"");return m=this._removePropertiesWithPossibleUserInfo(m),m}};u.IDLE_START_EVENT_NAME="UserIdleStart",u.IDLE_STOP_EVENT_NAME="UserIdleStop",u=Ae([Oe(1,D.IConfigurationService),Oe(2,A.IProductService)],u),e.TelemetryService=u;function b(){const f=(0,T.localize)(0,null,P.default.nameLong),d=P.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",P.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=w.isWeb?"":(0,T.localize)(3,null),m=(0,T.localize)(4,null),y=(0,T.localize)(5,null),c=(0,T.localize)(6,null),o=(0,T.localize)(7,null),l=`
|       | ${m} | ${y} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,T.localize)(8,null);return`
${f} ${d} ${p}

&nbsp;

${o}
${l}

&nbsp;

${i}
`}R.Registry.as(v.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:b(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),R.Registry.as(v.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:P.default.privacyStatementUrl?(0,T.localize)(16,null,P.default.nameLong,P.default.privacyStatementUrl):(0,T.localize)(15,null,P.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ve[213],we([0,1,26,6,28,32,212,41]),function(ee,e,k,n,w,C,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IServerTelemetryService=e.ServerNullTelemetryService=e.ServerTelemetryService=void 0;let v=class extends T.TelemetryService{constructor(A,R,E,S){super(A,E,S);this._telemetryCache=[],this._injectedTelemetryLevel=R}publicLog(A,R,E){return this._injectedTelemetryLevel===void 0?(this._telemetryCache?.push({eventName:A,data:R,anonymizeFilePaths:E,eventType:"usage"}),Promise.resolve()):this._injectedTelemetryLevel<3?Promise.resolve(void 0):super.publicLog(A,R,E)}publicLog2(A,R,E){return this.publicLog(A,R,E)}publicLogError(A,R){return this._injectedTelemetryLevel===void 0?(this._telemetryCache?.push({eventName:A,data:R,eventType:"error"}),Promise.resolve()):this._injectedTelemetryLevel<2?Promise.resolve(void 0):super.publicLogError(A,R)}publicLogError2(A,R){return this.publicLogError(A,R)}async flushTelemetryCache(){if(this._telemetryCache?.length!==0){for(const A of this._telemetryCache)A.eventType==="usage"?await this.publicLog(A.eventName,A.data,A.anonymizeFilePaths):await this.publicLogError(A.eventName,A.data);this._telemetryCache=[]}}async updateInjectedTelemetryLevel(A){if(A===void 0)throw this._injectedTelemetryLevel=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");if(this._injectedTelemetryLevel=this._injectedTelemetryLevel?Math.min(this._injectedTelemetryLevel,A):A,this._injectedTelemetryLevel===0)this._telemetryCache=[],this.dispose();else return this.flushTelemetryCache()}};v=Ae([Oe(2,k.IConfigurationService),Oe(3,w.IProductService)],v),e.ServerTelemetryService=v,e.ServerNullTelemetryService=new class extends D.NullTelemetryServiceShape{async updateInjectedTelemetryLevel(){}},e.IServerTelemetryService=(0,n.refineServiceDecorator)(C.ITelemetryService)}),define(ve[214],we([0,1,9,22,41]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function C(D){const v=await new Promise((A,R)=>{ee(["applicationinsights"],A,R)});let P;return v.defaultClient?(P=new v.TelemetryClient(D),P.channel.setUseDiskRetryCaching(!0)):(v.setup(D).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),P=v.defaultClient),D.indexOf("AIF-")===0&&(P.config.endpointUrl="https://mobile.events.data.microsoft.com/collect/v1"),P}class T{constructor(v,P,A){this._eventPrefix=v,this._defaultData=P,this._defaultData||(this._defaultData=Object.create(null)),typeof A=="function"?this._aiClient=A():this._aiClient=A,this._asyncAIClient=null}_withAIClient(v){if(!!this._aiClient){if(typeof this._aiClient!="string"){v(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=C(this._aiClient)),this._asyncAIClient.then(P=>{v(P)},P=>{(0,k.onUnexpectedError)(P),console.error(P)})}}log(v,P){if(!!this._aiClient){P=(0,n.mixin)(P,this._defaultData),P=(0,w.validateTelemetryData)(P);try{this._withAIClient(A=>A.trackEvent({name:this._eventPrefix+"/"+v,properties:P.properties,measurements:P.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(v=>{this._withAIClient(P=>{try{P.flush({callback:()=>{this._aiClient=void 0,v(void 0)}})}catch{}})}):Promise.resolve(void 0)}}e.AppInsightsAppender=T}),define(ve[215],we([0,1,9,207]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class w extends n.default{installErrorListeners(){(0,k.setUnexpectedErrorHandler)(D=>console.error(D));const T=[];process.on("unhandledRejection",(D,v)=>{T.push(v),setTimeout(()=>{const P=T.indexOf(v);P>=0&&v.catch(A=>{T.splice(P,1),(0,k.isCancellationError)(A)||(console.warn(`rejected promise not handled within 1 second: ${A}`),A.stack&&console.warn(`stack trace: ${A.stack}`),D&&(0,k.onUnexpectedError)(D))})},1e3)}),process.on("rejectionHandled",D=>{const v=T.indexOf(D);v>=0&&T.splice(v,1)}),process.on("uncaughtException",D=>{(0,k.onUnexpectedError)(D)})}}e.default=w}),define(ve[216],we([0,1,14,21,7,2,13]),function(ee,e,k,n,w,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let D=class extends C.Disposable{constructor(P,A){super();this._logService=A,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new w.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=P===void 0?15e3:P}createRequest(P){return new Promise((A,R)=>{const E=++this._lastRequestId;this._pendingRequests.set(E,A),this._onCreateRequest.fire({requestId:E,...P});const S=new n.CancellationTokenSource;(0,k.timeout)(this._timeout,S.token).then(()=>R(`Request ${E} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(E,[(0,C.toDisposable)(()=>S.cancel())])})}acceptReply(P,A){const R=this._pendingRequests.get(P);R?(this._pendingRequests.delete(P),(0,C.dispose)(this._pendingRequestDisposables.get(P)||[]),this._pendingRequestDisposables.delete(P),R(A)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${P}`)}};D=Ae([Oe(1,T.ILogService)],D),e.RequestStore=D}),define(ve[100],we([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var n;(function(f){f.Shell="terminal.integrated.shell.",f.ShellArgs="terminal.integrated.shellArgs.",f.DefaultProfile="terminal.integrated.defaultProfile.",f.Profiles="terminal.integrated.profiles."})(n=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var w;(function(f){f.ShellLinux="terminal.integrated.shell.linux",f.ShellMacOs="terminal.integrated.shell.osx",f.ShellWindows="terminal.integrated.shell.windows",f.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",f.AutomationShellLinux="terminal.integrated.automationShell.linux",f.AutomationShellMacOs="terminal.integrated.automationShell.osx",f.AutomationShellWindows="terminal.integrated.automationShell.windows",f.AutomationProfileLinux="terminal.integrated.automationProfile.linux",f.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",f.AutomationProfileWindows="terminal.integrated.automationProfile.windows",f.ShellArgsLinux="terminal.integrated.shellArgs.linux",f.ShellArgsMacOs="terminal.integrated.shellArgs.osx",f.ShellArgsWindows="terminal.integrated.shellArgs.windows",f.ProfilesWindows="terminal.integrated.profiles.windows",f.ProfilesMacOs="terminal.integrated.profiles.osx",f.ProfilesLinux="terminal.integrated.profiles.linux",f.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",f.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",f.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",f.UseWslProfiles="terminal.integrated.useWslProfiles",f.TabsEnabled="terminal.integrated.tabs.enabled",f.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",f.TabsHideCondition="terminal.integrated.tabs.hideCondition",f.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",f.TabsShowActions="terminal.integrated.tabs.showActions",f.TabsLocation="terminal.integrated.tabs.location",f.TabsFocusMode="terminal.integrated.tabs.focusMode",f.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",f.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",f.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",f.CopyOnSelection="terminal.integrated.copyOnSelection",f.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",f.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",f.FontFamily="terminal.integrated.fontFamily",f.FontSize="terminal.integrated.fontSize",f.LetterSpacing="terminal.integrated.letterSpacing",f.LineHeight="terminal.integrated.lineHeight",f.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",f.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",f.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",f.BellDuration="terminal.integrated.bellDuration",f.FontWeight="terminal.integrated.fontWeight",f.FontWeightBold="terminal.integrated.fontWeightBold",f.CursorBlinking="terminal.integrated.cursorBlinking",f.CursorStyle="terminal.integrated.cursorStyle",f.CursorWidth="terminal.integrated.cursorWidth",f.Scrollback="terminal.integrated.scrollback",f.DetectLocale="terminal.integrated.detectLocale",f.DefaultLocation="terminal.integrated.defaultLocation",f.GpuAcceleration="terminal.integrated.gpuAcceleration",f.TerminalTitleSeparator="terminal.integrated.tabs.separator",f.TerminalTitle="terminal.integrated.tabs.title",f.TerminalDescription="terminal.integrated.tabs.description",f.RightClickBehavior="terminal.integrated.rightClickBehavior",f.Cwd="terminal.integrated.cwd",f.ConfirmOnExit="terminal.integrated.confirmOnExit",f.ConfirmOnKill="terminal.integrated.confirmOnKill",f.EnableBell="terminal.integrated.enableBell",f.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",f.AllowChords="terminal.integrated.allowChords",f.AllowMnemonics="terminal.integrated.allowMnemonics",f.EnvMacOs="terminal.integrated.env.osx",f.EnvLinux="terminal.integrated.env.linux",f.EnvWindows="terminal.integrated.env.windows",f.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",f.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",f.ShowExitAlert="terminal.integrated.showExitAlert",f.SplitCwd="terminal.integrated.splitCwd",f.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",f.WordSeparators="terminal.integrated.wordSeparators",f.EnableFileLinks="terminal.integrated.enableFileLinks",f.UnicodeVersion="terminal.integrated.unicodeVersion",f.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",f.LocalEchoEnabled="terminal.integrated.localEchoEnabled",f.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",f.LocalEchoStyle="terminal.integrated.localEchoStyle",f.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",f.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",f.CustomGlyphs="terminal.integrated.customGlyphs",f.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",f.InheritEnv="terminal.integrated.inheritEnv",f.ShowLinkHover="terminal.integrated.showLinkHover",f.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",f.AutoReplies="terminal.integrated.autoReplies",f.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",f.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",f.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",f.ShellIntegrationDecorationIcon="terminal.integrated.shellIntegration.decorationIcon",f.ShellIntegrationDecorationIconError="terminal.integrated.shellIntegration.decorationIconError",f.ShellIntegrationDecorationIconSuccess="terminal.integrated.shellIntegration.decorationIconSuccess",f.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history"})(w=e.TerminalSettingId||(e.TerminalSettingId={}));var C;(function(f){f.PowerShell="pwsh",f.Bash="bash",f.Fish="fish",f.Sh="sh",f.Csh="csh",f.Ksh="ksh",f.Zsh="zsh"})(C=e.PosixShellType||(e.PosixShellType={}));var T;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash"})(T=e.WindowsShellType||(e.WindowsShellType={}));var D;(function(f){f[f.Api=0]="Api",f[f.Process=1]="Process",f[f.Sequence=2]="Sequence",f[f.Config=3]="Config"})(D=e.TitleEventSource||(e.TitleEventSource={}));var v;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.Log="log",f.Heartbeat="heartbeat"})(v=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,k.createDecorator)("ptyService");var P;(function(f){f.Cwd="cwd",f.InitialCwd="initialCwd",f.FixedDimensions="fixedDimensions",f.Title="title",f.ShellType="shellType",f.HasChildProcesses="hasChildProcesses",f.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",f.OverrideDimensions="overrideDimensions"})(P=e.ProcessPropertyType||(e.ProcessPropertyType={}));var A;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(A=e.HeartbeatConstants||(e.HeartbeatConstants={}));var R;(function(f){f[f.Panel=1]="Panel",f[f.Editor=2]="Editor"})(R=e.TerminalLocation||(e.TerminalLocation={}));var E;(function(f){f.TerminalView="view",f.Editor="editor"})(E=e.TerminalLocationString||(e.TerminalLocationString={}));var S;(function(f){f[f.GraceTime=6e4]="GraceTime",f[f.ShortGraceTime=6e3]="ShortGraceTime"})(S=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var u;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})(u=e.FlowControlConstants||(e.FlowControlConstants={}));var b;(function(f){f.GitBash="Git Bash",f.Pwsh="PowerShell"})(b=e.ProfileSource||(e.ProfileSource={}))}),define(ve[217],we([0,1,25,8,22,5,3,24,15,12,19]),function(ee,e,k,n,w,C,T,D,v,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function R(){const y=/(\d+)\.(\d+)\.(\d+)/g.exec(k.release());let c=0;return y&&y.length===4&&(c=parseInt(y[3])),c}e.getWindowsBuildNumber=R;async function E(y,c,o,l=D.env,i=A.Promises.exists){if(C.isAbsolute(y))return await i(y)?y:void 0;if(c===void 0&&(c=D.cwd()),C.dirname(y)!=="."){const a=C.join(c,y);return await i(a)?a:void 0}const r=(0,w.getCaseInsensitive)(l,"PATH");if(o===void 0&&(0,P.isString)(r)&&(o=r.split(C.delimiter)),o===void 0||o.length===0){const a=C.join(c,y);return await i(a)?a:void 0}for(let a of o){let h;if(C.isAbsolute(a)?h=C.join(a,y):h=C.join(c,a,y),await i(h))return h;if(T.isWindows){let g=h+".com";if(await i(g)||(g=h+".exe",await i(g)))return g}}const s=C.join(c,y);return await i(s)?s:void 0}e.findExecutable=E;function S(y,c){if(!c.enabled||!y.executable||y.isFeatureTerminal)return;const o=y.args,l=D.platform==="win32"?C.basename(y.executable).toLowerCase():C.basename(y.executable),i=C.dirname(n.FileAccess.asFileUri("",ee).fsPath);let t;if(T.isWindows){if(l==="pwsh.exe"){if(!o||p(o)?t=e.shellIntegrationArgs.get(u.WindowsPwsh):d(o)&&(t=e.shellIntegrationArgs.get(u.WindowsPwshLogin)),!t)return;if(t){const s=c.showWelcome?"":" -HideWelcome";t=[...t],t[t.length-1]=(0,v.format)(t[t.length-1],i,s)}return{newArgs:t}}return}const r={};switch(l){case"bash":return!o||o.length===0?t=e.shellIntegrationArgs.get(u.Bash):m(o)&&(r.VSCODE_SHELL_LOGIN="1",t=e.shellIntegrationArgs.get(u.Bash)),t?(t=[...t],t[t.length-1]=(0,v.format)(t[t.length-1],i),c.showWelcome||(r.VSCODE_SHELL_HIDE_WELCOME="1"),{newArgs:t,envMixin:r}):void 0;case"pwsh":{if(!o||p(o)?t=e.shellIntegrationArgs.get(u.Pwsh):d(o)&&(t=e.shellIntegrationArgs.get(u.PwshLogin)),!t)return;const s=c.showWelcome?"":" -HideWelcome";return t=[...t],t[t.length-1]=(0,v.format)(t[t.length-1],i,s),{newArgs:t}}case"zsh":{if(!o||o.length===0?t=e.shellIntegrationArgs.get(u.Zsh):m(o)?t=e.shellIntegrationArgs.get(u.ZshLogin):(o===e.shellIntegrationArgs.get(u.Zsh)||o===e.shellIntegrationArgs.get(u.ZshLogin))&&(t=o),!t)return;t=[...t],t[t.length-1]=(0,v.format)(t[t.length-1],i);const s=C.join(k.tmpdir(),"vscode-zsh");r.ZDOTDIR=s;const a=[];return a.push({source:C.join(i,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration.zsh"),dest:C.join(s,".zshrc")}),c.showWelcome||(r.VSCODE_SHELL_HIDE_WELCOME="1"),{newArgs:t,envMixin:r,filesToCopy:a}}}}e.getShellIntegrationInjection=S;var u;(function(y){y.WindowsPwsh="windows-pwsh",y.WindowsPwshLogin="windows-pwsh-login",y.Pwsh="pwsh",y.PwshLogin="pwsh-login",y.Zsh="zsh",y.ZshLogin="zsh-login",y.Bash="bash"})(u=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(u.WindowsPwsh,["-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(u.WindowsPwshLogin,["-l","-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(u.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(u.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(u.Zsh,["-i"]),e.shellIntegrationArgs.set(u.ZshLogin,["-il"]),e.shellIntegrationArgs.set(u.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const b=["-login","-l"],f=["-nol","-nologo"];function d(y){return typeof y=="string"?b.includes(y.toLowerCase()):y.length===1&&b.includes(y[0].toLowerCase())||y.length===2&&(b.includes(y[0].toLowerCase())||b.includes(y[1].toLowerCase()))&&(f.includes(y[0].toLowerCase())||f.includes(y[1].toLowerCase()))}function p(y){return typeof y=="string"?f.includes(y.toLowerCase()):y.length===0||y?.length===1&&f.includes(y[0].toLowerCase())}function m(y){return y==="string"&&b.includes(y.toLowerCase())||typeof y!="string"&&y.length===1&&b.includes(y[0].toLowerCase())}}),define(ve[218],we([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isHighContrast=e.ColorScheme=void 0;var k;(function(w){w.DARK="dark",w.LIGHT="light",w.HIGH_CONTRAST_DARK="hcDark",w.HIGH_CONTRAST_LIGHT="hcLight"})(k=e.ColorScheme||(e.ColorScheme={}));function n(w){return w===k.HIGH_CONTRAST_DARK||w===k.HIGH_CONTRAST_LIGHT}e.isHighContrast=n}),define(ve[101],we([0,1,37,7,2,6,34,218]),function(ee,e,k,n,w,C,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var v;(function(f){function d(p){return p&&typeof p=="object"&&typeof p.id=="string"}f.isThemeColor=d})(v=e.ThemeColor||(e.ThemeColor={}));function P(f){return{id:f}}e.themeColorFromId=P;var A;(function(f){function d(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||v.isThemeColor(t.color))}f.isThemeIcon=d;const p=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function m(t){const r=p.exec(t);if(!r)return;let[,s]=r;return{id:s}}f.fromString=m;function y(t){return{id:t}}f.fromId=y;function c(t,r){let s=t.id;const a=s.lastIndexOf("~");return a!==-1&&(s=s.substring(0,a)),r&&(s=`${s}~${r}`),{id:s}}f.modify=c;function o(t){const r=t.id.lastIndexOf("~");if(r!==-1)return t.id.substring(r+1)}f.getModifier=o;function l(t,r){return t.id===r.id&&t.color?.id===r.color?.id}f.isEqual=l;function i(t,r){return{id:t.id,color:r?P(r):void 0}}f.asThemeIcon=i,f.asClassNameArray=k.CSSIcon.asClassNameArray,f.asClassName=k.CSSIcon.asClassName,f.asCSSSelector=k.CSSIcon.asCSSSelector})(A=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function R(f){switch(f){case D.ColorScheme.DARK:return"vs-dark";case D.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case D.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=R,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(d){return this.themingParticipants.push(d),this.onThemingParticipantAddedEmitter.fire(d),(0,w.toDisposable)(()=>{const p=this.themingParticipants.indexOf(d);this.themingParticipants.splice(p,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let S=new E;T.Registry.add(e.Extensions.ThemingContribution,S);function u(f){return S.onColorThemeChange(f)}e.registerThemingParticipant=u;class b extends w.Disposable{constructor(d){super();this.themeService=d,this.theme=d.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(p=>this.onThemeChange(p)))}onThemeChange(d){this.theme=d,this.updateStyles()}updateStyles(){}getColor(d,p){let m=this.theme.getColor(d);return m&&p&&(m=p(m,this.theme)),m?m.toString():null}}e.Themable=b}),define(ve[219],we([0,1,37,4,101]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function C(R,E){const S=R.map(u=>({name:u.profileName,description:T(u)}));return E&&S.push(...E.map(u=>({name:u.title,description:D(u)}))),{values:S.map(u=>u.name),markdownDescriptions:S.map(u=>u.description)}}e.createProfileSchemaEnums=C;function T(R){let E=`$(${w.ThemeIcon.isThemeIcon(R.icon)?R.icon.id:R.icon?R.icon:k.Codicon.terminal.id}) ${R.profileName}
- path: ${R.path}`;return R.args&&(typeof R.args=="string"?E+=`
- args: "${R.args}"`:E+=`
- args: [${R.args.length===0?"":`'${R.args.join("','")}'`}]`),R.overrideName!==void 0&&(E+=`
- overrideName: ${R.overrideName}`),R.color&&(E+=`
- color: ${R.color}`),R.env&&(E+=`
- env: ${JSON.stringify(R.env)}`),E}function D(R){return`$(${w.ThemeIcon.isThemeIcon(R.icon)?R.icon.id:R.icon?R.icon:k.Codicon.terminal.id}) ${R.title}
- extensionIdenfifier: ${R.extensionIdentifier}`}function v(R,E){if(!R&&!E)return!0;if(typeof R=="string"&&typeof E=="string")return R===E;if(Array.isArray(R)&&Array.isArray(E)){if(R.length!==E.length)return!1;for(let S=0;S<R.length;S++)if(R[S]!==E[S])return!1;return!0}return!1}e.terminalProfileArgsMatch=v;function P(R,E){if(!R&&!E)return!0;if(!R||!E)return!1;if(w.ThemeIcon.isThemeIcon(R)&&w.ThemeIcon.isThemeIcon(E))return R.id===E.id&&R.color===E.color;if(typeof R=="object"&&R&&"light"in R&&"dark"in R&&typeof E=="object"&&E&&"light"in E&&"dark"in E){const S=R,u=E;if((n.URI.isUri(S.light)||A(S.light))&&(n.URI.isUri(S.dark)||A(S.dark))&&(n.URI.isUri(u.light)||A(u.light))&&(n.URI.isUri(u.dark)||A(u.dark)))return S.light.path===u.light.path&&S.dark.path===u.dark.path}if(n.URI.isUri(R)&&n.URI.isUri(E)||A(R)||A(E)){const S=R,u=E;return S.path===u.path&&S.scheme===u.scheme}return!1}e.terminalIconsEqual=P;function A(R){return R?typeof R.path=="string"&&typeof R.scheme=="string":!1}e.isUriComponents=A}),define(ve[220],we([0,1,37,164,46,34,219]),function(ee,e,k,n,w,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const D={args:{description:(0,n.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,n.localize)(1,null),type:"boolean"},icon:{description:(0,n.localize)(2,null),type:"string",enum:Array.from(k.Codicon.getAll(),y=>y.id),markdownEnumDescriptions:Array.from(k.Codicon.getAll(),y=>`$(${y.id})`)},color:{description:(0,n.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,n.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},v={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(5,null),type:["string","array"],items:{type:"string"}},...D}},P={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(6,null),type:["string"],items:{type:"string"}},...D}},A=(0,n.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),R=(0,n.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),E=(0,n.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),S=(0,n.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),u=(0,n.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),b=(0,n.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),f={id:"terminal",order:100,title:(0,n.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:u},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(17,null,"`#terminal.integrated.automationShell.linux#`"),type:["object","null"],default:null,anyOf:[{type:"null"},P],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(18,null,"`#terminal.integrated.automationShell.osx#`"),type:["object","null"],default:null,anyOf:[{type:"null"},P],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(19,null,"`#terminal.integrated.automationShell.windows#`"),type:["object","null"],default:null,anyOf:[{type:"null"},P],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:A},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:R},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:A},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:R},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,n.localize)(26,null)}},{type:"string",markdownDescription:(0,n.localize)(27,null)}],default:[],markdownDeprecationMessage:E},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,n.localize)(29,null),enum:["PowerShell","Git Bash"]},...D}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(30,null),type:"string"},id:{description:(0,n.localize)(31,null),type:"string"},title:{description:(0,n.localize)(32,null),type:"string"},...D}},{type:"null"},v]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(34,null),type:"string"},id:{description:(0,n.localize)(35,null),type:"string"},title:{description:(0,n.localize)(36,null),type:"string"},...D}},{type:"null"},v]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(38,null),type:"string"},id:{description:(0,n.localize)(39,null),type:"string"},title:{description:(0,n.localize)(40,null),type:"string"},...D}},{type:"null"},v]}},["terminal.integrated.useWslProfiles"]:{description:(0,n.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,n.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,n.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,n.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,n.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function d(){C.Registry.as(w.Extensions.Configuration).registerConfiguration(f),m()}e.registerTerminalPlatformConfiguration=d;let p;function m(y,c){const o=C.Registry.as(w.Extensions.Configuration);let l;y&&(l=(0,T.createProfileSchemaEnums)(y?.profiles,c));const i=p;p={id:"terminal",order:100,title:(0,n.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:y?.os===3?l?.values:void 0,markdownEnumDescriptions:y?.os===3?l?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:y?.os===2?l?.values:void 0,markdownEnumDescriptions:y?.os===2?l?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:y?.os===1?l?.values:void 0,markdownEnumDescriptions:y?.os===1?l?.markdownDescriptions:void 0}}},o.updateConfigurations({add:[p],remove:i?[i]:[]})}e.registerTerminalDefaultProfileConfiguration=m}),define(ve[221],we([0,1,38,37,5,3,19,83,217,101]),function(ee,e,k,n,w,C,T,D,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let A,R=!0;function E(l,i,t,r,s=process.env,a,h,g,_){return a=a||{existsFile:T.SymlinkSupport.existsFile,readFile:T.Promises.readFile},C.isWindows?S(t,a,s,h,r.getValue("terminal.integrated.useWslProfiles")!==!1,l&&typeof l=="object"?{...l}:r.getValue("terminal.integrated.profiles.windows"),typeof i=="string"?i:r.getValue("terminal.integrated.defaultProfile.windows"),_,g):y(a,h,t,l&&typeof l=="object"?{...l}:r.getValue(C.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof i=="string"?i:r.getValue(C.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),_,g,s)}e.detectAvailableProfiles=E;async function S(l,i,t,r,s,a,h,g,_){const F=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),$=`${process.env.windir}\\${F?"Sysnative":"System32"}`;let K=!1;(0,v.getWindowsBuildNumber)()>=16299&&(K=!0),await f(g);const I=new Map;l&&(I.set("PowerShell",{source:"PowerShell",icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),I.set("Windows PowerShell",{path:`${$}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),I.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),I.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),I.set("Command Prompt",{path:`${$}\\cmd.exe`,icon:n.Codicon.terminalCmd,isAutoDetected:!0})),c(a,I);const W=await u(I.entries(),h,i,t,r,_);if(l||!l&&s)try{const M=await p(`${$}\\${K?"wsl":"bash"}.exe`,h);for(const q of M)(!a||!(q.profileName in a))&&W.push(q)}catch{R&&(r?.info("WSL is not installed, so could not detect WSL profiles"),R=!1)}return W}async function u(l,i,t,r=process.env,s,a){const h=[];for(const[g,_]of l){if(_===null)continue;let F,$,K;if("source"in _){const M=A?.get(_.source);if(!M)continue;F=M.paths,$=_.args||M.args,_.icon?K=b(_.icon):M.icon&&(K=M.icon)}else F=Array.isArray(_.path)?_.path:[_.path],$=C.isWindows||Array.isArray(_.args)?_.args:void 0,K=b(_.icon);const I=await a?.(F)||F.slice(),W=await o(g,i,I,t,r,$,_.env,_.overrideName,_.isAutoDetected,s);W?(W.isAutoDetected=_.isAutoDetected,W.icon=K,W.color=_.color,h.push(W)):s?.trace("profile not validated",g,F)}return h}function b(l){return typeof l=="string"?{id:l}:l}async function f(l){A&&!l||(A=new Map,A.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),A.set("PowerShell",{profileName:"PowerShell",paths:l||await d(),icon:P.ThemeIcon.asThemeIcon(n.Codicon.terminalPowershell)}))}async function d(){const l=[];for await(const i of(0,D.enumeratePowerShellInstallations)())l.push(i.exePath);return l}async function p(l,i){const t=[],r=await new Promise((h,g)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(_,F)=>{if(_)return g("Problem occurred when getting wsl distros");h(F)})});if(!r)return[];const s=new RegExp(/[\r?\n]/),a=r.split(s).filter(h=>h.trim().length>0&&h!=="");for(const h of a){if(h===""||h.startsWith("docker-desktop"))continue;const g=`${h} (WSL)`,_={profileName:g,path:l,args:["-d",`${h}`],isDefault:g===i,icon:m(h),isAutoDetected:!1};t.push(_)}return t}function m(l){return l.includes("Ubuntu")?P.ThemeIcon.asThemeIcon(n.Codicon.terminalUbuntu):l.includes("Debian")?P.ThemeIcon.asThemeIcon(n.Codicon.terminalDebian):P.ThemeIcon.asThemeIcon(n.Codicon.terminalLinux)}async function y(l,i,t,r,s,a,h,g){const _=new Map;if(t){const F=(await l.readFile("/etc/shells")).toString(),$=a||F.split(`
`).filter(I=>I.trim().indexOf("#")!==0&&I.trim().length>0),K=new Map;for(const I of $){let W=(0,w.basename)(I),M=K.get(W)||0;M++,M>1&&(W=`${W} (${M})`),K.set(W,M),_.set(W,{path:I,isAutoDetected:!0})}}return c(r,_),await u(_.entries(),s,l,g,i,h)}function c(l,i){if(!!l)for(const[t,r]of Object.entries(l))r===null||!("path"in r)&&!("source"in r)?i.delete(t):(r.icon=r.icon||i.get(t)?.icon,i.set(t,r))}async function o(l,i,t,r,s,a,h,g,_,F){if(t.length===0)return Promise.resolve(void 0);const $=t.shift();if($==="")return o(l,i,t,r,s,a,h,g,_);const K={profileName:l,path:$,args:a,env:h,overrideName:g,isAutoDetected:_,isDefault:l===i};if((0,w.basename)($)===$){const W=s.PATH?s.PATH.split(w.delimiter):void 0,M=await(0,v.findExecutable)($,void 0,W,void 0,r.existsFile);return M?(K.path=M,K.isFromPath=!0,K):o(l,i,t,r,s,a)}return await r.existsFile((0,w.normalize)($))?K:o(l,i,t,r,s,a,h,g,_)}}),define(ve[222],we([0,1,7,2,8,3,39,87,26,27,88,70,13,93,216,100,220,221]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E,S,u,b,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var p;(function(c){c[c.MaxRestarts=5]="MaxRestarts"})(p||(p={}));let m=0,y=class extends n.Disposable{constructor(o,l,i,t){super();this._reconnectConstants=o,this._configurationService=l,this._environmentService=i,this._logService=t,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new k.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new k.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new k.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new k.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new k.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new k.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new k.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new k.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new k.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new k.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new k.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new k.Emitter),this.onProcessExit=this._onProcessExit.event,(0,f.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,n.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new u.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async r=>{r.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(C.isWindows)return process.env;try{return await(0,R.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(o){return this._logService.error("ptyHost was unable to resolve shell environment",o),{}}}_startPtyHost(){const o={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:m,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},l=(0,A.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);l&&(l.break&&l.port?o.debugBrk=l.port:!l.break&&l.port&&(o.debug=l.port));const i=new D.Client(w.FileAccess.asFileUri("bootstrap-fork",ee).fsPath,o);this._onPtyHostStart.fire(),T.ProxyChannel.toService(i.getChannel(b.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(i.onDidProcessExit(a=>{this._onPtyHostExit.fire(a.code),this._isDisposed||(this._restartCount<=p.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const r=i.getChannel(b.TerminalIpcChannels.Log);S.LogLevelChannelClient.setLevel(r,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{S.LogLevelChannelClient.setLevel(r,this._logService.getLevel())}));const s=T.ProxyChannel.toService(i.getChannel(b.TerminalIpcChannels.PtyHost));return this._register(s.onProcessData(a=>this._onProcessData.fire(a))),this._register(s.onProcessReady(a=>this._onProcessReady.fire(a))),this._register(s.onProcessExit(a=>this._onProcessExit.fire(a))),this._register(s.onDidChangeProperty(a=>this._onDidChangeProperty.fire(a))),this._register(s.onProcessReplay(a=>this._onProcessReplay.fire(a))),this._register(s.onProcessOrphanQuestion(a=>this._onProcessOrphanQuestion.fire(a))),this._register(s.onDidRequestDetach(a=>this._onDidRequestDetach.fire(a))),[i,s]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(o,l,i,t,r,s,a,h,g,_,F){const $=setTimeout(()=>this._handleUnresponsiveCreateProcess(),b.HeartbeatConstants.CreateProcessTimeout),K=await this._proxy.createProcess(o,l,i,t,r,s,a,h,g,_,F);return clearTimeout($),m=Math.max(m,K),K}updateTitle(o,l,i){return this._proxy.updateTitle(o,l,i)}updateIcon(o,l,i){return this._proxy.updateIcon(o,l,i)}attachToProcess(o){return this._proxy.attachToProcess(o)}detachFromProcess(o){return this._proxy.detachFromProcess(o)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(o){return this._proxy.start(o)}shutdown(o,l){return this._proxy.shutdown(o,l)}input(o,l){return this._proxy.input(o,l)}processBinary(o,l){return this._proxy.processBinary(o,l)}resize(o,l,i){return this._proxy.resize(o,l,i)}acknowledgeDataEvent(o,l){return this._proxy.acknowledgeDataEvent(o,l)}setUnicodeVersion(o,l){return this._proxy.setUnicodeVersion(o,l)}getInitialCwd(o){return this._proxy.getInitialCwd(o)}getCwd(o){return this._proxy.getCwd(o)}getLatency(o){return this._proxy.getLatency(o)}orphanQuestionReply(o){return this._proxy.orphanQuestionReply(o)}installAutoReply(o,l){return this._proxy.installAutoReply(o,l)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(o){return this._proxy.uninstallAutoReply(o)}getDefaultSystemShell(o){return this._proxy.getDefaultSystemShell(o)}async getProfiles(o,l,i,t=!1){const r=await this._shellEnv;return(0,d.detectAvailableProfiles)(l,i,t,this._configurationService,r,void 0,this._logService,this._resolveVariables.bind(this,o))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(o){return this._proxy.getWslPath(o)}setTerminalLayoutInfo(o){return this._proxy.setTerminalLayoutInfo(o)}async getTerminalLayoutInfo(o){return await this._proxy.getTerminalLayoutInfo(o)}async requestDetachInstance(o,l){return this._proxy.requestDetachInstance(o,l)}async acceptDetachInstanceReply(o,l){return this._proxy.acceptDetachInstanceReply(o,l)}async serializeTerminalState(o){return this._proxy.serializeTerminalState(o)}async reviveTerminalProcesses(o,l){return this._proxy.reviveTerminalProcesses(o,l)}async refreshProperty(o,l){return this._proxy.refreshProperty(o,l)}async updateProperty(o,l,i){return this._proxy.updateProperty(o,l,i)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier+b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${b.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(o,l){return this._resolveVariablesRequestStore.createRequest({workspaceId:o,originalText:l})}async acceptPtyHostResolvedVariables(o,l){this._resolveVariablesRequestStore.acceptReply(o,l)}};y=Ae([Oe(1,v.IConfigurationService),Oe(2,P.IEnvironmentService),Oe(3,E.ILogService)],y),e.PtyHostService=y}),define(ve[48],we([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,k.createDecorator)("IUriIdentityService")}),define(ve[223],we([0,1,7,2,4,27,35,17,13,48]),function(ee,e,k,n,w,C,T,D,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let A=class extends n.Disposable{constructor(E,S,u,b,f){super();this.extensionsManagementService=E,this.logService=b,this.uriIdentityService=f,this._onDidChangeExtensionsByAnotherSource=this._register(new k.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(p=>{this.installedExtensions=p.map(m=>m.identifier),this.startTimestamp=Date.now()}),this._register(E.onInstallExtension(p=>this.onInstallExtension(p))),this._register(E.onDidInstallExtensions(p=>this.onDidInstallExtensions(p))),this._register(E.onDidUninstallExtension(p=>this.onDidUninstallExtension(p)));const d=w.URI.file(u.extensionsPath);this._register(S.watch(d)),this._register(k.Event.filter(S.onDidFilesChange,p=>p.rawChanges.some(m=>this.doesChangeAffects(m,d)))(()=>this.onDidChange()))}doesChangeAffects(E,S){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(E.resource),S)?this.uriIdentityService.extUri.isEqual(E.resource,this.uriIdentityService.extUri.joinPath(S,".obsolete"))?!0:!(E.type!==1&&E.type!==2||this.uriIdentityService.extUri.basename(E.resource).startsWith(".")):!1}onInstallExtension(E){this.addInstallingExtension(E.identifier)}onDidInstallExtensions(E){for(const S of E)this.removeInstallingExtension(S.identifier),S.local&&this.addInstalledExtension(S.identifier)}onDidUninstallExtension(E){E.error||this.removeInstalledExtension(E.identifier)}addInstallingExtension(E){this.removeInstallingExtension(E),this.installingExtensions.push(E)}removeInstallingExtension(E){this.installingExtensions=this.installingExtensions.filter(S=>!(0,T.areSameExtensions)(S,E))}addInstalledExtension(E){this.installedExtensions&&(this.removeInstalledExtension(E),this.installedExtensions.push(E))}removeInstalledExtension(E){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(S=>!(0,T.areSameExtensions)(S,E)))}async onDidChange(){if(this.installedExtensions){const E=await this.extensionsManagementService.getInstalled(),S=E.filter(b=>[...this.installingExtensions,...this.installedExtensions].some(f=>(0,T.areSameExtensions)(f,b.identifier))?!1:b.installedTimestamp&&b.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",b.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",b.identifier.id),!1)),u=this.installedExtensions.filter(b=>this.installingExtensions.some(f=>(0,T.areSameExtensions)(f,b))?!1:E.every(f=>!(0,T.areSameExtensions)(f.identifier,b))?(this.logService.info("Detected extension removed from another source",b.id),!0):!1);this.installedExtensions=E.map(b=>b.identifier),(S.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:S,removed:u})}}};A=Ae([Oe(1,D.IFileService),Oe(2,C.INativeEnvironmentService),Oe(3,v.ILogService),Oe(4,P.IUriIdentityService)],A),e.ExtensionsWatcher=A}),define(ve[102],we([0,1,48,180,17,20,122,7,2]),function(ee,e,k,n,w,C,T,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class P{constructor(E){this.uri=E,this.time=P._clock++}touch(){return this.time=P._clock++,this}}P._clock=0;let A=class{constructor(E){this._fileService=E,this._dispooables=new v.DisposableStore,this._limit=2**16;const S=new Map,u=b=>{let f=S.get(b.scheme);return f===void 0&&(f=E.hasProvider(b)&&!this._fileService.hasCapability(b,1024),S.set(b.scheme,f)),f};this._dispooables.add(D.Event.any(E.onDidChangeFileSystemProviderRegistrations,E.onDidChangeFileSystemProviderCapabilities)(b=>{S.delete(b.scheme)})),this.extUri=new C.ExtUri(u),this._canonicalUris=new T.SkipList((b,f)=>this.extUri.compare(b,f,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(E){this._fileService.hasProvider(E)&&(E=(0,C.normalizePath)(E));let S=this._canonicalUris.get(E);return S?S.touch().uri.with({fragment:E.fragment}):(this._canonicalUris.set(E,new P(E)),this._checkTrim(),E)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const E=[...this._canonicalUris.entries()].sort((u,b)=>u[1].touch<b[1].touch?1:u[1].touch>b[1].touch?-1:0);P._clock=0,this._canonicalUris.clear();const S=this._limit*.5;for(let u=0;u<S;u++)this._canonicalUris.set(E[u][0],E[u][1].touch())}};A=Ae([Oe(0,w.IFileService)],A),e.UriIdentityService=A,(0,n.registerSingleton)(k.IUriIdentityService,A,!0)}),define(ve[103],we([0,1,165,5,31,20,4,6,8]),function(ee,e,k,n,w,C,T,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");function P(i){const t=i;return typeof t?.id=="string"&&T.URI.isUri(t.uri)}e.isSingleFolderWorkspaceIdentifier=P;function A(i){if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=A;function R(i){const t=i;return typeof t?.id=="string"&&T.URI.isUri(t.configPath)}e.isWorkspaceIdentifier=R;function E(i){const t=i;if(t?.uri)return{id:t.id,uri:T.URI.revive(t.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:T.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=E;var S;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(S=e.WorkbenchState||(e.WorkbenchState={}));function u(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.isWorkspace=u;function b(i){const t=i;return!!(t&&typeof t=="object"&&T.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.isWorkspaceFolder=b;class f{constructor(t,r,s,a,h){this._id=t,this._transient=s,this._configuration=a,this._ignorePathCasing=h,this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=r}update(t){this._id=t.id,this._configuration=t.configuration,this._transient=t.transient,this._ignorePathCasing=t._ignorePathCasing,this.folders=t.folders}get folders(){return this._folders}set folders(t){this._folders=t,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(t){this._configuration=t}getFolder(t){return t&&this._foldersMap.findSubstr(t.with({scheme:t.scheme,authority:t.authority,path:t.path}))||null}updateFoldersMap(){this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing);for(const t of this.folders)this._foldersMap.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class d{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,C.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function p(i){return new d({uri:i,index:0,name:(0,C.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=p,e.WORKSPACE_EXTENSION="code-workspace";const m=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function y(i,t){return C.extUriBiasedIgnorePathCase.isEqualOrParent(i,t.untitledWorkspacesHome)}e.isUntitledWorkspace=y;function c(i){let t;return T.URI.isUri(i)?t=i:t=i.configuration,t?.scheme===v.Schemas.tmp}e.isTemporaryWorkspace=c;function o(i,t){return!y(i,t)&&!c(i)}e.isSavedWorkspace=o;function l(i){return(typeof i=="string"?(0,n.extname)(i):(0,C.extname)(i))===m}e.hasWorkspaceFileExtension=l}),define(ve[104],we([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStatusService=e.IExtensionHostStatusService=void 0,e.IExtensionHostStatusService=(0,k.createDecorator)("extensionHostStatusService");class n{constructor(){this._exitInfo=new Map}setExitInfo(C,T){this._exitInfo.set(C,T)}getExitInfo(C){return this._exitInfo.get(C)||null}}e.ExtensionHostStatusService=n}),define(ve[224],we([0,1,7,14]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=e.printTime=void 0;function w(T){let D=0,v=0,P=0;T>=1e3&&(P=Math.floor(T/1e3),T-=P*1e3),P>=60&&(v=Math.floor(P/60),P-=v*60),v>=60&&(D=Math.floor(v/60),v-=D*60);const A=D?`${D}h`:"",R=v?`${v}m`:"",E=P?`${P}s`:"",S=T?`${T}ms`:"";return`${A}${R}${E}${S}`}e.printTime=w;class C{constructor(D,v,P,A){this._logService=D,this._reconnectionToken=v,this._onClose=new k.Emitter,this.onClose=this._onClose.event,this._reconnectionGraceTime=108e5,this._reconnectionShortGraceTime=3e5,this._remoteAddress=P,this.protocol=A,this._disposed=!1,this._disconnectRunner1=new n.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection grace time of ${w(this._reconnectionGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionGraceTime),this._disconnectRunner2=new n.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection short grace time of ${w(this._reconnectionShortGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionShortGraceTime),this.protocol.onDidDispose(()=>{this._log("The client has disconnected gracefully, so the connection will be disposed."),this._cleanResources()}),this.protocol.onSocketClose(()=>{this._log(`The client has disconnected, will wait for reconnection ${w(this._reconnectionGraceTime)} before disposing...`),this._disconnectRunner1.schedule()}),this._log("New connection established.")}_log(D){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ManagementConnection] ${D}`)}shortenReconnectionGraceTimeIfNecessary(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&(this._log(`Another client has connected, will shorten the wait for reconnection ${w(this._reconnectionShortGraceTime)} before disposing...`),this._disconnectRunner2.schedule())}_cleanResources(){if(this._disposed)return;this._disposed=!0,this._disconnectRunner1.dispose(),this._disconnectRunner2.dispose();const D=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),D.end(),this._onClose.fire(void 0)}acceptReconnection(D,v,P){this._remoteAddress=D,this._log("The client has reconnected."),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel(),this.protocol.beginAcceptReconnection(v,P),this.protocol.endAcceptReconnection()}}e.ManagementConnection=C}),define(ve[105],we([0,1,29,8,5,130,45]),function(ee,e,k,n,w,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const D=w.join(n.FileAccess.asFileUri("",ee).fsPath,"nls.metadata.json"),v=new Map;function P(E){return new Promise(S=>k.exists(E,S))}function A(E,S){return P(D).then(u=>{if(!u||!T.default.commit)return Promise.resolve({locale:"en",availableLanguages:{}});let b=`${E}||${S}`,f=v.get(b);return f||(f=C.getNLSConfiguration(T.default.commit,S,D,E).then(d=>(R.is(d)&&(d._languagePackSupport=!0),d)),v.set(b,f)),f})}e.getNLSConfiguration=A;var R;(function(E){function S(u){let b=u;return b&&typeof b._languagePackId=="string"}E.is=S})(R=e.InternalNLSConfiguration||(e.InternalNLSConfiguration={}))}),define(ve[225],we([0,1,226,29,5,23,8,19]),function(ee,e,k,n,w,C,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.requestHasValidConnectionToken=e.determineServerConnectionToken=e.parseServerConnectionToken=e.ServerConnectionTokenParseError=e.MandatoryServerConnectionToken=e.OptionalServerConnectionToken=e.NoneServerConnectionToken=e.ServerConnectionTokenType=void 0;const v=/^[0-9A-Za-z-]+$/;var P;(function(d){d[d.None=0]="None",d[d.Optional=1]="Optional",d[d.Mandatory=2]="Mandatory"})(P=e.ServerConnectionTokenType||(e.ServerConnectionTokenType={}));class A{constructor(){this.type=0}validate(p){return!0}}e.NoneServerConnectionToken=A;class R{constructor(p){this.value=p,this.type=1}validate(p){return p===this.value}}e.OptionalServerConnectionToken=R;class E{constructor(p){this.value=p,this.type=2}validate(p){return p===this.value}}e.MandatoryServerConnectionToken=E;class S{constructor(p){this.message=p}}e.ServerConnectionTokenParseError=S;async function u(d,p){const m=d["without-connection-token"],y=d["connection-token"],c=d["connection-token-file"],o=d.compatibility==="1.63";if(m)return typeof y!="undefined"||typeof c!="undefined"?new S("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new A;if(typeof c!="undefined"){if(typeof y!="undefined")return new S("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let l;try{l=n.readFileSync(c).toString().replace(/\r?\n$/,"")}catch{return new S(`Unable to read the connection token file at '${c}'.`)}return v.test(l)?new E(l):new S(`The connection token defined in '${c} does not adhere to the characters 0-9, a-z, A-Z or -.`)}return typeof y!="undefined"?v.test(y)?o?new R(y):new E(y):new S(`The connection token '${y} does not adhere to the characters 0-9, a-z, A-Z or -.`):o?(console.log("Breaking change in the next release: Please use one of the following arguments: '--connection-token', '--connection-token-file' or '--without-connection-token'."),new R(await p())):new E(await p())}e.parseServerConnectionToken=u;async function b(d){return u(d,async()=>{if(!d["user-data-dir"])return(0,C.generateUuid)();const m=w.join(d["user-data-dir"],"token");try{const o=(await D.Promises.readFile(m)).toString().replace(/\r?\n$/,"");if(v.test(o))return o}catch{}const y=(0,C.generateUuid)();try{await D.Promises.writeFile(m,y,{mode:384})}catch{}return y})}e.determineServerConnectionToken=b;function f(d,p,m){if(d.validate(m.query[T.connectionTokenQueryName]))return!0;const y=k.parse(p.headers.cookie||"");return d.validate(y[T.connectionTokenCookieName])}e.requestHasValidConnectionToken=f}),define(ve[42],we([0,1,167,177,52,6,27]),function(ee,e,k,n,w,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={host:{type:"string",cat:"o",args:"ip-address",description:k.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:k.localize(1,null)},"pick-port":{type:"string",deprecationMessage:"Use the range notation in 'port' instead."},"socket-path":{type:"string",cat:"o",args:"path",description:k.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:k.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:k.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:k.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:k.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:k.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:k.localize(8,null)},"user-data-dir":w.OPTIONS["user-data-dir"],driver:w.OPTIONS.driver,"disable-telemetry":w.OPTIONS["disable-telemetry"],"disable-workspace-trust":w.OPTIONS["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:w.OPTIONS.log,logsPath:w.OPTIONS.logsPath,"force-disable-user-env":w.OPTIONS["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:k.localize(9,null)},"default-workspace":{type:"string",description:k.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"extensions-dir":w.OPTIONS["extensions-dir"],"extensions-download-dir":w.OPTIONS["extensions-download-dir"],"builtin-extensions-dir":w.OPTIONS["builtin-extensions-dir"],"install-extension":w.OPTIONS["install-extension"],"install-builtin-extension":w.OPTIONS["install-builtin-extension"],"uninstall-extension":w.OPTIONS["uninstall-extension"],"list-extensions":w.OPTIONS["list-extensions"],"locate-extension":w.OPTIONS["locate-extension"],"show-versions":w.OPTIONS["show-versions"],category:w.OPTIONS.category,force:w.OPTIONS.force,"do-not-sync":w.OPTIONS["do-not-sync"],"pre-release":w.OPTIONS["pre-release"],"start-server":{type:"boolean",cat:"e",description:k.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:w.OPTIONS.help,version:w.OPTIONS.version,compatibility:{type:"string"},_:w.OPTIONS._},e.IServerEnvironmentService=(0,C.refineServiceDecorator)(T.IEnvironmentService);class D extends n.NativeEnvironmentService{get args(){return super.args}}e.ServerEnvironmentService=D}),define(ve[227],we([0,1,29,80,69,132,226,68,33,60,3,13,42,5,8,23,28,47,21,4,16,12]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E,S,u,b,f,d,p,m,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebClientServer=e.serveFile=e.serveError=void 0;const o={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function l(s,a,h,g){a.writeHead(h,{"Content-Type":"text/plain"}),a.end(g)}e.serveError=l;async function i(s,a,h,g,_=Object.create(null)){try{const F=await C.promisify(k.stat)(g),$=`W/"${[F.ino,F.size,F.mtime.getTime()].join("-")}"`;if(a.headers["if-none-match"]===$)return h.writeHead(304),h.end();_["Content-Type"]=o[(0,S.extname)(g)]||(0,P.getMediaMime)(g)||"text/plain",_.Etag=$,h.writeHead(200,_),k.createReadStream(g).pipe(h)}catch(F){return F.code!=="ENOENT"&&(s.error(F),console.error(F.toString())),h.writeHead(404,{"Content-Type":"text/plain"}),h.end("Not found")}}e.serveFile=i;const t=(0,S.dirname)(u.FileAccess.asFileUri("",ee).fsPath);let r=class{constructor(a,h,g,_,F){this._connectionToken=a,this._environmentService=h,this._logService=g,this._requestService=_,this._productService=F,this._webExtensionResourceUrlTemplate=this._productService.extensionsGallery?.resourceUrlTemplate?m.URI.parse(this._productService.extensionsGallery.resourceUrlTemplate):void 0}async handle(a,h,g){try{const _=g.pathname;return _==="/favicon.ico"||_==="/manifest.json"||_==="/code-192.png"||_==="/code-512.png"?i(this._logService,a,h,(0,S.join)(t,"resources","server",_.substr(1))):/^\/static\//.test(_)?this._handleStatic(a,h,g):_==="/"?this._handleRoot(a,h,g):_==="/callback"?this._handleCallback(h):/^\/web-extension-resource\//.test(_)?this._handleWebExtensionResource(a,h,g):l(a,h,404,"Not found.")}catch(_){return this._logService.error(_),console.error(_.toString()),l(a,h,500,"Internal Server Error.")}}async _handleStatic(a,h,g){const _=Object.create(null),F=decodeURIComponent(g.pathname),$=(0,S.normalize)(F.substr("/static/".length)),K=(0,S.join)(t,$);return(0,v.isEqualOrParent)(K,t,!A.isLinux)?i(this._logService,a,h,K,_):l(a,h,400,"Bad request.")}_getResourceURLTemplateAuthority(a){const h=a.authority.indexOf(".");return h!==-1?a.authority.substring(h+1):void 0}async _handleWebExtensionResource(a,h,g){if(!this._webExtensionResourceUrlTemplate)return l(a,h,500,"No extension gallery service configured.");const _=decodeURIComponent(g.pathname),F=(0,S.normalize)(_.substr("/web-extension-resource/".length)),$=m.URI.parse(F).with({scheme:this._webExtensionResourceUrlTemplate.scheme,authority:F.substring(0,F.indexOf("/")),path:F.substring(F.indexOf("/")+1)});if(this._getResourceURLTemplateAuthority(this._webExtensionResourceUrlTemplate)!==this._getResourceURLTemplateAuthority($))return l(a,h,403,"Request Forbidden");const K={},I=U=>{const z=a.headers[U];z&&((0,c.isString)(z)||z[0])?K[U]=(0,c.isString)(z)?z:z[0]:U!==U.toLowerCase()&&I(U.toLowerCase())};I("X-Client-Name"),I("X-Client-Version"),I("X-Machine-Id"),I("X-Client-Commit");const W=await this._requestService.request({type:"GET",url:$.toString(!0),headers:K},p.CancellationToken.None),M=W.res.statusCode||500;if(M!==200){let U=null;try{U=await(0,d.asText)(W)}catch{}return l(a,h,M,U||`Request failed with status ${M}`)}const q=Object.create(null),Z=U=>{const z=W.res.headers[U];z?q[U]=z:U!==U.toLowerCase()&&Z(U.toLowerCase())};Z("Cache-Control"),Z("Content-Type"),h.writeHead(200,q);const H=await(0,y.streamToBuffer)(W.stream);return h.end(H.buffer)}async _handleRoot(a,h,g){if(!a.headers.host)return l(a,h,400,"Bad request.");const _=g.query[u.connectionTokenQueryName];if(typeof _=="string"){const U=Object.create(null);U["Set-Cookie"]=T.serialize(u.connectionTokenCookieName,_,{sameSite:"lax",maxAge:60*60*24*7});const z=Object.create(null);for(let ie in g.query)ie!==u.connectionTokenQueryName&&(z[ie]=g.query[ie]);const Q=w.format({pathname:"/",query:z});return U.Location=Q,h.writeHead(302,U),h.end()}const F=a.headers.host;function $(U){return U.replace(/"/g,"&quot;")}let K;this._environmentService.driverHandle&&(K=!1);const I=U=>U&&m.URI.file(n.resolve(U)).with({scheme:u.Schemas.vscodeRemote,authority:F}),W=u.FileAccess.asFileUri(this._environmentService.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html",ee).fsPath,M=!this._environmentService.isBuilt&&this._environmentService.args["github-auth"]?{id:(0,b.generateUuid)(),providerId:"github",accessToken:this._environmentService.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,q=(await C.promisify(k.readFile)(W)).toString().replace("{{WORKBENCH_WEB_CONFIGURATION}}",$(JSON.stringify({remoteAuthority:F,_wrapWebWorkerExtHostInIframe:K,developmentOptions:{enableSmokeTestDriver:this._environmentService.driverHandle==="web"?!0:void 0},settingsSyncOptions:!this._environmentService.isBuilt&&this._environmentService.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this._environmentService.args["disable-workspace-trust"],folderUri:I(this._environmentService.args["default-folder"]),workspaceUri:I(this._environmentService.args["default-workspace"]),productConfiguration:{embedderIdentifier:"server-distro",extensionsGallery:this._webExtensionResourceUrlTemplate?{...this._productService.extensionsGallery,resourceUrlTemplate:this._webExtensionResourceUrlTemplate.with({scheme:"http",authority:F,path:`web-extension-resource/${this._webExtensionResourceUrlTemplate.authority}${this._webExtensionResourceUrlTemplate.path}`}).toString(!0)}:void 0}}))).replace("{{WORKBENCH_AUTH_SESSION}}",()=>M?$(JSON.stringify(M)):""),Z=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this._getScriptCspHashes(q).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=' http://${F};`,"child-src 'self';","frame-src 'self' https://*.vscode-webview.net data:;","worker-src 'self' data:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" "),H={"Content-Type":"text/html","Content-Security-Policy":Z};return this._connectionToken.type!==0&&(H["Set-Cookie"]=T.serialize(u.connectionTokenCookieName,this._connectionToken.value,{sameSite:"lax",maxAge:60*60*24*7})),h.writeHead(200,H),h.end(q)}_getScriptCspHashes(a){const h=/<script>([\s\S]+?)<\/script>/img,g=[];let _;for(;_=h.exec(a);){const F=D.createHash("sha256"),$=_[1].replace(/\r\n/g,`
`),K=F.update(Buffer.from($)).digest().toString("base64");g.push(`'sha256-${K}'`)}return g}async _handleCallback(a){const h=u.FileAccess.asFileUri("vs/code/browser/workbench/callback.html",ee).fsPath,g=(await C.promisify(k.readFile)(h)).toString(),_=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this._getScriptCspHashes(g).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return a.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":_}),a.end(g)}};r=Ae([Oe(1,E.IServerEnvironmentService),Oe(2,R.ILogService),Oe(3,d.IRequestService),Oe(4,f.IProductService)],r),e.WebClientServer=r}),define(ve[228],we([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,k.createDecorator)("IExtHostRpcService");class n{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=n}),define(ve[106],we([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var k;(function(p){p[p.Upsert=0]="Upsert",p[p.RemoveChild=1]="RemoveChild",p[p.Invalidated=2]="Invalidated",p[p.SetProp=3]="SetProp",p[p.Bulk=4]="Bulk"})(k=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const n=new WeakMap,w=(p,m)=>{const y={controllerId:m};return n.set(p,y),y};e.createPrivateApiFor=w;const C=p=>n.get(p);e.getPrivateApiFor=C;const T=(p,m,y,c)=>{let o=y;return{enumerable:!0,configurable:!1,get(){return o},set(l){if(!c(o,l)){const i=o;o=l,p.listener?.({op:3,key:m,value:l,previous:i})}}}},D=(p,m)=>p===m,v={range:(p,m)=>p===m?!0:!p||!m?!1:p.isEqual(m),label:D,description:D,sortText:D,busy:D,error:D,canResolveChildren:D,tags:(p,m)=>!(p.length!==m.length||p.some(y=>!m.find(c=>y.id===c.id)))},P=Object.keys(v),A=(p,m)=>({range:T(p,"range",void 0,v.range),label:T(p,"label",m,v.label),description:T(p,"description",void 0,v.description),sortText:T(p,"sortText",void 0,v.sortText),canResolveChildren:T(p,"canResolveChildren",!1,v.canResolveChildren),busy:T(p,"busy",!1,v.busy),error:T(p,"error",void 0,v.error),tags:T(p,"tags",[],v.tags)}),R=(p,m)=>{const y=new Map;for(const c of P)v[c](p[c],m[c])||y.set(c,m[c]);return y};e.diffTestItems=R;class E extends Error{constructor(m){super(`Attempted to insert a duplicate test item ID ${m}`)}}e.DuplicateTestItemError=E;class S extends Error{constructor(m){super(`TestItem with ID "${m}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=S;class u extends Error{constructor(m,y,c){super(`TestItem with ID "${m}" is from controller "${y}" and cannot be added as a child of an item from controller "${c}".`)}}e.MixedTestItemController=u;const b=p=>{const m=(0,e.getPrivateApiFor)(p);let y=new Map;return{get size(){return y.size},forEach(c,o){for(const l of y.values())c.call(o,l,this)},replace(c){const o=new Map,l=new Set(y.keys()),i={op:4,ops:[]};for(const t of c){if(!(t instanceof f))throw new S(t.id);const r=(0,e.getPrivateApiFor)(t).controllerId;if(r!==m.controllerId)throw new u(t.id,r,m.controllerId);if(o.has(t.id))throw new E(t.id);o.set(t.id,t),l.delete(t.id),i.ops.push({op:0,item:t})}for(const t of l.keys())i.ops.push({op:1,id:t});m.listener?.(i),y=o},add(c){if(!(c instanceof f))throw new S(c.id);y.set(c.id,c),m.listener?.({op:0,item:c})},delete(c){y.delete(c)&&m.listener?.({op:1,id:c})},get(c){return y.get(c)},toJSON(){return Array.from(y.values())},[Symbol.iterator](){return y.values()}}};class f{constructor(m,y,c,o){if(y.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(y)} symbol`);const l=(0,e.createPrivateApiFor)(this,m);Object.defineProperties(this,{id:{value:y,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return l.parent instanceof d?void 0:l.parent}},children:{value:b(this),enumerable:!0,writable:!1},...A(l,c)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=f;class d extends f{constructor(m,y){super(m,m,y,void 0)}}e.TestItemRootImpl=d});var bt=this&&this.__classPrivateFieldSet||function(ee,e,k,n,w){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!w:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?w.call(ee,k):w?w.value=k:e.set(ee,k),k},et=this&&this.__classPrivateFieldGet||function(ee,e,k,n){if(k==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!n:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?n:k==="a"?n.call(ee):n?n.value:e.get(ee)};define(ve[107],we([0,1,18,9,78,31,60,15,12,4,23,17,96]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E){"use strict";var S,u,b,f,d,p,m,y,c,o,l,i,t,r,s,a,h,g,_,F;Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function $(N){function L(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(L,N),Object.setPrototypeOf(L.prototype,N.prototype),L}let K=d=class{constructor(L){S.set(this,void 0),bt(this,S,L,"f")}static from(...L){let te=L;return new d(function(){if(te){for(const Se of te)Se&&typeof Se.dispose=="function"&&Se.dispose();te=void 0}})}dispose(){typeof et(this,S,"f")=="function"&&(et(this,S,"f").call(this),bt(this,S,void 0,"f"))}};S=new WeakMap,K=d=Ae([$],K),e.Disposable=K;let I=p=class{constructor(L,te){if(L<0)throw(0,n.illegalArgument)("line must be non-negative");if(te<0)throw(0,n.illegalArgument)("character must be non-negative");this._line=L,this._character=te}static Min(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let Se=1;Se<L.length;Se++){const ze=L[Se];ze.isBefore(te)&&(te=ze)}return te}static Max(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let Se=1;Se<L.length;Se++){const ze=L[Se];ze.isAfter(te)&&(te=ze)}return te}static isPosition(L){if(!L)return!1;if(L instanceof p)return!0;let{line:te,character:Se}=L;return typeof te=="number"&&typeof Se=="number"}static of(L){if(L instanceof p)return L;if(this.isPosition(L))return new p(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,te=0){if(L===null||te===null)throw(0,n.illegalArgument)();let Se;return typeof L=="undefined"?Se=0:typeof L=="number"?Se=L:(Se=typeof L.lineDelta=="number"?L.lineDelta:0,te=typeof L.characterDelta=="number"?L.characterDelta:0),Se===0&&te===0?this:new p(this.line+Se,this.character+te)}with(L,te=this.character){if(L===null||te===null)throw(0,n.illegalArgument)();let Se;return typeof L=="undefined"?Se=this.line:typeof L=="number"?Se=L:(Se=typeof L.line=="number"?L.line:this.line,te=typeof L.character=="number"?L.character:this.character),Se===this.line&&te===this.character?this:new p(Se,te)}toJSON(){return{line:this.line,character:this.character}}};I=p=Ae([$],I),e.Position=I;let W=m=class{constructor(L,te,Se,ze){let xe,Xe;if(typeof L=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof ze=="number"?(xe=new I(L,te),Xe=new I(Se,ze)):I.isPosition(L)&&I.isPosition(te)&&(xe=I.of(L),Xe=I.of(te)),!xe||!Xe)throw new Error("Invalid arguments");xe.isBefore(Xe)?(this._start=xe,this._end=Xe):(this._start=Xe,this._end=xe)}static isRange(L){return L instanceof m?!0:L?I.isPosition(L.start)&&I.isPosition(L.end):!1}static of(L){if(L instanceof m)return L;if(this.isRange(L))return new m(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(L){return m.isRange(L)?this.contains(L.start)&&this.contains(L.end):I.isPosition(L)?!(I.of(L).isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const te=I.Max(L.start,this._start),Se=I.Min(L.end,this._end);if(!te.isAfter(Se))return new m(te,Se)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const te=I.Min(L.start,this._start),Se=I.Max(L.end,this.end);return new m(te,Se)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,te=this.end){if(L===null||te===null)throw(0,n.illegalArgument)();let Se;return L?I.isPosition(L)?Se=L:(Se=L.start||this.start,te=L.end||this.end):Se=this.start,Se.isEqual(this._start)&&te.isEqual(this.end)?this:new m(Se,te)}toJSON(){return[this.start,this.end]}};W=m=Ae([$],W),e.Range=W;let M=y=class extends W{constructor(L,te,Se,ze){let xe,Xe;if(typeof L=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof ze=="number"?(xe=new I(L,te),Xe=new I(Se,ze)):I.isPosition(L)&&I.isPosition(te)&&(xe=I.of(L),Xe=I.of(te)),!xe||!Xe)throw new Error("Invalid arguments");super(xe,Xe);this._anchor=xe,this._active=Xe}static isSelection(L){return L instanceof y?!0:L?W.isRange(L)&&I.isPosition(L.anchor)&&I.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};M=y=Ae([$],M),e.Selection=M;class q{constructor(L,te,Se){if(typeof L!="string"||L.length===0)throw(0,n.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,n.illegalArgument)("port");if(typeof Se!="undefined"&&(typeof Se!="string"||Se.length===0||!/^[0-9A-Za-z\-]+$/.test(Se)))throw(0,n.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(te),this.connectionToken=Se}}e.ResolvedAuthority=q;class Z extends Error{constructor(L,te=E.RemoteAuthorityResolverErrorCode.Unknown,Se){super(L);this._message=L,this._code=te,this._detail=Se,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,Z.prototype)}static NotAvailable(L,te){return new Z(L,E.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(L){return new Z(L,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=Z;var H;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(H=e.EndOfLine||(e.EndOfLine={}));var U;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(U=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let z=c=class{constructor(L,te){this._range=L,this._newText=te}static isTextEdit(L){return L instanceof c?!0:L?W.isRange(L)&&typeof L.newText=="string":!1}static replace(L,te){return new c(L,te)}static insert(L,te){return c.replace(new W(L,L),te)}static delete(L){return c.replace(L,"")}static setEndOfLine(L){const te=new c(new W(new I(0,0),new I(0,0)),"");return te.newEol=L,te}get range(){return this._range}set range(L){if(L&&!W.isRange(L))throw(0,n.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,n.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,n.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};z=c=Ae([$],z),e.TextEdit=z;var Q;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(Q=e.FileEditType||(e.FileEditType={}));let ie=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,te,Se,ze){this._edits.push({_type:1,from:L,to:te,options:Se,metadata:ze})}createFile(L,te,Se){this._edits.push({_type:1,from:void 0,to:L,options:te,metadata:Se})}deleteFile(L,te,Se){this._edits.push({_type:1,from:L,to:void 0,options:te,metadata:Se})}replaceNotebookMetadata(L,te,Se){this._edits.push({_type:3,metadata:Se,uri:L,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(L,te,Se,ze,xe){let Xe,Je,rt=[],ot;if(Tt.isNotebookRange(te)&&Ct.isNotebookCellDataArray(Se)&&!Ct.isNotebookCellDataArray(ze)?(Xe=te.start,Je=te.end,rt=Se,ot=ze):typeof te=="number"&&typeof Se=="number"&&Ct.isNotebookCellDataArray(ze)&&(Xe=te,Je=Se,rt=ze,ot=xe),Xe===void 0||Je===void 0)throw new Error("Invalid arguments");(Xe!==Je||rt.length>0)&&this._edits.push({_type:5,uri:L,index:Xe,count:Je-Xe,cells:rt,metadata:ot})}replaceNotebookCellMetadata(L,te,Se,ze){this._edits.push({_type:3,metadata:ze,uri:L,edit:{editType:8,index:te,metadata:Se}})}replace(L,te,Se,ze){this._edits.push({_type:2,uri:L,edit:new z(te,Se),metadata:ze})}insert(L,te,Se,ze){this.replace(L,new W(te,te),Se,ze)}delete(L,te,Se){this.replace(L,te,"",Se)}has(L){return this._edits.some(te=>te._type===2&&te.uri.toString()===L.toString())}set(L,te){if(te)for(const Se of te)Se&&this._edits.push({_type:2,uri:L,edit:Se});else{for(let Se=0;Se<this._edits.length;Se++){const ze=this._edits[Se];ze._type===2&&ze.uri.toString()===L.toString()&&(this._edits[Se]=void 0)}(0,k.coalesceInPlace)(this._edits)}}get(L){const te=[];for(let Se of this._edits)Se._type===2&&Se.uri.toString()===L.toString()&&te.push(Se.edit);return te}entries(){const L=new C.ResourceMap;for(let te of this._edits)if(te._type===2){let Se=L.get(te.uri);Se||(Se=[te.uri,[]],L.set(te.uri,Se)),Se[1].push(te.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ie=Ae([$],ie),e.WorkspaceEdit=ie;let re=o=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof o?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=o._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,te=this._tabstop++){if(typeof L=="function"){const Se=new o;Se._tabstop=this._tabstop,L(Se),this._tabstop=Se._tabstop,L=Se.value}else L=o._escape(L);return this.value+="${",this.value+=te,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,te=this._tabstop++){const Se=L.map(ze=>ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(L,te){if(typeof te=="function"){const Se=new o;Se._tabstop=this._tabstop,te(Se),this._tabstop=Se._tabstop,te=Se.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,te&&(this.value+=":",this.value+=te),this.value+="}",this}};re=o=Ae([$],re),e.SnippetString=re;var ce;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(ce=e.DiagnosticTag||(e.DiagnosticTag={}));var de;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(de=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let he=l=class{constructor(L,te){if(this.uri=L,te)if(W.isRange(te))this.range=W.of(te);else if(I.isPosition(te))this.range=new W(te,te);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof l?!0:L?W.isRange(L.range)&&P.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};he=l=Ae([$],he),e.Location=he;let j=class{constructor(L,te){this.location=L,this.message=te}static is(L){return L?typeof L.message=="string"&&L.location&&W.isRange(L.location.range)&&P.URI.isUri(L.location.uri):!1}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.location.range.isEqual(te.location.range)&&L.location.uri.toString()===te.location.uri.toString()}};j=Ae([$],j),e.DiagnosticRelatedInformation=j;let O=class{constructor(L,te,Se=de.Error){if(!W.isRange(L))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=L,this.message=te,this.severity=Se}toJSON(){return{severity:de[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.severity===te.severity&&L.code===te.code&&L.severity===te.severity&&L.source===te.source&&L.range.isEqual(te.range)&&(0,k.equals)(L.tags,te.tags)&&(0,k.equals)(L.relatedInformation,te.relatedInformation,j.isEqual)}};O=Ae([$],O),e.Diagnostic=O;let V=class{constructor(L,te){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=te}};V=Ae([$],V),e.Hover=V;var J;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(J=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let le=class{constructor(L,te=J.Text){this.range=L,this.kind=te}toJSON(){return{range:this.range,kind:J[this.kind]}}};le=Ae([$],le),e.DocumentHighlight=le;var ge;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(ge=e.SymbolKind||(e.SymbolKind={}));var ue;(function(N){N[N.Deprecated=1]="Deprecated"})(ue=e.SymbolTag||(e.SymbolTag={}));let oe=i=class{constructor(L,te,Se,ze,xe){this.name=L,this.kind=te,this.containerName=xe,typeof Se=="string"&&(this.containerName=Se),ze instanceof he?this.location=ze:Se instanceof W&&(this.location=new he(ze,Se)),i.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:ge[this.kind],location:this.location,containerName:this.containerName}}};oe=i=Ae([$],oe),e.SymbolInformation=oe;let pe=t=class{constructor(L,te,Se,ze,xe){this.name=L,this.detail=te,this.kind=Se,this.range=ze,this.selectionRange=xe,this.children=[],t.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(t.validate)}};pe=t=Ae([$],pe),e.DocumentSymbol=pe;var X;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(X=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let B=class{constructor(L,te){this.title=L,this.kind=te}};B=Ae([$],B),e.CodeAction=B;let x=r=class{constructor(L){this.value=L}append(L){return new r(this.value?this.value+r.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+r.sep)}};x.sep=".",x=r=Ae([$],x),e.CodeActionKind=x,x.Empty=new x(""),x.QuickFix=x.Empty.append("quickfix"),x.Refactor=x.Empty.append("refactor"),x.RefactorExtract=x.Refactor.append("extract"),x.RefactorInline=x.Refactor.append("inline"),x.RefactorRewrite=x.Refactor.append("rewrite"),x.Source=x.Empty.append("source"),x.SourceOrganizeImports=x.Source.append("organizeImports"),x.SourceFixAll=x.Source.append("fixAll");let Y=class{constructor(L,te){if(this.range=L,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Y=Ae([$],Y),e.SelectionRange=Y;class fe{constructor(L,te,Se,ze,xe,Xe){this.kind=L,this.name=te,this.detail=Se,this.uri=ze,this.range=xe,this.selectionRange=Xe}}e.CallHierarchyItem=fe;class ye{constructor(L,te){this.fromRanges=te,this.from=L}}e.CallHierarchyIncomingCall=ye;class ke{constructor(L,te){this.fromRanges=te,this.to=L}}e.CallHierarchyOutgoingCall=ke;var Re;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})(Re=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ue=class{constructor(L,te){this.range=L,this.command=te}get isResolved(){return!!this.command}};Ue=Ae([$],Ue),e.CodeLens=Ue;let Ne=s=class{constructor(L,te=!1){u.set(this,void 0),bt(this,u,new w.MarkdownString(L,{supportThemeIcons:te}),"f")}static isMarkdownString(L){return L instanceof s?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return et(this,u,"f").value}set value(L){et(this,u,"f").value=L}get isTrusted(){return et(this,u,"f").isTrusted}set isTrusted(L){et(this,u,"f").isTrusted=L}get supportThemeIcons(){return et(this,u,"f").supportThemeIcons}set supportThemeIcons(L){et(this,u,"f").supportThemeIcons=L}get supportHtml(){return et(this,u,"f").supportHtml}set supportHtml(L){et(this,u,"f").supportHtml=L}get baseUri(){return et(this,u,"f").baseUri}set baseUri(L){et(this,u,"f").baseUri=L}appendText(L){return et(this,u,"f").appendText(L),this}appendMarkdown(L){return et(this,u,"f").appendMarkdown(L),this}appendCodeblock(L,te){return et(this,u,"f").appendCodeblock(te??"",L),this}};u=new WeakMap,Ne=s=Ae([$],Ne),e.MarkdownString=Ne;let se=class{constructor(L,te){this.label=L,this.documentation=te}};se=Ae([$],se),e.ParameterInformation=se;let Ee=class{constructor(L,te){this.label=L,this.documentation=te,this.parameters=[]}};Ee=Ae([$],Ee),e.SignatureInformation=Ee;let me=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};me=Ae([$],me),e.SignatureHelp=me;var Te;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(Te=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Fe;(function(N){N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(Fe=e.InlayHintKind||(e.InlayHintKind={}));let Ye=class{constructor(L){this.value=L}};Ye=Ae([$],Ye),e.InlayHintLabelPart=Ye;let Be=class{constructor(L,te,Se){this.position=L,this.label=te,this.kind=Se}};Be=Ae([$],Be),e.InlayHint=Be;var je;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(je=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ge;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(Ge=e.CompletionItemKind||(e.CompletionItemKind={}));var ne;(function(N){N[N.Deprecated=1]="Deprecated"})(ne=e.CompletionItemTag||(e.CompletionItemTag={}));let Ce=class{constructor(L,te){this.label=L,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&Ge[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ce=Ae([$],Ce),e.CompletionItem=Ce;let Pe=class{constructor(L=[],te=!1){this.items=L,this.isIncomplete=te}};Pe=Ae([$],Pe),e.CompletionList=Pe;let Le=class{constructor(L,te,Se){this.insertText=L,this.range=te,this.command=Se}};Le=Ae([$],Le),e.InlineSuggestion=Le;let Me=class{constructor(L){this.items=L}};Me=Ae([$],Me),e.InlineSuggestions=Me;let Ke=class{constructor(L,te,Se){this.insertText=L,this.range=te,this.command=Se}};Ke=Ae([$],Ke),e.InlineSuggestionNew=Ke;let $e=class{constructor(L){this.items=L}};$e=Ae([$],$e),e.InlineSuggestionsNew=$e;var He;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(He=e.ViewColumn||(e.ViewColumn={}));var Qe;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(Qe=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ve;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(Ve=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ze;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(Ze=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var it;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(it=e.TextEditorRevealType||(e.TextEditorRevealType={}));var st;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(st=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var tt;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(tt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var ut;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(ut=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function L(te){switch(te){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=L}(st=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ct=class{constructor(L,te){if(te&&!P.URI.isUri(te))throw(0,n.illegalArgument)("target");if(!W.isRange(L)||L.isEmpty)throw(0,n.illegalArgument)("range");this.range=L,this.target=te}};ct=Ae([$],ct),e.DocumentLink=ct;let ht=class{constructor(L,te,Se,ze){this.red=L,this.green=te,this.blue=Se,this.alpha=ze}};ht=Ae([$],ht),e.Color=ht;let wt=class{constructor(L,te){if(te&&!(te instanceof ht))throw(0,n.illegalArgument)("color");if(!W.isRange(L)||L.isEmpty)throw(0,n.illegalArgument)("range");this.range=L,this.color=te}};wt=Ae([$],wt),e.ColorInformation=wt;let St=class{constructor(L){if(!L||typeof L!="string")throw(0,n.illegalArgument)("label");this.label=L}};St=Ae([$],St),e.ColorPresentation=St;var Pt;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(Pt=e.ColorFormat||(e.ColorFormat={}));var kt;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(kt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class _t{constructor(L,te,Se){if(this.startIndex=L,this.length=te,this.tooltip=Se,typeof L!="number"||L<0)throw(0,n.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,n.illegalArgument)("length");if(Se!==void 0&&typeof Se!="string")throw(0,n.illegalArgument)("tooltip")}}e.TerminalLink=_t;var be;(function(N){N[N.Panel=1]="Panel",N[N.Editor=2]="Editor"})(be=e.TerminalLocation||(e.TerminalLocation={}));class Ie{constructor(L){this.options=L,typeof L!="object"&&(0,n.illegalArgument)("options")}}e.TerminalProfile=Ie;var ae;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(ae=e.TaskRevealKind||(e.TaskRevealKind={}));var G;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(G=e.TaskPanelKind||(e.TaskPanelKind={}));let De=a=class{constructor(L,te){if(this.label=te,typeof L!="string"||typeof te!="string")throw(0,n.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return a.Clean;case"build":return a.Build;case"rebuild":return a.Rebuild;case"test":return a.Test;default:return}}get id(){return this._id}};De.Clean=new a("clean","Clean"),De.Build=new a("build","Build"),De.Rebuild=new a("rebuild","Rebuild"),De.Test=new a("test","Test"),De=a=Ae([$],De),e.TaskGroup=De;function _e(N){let L="";for(let te=0;te<N.length;te++)L+=N[te].replace(/,/g,",,")+",";return L}let We=class{constructor(L,te,Se){if(typeof L!="string")throw(0,n.illegalArgument)("process");this._args=[],this._process=L,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=Se):this._options=te)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,n.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let te of this._args)L.push(te);return _e(L)}};We=Ae([$],We),e.ProcessExecution=We;let qe=class{constructor(L,te,Se){if(this._args=[],Array.isArray(te)){if(!L)throw(0,n.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,n.illegalArgument)("command");this._command=L,this._args=te,this._options=Se}else{if(typeof L!="string")throw(0,n.illegalArgument)("commandLine");this._commandLine=L,this._options=te}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,n.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,n.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)L.push(typeof te=="string"?te:te.value);return _e(L)}};qe=Ae([$],qe),e.ShellExecution=qe;var nt;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(nt=e.ShellQuoting||(e.ShellQuoting={}));var at;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(at=e.TaskScope||(e.TaskScope={}));class yt{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,A.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=yt;let lt=h=class{constructor(L,te,Se,ze,xe,Xe){this.__deprecated=!1,this._definition=this.definition=L;let Je;typeof te=="string"?(this._name=this.name=te,this._source=this.source=Se,this.execution=ze,Je=xe,this.__deprecated=!0):te===at.Global||te===at.Workspace?(this.target=te,this._name=this.name=Se,this._source=this.source=ze,this.execution=xe,Je=Xe):(this.target=te,this._name=this.name=Se,this._source=this.source=ze,this.execution=xe,Je=Xe),typeof Je=="string"?(this._problemMatchers=[Je],this._hasDefinedMatchers=!0):Array.isArray(Je)?(this._problemMatchers=Je,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof We?this._definition={type:h.ProcessType,id:this._execution.computeId()}:this._execution instanceof qe?this._definition={type:h.ShellType,id:this._execution.computeId()}:this._execution instanceof yt?this._definition={type:h.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:h.EmptyType,id:(0,A.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,n.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,n.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const te=this._definition.type;(h.EmptyType===te||h.ProcessType===te||h.ShellType===te||h.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,n.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};lt.ExtensionCallbackType="customExecution",lt.ProcessType="process",lt.ShellType="shell",lt.EmptyType="$empty",lt=h=Ae([$],lt),e.Task=lt;var ft;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(ft=e.ProgressLocation||(e.ProgressLocation={}));let dt=class{constructor(L,te=hn.None){this.collapsibleState=te,P.URI.isUri(L)?this.resourceUri=L:this.label=L}};dt=Ae([$],dt),e.TreeItem=dt;var hn;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(hn=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Nt=class{constructor(L){this.value=L}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}};Nt=Ae([$],Nt),e.DataTransferItem=Nt;let Mt=class{constructor(){this._items=new Map}get(L){return this._items.get(L)}set(L,te){this._items.set(L,te)}forEach(L){this._items.forEach(L)}};Mt=Ae([$],Mt),e.DataTransfer=Mt;let Et=class{constructor(L,te){this.id=L,this.color=te}};Et=Ae([$],Et),e.ThemeIcon=Et,Et.File=new Et("file"),Et.Folder=new Et("folder");let Ut=class{constructor(L){this.id=L}};Ut=Ae([$],Ut),e.ThemeColor=Ut;var mn;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(mn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Bt=class{constructor(L,te){if(typeof L!="string"&&(!L||!P.URI.isUri(L)&&!P.URI.isUri(L.uri)))throw(0,n.illegalArgument)("base");if(typeof te!="string")throw(0,n.illegalArgument)("pattern");typeof L=="string"?this.baseUri=P.URI.file(L):P.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=te}get base(){return this._base}set base(L){this._base=L,this._baseUri=P.URI.file(L)}get baseUri(){return this._baseUri}set baseUri(L){this._baseUri=L,this._base=L.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Bt=Ae([$],Bt),e.RelativePattern=Bt;let It=class{constructor(L,te,Se,ze){this.enabled=typeof L=="boolean"?L:!0,typeof te=="string"&&(this.condition=te),typeof Se=="string"&&(this.hitCondition=Se),typeof ze=="string"&&(this.logMessage=ze)}get id(){return this._id||(this._id=(0,A.generateUuid)()),this._id}};It=Ae([$],It),e.Breakpoint=It;let zt=class extends It{constructor(L,te,Se,ze,xe){super(te,Se,ze,xe);if(L===null)throw(0,n.illegalArgument)("location");this.location=L}};zt=Ae([$],zt),e.SourceBreakpoint=zt;let $t=class extends It{constructor(L,te,Se,ze,xe){super(te,Se,ze,xe);this.functionName=L}};$t=Ae([$],$t),e.FunctionBreakpoint=$t;let Wt=class extends It{constructor(L,te,Se,ze,xe,Xe,Je){super(ze,xe,Xe,Je);if(!te)throw(0,n.illegalArgument)("dataId");this.label=L,this.dataId=te,this.canPersist=Se}};Wt=Ae([$],Wt),e.DataBreakpoint=Wt;let jt=class{constructor(L,te,Se){this.command=L,this.args=te||[],this.options=Se}};jt=Ae([$],jt),e.DebugAdapterExecutable=jt;let Ht=class{constructor(L,te){this.port=L,this.host=te}};Ht=Ae([$],Ht),e.DebugAdapterServer=Ht;let qt=class{constructor(L){this.path=L}};qt=Ae([$],qt),e.DebugAdapterNamedPipeServer=qt;let Vt=class{constructor(L){this.implementation=L}};Vt=Ae([$],Vt),e.DebugAdapterInlineImplementation=Vt;let xt=class{constructor(L,te){this.range=L,this.expression=te}};xt=Ae([$],xt),e.EvaluatableExpression=xt;var gn;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(gn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var vn;(function(N){N[N.Invoke=0]="Invoke",N[N.Automatic=1]="Automatic"})(vn=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let Gt=class{constructor(L,te){this.range=L,this.text=te}};Gt=Ae([$],Gt),e.InlineValueText=Gt;let Kt=class{constructor(L,te,Se=!0){this.range=L,this.variableName=te,this.caseSensitiveLookup=Se}};Kt=Ae([$],Kt),e.InlineValueVariableLookup=Kt;let Qt=class{constructor(L,te){this.range=L,this.expression=te}};Qt=Ae([$],Qt),e.InlineValueEvaluatableExpression=Qt;let Yt=class{constructor(L,te){this.frameId=L,this.stoppedLocation=te}};Yt=Ae([$],Yt),e.InlineValueContext=Yt;var pn;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(pn=e.FileChangeType||(e.FileChangeType={}));let Xt=g=class extends Error{constructor(L,te=R.FileSystemProviderErrorCode.Unknown,Se){super(P.URI.isUri(L)?L.toString(!0):L);this.code=Se?.name??"Unknown",(0,R.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,g.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}static FileExists(L){return new g(L,R.FileSystemProviderErrorCode.FileExists,g.FileExists)}static FileNotFound(L){return new g(L,R.FileSystemProviderErrorCode.FileNotFound,g.FileNotFound)}static FileNotADirectory(L){return new g(L,R.FileSystemProviderErrorCode.FileNotADirectory,g.FileNotADirectory)}static FileIsADirectory(L){return new g(L,R.FileSystemProviderErrorCode.FileIsADirectory,g.FileIsADirectory)}static NoPermissions(L){return new g(L,R.FileSystemProviderErrorCode.NoPermissions,g.NoPermissions)}static Unavailable(L){return new g(L,R.FileSystemProviderErrorCode.Unavailable,g.Unavailable)}};Xt=g=Ae([$],Xt),e.FileSystemError=Xt;let Jt=class{constructor(L,te,Se){this.start=L,this.end=te,this.kind=Se}};Jt=Ae([$],Jt),e.FoldingRange=Jt;var wn;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(wn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var yn;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(yn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var En;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(En=e.CommentMode||(e.CommentMode={}));var bn;(function(N){N[N.Unresolved=0]="Unresolved",N[N.Resolved=1]="Resolved"})(bn=e.CommentThreadState||(e.CommentThreadState={}));class Sn{constructor(L,te=[]){this.tokenTypes=L,this.tokenModifiers=te}}e.SemanticTokensLegend=Sn;function Cn(N){return typeof N=="undefined"||(0,v.isStringArray)(N)}class Zt{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let te=0,Se=L.tokenTypes.length;te<Se;te++)this._tokenTypeStrToInt.set(L.tokenTypes[te],te);for(let te=0,Se=L.tokenModifiers.length;te<Se;te++)this._tokenModifierStrToInt.set(L.tokenModifiers[te],te)}}push(L,te,Se,ze,xe){if(typeof L=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof ze=="number"&&(typeof xe=="number"||typeof xe=="undefined"))return typeof xe=="undefined"&&(xe=0),this._pushEncoded(L,te,Se,ze,xe);if(W.isRange(L)&&typeof te=="string"&&Cn(Se))return this._push(L,te,Se);throw(0,n.illegalArgument)()}_push(L,te,Se){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const ze=L.start.line,xe=L.start.character,Xe=L.end.character-L.start.character,Je=this._tokenTypeStrToInt.get(te);let rt=0;if(Se)for(const ot of Se){if(!this._tokenModifierStrToInt.has(ot))throw new Error("`tokenModifier` is not in the provided legend");const gt=this._tokenModifierStrToInt.get(ot);rt|=1<<gt>>>0}this._pushEncoded(ze,xe,Xe,Je,rt)}_pushEncoded(L,te,Se,ze,xe){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const rt=this._data.length/5|0;let ot=0,gt=0;for(let vt=0;vt<rt;vt++){let pt=this._data[5*vt],Rt=this._data[5*vt+1];pt===0?(pt=ot,Rt+=gt):pt+=ot,this._data[5*vt]=pt,this._data[5*vt+1]=Rt,ot=pt,gt=Rt}}let Xe=L,Je=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Xe-=this._prevLine,Xe===0&&(Je-=this._prevChar)),this._data[this._dataLen++]=Xe,this._data[this._dataLen++]=Je,this._data[this._dataLen++]=Se,this._data[this._dataLen++]=ze,this._data[this._dataLen++]=xe,this._prevLine=L,this._prevChar=te}static _sortAndDeltaEncode(L){let te=[];const Se=L.length/5|0;for(let Je=0;Je<Se;Je++)te[Je]=Je;te.sort((Je,rt)=>{const ot=L[5*Je],gt=L[5*rt];if(ot===gt){const vt=L[5*Je+1],pt=L[5*rt+1];return vt-pt}return ot-gt});const ze=new Uint32Array(L.length);let xe=0,Xe=0;for(let Je=0;Je<Se;Je++){const rt=5*te[Je],ot=L[rt+0],gt=L[rt+1],vt=L[rt+2],pt=L[rt+3],Rt=L[rt+4],dn=ot-xe,ri=dn===0?gt-Xe:gt,At=5*Je;ze[At+0]=dn,ze[At+1]=ri,ze[At+2]=vt,ze[At+3]=pt,ze[At+4]=Rt,xe=ot,Xe=gt}return ze}build(L){return this._dataIsSortedAndDeltaEncoded?new en(new Uint32Array(this._data),L):new en(Zt._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=Zt;class en{constructor(L,te){this.resultId=te,this.data=L}}e.SemanticTokens=en;class In{constructor(L,te,Se){this.start=L,this.deleteCount=te,this.data=Se}}e.SemanticTokensEdit=In;class Dn{constructor(L,te){this.resultId=te,this.edits=L}}e.SemanticTokensEdits=Dn;var Pn;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(Pn=e.DebugConsoleMode||(e.DebugConsoleMode={}));let Lt=class{constructor(){}};Lt.Back={iconPath:new Et("arrow-left")},Lt=Ae([$],Lt),e.QuickInputButtons=Lt;var kn;(function(N){N[N.Separator=-1]="Separator",N[N.Default=0]="Default"})(kn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var _n;(function(N){N[N.Info=1]="Info",N[N.Warning=2]="Warning",N[N.Error=3]="Error"})(_n=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Tn;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Tn=e.ExtensionKind||(e.ExtensionKind={}));class Rn{constructor(L,te,Se){this.badge=L,this.tooltip=te,this.color=Se}static validate(L){if(L.badge){let te=(0,D.nextCharLength)(L.badge,0);if(te<L.badge.length&&(te+=(0,D.nextCharLength)(L.badge,te)),L.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Rn;let tn=class{constructor(L){this.kind=L}};tn=Ae([$],tn),e.ColorTheme=tn;var An;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast",N[N.HighContrastLight=4]="HighContrastLight"})(An=e.ColorThemeKind||(e.ColorThemeKind={}));class Tt{constructor(L,te){if(L<0)throw(0,n.illegalArgument)("start must be positive");if(te<0)throw(0,n.illegalArgument)("end must be positive");L<=te?(this._start=L,this._end=te):(this._start=te,this._end=L)}static isNotebookRange(L){return L instanceof Tt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let te=this._start,Se=this._end;return L.start!==void 0&&(te=L.start),L.end!==void 0&&(Se=L.end),te===this._start&&Se===this._end?this:new Tt(te,Se)}}e.NotebookRange=Tt;class Ct{constructor(L,te,Se,ze,xe,Xe,Je){this.kind=L,this.value=te,this.languageId=Se,this.mime=ze,this.outputs=xe??[],this.metadata=Xe,this.executionSummary=Je,Ct.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(te=>Ct.isNotebookCellData(te))}static isNotebookCellData(L){return!0}}e.NotebookCellData=Ct;class Ln{constructor(L){this.cells=L}}e.NotebookData=Ln;class mt{constructor(L,te){this.data=L,this.mime=te;const Se=(0,T.normalizeMimeType)(te,!0);if(!Se)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}static isNotebookCellOutputItem(L){return L instanceof mt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const te={name:L.name,message:L.message,stack:L.stack};return mt.json(te,"application/vnd.code.notebook.error")}static stdout(L){return mt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return mt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,te="application/octet-stream"){return new mt(L,te)}static text(L,te=T.Mimes.text){const Se=et(mt,b,"f",f).encode(String(L));return new mt(Se,te)}static json(L,te="text/x-json"){const Se=JSON.stringify(L,void 0,"	");return mt.text(Se,te)}}e.NotebookCellOutputItem=mt,b=mt,f={value:new TextEncoder};class Ft{constructor(L,te,Se){this.items=Ft.ensureUniqueMimeTypes(L,!0),typeof te=="string"?(this.id=te,this.metadata=Se):(this.id=(0,A.generateUuid)(),this.metadata=te??Se)}static isNotebookCellOutput(L){return L instanceof Ft?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&(0,v.isArray)(L.items)}static ensureUniqueMimeTypes(L,te=!1){const Se=new Set,ze=new Set;for(let xe=0;xe<L.length;xe++){const Xe=L[xe],Je=(0,T.normalizeMimeType)(Xe.mime);if(!Se.has(Je)){Se.add(Je);continue}ze.add(xe),te&&console.warn(`DUPLICATED mime type '${Xe.mime}' will be dropped`)}return ze.size===0?L:L.filter((xe,Xe)=>!ze.has(Xe))}}e.NotebookCellOutput=Ft;var Fn;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(Fn=e.NotebookCellKind||(e.NotebookCellKind={}));var On;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(On=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Nn;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(Nn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Mn;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Mn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Un{constructor(L,te){this.text=L,this.alignment=te}}e.NotebookCellStatusBarItem=Un;var Bn;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(Bn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class zn{constructor(L,te=[]){this.uri=L,this.provides=(0,k.asArray)(te)}}e.NotebookRendererScript=zn;let nn=class{constructor(L,te){this.label=L,this.timestamp=te}};nn=Ae([$],nn),e.TimelineItem=nn;var $n;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})($n=e.ExtensionMode||(e.ExtensionMode={}));var Wn;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(Wn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var jn;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=3]="RegEx"})(jn=e.StandardTokenType||(e.StandardTokenType={}));class Hn{constructor(L,te){this.ranges=L,this.wordPattern=te}}e.LinkedEditingRanges=Hn;class qn{constructor(L,te){this._port=L,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=qn;var Vn;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(Vn=e.TestResultState||(e.TestResultState={}));var xn;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(xn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let rn=class{constructor(L=void 0,te=void 0,Se=void 0){this.include=L,this.exclude=te,this.profile=Se}};rn=Ae([$],rn),e.TestRunRequest=rn;let sn=_=class{constructor(L){this.message=L}static diff(L,te,Se){const ze=new _(L);return ze.expectedOutput=te,ze.actualOutput=Se,ze}};sn=_=Ae([$],sn),e.TestMessage=sn;let on=class{constructor(L){this.id=L}};on=Ae([$],on),e.TestTag=on;let Dt=class{constructor(L,te){this.covered=L,this.total=te}};Dt=Ae([$],Dt),e.CoveredCount=Dt;let an=F=class{constructor(L,te,Se,ze){this.uri=L,this.statementCoverage=te,this.branchCoverage=Se,this.functionCoverage=ze}static fromDetails(L,te){const Se=new Dt(0,0),ze=new Dt(0,0),xe=new Dt(0,0);for(const Je of te)if("branches"in Je){Se.total+=1,Se.covered+=Je.executionCount>0?1:0;for(const rt of Je.branches)ze.total+=1,ze.covered+=rt.executionCount>0?1:0}else xe.total+=1,xe.covered+=Je.executionCount>0?1:0;const Xe=new F(L,Se,ze.total>0?ze:void 0,xe.total>0?xe:void 0);return Xe.detailedCoverage=te,Xe}};an=F=Ae([$],an),e.FileCoverage=an;let ln=class{constructor(L,te,Se=[]){this.executionCount=L,this.location=te,this.branches=Se}};ln=Ae([$],ln),e.StatementCoverage=ln;let cn=class{constructor(L,te){this.executionCount=L,this.location=te}};cn=Ae([$],cn),e.BranchCoverage=cn;let un=class{constructor(L,te){this.executionCount=L,this.location=te}};un=Ae([$],un),e.FunctionCoverage=un;var Gn;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(Gn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Kn;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(Kn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Qn;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(Qn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Yn{constructor(L,te,Se,ze,xe,Xe){this.kind=L,this.name=te,this.detail=Se,this.uri=ze,this.range=xe,this.selectionRange=Xe}}e.TypeHierarchyItem=Yn;class Xn{constructor(L){this.uri=L}}e.TextTabInput=Xn;class Jn{constructor(L,te){this.original=L,this.modified=te}}e.TextDiffTabInput=Jn;class Zn{constructor(L,te){this.uri=L,this.viewType=te}}e.CustomEditorTabInput=Zn;class ei{constructor(L){this.viewType=L}}e.WebviewEditorTabInput=ei;class ti{constructor(L,te){this.uri=L,this.notebookType=te}}e.NotebookEditorTabInput=ti;class ni{constructor(L,te,Se){this.original=L,this.modified=te,this.notebookType=Se}}e.NotebookDiffEditorTabInput=ni;class ii{constructor(){}}e.TerminalEditorTabInput=ii}),define(ve[57],we([0,1,61]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function n(C){return{transformIncoming:T=>T.scheme==="vscode-remote"?{scheme:"file",path:T.path,query:T.query,fragment:T.fragment}:T.scheme==="file"?{scheme:"vscode-local",path:T.path,query:T.query,fragment:T.fragment}:T,transformOutgoing:T=>T.scheme==="file"?{scheme:"vscode-remote",authority:C,path:T.path,query:T.query,fragment:T.fragment}:T.scheme==="vscode-local"?{scheme:"file",path:T.path,query:T.query,fragment:T.fragment}:T,transformOutgoingScheme:T=>T==="file"?"vscode-remote":T==="vscode-local"?"file":T}}function w(C){return new k.URITransformer(n(C))}e.createURITransformer=w}),define(ve[229],we([0,1,4,57,55,5,194]),function(ee,e,k,n,w,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemProviderChannel=void 0;class D extends T.AbstractDiskFileSystemProviderChannel{constructor(A,R){super(new w.DiskFileSystemProvider(A),A);this.environmentService=R,this.uriTransformerCache=new Map,this._register(this.provider)}getUriTransformer(A){let R=this.uriTransformerCache.get(A.remoteAuthority);return R||(R=(0,n.createURITransformer)(A.remoteAuthority),this.uriTransformerCache.set(A.remoteAuthority,R)),R}transformIncoming(A,R,E=!1){if(E&&R.path==="/vscode-resource"&&R.query){const S=JSON.parse(R.query).requestResourcePath;return k.URI.from({scheme:"file",path:S})}return k.URI.revive(A.transformIncoming(R))}createSessionFileWatcher(A,R){return new v(A,R,this.logService,this.environmentService)}}e.RemoteAgentFileSystemProviderChannel=D;class v extends T.AbstractSessionFileWatcher{constructor(A,R,E,S){super(A,R,E,S)}getRecursiveWatcherOptions(A){const R=A.args["file-watcher-polling"];if(R){const E=R.split(C.delimiter),S=Number(E[0]);if(S>0)return{usePolling:E.length>1?E.slice(1):!0,pollingInterval:S}}}getExtraExcludes(A){if(A.extensionsPath)return[C.posix.join(A.extensionsPath,"**")]}}}),define(ve[108],we([0,1,168,12,4,2,6,34,17,18,8]),function(ee,e,k,n,w,C,T,D,v,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,k.localize)(0,null),providerDisplayName:(0,k.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var R;(function(H){H[H.PROGRAMMATIC=1]="PROGRAMMATIC",H[H.USER=2]="USER",H[H.EDIT=3]="EDIT",H[H.NAVIGATION=4]="NAVIGATION",H[H.JUMP=5]="JUMP"})(R=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var E;(function(H){H[H.IDENTICAL=1]="IDENTICAL",H[H.SIMILAR=2]="SIMILAR",H[H.DIFFERENT=3]="DIFFERENT"})(E=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function S(H){const U=H;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}e.isEditorPaneWithSelection=S;function u(H,U,z){for(const Q of z.visibleEditorPanes)if(Q.group.id===U&&H.matches(Q.input))return Q.getViewState()}e.findViewStateForEditor=u;function b(H){if(i(H))return!1;const U=H;return w.URI.isUri(U?.resource)}e.isResourceEditorInput=b;function f(H){if(i(H))return!1;const U=H;return U?.original!==void 0&&U.modified!==void 0}e.isResourceDiffEditorInput=f;function d(H){if(i(H)||f(H))return!1;const U=H;return U?.primary!==void 0&&U.secondary!==void 0}e.isResourceSideBySideEditorInput=d;function p(H){if(i(H))return!1;const U=H;return U?U.resource===void 0||U.resource.scheme===A.Schemas.untitled||U.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=p;var m;(function(H){H[H.SHORT=0]="SHORT",H[H.MEDIUM=1]="MEDIUM",H[H.LONG=2]="LONG"})(m=e.Verbosity||(e.Verbosity={}));var y;(function(H){H[H.EXPLICIT=1]="EXPLICIT",H[H.AUTO=2]="AUTO",H[H.FOCUS_CHANGE=3]="FOCUS_CHANGE",H[H.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(y=e.SaveReason||(e.SaveReason={}));class c{constructor(){this.mapIdToSaveSource=new Map}registerSource(U,z){let Q=this.mapIdToSaveSource.get(U);return Q||(Q={source:U,label:z},this.mapIdToSaveSource.set(U,Q)),Q.source}getSourceLabel(U){return this.mapIdToSaveSource.get(U)?.label??U}}e.SaveSourceRegistry=new c;var o;(function(H){H[H.None=0]="None",H[H.Readonly=2]="Readonly",H[H.Untitled=4]="Untitled",H[H.Singleton=8]="Singleton",H[H.RequiresTrust=16]="RequiresTrust",H[H.CanSplitInGroup=32]="CanSplitInGroup",H[H.ForceDescription=64]="ForceDescription"})(o=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class l extends C.Disposable{}e.AbstractEditorInput=l;function i(H){return H instanceof l}e.isEditorInput=i;function t(H){const U=H;return w.URI.isUri(U?.preferredResource)}function r(H){const U=H;return i(U?.primary)&&i(U?.secondary)}e.isSideBySideEditorInput=r;function s(H){const U=H;return i(U?.modified)&&i(U?.original)}e.isDiffEditorInput=s;function a(H){return i(H?.editor)}e.isEditorInputWithOptions=a;function h(H){const U=H;return a(H)&&U?.group!==void 0}e.isEditorInputWithOptionsAndGroup=h;function g(H){const U=H;return typeof U?.groupId=="number"&&i(U.editor)}e.isEditorIdentifier=g;var _;(function(H){H[H.UNKNOWN=0]="UNKNOWN",H[H.REPLACE=1]="REPLACE",H[H.MOVE=2]="MOVE",H[H.UNPIN=3]="UNPIN"})(_=e.EditorCloseContext||(e.EditorCloseContext={}));var F;(function(H){H[H.GROUP_ACTIVE=0]="GROUP_ACTIVE",H[H.GROUP_INDEX=1]="GROUP_INDEX",H[H.GROUP_LOCKED=2]="GROUP_LOCKED",H[H.EDITOR_OPEN=3]="EDITOR_OPEN",H[H.EDITOR_CLOSE=4]="EDITOR_CLOSE",H[H.EDITOR_MOVE=5]="EDITOR_MOVE",H[H.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",H[H.EDITOR_LABEL=7]="EDITOR_LABEL",H[H.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",H[H.EDITOR_PIN=9]="EDITOR_PIN",H[H.EDITOR_STICKY=10]="EDITOR_STICKY",H[H.EDITOR_DIRTY=11]="EDITOR_DIRTY",H[H.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(F=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var $;(function(H){H[H.PRIMARY=1]="PRIMARY",H[H.SECONDARY=2]="SECONDARY",H[H.BOTH=3]="BOTH",H[H.ANY=4]="ANY"})($=e.SideBySideEditor||(e.SideBySideEditor={}));class K{getOriginalUri(U,z){if(!U)return;if(z?.supportSideBySide){const{primary:ie,secondary:re}=this.getSideEditors(U);if(ie&&re){if(z?.supportSideBySide===$.BOTH)return{primary:this.getOriginalUri(ie,{filterByScheme:z.filterByScheme}),secondary:this.getOriginalUri(re,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===$.ANY)return this.getOriginalUri(ie,{filterByScheme:z.filterByScheme})??this.getOriginalUri(re,{filterByScheme:z.filterByScheme});U=z.supportSideBySide===$.PRIMARY?ie:re}}if(f(U)||d(U))return;const Q=t(U)?U.preferredResource:U.resource;return!Q||!z||!z.filterByScheme?Q:this.filterUri(Q,z.filterByScheme)}getSideEditors(U){return r(U)||d(U)?{primary:U.primary,secondary:U.secondary}:s(U)||f(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,z){if(!U)return;if(z?.supportSideBySide){const{primary:ie,secondary:re}=this.getSideEditors(U);if(ie&&re){if(z?.supportSideBySide===$.BOTH)return{primary:this.getCanonicalUri(ie,{filterByScheme:z.filterByScheme}),secondary:this.getCanonicalUri(re,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===$.ANY)return this.getCanonicalUri(ie,{filterByScheme:z.filterByScheme})??this.getCanonicalUri(re,{filterByScheme:z.filterByScheme});U=z.supportSideBySide===$.PRIMARY?ie:re}}if(f(U)||d(U))return;const Q=U.resource;return!Q||!z||!z.filterByScheme?Q:this.filterUri(Q,z.filterByScheme)}filterUri(U,z){if(Array.isArray(z)){if(z.some(Q=>U.scheme===Q))return U}else if(z===U.scheme)return U}}e.EditorResourceAccessor=new K;var I;(function(H){H[H.LEFT=0]="LEFT",H[H.RIGHT=1]="RIGHT"})(I=e.CloseDirection||(e.CloseDirection={}));class W{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(U){const z=this.instantiationService=U.get(T.IInstantiationService);for(const[Q,ie]of this.editorSerializerConstructors)this.createEditorSerializer(Q,ie,z);this.editorSerializerConstructors.clear()}createEditorSerializer(U,z,Q){const ie=Q.createInstance(z);this.editorSerializerInstances.set(U,ie)}registerFileEditorFactory(U){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=U}getFileEditorFactory(){return(0,n.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(U,z){if(this.editorSerializerConstructors.has(U)||this.editorSerializerInstances.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.instantiationService?this.createEditorSerializer(U,z,this.instantiationService):this.editorSerializerConstructors.set(U,z),(0,C.toDisposable)(()=>{this.editorSerializerConstructors.delete(U),this.editorSerializerInstances.delete(U)})}getEditorSerializer(U){return this.editorSerializerInstances.get(typeof U=="string"?U:U.typeId)}}D.Registry.add(e.EditorExtensions.EditorFactory,new W);async function M(H,U){if(!H||!H.length)return[];const z=await Promise.all(H.map(async Q=>{const ie=w.URI.revive(Q.fileUri);if(!ie||!await U.canHandleResource(ie))return;let ce=Q.exists,de=Q.type;if(typeof ce!="boolean"||typeof de!="number")try{de=(await U.stat(ie)).isDirectory?v.FileType.Directory:v.FileType.Unknown,ce=!0}catch{ce=!1}if(!ce&&Q.openOnlyIfExists||de===v.FileType.Directory)return;const he={selection:ce?Q.selection:void 0,pinned:!0,override:Q.editorOverrideId};let j;return ce?j={resource:ie,options:he}:j={resource:ie,options:he,forceUntitled:!0},j}));return(0,P.coalesce)(z)}e.pathsToEditors=M;var q;(function(H){H[H.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",H[H.SEQUENTIAL=1]="SEQUENTIAL"})(q=e.EditorsOrder||(e.EditorsOrder={}));function Z(H){const U=H;if(!U)return!1;const z=U;if(z.modified)return Z(z.modified);const Q=U;return!!(Q.contributionsState&&Q.viewState&&Array.isArray(Q.cursorState))}e.isTextEditorViewState=Z}),define(ve[230],we([0,1,77,49,60,8,5,3,89]),function(ee,e,k,n,w,C,T,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var P;(function(s){s[s.Markup=1]="Markup",s[s.Code=2]="Code"})(P=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",w.Mimes.latex,w.Mimes.markdown,"image/png","image/jpeg",w.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[w.Mimes.latex,w.Mimes.markdown,"application/json",w.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var A;(function(s){s[s.Running=1]="Running",s[s.Idle=2]="Idle"})(A=e.NotebookRunState||(e.NotebookRunState={}));var R;(function(s){s[s.Unconfirmed=1]="Unconfirmed",s[s.Pending=2]="Pending",s[s.Executing=3]="Executing"})(R=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var E;(function(s){s[s.WithHardKernelDependency=0]="WithHardKernelDependency",s[s.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",s[s.Pure=2]="Pure",s[s.Never=3]="Never"})(E=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var S;(function(s){s.Always="always",s.Never="never",s.Optional="optional"})(S=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var u;(function(s){s[s.ModelChange=1]="ModelChange",s[s.Move=2]="Move",s[s.ChangeLanguage=5]="ChangeLanguage",s[s.Initialize=6]="Initialize",s[s.ChangeCellMetadata=7]="ChangeCellMetadata",s[s.Output=8]="Output",s[s.OutputItem=9]="OutputItem",s[s.ChangeCellContent=10]="ChangeCellContent",s[s.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",s[s.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",s[s.ChangeCellMime=13]="ChangeCellMime",s[s.Unknown=100]="Unknown"})(u=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var b;(function(s){s[s.Handle=0]="Handle",s[s.Index=1]="Index"})(b=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(s){s[s.Replace=1]="Replace",s[s.Output=2]="Output",s[s.Metadata=3]="Metadata",s[s.CellLanguage=4]="CellLanguage",s[s.DocumentMetadata=5]="DocumentMetadata",s[s.Move=6]="Move",s[s.OutputItems=7]="OutputItems",s[s.PartialMetadata=8]="PartialMetadata",s[s.PartialInternalMetadata=9]="PartialInternalMetadata"})(f=e.CellEditType||(e.CellEditType={}));var d;(function(s){s.scheme=C.Schemas.vscodeNotebookCell;const a=/^ch(\d{7,})/;function h(I,W){return I.with({scheme:s.scheme,fragment:`ch${W.toString().padStart(7,"0")}${I.scheme!==C.Schemas.file?I.scheme:""}`})}s.generate=h;function g(I){if(I.scheme!==s.scheme)return;const W=a.exec(I.fragment);return W?{handle:Number(W[1]),notebook:I.with({scheme:I.fragment.substring(W[0].length)||C.Schemas.file,fragment:null})}:void 0}s.parse=g;function _(I,W){return I.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`op${W??""},${I.scheme!==C.Schemas.file?I.scheme:""}`})}s.generateCellOutputUri=_;function F(I){if(I.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const W=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(I.fragment);if(!W)return;const M=W[1]&&W[1]!==""?W[1]:void 0,q=W[2];return{outputId:M,notebook:I.with({scheme:q||C.Schemas.file,fragment:null})}}s.parseCellOutputUri=F;function $(I,W,M){return I.with({scheme:M,fragment:`ch${W.toString().padStart(7,"0")}${I.scheme!==C.Schemas.file?I.scheme:""}`})}s.generateCellUri=$;function K(I,W){if(I.scheme!==W)return;const M=a.exec(I.fragment);return M?{handle:Number(M[1]),notebook:I.with({scheme:I.fragment.substring(M[0].length)||C.Schemas.file,fragment:null})}:void 0}s.parseCellUri=K})(d=e.CellUri||(e.CellUri={}));const p=s=>D.isWindows?s.replace(/\//g,"\\"):s;class m{constructor(a=[],h=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=h,this.order=[...new Set(a)].map(g=>({pattern:g,matches:k.parse(p(g))}))}sort(a){const h=new Map(n.Iterable.map(a,_=>[_,p(_)]));let g=[];for(const{matches:_}of this.order)for(const[F,$]of h)if(_($)){g.push(F),h.delete(F);break}return h.size&&(g=g.concat([...h.keys()].sort((_,F)=>this.defaultOrder.indexOf(_)-this.defaultOrder.indexOf(F)))),g}prioritize(a,h){const g=this.findIndex(a);if(g===-1){this.order.unshift({pattern:a,matches:k.parse(p(a))});return}const _=new Set(h.map($=>this.findIndex($,g)));_.delete(-1);const F=Array.from(_).sort();this.order.splice(g+1,0,...F.map($=>this.order[$]));for(let $=F.length-1;$>=0;$--)this.order.splice(F[$],1)}toArray(){return this.order.map(a=>a.pattern)}findIndex(a,h=this.order.length){const g=p(a);for(let _=0;_<h;_++)if(this.order[_].matches(g))return _;return-1}}e.MimeTypeDisplayOrder=m;function y(s,a,h,g=(_,F)=>_===F){const _=[];function F(I,W,M){if(W===0&&M.length===0)return;const q=_[_.length-1];q&&q.start+q.deleteCount===I?(q.deleteCount+=W,q.toInsert.push(...M)):_.push({start:I,deleteCount:W,toInsert:M})}let $=0,K=0;for(;;){if($===s.length){F($,0,a.slice(K));break}if(K===a.length){F($,s.length-$,[]);break}const I=s[$],W=a[K];if(g(I,W)){$+=1,K+=1;continue}h(W)?(F($,1,[]),$+=1):(F($,0,[W]),K+=1)}return _}e.diff=y,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new v.RawContextKey("notebookEditorCursorAtBoundary","none");var c;(function(s){s.default="default",s.option="option"})(c=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(s){const a=s;return!!((typeof a.include=="string"||k.isRelativePattern(a.include))&&(typeof a.exclude=="string"||k.isRelativePattern(a.exclude)))}e.isDocumentExcludePattern=o;function l(s,a,h){if(Array.isArray(s.viewType)&&s.viewType.indexOf(a)>=0||s.viewType===a)return!0;if(s.filenamePattern){const g=o(s.filenamePattern)?s.filenamePattern.include:s.filenamePattern,_=o(s.filenamePattern)?s.filenamePattern.exclude:void 0;if(k.match(g,(0,T.basename)(h.fsPath).toLowerCase()))return!(_&&k.match(_,(0,T.basename)(h.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=l;class i{constructor(a){this.textModel=a}getElements(){const a=new Int32Array(this.textModel.cells.length);for(let h=0;h<this.textModel.cells.length;h++)a[h]=this.textModel.cells[h].getHashValue();return a}}e.CellSequence=i,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var t;(function(s){s[s.Left=1]="Left",s[s.Right=2]="Right"})(t=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class r{static create(a){return`${r._prefix}${a}`}static parse(a){if(a.startsWith(r._prefix))return a.substring(r._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=r,r._prefix="notebook/"}),define(ve[109],we([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,k.createDecorator)("environmentVariableService");var n;(function(w){w[w.Replace=1]="Replace",w[w.Append=2]="Append",w[w.Prepend=3]="Prepend"})(n=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(ve[231],we([0,1,3,109]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class w{constructor(v){this.map=new Map,v.forEach((P,A)=>{const R=P.map.entries();let E=R.next();for(;!E.done;){const S=E.value[0];let u=this.map.get(S);if(u||(u=[],this.map.set(S,u)),u.length>0&&u[0].type===n.EnvironmentVariableMutatorType.Replace){E=R.next();continue}const b=E.value[1];u.unshift({extensionIdentifier:A,value:b.value,type:b.type}),E=R.next()}})}applyToProcessEnvironment(v,P){let A;k.isWindows&&(A={},Object.keys(v).forEach(R=>A[R.toLowerCase()]=R)),this.map.forEach((R,E)=>{const S=k.isWindows&&A[E.toLowerCase()]||E;R.forEach(u=>{const b=P?P(u.value):u.value;switch(u.type){case n.EnvironmentVariableMutatorType.Append:v[S]=(v[S]||"")+b;break;case n.EnvironmentVariableMutatorType.Prepend:v[S]=b+(v[S]||"");break;case n.EnvironmentVariableMutatorType.Replace:v[S]=b;break}})})}diff(v){const P=new Map,A=new Map,R=new Map;if(v.map.forEach((E,S)=>{const u=this.map.get(S),b=C(E,u);b&&P.set(S,b)}),this.map.forEach((E,S)=>{const u=v.map.get(S),b=C(E,u);b&&R.set(S,b)}),this.map.forEach((E,S)=>{const u=v.map.get(S),b=T(E,u);b&&A.set(S,b)}),!(P.size===0&&A.size===0&&R.size===0))return{added:P,changed:A,removed:R}}}e.MergedEnvironmentVariableCollection=w;function C(D,v){if(!v)return D;const P=new Set;v.forEach(R=>P.add(R.extensionIdentifier));const A=[];return D.forEach(R=>{P.has(R.extensionIdentifier)||A.push(R)}),A.length===0?void 0:A}function T(D,v){if(!v)return;const P=new Map;v.forEach(R=>P.set(R.extensionIdentifier,R));const A=[];return D.forEach(R=>{const E=P.get(R.extensionIdentifier);E&&(R.type!==E.type||R.value!==E.value)&&A.push(E)}),A.length===0?void 0:A}}),define(ve[110],we([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function k(w){return[...w.entries()]}e.serializeEnvironmentVariableCollection=k;function n(w){return new Map(w)}e.deserializeEnvironmentVariableCollection=n}),define(ve[232],we([0,1,5,74,3]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function C(y,c){if(!!c)if(w.isWindows)for(const o in c){let l=o;for(const t in y)if(o.toLowerCase()===t.toLowerCase()){l=t;break}const i=c[o];i!==void 0&&T(y,l,i)}else Object.keys(c).forEach(o=>{const l=c[o];l!==void 0&&T(y,o,l)})}e.mergeEnvironments=C;function T(y,c,o){typeof o=="string"?y[c]=o:delete y[c]}function D(y,c,o,l){y.TERM_PROGRAM="vscode",c&&(y.TERM_PROGRAM_VERSION=c),A(y,l)&&(y.LANG=R(o)),y.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=D;function v(y,c){if(!!c)for(const o of Object.keys(c)){const l=c[o];l&&(y[o]=l)}}function P(y,c){return Object.keys(c).forEach(o=>{const l=c[o];if(typeof l=="string")try{c[o]=y(l)}catch{c[o]=l}}),c}function A(y,c){if(c==="on")return!0;if(c==="auto"){const o=y.LANG;return!o||o.search(/\.UTF\-8$/)===-1&&o.search(/\.utf8$/)===-1&&o.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=A;function R(y){const c=y?y.split("-"):[],o=c.length;if(o===0)return"en_US.UTF-8";if(o===1){const l={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};c[0]in l&&c.push(l[c[0]])}else c[1]=c[1].toUpperCase();return c.join("_")+".UTF-8"}e.getLangEnvVariable=R;function E(y,c,o,l,i,t){if(y.cwd){const s=typeof y.cwd=="object"?y.cwd.fsPath:y.cwd,a=S(s,o);return u(a||s)}let r;return!y.ignoreConfigurationCwd&&i&&(o&&(i=S(i,o,t)),i&&(k.isAbsolute(i)?r=i:l&&(r=k.join(l.fsPath,i)))),r||(r=l?l.fsPath:c||""),u(r)}e.getCwd=E;function S(y,c,o){if(c)try{return c(y)}catch(l){o?.error("Could not resolve terminal cwd",l);return}return y}function u(y){return w.OS===1&&y&&y[1]===":"?y[0].toUpperCase()+y.substr(1):y}function b(y,c,o){if(!!o)return l=>o.resolveWithEnvironment(c,y,l)}e.createVariableResolver=b;function f(y,c,o,l,i,t,r,s=w.platform){let a;r&&(a=p(y,"automationShell",s)),a||(a=p(y,"shell",s));let h=a||c;if(s===3&&!o&&l){const g=k.join(l,"Sysnative").replace(/\//g,"\\").toLowerCase();h&&h.toLowerCase().indexOf(g)===0&&(h=k.join(l,"System32",h.substr(g.length+1)))}if(h&&s===3&&(h=h.replace(/\//g,"\\")),i)try{h=i(h)}catch(g){t.error("Could not resolve shell",g)}return h}e.getDefaultShell=f;function d(y,c,o,l,i=w.platform){if(c&&p(y,"automationShell",i))return[];const t=i===3?"windows":i===1?"osx":"linux";let r=y(`terminal.integrated.shellArgs.${t}`);if(!r)return[];if(typeof r=="string"&&i===3)return o?o(r):r;if(o){const s=[];for(const a of r)try{s.push(o(a))}catch(h){l.error(`Could not resolve terminal.integrated.shellArgs.${t}`,h),s.push(a)}r=s}return r}e.getDefaultShellArgs=d;function p(y,c,o=w.platform){return y(`terminal.integrated.${c}.${o===3?"windows":o===1?"osx":"linux"}`)}function m(y,c,o,l,i,t){const r={};if(y.strictEnv)v(r,y.env);else{v(r,t);const s={...c};o&&(s&&P(o,s),y.env&&P(o,y.env)),(0,n.sanitizeProcessEnvironment)(r,"VSCODE_IPC_HOOK_CLI"),C(r,s),C(r,y.env),D(r,l,w.locale,i)}return r}e.createTerminalEnvironment=m}),define(ve[233],we([0,1,4,51]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var w;(function(r){r[r.Unset=0]="Unset",r[r.Queued=1]="Queued",r[r.Running=2]="Running",r[r.Passed=3]="Passed",r[r.Failed=4]="Failed",r[r.Skipped=5]="Skipped",r[r.Errored=6]="Errored"})(w=e.TestResultState||(e.TestResultState={}));var C;(function(r){r[r.Run=2]="Run",r[r.Debug=4]="Debug",r[r.Coverage=8]="Coverage",r[r.HasNonDefaultProfile=16]="HasNonDefaultProfile",r[r.HasConfigurable=32]="HasConfigurable"})(C=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var T;(function(r){r.serialize=s=>({range:s.range.toJSON(),uri:s.uri.toJSON()}),r.deserialize=s=>({range:n.Range.lift(s.range),uri:k.URI.revive(s.uri)})})(T=e.IRichLocation||(e.IRichLocation={}));var D;(function(r){r[r.Error=0]="Error",r[r.Info=1]="Info"})(D=e.TestMessageType||(e.TestMessageType={}));var v;(function(r){r.serialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&T.serialize(s.location)}),r.deserialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&T.deserialize(s.location)})})(v=e.ITestErrorMessage||(e.ITestErrorMessage={}));var P;(function(r){r.serialize=s=>({message:s.message,type:1,offset:s.offset,location:s.location&&T.serialize(s.location)}),r.deserialize=s=>({message:s.message,type:1,offset:s.offset,location:s.location&&T.deserialize(s.location)})})(P=e.ITestOutputMessage||(e.ITestOutputMessage={}));var A;(function(r){r.serialize=s=>s.type===0?v.serialize(s):P.serialize(s),r.deserialize=s=>s.type===0?v.deserialize(s):P.deserialize(s)})(A=e.ITestMessage||(e.ITestMessage={}));var R;(function(r){r.serialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(A.serialize)}),r.deserialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(A.deserialize)})})(R=e.ITestTaskState||(e.ITestTaskState={}));const E="\0",S=(r,s)=>r+E+s;e.namespaceTestTag=S;const u=r=>{const s=r.indexOf(E);return{ctrlId:r.slice(0,s),tagId:r.slice(s+1)}};e.denamespaceTestTag=u;var b;(function(r){r.serialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?.toJSON(),range:s.range?.toJSON()||null,description:s.description,error:s.error,sortText:s.sortText}),r.deserialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?k.URI.revive(s.uri):void 0,range:s.range?n.Range.lift(s.range):null,description:s.description,error:s.error,sortText:s.sortText})})(b=e.ITestItem||(e.ITestItem={}));var f;(function(r){r[r.NotExpandable=0]="NotExpandable",r[r.Expandable=1]="Expandable",r[r.BusyExpanding=2]="BusyExpanding",r[r.Expanded=3]="Expanded"})(f=e.TestItemExpandState||(e.TestItemExpandState={}));var d;(function(r){r.serialize=s=>({controllerId:s.controllerId,expand:s.expand,parent:s.parent,item:b.serialize(s.item)}),r.deserialize=s=>({controllerId:s.controllerId,expand:s.expand,parent:s.parent,item:b.deserialize(s.item)})})(d=e.InternalTestItem||(e.InternalTestItem={}));var p;(function(r){r.serialize=s=>{let a;return s.item&&(a={},s.item.label!==void 0&&(a.label=s.item.label),s.item.tags!==void 0&&(a.tags=s.item.tags),s.item.busy!==void 0&&(a.busy=s.item.busy),s.item.uri!==void 0&&(a.uri=s.item.uri?.toJSON()),s.item.range!==void 0&&(a.range=s.item.range?.toJSON()),s.item.description!==void 0&&(a.description=s.item.description),s.item.error!==void 0&&(a.error=s.item.error),s.item.sortText!==void 0&&(a.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:a}},r.deserialize=s=>{let a;return s.item&&(a={},s.item.label!==void 0&&(a.label=s.item.label),s.item.tags!==void 0&&(a.tags=s.item.tags),s.item.busy!==void 0&&(a.busy=s.item.busy),s.item.range!==void 0&&(a.range=s.item.range?n.Range.lift(s.item.range):null),s.item.description!==void 0&&(a.description=s.item.description),s.item.error!==void 0&&(a.error=s.item.error),s.item.sortText!==void 0&&(a.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:a}}})(p=e.ITestItemUpdate||(e.ITestItemUpdate={}));const m=(r,s)=>{s.expand!==void 0&&(r.expand=s.expand),s.item!==void 0&&(r.item=r.item?Object.assign(r.item,s.item):s.item)};e.applyTestItemUpdate=m;var y;(function(r){r.serialize=(s,a)=>({...d.serialize(s),children:a,ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(R.serialize)})})(y=e.TestResultItem||(e.TestResultItem={}));var c;(function(r){r[r.Function=0]="Function",r[r.Statement=1]="Statement"})(c=e.DetailType||(e.DetailType={}));var o;(function(r){r[r.Add=0]="Add",r[r.Update=1]="Update",r[r.Remove=2]="Remove",r[r.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",r[r.Retire=4]="Retire",r[r.AddTag=5]="AddTag",r[r.RemoveTag=6]="RemoveTag"})(o=e.TestDiffOpType||(e.TestDiffOpType={}));var l;(function(r){r.deserialize=s=>s.op===0?{op:s.op,item:d.deserialize(s.item)}:s.op===1?{op:s.op,item:p.deserialize(s.item)}:s,r.serialize=s=>s.op===0?{op:s.op,item:d.serialize(s.item)}:s.op===1?{op:s.op,item:p.serialize(s.item)}:s})(l=e.TestsDiffOp||(e.TestsDiffOp={}));class i{add(s){}update(s){}remove(s,a){}complete(){}}e.IncrementalChangeCollector=i;class t{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(s){const a=this.createChangeCollector();for(const h of s)switch(h.op){case 0:{const g=d.deserialize(h.item);if(g.parent){if(this.items.has(g.parent)){const _=this.items.get(g.parent);_.children.add(g.item.extId);const F=this.createItem(g,_);this.items.set(g.item.extId,F),a.add(F)}}else{const _=this.createItem(g);this.roots.add(_),this.items.set(g.item.extId,_),a.add(_)}g.expand===2&&this.busyControllerCount++;break}case 1:{const g=p.deserialize(h.item),_=this.items.get(g.extId);if(!_)break;g.expand!==void 0&&(_.expand===2&&this.busyControllerCount--,g.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(_,g),a.update(_);break}case 2:{const g=this.items.get(h.itemId);if(!g)break;g.parent?this.items.get(g.parent).children.delete(g.item.extId):this.roots.delete(g);const _=[[h.itemId]];for(;_.length;)for(const F of _.pop()){const $=this.items.get(F);$&&(_.push($.children),this.items.delete(F),a.remove($,$!==g),$.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(h.itemId);break;case 3:this.updatePendingRoots(h.amount);break;case 5:this._tags.set(h.tag.id,h.tag);break;case 6:this._tags.delete(h.id);break}a.complete()}retireTest(s){}updatePendingRoots(s){this.pendingRootCount+=s}createChangeCollector(){return new i}}e.AbstractIncrementalTestCollection=t}),define(ve[234],we([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var k;(function(C){C.Delimiter="\0"})(k=e.TestIdPathParts||(e.TestIdPathParts={}));var n;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(n=e.TestPosition||(e.TestPosition={}));class w{constructor(T,D=T.length){if(this.path=T,this.viewEnd=D,T.length===0||D<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(T,D,v=T.parent){if(T.id===D)return new w([D]);let P=[T.id];for(let A=v;A&&A.id!==D;A=A.parent)P.push(A.id);return P.push(D),new w(P.reverse())}static isRoot(T){return!T.includes("\0")}static root(T){const D=T.indexOf("\0");return D===-1?T:T.slice(0,D)}static fromString(T){return new w(T.split("\0"))}static join(T,D){return new w([...T.path,D])}static joinToString(T,D){return T.toString()+"\0"+D}static compare(T,D){return T===D?0:D.startsWith(T+"\0")?2:T.startsWith(D+"\0")?3:1}get parentId(){return this.viewEnd>1?new w(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let T=1;T<=this.viewEnd;T++)yield new w(this.path,T)}compare(T){if(typeof T=="string")return w.compare(this.toString(),T);for(let D=0;D<T.viewEnd&&D<this.viewEnd;D++)if(T.path[D]!==this.path[D])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=w}),define(ve[235],we([0,1,26,6]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.LOCAL_MACHINE_SCOPES=[1,3,4,5],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=(0,n.refineServiceDecorator)(k.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(ve[236],we([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,k.createDecorator)("configurationResolverService")}),define(ve[237],we([0,1,5,24,12,22,3,79,169]),function(ee,e,k,n,w,C,T,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(R,E,S,u){this._contributedVariables=new Map,this._context=R,this._labelService=E,this._userHomePromise=S,u&&(this._envVariablesPromise=u.then(b=>this.prepareEnv(b)))}prepareEnv(R){if(T.isWindows){const E=Object.create(null);return Object.keys(R).forEach(S=>{E[S.toLowerCase()]=R[S]}),E}return R}resolveWithEnvironment(R,E,S){return this.recursiveResolve({env:this.prepareEnv(R),userHome:void 0},E?E.uri:void 0,S)}async resolveAsync(R,E){const S={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(S,R?R.uri:void 0,E)}async resolveAnyBase(R,E,S,u){const b=C.deepClone(E);T.isWindows&&b.windows?Object.keys(b.windows).forEach(d=>b[d]=b.windows[d]):T.isMacintosh&&b.osx?Object.keys(b.osx).forEach(d=>b[d]=b.osx[d]):T.isLinux&&b.linux&&Object.keys(b.linux).forEach(d=>b[d]=b.linux[d]),delete b.windows,delete b.osx,delete b.linux;const f={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(f,R?R.uri:void 0,b,S,u)}async resolveAnyAsync(R,E,S){return this.resolveAnyBase(R,E,S)}async resolveAnyMap(R,E,S){const u=new Map;return{newConfig:await this.resolveAnyBase(R,E,S,u),resolvedVariables:u}}resolveWithInteractionReplace(R,E,S,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(R,E,S,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(R,E){if(this._contributedVariables.has(R))throw new Error("Variable "+R+" is contributed twice.");this._contributedVariables.set(R,E)}recursiveResolve(R,E,S,u,b){if(w.isString(S))return this.resolveString(R,E,S,u,b);if(w.isArray(S))return S.map(f=>this.recursiveResolve(R,E,f,u,b));if(w.isObject(S)){let f=Object.create(null);return Object.keys(S).forEach(d=>{const p=this.resolveString(R,E,d,u,b);f[p]=this.recursiveResolve(R,E,S[d],u,b)}),f}return S}resolveString(R,E,S,u,b){return S.replace(P.VARIABLE_REGEXP,(d,p)=>{if(p.includes(P.VARIABLE_LHS))return d;let m=this.evaluateSingleVariable(R,d,p,E,u);return b&&b.set(p,m),m!==d&&w.isString(m)&&m.match(P.VARIABLE_REGEXP)&&(m=this.resolveString(R,E,m,u,b)),m})}fsPath(R){return this._labelService?this._labelService.getUriLabel(R,{noPrefix:!0}):R.fsPath}evaluateSingleVariable(R,E,S,u,b){let f;const d=S.split(":");d.length>1&&(S=d[0],f=d[1]);const p=()=>{const c=this._context.getFilePath();if(c)return c;throw new Error((0,v.localize)(0,null,E))},m=()=>{const c=p();if(this._context.getWorkspaceFolderPathForFile){const o=this._context.getWorkspaceFolderPathForFile();if(o)return o}throw new Error((0,v.localize)(1,null,E,k.basename(c)))},y=()=>{if(f){const c=this._context.getFolderUri(f);if(c)return c;throw new Error((0,v.localize)(2,null,E,f))}if(u)return u;throw this._context.getWorkspaceFolderCount()>1?new Error((0,v.localize)(3,null,E)):new Error((0,v.localize)(4,null,E))};switch(S){case"env":if(f){if(R.env){const c=R.env[T.isWindows?f.toLowerCase():f];if(w.isString(c))return c}return""}throw new Error((0,v.localize)(5,null,E));case"config":if(f){const c=this._context.getConfigurationValue(u,f);if(w.isUndefinedOrNull(c))throw new Error((0,v.localize)(6,null,E,f));if(w.isObject(c))throw new Error((0,v.localize)(7,null,E,f));return c}throw new Error((0,v.localize)(8,null,E));case"command":return this.resolveFromMap(E,f,b,"command");case"input":return this.resolveFromMap(E,f,b,"input");default:switch(S){case"workspaceRoot":case"workspaceFolder":return(0,D.normalizeDriveLetter)(this.fsPath(y()));case"cwd":return u||f?(0,D.normalizeDriveLetter)(this.fsPath(y())):n.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return k.basename(this.fsPath(y()));case"userHome":{if(R.userHome)return R.userHome;throw new Error((0,v.localize)(9,null,E))}case"lineNumber":{const c=this._context.getLineNumber();if(c)return c;throw new Error((0,v.localize)(10,null,E))}case"selectedText":{const c=this._context.getSelectedText();if(c)return c;throw new Error((0,v.localize)(11,null,E))}case"file":return p();case"fileWorkspaceFolder":return m();case"relativeFile":return u||f?k.relative(this.fsPath(y()),p()):p();case"relativeFileDirname":{const c=k.dirname(p());if(u||f){const o=k.relative(this.fsPath(y()),c);return o.length===0?".":o}return c}case"fileDirname":return k.dirname(p());case"fileExtname":return k.extname(p());case"fileBasename":return k.basename(p());case"fileBasenameNoExtension":{const c=k.basename(p());return c.slice(0,c.length-k.extname(c).length)}case"fileDirnameBasename":return k.basename(k.dirname(p()));case"execPath":{const c=this._context.getExecPath();return c||E}case"execInstallFolder":{const c=this._context.getAppRoot();return c||E}case"pathSeparator":return k.sep;default:try{const c=f?`${S}:${f}`:S;return this.resolveFromMap(E,c,b,void 0)}catch{return E}}}}resolveFromMap(R,E,S,u){if(E&&S){const b=u===void 0?S[E]:S[u+":"+E];if(typeof b=="string")return b;throw new Error((0,v.localize)(12,null,R))}return R}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ve[238],we([0,1,6,108]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,k.createDecorator)("editorGroupsService");var w;(function(u){u[u.UP=0]="UP",u[u.DOWN=1]="DOWN",u[u.LEFT=2]="LEFT",u[u.RIGHT=3]="RIGHT"})(w=e.GroupDirection||(e.GroupDirection={}));var C;(function(u){u[u.HORIZONTAL=0]="HORIZONTAL",u[u.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(u){u[u.FIRST=0]="FIRST",u[u.LAST=1]="LAST",u[u.NEXT=2]="NEXT",u[u.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var D;(function(u){u[u.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",u[u.EVEN=1]="EVEN",u[u.TOGGLE=2]="TOGGLE"})(D=e.GroupsArrangement||(e.GroupsArrangement={}));var v;(function(u){u[u.COPY_EDITORS=0]="COPY_EDITORS",u[u.MOVE_EDITORS=1]="MOVE_EDITORS"})(v=e.MergeGroupMode||(e.MergeGroupMode={}));function P(u){const b=u;return(0,n.isEditorInput)(b?.editor)&&(0,n.isEditorInput)(b?.replacement)}e.isEditorReplacement=P;var A;(function(u){u[u.CREATION_TIME=0]="CREATION_TIME",u[u.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",u[u.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A=e.GroupsOrder||(e.GroupsOrder={}));var R;(function(u){u[u.NEW_EDITOR=1]="NEW_EDITOR",u[u.MOVE_EDITOR=2]="MOVE_EDITOR",u[u.COPY_EDITOR=3]="COPY_EDITOR"})(R=e.OpenEditorContext||(e.OpenEditorContext={}));function E(u){const b=u;return!!b&&typeof b.id=="number"&&Array.isArray(b.editors)}e.isEditorGroup=E;function S(u){return u.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=S}),define(ve[111],we([0,1,6,238]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,k.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function w(C){const T=C;return typeof C=="number"||(0,n.isEditorGroup)(T)}e.isPreferredGroup=w}),define(ve[239],we([0,1,18,16,78,121,50,22,12,4,51,137,173,195,106,230,233,234,111,107]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E,S,u,b,f,d,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var y;(function(be){function Ie(G){const{selectionStartLineNumber:De,selectionStartColumn:_e,positionLineNumber:We,positionColumn:qe}=G,nt=new m.Position(De-1,_e-1),at=new m.Position(We-1,qe-1);return new m.Selection(nt,at)}be.to=Ie;function ae(G){const{anchor:De,active:_e}=G;return{selectionStartLineNumber:De.line+1,selectionStartColumn:De.character+1,positionLineNumber:_e.line+1,positionColumn:_e.character+1}}be.from=ae})(y=e.Selection||(e.Selection={}));var c;(function(be){function Ie(G){if(!G)return;const{start:De,end:_e}=G;return{startLineNumber:De.line+1,startColumn:De.character+1,endLineNumber:_e.line+1,endColumn:_e.character+1}}be.from=Ie;function ae(G){if(!G)return;const{startLineNumber:De,startColumn:_e,endLineNumber:We,endColumn:qe}=G;return new m.Range(De-1,_e-1,We-1,qe-1)}be.to=ae})(c=e.Range||(e.Range={}));var o;(function(be){function Ie(ae){switch(ae){case 1:return m.StandardTokenType.Comment;case 0:return m.StandardTokenType.Other;case 3:return m.StandardTokenType.RegEx;case 2:return m.StandardTokenType.String}}be.to=Ie})(o=e.TokenType||(e.TokenType={}));var l;(function(be){function Ie(G){return new m.Position(G.lineNumber-1,G.column-1)}be.to=Ie;function ae(G){return{lineNumber:G.line+1,column:G.character+1}}be.from=ae})(l=e.Position||(e.Position={}));var i;(function(be){function Ie(De,_e){return(0,k.coalesce)((0,k.asArray)(De).map(We=>ae(We,_e)))}be.from=Ie;function ae(De,_e){if(typeof De=="string")return{$serialized:!0,language:De};if(De)return{$serialized:!0,language:De.language,scheme:G(De.scheme,_e),pattern:ne.from(De.pattern)??void 0,exclusive:De.exclusive,notebookType:De.notebookType}}function G(De,_e){return _e&&typeof De=="string"?_e.transformOutgoingScheme(De):De}})(i=e.DocumentSelector||(e.DocumentSelector={}));var t;(function(be){function Ie(G){switch(G){case m.DiagnosticTag.Unnecessary:return 1;case m.DiagnosticTag.Deprecated:return 2}}be.from=Ie;function ae(G){switch(G){case 1:return m.DiagnosticTag.Unnecessary;case 2:return m.DiagnosticTag.Deprecated;default:return}}be.to=ae})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(be){function Ie(G){let De;return G.code&&((0,v.isString)(G.code)||(0,v.isNumber)(G.code)?De=String(G.code):De={value:String(G.code.value),target:G.code.target}),{...c.from(G.range),message:G.message,source:G.source,code:De,severity:a.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(s.from),tags:Array.isArray(G.tags)?(0,k.coalesce)(G.tags.map(t.from)):void 0}}be.from=Ie;function ae(G){const De=new m.Diagnostic(c.to(G),G.message,a.to(G.severity));return De.source=G.source,De.code=(0,v.isString)(G.code)?G.code:G.code?.value,De.relatedInformation=G.relatedInformation&&G.relatedInformation.map(s.to),De.tags=G.tags&&(0,k.coalesce)(G.tags.map(t.to)),De}be.to=ae})(r=e.Diagnostic||(e.Diagnostic={}));var s;(function(be){function Ie(G){return{...c.from(G.location.range),message:G.message,resource:G.location.uri}}be.from=Ie;function ae(G){return new m.DiagnosticRelatedInformation(new m.Location(G.resource,c.to(G)),G.message)}be.to=ae})(s=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var a;(function(be){function Ie(G){switch(G){case m.DiagnosticSeverity.Error:return S.MarkerSeverity.Error;case m.DiagnosticSeverity.Warning:return S.MarkerSeverity.Warning;case m.DiagnosticSeverity.Information:return S.MarkerSeverity.Info;case m.DiagnosticSeverity.Hint:return S.MarkerSeverity.Hint}return S.MarkerSeverity.Error}be.from=Ie;function ae(G){switch(G){case S.MarkerSeverity.Info:return m.DiagnosticSeverity.Information;case S.MarkerSeverity.Warning:return m.DiagnosticSeverity.Warning;case S.MarkerSeverity.Error:return m.DiagnosticSeverity.Error;case S.MarkerSeverity.Hint:return m.DiagnosticSeverity.Hint;default:return m.DiagnosticSeverity.Error}}be.to=ae})(a=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var h;(function(be){function Ie(G){return typeof G=="number"&&G>=m.ViewColumn.One?G-1:G===m.ViewColumn.Beside?p.SIDE_GROUP:p.ACTIVE_GROUP}be.from=Ie;function ae(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=ae})(h=e.ViewColumn||(e.ViewColumn={}));function g(be){return typeof be.range!="undefined"}function _(be){return be.length===0?!0:!!g(be[0])}e.isDecorationOptionsArr=_;var F;(function(be){function Ie(qe){return qe.map(be.from)}be.fromMany=Ie;function ae(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function G(qe){let nt;if(ae(qe)){const{language:ft,value:dt}=qe;nt={value:"```"+ft+`
`+dt+"\n```\n"}}else m.MarkdownString.isMarkdownString(qe)?nt={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?nt={value:qe}:nt={value:""};const at=Object.create(null);nt.uris=at;const yt=ft=>{try{let dt=P.URI.parse(ft,!0);dt=dt.with({query:De(dt.query,at)}),at[ft]=dt}catch{}return""},lt=new C.marked.Renderer;return lt.link=yt,lt.image=ft=>typeof ft=="string"?yt(w.parseHrefAndDimensions(ft).href):"",(0,C.marked)(nt.value,{renderer:lt}),nt}be.from=G;function De(qe,nt){if(!qe)return qe;let at;try{at=(0,T.parse)(qe)}catch{}if(!at)return qe;let yt=!1;return at=(0,D.cloneAndChange)(at,lt=>{if(P.URI.isUri(lt)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return nt[ft]=lt,yt=!0,ft}else return}),yt?JSON.stringify(at):qe}function _e(qe){const nt=new m.MarkdownString(qe.value,qe.supportThemeIcons);return nt.isTrusted=qe.isTrusted,nt.supportHtml=qe.supportHtml,nt.baseUri=qe.baseUri?P.URI.from(qe.baseUri):void 0,nt}be.to=_e;function We(qe){if(!!qe)return typeof qe=="string"?qe:be.from(qe)}be.fromStrict=We})(F=e.MarkdownString||(e.MarkdownString={}));function $(be){return _(be)?be.map(Ie=>({range:c.from(Ie.range),hoverMessage:Array.isArray(Ie.hoverMessage)?F.fromMany(Ie.hoverMessage):Ie.hoverMessage?F.from(Ie.hoverMessage):void 0,renderOptions:Ie.renderOptions})):be.map(Ie=>({range:c.from(Ie)}))}e.fromRangeOrRangeWithMessage=$;function K(be){return typeof be=="undefined"?be:typeof be=="string"?P.URI.file(be):be}e.pathOrURIToURI=K;var I;(function(be){function Ie(ae){return typeof ae=="undefined"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?K(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}be.from=Ie})(I=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var W;(function(be){function Ie(ae){return typeof ae=="undefined"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?K(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?I.from(ae.before):void 0,after:ae.after?I.from(ae.after):void 0}}be.from=Ie})(W=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var M;(function(be){function Ie(ae){if(typeof ae=="undefined")return ae;switch(ae){case m.DecorationRangeBehavior.OpenOpen:return 0;case m.DecorationRangeBehavior.ClosedClosed:return 1;case m.DecorationRangeBehavior.OpenClosed:return 2;case m.DecorationRangeBehavior.ClosedOpen:return 3}}be.from=Ie})(M=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var q;(function(be){function Ie(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?M.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?W.from(ae.light):void 0,dark:ae.dark?W.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?K(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?I.from(ae.before):void 0,after:ae.after?I.from(ae.after):void 0}}be.from=Ie})(q=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var Z;(function(be){function Ie(G){return{text:G.newText,eol:G.newEol&&Fe.from(G.newEol),range:c.from(G.range)}}be.from=Ie;function ae(G){const De=new m.TextEdit(c.to(G.range),G.text);return De.newEol=typeof G.eol=="undefined"?void 0:Fe.to(G.eol),De}be.to=ae})(Z=e.TextEdit||(e.TextEdit={}));var H;(function(be){function Ie(G,De){const _e={edits:[]};if(G instanceof m.WorkspaceEdit)for(let We of G._allEntries())We._type===1?_e.edits.push({_type:1,oldUri:We.from,newUri:We.to,options:We.options,metadata:We.metadata}):We._type===2?_e.edits.push({_type:2,resource:We.uri,edit:Z.from(We.edit),modelVersionId:De?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?_e.edits.push({_type:3,metadata:We.metadata,resource:We.uri,edit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:De?.getNotebookDocumentVersion(We.uri)}):We._type===5&&_e.edits.push({_type:3,metadata:We.metadata,resource:We.uri,notebookVersionId:De?.getNotebookDocumentVersion(We.uri),edit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(He.from)}});return _e}be.from=Ie;function ae(G){const De=new m.WorkspaceEdit;for(const _e of G.edits)_e.edit?De.replace(P.URI.revive(_e.resource),c.to(_e.edit.range),_e.edit.text):De.renameFile(P.URI.revive(_e.oldUri),P.URI.revive(_e.newUri),_e.options);return De}be.to=ae})(H=e.WorkspaceEdit||(e.WorkspaceEdit={}));var U;(function(be){const Ie=Object.create(null);Ie[m.SymbolKind.File]=0,Ie[m.SymbolKind.Module]=1,Ie[m.SymbolKind.Namespace]=2,Ie[m.SymbolKind.Package]=3,Ie[m.SymbolKind.Class]=4,Ie[m.SymbolKind.Method]=5,Ie[m.SymbolKind.Property]=6,Ie[m.SymbolKind.Field]=7,Ie[m.SymbolKind.Constructor]=8,Ie[m.SymbolKind.Enum]=9,Ie[m.SymbolKind.Interface]=10,Ie[m.SymbolKind.Function]=11,Ie[m.SymbolKind.Variable]=12,Ie[m.SymbolKind.Constant]=13,Ie[m.SymbolKind.String]=14,Ie[m.SymbolKind.Number]=15,Ie[m.SymbolKind.Boolean]=16,Ie[m.SymbolKind.Array]=17,Ie[m.SymbolKind.Object]=18,Ie[m.SymbolKind.Key]=19,Ie[m.SymbolKind.Null]=20,Ie[m.SymbolKind.EnumMember]=21,Ie[m.SymbolKind.Struct]=22,Ie[m.SymbolKind.Event]=23,Ie[m.SymbolKind.Operator]=24,Ie[m.SymbolKind.TypeParameter]=25;function ae(De){return typeof Ie[De]=="number"?Ie[De]:6}be.from=ae;function G(De){for(const _e in Ie)if(Ie[_e]===De)return Number(_e);return m.SymbolKind.Property}be.to=G})(U=e.SymbolKind||(e.SymbolKind={}));var z;(function(be){function Ie(G){switch(G){case m.SymbolTag.Deprecated:return 1}}be.from=Ie;function ae(G){switch(G){case 1:return m.SymbolTag.Deprecated}}be.to=ae})(z=e.SymbolTag||(e.SymbolTag={}));var Q;(function(be){function Ie(G){return{name:G.name,kind:U.from(G.kind),tags:G.tags&&G.tags.map(z.from),containerName:G.containerName,location:he.from(G.location)}}be.from=Ie;function ae(G){const De=new m.SymbolInformation(G.name,U.to(G.kind),G.containerName,he.to(G.location));return De.tags=G.tags&&G.tags.map(z.to),De}be.to=ae})(Q=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var ie;(function(be){function Ie(G){const De={name:G.name||"!!MISSING: name!!",detail:G.detail,range:c.from(G.range),selectionRange:c.from(G.selectionRange),kind:U.from(G.kind),tags:G.tags?.map(z.from)??[]};return G.children&&(De.children=G.children.map(Ie)),De}be.from=Ie;function ae(G){const De=new m.DocumentSymbol(G.name,G.detail,U.to(G.kind),c.to(G.range),c.to(G.selectionRange));return(0,k.isNonEmptyArray)(G.tags)&&(De.tags=G.tags.map(z.to)),G.children&&(De.children=G.children.map(ae)),De}be.to=ae})(ie=e.DocumentSymbol||(e.DocumentSymbol={}));var re;(function(be){function Ie(G){const De=new m.CallHierarchyItem(U.to(G.kind),G.name,G.detail||"",P.URI.revive(G.uri),c.to(G.range),c.to(G.selectionRange));return De._sessionId=G._sessionId,De._itemId=G._itemId,De}be.to=Ie;function ae(G,De,_e){if(De=De??G._sessionId,_e=_e??G._itemId,De===void 0||_e===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:_e,name:G.name,detail:G.detail,kind:U.from(G.kind),uri:G.uri,range:c.from(G.range),selectionRange:c.from(G.selectionRange),tags:G.tags?.map(z.from)}}be.from=ae})(re=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ce;(function(be){function Ie(ae){return new m.CallHierarchyIncomingCall(re.to(ae.from),ae.fromRanges.map(G=>c.to(G)))}be.to=Ie})(ce=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var de;(function(be){function Ie(ae){return new m.CallHierarchyOutgoingCall(re.to(ae.to),ae.fromRanges.map(G=>c.to(G)))}be.to=Ie})(de=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var he;(function(be){function Ie(G){return{range:G.range&&c.from(G.range),uri:G.uri}}be.from=Ie;function ae(G){return new m.Location(P.URI.revive(G.uri),c.to(G.range))}be.to=ae})(he=e.location||(e.location={}));var j;(function(be){function Ie(G){const De=G,_e=G;return{originSelectionRange:De.originSelectionRange?c.from(De.originSelectionRange):void 0,uri:De.targetUri?De.targetUri:_e.uri,range:c.from(De.targetRange?De.targetRange:_e.range),targetSelectionRange:De.targetSelectionRange?c.from(De.targetSelectionRange):void 0}}be.from=Ie;function ae(G){return{targetUri:P.URI.revive(G.uri),targetRange:c.to(G.range),targetSelectionRange:G.targetSelectionRange?c.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?c.to(G.originSelectionRange):void 0}}be.to=ae})(j=e.DefinitionLink||(e.DefinitionLink={}));var O;(function(be){function Ie(G){return{range:c.from(G.range),contents:F.fromMany(G.contents)}}be.from=Ie;function ae(G){return new m.Hover(G.contents.map(F.to),c.to(G.range))}be.to=ae})(O=e.Hover||(e.Hover={}));var V;(function(be){function Ie(G){return{range:c.from(G.range),expression:G.expression}}be.from=Ie;function ae(G){return new m.EvaluatableExpression(c.to(G.range),G.expression)}be.to=ae})(V=e.EvaluatableExpression||(e.EvaluatableExpression={}));var J;(function(be){function Ie(G){if(G instanceof m.InlineValueText)return{type:"text",range:c.from(G.range),text:G.text};if(G instanceof m.InlineValueVariableLookup)return{type:"variable",range:c.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof m.InlineValueEvaluatableExpression)return{type:"expression",range:c.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}be.from=Ie;function ae(G){switch(G.type){case"text":return{range:c.to(G.range),text:G.text};case"variable":return{range:c.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:c.to(G.range),expression:G.expression}}}be.to=ae})(J=e.InlineValue||(e.InlineValue={}));var le;(function(be){function Ie(G){return{frameId:G.frameId,stoppedLocation:c.from(G.stoppedLocation)}}be.from=Ie;function ae(G){return new m.InlineValueContext(G.frameId,c.to(G.stoppedLocation))}be.to=ae})(le=e.InlineValueContext||(e.InlineValueContext={}));var ge;(function(be){function Ie(G){return{range:c.from(G.range),kind:G.kind}}be.from=Ie;function ae(G){return new m.DocumentHighlight(c.to(G.range),G.kind)}be.to=ae})(ge=e.DocumentHighlight||(e.DocumentHighlight={}));var ue;(function(be){function Ie(ae){switch(ae){case 1:return m.CompletionTriggerKind.TriggerCharacter;case 2:return m.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return m.CompletionTriggerKind.Invoke}}be.to=Ie})(ue=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var oe;(function(be){function Ie(ae){return{triggerKind:ue.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}be.to=Ie})(oe=e.CompletionContext||(e.CompletionContext={}));var pe;(function(be){function Ie(G){switch(G){case m.CompletionItemTag.Deprecated:return 1}}be.from=Ie;function ae(G){switch(G){case 1:return m.CompletionItemTag.Deprecated}}be.to=ae})(pe=e.CompletionItemTag||(e.CompletionItemTag={}));var X;(function(be){const Ie=new Map([[m.CompletionItemKind.Method,0],[m.CompletionItemKind.Function,1],[m.CompletionItemKind.Constructor,2],[m.CompletionItemKind.Field,3],[m.CompletionItemKind.Variable,4],[m.CompletionItemKind.Class,5],[m.CompletionItemKind.Interface,7],[m.CompletionItemKind.Struct,6],[m.CompletionItemKind.Module,8],[m.CompletionItemKind.Property,9],[m.CompletionItemKind.Unit,12],[m.CompletionItemKind.Value,13],[m.CompletionItemKind.Constant,14],[m.CompletionItemKind.Enum,15],[m.CompletionItemKind.EnumMember,16],[m.CompletionItemKind.Keyword,17],[m.CompletionItemKind.Snippet,27],[m.CompletionItemKind.Text,18],[m.CompletionItemKind.Color,19],[m.CompletionItemKind.File,20],[m.CompletionItemKind.Reference,21],[m.CompletionItemKind.Folder,23],[m.CompletionItemKind.Event,10],[m.CompletionItemKind.Operator,11],[m.CompletionItemKind.TypeParameter,24],[m.CompletionItemKind.Issue,26],[m.CompletionItemKind.User,25]]);function ae(_e){return Ie.get(_e)??9}be.from=ae;const G=new Map([[0,m.CompletionItemKind.Method],[1,m.CompletionItemKind.Function],[2,m.CompletionItemKind.Constructor],[3,m.CompletionItemKind.Field],[4,m.CompletionItemKind.Variable],[5,m.CompletionItemKind.Class],[7,m.CompletionItemKind.Interface],[6,m.CompletionItemKind.Struct],[8,m.CompletionItemKind.Module],[9,m.CompletionItemKind.Property],[12,m.CompletionItemKind.Unit],[13,m.CompletionItemKind.Value],[14,m.CompletionItemKind.Constant],[15,m.CompletionItemKind.Enum],[16,m.CompletionItemKind.EnumMember],[17,m.CompletionItemKind.Keyword],[27,m.CompletionItemKind.Snippet],[18,m.CompletionItemKind.Text],[19,m.CompletionItemKind.Color],[20,m.CompletionItemKind.File],[21,m.CompletionItemKind.Reference],[23,m.CompletionItemKind.Folder],[10,m.CompletionItemKind.Event],[11,m.CompletionItemKind.Operator],[24,m.CompletionItemKind.TypeParameter],[25,m.CompletionItemKind.User],[26,m.CompletionItemKind.Issue]]);function De(_e){return G.get(_e)??m.CompletionItemKind.Property}be.to=De})(X=e.CompletionItemKind||(e.CompletionItemKind={}));var B;(function(be){function Ie(ae,G){const De=new m.CompletionItem(ae.label);return De.insertText=ae.insertText,De.kind=X.to(ae.kind),De.tags=ae.tags?.map(pe.to),De.detail=ae.detail,De.documentation=w.isMarkdownString(ae.documentation)?F.to(ae.documentation):ae.documentation,De.sortText=ae.sortText,De.filterText=ae.filterText,De.preselect=ae.preselect,De.commitCharacters=ae.commitCharacters,A.Range.isIRange(ae.range)?De.range=c.to(ae.range):typeof ae.range=="object"&&(De.range={inserting:c.to(ae.range.insert),replacing:c.to(ae.range.replace)}),De.keepWhitespace=typeof ae.insertTextRules=="undefined"?!1:Boolean(ae.insertTextRules&1),typeof ae.insertTextRules!="undefined"&&ae.insertTextRules&4?De.insertText=new m.SnippetString(ae.insertText):(De.insertText=ae.insertText,De.textEdit=De.range instanceof m.Range?new m.TextEdit(De.range,De.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(De.additionalTextEdits=ae.additionalTextEdits.map(_e=>Z.to(_e))),De.command=G&&ae.command?G.fromInternal(ae.command):void 0,De}be.to=Ie})(B=e.CompletionItem||(e.CompletionItem={}));var x;(function(be){function Ie(G){return{label:G.label,documentation:F.fromStrict(G.documentation)}}be.from=Ie;function ae(G){return{label:G.label,documentation:w.isMarkdownString(G.documentation)?F.to(G.documentation):G.documentation}}be.to=ae})(x=e.ParameterInformation||(e.ParameterInformation={}));var Y;(function(be){function Ie(G){return{label:G.label,documentation:F.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(x.from):[],activeParameter:G.activeParameter}}be.from=Ie;function ae(G){return{label:G.label,documentation:w.isMarkdownString(G.documentation)?F.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(x.to):[],activeParameter:G.activeParameter}}be.to=ae})(Y=e.SignatureInformation||(e.SignatureInformation={}));var fe;(function(be){function Ie(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(Y.from):[]}}be.from=Ie;function ae(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(Y.to):[]}}be.to=ae})(fe=e.SignatureHelp||(e.SignatureHelp={}));var ye;(function(be){function Ie(ae,G){const De=new m.InlayHint(l.to(G.position),typeof G.label=="string"?G.label:G.label.map(ke.to.bind(void 0,ae)),G.kind&&Re.to(G.kind));return De.textEdits=G.textEdits&&G.textEdits.map(Z.to),De.tooltip=w.isMarkdownString(G.tooltip)?F.to(G.tooltip):G.tooltip,De.paddingLeft=G.paddingLeft,De.paddingRight=G.paddingRight,De}be.to=Ie})(ye=e.InlayHint||(e.InlayHint={}));var ke;(function(be){function Ie(ae,G){const De=new m.InlayHintLabelPart(G.label);return De.tooltip=w.isMarkdownString(G.tooltip)?F.to(G.tooltip):G.tooltip,R.Command.is(G.command)&&(De.command=ae.fromInternal(G.command)),G.location&&(De.location=he.to(G.location)),De}be.to=Ie})(ke=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Re;(function(be){function Ie(G){return G}be.from=Ie;function ae(G){return G}be.to=ae})(Re=e.InlayHintKind||(e.InlayHintKind={}));var Ue;(function(be){function Ie(G){return{range:c.from(G.range),url:G.target,tooltip:G.tooltip}}be.from=Ie;function ae(G){let De;if(G.url)try{De=typeof G.url=="string"?P.URI.parse(G.url,!0):P.URI.revive(G.url)}catch{}return new m.DocumentLink(c.to(G.range),De)}be.to=ae})(Ue=e.DocumentLink||(e.DocumentLink={}));var Ne;(function(be){function Ie(G){const De=new m.ColorPresentation(G.label);return G.textEdit&&(De.textEdit=Z.to(G.textEdit)),G.additionalTextEdits&&(De.additionalTextEdits=G.additionalTextEdits.map(_e=>Z.to(_e))),De}be.to=Ie;function ae(G){return{label:G.label,textEdit:G.textEdit?Z.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(De=>Z.from(De)):void 0}}be.from=ae})(Ne=e.ColorPresentation||(e.ColorPresentation={}));var se;(function(be){function Ie(G){return new m.Color(G[0],G[1],G[2],G[3])}be.to=Ie;function ae(G){return[G.red,G.green,G.blue,G.alpha]}be.from=ae})(se=e.Color||(e.Color={}));var Ee;(function(be){function Ie(G){return{range:c.from(G.range)}}be.from=Ie;function ae(G){return new m.SelectionRange(c.to(G.range))}be.to=ae})(Ee=e.SelectionRange||(e.SelectionRange={}));var me;(function(be){function Ie(ae){switch(ae){case 2:return m.TextDocumentSaveReason.AfterDelay;case 1:return m.TextDocumentSaveReason.Manual;case 3:case 4:return m.TextDocumentSaveReason.FocusOut}}be.to=Ie})(me=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Te;(function(be){function Ie(G){switch(G){case m.TextEditorLineNumbersStyle.Off:return 0;case m.TextEditorLineNumbersStyle.Relative:return 2;case m.TextEditorLineNumbersStyle.On:default:return 1}}be.from=Ie;function ae(G){switch(G){case 0:return m.TextEditorLineNumbersStyle.Off;case 2:return m.TextEditorLineNumbersStyle.Relative;case 1:default:return m.TextEditorLineNumbersStyle.On}}be.to=ae})(Te=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Fe;(function(be){function Ie(G){if(G===m.EndOfLine.CRLF)return 1;if(G===m.EndOfLine.LF)return 0}be.from=Ie;function ae(G){if(G===1)return m.EndOfLine.CRLF;if(G===0)return m.EndOfLine.LF}be.to=ae})(Fe=e.EndOfLine||(e.EndOfLine={}));var Ye;(function(be){function Ie(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case m.ProgressLocation.SourceControl:return 3;case m.ProgressLocation.Window:return 10;case m.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}be.from=Ie})(Ye=e.ProgressLocation||(e.ProgressLocation={}));var Be;(function(be){function Ie(ae){const G={start:ae.start+1,end:ae.end+1};return ae.kind&&(G.kind=je.from(ae.kind)),G}be.from=Ie})(Be=e.FoldingRange||(e.FoldingRange={}));var je;(function(be){function Ie(ae){if(ae)switch(ae){case m.FoldingRangeKind.Comment:return R.FoldingRangeKind.Comment;case m.FoldingRangeKind.Imports:return R.FoldingRangeKind.Imports;case m.FoldingRangeKind.Region:return R.FoldingRangeKind.Region}}be.from=Ie})(je=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ge;(function(be){function Ie(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?c.from(ae.selection):void 0,override:typeof ae.override=="boolean"?E.EditorResolution.DISABLED:void 0}}be.from=Ie})(Ge=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ne;(function(be){function Ie(_e){return _e instanceof m.RelativePattern?_e.toJSON():typeof _e=="string"?_e:ae(_e)||G(_e)?new m.RelativePattern(_e.baseUri??_e.base,_e.pattern).toJSON():_e}be.from=Ie;function ae(_e){const We=_e;return We?P.URI.isUri(We.baseUri)&&typeof We.pattern=="string":!1}function G(_e){const We=_e;return We?typeof We.base=="string"&&typeof We.pattern=="string":!1}function De(_e){return typeof _e=="string"?_e:new m.RelativePattern(P.URI.revive(_e.baseUri),_e.pattern)}be.to=De})(ne=e.GlobPattern||(e.GlobPattern={}));var Ce;(function(be){function Ie(ae){if(ae){if(Array.isArray(ae))return ae.map(Ie);if(typeof ae=="string")return ae;{const G=ae;return{language:G.language,scheme:G.scheme,pattern:ne.from(G.pattern),exclusive:G.exclusive}}}else return}be.from=Ie})(Ce=e.LanguageSelector||(e.LanguageSelector={}));var Pe;(function(be){function Ie(G){return{start:G.start,end:G.end}}be.from=Ie;function ae(G){return new m.NotebookRange(G.start,G.end)}be.to=ae})(Pe=e.NotebookRange||(e.NotebookRange={}));var Le;(function(be){function Ie(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}be.to=Ie;function ae(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}be.from=ae})(Le=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Me;(function(be){function Ie(ae){if(ae===b.NotebookCellExecutionState.Executing)return m.NotebookCellExecutionState.Executing;if(ae===b.NotebookCellExecutionState.Pending)return m.NotebookCellExecutionState.Pending;if(ae===b.NotebookCellExecutionState.Unconfirmed)return m.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${ae}`)}be.to=Ie})(Me=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ke;(function(be){function Ie(G){switch(G){case m.NotebookCellKind.Markup:return b.CellKind.Markup;case m.NotebookCellKind.Code:default:return b.CellKind.Code}}be.from=Ie;function ae(G){switch(G){case b.CellKind.Markup:return m.NotebookCellKind.Markup;case b.CellKind.Code:default:return m.NotebookCellKind.Code}}be.to=ae})(Ke=e.NotebookCellKind||(e.NotebookCellKind={}));var $e;(function(be){function Ie(G){const De={metadata:G.metadata??Object.create(null),cells:[]};for(let _e of G.cells)m.NotebookCellData.validate(_e),De.cells.push(He.from(_e));return De}be.from=Ie;function ae(G){const De=new m.NotebookData(G.cells.map(He.to));return(0,v.isEmptyObject)(G.metadata)||(De.metadata=G.metadata),De}be.to=ae})($e=e.NotebookData||(e.NotebookData={}));var He;(function(be){function Ie(G){return{cellKind:Ke.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:Le.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(Ve.from):[]}}be.from=Ie;function ae(G){return new m.NotebookCellData(Ke.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(Ve.to):void 0,G.metadata,G.internalMetadata?Le.to(G.internalMetadata):void 0)}be.to=ae})(He=e.NotebookCellData||(e.NotebookCellData={}));var Qe;(function(be){function Ie(G){return{mime:G.mime,valueBytes:n.VSBuffer.wrap(G.data)}}be.from=Ie;function ae(G){return new m.NotebookCellOutputItem(G.valueBytes.buffer,G.mime)}be.to=ae})(Qe=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ve;(function(be){function Ie(G){return{outputId:G.id,items:G.items.map(Qe.from),metadata:G.metadata}}be.from=Ie;function ae(G){const De=G.items.map(Qe.to);return new m.NotebookCellOutput(De,G.outputId,G.metadata)}be.to=ae})(Ve=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ze;(function(be){function Ie(De){return G(De)?{include:(0,v.withNullAsUndefined)(ne.from(De.include)),exclude:(0,v.withNullAsUndefined)(ne.from(De.exclude))}:(0,v.withNullAsUndefined)(ne.from(De))}be.from=Ie;function ae(De){return G(De)?{include:ne.to(De.include),exclude:ne.to(De.exclude)}:ne.to(De)}be.to=ae;function G(De){const _e=De;return _e?!!_e.include&&!!_e.exclude:!1}})(Ze=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var it;(function(be){function Ie(ae){return{backgroundColor:ae.backgroundColor,borderColor:ae.borderColor,top:ae.top?I.from(ae.top):void 0}}be.from=Ie})(it=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var st;(function(be){function Ie(ae,G,De){const _e=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===m.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(_e,De),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}be.from=Ie})(st=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var tt;(function(be){function Ie(ae){return{transientOutputs:ae?.transientOutputs??!1,transientCellMetadata:ae?.transientCellMetadata??{},transientDocumentMetadata:ae?.transientDocumentMetadata??{}}}be.from=Ie})(tt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ut;(function(be){function Ie(G){return{uri:G.uri,provides:G.provides}}be.from=Ie;function ae(G){return new m.NotebookRendererScript(P.URI.revive(G.uri),G.provides)}be.to=ae})(ut=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ct;(function(be){function Ie(G){return{message:F.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,location:G.location&&{range:c.from(G.location.range),uri:G.location.uri}}}be.from=Ie;function ae(G){const De=new m.TestMessage(typeof G.message=="string"?G.message:F.to(G.message));return De.actualOutput=G.actual,De.expectedOutput=G.expected,De.location=G.location?he.to(G.location):void 0,De}be.to=ae})(ct=e.TestMessage||(e.TestMessage={}));var ht;(function(be){be.namespace=f.namespaceTestTag,be.denamespace=f.denamespaceTestTag})(ht=e.TestTag||(e.TestTag={}));var wt;(function(be){function Ie(_e){const We=(0,u.getPrivateApiFor)(_e).controllerId;return{extId:d.TestId.fromExtHostTestItem(_e,We).toString(),label:_e.label,uri:P.URI.revive(_e.uri),busy:!1,tags:_e.tags.map(qe=>ht.namespace(We,qe.id)),range:A.Range.lift(c.from(_e.range)),description:_e.description||null,sortText:_e.sortText||null,error:_e.error&&F.fromStrict(_e.error)||null}}be.from=Ie;function ae(_e){return{parent:void 0,error:void 0,id:d.TestId.fromString(_e.extId).localId,label:_e.label,uri:P.URI.revive(_e.uri),tags:(_e.tags||[]).map(We=>{const{tagId:qe}=ht.denamespace(We);return new m.TestTag(qe)}),range:c.to(_e.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:_e.description||void 0,sortText:_e.sortText||void 0}}be.toPlain=ae;function G(_e){const We=d.TestId.fromString(_e.extId),qe=new u.TestItemImpl(We.controllerId,We.localId,_e.label,P.URI.revive(_e.uri)||void 0);return qe.range=c.to(_e.range||void 0),qe.description=_e.description||void 0,qe.sortText=_e.sortText||void 0,qe}function De(_e){let We;for(const qe of _e.tests){const nt=G(qe.item);(0,u.getPrivateApiFor)(nt).parent=We,We=nt}return We}be.toItemFromContext=De})(wt=e.TestItem||(e.TestItem={})),function(be){function Ie(G){return{id:G.id}}be.from=Ie;function ae(G){return new m.TestTag(G.id)}be.to=ae}(ht=e.TestTag||(e.TestTag={}));var St;(function(be){const Ie=(G,De)=>{const _e={...wt.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(qe=>qe.type===0).map(ct.to)})),children:G.children.map(We=>De.get(We)).filter(v.isDefined).map(We=>Ie(We,De))};for(const We of _e.children)We.parent=_e;return _e};function ae(G){const De=[],_e=new Map;for(const We of G.items)_e.set(We.item.extId,We),G.request.targets.some(qe=>qe.controllerId===We.controllerId&&qe.testIds.includes(We.item.extId))&&De.push(We);return{completedAt:G.completedAt,results:De.map(We=>Ie(We,_e))}}be.to=ae})(St=e.TestResults||(e.TestResults={}));var Pt;(function(be){function Ie(_e){return{covered:_e.covered,total:_e.covered}}function ae(_e){return"line"in _e?l.from(_e):c.from(_e)}function G(_e){return"branches"in _e?{count:_e.executionCount,location:ae(_e.location),type:1,branches:_e.branches.length?_e.branches.map(We=>({count:We.executionCount,location:We.location&&ae(We.location)})):void 0}:{type:0,count:_e.executionCount,location:ae(_e.location)}}be.fromDetailed=G;function De(_e){return{uri:_e.uri,statement:Ie(_e.statementCoverage),branch:_e.branchCoverage&&Ie(_e.branchCoverage),function:_e.functionCoverage&&Ie(_e.functionCoverage),details:_e.detailedCoverage?.map(G)}}be.fromFile=De})(Pt=e.TestCoverage||(e.TestCoverage={}));var kt;(function(be){function Ie(ae){switch(ae){case 1:return m.CodeActionTriggerKind.Invoke;case 2:return m.CodeActionTriggerKind.Automatic}}be.to=Ie})(kt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var _t;(function(be){function Ie(G){const De=new m.TypeHierarchyItem(U.to(G.kind),G.name,G.detail||"",P.URI.revive(G.uri),c.to(G.range),c.to(G.selectionRange));return De._sessionId=G._sessionId,De._itemId=G._itemId,De}be.to=Ie;function ae(G,De,_e){if(De=De??G._sessionId,_e=_e??G._itemId,De===void 0||_e===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:_e,kind:U.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:c.from(G.range),selectionRange:c.from(G.selectionRange),tags:G.tags?.map(z.from)}}be.from=ae})(_t=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(ve[240],we([0,1,12,235,13,96,103,110,236,108,111,8,190,109]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let u=class{constructor(f,d,p,m,y,c,o,l,i,t){this._remoteAuthority=f,this._channel=d,this._configurationService=p,this._workspaceContextService=m,this._resolverService=y,this._environmentVariableService=c,this._remoteAuthorityResolverService=o,this._logService=l,this._editorService=i,this._labelService=t}get onPtyHostExit(){return this._channel.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this._channel.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this._channel.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this._channel.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this._channel.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this._channel.listen("$onProcessDataEvent")}get onProcessExit(){return this._channel.listen("$onProcessExitEvent")}get onProcessReady(){return this._channel.listen("$onProcessReadyEvent")}get onProcessReplay(){return this._channel.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this._channel.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this._channel.listen("$onExecuteCommand")}get onDidRequestDetach(){return this._channel.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this._channel.listen("$onDidChangeProperty")}restartPtyHost(){return this._channel.call("$restartPtyHost",[])}async createProcess(f,d,p,m,y,c,o,l){await this._configurationService.whenRemoteConfigurationLoaded();const i=Object.create(null),t=p?(0,k.withNullAsUndefined)(this._workspaceContextService.getWorkspaceFolder(p)):void 0;let r;try{r=(await this._resolverService.resolveAnyMap(t,{shellLaunchConfig:f,configuration:d})).resolvedVariables}catch(I){this._logService.error(I)}if(r)for(const[I,W]of r.entries())(/^config:/.test(I)||I==="selectedText"||I==="lineNumber")&&(i[I]=W);const s=[];for(const[I,W]of this._environmentVariableService.collections.entries())s.push([I,(0,D.serializeEnvironmentVariableCollection)(W.map)]);const a=await this._remoteAuthorityResolverService.resolveAuthority(this._remoteAuthority),h=a.options&&a.options.extensionHostEnv,g=this._workspaceContextService.getWorkspace(),_=g.folders,F=p?this._workspaceContextService.getWorkspaceFolder(p):null,$=P.EditorResourceAccessor.getOriginalUri(this._editorService.activeEditor,{supportSideBySide:P.SideBySideEditor.PRIMARY,filterByScheme:[R.Schemas.file,R.Schemas.vscodeUserData,R.Schemas.vscodeRemote]}),K={configuration:d,resolvedVariables:i,envVariableCollections:s,shellLaunchConfig:f,workspaceId:g.id,workspaceName:this._labelService.getWorkspaceLabel(g),workspaceFolders:_,activeWorkspaceFolder:F,activeFileResource:$,shouldPersistTerminal:y,options:m,cols:c,rows:o,unicodeVersion:l,resolverEnv:h};return await this._channel.call("$createProcess",K)}requestDetachInstance(f,d){return this._channel.call("$requestDetachInstance",[f,d])}acceptDetachInstanceReply(f,d){return this._channel.call("$acceptDetachInstanceReply",[f,d])}attachToProcess(f){return this._channel.call("$attachToProcess",[f])}detachFromProcess(f){return this._channel.call("$detachFromProcess",[f])}listProcesses(){return this._channel.call("$listProcesses")}reduceConnectionGraceTime(){return this._channel.call("$reduceConnectionGraceTime")}processBinary(f,d){return this._channel.call("$processBinary",[f,d])}start(f){return this._channel.call("$start",[f])}input(f,d){return this._channel.call("$input",[f,d])}acknowledgeDataEvent(f,d){return this._channel.call("$acknowledgeDataEvent",[f,d])}setUnicodeVersion(f,d){return this._channel.call("$setUnicodeVersion",[f,d])}shutdown(f,d){return this._channel.call("$shutdown",[f,d])}resize(f,d,p){return this._channel.call("$resize",[f,d,p])}getInitialCwd(f){return this._channel.call("$getInitialCwd",[f])}getCwd(f){return this._channel.call("$getCwd",[f])}orphanQuestionReply(f){return this._channel.call("$orphanQuestionReply",[f])}sendCommandResult(f,d,p){return this._channel.call("$sendCommandResult",[f,d,p])}installAutoReply(f,d){return this._channel.call("$installAutoReply",[f,d])}uninstallAllAutoReplies(){return this._channel.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(f){return this._channel.call("$getDefaultSystemShell",[f])}getProfiles(f,d,p){return this._channel.call("$getProfiles",[this._workspaceContextService.getWorkspace().id,f,d,p])}acceptPtyHostResolvedVariables(f,d){return this._channel.call("$acceptPtyHostResolvedVariables",[f,d])}getEnvironment(){return this._channel.call("$getEnvironment")}getWslPath(f){return this._channel.call("$getWslPath",[f])}setTerminalLayoutInfo(f){const p={workspaceId:this._workspaceContextService.getWorkspace().id,tabs:f?f.tabs:[]};return this._channel.call("$setTerminalLayoutInfo",p)}updateTitle(f,d,p){return this._channel.call("$updateTitle",[f,d,p])}updateIcon(f,d,p){return this._channel.call("$updateIcon",[f,d,p])}refreshProperty(f,d){return this._channel.call("$refreshProperty",[f,d])}updateProperty(f,d,p){return this._channel.call("$updateProperty",[f,d,p])}getTerminalLayoutInfo(){const d={workspaceId:this._workspaceContextService.getWorkspace().id};return this._channel.call("$getTerminalLayoutInfo",d)}reviveTerminalProcesses(f,d){return this._channel.call("$reviveTerminalProcesses",[f,d])}serializeTerminalState(f){return this._channel.call("$serializeTerminalState",[f])}};u=Ae([Oe(2,n.IWorkbenchConfigurationService),Oe(3,T.IWorkspaceContextService),Oe(4,v.IConfigurationResolverService),Oe(5,S.IEnvironmentVariableService),Oe(6,C.IRemoteAuthorityResolverService),Oe(7,w.ILogService),Oe(8,A.IEditorService),Oe(9,E.ILabelService)],u),e.RemoteTerminalChannelClient=u}),define(ve[241],we([0,1,170,5,20,56,59,18,142,12,4,35,63,40,17]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionScanner=e.ExtensionScannerInput=e.ExtensionManifestValidator=e.Translations=void 0;const b="package.json";var f;(function(s){function a(h,g){if(h===g)return!0;let _=Object.keys(h),F=new Set;for(let $ of Object.keys(g))F.add($);if(_.length!==F.size)return!1;for(let $ of _){if(h[$]!==g[$])return!1;F.delete($)}return F.size===0}s.equals=a})(f=e.Translations||(e.Translations={}));class d{constructor(a,h,g,_,F,$,K){this._ourVersion=a,this._ourProductDate=h,this._absoluteFolderPath=g,this._isBuiltin=_,this._isUnderDevelopment=F,this._log=$,this._fileService=K,this._absoluteManifestPath=n.join(this._absoluteFolderPath,b)}_error(a,h){this._log.error(`[${a}]: ${h}`)}_warn(a,h){this._log.warn(`[${a}]: ${h}`)}}class p extends d{static _fastParseJSON(a,h){try{return JSON.parse(a)}catch{return T.parse(a,h)}}parse(){return i(this._fileService,this._absoluteManifestPath).then(a=>{const h=[],g=p._fastParseJSON(a,h);if(T.getNodeType(g)!=="object")this._error(this._absoluteFolderPath,k.localize(0,null,this._absoluteManifestPath));else{if(h.length===0)return g.uuid=g.__metadata?.id,g.targetPlatform=g.__metadata?.targetPlatform??"undefined",g.isUserBuiltin=!!g.__metadata?.isBuiltin,delete g.__metadata,g;h.forEach(_=>{this._error(this._absoluteFolderPath,k.localize(1,null,this._absoluteManifestPath,_.offset,_.length,(0,v.getParseErrorMessage)(_.error)))})}return null},a=>(a.code==="ENOENT"||this._error(this._absoluteFolderPath,k.localize(2,null,this._absoluteManifestPath,a.message)),null))}}class m extends d{constructor(a,h,g,_,F,$,K,I){super(a,h,g,_,F,K,I);this._nlsConfig=$}replaceNLS(a){const h=(W,M)=>{M.forEach(q=>{this._error(this._absoluteFolderPath,k.localize(3,null,W,(0,v.getParseErrorMessage)(q.error)))})},g=W=>{this._error(this._absoluteFolderPath,k.localize(4,null,W))};let _=n.extname(this._absoluteManifestPath),F=this._absoluteManifestPath.substr(0,this._absoluteManifestPath.length-_.length);const $=`${a.publisher}.${a.name}`;let K=this._nlsConfig.translations[$],I;return K?I=i(this._fileService,K).then(W=>{let M=[],q=T.parse(W,M);return M.length>0?(h(K,M),{values:void 0,default:`${F}.nls.json`}):T.getNodeType(q)!=="object"?(g(K),{values:void 0,default:`${F}.nls.json`}):{values:q.contents?q.contents.package:void 0,default:`${F}.nls.json`}},W=>({values:void 0,default:`${F}.nls.json`})):I=t(this._fileService,F+".nls"+_).then(W=>{if(!!W)return m.findMessageBundles(this._nlsConfig,F,this._fileService).then(M=>M.localized?i(this._fileService,M.localized).then(q=>{let Z=[],H=T.parse(q,Z);return Z.length>0?(h(M.localized,Z),{values:void 0,default:M.original}):T.getNodeType(H)!=="object"?(g(M.localized),{values:void 0,default:M.original}):{values:H,default:M.original}},q=>({values:void 0,default:M.original})):{values:void 0,default:M.original},M=>{})}),I.then(W=>{if(W===void 0)return a;let M=[];return this.resolveOriginalMessageBundle(W.default,M).then(q=>{if(M.length>0)return h(W.default,M),a;if(T.getNodeType(W)!=="object")return g(W.default),a;const Z=W.values||Object.create(null);return m._replaceNLStrings(this._nlsConfig,a,Z,q,this._absoluteFolderPath,this._log),a})},W=>a)}resolveOriginalMessageBundle(a,h){return new Promise((g,_)=>{a?i(this._fileService,a).then(F=>{g(T.parse(F,h))},F=>{g(null)}):g(null)})}static findMessageBundles(a,h,g){return new Promise((_,F)=>{function $(K,I){let W=`${K}.nls.${I}.json`;t(g,W).then(M=>{M&&_({localized:W,original:`${K}.nls.json`});let q=I.lastIndexOf("-");q===-1?_({localized:`${K}.nls.json`,original:null}):(I=I.substring(0,q),$(K,I))})}if(a.devMode||a.pseudo||!a.locale)return _({localized:h+".nls.json",original:null});$(h,a.locale)})}static _replaceNLStrings(a,h,g,_,F,$){function K(I,W,M){const q=I[W];if(P.isString(q)){const Z=q,H=Z.length;if(H>1&&Z[0]==="%"&&Z[H-1]==="%"){const U=Z.substr(1,H-2);let z=g[U];z===void 0&&_&&(z=_[U]);let Q=typeof z=="string"?z:typeof z?.message=="string"?z.message:void 0;if(Q!==void 0)a.pseudo&&(Q="\uFF3B"+Q.replace(/[aouei]/g,"$&$&")+"\uFF3D"),I[W]=M&&(W==="title"||W==="category")&&_?{value:Q,original:_[U]}:Q;else{const ie=k.localize(5,null,U);$.warn(`[${F}]: ${ie}`)}}}else if(P.isObject(q))for(let Z in q)q.hasOwnProperty(Z)&&(Z==="commands"?K(q,Z,!0):K(q,Z,M));else if(P.isArray(q))for(let Z=0;Z<q.length;Z++)K(q,Z,M)}for(let I in h)h.hasOwnProperty(I)&&K(h,I)}}class y extends d{validate(a){let h=a;h.isBuiltin=this._isBuiltin,h.isUserBuiltin=!this._isBuiltin&&!!h.isUserBuiltin,h.isUnderDevelopment=this._isUnderDevelopment;let g=[];return y.isValidExtensionManifest(this._ourVersion,this._ourProductDate,A.URI.file(this._absoluteFolderPath),h,h.isBuiltin,g)?(g.forEach(_=>{this._warn(this._absoluteFolderPath,_)}),h.publisher||(h.publisher=S.UNDEFINED_PUBLISHER),h.id=(0,R.getExtensionId)(h.publisher,h.name),h.identifier=new S.ExtensionIdentifier(h.id),h.extensionLocation=A.URI.file(this._absoluteFolderPath),h):(g.forEach(_=>{this._error(this._absoluteFolderPath,_)}),null)}static isValidExtensionManifest(a,h,g,_,F,$){return y.baseIsValidExtensionManifest(g,_,$)?C.valid(_.version)?(0,E.isValidExtensionVersion)(a,h,_,F,$):($.push(k.localize(6,null)),!1):!1}static baseIsValidExtensionManifest(a,h,g){if(!h)return g.push(k.localize(7,null)),!1;if(typeof h.publisher!="undefined"&&typeof h.publisher!="string")return g.push(k.localize(8,null)),!1;if(typeof h.name!="string")return g.push(k.localize(9,null,"name")),!1;if(typeof h.version!="string")return g.push(k.localize(10,null,"version")),!1;if(!h.engines)return g.push(k.localize(11,null,"engines")),!1;if(typeof h.engines.vscode!="string")return g.push(k.localize(12,null,"engines.vscode")),!1;if(typeof h.extensionDependencies!="undefined"&&!y._isStringArray(h.extensionDependencies))return g.push(k.localize(13,null,"extensionDependencies")),!1;if(typeof h.activationEvents!="undefined"){if(!y._isStringArray(h.activationEvents))return g.push(k.localize(14,null,"activationEvents")),!1;if(typeof h.main=="undefined"&&typeof h.browser=="undefined")return g.push(k.localize(15,null,"activationEvents","main")),!1}if(typeof h.extensionKind!="undefined"&&typeof h.main=="undefined"&&g.push(k.localize(16,null,"extensionKind")),typeof h.main!="undefined"){if(typeof h.main!="string")return g.push(k.localize(17,null,"main")),!1;{const _=w.joinPath(a,h.main);w.isEqualOrParent(_,a)||g.push(k.localize(18,null,_.path,a.path))}if(typeof h.activationEvents=="undefined")return g.push(k.localize(19,null,"activationEvents","main")),!1}if(typeof h.browser!="undefined"){if(typeof h.browser!="string")return g.push(k.localize(20,null,"browser")),!1;{const _=w.joinPath(a,h.browser);w.isEqualOrParent(_,a)||g.push(k.localize(21,null,_.path,a.path))}if(typeof h.activationEvents=="undefined")return g.push(k.localize(22,null,"activationEvents","browser")),!1}return!0}static _isStringArray(a){if(!Array.isArray(a))return!1;for(let h=0,g=a.length;h<g;h++)if(typeof a[h]!="string")return!1;return!0}}e.ExtensionManifestValidator=y;class c{constructor(a,h,g,_,F,$,K,I,W,M){this.ourVersion=a,this.ourProductDate=h,this.commit=g,this.locale=_,this.devMode=F,this.absoluteFolderPath=$,this.isBuiltin=K,this.isUnderDevelopment=I,this.targetPlatform=W,this.translations=M}static createNLSConfig(a){return{devMode:a.devMode,locale:a.locale,pseudo:a.locale==="pseudo",translations:a.translations}}static equals(a,h){return a.ourVersion===h.ourVersion&&a.ourProductDate===h.ourProductDate&&a.commit===h.commit&&a.locale===h.locale&&a.devMode===h.devMode&&a.absoluteFolderPath===h.absoluteFolderPath&&a.isBuiltin===h.isBuiltin&&a.isUnderDevelopment===h.isUnderDevelopment&&a.mtime===h.mtime&&a.targetPlatform===h.targetPlatform&&f.equals(a.translations,h.translations)}}e.ExtensionScannerInput=c;class o{constructor(a,h){this.root=a,this._fileService=h}resolveExtensions(){return r(this._fileService,this.root).then(a=>a.map(h=>({name:h,path:n.join(this.root,h)})))}}class l{static scanExtension(a,h,g,_,F,$,K,I){return g=n.normalize(g),new p(a,h,g,_,F,K,I).parse().then(M=>M===null?null:new m(a,h,g,_,F,$,K,I).replaceNLS(M)).then(M=>M===null?null:new y(a,h,g,_,F,K,I).validate(M))}static async scanExtensions(a,h,g,_=null){const F=a.absoluteFolderPath,$=a.isBuiltin,K=a.isUnderDevelopment;_||(_=new o(F,g));try{let I={};if(!$)try{const H=await i(g,n.join(F,".obsolete"));I=JSON.parse(H)}catch{}let W=await _.resolveExtensions();W.sort((H,U)=>H.name<U.name?-1:1),$||(W=W.filter(H=>H.name.indexOf(".")!==0));const M=c.createNLSConfig(a);let q=await Promise.all(W.map(H=>this.scanExtension(a.ourVersion,a.ourProductDate,H.path,$,K,M,h,g))),Z=D.coalesce(q);return Z=Z.filter(H=>H!==null&&!I[new R.ExtensionKey({id:(0,R.getGalleryExtensionId)(H.publisher,H.name)},H.version,H.targetPlatform).toString()]),$||(Z=this.filterOutdatedExtensions(Z,a.targetPlatform)),Z.sort((H,U)=>H.extensionLocation.fsPath<U.extensionLocation.fsPath?-1:1),Z}catch(I){return h.error(`Error scanning extensions at ${F}:`),h.error(I),[]}}static scanOneOrMultipleExtensions(a,h,g){const _=a.absoluteFolderPath,F=a.isBuiltin,$=a.isUnderDevelopment;return t(g,n.join(_,b)).then(K=>{if(K){const I=c.createNLSConfig(a);return this.scanExtension(a.ourVersion,a.ourProductDate,_,F,$,I,h,g).then(W=>W===null?[]:[W])}return this.scanExtensions(a,h,g)},K=>(h.error(`Error scanning extensions at ${_}:`),h.error(K),[]))}static scanSingleExtension(a,h,g){const _=a.absoluteFolderPath,F=a.isBuiltin,$=a.isUnderDevelopment,K=c.createNLSConfig(a);return this.scanExtension(a.ourVersion,a.ourProductDate,_,F,$,K,h,g)}static mergeBuiltinExtensions(a,h){return Promise.all([a,h]).then(([g,_])=>{let F=Object.create(null);for(let K=0,I=g.length;K<I;K++)F[S.ExtensionIdentifier.toKey(g[K].identifier)]=g[K];for(let K=0,I=_.length;K<I;K++)F[S.ExtensionIdentifier.toKey(_[K].identifier)]=_[K];let $=Object.keys(F).map(K=>F[K]);return $.sort((K,I)=>{const W=n.basename(K.extensionLocation.fsPath),M=n.basename(I.extensionLocation.fsPath);return W<M?-1:W>M?1:0}),$})}static filterOutdatedExtensions(a,h){const g=new Map;for(const _ of a){const F=_.identifier.value,$=g.get(F);$&&(C.gt($.version,_.version)||C.eq($.version,_.version)&&$.targetPlatform===h)||g.set(F,_)}return[...g.values()]}}e.ExtensionScanner=l;async function i(s,a){try{return(await s.readFile(A.URI.file(a),{atomic:!0})).value.toString()}catch(h){if((0,u.toFileOperationResult)(h)===1){const g=new Error("File not found");throw g.code="ENOENT",g}throw h}}async function t(s,a){try{return(await s.resolve(A.URI.file(a))).isFile}catch{return!1}}async function r(s,a){const h=await s.resolve(A.URI.file(a)),g=[];for(const _ of h.children||[])_.isDirectory&&g.push(_.name);return g}}),define(ve[242],we([0,1,3,44,4,57,166,8,241,40,61,105,89,84,209,5,24,19]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E,S,u,b,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;let p=null;function m(){return p||(p=(0,b.normalize)((0,b.join)(D.FileAccess.asFileUri("",ee).fsPath,"..","extensions"))),p}let y=null;function c(){return y||(y=(0,b.normalize)((0,b.join)(D.FileAccess.asFileUri("",ee).fsPath,"..",".build","builtInExtensions"))),y}class o{constructor(i,t,r,s,a,h,g,_){if(this._connectionToken=i,this.environmentService=t,this._extensionManagementService=s,this.logService=a,this.productService=h,this.extensionHostStatusService=g,this._fileService=_,t.args["install-builtin-extension"]){const $={isMachineScoped:!!t.args["do-not-sync"],installPreReleaseVersion:!!t.args["pre-release"]};this.whenExtensionsReady=r.installExtensions([],t.args["install-builtin-extension"],$,!!t.args.force).then(null,K=>{a.error(K)})}else this.whenExtensionsReady=Promise.resolve();const F=t.args["install-extension"];if(F){const $=F.map(K=>/\.vsix$/i.test(K)?w.URI.file((0,b.isAbsolute)(K)?K:(0,b.join)((0,f.cwd)(),K)):K);this.whenExtensionsReady.then(()=>r.installExtensions($,[],{isMachineScoped:!!t.args["do-not-sync"],installPreReleaseVersion:!!t.args["pre-release"]},!!t.args.force)).then(null,K=>{a.error(K)})}}async call(i,t,r){switch(t){case"getEnvironmentData":{const s=r,a=(0,C.createURITransformer)(s.remoteAuthority);let h=await this._getEnvironmentData();return h=(0,A.transformOutgoingURIs)(h,a),h}case"getExtensionHostExitInfo":{const s=r;return this.extensionHostStatusService.getExitInfo(s.reconnectionToken)}case"whenExtensionsReady":{await this.whenExtensionsReady;return}case"scanExtensions":{await this.whenExtensionsReady;const s=r,a=s.language;this.logService.trace(`Scanning extensions using UI language: ${a}`);const h=(0,C.createURITransformer)(s.remoteAuthority),g=s.extensionDevelopmentPath&&s.extensionDevelopmentPath.map($=>w.URI.revive(h.transformIncoming($))),_=g?g.filter($=>$.scheme===D.Schemas.file).map($=>$.fsPath):void 0;let F=await this._scanExtensions(a,_);return F=(0,A.transformOutgoingURIs)(F,h),this.logService.trace("Scanned Extensions",F),o._massageWhenConditions(F),F}case"scanSingleExtension":{await this.whenExtensionsReady;const s=r,a=s.language,h=s.isBuiltin,g=(0,C.createURITransformer)(s.remoteAuthority),_=w.URI.revive(g.transformIncoming(s.extensionLocation)),F=_.scheme===D.Schemas.file?_.fsPath:null;if(!F)return null;const $=await this._getTranslations(a);let K=await this._scanSingleExtension(F,h,a,$);return K?(K=(0,A.transformOutgoingURIs)(K,g),o._massageWhenConditions([K]),K):null}case"getDiagnosticInfo":{const s=r,a={machineInfo:(0,u.getMachineInfo)()},h=s.includeProcesses?(0,S.listProcesses)(process.pid):Promise.resolve();let g=[];const _={};if(s.folders){const F=(0,C.createURITransformer)("");g=s.folders.map(K=>w.URI.revive(F.transformIncoming(K))).filter(K=>K.scheme==="file").map(K=>(0,u.collectWorkspaceStats)(K.fsPath,["node_modules",".git"]).then(I=>{_[(0,b.basename)(K.fsPath)]=I}))}return Promise.all([h,...g]).then(([F,$])=>(a.processes=F||void 0,a.workspaceMetadata=s.folders?_:void 0,a))}}throw new Error(`IPC Command ${t} not found`)}listen(i,t,r){throw new Error("Not supported")}static _massageWhenConditions(i){const t=(_,F)=>_.replace(/file/g,"vscode-remote"),r=_=>{let F="";return F+=_.global?"g":"",F+=_.ignoreCase?"i":"",F+=_.multiline?"m":"",new RegExp(t(_.source,!0),F)},s=new class{mapDefined(_){return E.ContextKeyDefinedExpr.create(_)}mapNot(_){return E.ContextKeyNotExpr.create(_)}mapEquals(_,F){return _==="resourceScheme"&&typeof F=="string"?E.ContextKeyEqualsExpr.create(_,t(F,!1)):E.ContextKeyEqualsExpr.create(_,F)}mapNotEquals(_,F){return _==="resourceScheme"&&typeof F=="string"?E.ContextKeyNotEqualsExpr.create(_,t(F,!1)):E.ContextKeyNotEqualsExpr.create(_,F)}mapGreater(_,F){return E.ContextKeyGreaterExpr.create(_,F)}mapGreaterEquals(_,F){return E.ContextKeyGreaterEqualsExpr.create(_,F)}mapSmaller(_,F){return E.ContextKeySmallerExpr.create(_,F)}mapSmallerEquals(_,F){return E.ContextKeySmallerEqualsExpr.create(_,F)}mapRegex(_,F){return _==="resourceScheme"&&F?E.ContextKeyRegexExpr.create(_,r(F)):E.ContextKeyRegexExpr.create(_,F)}mapIn(_,F){return E.ContextKeyInExpr.create(_,F)}},a=_=>{if(!_||!_.when||!/resourceScheme/.test(_.when))return;const F=E.ContextKeyExpr.deserialize(_.when);if(!F)return;const $=F.map(s);_.when=$.serialize()},h=_=>{if(Array.isArray(_))for(let F of _)a(F);else a(_)},g=_=>{for(let F in _)h(_[F])};i.forEach(_=>{_.contributes&&(_.contributes.menus&&g(_.contributes.menus),_.contributes.keybindings&&h(_.contributes.keybindings),_.contributes.views&&g(_.contributes.views))})}async _getEnvironmentData(){return{pid:process.pid,connectionToken:this._connectionToken.type!==0?this._connectionToken.value:"",appRoot:w.URI.file(this.environmentService.appRoot),settingsPath:this.environmentService.machineSettingsResource,logsPath:w.URI.file(this.environmentService.logsPath),extensionsPath:w.URI.file(this.environmentService.extensionsPath),extensionHostLogsPath:w.URI.file((0,b.join)(this.environmentService.logsPath,`exthost${o._namePool++}`)),globalStorageHome:this.environmentService.globalStorageHome,workspaceStorageHome:this.environmentService.workspaceStorageHome,localHistoryHome:this.environmentService.localHistoryHome,userHome:this.environmentService.userHome,os:k.OS,arch:process.arch,marks:n.getMarks(),useHostProxy:!!this.environmentService.args["use-host-proxy"]}}async _getTranslations(i){const t=await(0,R.getNLSConfiguration)(i,this.environmentService.userDataPath);if(R.InternalNLSConfiguration.is(t))try{const r=await d.Promises.readFile(t._translationsConfigFile,"utf8");return JSON.parse(r)}catch{return Object.create(null)}else return Object.create(null)}async _scanExtensions(i,t){const r=await this._getTranslations(i),[s,a,h]=await Promise.all([this._scanBuiltinExtensions(i,r),this._scanInstalledExtensions(i,r),this._scanDevelopedExtensions(i,r,t)]);let g=new Map;s.forEach(F=>{!F||g.set(P.ExtensionIdentifier.toKey(F.identifier),F)}),a.forEach(F=>{!F||(g.has(P.ExtensionIdentifier.toKey(F.identifier))&&console.warn(T.localize(0,null,g.get(P.ExtensionIdentifier.toKey(F.identifier)).extensionLocation.fsPath,F.extensionLocation.fsPath)),g.set(P.ExtensionIdentifier.toKey(F.identifier),F))}),h.forEach(F=>{!F||g.set(P.ExtensionIdentifier.toKey(F.identifier),F)});const _=[];return g.forEach(F=>_.push(F)),_}async _scanDevelopedExtensions(i,t,r){if(r){const s=await this._extensionManagementService.getTargetPlatform(),a=r.map(_=>v.ExtensionScanner.scanOneOrMultipleExtensions(new v.ExtensionScannerInput(this.productService.version,this.productService.date,this.productService.commit,i,!0,_,!1,!0,s,t),this.logService,this._fileService)),h=await Promise.all(a);let g=[];for(let _ of h)g=g.concat(_);return g}return[]}async _scanBuiltinExtensions(i,t){const r=this.productService.version,s=this.productService.commit,a=this.productService.date,h=!!process.env.VSCODE_DEV,g=await this._extensionManagementService.getTargetPlatform(),_=new v.ExtensionScannerInput(r,a,s,i,h,m(),!0,!1,g,t),F=v.ExtensionScanner.scanExtensions(_,this.logService,this._fileService);let $=F;if(h){class K{constructor(Z){this.builtInExtensions=Z}resolveExtensions(){return Promise.resolve(this.builtInExtensions.map(Z=>({name:Z.name,path:(0,b.join)(c(),Z.name)})))}}const I=Promise.resolve(this.productService.builtInExtensions||[]),W=new v.ExtensionScannerInput(r,a,s,i,h,c(),!0,!1,g,{}),M=I.then(q=>new K(q)).then(q=>v.ExtensionScanner.scanExtensions(W,this.logService,this._fileService,q));$=v.ExtensionScanner.mergeBuiltinExtensions(F,M)}return $}async _scanInstalledExtensions(i,t){const r=await this._extensionManagementService.getTargetPlatform(),s=!!process.env.VSCODE_DEV,a=new v.ExtensionScannerInput(this.productService.version,this.productService.date,this.productService.commit,i,s,this.environmentService.extensionsPath,!1,!1,r,t);return v.ExtensionScanner.scanExtensions(a,this.logService,this._fileService)}async _scanSingleExtension(i,t,r,s){const a=await this._extensionManagementService.getTargetPlatform(),h=!!process.env.VSCODE_DEV,g=new v.ExtensionScannerInput(this.productService.version,this.productService.date,this.productService.commit,r,h,i,t,!1,a,s);return v.ExtensionScanner.scanSingleExtension(g,this.logService,this._fileService)}}e.RemoteAgentEnvironmentChannel=o,o._namePool=1}),define(ve[112],we([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class k{constructor(v){this._proxyIdentifierBrand=void 0,this.sid=v,this.nid=++k.count}}e.ProxyIdentifier=k,k.count=0;const n=[];function w(D){const v=new k(D);return n[v.nid]=v,v}e.createProxyIdentifier=w;function C(D){return n[D].sid}e.getStringIdentifierForProxy=C;class T{constructor(v){this.value=v}}e.SerializableObjectWithBuffers=T}),define(ve[243],we([0,1,50,4,112]),function(ee,e,k,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabInputKind=e.TextEditorRevealType=void 0;var C;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(C=e.TextEditorRevealType||(e.TextEditorRevealType={}));var T;(function(p){p[p.UnknownInput=0]="UnknownInput",p[p.TextInput=1]="TextInput",p[p.TextDiffInput=2]="TextDiffInput",p[p.NotebookInput=3]="NotebookInput",p[p.NotebookDiffInput=4]="NotebookDiffInput",p[p.CustomEditorInput=5]="CustomEditorInput",p[p.WebviewEditorInput=6]="WebviewEditorInput",p[p.TerminalEditorInput=7]="TerminalEditorInput"})(T=e.TabInputKind||(e.TabInputKind={}));var D;(function(p){p[p.Editable=0]="Editable",p[p.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var v;(function(p){p[p.Int8Array=1]="Int8Array",p[p.Uint8Array=2]="Uint8Array",p[p.Uint8ClampedArray=3]="Uint8ClampedArray",p[p.Int16Array=4]="Int16Array",p[p.Uint16Array=5]="Uint16Array",p[p.Int32Array=6]="Int32Array",p[p.Uint32Array=7]="Uint32Array",p[p.Float32Array=8]="Float32Array",p[p.Float64Array=9]="Float64Array",p[p.BigInt64Array=10]="BigInt64Array",p[p.BigUint64Array=11]="BigUint64Array"})(v=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(p){p[p.Text=1]="Text",p[p.Error=2]="Error",p[p.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var A;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(A=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var R;(function(p){p[p.None=0]="None",p[p.Process=1]="Process",p[p.Output=2]="Output"})(R=e.CandidatePortSource||(e.CandidatePortSource={}));class E{static mixin(m){return m._id=E._n++,m}}e.IdObject=E,E._n=0;var S;(function(p){p.label="a",p.kind="b",p.detail="c",p.documentation="d",p.sortText="e",p.filterText="f",p.preselect="g",p.insertText="h",p.insertTextRules="i",p.range="j",p.commitCharacters="k",p.additionalTextEdits="l",p.command="m",p.kindModifier="n"})(S=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var u;(function(p){p.defaultRanges="a",p.completions="b",p.isIncomplete="c",p.duration="d"})(u=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var b;(function(p){p[p.File=1]="File",p[p.Text=2]="Text",p[p.Cell=3]="Cell"})(b=e.WorkspaceEditType||(e.WorkspaceEditType={}));function f(p){if(p&&p.edits)for(const m of p.edits)typeof m.resource=="object"?m.resource=n.URI.revive(m.resource):(m.newUri=n.URI.revive(m.newUri),m.oldUri=n.URI.revive(m.oldUri)),m.metadata&&m.metadata.iconPath&&(m.metadata=(0,k.revive)(m.metadata));return p}e.reviveWorkspaceEditDto=f;var d;(function(p){p[p.Workspace=0]="Workspace",p[p.TextDocument=1]="TextDocument"})(d=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,w.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,w.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,w.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,w.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,w.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,w.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,w.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,w.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,w.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,w.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,w.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,w.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,w.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,w.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,w.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,w.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,w.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,w.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,w.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,w.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,w.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,w.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,w.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,w.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,w.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,w.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,w.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,w.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,w.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,w.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,w.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,w.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,w.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,w.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,w.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,w.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,w.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,w.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,w.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,w.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,w.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,w.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,w.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,w.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,w.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,w.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,w.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,w.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,w.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,w.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,w.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,w.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,w.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,w.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,w.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,w.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,w.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,w.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,w.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,w.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,w.createProxyIdentifier)("ExtHostTelemetry")}});var bt=this&&this.__classPrivateFieldSet||function(ee,e,k,n,w){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!w:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?w.call(ee,k):w?w.value=k:e.set(ee,k),k},et=this&&this.__classPrivateFieldGet||function(ee,e,k,n){if(k==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!n:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?n:k==="a"?n.call(ee):n?n.value:e.get(ee)};define(ve[244],we([0,1,12,107,239,22,243,18,13,50,51,86,4,2,6,228,106,16,112,36]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E,S,u,b,f,d,p,m){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let c=class{constructor(s,a){y.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,bt(this,y,s.getProxy(T.MainContext.MainThreadCommands),"f"),this._logService=a,this.converter=new o(this,h=>{const g=this._apiCommands.get(h);return g?.result===i.Void?g:void 0},a),this._argumentProcessors=[{processArgument(h){return(0,P.revive)(h)}},{processArgument(h){return(0,C.cloneAndChange)(h,function(g){if(A.Range.isIRange(g))return w.Range.to(g);if(R.Position.isIPosition(g))return w.Position.to(g);if(A.Range.isIRange(g.range)&&E.URI.isUri(g.uri))return w.location.to(g);if(g instanceof d.VSBuffer)return g.buffer.buffer;if(!Array.isArray(g))return g})}}]}registerArgumentProcessor(s){this._argumentProcessors.push(s)}registerApiCommand(s){const a=this.registerCommand(!1,s.id,async(...h)=>{const g=s.args.map((F,$)=>{if(!F.validate(h[$]))throw new Error(`Invalid argument '${F.name}' when running '${s.id}', received: ${h[$]}`);return F.convert(h[$])}),_=await this.executeCommand(s.internalId,...g);return s.result.convert(_,h,this.converter)},void 0,{description:s.description,args:s.args,returns:s.result.description});return this._apiCommands.set(s.id,s),new n.Disposable(()=>{a.dispose(),this._apiCommands.delete(s.id)})}registerCommand(s,a,h,g,_,F){if(this._logService.trace("ExtHostCommands#registerCommand",a),!a.trim().length)throw new Error("invalid id");if(this._commands.has(a))throw new Error(`command '${a}' already exists`);return this._commands.set(a,{callback:h,thisArg:g,description:_,extension:F}),s&&et(this,y,"f").$registerCommand(a),new n.Disposable(()=>{this._commands.delete(a)&&s&&et(this,y,"f").$unregisterCommand(a)})}executeCommand(s,...a){return this._logService.trace("ExtHostCommands#executeCommand",s),this._doExecuteCommand(s,a,!0)}async _doExecuteCommand(s,a,h){if(this._commands.has(s))return this._executeContributedCommand(s,a,!1);{let g=!1;const _=(0,C.cloneAndChange)(a,function(F){if(F instanceof n.Position)return w.Position.from(F);if(F instanceof n.Range)return w.Range.from(F);if(F instanceof n.Location)return w.location.from(F);if(n.NotebookRange.isNotebookRange(F))return w.NotebookRange.from(F);if(F instanceof ArrayBuffer)return g=!0,d.VSBuffer.wrap(new Uint8Array(F));if(F instanceof Uint8Array)return g=!0,d.VSBuffer.wrap(F);if(!Array.isArray(F))return F});try{const F=await et(this,y,"f").$executeCommand(s,g?new p.SerializableObjectWithBuffers(_):_,h);return(0,P.revive)(F)}catch(F){if(F instanceof Error&&F.message==="$executeCommand:retry")return this._doExecuteCommand(s,a,!1);throw F}}}async _executeContributedCommand(s,a,h){const g=this._commands.get(s);if(!g)throw new Error("Unknown command");let{callback:_,thisArg:F,description:$}=g;if($)for(let K=0;K<$.args.length;K++)try{(0,k.validateConstraint)(a[K],$.args[K].constraint)}catch{throw new Error(`Running the contributed command: '${s}' failed. Illegal argument '${$.args[K].name}' - ${$.args[K].description}`)}try{return await _.apply(F,a)}catch(K){if(s===this.converter.delegatingCommandId){const I=this.converter.getActualCommand(...a);I&&(s=I.command)}throw this._logService.error(K,s,g.extension?.identifier),h?new class extends Error{constructor(){super((0,m.toErrorMessage)(K));this.id=s,this.source=g.extension?.displayName??g.extension?.name}}:K}}$executeContributedCommand(s,...a){return this._logService.trace("ExtHostCommands#$executeContributedCommand",s),this._commands.has(s)?(a=a.map(h=>this._argumentProcessors.reduce((g,_)=>_.processArgument(g),h)),this._executeContributedCommand(s,a,!0)):Promise.reject(new Error(`Contributed command '${s}' does not exist.`))}getCommands(s=!1){return this._logService.trace("ExtHostCommands#getCommands",s),et(this,y,"f").$getCommands().then(a=>(s&&(a=a.filter(h=>h[0]!=="_")),a))}$getContributedCommandHandlerDescriptions(){const s=Object.create(null);for(let[a,h]of this._commands){let{description:g}=h;g&&(s[a]=g)}return Promise.resolve(s)}};y=new WeakMap,c=Ae([Oe(0,b.IExtHostRpcService),Oe(1,v.ILogService)],c),e.ExtHostCommands=c,e.IExtHostCommands=(0,u.createDecorator)("IExtHostCommands");class o{constructor(s,a,h){this._commands=s,this._lookupApiCommand=a,this._logService=h,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(s,a){if(!s)return;const h={$ident:void 0,id:s.command,title:s.title,tooltip:s.tooltip};if(!s.command)return h;const g=this._lookupApiCommand(s.command);if(g)h.id=g.internalId,h.arguments=g.args.map((_,F)=>_.convert(s.arguments&&s.arguments[F]));else if((0,D.isNonEmptyArray)(s.arguments)){const _=++this._cachIdPool;this._cache.set(_,s),a.add((0,S.toDisposable)(()=>{this._cache.delete(_),this._logService.trace("CommandsConverter#DISPOSE",_)})),h.$ident=_,h.id=this.delegatingCommandId,h.arguments=[_],this._logService.trace("CommandsConverter#CREATE",s.command,_)}return h}fromInternal(s){return typeof s.$ident=="number"?this._cache.get(s.$ident):{command:s.id,title:s.title,arguments:s.arguments}}getActualCommand(...s){return this._cache.get(s[0])}_executeConvertedCommand(...s){const a=this.getActualCommand(...s);return this._logService.trace("CommandsConverter#EXECUTE",s[0],a?a.command:"MISSING"),a?this._commands.executeCommand(a.command,...a.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=o;class l{constructor(s,a,h,g){this.name=s,this.description=a,this.validate=h,this.convert=g}optional(){return new l(this.name,`(optional) ${this.description}`,s=>s==null||this.validate(s),s=>s===void 0?void 0:s===null?null:this.convert(s))}with(s,a){return new l(s??this.name,a??this.description,this.validate,this.convert)}}e.ApiCommandArgument=l,l.Uri=new l("uri","Uri of a text document",r=>E.URI.isUri(r),r=>r),l.Position=new l("position","A position in a text document",r=>n.Position.isPosition(r),w.Position.from),l.Range=new l("range","A range in a text document",r=>n.Range.isRange(r),w.Range.from),l.Selection=new l("selection","A selection in a text document",r=>n.Selection.isSelection(r),w.Selection.from),l.Number=new l("number","",r=>typeof r=="number",r=>r),l.String=new l("string","",r=>typeof r=="string",r=>r),l.CallHierarchyItem=new l("item","A call hierarchy item",r=>r instanceof n.CallHierarchyItem,w.CallHierarchyItem.from),l.TypeHierarchyItem=new l("item","A type hierarchy item",r=>r instanceof n.TypeHierarchyItem,w.TypeHierarchyItem.from),l.TestItem=new l("testItem","A VS Code TestItem",r=>r instanceof f.TestItemImpl,w.TestItem.from);class i{constructor(s,a){this.description=s,this.convert=a}}e.ApiCommandResult=i,i.Void=new i("no result",r=>r);class t{constructor(s,a,h,g,_){this.id=s,this.internalId=a,this.description=h,this.args=g,this.result=_}}e.ApiCommand=t}),define(ve[245],we([0,1,76]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logRemoteEntryIfError=e.logRemoteEntry=void 0;function n(C,T,D=null){const v=(0,k.parse)(T).args;let P=v.shift();if(typeof P=="string")switch(T.severity||(T.severity="info"),D&&(/^\[/.test(D)||(D=`[${D}]`),/ $/.test(D)||(D=`${D} `),P=D+P),T.severity){case"log":case"info":C.info(P,...v);break;case"warn":C.warn(P,...v);break;case"error":C.error(P,...v);break}}e.logRemoteEntry=n;function w(C,T,D){const v=(0,k.parse)(T).args,P=v.shift();typeof P!="string"||T.severity!=="error"||(/^\[/.test(D)||(D=`[${D}]`),/ $/.test(D)||(D=`${D} `),C.error(D+P,...v))}e.logRemoteEntryIfError=w}),define(ve[113],we([0,1,6]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,k.createDecorator)("remoteAgentService")}),define(ve[246],we([0,1,9,2,8,185]),function(ee,e,k,n,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProviderClient=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remoteFilesystem";class T extends C.DiskFileSystemProviderClient{static register(v,P,A){const R=v.getConnection();if(!R)return n.Disposable.None;const E=new n.DisposableStore,S=(async()=>{try{const u=await v.getRawEnvironment();u?P.registerProvider(w.Schemas.vscodeRemote,E.add(new T(u,R))):A.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(u){A.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,k.getErrorMessage)(u))}})();return E.add(P.onWillActivateFileSystemProvider(u=>{u.scheme===w.Schemas.vscodeRemote&&u.join(S)})),E}constructor(v,P){super(P.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:v.os===3})}}e.RemoteFileSystemProviderClient=T}),define(ve[71],we([0,1,29,14,5,12,19,145,260,261]),function(ee,e,k,n,w,C,T,D,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class A extends Error{constructor(o,l){let i=l.message;switch(o){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=o,this.cause=l}}e.ExtractError=A;function R(c){const o=c.externalFileAttributes>>16||33188;return[448,56,7].map(l=>o&l).reduce((l,i)=>l+i,o&61440)}function E(c){if(c instanceof A)return c;let o;return/end of central directory record signature not found/.test(c.message)&&(o="CorruptZip"),new A(o,c)}function S(c,o,l,i,t,r){const s=w.dirname(o),a=w.join(i,s);if(!a.startsWith(i))return Promise.reject(new Error(D.localize(0,null,o)));const h=w.join(i,o);let g;return r.onCancellationRequested(()=>{g&&g.destroy()}),Promise.resolve(T.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((_,F)=>{if(!r.isCancellationRequested)try{g=(0,k.createWriteStream)(h,{mode:l}),g.once("close",()=>_()),g.once("error",F),c.once("error",F),c.pipe(g)}catch($){F($)}}))}function u(c,o,l,i){let t=(0,n.createCancelablePromise)(()=>Promise.resolve()),r=0;return i.onCancellationRequested(()=>{t.cancel(),c.close()}),new Promise((s,a)=>{const h=new n.Sequencer,g=_=>{_.isCancellationRequested||(r++,c.readEntry())};c.once("error",a),c.once("close",()=>t.then(()=>{i.isCancellationRequested||c.entryCount===r?s():a(new A("Incomplete",new Error(D.localize(1,null,r,c.entryCount))))},a)),c.readEntry(),c.on("entry",_=>{if(i.isCancellationRequested)return;if(!l.sourcePathRegex.test(_.fileName)){g(i);return}const F=_.fileName.replace(l.sourcePathRegex,"");if(/\/$/.test(F)){const I=w.join(o,F);t=(0,n.createCancelablePromise)(W=>T.Promises.mkdir(I,{recursive:!0}).then(()=>g(W)).then(void 0,a));return}const $=f(c,_),K=R(_);t=(0,n.createCancelablePromise)(I=>h.queue(()=>$.then(W=>S(W,F,K,o,l,I).then(()=>g(I)))).then(null,a))})})}function b(c,o=!1){return new Promise((l,i)=>{(0,v.open)(c,o?{lazyEntries:!0}:void 0,(t,r)=>{t?i(E(t)):l((0,C.assertIsDefined)(r))})})}function f(c,o){return new Promise((l,i)=>{c.openReadStream(o,(t,r)=>{t?i(E(t)):l((0,C.assertIsDefined)(r))})})}function d(c,o){return new Promise((l,i)=>{const t=new P.ZipFile;o.forEach(s=>{s.contents?t.addBuffer(typeof s.contents=="string"?Buffer.from(s.contents,"utf8"):s.contents,s.path):s.localPath&&t.addFile(s.localPath,s.path)}),t.end();const r=(0,k.createWriteStream)(c);t.outputStream.pipe(r),t.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>l(c))})}e.zip=d;function p(c,o,l={},i){const t=new RegExp(l.sourcePath?`^${l.sourcePath}`:"");let r=b(c,!0);return l.overwrite&&(r=r.then(s=>T.Promises.rm(o).then(()=>s))),r.then(s=>u(s,o,{sourcePathRegex:t},i))}e.extract=p;function m(c,o){return b(c).then(l=>new Promise((i,t)=>{l.on("entry",r=>{r.fileName===o&&f(l,r).then(s=>i(s),s=>t(s))}),l.once("close",()=>t(new Error(D.localize(2,null,o))))}))}function y(c,o){return m(c,o).then(l=>new Promise((i,t)=>{const r=[];l.once("error",t),l.on("data",s=>r.push(s)),l.on("end",()=>i(Buffer.concat(r)))}))}e.buffer=y}),define(ve[247],we([0,1,71,153]),function(ee,e,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function w(C){return(0,k.buffer)(C,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,n.localize)(0,null))}})}e.getManifest=w}),define(ve[248],we([0,1,18,14,9,2,8,5,3,20,56,4,23,19,71,154,27,30,35,178,40,17,13,28]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E,S,u,b,f,d,p,m,y,c,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let i=class extends C.Disposable{constructor(r,s,a,h,g,_){super();this.beforeRemovingExtension=r,this.targetPlatform=s,this.fileService=a,this.logService=h,this.environmentService=g,this.productService=_,this._devSystemExtensionsLocation=null,this.systemExtensionsLocation=R.URI.file(g.builtinExtensionsPath),this.userExtensionsLocation=R.URI.file(g.extensionsPath),this.uninstalledPath=(0,P.joinPath)(this.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new n.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(r){const s=[];r===null||r===0?(s.push(this.scanDefaultSystemExtensions()),s.push(this.environmentService.isBuilt?Promise.resolve([]):this.scanDevSystemExtensions())):(s.push(Promise.resolve([])),s.push(Promise.resolve([]))),s.push(this.scanUserExtensions(!1));try{const[a,h,g]=await Promise.all(s),_=this.dedupExtensions([...a,...h,...g],await this.targetPlatform);return r!==null?_.filter(F=>F.type===r):_}catch(a){throw this.joinErrors(a)}}async scanUserExtensions(r){this.logService.trace("Started scanning user extensions");let[s,a]=await Promise.all([this.getUninstalledExtensions(),this.scanFromUserExtensionsLocation()]);return a=a.filter(h=>!s[p.ExtensionKey.create(h).toString()]),a=r?this.dedupExtensions(a,await this.targetPlatform):a,this.logService.trace("Scanned user extensions:",a.length),a}async extractUserExtension(r,s,a,h){const g=r.toString(),_=D.join(this.userExtensionsLocation.fsPath,`.${(0,E.generateUuid)()}`),F=D.join(this.userExtensionsLocation.fsPath,g);try{await S.Promises.rm(F)}catch{throw new d.ExtensionManagementError((0,b.localize)(0,null,F,r.id),d.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(r,s,_,h);let $=await this.scanExtension(R.URI.file(_),1);if(!$)throw new Error((0,b.localize)(1,null,_));await this.storeMetadata($,{...a,installedTimestamp:Date.now()});try{await this.rename(r,_,F,Date.now()+2*60*1e3),this.logService.info("Renamed to",F)}catch(K){try{await S.Promises.rm(_)}catch{}if(K.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",r.id);else throw this.logService.info(`Rename failed because of ${(0,w.getErrorMessage)(K)}. Deleted from extracted location`,_),K}try{$=await this.scanExtension(R.URI.file(F),1)}catch{}if($)return $;throw new Error((0,b.localize)(2,null,this.userExtensionsLocation.fsPath))}async saveMetadataForLocalExtension(r,s){return this.setMetadata(r,s),await this.storeMetadata(r,{...s,installedTimestamp:r.installedTimestamp}),r}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...r){const s=r.map(a=>p.ExtensionKey.create(a));await this.withUninstalledExtensions(a=>{s.forEach(h=>a[h.toString()]=!0)})}async setInstalled(r){await this.withUninstalledExtensions(h=>delete h[r.toString()]);const a=(await this.scanUserExtensions(!0)).find(h=>p.ExtensionKey.create(h).equals(r))||null;return a?(await this.storeMetadata(a,{installedTimestamp:Date.now()}),this.scanExtension(a.location,a.type)):null}async removeExtension(r,s){this.logService.trace(`Deleting ${s} extension from disk`,r.identifier.id,r.location.fsPath),await S.Promises.rm(r.location.fsPath),this.logService.info("Deleted from disk",r.identifier.id,r.location.fsPath)}async removeUninstalledExtension(r){await this.removeExtension(r,"uninstalled"),await this.withUninstalledExtensions(s=>delete s[p.ExtensionKey.create(r).toString()])}async storeMetadata(r,s){s.isMachineScoped=s.isMachineScoped||void 0,s.isBuiltin=s.isBuiltin||void 0,s.installedTimestamp=s.installedTimestamp||void 0;const a=D.join(r.location.fsPath,"package.json"),h=await S.Promises.readFile(a,"utf8"),{manifest:g}=await this.parseManifest(h);return g.__metadata=s,await S.Promises.writeFile(a,JSON.stringify(g,null,"	")),r}async withUninstalledExtensions(r){return this.uninstalledFileLimiter.queue(async()=>{let s;try{s=await S.Promises.readFile(this.uninstalledPath,"utf8")}catch(h){if(h.code!=="ENOENT")throw h}let a={};if(s)try{a=JSON.parse(s)}catch{}return r&&(r(a),Object.keys(a).length?await S.Promises.writeFile(this.uninstalledPath,JSON.stringify(a)):await S.Promises.rm(this.uninstalledPath)),a})}async extractAtLocation(r,s,a,h){this.logService.trace(`Started extracting the extension from ${s} to ${a}`);try{await S.Promises.rm(a)}catch(g){throw new d.ExtensionManagementError(this.joinErrors(g).message,d.ExtensionManagementErrorCode.Delete)}try{await(0,u.extract)(s,a,{sourcePath:"extension",overwrite:!0},h),this.logService.info(`Extracted extension to ${a}:`,r.id)}catch(g){try{await S.Promises.rm(a)}catch{}let _=d.ExtensionManagementErrorCode.Extract;throw g instanceof u.ExtractError&&(g.type==="CorruptZip"?_=d.ExtensionManagementErrorCode.CorruptZip:g.type==="Incomplete"&&(_=d.ExtensionManagementErrorCode.IncompleteZip)),new d.ExtensionManagementError(g.message,_)}}async rename(r,s,a,h){try{await S.Promises.rename(s,a)}catch(g){if(v.isWindows&&g&&g.code==="EPERM"&&Date.now()<h)return this.logService.info(`Failed renaming ${s} to ${a} with 'EPERM' error. Trying again...`,r.id),this.rename(r,s,a,h);throw new d.ExtensionManagementError(g.message||(0,b.localize)(3,null,s,a),g.code||d.ExtensionManagementErrorCode.Rename)}}async scanExtensionsInLocation(r,s){const a=new n.Limiter(10),h=await this.fileService.resolve(r);return h.children?(await Promise.all(h.children.filter(_=>_.isDirectory).map(_=>a.queue(async()=>(0,P.isEqualOrParent)(_.resource,this.userExtensionsLocation)&&(0,P.basename)(_.resource).indexOf(".")===0?null:this.scanExtension(_.resource,s))))).filter(_=>_&&_.identifier):[]}async scanExtension(r,s){try{const a=await this.fileService.resolve(r);if(a.children){const{manifest:h,metadata:g}=await this.readManifest(r.fsPath),_=a.children.find(({name:W})=>/^readme(\.txt|\.md|)$/i.test(W))?.resource,F=a.children.find(({name:W})=>/^changelog(\.txt|\.md|)$/i.test(W))?.resource,$={id:(0,p.getGalleryExtensionId)(h.publisher,h.name)},K=g?.isSystem?0:s,I={type:K,identifier:$,manifest:h,location:r,readmeUrl:_,changelogUrl:F,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:K===0};return this.setMetadata(I,g),I}}catch(a){s!==0&&this.logService.trace(a)}return null}async scanDefaultSystemExtensions(){this.logService.trace("Started scanning system extensions");const r=await this.scanExtensionsInLocation(this.systemExtensionsLocation,0);return this.logService.trace("Scanned system extensions:",r.length),r}async scanDevSystemExtensions(){this.logService.trace("Started scanning dev system extensions");const r=this.getDevSystemExtensionsList();if(r.length){const s=await this.scanExtensionsInLocation(this.devSystemExtensionsLocation,0);return this.logService.trace("Scanned dev system extensions:",s.length),s.filter(a=>r.some(h=>(0,p.areSameExtensions)(a.identifier,{id:h})))}else return[]}async scanFromUserExtensionsLocation(){return this.scanExtensionsInLocation(this.userExtensionsLocation,1)}dedupExtensions(r,s){const a=new Map;for(const h of r){const g=y.ExtensionIdentifier.toKey(h.identifier.id),_=a.get(g);if(_){if(A.gt(_.manifest.version,h.manifest.version)){this.logService.debug(`Skipping extension ${h.location.fsPath} with lower version ${h.manifest.version}.`);continue}if(A.eq(_.manifest.version,h.manifest.version)&&_.targetPlatform===s){this.logService.debug(`Skipping extension ${h.location.fsPath} from different target platform ${h.targetPlatform}`);continue}_.type===0?this.logService.debug(`Overwriting system extension ${_.location.fsPath} with ${h.location.fsPath}.`):this.logService.warn(`Overwriting user extension ${_.location.fsPath} with ${h.location.fsPath}.`)}a.set(g,h)}return[...a.values()]}setMetadata(r,s){r.publisherDisplayName=s?.publisherDisplayName||null,r.publisherId=s?.publisherId||null,r.identifier.uuid=s?.id,r.isMachineScoped=!!s?.isMachineScoped,r.isPreReleaseVersion=!!s?.isPreReleaseVersion,r.preRelease=!!s?.preRelease,r.isBuiltin=r.type===0||!!s?.isBuiltin,r.installedTimestamp=s?.installedTimestamp,r.targetPlatform=s?.targetPlatform??"undefined",r.updated=!!s?.updated}async removeUninstalledExtensions(){const r=await this.getUninstalledExtensions(),s=await this.scanFromUserExtensionsLocation(),a=new Set;for(const _ of s)r[p.ExtensionKey.create(_).toString()]||a.add(_.identifier.id.toLowerCase());const h=(0,p.groupByExtension)(s,_=>_.identifier);await n.Promises.settled(h.map(async _=>{const F=_.sort(($,K)=>A.rcompare($.manifest.version,K.manifest.version))[0];a.has(F.identifier.id.toLowerCase())||await this.beforeRemovingExtension(F)}));const g=s.filter(_=>r[p.ExtensionKey.create(_).toString()]);await n.Promises.settled(g.map(_=>this.removeUninstalledExtension(_)))}async removeOutdatedExtensions(){const r=await this.scanFromUserExtensionsLocation(),s=[],a=await this.targetPlatform,h=(0,p.groupByExtension)(r,g=>g.identifier);s.push(...(0,k.flatten)(h.map(g=>g.sort((_,F)=>{const $=A.rcompare(_.manifest.version,F.manifest.version);return $!==0?$:_.targetPlatform===a?-1:1}).slice(1)))),await n.Promises.settled(s.map(g=>this.removeExtension(g,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(r=>r.name)}joinErrors(r){const s=Array.isArray(r)?r:[r];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((a,h)=>new Error(`${a.message}${a.message?",":""}${h instanceof Error?h.message:h}`),new Error(""))}get devSystemExtensionsLocation(){return this._devSystemExtensionsLocation||(this._devSystemExtensionsLocation=R.URI.file(D.normalize(D.join(T.FileAccess.asFileUri("",ee).fsPath,"..",".build","builtInExtensions")))),this._devSystemExtensionsLocation}async readManifest(r){const s=[S.Promises.readFile(D.join(r,"package.json"),"utf8").then(_=>this.parseManifest(_)),S.Promises.readFile(D.join(r,"package.nls.json"),"utf8").then(void 0,_=>_.code!=="ENOENT"?Promise.reject(_):"{}").then(_=>JSON.parse(_))],[{manifest:a,metadata:h},g]=await Promise.all(s);return{manifest:(0,m.localizeManifest)(a,g),metadata:h}}parseManifest(r){return new Promise((s,a)=>{try{const h=JSON.parse(r);h.publisher||(h.publisher=y.UNDEFINED_PUBLISHER);const g=h.__metadata||null;s({manifest:h,metadata:g})}catch{a(new Error((0,b.localize)(4,null)))}})}};i=Ae([Oe(2,c.IFileService),Oe(3,o.ILogService),Oe(4,f.INativeEnvironmentService),Oe(5,l.IProductService)],i),e.ExtensionsScanner=i}),define(ve[114],we([0,1,36,9,8,5,3,20,56,12,4,23,19,71,152,65,27,210,30,35,200,192,247,201,248,223,63,17,6,13,28,32,48]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E,S,u,b,f,d,p,m,y,c,o,l,i,t,r,s,a,h,g,_,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let $=class extends d.AbstractExtensionManagementService{constructor(Z,H,U,z,Q,ie,re,ce,de){super(Z,H,U,ce);this.environmentService=z,this.downloadService=Q,this.fileService=re;const he=this._register(ie.createInstance(c.ExtensionsLifecycle));this.extensionsScanner=this._register(ie.createInstance(i.ExtensionsScanner,O=>he.postUninstall(O),this.getTargetPlatform())),this.manifestCache=this._register(new l.ExtensionsManifestCache(z,this)),this.extensionsDownloader=this._register(ie.createInstance(y.ExtensionsDownloader));const j=this._register(new t.ExtensionsWatcher(this,re,z,U,de));this._register(j.onDidChangeExtensionsByAnotherSource(({added:O,removed:V})=>{O.length&&this._onDidInstallExtensions.fire(O.map(J=>({identifier:J.identifier,operation:1,local:J}))),V.forEach(J=>this._onDidUninstallExtension.fire({identifier:J}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,m.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(Z){this.logService.trace("ExtensionManagementService#zip",Z.identifier.id);const H=await this.collectFiles(Z),U=await(0,S.zip)((0,D.joinPath)(this.environmentService.tmpDir,(0,R.generateUuid)()).fsPath,H);return A.URI.file(U)}async unzip(Z){return this.logService.trace("ExtensionManagementService#unzip",Z.toString()),(await this.install(Z)).identifier}async getManifest(Z){const H=await this.downloadVsix(Z),U=C.resolve(H.fsPath);return(0,o.getManifest)(U)}getInstalled(Z=null){return this.extensionsScanner.scanExtensions(Z)}async install(Z,H={}){this.logService.trace("ExtensionManagementService#install",Z.toString());const U=await this.downloadVsix(Z),z=await(0,o.getManifest)(C.resolve(U.fsPath));if(z.engines&&z.engines.vscode&&!(0,r.isEngineValid)(z.engines.vscode,this.productService.version,this.productService.date))throw new Error(u.localize(0,null,(0,m.getGalleryExtensionId)(z.publisher,z.name),this.productService.version));return this.installExtension(z,U,H)}async updateMetadata(Z,H){this.logService.trace("ExtensionManagementService#updateMetadata",Z.identifier.id);const U={...Z.manifest.__metadata||{},...H};return H.isPreReleaseVersion&&(U.preRelease=!0),Z=await this.extensionsScanner.saveMetadataForLocalExtension(Z,U),this.manifestCache.invalidate(),Z}async updateExtensionScope(Z,H){return this.logService.trace("ExtensionManagementService#updateExtensionScope",Z.identifier.id),Z=await this.extensionsScanner.saveMetadataForLocalExtension(Z,{...Z.manifest.__metadata||{},isMachineScoped:H}),this.manifestCache.invalidate(),Z}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(Z){if(Z.scheme===w.Schemas.file)return Z;const H=(0,D.joinPath)(this.environmentService.tmpDir,(0,R.generateUuid)());return await this.downloadService.download(Z,H),H}createInstallExtensionTask(Z,H,U){return A.URI.isUri(H)?new W(Z,H,U,this.galleryService,this.extensionsScanner,this.logService):new I(H,U,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(Z,H){return new M(Z,H,this.extensionsScanner)}async collectFiles(Z){const H=async z=>{let Q=await E.Promises.readdir(z);Q=Q.map(ce=>C.join(z,ce));const ie=await Promise.all(Q.map(ce=>E.Promises.stat(ce)));let re=Promise.resolve([]);return ie.forEach((ce,de)=>{const he=Q[de];ce.isFile()&&(re=re.then(j=>[...j,he])),ce.isDirectory()&&(re=re.then(j=>H(he).then(O=>[...j,...O])))}),re};return(await H(Z.location.fsPath)).map(z=>({path:`extension/${C.relative(Z.location.fsPath,z)}`,localPath:z}))}};$=Ae([Oe(0,p.IExtensionGalleryService),Oe(1,_.ITelemetryService),Oe(2,h.ILogService),Oe(3,f.INativeEnvironmentService),Oe(4,b.IDownloadService),Oe(5,a.IInstantiationService),Oe(6,s.IFileService),Oe(7,g.IProductService),Oe(8,F.IUriIdentityService)],$),e.ExtensionManagementService=$;class K extends d.AbstractExtensionTask{constructor(Z,H,U,z,Q){super();this.identifier=Z,this.source=H,this.options=U,this.extensionsScanner=z,this.logService=Q,this._operation=2}get operation(){return(0,P.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(Z,H){try{const U=await this.unsetUninstalledAndGetLocal(Z.key);if(U)return Z.metadata?this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},...Z.metadata}):U}catch{throw T.isMacintosh?new p.ExtensionManagementError(u.localize(1,null),p.ExtensionManagementErrorCode.Internal):new p.ExtensionManagementError(u.localize(2,null),p.ExtensionManagementErrorCode.Internal)}return this.extract(Z,H)}async unsetUninstalledAndGetLocal(Z){if(!await this.isUninstalled(Z))return null;this.logService.trace("Removing the extension from uninstalled list:",Z.id);const U=await this.extensionsScanner.setInstalled(Z);return this.logService.info("Removed the extension from uninstalled list:",Z.id),U}async isUninstalled(Z){return!!(await this.extensionsScanner.getUninstalledExtensions())[Z.toString()]}async extract({zipPath:Z,key:H,metadata:U},z){let Q=await this.extensionsScanner.extractUserExtension(H,Z,U,z);return this.logService.info("Extracting completed.",H.id),Q}}class I extends K{constructor(Z,H,U,z,Q){super(Z.identifier,Z,H,z,Q);this.gallery=Z,this.extensionsDownloader=U}async doRun(Z){const U=(await this.extensionsScanner.scanExtensions(null)).find(Q=>(0,m.areSameExtensions)(Q.identifier,this.gallery.identifier));U&&(this._operation=3);const z=await this.downloadInstallableExtension(this.gallery,this._operation);z.metadata.isMachineScoped=this.options.isMachineScoped||U?.isMachineScoped,z.metadata.isBuiltin=this.options.isBuiltin||U?.isBuiltin,z.metadata.isSystem=U?.type===0?!0:void 0,z.metadata.updated=!!U,z.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,z.metadata.preRelease=this.gallery.properties.isPreReleaseVersion||((0,P.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:U?.preRelease);try{const Q=await this.installExtension(z,Z);return U&&(U.targetPlatform!==Q.targetPlatform||v.neq(U.manifest.version,Q.manifest.version))&&await this.extensionsScanner.setUninstalled(U),Q}catch(Q){throw await this.deleteDownloadedVSIX(z.zipPath),Q}}async deleteDownloadedVSIX(Z){try{await this.extensionsDownloader.delete(A.URI.file(Z))}catch(H){this.logService.warn("Error while deleting the downloaded vsix",Z.toString(),(0,n.getErrorMessage)(H))}}async downloadInstallableExtension(Z,H){const U={id:Z.identifier.uuid,publisherId:Z.publisherId,publisherDisplayName:Z.publisherDisplayName,targetPlatform:Z.properties.targetPlatform};let z;try{this.logService.trace("Started downloading extension:",Z.identifier.id),z=(await this.extensionsDownloader.downloadExtension(Z,H)).fsPath,this.logService.info("Downloaded extension:",Z.identifier.id,z)}catch(Q){throw new p.ExtensionManagementError((0,d.joinErrors)(Q).message,p.ExtensionManagementErrorCode.Download)}try{return await(0,o.getManifest)(z),{zipPath:z,key:m.ExtensionKey.create(Z),metadata:U}}catch(Q){throw await this.deleteDownloadedVSIX(z),new p.ExtensionManagementError((0,d.joinErrors)(Q).message,p.ExtensionManagementErrorCode.Invalid)}}}class W extends K{constructor(Z,H,U,z,Q,ie){super({id:(0,m.getGalleryExtensionId)(Z.publisher,Z.name)},H,U,Q,ie);this.manifest=Z,this.location=H,this.galleryService=z}async doRun(Z){const H=new m.ExtensionKey(this.identifier,this.manifest.version),z=(await this.extensionsScanner.scanExtensions(1)).find(ie=>(0,m.areSameExtensions)(this.identifier,ie.identifier)),Q=await this.getMetadata(this.identifier.id,this.manifest.version,Z);if(Q.isMachineScoped=this.options.isMachineScoped||z?.isMachineScoped,Q.isBuiltin=this.options.isBuiltin||z?.isBuiltin,z)if(this._operation=3,H.equals(new m.ExtensionKey(z.identifier,z.manifest.version)))try{await this.extensionsScanner.removeExtension(z,"existing")}catch{throw new Error(u.localize(3,null,this.manifest.displayName||this.manifest.name))}else v.gt(z.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(z);else{const ie=await this.unsetUninstalledAndGetLocal(H);if(ie)try{await this.extensionsScanner.removeExtension(ie,"existing")}catch{throw new Error(u.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:C.resolve(this.location.fsPath),key:H,metadata:Q},Z)}async getMetadata(Z,H,U){try{let[z]=await this.galleryService.getExtensions([{id:Z,version:H}],U);if(z||([z]=await this.galleryService.getExtensions([{id:Z}],U)),z)return{id:z.identifier.uuid,publisherDisplayName:z.publisherDisplayName,publisherId:z.publisherId,isPreReleaseVersion:z.properties.isPreReleaseVersion,preRelease:z.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class M extends d.AbstractExtensionTask{constructor(Z,H,U){super();this.extension=Z,this.options=H,this.extensionsScanner=U}async doRun(Z){const H=[],U=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const z=m.ExtensionKey.create(this.extension);H.push(...U.filter(Q=>z.equals(m.ExtensionKey.create(Q))))}else H.push(...U.filter(z=>(0,m.areSameExtensions)(z.identifier,this.extension.identifier)));if(!H.length)throw new Error(u.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...H),this.options.remove)for(const z of H)try{Z.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(z)}catch(Q){throw new Error(u.localize(6,null,(0,k.toErrorMessage)(Q)))}}}}),define(ve[58],we([0,1,68,82,25,16,9,7,2,5,3,23,39,85,249]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class b{constructor(_,F=""){this.debugLabel=F,this.socket=_,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=$=>{if(this.traceSocketEvent("error",{code:$?.code,message:$?.message}),$){if($.code==="EPIPE")return;(0,T.onUnexpectedError)($)}},this.socket.on("error",this._errorListener)}traceSocketEvent(_,F){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,_,F)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(_){const F=$=>{this.traceSocketEvent("read",$),_(C.VSBuffer.wrap($))};return this.socket.on("data",F),{dispose:()=>this.socket.off("data",F)}}onClose(_){const F=$=>{this.traceSocketEvent("close",{hadError:$}),_({type:0,hadError:$,error:void 0})};return this.socket.on("close",F),{dispose:()=>this.socket.off("close",F)}}onEnd(_){const F=()=>{this.traceSocketEvent("nodeEndReceived"),_()};return this.socket.on("end",F),{dispose:()=>this.socket.off("end",F)}}write(_){if(!this.socket.destroyed)try{this.traceSocketEvent("write",_),this.socket.write(_.buffer,F=>{if(F){if(F.code==="EPIPE")return;(0,T.onUnexpectedError)(F)}})}catch(F){if(F.code==="EPIPE")return;(0,T.onUnexpectedError)(F)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((_,F)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),_();return}const $=()=>{this.socket.off("close",$),this.socket.off("end",$),this.socket.off("error",$),this.socket.off("timeout",$),this.socket.off("drain",$),this.traceSocketEvent("nodeDrainEnd"),_()};this.socket.on("close",$),this.socket.on("end",$),this.socket.on("error",$),this.socket.on("timeout",$),this.socket.on("drain",$)})}}e.NodeSocket=b;var f;(function(g){g[g.MinHeaderByteSize=2]="MinHeaderByteSize"})(f||(f={}));var d;(function(g){g[g.PeekHeader=1]="PeekHeader",g[g.ReadHeader=2]="ReadHeader",g[g.ReadBody=3]="ReadBody",g[g.Fin=4]="Fin"})(d||(d={}));class p extends v.Disposable{constructor(_,F,$,K){super();this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=_,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:F,inflateBytesLength:$?.byteLength||0,recordInflateBytes:K}),this._flowManager=this._register(new m(this,F,$,K,this._onData,(I,W)=>this._write(I,W))),this._register(this._flowManager.onError(I=>{console.error(I),(0,T.onUnexpectedError)(I),this._onClose.fire({type:0,hadError:!0,error:I})})),this._incomingData=new S.ChunkStream,this._register(this.socket.onData(I=>this._acceptChunk(I))),this._register(this.socket.onClose(I=>this._onClose.fire(I)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(_,F){this.socket.traceSocketEvent(_,F)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(_){return this._onData.event(_)}onClose(_){return this._onClose.event(_)}onEnd(_){return this.socket.onEnd(_)}write(_){this._flowManager.writeMessage(_)}_write(_,F){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",_);let $=2;_.byteLength<126?$+=0:_.byteLength<2**16?$+=2:$+=8;const K=C.VSBuffer.alloc($);if(F?K.writeUInt8(194,0):K.writeUInt8(130,0),_.byteLength<126)K.writeUInt8(_.byteLength,1);else if(_.byteLength<2**16){K.writeUInt8(126,1);let I=1;K.writeUInt8(_.byteLength>>>8&255,++I),K.writeUInt8(_.byteLength>>>0&255,++I)}else{K.writeUInt8(127,1);let I=1;K.writeUInt8(0,++I),K.writeUInt8(0,++I),K.writeUInt8(0,++I),K.writeUInt8(0,++I),K.writeUInt8(_.byteLength>>>24&255,++I),K.writeUInt8(_.byteLength>>>16&255,++I),K.writeUInt8(_.byteLength>>>8&255,++I),K.writeUInt8(_.byteLength>>>0&255,++I)}this.socket.write(C.VSBuffer.concat([K,_]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(_){if(_.byteLength!==0){for(this._incomingData.acceptChunk(_);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const F=this._incomingData.peek(this._state.readLen),$=F.readUInt8(0),K=($&128)>>>7,I=($&64)>>>6,W=F.readUInt8(1),M=(W&128)>>>7,q=W&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(q===126?2:0)+(q===127?8:0),this._state.fin=K,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(I)),this._state.firstFrameOfMessage=Boolean(K),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const F=this._incomingData.read(this._state.readLen),$=F.readUInt8(1),K=($&128)>>>7;let I=$&127,W=1;I===126?I=F.readUInt8(++W)*2**8+F.readUInt8(++W):I===127&&(I=F.readUInt8(++W)*0+F.readUInt8(++W)*0+F.readUInt8(++W)*0+F.readUInt8(++W)*0+F.readUInt8(++W)*2**24+F.readUInt8(++W)*2**16+F.readUInt8(++W)*2**8+F.readUInt8(++W));let M=0;K&&(M=F.readUInt8(++W)*2**24+F.readUInt8(++W)*2**16+F.readUInt8(++W)*2**8+F.readUInt8(++W)),this._state.state=3,this._state.readLen=I,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const F=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",F),o(F,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",F),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(F,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=p;class m extends v.Disposable{constructor(_,F,$,K,I,W){super();this._tracer=_,this._onData=I,this._writeFn=W,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new D.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,F?(this._zlibInflateStream=this._register(new y(this._tracer,K,$,{windowBits:15})),this._zlibDeflateStream=this._register(new c(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:C.VSBuffer.alloc(0)}writeMessage(_){this._writeQueue.push(_),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const _=this._writeQueue.shift();if(this._zlibDeflateStream){const F=await this._deflateMessage(this._zlibDeflateStream,_);this._writeFn(F,!0)}else this._writeFn(_,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(_,F){return new Promise(($,K)=>{_.write(F),_.flush(I=>$(I))})}acceptFrame(_,F,$){this._readQueue.push({data:_,isCompressed:F,isLastFrameOfMessage:$}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const _=this._readQueue.shift();if(this._zlibInflateStream&&_.isCompressed){const F=await this._inflateFrame(this._zlibInflateStream,_.data,_.isLastFrameOfMessage);this._onData.fire(F)}else this._onData.fire(_.data)}this._isProcessingReadQueue=!1}}_inflateFrame(_,F,$){return new Promise((K,I)=>{_.write(F),$&&_.write(C.VSBuffer.fromByteArray([0,0,255,255])),_.flush(W=>K(W))})}}class y extends v.Disposable{constructor(_,F,$,K){super();this._tracer=_,this._recordInflateBytes=F,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=u.createInflateRaw(K),this._zlibInflate.on("error",I=>{this._tracer.traceSocketEvent("zlibInflateError",{message:I?.message,code:I?.code}),this._onError.fire(I)}),this._zlibInflate.on("data",I=>{this._tracer.traceSocketEvent("zlibInflateData",I),this._pendingInflateData.push(C.VSBuffer.wrap(I))}),$&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",$.buffer),this._zlibInflate.write($.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.concat(this._recordedInflateBytes):C.VSBuffer.alloc(0)}write(_){this._recordInflateBytes&&this._recordedInflateBytes.push(_.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",_),this._zlibInflate.write(_.buffer)}flush(_){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const F=C.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,_(F)})}}class c extends v.Disposable{constructor(_,F){super();this._tracer=_,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=u.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",$=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:$?.message,code:$?.code}),this._onError.fire($)}),this._zlibDeflate.on("data",$=>{this._tracer.traceSocketEvent("zlibDeflateData",$),this._pendingDeflateData.push(C.VSBuffer.wrap($))})}write(_){this._tracer.traceSocketEvent("zlibDeflateWrite",_.buffer),this._zlibDeflate.write(_.buffer)}flush(_){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let F=C.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,F=F.slice(0,F.byteLength-4),_(F)})}}function o(g,_){if(_===0)return;let F=g.byteLength>>>2;for(let q=0;q<F;q++){const Z=g.readUInt32BE(q*4);g.writeUInt32BE(Z^_,q*4)}let $=F*4,K=g.byteLength-$;const I=_>>>24&255,W=_>>>16&255,M=_>>>8&255;K>=1&&g.writeUInt8(g.readUInt8($)^I,$),K>=2&&g.writeUInt8(g.readUInt8($+1)^W,$+1),K>=3&&g.writeUInt8(g.readUInt8($+2)^M,$+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function i(){const g=(0,R.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${g}-sock`;let _;return e.XDG_RUNTIME_DIR?_=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${g}.sock`):_=(0,P.join)((0,w.tmpdir)(),`vscode-ipc-${g}.sock`),r(_),_}e.createRandomIPCHandle=i;function t(g,_,F){const $=(0,k.createHash)("md5").update(g).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${$}-${F}-${_}-sock`;let K;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?K=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${$.substr(0,8)}-${F}-${_}.sock`):K=(0,P.join)(g,`${F}-${_}.sock`),r(K),K}e.createStaticIPCHandle=t;function r(g){const _=l[A.platform];typeof _=="number"&&g.length>=_&&console.warn(`WARNING: IPC handle "${g}" is longer than ${_} chars, try a shorter --user-data-dir`)}class s extends E.IPCServer{constructor(_){super(s.toClientConnectionEvent(_));this.server=_}static toClientConnectionEvent(_){const F=D.Event.fromNodeEventEmitter(_,"connection");return D.Event.map(F,$=>({protocol:new S.Protocol(new b($,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter($,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function a(g){return new Promise((_,F)=>{const $=(0,n.createServer)();$.on("error",F),$.listen(g,()=>{$.removeListener("error",F),_(new s($))})})}e.serve=a;function h(g,_){return new Promise((F,$)=>{const K=(0,n.createConnection)(g,()=>{K.removeListener("error",$),F(S.Client.fromSocket(new b(K,`ipc-client${_}`),_))});K.once("error",$)})}e.connect=h}),define(ve[115],we([0,1,69,14,16,9,2,12,26,27,70,13,204,249]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let u=class extends T.Disposable{constructor(f,d,p){super();this.environmentService=d,this.logService=p,this.configure(f.getValue()),this._register(f.onDidChangeConfiguration(()=>this.configure(f.getValue()),this))}configure(f){this.proxyUrl=f.http&&f.http.proxy,this.strictSSL=!!(f.http&&f.http.proxyStrictSSL),this.authorization=f.http&&f.http.proxyAuthorization}async request(f,d){this.logService.trace("RequestService#request",f.url);const{proxyUrl:p,strictSSL:m}=this;let y;try{y=await(0,A.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(l){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",l))}const c={...process.env,...y},o=f.agent?f.agent:await(0,E.getProxyAgent)(f.url||"",c,{proxyUrl:p,strictSSL:m});return f.agent=o,f.strictSSL=m,this.authorization&&(f.headers={...f.headers||{},"Proxy-Authorization":this.authorization}),this._request(f,d)}async getNodeRequest(f){return((0,k.parse)(f.url).protocol==="https:"?await new Promise((m,y)=>{ee(["https"],m,y)}):await new Promise((m,y)=>{ee(["http"],m,y)})).request}_request(f,d){return n.Promises.withAsyncBody(async(p,m)=>{let y;const c=(0,k.parse)(f.url),o=f.getRawRequest?f.getRawRequest(f):await this.getNodeRequest(f),l={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:f.type||"GET",headers:f.headers,agent:f.agent,rejectUnauthorized:(0,D.isBoolean)(f.strictSSL)?f.strictSSL:!0};f.user&&f.password&&(l.auth=f.user+":"+f.password),y=o(l,i=>{const t=(0,D.isNumber)(f.followRedirects)?f.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&t>0&&i.headers.location)this._request({...f,url:i.headers.location,followRedirects:t-1},d).then(p,m);else{let r=i;i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,S.createGunzip)())),p({res:i,stream:(0,w.streamToBufferReadableStream)(r)})}}),y.on("error",m),f.timeout&&y.setTimeout(f.timeout),f.data&&typeof f.data=="string"&&y.write(f.data),y.end(),d.onCancellationRequested(()=>{y.abort(),m((0,C.canceled)())})})}async resolveProxy(f){}};u=Ae([Oe(0,v.IConfigurationService),Oe(1,P.INativeEnvironmentService),Oe(2,R.ILogService)],u),e.RequestService=u}),define(ve[116],we([0,1,38,105,8,5,16,7,58,70,13,42,3,245,62,104]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E,S,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function f(o={},l,i,t,r,s){const a=await(0,n.getNLSConfiguration)(i,r.userDataPath);let h={};if(l)try{h=await(0,P.getResolvedShellEnv)(s,r.args,process.env)}catch(I){s.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",I)}const _={...process.env,...h,VSCODE_LOG_NATIVE:String(t),VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_EXTHOST_WILL_SEND_SOCKET:"true",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_LOG_STACK:"false",VSCODE_NLS_CONFIG:JSON.stringify(a,void 0,0),...o},F=r.isBuilt?(0,C.join)(r.appRoot,"bin"):(0,C.join)(r.appRoot,"resources","server","bin-dev"),$=(0,C.join)(F,"remote-cli");let K=m(_,"PATH");return K?K=$+C.delimiter+K:K=$,y(_,"PATH",K),r.args["without-browser-env-var"]||(_.BROWSER=(0,C.join)(F,"helpers",E.isWindows?"browser.cmd":"browser.sh")),c(_),_}e.buildUserEnvironment=f;class d{constructor(l,i,t,r,s,a){this.socket=l,this.socketDrain=i,this.initialDataChunk=t,this.skipWebSocketFrames=r,this.permessageDeflate=s,this.inflateBytes=a}toIExtHostSocketMessage(){return{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:this.skipWebSocketFrames,permessageDeflate:this.permessageDeflate,inflateBytes:this.inflateBytes.buffer.toString("base64")}}}let p=class fn{constructor(l,i,t,r,s,a,h){this._reconnectionToken=l,this._environmentService=s,this._logService=a,this._extensionHostStatusService=h,this._onClose=new D.Emitter,this.onClose=this._onClose.event,this._disposed=!1,this._remoteAddress=i,this._extensionHostProcess=null,this._connectionData=fn._toConnectionData(t,r),this._log("New connection established.")}get _logPrefix(){return`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] `}_log(l){this._logService.info(`${this._logPrefix}${l}`)}_logError(l){this._logService.error(`${this._logPrefix}${l}`)}static _toConnectionData(l,i){return l instanceof v.NodeSocket?new d(l.socket,l.drain(),i,!0,!1,T.VSBuffer.alloc(0)):new d(l.socket.socket,l.drain(),i,!1,l.permessageDeflate,l.recordedInflateBytes)}async _sendSocketToExtensionHost(l,i){await i.socketDrain;const t=i.toIExtHostSocketMessage();l.send(t,i.socket)}shortenReconnectionGraceTimeIfNecessary(){if(!this._extensionHostProcess)return;const l={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this._extensionHostProcess.send(l)}acceptReconnection(l,i,t){this._remoteAddress=l,this._log("The client has reconnected.");const r=fn._toConnectionData(i,t);if(!this._extensionHostProcess){this._connectionData=r;return}this._sendSocketToExtensionHost(this._extensionHostProcess,r)}_cleanResources(){this._disposed||(this._disposed=!0,this._connectionData&&(this._connectionData.socket.end(),this._connectionData=null),this._extensionHostProcess&&(this._extensionHostProcess.kill(),this._extensionHostProcess=null),this._onClose.fire(void 0))}async start(l){try{let i=[];l.port&&!process.pkg&&(i=[`--inspect${l.break?"-brk":""}=${l.port}`]);const t=await f(l.env,!0,l.language,!!l.debugId,this._environmentService,this._logService);(0,u.removeDangerousEnvVariables)(t);const r={env:t,execArgv:i,silent:!0},s=["--type=extensionHost","--transformURIs"],a=this._environmentService.args["use-host-proxy"];s.push(`--useHostProxy=${a?"true":"false"}`),this._extensionHostProcess=k.fork(w.FileAccess.asFileUri("bootstrap-fork",ee).fsPath,s,r);const h=this._extensionHostProcess.pid;this._log(`<${h}> Launched Extension Host Process.`),this._extensionHostProcess.stdout.setEncoding("utf8"),this._extensionHostProcess.stderr.setEncoding("utf8");const g=D.Event.fromNodeEventEmitter(this._extensionHostProcess.stdout,"data"),_=D.Event.fromNodeEventEmitter(this._extensionHostProcess.stderr,"data");g($=>this._log(`<${h}> ${$}`)),_($=>this._log(`<${h}><stderr> ${$}`)),this._extensionHostProcess.on("message",$=>{$&&$.type==="__$console"&&(0,S.logRemoteEntry)(this._logService,$,`${this._logPrefix}<${h}>`)}),this._extensionHostProcess.on("error",$=>{this._logError(`<${h}> Extension Host Process had an error`),this._logService.error($),this._cleanResources()}),this._extensionHostProcess.on("exit",($,K)=>{this._extensionHostStatusService.setExitInfo(this._reconnectionToken,{code:$,signal:K}),this._log(`<${h}> Extension Host Process exited with code: ${$}, signal: ${K}.`),this._cleanResources()});const F=$=>{$.type==="VSCODE_EXTHOST_IPC_READY"&&(this._extensionHostProcess.removeListener("message",F),this._sendSocketToExtensionHost(this._extensionHostProcess,this._connectionData),this._connectionData=null)};this._extensionHostProcess.on("message",F)}catch(i){console.error("ExtensionHostConnection errored"),i&&console.error(i)}}};p=Ae([Oe(4,R.IServerEnvironmentService),Oe(5,A.ILogService),Oe(6,b.IExtensionHostStatusService)],p),e.ExtensionHostConnection=p;function m(o,l){const i=Object.keys(o).filter(r=>r.toLowerCase()===l.toLowerCase()),t=i.length>0?i[0]:l;return o[t]}function y(o,l,i){const t=Object.keys(o).filter(s=>s.toLowerCase()===l.toLowerCase()),r=t.length>0?t[0]:l;o[r]=i}function c(o){for(let l of Object.keys(o))o[l]===null&&delete o[l]}}),define(ve[250],we([0,1,66,13,53,95,26,47,115,41,32,30,99,114,91,45,2,92,55,8,17,28,94,113,42,97,67,98,9,4,5,24,202,65,48,102,52,3]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E,S,u,b,f,d,p,m,y,c,o,l,i,t,r,s,a,h,g,_,F,$,K,I,W,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class q extends f.Disposable{constructor(z,Q){super();this.args=z,this.remoteDataFolder=Q,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){await(await this.initServices()).invokeFunction(async Q=>{const ie=Q.get(n.ILogService),re=Q.get(R.IExtensionManagementCLIService);try{await this.doRun(re)}catch(ce){throw ie.error(ce),console.error((0,a.getErrorMessage)(ce)),ce}})}async initServices(){const z=new k.ServiceCollection,Q={_serviceBrand:void 0,...b.default};z.set(c.IProductService,Q);const ie=new i.ServerEnvironmentService(this.args,Q);z.set(i.IServerEnvironmentService,ie);const re=new n.LogService(new o.SpdLogLogger(l.RemoteExtensionLogFileName,(0,g.join)(ie.logsPath,`${l.RemoteExtensionLogFileName}.log`),!0,!1,(0,n.getLogLevel)(ie)));z.set(n.ILogService,re),re.trace(`Remote configuration data at ${this.remoteDataFolder}`),re.trace("process arguments:",this.args);const ce=this._register(new d.FileService(re));z.set(y.IFileService,ce),ce.registerProvider(m.Schemas.file,this._register(new p.DiskFileSystemProvider(re)));const de=this._register(new C.ConfigurationService(ie.settingsResource,ce));return await de.initialize(),z.set(T.IConfigurationService,de),z.set(K.IUriIdentityService,new I.UriIdentityService(ce)),z.set(D.IRequestService,new w.SyncDescriptor(v.RequestService)),z.set($.IDownloadService,new w.SyncDescriptor(F.DownloadService)),z.set(A.ITelemetryService,P.NullTelemetryService),z.set(R.IExtensionGalleryService,new w.SyncDescriptor(E.ExtensionGalleryServiceWithNoStorageService)),z.set(R.IExtensionManagementService,new w.SyncDescriptor(S.ExtensionManagementService)),z.set(R.IExtensionManagementCLIService,new w.SyncDescriptor(t.ExtensionManagementCLIService)),z.set(r.ILocalizationsService,new w.SyncDescriptor(s.LocalizationsService)),new u.InstantiationService(z)}async doRun(z){if(this.args["list-extensions"])return z.listExtensions(!!this.args["show-versions"],this.args.category);if(this.args["install-extension"]||this.args["install-builtin-extension"]){const Q={isMachineScoped:!!this.args["do-not-sync"],installPreReleaseVersion:!!this.args["pre-release"]};return z.installExtensions(this.asExtensionIdOrVSIX(this.args["install-extension"]||[]),this.args["install-builtin-extension"]||[],Q,!!this.args.force)}else{if(this.args["uninstall-extension"])return z.uninstallExtensions(this.asExtensionIdOrVSIX(this.args["uninstall-extension"]),!!this.args.force);if(this.args["locate-extension"])return z.locateExtension(this.args["locate-extension"])}}asExtensionIdOrVSIX(z){return z.map(Q=>/\.vsix$/i.test(Q)?h.URI.file((0,g.isAbsolute)(Q)?Q:(0,g.join)((0,_.cwd)(),Q)):Q)}}function Z(U){setTimeout(()=>process.exit(U),0)}async function H(U,z,Q){if(U.help){const re=b.default.serverApplicationName+(M.isWindows?".cmd":"");console.log((0,W.buildHelpMessage)(b.default.nameLong,re,b.default.version,Q,{noInputFiles:!0,noPipe:!0}));return}if(U.version){console.log((0,W.buildVersionMessage)(b.default.version,b.default.commit));return}const ie=new q(U,z);try{await ie.run(),Z(0)}catch{Z(1)}finally{ie.dispose()}}e.run=H}),define(ve[251],we([0,1,58,262,29,244,4,13,103]),function(ee,e,k,n,w,C,T,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class P{constructor(E,S,u){this._commands=E,this.logService=S,this._ipcHandlePath=u,this._server=n.createServer((b,f)=>this.onRequest(b,f)),this.setup().catch(b=>(S.error(b),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",E=>this.logService.error(E))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(E,S){const u=(f,d)=>{S.writeHead(f,{"content-type":"application/json"}),S.end(JSON.stringify(d||null),p=>p&&this.logService.error(p))},b=[];E.setEncoding("utf8"),E.on("data",f=>b.push(f)),E.on("end",async()=>{try{const f=JSON.parse(b.join(""));let d;switch(f.type){case"open":d=await this.open(f);break;case"openExternal":d=await this.openExternal(f);break;case"status":d=await this.getStatus(f);break;case"extensionManagement":d=await this.manageExtensions(f);break;default:u(404,`Unknown message type: ${f.type}`);break}u(200,d)}catch(f){const d=f instanceof Error?f.message:JSON.stringify(f);u(500,d),this.logService.error("Error while processing pipe request",f)}})}async open(E){const{fileURIs:S,folderURIs:u,forceNewWindow:b,diffMode:f,addMode:d,forceReuseWindow:p,gotoLineMode:m,waitMarkerFilePath:y,remoteAuthority:c}=E,o=[];if(Array.isArray(u))for(const r of u)try{o.push({folderUri:T.URI.parse(r)})}catch{}if(Array.isArray(S))for(const r of S)try{(0,v.hasWorkspaceFileExtension)(r)?o.push({workspaceUri:T.URI.parse(r)}):o.push({fileUri:T.URI.parse(r)})}catch{}const l=y?T.URI.file(y):void 0,t={forceNewWindow:b,diffMode:f,addMode:d,gotoLineMode:m,forceReuseWindow:p,preferNewWindow:!p&&!l&&!d,waitMarkerFileURI:l,remoteAuthority:c};return this._commands.executeCommand("_remoteCLI.windowOpen",o,t),""}async openExternal(E){for(const S of E.uris){const u=T.URI.parse(S),b=u.scheme==="file"?u:S;await this._commands.executeCommand("_remoteCLI.openExternal",b)}}async manageExtensions(E){const S=b=>b?.map(f=>/\.vsix$/i.test(f)?T.URI.parse(f):f),u={list:E.list,install:S(E.install),uninstall:S(E.uninstall),force:E.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",u)}async getStatus(E){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&w.existsSync(this._ipcHandlePath)&&w.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=P;let A=class extends P{constructor(E,S){super(E,S,(0,k.createRandomIPCHandle)())}};A=Ae([Oe(0,C.IExtHostCommands),Oe(1,D.ILogService)],A),e.CLIServer=A}),define(ve[252],we([0,1,25,7,22,2,5,3,4,58,57,251,231,110,232,237,116]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E,S,u,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class d extends b.AbstractVariableResolverService{constructor(y,c,o,l){super({getFolderUri:i=>{const t=c.filter(r=>r.name===i);if(t&&t.length>0)return t[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(i,t)=>l[`config:${t}`],getExecPath:()=>y.VSCODE_EXEC_PATH,getAppRoot:()=>y.VSCODE_CWD,getFilePath:()=>{if(o)return T.normalize(o.fsPath)},getSelectedText:()=>l.selectedText,getLineNumber:()=>l.lineNumber},void 0,Promise.resolve(k.homedir()),Promise.resolve(y))}}class p extends C.Disposable{constructor(y,c,o,l){super();this._environmentService=y,this._logService=c,this._ptyService=o,this._productService=l,this._lastReqId=0,this._pendingCommands=new Map,this._onExecuteCommand=this._register(new n.Emitter),this.onExecuteCommand=this._onExecuteCommand.event}async call(y,c,o){switch(c){case"$restartPtyHost":return this._ptyService.restartPtyHost?.apply(this._ptyService,o);case"$createProcess":{const l=(0,A.createURITransformer)(y.remoteAuthority);return this._createProcess(l,o)}case"$attachToProcess":return this._ptyService.attachToProcess.apply(this._ptyService,o);case"$detachFromProcess":return this._ptyService.detachFromProcess.apply(this._ptyService,o);case"$listProcesses":return this._ptyService.listProcesses.apply(this._ptyService,o);case"$orphanQuestionReply":return this._ptyService.orphanQuestionReply.apply(this._ptyService,o);case"$acceptPtyHostResolvedVariables":return this._ptyService.acceptPtyHostResolvedVariables?.apply(this._ptyService,o);case"$start":return this._ptyService.start.apply(this._ptyService,o);case"$input":return this._ptyService.input.apply(this._ptyService,o);case"$acknowledgeDataEvent":return this._ptyService.acknowledgeDataEvent.apply(this._ptyService,o);case"$shutdown":return this._ptyService.shutdown.apply(this._ptyService,o);case"$resize":return this._ptyService.resize.apply(this._ptyService,o);case"$getInitialCwd":return this._ptyService.getInitialCwd.apply(this._ptyService,o);case"$getCwd":return this._ptyService.getCwd.apply(this._ptyService,o);case"$processBinary":return this._ptyService.processBinary.apply(this._ptyService,o);case"$sendCommandResult":return this._sendCommandResult(o[0],o[1],o[2]);case"$installAutoReply":return this._ptyService.installAutoReply.apply(this._ptyService,o);case"$uninstallAllAutoReplies":return this._ptyService.uninstallAllAutoReplies.apply(this._ptyService,o);case"$getDefaultSystemShell":return this._getDefaultSystemShell.apply(this,o);case"$getProfiles":return this._getProfiles.apply(this,o);case"$getEnvironment":return this._getEnvironment();case"$getWslPath":return this._getWslPath(o[0]);case"$getTerminalLayoutInfo":return this._ptyService.getTerminalLayoutInfo(o);case"$setTerminalLayoutInfo":return this._ptyService.setTerminalLayoutInfo(o);case"$serializeTerminalState":return this._ptyService.serializeTerminalState.apply(this._ptyService,o);case"$reviveTerminalProcesses":return this._ptyService.reviveTerminalProcesses.apply(this._ptyService,o);case"$setUnicodeVersion":return this._ptyService.setUnicodeVersion.apply(this._ptyService,o);case"$reduceConnectionGraceTime":return this._reduceConnectionGraceTime();case"$updateIcon":return this._ptyService.updateIcon.apply(this._ptyService,o);case"$updateTitle":return this._ptyService.updateTitle.apply(this._ptyService,o);case"$updateProperty":return this._ptyService.updateProperty.apply(this._ptyService,o);case"$refreshProperty":return this._ptyService.refreshProperty.apply(this._ptyService,o);case"$requestDetachInstance":return this._ptyService.requestDetachInstance(o[0],o[1]);case"$acceptDetachedInstance":return this._ptyService.acceptDetachInstanceReply(o[0],o[1])}throw new Error(`IPC Command ${c} not found`)}listen(y,c,o){switch(c){case"$onPtyHostExitEvent":return this._ptyService.onPtyHostExit||n.Event.None;case"$onPtyHostStartEvent":return this._ptyService.onPtyHostStart||n.Event.None;case"$onPtyHostUnresponsiveEvent":return this._ptyService.onPtyHostUnresponsive||n.Event.None;case"$onPtyHostResponsiveEvent":return this._ptyService.onPtyHostResponsive||n.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this._ptyService.onPtyHostRequestResolveVariables||n.Event.None;case"$onProcessDataEvent":return this._ptyService.onProcessData;case"$onProcessReadyEvent":return this._ptyService.onProcessReady;case"$onProcessExitEvent":return this._ptyService.onProcessExit;case"$onProcessReplayEvent":return this._ptyService.onProcessReplay;case"$onProcessOrphanQuestion":return this._ptyService.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this._ptyService.onDidRequestDetach||n.Event.None;case"$onDidChangeProperty":return this._ptyService.onDidChangeProperty;default:break}throw new Error("Not supported")}async _createProcess(y,c){const o={name:c.shellLaunchConfig.name,executable:c.shellLaunchConfig.executable,args:c.shellLaunchConfig.args,cwd:typeof c.shellLaunchConfig.cwd=="string"||typeof c.shellLaunchConfig.cwd=="undefined"?c.shellLaunchConfig.cwd:v.URI.revive(y.transformIncoming(c.shellLaunchConfig.cwd)),env:c.shellLaunchConfig.env,useShellEnvironment:c.shellLaunchConfig.useShellEnvironment},l=await(0,f.buildUserEnvironment)(c.resolverEnv,!!c.shellLaunchConfig.useShellEnvironment,D.language,!1,this._environmentService,this._logService);this._logService.trace("baseEnv",l);const i=q=>({uri:v.URI.revive(y.transformIncoming(q.uri)),name:q.name,index:q.index,toResource:()=>{throw new Error("Not implemented")}}),t=c.workspaceFolders.map(i),r=c.activeWorkspaceFolder?i(c.activeWorkspaceFolder):void 0,s=c.activeFileResource?v.URI.revive(y.transformIncoming(c.activeFileResource)):void 0,a=new d(l,t,s,c.resolvedVariables),h=u.createVariableResolver(r,process.env,a),g=u.getCwd(o,k.homedir(),h,r?.uri,c.configuration["terminal.integrated.cwd"],this._logService);o.cwd=g;const _=D.isWindows?"terminal.integrated.env.windows":D.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",F=c.configuration[_],$=u.createTerminalEnvironment(o,F,h,this._productService.version,c.configuration["terminal.integrated.detectLocale"],l);if(!o.strictEnv){const q=[];for(const[U,z]of c.envVariableCollections)q.push([U,{map:(0,S.deserializeEnvironmentVariableCollection)(z)}]);const Z=new Map(q);new E.MergedEnvironmentVariableCollection(Z).applyToProcessEnvironment($)}this._logService.debug("Terminal process launching on remote agent",{shellLaunchConfig:o,initialCwd:g,cols:c.cols,rows:c.rows,env:$});const K=(0,P.createRandomIPCHandle)();$.VSCODE_IPC_HOOK_CLI=K;const I={executeCommand:(q,...Z)=>this._executeCommand(q,Z,y)},W=new R.CLIServerBase(I,this._logService,K),M=await this._ptyService.createProcess(o,g,c.cols,c.rows,c.unicodeVersion,$,l,c.options,c.shouldPersistTerminal,c.workspaceId,c.workspaceName);return this._ptyService.onProcessExit(q=>q.id===M&&W.dispose()),{persistentTerminalId:M,resolvedShellLaunchConfig:o}}_executeCommand(y,c,o){let l,i;const t=new Promise((a,h)=>{l=a,i=h}),r=++this._lastReqId;this._pendingCommands.set(r,{resolve:l,reject:i,uriTransformer:o});const s=(0,w.cloneAndChange)(c,a=>{if(a&&a.$mid===1)return o.transformOutgoing(a);if(a&&a instanceof v.URI)return o.transformOutgoingURI(a)});return this._onExecuteCommand.fire({reqId:r,commandId:y,commandArgs:s}),t}_sendCommandResult(y,c,o){const l=this._pendingCommands.get(y);if(!l)return;this._pendingCommands.delete(y);const i=(0,w.cloneAndChange)(o,t=>{if(t&&t.$mid===1)return l.uriTransformer.transformIncoming(t)});c?l.reject(i):l.resolve(i)}_getDefaultSystemShell(y){return this._ptyService.getDefaultSystemShell(y)}async _getProfiles(y,c,o,l){return this._ptyService.getProfiles?.(y,c,o,l)||[]}_getEnvironment(){return{...process.env}}_getWslPath(y){return this._ptyService.getWslPath(y)}_reduceConnectionGraceTime(){return this._ptyService.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=p}),define(ve[253],we([0,1,25,7,2,8,5,81,19,39,26,95,64,196,171,65,172,183,174,27,99,30,97,184,114,17,92,55,53,91,66,67,98,13,93,94,45,28,47,203,115,206,32,41,214,215,100,222,48,102,242,229,208,213,252,57,42,240,113,246,104]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E,S,u,b,f,d,p,m,y,c,o,l,i,t,r,s,a,h,g,_,F,$,K,I,W,M,q,Z,H,U,z,Q,ie,re,ce,de,he,j,O,V,J,le,ge,ue,oe,pe,X,B,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SocketServer=e.setupServerServices=void 0;const Y="monacoworkbench";async function fe(me,Te,Fe,Ye){const Be=new g.ServiceCollection,je=new Re,Ge={_serviceBrand:void 0,...W.default};Be.set(M.IProductService,Ge);const ne=new oe.ServerEnvironmentService(Te,Ge);Be.set(m.IEnvironmentService,ne),Be.set(m.INativeEnvironmentService,ne);const Ce=new $.LogService(new I.SpdLogLogger(X.RemoteExtensionLogFileName,T.join(ne.logsPath,`${X.RemoteExtensionLogFileName}.log`),!0,!1,(0,$.getLogLevel)(ne))),Pe=new $.MultiplexLogService([new Ue((0,$.getLogLevel)(ne)),Ce]);Be.set($.ILogService,Pe),setTimeout(()=>Ee(ne.logsPath).then(null,tt=>Pe.error(tt)),1e4),Pe.trace(`Remote configuration data at ${Fe}`),Pe.trace("process arguments:",ne.args),Array.isArray(Ge.serverGreeting)&&Ce.info(`

${Ge.serverGreeting.join(`
`)}

`),je.registerChannel(u.ExtensionHostDebugBroadcastChannel.ChannelName,new u.ExtensionHostDebugBroadcastChannel);const Le=new P.StaticRouter(tt=>tt.clientId==="renderer");je.registerChannel("logger",new K.LogLevelChannel(Pe));const Me=Ye.add(new r.FileService(Pe));Be.set(t.IFileService,Me),Me.registerProvider(C.Schemas.file,Ye.add(new s.DiskFileSystemProvider(Pe)));const Ke=new R.ConfigurationService(ne.machineSettingsResource,Me);Be.set(A.IConfigurationService,Ke);const $e=new x.ExtensionHostStatusService;Be.set(x.IExtensionHostStatusService,$e),Be.set(he.IUriIdentityService,new j.UriIdentityService(Me)),Be.set(q.IRequestService,new a.SyncDescriptor(H.RequestService));let He=Q.NullAppender;const Qe=await(0,D.getMachineId)();if((0,Q.supportsTelemetry)(Ge,ne)){Ge.aiConfig&&Ge.aiConfig.asimovKey&&(He=new ie.AppInsightsAppender(Y,null,Ge.aiConfig.asimovKey),Ye.add((0,w.toDisposable)(()=>He.flush())));const tt={appenders:[He],commonProperties:(0,U.resolveCommonProperties)(Me,(0,k.release)(),(0,k.hostname)(),process.arch,Ge.commit,Ge.version+"-remote",Qe,Ge.msftInternalDomains,ne.installSourcePath,"remoteAgent"),piiPaths:(0,Q.getPiiPathsFromEnvironment)(ne)},ut=ne.args["telemetry-level"];let ct;ut==="all"?ct=3:ut==="error"?ct=2:ut==="crash"?ct=1:ut!==void 0&&(ct=0),Be.set(le.IServerTelemetryService,new a.SyncDescriptor(le.ServerTelemetryService,[tt,ct]))}else Be.set(le.IServerTelemetryService,le.ServerNullTelemetryService);Be.set(c.IExtensionGalleryService,new a.SyncDescriptor(y.ExtensionGalleryServiceWithNoStorageService));const Ve=je.getChannel("download",Le);Be.set(b.IDownloadService,new f.DownloadServiceChannelClient(Ve,()=>ke("renderer"))),Be.set(c.IExtensionManagementService,new a.SyncDescriptor(i.ExtensionManagementService));const Ze=new h.InstantiationService(Be);Be.set(_.ILocalizationsService,Ze.createInstance(F.LocalizationsService));const it=Ze.createInstance(o.ExtensionManagementCLIService);Be.set(c.IExtensionManagementCLIService,it);const st=Ze.createInstance(de.PtyHostService,{graceTime:108e5,shortGraceTime:3e5,scrollback:Ke.getValue("terminal.integrated.persistentSessionScrollback")??100});return Be.set(ce.IPtyService,st),Be.set(d.IEncryptionMainService,new a.SyncDescriptor(p.EncryptionMainService,[Qe])),Be.set(E.ICredentialsMainService,new a.SyncDescriptor(S.CredentialsWebMainService)),Ze.invokeFunction(tt=>{const ut=tt.get(c.IExtensionManagementService),ct=new O.RemoteAgentEnvironmentChannel(me,ne,it,ut,Pe,Ge,$e,Me);je.registerChannel("remoteextensionsenvironment",ct);const ht=new J.ServerTelemetryChannel(tt.get(le.IServerTelemetryService),He);je.registerChannel("telemetry",ht),je.registerChannel(pe.REMOTE_TERMINAL_CHANNEL_NAME,new ge.RemoteTerminalChannel(ne,Pe,st,Ge));const wt=new V.RemoteAgentFileSystemProviderChannel(Pe,ne);je.registerChannel(B.REMOTE_FILE_SYSTEM_CHANNEL_NAME,wt),je.registerChannel("request",new Z.RequestChannel(tt.get(q.IRequestService)));const St=new l.ExtensionManagementChannel(ut,_t=>ke(_t.remoteAuthority));je.registerChannel("extensions",St);const Pt=P.ProxyChannel.fromService(tt.get(d.IEncryptionMainService));je.registerChannel("encryption",Pt);const kt=P.ProxyChannel.fromService(tt.get(E.ICredentialsMainService));return je.registerChannel("credentials",kt),ut.removeDeprecatedExtensions(),Ye.add(new re.default(tt.get(z.ITelemetryService))),{telemetryService:tt.get(z.ITelemetryService)}}),{socketServer:je,instantiationService:Ze}}e.setupServerServices=fe;const ye=Object.create(null);function ke(me){return ye[me]||(ye[me]=(0,ue.createURITransformer)(me)),ye[me]}class Re extends P.IPCServer{constructor(){const Te=new n.Emitter;super(Te.event);this._onDidConnectEmitter=Te}acceptConnection(Te,Fe){this._onDidConnectEmitter.fire({protocol:Te,onDidClientDisconnect:Fe})}}e.SocketServer=Re;class Ue extends $.AbstractLogger{constructor(Te=$.DEFAULT_LOG_LEVEL){super();this.setLevel(Te),this.useColors=Boolean(process.stdout.isTTY)}trace(Te,...Fe){this.getLevel()<=$.LogLevel.Trace&&(this.useColors?console.log(`[90m[${Ne()}][0m`,Te,...Fe):console.log(`[${Ne()}]`,Te,...Fe))}debug(Te,...Fe){this.getLevel()<=$.LogLevel.Debug&&(this.useColors?console.log(`[90m[${Ne()}][0m`,Te,...Fe):console.log(`[${Ne()}]`,Te,...Fe))}info(Te,...Fe){this.getLevel()<=$.LogLevel.Info&&(this.useColors?console.log(`[90m[${Ne()}][0m`,Te,...Fe):console.log(`[${Ne()}]`,Te,...Fe))}warn(Te,...Fe){this.getLevel()<=$.LogLevel.Warning&&(this.useColors?console.warn(`[93m[${Ne()}][0m`,Te,...Fe):console.warn(`[${Ne()}]`,Te,...Fe))}error(Te,...Fe){this.getLevel()<=$.LogLevel.Error&&(this.useColors?console.error(`[91m[${Ne()}][0m`,Te,...Fe):console.error(`[${Ne()}]`,Te,...Fe))}critical(Te,...Fe){this.getLevel()<=$.LogLevel.Critical&&(this.useColors?console.error(`[90m[${Ne()}][0m`,Te,...Fe):console.error(`[${Ne()}]`,Te,...Fe))}dispose(){}flush(){}}function Ne(){const me=new Date;return`${se(me.getHours())}:${se(me.getMinutes())}:${se(me.getSeconds())}`}function se(me){return me<10?`0${me}`:String(me)}async function Ee(me){const Te=T.basename(me),Fe=T.dirname(me),je=(await v.Promises.readdir(Fe)).filter(ne=>/^\d{8}T\d{6}$/.test(ne)).sort().filter(ne=>ne!==Te),Ge=je.slice(0,Math.max(0,je.length-9));await Promise.all(Ge.map(ne=>v.Promises.rm(T.join(Fe,ne))))}}),define(ve[254],we([0,1,68,29,82,255,69,117,16,9,33,2,8,5,44,3,15,4,23,134,85,58,6,13,28,32,116,224,225,42,253,227]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E,S,u,b,f,d,p,m,y,c,o,l,i,t,r,s,a,h,g,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.RemoteExtensionHostAgentServer=void 0;const F=5*60*1e3;let $=class extends R.Disposable{constructor(M,q,Z,H,U,z,Q,ie){super();this._socketServer=M,this._connectionToken=q,this._vsdaMod=Z,this._environmentService=U,this._productService=z,this._logService=Q,this._instantiationService=ie,this._webEndpointOriginChecker=I.create(this._productService),this._extHostConnections=Object.create(null),this._managementConnections=Object.create(null),this._allReconnectionTokens=new Set,this._webClientServer=H?this._instantiationService.createInstance(_.WebClientServer,this._connectionToken):null,this._logService.info("Extension host agent started.")}async handleRequest(M,q){if(M.method!=="GET")return(0,_.serveError)(M,q,405,`Unsupported method ${M.method}`);if(!M.url)return(0,_.serveError)(M,q,400,"Bad request.");const Z=T.parse(M.url,!0),H=Z.pathname;if(!H)return(0,_.serveError)(M,q,400,"Bad request.");if(H==="/version")return q.writeHead(200,{"Content-Type":"text/plain"}),q.end(this._productService.commit||"");if(H==="/delay-shutdown")return this._delayShutdown(),q.writeHead(200),q.end("OK");if(!(0,a.requestHasValidConnectionToken)(this._connectionToken,M,Z))return(0,_.serveError)(M,q,403,"Forbidden.");if(H==="/vscode-remote-resource"){const U=Z.query.path;if(typeof U!="string")return(0,_.serveError)(M,q,400,"Bad request.");let z;try{z=d.URI.from({scheme:E.Schemas.file,path:U}).fsPath}catch{return(0,_.serveError)(M,q,400,"Bad request.")}const Q=Object.create(null);this._environmentService.isBuilt&&((0,A.isEqualOrParent)(z,this._environmentService.builtinExtensionsPath,!b.isLinux)||(0,A.isEqualOrParent)(z,this._environmentService.extensionsPath,!b.isLinux))&&(Q["Cache-Control"]="public, max-age=31536000"),Q.Vary="Origin";const ie=M.headers.origin;return ie&&this._webEndpointOriginChecker.matches(ie)&&(Q["Access-Control-Allow-Origin"]=ie),(0,_.serveFile)(this._logService,M,q,z,Q)}if(this._webClientServer){this._webClientServer.handle(M,q,Z);return}return q.writeHead(404,{"Content-Type":"text/plain"}),q.end("Not found")}handleUpgrade(M,q){let Z=(0,p.generateUuid)(),H=!1,U=!1;if(M.url){const de=T.parse(M.url,!0).query;typeof de.reconnectionToken=="string"&&(Z=de.reconnectionToken),de.reconnection==="true"&&(H=!0),de.skipWebSocketFrames==="true"&&(U=!0)}if(M.headers.upgrade!=="websocket"){q.end("HTTP/1.1 400 Bad Request");return}const z=M.headers["sec-websocket-key"],Q=k.createHash("sha1");Q.update(z+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const ie=Q.digest("base64"),re=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${ie}`];let ce=!1;if(!U&&!this._environmentService.args["disable-websocket-compression"]&&M.headers["sec-websocket-extensions"]){const de=Array.isArray(M.headers["sec-websocket-extensions"])?M.headers["sec-websocket-extensions"]:[M.headers["sec-websocket-extensions"]];for(const he of de)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(he)){if(/\b(permessage-deflate)\b/.test(he)){ce=!0,re.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(he)){ce=!0,re.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}q.write(re.join(`\r
`)+`\r
\r
`),q.setTimeout(0),q.setNoDelay(!0),U?this._handleWebSocketConnection(new c.NodeSocket(q,`server-connection-${Z}`),H,Z):this._handleWebSocketConnection(new c.WebSocketNodeSocket(new c.NodeSocket(q,`server-connection-${Z}`),ce,null,!0),H,Z)}handleServerError(M){this._logService.error("Error occurred in server"),this._logService.error(M)}_getRemoteAddress(M){let q;return M instanceof c.NodeSocket?q=M.socket:q=M.socket.socket,q.remoteAddress||"<unknown>"}async _rejectWebSocketConnection(M,q,Z){const H=q.getSocket();this._logService.error(`${M} ${Z}.`);const U={type:"error",reason:Z};q.sendControl(v.VSBuffer.fromString(JSON.stringify(U))),q.dispose(),await H.drain(),H.dispose()}_handleWebSocketConnection(M,q,Z){const H=this._getRemoteAddress(M),U=`[${H}][${Z.substr(0,8)}]`,z=new y.PersistentProtocol(M),Q=this._vsdaMod?new this._vsdaMod.validator:null,ie=this._vsdaMod?new this._vsdaMod.signer:null;let re;(function(j){j[j.WaitingForAuth=0]="WaitingForAuth",j[j.WaitingForConnectionType=1]="WaitingForConnectionType",j[j.Done=2]="Done",j[j.Error=3]="Error"})(re||(re={}));let ce=0;const de=j=>{ce=3,he.dispose(),this._rejectWebSocketConnection(U,z,j)},he=z.onControlMessage(j=>{if(ce===0){let O;try{O=JSON.parse(j.toString())}catch{return de("Malformed first message")}if(O.type!=="auth")return de("Invalid first message");if(this._connectionToken.type===2&&!this._connectionToken.validate(O.auth))return de("Unauthorized client refused: auth mismatch");let V=(0,p.generateUuid)();if(ie)try{V=ie.sign(O.data)}catch{}let J=(0,p.generateUuid)();if(Q)try{J=Q.createNewMessage(J)}catch{}const le={type:"sign",data:J,signedData:V};z.sendControl(v.VSBuffer.fromString(JSON.stringify(le))),ce=1}else if(ce===1){let O;try{O=JSON.parse(j.toString())}catch{return de("Malformed second message")}if(O.type!=="connectionType")return de("Invalid second message");if(typeof O.signedData!="string")return de("Invalid second message field type");const V=O.commit,J=this._productService.commit;if(V&&J&&V!==J)return de("Client refused: version mismatch");let le=!1;if(!Q)le=!0;else if(this._connectionToken.validate(O.signedData))le=!0;else try{le=Q.validate(O.signedData)==="ok"}catch{}if(!le){if(this._environmentService.isBuilt)return de("Unauthorized client refused");this._logService.error(`${U} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(let ge in this._managementConnections)this._managementConnections[ge].shortenReconnectionGraceTimeIfNecessary();for(let ge in this._extHostConnections)this._extHostConnections[ge].shortenReconnectionGraceTimeIfNecessary();ce=2,he.dispose(),this._handleConnectionType(H,U,z,M,q,Z,O)}})}async _handleConnectionType(M,q,Z,H,U,z,Q){const ie=Q.desiredConnectionType===1?`${q}[ManagementConnection]`:Q.desiredConnectionType===2?`${q}[ExtensionHostConnection]`:q;if(Q.desiredConnectionType===1)if(U){if(!this._managementConnections[z])return this._allReconnectionTokens.has(z)?this._rejectWebSocketConnection(ie,Z,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(ie,Z,"Unknown reconnection token (never seen)");Z.sendControl(v.VSBuffer.fromString(JSON.stringify({type:"ok"})));const re=Z.readEntireBuffer();Z.dispose(),this._managementConnections[z].acceptReconnection(M,H,re)}else{if(this._managementConnections[z])return this._rejectWebSocketConnection(ie,Z,"Duplicate reconnection token");Z.sendControl(v.VSBuffer.fromString(JSON.stringify({type:"ok"})));const re=new s.ManagementConnection(this._logService,z,M,Z);this._socketServer.acceptConnection(re.protocol,re.onClose),this._managementConnections[z]=re,this._allReconnectionTokens.add(z),re.onClose(()=>{delete this._managementConnections[z]})}else if(Q.desiredConnectionType===2){const re=Q.args||{language:"en"},ce=await this._updateWithFreeDebugPort(re);if(ce.port&&this._logService.trace(`${ie} - startParams debug port ${ce.port}`),this._logService.trace(`${ie} - startParams language: ${ce.language}`),this._logService.trace(`${ie} - startParams env: ${JSON.stringify(ce.env)}`),U){if(!this._extHostConnections[z])return this._allReconnectionTokens.has(z)?this._rejectWebSocketConnection(ie,Z,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(ie,Z,"Unknown reconnection token (never seen)");Z.sendPause(),Z.sendControl(v.VSBuffer.fromString(JSON.stringify(ce.port?{debugPort:ce.port}:{})));const de=Z.readEntireBuffer();Z.dispose(),this._extHostConnections[z].acceptReconnection(M,H,de)}else{if(this._extHostConnections[z])return this._rejectWebSocketConnection(ie,Z,"Duplicate reconnection token");Z.sendPause(),Z.sendControl(v.VSBuffer.fromString(JSON.stringify(ce.port?{debugPort:ce.port}:{})));const de=Z.readEntireBuffer();Z.dispose();const he=this._instantiationService.createInstance(r.ExtensionHostConnection,z,M,H,de);this._extHostConnections[z]=he,this._allReconnectionTokens.add(z),he.onClose(()=>{delete this._extHostConnections[z],this._onDidCloseExtHostConnection()}),he.start(ce)}}else if(Q.desiredConnectionType===3){const re=Q.args;this._createTunnel(Z,re)}else return this._rejectWebSocketConnection(ie,Z,"Unknown initial data received")}async _createTunnel(M,q){const Z=M.getSocket().socket,H=M.readEntireBuffer();M.dispose(),Z.pause();const U=await this._connectTunnelSocket(q.host,q.port);H.byteLength>0&&U.write(H.buffer),U.on("end",()=>Z.end()),U.on("close",()=>Z.end()),U.on("error",()=>Z.destroy()),Z.on("end",()=>U.end()),Z.on("close",()=>U.end()),Z.on("error",()=>U.destroy()),U.pipe(Z),Z.pipe(U)}_connectTunnelSocket(M,q){return new Promise((Z,H)=>{const U=w.createConnection({host:M,port:q},()=>{U.removeListener("error",H),U.pause(),Z(U)});U.once("error",H)})}_updateWithFreeDebugPort(M){return typeof M.port=="number"?(0,m.findFreePort)(M.port,10,5e3).then(q=>(M.port=q,M)):(M.debugId=void 0,M.port=void 0,M.break=void 0,Promise.resolve(M))}async _onDidCloseExtHostConnection(){if(!this._environmentService.args["enable-remote-auto-shutdown"])return;this._cancelShutdown(),!!Object.keys(this._extHostConnections).length||(console.log("Last EH closed, waiting before shutting down"),this._logService.info("Last EH closed, waiting before shutting down"),this._waitThenShutdown())}_waitThenShutdown(){!this._environmentService.args["enable-remote-auto-shutdown"]||(this._environmentService.args["remote-auto-shutdown-without-delay"]?this._shutdown():this.shutdownTimer=setTimeout(()=>{this.shutdownTimer=void 0,this._shutdown()},F))}_shutdown(){if(!!Object.keys(this._extHostConnections).length){console.log("New EH opened, aborting shutdown"),this._logService.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this._logService.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}_delayShutdown(){this.shutdownTimer&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this._logService.info("Got delay-shutdown request while in shutdown timeout, delaying"),this._cancelShutdown(),this._waitThenShutdown())}_cancelShutdown(){this.shutdownTimer&&(console.log("Cancelling previous shutdown timeout"),this._logService.info("Cancelling previous shutdown timeout"),clearTimeout(this.shutdownTimer),this.shutdownTimer=void 0)}};$=Ae([Oe(4,h.IServerEnvironmentService),Oe(5,i.IProductService),Oe(6,l.ILogService),Oe(7,o.IInstantiationService)],$),e.RemoteExtensionHostAgentServer=$;async function K(W,M,q){const Z=await(0,a.determineServerConnectionToken)(M);Z instanceof a.ServerConnectionTokenParseError&&(console.warn(Z.message),process.exit(1));const H=new R.DisposableStore,{socketServer:U,instantiationService:z}=await(0,g.setupServerServices)(Z,M,q,H);z.invokeFunction(O=>{const V=O.get(l.ILogService);(0,P.setUnexpectedErrorHandler)(J=>{J&&J.code==="EPIPE"&&J.syscall==="write"&&J.stack&&/unexpectedErrorHandler/.test(J.stack)||V.error(J)})}),z.invokeFunction(O=>{const V=O.get(l.ILogService);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const J=(0,S.join)(process.env.HOMEDRIVE,"node_modules"),le=(0,S.dirname)((0,S.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),ge=(0,S.join)(le,"node_modules");if(n.existsSync(J)||n.existsSync(ge)){const ue=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${J}
* ${ge}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;V.warn(ue),console.warn(ue),process.exit(0)}}});const Q=z.invokeFunction(O=>{const V=O.get(l.ILogService);if(n.existsSync((0,S.join)(E.FileAccess.asFileUri("",ee).fsPath,"../node_modules/vsda")))try{return ee.__$__nodeRequire("vsda")}catch(le){V.error(le)}return null}),ie=n.existsSync(E.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html",ee).fsPath);if(ie&&W&&typeof W!="string"){const O=Z.type!==0?`?${E.connectionTokenQueryName}=${Z.value}`:"";console.log(`Web UI available at http://localhost${W.port===80?"":`:${W.port}`}/${O}`)}const re=z.createInstance($,U,Z,Q,ie);u.mark("code/server/ready");const ce=C.performance.now(),de=global.vscodeServerStartTime,he=global.vscodeServerListenTime,j=global.vscodeServerCodeLoadedTime;if(z.invokeFunction(O=>{O.get(t.ITelemetryService).publicLog2("serverStart",{startTime:de,startedTime:he,codeLoadedTime:j,readyTime:ce})}),M["print-startup-performance"]){const O=D.LoaderStats.get();let V="";V+=`

### Load AMD-module
`,V+=D.LoaderStats.toMarkdownTable(["Module","Duration"],O.amdLoad),V+=`

### Load commonjs-module
`,V+=D.LoaderStats.toMarkdownTable(["Module","Duration"],O.nodeRequire),V+=`

### Invoke AMD-module factory
`,V+=D.LoaderStats.toMarkdownTable(["Module","Duration"],O.amdInvoke),V+=`

### Invoke commonjs-module
`,V+=D.LoaderStats.toMarkdownTable(["Module","Duration"],O.nodeEval),V+=`Start-up time: ${he-de}
`,V+=`Code loading time: ${j-de}
`,V+=`Initialized time: ${ce-de}
`,V+=`
`,console.log(V)}return re}e.createServer=K;class I{constructor(M){this._originRegExp=M}static create(M){const q=M.webEndpointUrlTemplate,Z=M.commit,H=M.quality;if(!q||!Z||!H)return new I(null);const U=(0,p.generateUuid)(),Q=new URL(q.replace("{{uuid}}",U).replace("{{commit}}",Z).replace("{{quality}}",H)).origin,ie=(0,f.escapeRegExpCharacters)(Q).replace(U,"[a-zA-Z0-9-]+");try{const re=(0,f.createRegExp)(`^${ie}$`,!0,{matchCase:!1});return new I(re)}catch{return new I(null)}}matches(M){return this._originRegExp?this._originRegExp.test(M):!1}}}),define(ve[263],we([0,1,25,29,8,250,254,52,5,255,42,45,44]),function(ee,e,k,n,w,C,T,D,v,P,A,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,E.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=P.performance.now();const S={onMultipleValues:(t,r)=>{console.error(`Option ${t} can only be defined once. Using value ${r}.`)},onUnknownOption:t=>{console.error(`Ignoring option ${t}: not supported for server.`)},onDeprecatedOption:(t,r)=>{console.warn(`Option '${t}' is deprecated: ${r}`)}},u=(0,D.parseArgs)(process.argv.slice(2),A.serverOptions,S),b=u["server-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,v.join)(k.homedir(),R.default.serverDataFolderName||".vscode-remote"),f=(0,v.join)(b,"data"),d=(0,v.join)(f,"User"),p=(0,v.join)(d,"globalStorage"),m=(0,v.join)(d,"History"),y=(0,v.join)(f,"Machine");u["user-data-dir"]=f;const c=(0,v.dirname)(w.FileAccess.asFileUri("",ee).fsPath),o=(0,v.join)(c,"extensions");u["builtin-extensions-dir"]=o,u["extensions-dir"]=u["extensions-dir"]||(0,v.join)(b,"extensions"),[b,u["extensions-dir"],f,d,y,p,m].forEach(t=>{try{n.existsSync(t)||n.mkdirSync(t,{mode:448})}catch(r){console.error(r)}});function l(){(0,C.run)(u,b,A.serverOptions)}e.spawnCli=l;function i(t){return(0,T.createServer)(t,u,b)}e.createServer=i})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/dfd34e8260c270da74b5c2d86d61aee4b6d56977/core/vs/server/node/server.main.js.map
